"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/charCode","vs/base/common/errors","vs/base/common/extpath","vs/base/common/strings","vs/base/common/uri","vs/base/common/async","vs/base/common/functional","vs/base/common/lazy","vs/base/common/map","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/cancellation","vs/base/common/process","vs/base/common/resources","fs","os","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/types","vs/base/common/uint","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/server/node/server.cli","vs/base/common/network","vs/base/node/pfs","vs/base/node/terminalEncoding","child_process","vs/nls!vs/platform/environment/node/argv","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","util","minimist","vs/server/node/server.cli","url","http"],be=function(le){for(var e=[],a=0,t=le.length;a<t;a++)e[a]=$e[le[a]];return e};define($e[20],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=a,e.$jb=t,e.$kb=v,e.$lb=O,e.$mb=ie,e.$nb=X,e.$ob=F,e.$qb=W,e.$rb=x,e.$sb=j,e.$tb=te,e.$ub=P;function a(l,d){const w=t(l,d);if(w!==-1)return l[w]}function t(l,d,w=l.length-1){for(let k=w;k>=0;k--){const q=l[k];if(d(q))return k}return-1}function v(l,d){const w=O(l,d);return w===-1?void 0:l[w]}function O(l,d,w=0,k=l.length){let q=w,ne=k;for(;q<ne;){const p=Math.floor((q+ne)/2);d(l[p])?q=p+1:ne=p}return q-1}function ie(l,d){const w=X(l,d);return w===l.length?void 0:l[w]}function X(l,d,w=0,k=l.length){let q=w,ne=k;for(;q<ne;){const p=Math.floor((q+ne)/2);d(l[p])?ne=p:q=p+1}return q}function F(l,d,w=0,k=l.length){const q=X(l,d,w,k);return q===l.length?-1:q}class T{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(T.assertInvariants){if(this.d){for(const k of this.e)if(this.d(k)&&!d(k))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const w=O(this.e,d,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$pb=T;function W(l,d){if(l.length===0)return;let w=l[0];for(let k=1;k<l.length;k++){const q=l[k];d(q,w)>0&&(w=q)}return w}function x(l,d){if(l.length===0)return;let w=l[0];for(let k=1;k<l.length;k++){const q=l[k];d(q,w)>=0&&(w=q)}return w}function j(l,d){return W(l,(w,k)=>-d(w,k))}function te(l,d){if(l.length===0)return-1;let w=0;for(let k=1;k<l.length;k++){const q=l[k];d(q,l[w])>0&&(w=k)}return w}function P(l,d){for(const w of l){const k=d(w);if(k!==void 0)return k}}}),define($e[4],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define($e[21],be([0,1]),function(le,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=t,e.$L=v,e.$M=O,e.$N=ie;function t(F,T){const W=Object.create(null);for(const x of F){const j=T(x);let te=W[j];te||(te=W[j]=[]),te.push(x)}return W}function v(F,T){const W=[],x=[];for(const j of F)T.has(j)||W.push(j);for(const j of T)F.has(j)||x.push(j);return{removed:W,added:x}}function O(F,T){const W=[],x=[];for(const[j,te]of F)T.has(j)||W.push(te);for(const[j,te]of T)F.has(j)||x.push(te);return{removed:W,added:x}}function ie(F,T){const W=new Set;for(const x of T)F.has(x)&&W.add(x);return W}class X{static{a=Symbol.toStringTag}constructor(T,W){this.b=W,this.a=new Map,this[a]="SetWithKey";for(const x of T)this.add(x)}get size(){return this.a.size}add(T){const W=this.b(T);return this.a.set(W,T),this}delete(T){return this.a.delete(this.b(T))}has(T){return this.a.has(this.b(T))}*entries(){for(const T of this.a.values())yield[T,T]}keys(){return this.values()}*values(){for(const T of this.a.values())yield T}clear(){this.a.clear()}forEach(T,W){this.a.forEach(x=>T.call(W,x,x,this))}[Symbol.iterator](){return this.values()}}e.$O=X}),define($e[5],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=v,e.$3=O,e.$4=ie,e.$5=X,e.$6=F,e.$7=W,e.$9=j,e.$0=te,e.$$=P,e.$ab=d;class a{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?ne.isErrorNoTelemetry(i)?new ne(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=a,e.$Z=new a;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function v(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function O(n){W(n)||e.$Z.onUnexpectedError(n)}function ie(n){W(n)||e.$Z.onUnexpectedExternalError(n)}function X(n){if(n instanceof Error){const{name:i,message:c}=n,g=n.stacktrace||n.stack;return{$isError:!0,name:i,message:c,stack:g,noTelemetry:ne.isErrorNoTelemetry(n)}}return n}function F(n){let i;return n.noTelemetry?i=new ne:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const T="Canceled";function W(n){return n instanceof x?!0:n instanceof Error&&n.name===T&&n.message===T}class x extends Error{constructor(){super(T),this.name=this.message}}e.$8=x;function j(){const n=new Error(T);return n.name=n.message,n}function te(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function P(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class l extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=l;function d(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=w;class k extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=k;class q extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=q;class ne extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof ne)return i;const c=new ne;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=ne;class p extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$fb=p}),define($e[22],be([0,1,5,20]),function(le,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=v,e.$wb=O,e.$xb=ie,e.$yb=X,e.$zb=F,e.$Ab=T,e.$Bb=W,e.$Cb=x,e.$Db=j,e.$Eb=te,e.$Fb=P,e.$Gb=l,e.$Hb=d,e.top=w,e.$Jb=k,e.$Kb=ne,e.$Lb=p,e.$Mb=n,e.$Nb=i,e.$Ob=c,e.$Pb=g,e.$Qb=A,e.$Rb=f,e.$Sb=h,e.$Tb=s,e.$Ub=_,e.$Vb=U,e.$Wb=I,e.$Xb=u,e.$Yb=B,e.$Zb=G,e.$1b=V,e.$2b=D,e.$3b=Q,e.$4b=S,e.$5b=y,e.$6b=H,e.$7b=K,e.$8b=J,e.$9b=me,e.$0b=ye,e.$ac=fe;function v(b,R=0){return b[b.length-(1+R)]}function O(b){if(b.length===0)throw new Error("Invalid tail call");return[b.slice(0,b.length-1),b[b.length-1]]}function ie(b,R,L=(m,r)=>m===r){if(b===R)return!0;if(!b||!R||b.length!==R.length)return!1;for(let m=0,r=b.length;m<r;m++)if(!L(b[m],R[m]))return!1;return!0}function X(b,R){const L=b.length-1;R<L&&(b[R]=b[L]),b.pop()}function F(b,R,L){return T(b.length,m=>L(b[m],R))}function T(b,R){let L=0,m=b-1;for(;L<=m;){const r=(L+m)/2|0,E=R(r);if(E<0)L=r+1;else if(E>0)m=r-1;else return r}return-(L+1)}function W(b,R,L){if(b=b|0,b>=R.length)throw new TypeError("invalid index");const m=R[Math.floor(R.length*Math.random())],r=[],E=[],M=[];for(const z of R){const oe=L(z,m);oe<0?r.push(z):oe>0?E.push(z):M.push(z)}return b<r.length?W(b,r,L):b<r.length+M.length?M[0]:W(b-(r.length+M.length),E,L)}function x(b,R){const L=[];let m;for(const r of b.slice(0).sort(R))!m||R(m[0],r)!==0?(m=[r],L.push(m)):m.push(r);return L}function*j(b,R){let L,m;for(const r of b)m!==void 0&&R(m,r)?L.push(r):(L&&(yield L),L=[r]),m=r;L&&(yield L)}function te(b,R){for(let L=0;L<=b.length;L++)R(L===0?void 0:b[L-1],L===b.length?void 0:b[L])}function P(b,R){for(let L=0;L<b.length;L++)R(L===0?void 0:b[L-1],b[L],L+1===b.length?void 0:b[L+1])}function l(b,R,L){const m=[];function r(z,oe,we){if(oe===0&&we.length===0)return;const ee=m[m.length-1];ee&&ee.start+ee.deleteCount===z?(ee.deleteCount+=oe,ee.toInsert.push(...we)):m.push({start:z,deleteCount:oe,toInsert:we})}let E=0,M=0;for(;;){if(E===b.length){r(E,0,R.slice(M));break}if(M===R.length){r(E,b.length-E,[]);break}const z=b[E],oe=R[M],we=L(z,oe);we===0?(E+=1,M+=1):we<0?(r(E,1,[]),E+=1):we>0&&(r(E,0,[oe]),M+=1)}return m}function d(b,R,L){const m=l(b,R,L),r=[],E=[];for(const M of m)r.push(...b.slice(M.start,M.start+M.deleteCount)),E.push(...M.toInsert);return{removed:r,added:E}}function w(b,R,L){if(L===0)return[];const m=b.slice(0,L).sort(R);return q(b,R,m,L,b.length),m}function k(b,R,L,m,r){return L===0?Promise.resolve([]):new Promise((E,M)=>{(async()=>{const z=b.length,oe=b.slice(0,L).sort(R);for(let we=L,ee=Math.min(L+m,z);we<z;we=ee,ee=Math.min(ee+m,z)){if(we>L&&await new Promise(C=>setTimeout(C)),r&&r.isCancellationRequested)throw new a.$8;q(b,R,oe,we,ee)}return oe})().then(E,M)})}function q(b,R,L,m,r){for(const E=L.length;m<r;m++){const M=b[m];if(R(M,L[E-1])<0){L.pop();const z=(0,t.$nb)(L,oe=>R(M,oe)<0);L.splice(z,0,M)}}}function ne(b){return b.filter(R=>!!R)}function p(b){let R=0;for(let L=0;L<b.length;L++)b[L]&&(b[R]=b[L],R+=1);b.length=R}function n(b,R,L){b.splice(L,0,b.splice(R,1)[0])}function i(b){return!Array.isArray(b)||b.length===0}function c(b){return Array.isArray(b)&&b.length>0}function g(b,R=L=>L){const L=new Set;return b.filter(m=>{const r=R(m);return L.has(r)?!1:(L.add(r),!0)})}function A(b){const R=new Set;return L=>{const m=b(L);return R.has(m)?!1:(R.add(m),!0)}}function f(b,R){return b.length>0?b[0]:R}function h(b,R){return b.length>0?b[b.length-1]:R}function s(b,R,L=(m,r)=>m===r){let m=0;for(let r=0,E=Math.min(b.length,R.length);r<E&&L(b[r],R[r]);r++)m++;return m}function _(b,R){let L=typeof R=="number"?b:0;typeof R=="number"?L=b:(L=0,R=b);const m=[];if(L<=R)for(let r=L;r<R;r++)m.push(r);else for(let r=L;r>R;r--)m.push(r);return m}function U(b,R,L){return b.reduce((m,r)=>(m[R(r)]=L?L(r):r,m),Object.create(null))}function I(b,R){return b.push(R),()=>u(b,R)}function u(b,R){const L=b.indexOf(R);if(L>-1)return b.splice(L,1),R}function B(b,R,L){const m=b.slice(0,R),r=b.slice(R);return m.concat(L,r)}function G(b,R){let L;if(typeof R=="number"){let m=R;L=()=>{const r=Math.sin(m++)*179426549;return r-Math.floor(r)}}else L=Math.random;for(let m=b.length-1;m>0;m-=1){const r=Math.floor(L()*(m+1)),E=b[m];b[m]=b[r],b[r]=E}}function V(b,R){const L=b.indexOf(R);L>-1&&(b.splice(L,1),b.unshift(R))}function D(b,R){const L=b.indexOf(R);L>-1&&(b.splice(L,1),b.push(R))}function Q(b,R){for(const L of R)b.push(L)}function S(b,R){return Array.isArray(b)?b.map(R):R(b)}function y(b){return Array.isArray(b)?b:[b]}function H(b){return b[Math.floor(Math.random()*b.length)]}function K(b,R,L){const m=Z(b,R),r=b.length,E=L.length;b.length=r+E;for(let M=r-1;M>=m;M--)b[M+E]=b[M];for(let M=0;M<E;M++)b[M+m]=L[M]}function J(b,R,L,m){const r=Z(b,R);let E=b.splice(r,L);return E===void 0&&(E=[]),K(b,r,m),E}function Z(b,R){return R<0?Math.max(R+b.length,0):Math.min(R,b.length)}var se;(function(b){function R(E){return E<0}b.isLessThan=R;function L(E){return E<=0}b.isLessThanOrEqual=L;function m(E){return E>0}b.isGreaterThan=m;function r(E){return E===0}b.isNeitherLessOrGreaterThan=r,b.greaterThan=1,b.lessThan=-1,b.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function me(b,R){return(L,m)=>R(b(L),b(m))}function ye(...b){return(R,L)=>{for(const m of b){const r=m(R,L);if(!se.isNeitherLessOrGreaterThan(r))return r}return se.neitherLessOrGreaterThan}}const Re=(b,R)=>b-R;e.$$b=Re;const Te=(b,R)=>(0,e.$$b)(b?1:0,R?1:0);e.$_b=Te;function fe(b){return(R,L)=>-b(R,L)}class ve{constructor(R){this.g=R,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(R){let L=this.c;for(;L<this.g.length&&R(this.g[L]);)L++;const m=L===this.c?null:this.g.slice(this.c,L);return this.c=L,m}takeFromEndWhile(R){let L=this.d;for(;L>=0&&R(this.g[L]);)L--;const m=L===this.d?null:this.g.slice(L+1,this.d+1);return this.d=L,m}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const R=this.g[this.c];return this.c++,R}removeLast(){const R=this.g[this.d];return this.d--,R}takeCount(R){const L=this.g.slice(this.c,this.c+R);return this.c+=R,L}}e.$bc=ve;class ge{static{this.empty=new ge(R=>{})}constructor(R){this.iterate=R}forEach(R){this.iterate(L=>(R(L),!0))}toArray(){const R=[];return this.iterate(L=>(R.push(L),!0)),R}filter(R){return new ge(L=>this.iterate(m=>R(m)?L(m):!0))}map(R){return new ge(L=>this.iterate(m=>L(R(m))))}some(R){let L=!1;return this.iterate(m=>(L=R(m),!L)),L}findFirst(R){let L;return this.iterate(m=>R(m)?(L=m,!1):!0),L}findLast(R){let L;return this.iterate(m=>(R(m)&&(L=m),!0)),L}findLastMaxBy(R){let L,m=!0;return this.iterate(r=>((m||se.isGreaterThan(R(r,L)))&&(m=!1,L=r),!0)),L}}e.$cc=ge;class Ee{constructor(R){this.c=R}static createSortPermutation(R,L){const m=Array.from(R.keys()).sort((r,E)=>L(R[r],R[E]));return new Ee(m)}apply(R){return R.map((L,m)=>R[this.c[m]])}inverse(){const R=this.c.slice();for(let L=0;L<this.c.length;L++)R[this.c[L]]=L;return new Ee(R)}}e.$dc=Ee}),define($e[10],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=a;function a(t,v){const O=this;let ie=!1,X;return function(){if(ie)return X;if(ie=!0,v)try{X=t.apply(O,arguments)}finally{v()}else X=t.apply(O,arguments);return X}}}),define($e[23],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function v(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=v;const O=Object.freeze([]);function ie(){return O}t.empty=ie;function*X(i){yield i}t.single=X;function F(i){return v(i)?i:X(i)}t.wrap=F;function T(i){return i||O}t.from=T;function*W(i){for(let c=i.length-1;c>=0;c--)yield i[c]}t.reverse=W;function x(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=x;function j(i){return i[Symbol.iterator]().next().value}t.first=j;function te(i,c){let g=0;for(const A of i)if(c(A,g++))return!0;return!1}t.some=te;function P(i,c){for(const g of i)if(c(g))return g}t.find=P;function*l(i,c){for(const g of i)c(g)&&(yield g)}t.filter=l;function*d(i,c){let g=0;for(const A of i)yield c(A,g++)}t.map=d;function*w(i,c){let g=0;for(const A of i)yield*c(A,g++)}t.flatMap=w;function*k(...i){for(const c of i)yield*c}t.concat=k;function q(i,c,g){let A=g;for(const f of i)A=c(A,f);return A}t.reduce=q;function*ne(i,c,g=i.length){for(c<0&&(c+=i.length),g<0?g+=i.length:g>i.length&&(g=i.length);c<g;c++)yield i[c]}t.slice=ne;function p(i,c=Number.POSITIVE_INFINITY){const g=[];if(c===0)return[g,i];const A=i[Symbol.iterator]();for(let f=0;f<c;f++){const h=A.next();if(h.done)return[g,t.empty()];g.push(h.value)}return[g,{[Symbol.iterator](){return A}}]}t.consume=p;async function n(i){const c=[];for await(const g of i)c.push(g);return Promise.resolve(c)}t.asyncToArray=n})(a||(e.Iterable=a={}))}),define($e[11],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class a{constructor(v){this.d=v,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(v){this.c=v}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=a}),define($e[24],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class a{static{this.Undefined=new a(void 0)}constructor(O){this.element=O,this.next=a.Undefined,this.prev=a.Undefined}}class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let O=this.a;for(;O!==a.Undefined;){const ie=O.next;O.prev=a.Undefined,O.next=a.Undefined,O=ie}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,ie){const X=new a(O);if(this.a===a.Undefined)this.a=X,this.b=X;else if(ie){const T=this.b;this.b=X,X.prev=T,T.next=X}else{const T=this.a;this.a=X,X.next=T,T.prev=X}this.c+=1;let F=!1;return()=>{F||(F=!0,this.e(X))}}shift(){if(this.a!==a.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==a.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==a.Undefined&&O.next!==a.Undefined){const ie=O.prev;ie.next=O.next,O.next.prev=ie}else O.prev===a.Undefined&&O.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):O.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):O.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==a.Undefined;)yield O.element,O=O.next}}e.$8c=t}),define($e[12],be([0,1]),function(le,e){"use strict";var a,t,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=O,e.$Bc=ie,e.$Cc=X,e.$Lc=ne;function O(p,n,i){let c=p.get(n);return c===void 0&&(c=i,p.set(n,c)),c}function ie(p){const n=[];return p.forEach((i,c)=>{n.push(`${c} => ${i}`)}),`Map(${p.size}) {${n.join(", ")}}`}function X(p){const n=[];return p.forEach(i=>{n.push(i)}),`Set(${p.size}) {${n.join(", ")}}`}class F{constructor(n,i){this.uri=n,this.value=i}}function T(p){return Array.isArray(p)}class W{static{this.c=n=>n.toString()}constructor(n,i){if(this[a]="ResourceMap",n instanceof W)this.d=new Map(n.d),this.e=i??W.c;else if(T(n)){this.d=new Map,this.e=i??W.c;for(const[c,g]of n)this.set(c,g)}else this.d=new Map,this.e=n??W.c}set(n,i){return this.d.set(this.e(n),new F(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[c,g]of this.d)n(g.value,g.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=W;class x{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new W(n):(this.c=new W(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((c,g)=>n.call(i,g,g,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=x;var j;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(j||(e.Touch=j={}));class te{constructor(){this[v]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=j.None){const c=this.c.get(n);if(c)return i!==j.None&&this.m(c,i),c.value}set(n,i,c=j.None){let g=this.c.get(n);if(g)g.value=i,c!==j.None&&this.m(g,c);else{switch(g={key:n,value:i,next:void 0,previous:void 0},c){case j.None:this.k(g);break;case j.AsOld:this.j(g);break;case j.AsNew:this.k(g);break;default:this.k(g);break}this.c.set(n,g),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const c=this.g;let g=this.d;for(;g;){if(i?n.bind(i)(g.value,g.key,this):n(g.value,g.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const n=this,i=this.g;let c=this.d;const g={[Symbol.iterator](){return g},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const A={value:c.key,done:!1};return c=c.next,A}else return{value:void 0,done:!0}}};return g}values(){const n=this,i=this.g;let c=this.d;const g={[Symbol.iterator](){return g},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const A={value:c.value,done:!1};return c=c.next,A}else return{value:void 0,done:!0}}};return g}entries(){const n=this,i=this.g;let c=this.d;const g={[Symbol.iterator](){return g},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const A={value:[c.key,c.value],done:!1};return c=c.next,A}else return{value:void 0,done:!0}}};return g}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,c=this.size;for(;i&&c>n;)this.c.delete(i.key),i=i.next,c--;this.d=i,this.f=c,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,c=this.size;for(;i&&c>n;)this.c.delete(i.key),i=i.previous,c--;this.e=i,this.f=c,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,c=n.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==j.AsOld&&i!==j.AsNew)){if(i===j.AsOld){if(n===this.d)return;const c=n.next,g=n.previous;n===this.e?(g.next=void 0,this.e=g):(c.previous=g,g.next=c),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===j.AsNew){if(n===this.e)return;const c=n.next,g=n.previous;n===this.d?(c.previous=void 0,this.d=c):(c.previous=g,g.next=c),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,c)=>{n.push([c,i])}),n}fromJSON(n){this.clear();for(const[i,c]of n)this.set(i,c)}}e.$Fc=te;class P extends te{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=j.AsNew){return super.get(n,i)}peek(n){return super.get(n,j.None)}set(n,i){return super.set(n,i,j.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class l extends P{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Gc=l;class d extends P{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Hc=d;class w{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Ic=w;class k{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,c]of n)this.set(i,c)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((c,g)=>{n.call(i,c,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=k;class q{constructor(){this.c=new Map}add(n,i){let c=this.c.get(n);c||(c=new Set,this.c.set(n,c)),c.add(i)}delete(n,i){const c=this.c.get(n);c&&(c.delete(i),c.size===0&&this.c.delete(n))}forEach(n,i){const c=this.c.get(n);c&&c.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Kc=q;function ne(p,n){if(p===n)return!0;if(p.size!==n.size)return!1;for(const[i,c]of p)if(!n.has(i)||n.get(i)!==c)return!1;for(const[i]of n)if(!p.has(i))return!1;return!0}}),define($e[13],be([0,1,22,21,12,10,23]),function(le,e,a,t,v,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=W,e.$Oc=x,e.$Pc=j,e.$Qc=l,e.$Rc=d,e.$Sc=w,e.$Tc=k,e.$Uc=q,e.$Vc=ne,e.$6c=_;const X=!1;let F=null;class T{constructor(){this.b=new Map}static{this.a=0}c(u){let B=this.b.get(u);return B||(B={parent:null,source:null,isSingleton:!1,value:u,idx:T.a++},this.b.set(u,B)),B}trackDisposable(u){const B=this.c(u);B.source||(B.source=new Error().stack)}setParent(u,B){const G=this.c(u);G.parent=B}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,B){const G=B.get(u);if(G)return G;const V=u.parent?this.f(this.c(u.parent),B):u;return B.set(u,V),V}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,u).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(u=10,B){let G;if(B)G=B;else{const y=new Map,H=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,y).isSingleton);if(H.length===0)return;const K=new Set(H.map(J=>J.value));if(G=H.filter(J=>!(J.parent&&K.has(J.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function V(y){function H(J,Z){for(;J.length>0&&Z.some(se=>typeof se=="string"?se===J[0]:J[0].match(se));)J.shift()}const K=y.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return H(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const D=new v.$Kc;for(const y of G){const H=V(y);for(let K=0;K<=H.length;K++)D.add(H.slice(0,K).join(`
`),y)}G.sort((0,a.$9b)(y=>y.idx,a.$$b));let Q="",S=0;for(const y of G.slice(0,u)){S++;const H=V(y),K=[];for(let J=0;J<H.length;J++){let Z=H[J];Z=`(shared with ${D.get(H.slice(0,J+1).join(`
`)).size}/${G.length} leaks) at ${Z}`;const me=D.get(H.slice(0,J).join(`
`)),ye=(0,t.$K)([...me].map(Re=>V(Re)[J]),Re=>Re);delete ye[H[J]];for(const[Re,Te]of Object.entries(ye))K.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${Re}`);K.unshift(Z)}Q+=`


==================== Leaking disposable ${S}/${G.length}: ${y.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return G.length>u&&(Q+=`


... and ${G.length-u} more leaking disposables

`),{leaks:G,details:Q}}}e.$Mc=T;function W(I){F=I}if(X){const I="__is_disposable_tracked__";W(new class{trackDisposable(u){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[I]||console.log(B)},3e3)}setParent(u,B){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsDisposed(u){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsSingleton(u){}})}function x(I){return F?.trackDisposable(I),I}function j(I){F?.markAsDisposed(I)}function te(I,u){F?.setParent(I,u)}function P(I,u){if(F)for(const B of I)F.setParent(B,u)}function l(I){return F?.markAsSingleton(I),I}function d(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function w(I){if(ie.Iterable.is(I)){const u=[];for(const B of I)if(B)try{B.dispose()}catch(G){u.push(G)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function k(I){for(const u of I)d(u)&&u.dispose();return[]}function q(...I){const u=ne(()=>w(I));return P(I,u),u}function ne(I){const u=x({dispose:(0,O.$gb)(()=>{j(u),I()})});return u}class p{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,x(this)}dispose(){this.g||(j(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return te(u,this),this.g?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}delete(u){if(u){if(u===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(u),u.dispose()}}deleteAndLeak(u){u&&this.f.has(u)&&(this.f.delete(u),te(u,null))}}e.$Wc=p;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new p,x(this),te(this.q,this)}dispose(){j(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$Xc=n;class i{constructor(){this.b=!1,x(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&te(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,j(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&te(u,null),u}}e.$Yc=i;class c{constructor(u){this.a=new i,this.b=!1,this.a.value=u}get value(){return this.a.value}set value(u){this.b||u===this.a.value||(this.a.value=u)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=c;class g{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=g;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,x(this)}set(u){let B=u;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,j(this))},this}}e.$2c=A;class f{constructor(){this.a=new Map}acquire(u,...B){let G=this.a.get(u);G||(G={counter:0,object:this.b(u,...B)},this.a.set(u,G));const{object:V}=G,D=(0,O.$gb)(()=>{--G.counter===0&&(this.c(u,G.object),this.a.delete(u))});return G.counter++,{object:V,dispose:D}}}e.$3c=f;class h{constructor(u){this.a=u}async acquire(u,...B){const G=this.a.acquire(u,...B);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(V){throw G.dispose(),V}}}e.$4c=h;class s{constructor(u){this.object=u}dispose(){}}e.$5c=s;function _(I){const u=new p;try{I(u)}finally{u.dispose()}}class U{constructor(){this.a=new Map,this.b=!1,x(this)}dispose(){j(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,B,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(u)?.dispose(),this.a.set(u,B)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}deleteAndLeak(u){const B=this.a.get(u);return this.a.delete(u),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=U}),define($e[25],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define($e[26],be([0,1,12]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=v,e.$om=ie;const t=new a.$Gc(1e4);function v(T){return F(T,"NFC",t)}const O=new a.$Gc(1e4);function ie(T){return F(T,"NFD",O)}const X=/[^\u0000-\u0080]/;function F(T,W,x){if(!T)return T;const j=x.get(T);if(j)return j;let te;return X.test(T)?te=T.normalize(W):te=T,x.set(T,te),te}e.$pm=function(){const T=/[\u0300-\u036f]/g;return function(W){return ie(W).replace(T,"")}}()}),define($e[27],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(O){return new t(O)}constructor(O){this.c=a&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define($e[14],be([0,1,5,10,13,24,27]),function(le,e,a,t,v,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=te;const X=!1,F=!1,T=!1;var W;(function(V){V.None=()=>v.$Xc.None;function D(ee){if(T){const{onDidAddListener:C}=ee,ue=l.create();let re=0;ee.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),C?.()}}}function Q(ee,C){return Re(ee,()=>{},0,void 0,!0,void 0,C)}V.defer=Q;function S(ee){return(C,ue=null,re)=>{let ae=!1,de;return de=ee(Ae=>{if(!ae)return de?de.dispose():ae=!0,C.call(ue,Ae)},null,re),ae&&de.dispose(),de}}V.once=S;function y(ee,C,ue){return me((re,ae=null,de)=>ee(Ae=>re.call(ae,C(Ae)),null,de),ue)}V.map=y;function H(ee,C,ue){return me((re,ae=null,de)=>ee(Ae=>{C(Ae),re.call(ae,Ae)},null,de),ue)}V.forEach=H;function K(ee,C,ue){return me((re,ae=null,de)=>ee(Ae=>C(Ae)&&re.call(ae,Ae),null,de),ue)}V.filter=K;function J(ee){return ee}V.signal=J;function Z(...ee){return(C,ue=null,re)=>{const ae=(0,v.$Uc)(...ee.map(de=>de(Ae=>C.call(ue,Ae))));return ye(ae,re)}}V.any=Z;function se(ee,C,ue,re){let ae=ue;return y(ee,de=>(ae=C(ae,de),ae),re)}V.reduce=se;function me(ee,C){let ue;const re={onWillAddFirstListener(){ue=ee(ae.fire,ae)},onDidRemoveLastListener(){ue?.dispose()}};C||D(re);const ae=new i(re);return C?.add(ae),ae.event}function ye(ee,C){return C instanceof Array?C.push(ee):C&&C.add(ee),ee}function Re(ee,C,ue=100,re=!1,ae=!1,de,Ae){let Ue,Le,Fe,je=0,he;const De={leakWarningThreshold:de,onWillAddFirstListener(){Ue=ee(He=>{je++,Le=C(Le,He),re&&!Fe&&(Be.fire(Le),Le=void 0),he=()=>{const Ve=Le;Le=void 0,Fe=void 0,(!re||je>1)&&Be.fire(Ve),je=0},typeof ue=="number"?(clearTimeout(Fe),Fe=setTimeout(he,ue)):Fe===void 0&&(Fe=0,queueMicrotask(he))})},onWillRemoveListener(){ae&&je>0&&he?.()},onDidRemoveLastListener(){he=void 0,Ue.dispose()}};Ae||D(De);const Be=new i(De);return Ae?.add(Be),Be.event}V.debounce=Re;function Te(ee,C=0,ue){return V.debounce(ee,(re,ae)=>re?(re.push(ae),re):[ae],C,void 0,!0,void 0,ue)}V.accumulate=Te;function fe(ee,C=(re,ae)=>re===ae,ue){let re=!0,ae;return K(ee,de=>{const Ae=re||!C(de,ae);return re=!1,ae=de,Ae},ue)}V.latch=fe;function ve(ee,C,ue){return[V.filter(ee,C,ue),V.filter(ee,re=>!C(re),ue)]}V.split=ve;function ge(ee,C=!1,ue=[],re){let ae=ue.slice(),de=ee(Le=>{ae?ae.push(Le):Ue.fire(Le)});re&&re.add(de);const Ae=()=>{ae?.forEach(Le=>Ue.fire(Le)),ae=null},Ue=new i({onWillAddFirstListener(){de||(de=ee(Le=>Ue.fire(Le)),re&&re.add(de))},onDidAddFirstListener(){ae&&(C?setTimeout(Ae):Ae())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return re&&re.add(Ue),Ue.event}V.buffer=ge;function Ee(ee,C){return(re,ae,de)=>{const Ae=C(new R);return ee(function(Ue){const Le=Ae.evaluate(Ue);Le!==b&&re.call(ae,Le)},void 0,de)}}V.chain=Ee;const b=Symbol("HaltChainable");class R{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(ue=>(C(ue),ue)),this}filter(C){return this.f.push(ue=>C(ue)?ue:b),this}reduce(C,ue){let re=ue;return this.f.push(ae=>(re=C(re,ae),re)),this}latch(C=(ue,re)=>ue===re){let ue=!0,re;return this.f.push(ae=>{const de=ue||!C(ae,re);return ue=!1,re=ae,de?ae:b}),this}evaluate(C){for(const ue of this.f)if(C=ue(C),C===b)break;return C}}function L(ee,C,ue=re=>re){const re=(...Ue)=>Ae.fire(ue(...Ue)),ae=()=>ee.on(C,re),de=()=>ee.removeListener(C,re),Ae=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return Ae.event}V.fromNodeEventEmitter=L;function m(ee,C,ue=re=>re){const re=(...Ue)=>Ae.fire(ue(...Ue)),ae=()=>ee.addEventListener(C,re),de=()=>ee.removeEventListener(C,re),Ae=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return Ae.event}V.fromDOMEventEmitter=m;function r(ee){return new Promise(C=>S(ee)(C))}V.toPromise=r;function E(ee){const C=new i;return ee.then(ue=>{C.fire(ue)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}V.fromPromise=E;function M(ee,C,ue){return C(ue),ee(re=>C(re))}V.runAndSubscribe=M;class z{constructor(C,ue){this._observable=C,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};ue||D(re),this.emitter=new i(re),ue&&ue.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,ue){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(ee,C){return new z(ee,C).emitter.event}V.fromObservable=oe;function we(ee){return(C,ue,re)=>{let ae=0,de=!1;const Ae={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(ee.reportChanges(),de&&(de=!1,C.call(ue)))},handlePossibleChange(){},handleChange(){de=!0}};ee.addObserver(Ae),ee.reportChanges();const Ue={dispose(){ee.removeObserver(Ae)}};return re instanceof v.$Wc?re.add(Ue):Array.isArray(re)&&re.push(Ue),Ue}}V.fromObservableLight=we})(W||(e.Event=W={}));class x{static{this.all=new Set}static{this.f=0}constructor(D){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${D}_${x.f++}`,x.all.add(this)}start(D){this.g=new ie.$he,this.listenerCount=D}stop(){if(this.g){const D=this.g.elapsed();this.durations.push(D),this.elapsedOverall+=D,this.invocationCount+=1,this.g=void 0}}}e.$je=x;let j=-1;function te(V){const D=j;return j=V,{dispose(){j=D}}}class P{static{this.f=1}constructor(D,Q,S=(P.f++).toString(16).padStart(3,"0")){this.j=D,this.threshold=Q,this.name=S,this.h=0}dispose(){this.g?.clear()}check(D,Q){const S=this.threshold;if(S<=0||Q<S)return;this.g||(this.g=new Map);const y=this.g.get(D.value)||0;if(this.g.set(D.value,y+1),this.h-=1,this.h<=0){this.h=S*.5;const[H,K]=this.getMostFrequentStack(),J=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${K}):`;console.warn(J),console.warn(H);const Z=new d(J,H);this.j(Z)}return()=>{const H=this.g.get(D.value)||0;this.g.set(D.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let D,Q=0;for(const[S,y]of this.g)(!D||Q<y)&&(D=[S,y],Q=y);return D}}class l{static create(){const D=new Error;return new l(D.stack??"")}constructor(D){this.value=D}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(D,Q){super(D),this.name="ListenerLeakError",this.stack=Q}}e.$le=d;class w extends Error{constructor(D,Q){super(D),this.name="ListenerRefusalError",this.stack=Q}}e.$me=w;let k=0;class q{constructor(D){this.value=D,this.id=k++}}const ne=2,p=(V,D)=>{if(V instanceof q)D(V);else for(let Q=0;Q<V.length;Q++){const S=V[Q];S&&D(S)}};let n;if(X){const V=[];setInterval(()=>{V.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(V.join(`
`)),V.length=0)},3e3),n=new FinalizationRegistry(D=>{typeof D=="string"&&V.push(D)})}class i{constructor(D){this.z=0,this.f=D,this.g=j>0||this.f?.leakWarningThreshold?new P(D?.onListenerError??a.$3,this.f?.leakWarningThreshold??j):void 0,this.j=this.f?._profName?new x(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(F){const D=this.u;queueMicrotask(()=>{p(D,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(D,Q,S)=>{if(this.g&&this.z>this.g.threshold**2){const Z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(Z);const se=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],me=new w(`${Z}. HINT: Stack shows most frequent listener (${se[1]}-times)`,se[0]);return(this.f?.onListenerError||a.$3)(me),v.$Xc.None}if(this.m)return v.$Xc.None;Q&&(D=D.bind(Q));const y=new q(D);let H,K;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(y.stack=l.create(),H=this.g.check(y.stack,this.z+1)),F&&(y.stack=K??l.create()),this.u?this.u instanceof q?(this.w??=new g,this.u=[this.u,y]):this.u.push(y):(this.f?.onWillAddFirstListener?.(this),this.u=y,this.f?.onDidAddFirstListener?.(this)),this.z++;const J=(0,v.$Vc)(()=>{n?.unregister(J),H?.(),this.A(y)});if(S instanceof v.$Wc?S.add(J):Array.isArray(S)&&S.push(J),n){const Z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),se=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Z);n.register(J,se?.[2]??Z,J)}return J},this.q}A(D){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,S=Q.indexOf(D);if(S===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[S]=void 0;const y=this.w.current===this;if(this.z*ne<=Q.length){let H=0;for(let K=0;K<Q.length;K++)Q[K]?Q[H++]=Q[K]:y&&(this.w.end--,H<this.w.i&&this.w.i--);Q.length=H}}B(D,Q){if(!D)return;const S=this.f?.onListenerError||a.$3;if(!S){D.value(Q);return}try{D.value(Q)}catch(y){S(y)}}C(D){const Q=D.current.u;for(;D.i<D.end;)this.B(Q[D.i++],D.value);D.reset()}fire(D){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof q)this.B(this.u,D);else{const Q=this.w;Q.enqueue(this,D,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const c=()=>new g;e.$oe=c;class g{constructor(){this.i=-1,this.end=0}enqueue(D,Q,S){this.i=0,this.end=S,this.current=D,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class A extends i{async fireAsync(D,Q,S){if(this.u)for(this.h||(this.h=new O.$8c),p(this.u,y=>this.h.push([y.value,D]));this.h.size>0&&!Q.isCancellationRequested;){const[y,H]=this.h.shift(),K=[],J={...H,token:Q,waitUntil:Z=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");S&&(Z=S(Z,y)),K.push(Z)}};try{y(J)}catch(Z){(0,a.$3)(Z);continue}Object.freeze(K),await Promise.allSettled(K).then(Z=>{for(const se of Z)se.status==="rejected"&&(0,a.$3)(se.reason)})}}}e.$pe=A;class f extends i{get isPaused(){return this.h!==0}constructor(D){super(D),this.h=0,this.s=new O.$8c,this.t=D?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const D=Array.from(this.s);this.s.clear(),super.fire(this.t(D))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(D){this.z&&(this.h!==0?this.s.push(D):super.fire(D))}}e.$qe=f;class h extends f{constructor(D){super(D),this.k=D.delay??100}fire(D){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(D)}}e.$re=h;class s extends i{constructor(D){super(D),this.h=[],this.k=D?.merge}fire(D){this.hasListeners()&&(this.h.push(D),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$se=s;class _{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(D){const Q={event:D,listener:null};this.h.push(Q),this.g&&this.m(Q);const S=()=>{this.g&&this.o(Q);const y=this.h.indexOf(Q);this.h.splice(y,1)};return(0,v.$Vc)((0,t.$gb)(S))}j(){this.g=!0,this.h.forEach(D=>this.m(D))}k(){this.g=!1,this.h.forEach(D=>this.o(D))}m(D){D.listener=D.event(Q=>this.f.fire(Q))}o(D){D.listener?.dispose(),D.listener=null}dispose(){this.f.dispose();for(const D of this.h)D.listener?.dispose();this.h=[]}}e.$te=_;class U{constructor(D,Q,S,y){this.f=new v.$Wc;const H=this.f.add(new _),K=this.f.add(new v.$7c);function J(Z){K.set(Z,H.add(y(Z)))}for(const Z of D)J(Z);this.f.add(Q(Z=>{J(Z)})),this.f.add(S(Z=>{K.deleteAndDispose(Z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ue=U;class I{constructor(){this.f=[]}wrapEvent(D,Q,S){return(y,H,K)=>D(J=>{const Z=this.f[this.f.length-1];if(!Q){Z?Z.buffers.push(()=>y.call(H,J)):y.call(H,J);return}const se=Z;if(!se){y.call(H,Q(S,J));return}se.items??=[],se.items.push(J),se.buffers.length===0&&Z.buffers.push(()=>{se.reducedResult??=S?se.items.reduce(Q,S):se.items.reduce(Q),y.call(H,se.reducedResult)})},void 0,K)}bufferEvents(D){const Q={buffers:new Array};this.f.push(Q);const S=D();return this.f.pop(),Q.buffers.forEach(y=>y()),S}}e.$ve=I;class u{constructor(){this.f=!1,this.g=W.None,this.h=v.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(D){this.g=D,this.f&&(this.h.dispose(),this.h=D(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=u;class B{static const(D){return new G(D)}constructor(D){this.g=D,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(D){D!==this.g&&(this.g=D,this.f.fire(void 0))}}e.$xe=B;class G{constructor(D){this.value=D,this.onDidChange=W.None}}}),define($e[15],be([0,1,14]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=X;const t=Object.freeze(function(F,T){const W=setTimeout(F.bind(T),0);return{dispose(){clearTimeout(W)}}});var v;(function(F){function T(W){return W===F.None||W===F.Cancelled||W instanceof O?!0:!W||typeof W!="object"?!1:typeof W.isCancellationRequested=="boolean"&&typeof W.onCancellationRequested=="function"}F.isCancellationToken=T,F.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),F.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(v||(e.CancellationToken=v={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class ie{constructor(T){this.f=void 0,this.g=void 0,this.g=T&&T.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=v.Cancelled}dispose(T=!1){T&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=v.None}}e.$ye=ie;function X(F){const T=new ie;return F.add({dispose(){T.cancel()}}),T.token}}),define($e[28],be([0,1,15]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=v;class t{constructor(F){this.b=F,this.a=null}get(){if(this.a)return this.a;const F=new a.$ye,T=this.b(F.token);return this.a={promise:T,dispose:()=>{this.a=null,F.cancel(),F.dispose()}},this.a}}e.$$e=t;function v(X){return X}class O{constructor(F,T){this.a=void 0,this.b=void 0,typeof F=="function"?(this.c=F,this.d=v):(this.c=T,this.d=F.getCacheKey)}get(F){const T=this.d(F);return this.b!==T&&(this.b=T,this.a=this.c(F)),this.a}}e.$af=O;class ie{get cachedValues(){return this.a}constructor(F,T){this.a=new Map,this.b=new Map,typeof F=="function"?(this.c=F,this.d=v):(this.c=T,this.d=F.getCacheKey)}get(F){const T=this.d(F);if(this.b.has(T))return this.b.get(T);const W=this.c(F);return this.a.set(F,W),this.b.set(T,W),W}}e.$bf=ie}),define($e[29],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define($e[30],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=a,e.$hg=t,e.$ig=v,e.$jg=O,e.$kg=ie,e.$lg=X,e.$mg=F,e.$ng=T,e.$og=W,e.$pg=x,e.$qg=j,e.$rg=te,e.$sg=P,e.$tg=d,e.$ug=w,e.$vg=k,e.$wg=q,e.$xg=ne;function a(p){return typeof p=="string"}function t(p){return Array.isArray(p)&&p.every(n=>a(n))}function v(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}function O(p){const n=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof n}function ie(p){return typeof p=="number"&&!isNaN(p)}function X(p){return!!p&&typeof p[Symbol.iterator]=="function"}function F(p){return p===!0||p===!1}function T(p){return typeof p>"u"}function W(p){return!x(p)}function x(p){return T(p)||p===null}function j(p,n){if(!p)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function te(p){if(x(p))throw new Error("Assertion Failed: argument is undefined or null");return p}function P(...p){const n=[];for(let i=0;i<p.length;i++){const c=p[i];if(x(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(c)}return n}const l=Object.prototype.hasOwnProperty;function d(p){if(!v(p))return!1;for(const n in p)if(l.call(p,n))return!1;return!0}function w(p){return typeof p=="function"}function k(...p){return p.length>0&&p.every(w)}function q(p,n){const i=Math.min(p.length,n.length);for(let c=0;c<i;c++)ne(p[c],n[c])}function ne(p,n){if(a(n)){if(typeof p!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(w(n)){try{if(p instanceof n)return}catch{}if(!x(p)&&p.constructor===n||n.length===1&&n.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define($e[31],be([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=v;var a;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t(O){return O<0?0:O>a.MAX_UINT_8?a.MAX_UINT_8:O|0}function v(O){return O<0?0:O>a.MAX_UINT_32?a.MAX_UINT_32:O|0}}),define($e[7],be([0,1,28,4,11,31]),function(le,e,a,t,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=ie,e.$ff=F,e.$gf=W,e.$hf=x,e.$if=j,e.$jf=te,e.$kf=P,e.$lf=l,e.$mf=d,e.$nf=w,e.$of=k,e.$pf=q,e.$qf=ne,e.$rf=p,e.$sf=n,e.$tf=i,e.$uf=c,e.$vf=g,e.$wf=A,e.$xf=f,e.$yf=h,e.$zf=s,e.$Af=_,e.$Bf=U,e.$Cf=I,e.$Df=u,e.$Ef=B,e.$Ff=G,e.$Gf=V,e.$Hf=D,e.$If=Q,e.$Jf=S,e.$Kf=y,e.$Lf=H,e.$Mf=K,e.$Nf=J,e.$Of=Z,e.$Rf=Re,e.$Sf=Te,e.$Tf=fe,e.$Uf=ve,e.$Vf=b,e.$Wf=L,e.$Yf=m,e.$Zf=r,e.$1f=E,e.$2f=M,e.$3f=oe,e.$4f=we,e.$5f=C,e.$7f=ue,e.$8f=re,e.$9f=ae,e.$0f=de,e.$$f=Ae,e.$_f=Ue,e.$ag=Le,e.$bg=Fe,e.$cg=He;function ie(o){return!o||typeof o!="string"?!0:o.trim().length===0}const X=/{(\d+)}/g;function F(o,...$){return $.length===0?o:o.replace(X,function(N,Y){const ce=parseInt(Y,10);return isNaN(ce)||ce<0||ce>=$.length?N:$[ce]})}const T=/{([^}]+)}/g;function W(o,$){return Object.keys($).length===0?o:o.replace(T,(N,Y)=>$[Y]??N)}function x(o){return o.replace(/[<>"'&]/g,$=>{switch($){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $})}function j(o){return o.replace(/[<>&]/g,function($){switch($){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $}})}function te(o){return o.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function P(o,$){let N=0,Y=o.indexOf($);for(;Y!==-1;)N++,Y=o.indexOf($,Y+$.length);return N}function l(o,$,N="\u2026"){return o.length<=$?o:`${o.substr(0,$)}${N}`}function d(o,$,N="\u2026"){if(o.length<=$)return o;const Y=Math.ceil($/2)-N.length/2,ce=Math.floor($/2)-N.length/2;return`${o.substr(0,Y)}${N}${o.substr(o.length-ce)}`}function w(o,$=" "){const N=k(o,$);return q(N,$)}function k(o,$){if(!o||!$)return o;const N=$.length;if(N===0||o.length===0)return o;let Y=0;for(;o.indexOf($,Y)===Y;)Y=Y+N;return o.substring(Y)}function q(o,$){if(!o||!$)return o;const N=$.length,Y=o.length;if(N===0||Y===0)return o;let ce=Y,_e=-1;for(;_e=o.lastIndexOf($,ce-1),!(_e===-1||_e+N!==ce);){if(_e===0)return"";ce=_e}return o.substring(0,ce)}function ne(o){return o.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function p(o){return o.replace(/\*/g,"")}function n(o,$,N={}){if(!o)throw new Error("Cannot create regex from empty string");$||(o=te(o)),N.wholeWord&&(/\B/.test(o.charAt(0))||(o="\\b"+o),/\B/.test(o.charAt(o.length-1))||(o=o+"\\b"));let Y="";return N.global&&(Y+="g"),N.matchCase||(Y+="i"),N.multiline&&(Y+="m"),N.unicode&&(Y+="u"),new RegExp(o,Y)}function i(o){return o.source==="^"||o.source==="^$"||o.source==="$"||o.source==="^\\s*$"?!1:!!(o.exec("")&&o.lastIndex===0)}function c(o){return o.split(/\r\n|\r|\n/)}function g(o){const $=[],N=o.split(/(\r\n|\r|\n)/);for(let Y=0;Y<Math.ceil(N.length/2);Y++)$.push(N[2*Y]+(N[2*Y+1]??""));return $}function A(o){for(let $=0,N=o.length;$<N;$++){const Y=o.charCodeAt($);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return $}return-1}function f(o,$=0,N=o.length){for(let Y=$;Y<N;Y++){const ce=o.charCodeAt(Y);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return o.substring($,Y)}return o.substring($,N)}function h(o,$=o.length-1){for(let N=$;N>=0;N--){const Y=o.charCodeAt(N);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return N}return-1}function s(o,$,N){const Y=[];let ce=0;for(const _e of o.matchAll($)){if(Y.push(o.slice(ce,_e.index)),_e.index===void 0)throw new Error("match.index should be defined");ce=_e.index+_e[0].length,Y.push(N(_e[0],..._e.slice(1),_e.index,o,_e.groups))}return Y.push(o.slice(ce)),Promise.all(Y).then(_e=>_e.join(""))}function _(o,$){return o<$?-1:o>$?1:0}function U(o,$,N=0,Y=o.length,ce=0,_e=$.length){for(;N<Y&&ce<_e;N++,ce++){const Se=o.charCodeAt(N),Pe=$.charCodeAt(ce);if(Se<Pe)return-1;if(Se>Pe)return 1}const Oe=Y-N,Me=_e-ce;return Oe<Me?-1:Oe>Me?1:0}function I(o,$){return u(o,$,0,o.length,0,$.length)}function u(o,$,N=0,Y=o.length,ce=0,_e=$.length){for(;N<Y&&ce<_e;N++,ce++){let Se=o.charCodeAt(N),Pe=$.charCodeAt(ce);if(Se===Pe)continue;if(Se>=128||Pe>=128)return U(o.toLowerCase(),$.toLowerCase(),N,Y,ce,_e);G(Se)&&(Se-=32),G(Pe)&&(Pe-=32);const Ie=Se-Pe;if(Ie!==0)return Ie}const Oe=Y-N,Me=_e-ce;return Oe<Me?-1:Oe>Me?1:0}function B(o){return o>=t.CharCode.Digit0&&o<=t.CharCode.Digit9}function G(o){return o>=t.CharCode.a&&o<=t.CharCode.z}function V(o){return o>=t.CharCode.A&&o<=t.CharCode.Z}function D(o,$){return o.length===$.length&&u(o,$)===0}function Q(o,$){const N=$.length;return $.length>o.length?!1:u(o,$,0,N)===0}function S(o,$){const N=Math.min(o.length,$.length);let Y;for(Y=0;Y<N;Y++)if(o.charCodeAt(Y)!==$.charCodeAt(Y))return Y;return N}function y(o,$){const N=Math.min(o.length,$.length);let Y;const ce=o.length-1,_e=$.length-1;for(Y=0;Y<N;Y++)if(o.charCodeAt(ce-Y)!==$.charCodeAt(_e-Y))return Y;return N}function H(o){return 55296<=o&&o<=56319}function K(o){return 56320<=o&&o<=57343}function J(o,$){return(o-55296<<10)+($-56320)+65536}function Z(o,$,N){const Y=o.charCodeAt(N);if(H(Y)&&N+1<$){const ce=o.charCodeAt(N+1);if(K(ce))return J(Y,ce)}return Y}function se(o,$){const N=o.charCodeAt($-1);if(K(N)&&$>1){const Y=o.charCodeAt($-2);if(H(Y))return J(Y,N)}return N}class me{get offset(){return this.e}constructor($,N=0){this.c=$,this.d=$.length,this.e=N}setOffset($){this.e=$}prevCodePoint(){const $=se(this.c,this.e);return this.e-=$>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,$}nextCodePoint(){const $=Z(this.c,this.d,this.e);return this.e+=$>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,$}eol(){return this.e>=this.d}}e.$Pf=me;class ye{get offset(){return this.c.offset}constructor($,N=0){this.c=new me($,N)}nextGraphemeLength(){const $=De.getInstance(),N=this.c,Y=N.offset;let ce=$.getGraphemeBreakType(N.nextCodePoint());for(;!N.eol();){const _e=N.offset,Oe=$.getGraphemeBreakType(N.nextCodePoint());if(je(ce,Oe)){N.setOffset(_e);break}ce=Oe}return N.offset-Y}prevGraphemeLength(){const $=De.getInstance(),N=this.c,Y=N.offset;let ce=$.getGraphemeBreakType(N.prevCodePoint());for(;N.offset>0;){const _e=N.offset,Oe=$.getGraphemeBreakType(N.prevCodePoint());if(je(Oe,ce)){N.setOffset(_e);break}ce=Oe}return Y-N.offset}eol(){return this.c.eol()}}e.$Qf=ye;function Re(o,$){return new ye(o,$).nextGraphemeLength()}function Te(o,$){return new ye(o,$).prevGraphemeLength()}function fe(o,$){$>0&&K(o.charCodeAt($))&&$--;const N=$+Re(o,$);return[N-Te(o,N),N]}function ve(o){const $=new ye(o);let N=0;for(;!$.eol();)N++,$.nextGraphemeLength();return N}let ge;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function b(o){return ge||(ge=Ee()),ge.test(o)}const R=/^[\t\n\r\x20-\x7E]*$/;function L(o){return R.test(o)}e.$Xf=/[\u2028\u2029]/;function m(o){return e.$Xf.test(o)}function r(o){return o>=11904&&o<=55215||o>=63744&&o<=64255||o>=65281&&o<=65374}function E(o){return o>=127462&&o<=127487||o===8986||o===8987||o===9200||o===9203||o>=9728&&o<=10175||o===11088||o===11093||o>=127744&&o<=128591||o>=128640&&o<=128764||o>=128992&&o<=129008||o>=129280&&o<=129535||o>=129648&&o<=129782}function M(o,$,N=""){const Y=o.trimStart();if(Y.length<$)return Y;const ce=/\b/g;let _e=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<$);)_e=ce.lastIndex,ce.lastIndex+=1;return _e===0?Y:N+Y.substring(_e).trimStart()}const z=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*oe(o){let $=0;for(const N of o.matchAll(z))$!==N.index&&(yield{isCode:!1,str:o.substring($,N.index)}),yield{isCode:!0,str:N[0]},$=N.index+N[0].length;$!==o.length&&(yield{isCode:!1,str:o.substring($)})}function we(o){return o&&(o=o.replace(z,"")),o}const ee=/\\\[.*?\\\]/g;function C(o){return we(o).replace(ee,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function ue(o){return!!(o&&o.length>0&&o.charCodeAt(0)===t.CharCode.UTF8_BOM)}function re(o){return ue(o)?o.substr(1):o}function ae(o,$){if(!o||!$||o.length<$.length)return!1;const N=$.length,Y=o.toLowerCase();let ce=0,_e=-1;for(;ce<N;){const Oe=Y.indexOf($[ce],_e+1);if(Oe<0)return!1;_e=Oe,ce++}return!0}function de(o,$=!1){return o?($&&(o=o.replace(/\\./g,"")),o.toLowerCase()!==o):!1}function Ae(o){return o.charAt(0).toUpperCase()+o.slice(1)}function Ue(o,$=1){if($===0)return"";let N=-1;do N=o.indexOf(`
`,N+1),$--;while($>0&&N>=0);return N===-1?o:(o[N-1]==="\r"&&N--,o.substr(0,N))}function Le(o){const $=t.CharCode.Z-t.CharCode.A+1;return o=o%(2*$),o<$?String.fromCharCode(t.CharCode.a+o):String.fromCharCode(t.CharCode.A+o-$)}function Fe(o){return De.getInstance().getGraphemeBreakType(o)}function je(o,$){return o===he.Other?$!==he.Extend&&$!==he.SpacingMark:o===he.CR&&$===he.LF?!1:o===he.Control||o===he.CR||o===he.LF||$===he.Control||$===he.CR||$===he.LF?!0:!(o===he.L&&($===he.L||$===he.V||$===he.LV||$===he.LVT)||(o===he.LV||o===he.V)&&($===he.V||$===he.T)||(o===he.LVT||o===he.T)&&$===he.T||$===he.Extend||$===he.ZWJ||$===he.SpacingMark||o===he.Prepend||o===he.ZWJ&&$===he.Extended_Pictographic||o===he.Regional_Indicator&&$===he.Regional_Indicator)}var he;(function(o){o[o.Other=0]="Other",o[o.Prepend=1]="Prepend",o[o.CR=2]="CR",o[o.LF=3]="LF",o[o.Control=4]="Control",o[o.Extend=5]="Extend",o[o.Regional_Indicator=6]="Regional_Indicator",o[o.SpacingMark=7]="SpacingMark",o[o.L=8]="L",o[o.V=9]="V",o[o.T=10]="T",o[o.LV=11]="LV",o[o.LVT=12]="LVT",o[o.ZWJ=13]="ZWJ",o[o.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Be()}getGraphemeBreakType($){if($<32)return $===t.CharCode.LineFeed?he.LF:$===t.CharCode.CarriageReturn?he.CR:he.Control;if($<127)return he.Other;const N=this.d,Y=N.length/3;let ce=1;for(;ce<=Y;)if($<N[3*ce])ce=2*ce;else if($>N[3*ce+1])ce=2*ce+1;else return N[3*ce+2];return he.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(o,$){if(o===0)return 0;const N=Ve(o,$);if(N!==void 0)return N;const Y=new me($,o);return Y.prevCodePoint(),Y.offset}function Ve(o,$){const N=new me($,o);let Y=N.prevCodePoint();for(;Je(Y)||Y===We.emojiVariantSelector||Y===We.enclosingKeyCap;){if(N.offset===0)return;Y=N.prevCodePoint()}if(!E(Y))return;let ce=N.offset;return ce>0&&N.prevCodePoint()===We.zwj&&(ce=N.offset),ce}function Je(o){return 127995<=o&&o<=127999}var We;(function(o){o[o.zwj=8205]="zwj",o[o.emojiVariantSelector=65039]="emojiVariantSelector",o[o.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$dg="\xA0";class qe{static{this.c=new v.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new a.$af({getCacheKey:JSON.stringify},$=>{function N(Ie){const ke=new Map;for(let Ne=0;Ne<Ie.length;Ne+=2)ke.set(Ie[Ne],Ie[Ne+1]);return ke}function Y(Ie,ke){const Ne=new Map(Ie);for(const[Ge,Ke]of ke)Ne.set(Ge,Ke);return Ne}function ce(Ie,ke){if(!Ie)return ke;const Ne=new Map;for(const[Ge,Ke]of Ie)ke.has(Ge)&&Ne.set(Ge,Ke);return Ne}const _e=this.c.value;let Oe=$.filter(Ie=>!Ie.startsWith("_")&&Ie in _e);Oe.length===0&&(Oe=["_default"]);let Me;for(const Ie of Oe){const ke=N(_e[Ie]);Me=ce(Me,ke)}const Se=N(_e._common),Pe=Y(Se,Me);return new qe(Pe)})}static getInstance($){return qe.d.get(Array.from($))}static{this.e=new v.$X(()=>Object.keys(qe.c.value).filter($=>!$.startsWith("_")))}static getLocales(){return qe.e.value}constructor($){this.f=$}isAmbiguous($){return this.f.has($)}containsAmbiguousCharacter($){for(let N=0;N<$.length;N++){const Y=$.codePointAt(N);if(typeof Y=="number"&&this.isAmbiguous(Y))return!0}return!1}getPrimaryConfusable($){return this.f.get($)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=qe;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter($){return ze.e().has($)}static containsInvisibleCharacter($){for(let N=0;N<$.length;N++){const Y=$.codePointAt(N);if(typeof Y=="number"&&ze.isInvisibleCharacter(Y))return!0}return!1}static get codePoints(){return ze.e()}}e.$fg=ze}),define($e[32],be([33,34]),function(le,e){return le.create("vs/base/common/platform",e)});var Xe=this&&this.__createBinding||(Object.create?function(le,e,a,t){t===void 0&&(t=a);var v=Object.getOwnPropertyDescriptor(e,a);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(le,t,v)}:function(le,e,a,t){t===void 0&&(t=a),le[t]=e[a]}),Ye=this&&this.__setModuleDefault||(Object.create?function(le,e){Object.defineProperty(le,"default",{enumerable:!0,value:e})}:function(le,e){le.default=e}),pe=this&&this.__importStar||function(le){if(le&&le.__esModule)return le;var e={};if(le!=null)for(var a in le)a!=="default"&&Object.prototype.hasOwnProperty.call(le,a)&&Xe(e,le,a);return Ye(e,le),e};define($e[2],be([0,1,32]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=s,e.$J=_,a=pe(a),e.$g="en";let t=!1,v=!1,O=!1,ie=!1,X=!1,F=!1,T=!1,W=!1,x=!1,j=!1,te,P=e.$g,l=e.$g,d,w;const k=globalThis;let q;typeof k.vscode<"u"&&typeof k.vscode.process<"u"?q=k.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(q=process);const ne=typeof q?.versions?.electron=="string",p=ne&&q?.type==="renderer";if(typeof q=="object"){t=q.platform==="win32",v=q.platform==="darwin",O=q.platform==="linux",ie=O&&!!q.env.SNAP&&!!q.env.SNAP_REVISION,T=ne,x=!!q.env.CI||!!q.env.BUILD_ARTIFACTSTAGINGDIRECTORY,te=e.$g,P=e.$g;const U=q.env.VSCODE_NLS_CONFIG;if(U)try{const I=JSON.parse(U),u=I.availableLanguages["*"];te=I.locale,l=I.osLocale,P=u||e.$g,d=I._translationsConfigFile}catch{}X=!0}else typeof navigator=="object"&&!p?(w=navigator.userAgent,t=w.indexOf("Windows")>=0,v=w.indexOf("Macintosh")>=0,W=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=w.indexOf("Linux")>=0,j=w?.indexOf("Mobi")>=0,F=!0,te=a.getConfiguredDefaultLocale(a.localize(0,null))||e.$g,P=te,l=navigator.language):console.error("Unable to resolve platform.");var n;(function(U){U[U.Web=0]="Web",U[U.Mac=1]="Mac",U[U.Linux=2]="Linux",U[U.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(U){switch(U){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let c=n.Web;v?c=n.Mac:t?c=n.Windows:O&&(c=n.Linux),e.$i=t,e.$j=v,e.$k=O,e.$l=ie,e.$m=X,e.$n=T,e.$o=F,e.$p=F&&typeof k.importScripts=="function",e.$q=e.$p?k.origin:void 0,e.$r=W,e.$s=j,e.$t=x,e.$u=c,e.$v=w,e.$w=P;var g;(function(U){function I(){return e.$w}U.value=I;function u(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}U.isDefaultVariant=u;function B(){return e.$w==="en"}U.isDefault=B})(g||(e.Language=g={})),e.$x=te,e.$y=l,e.$z=d,e.$A=typeof k.postMessage=="function"&&!k.importScripts,e.$B=(()=>{if(e.$A){const U=[];k.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let B=0,G=U.length;B<G;B++){const V=U[B];if(V.id===u.data.vscodeScheduleAsyncWork){U.splice(B,1),V.callback();return}}});let I=0;return u=>{const B=++I;U.push({id:B,callback:u}),k.postMessage({vscodeScheduleAsyncWork:B},"*")}}return U=>setTimeout(U)})();var A;(function(U){U[U.Windows=1]="Windows",U[U.Macintosh=2]="Macintosh",U[U.Linux=3]="Linux"})(A||(e.OperatingSystem=A={})),e.OS=v||W?A.Macintosh:t?A.Windows:A.Linux;let f=!0,h=!1;function s(){if(!h){h=!0;const U=new Uint8Array(2);U[0]=1,U[1]=2,f=new Uint16Array(U.buffer)[0]===513}return f}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function _(U){return parseFloat(U)>=20}}),define($e[16],be([0,1,2]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.process<"u"){const O=v.process;t={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.$i?"win32":a.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch}),define($e[3],be([0,1,16]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,a=pe(a);const t=65,v=97,O=90,ie=122,X=46,F=47,T=92,W=58,x=63;class j extends Error{constructor(i,c,g){let A;typeof c=="string"&&c.indexOf("not ")===0?(A="must not be",c=c.replace(/^not /,"")):A="must be";const f=i.indexOf(".")!==-1?"property":"argument";let h=`The "${i}" ${f} ${A} of type ${c}`;h+=`. Received type ${typeof g}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function te(n,i){if(n===null||typeof n!="object")throw new j(i,"Object",n)}function P(n,i){if(typeof n!="string")throw new j(i,"string",n)}const l=a.$gc==="win32";function d(n){return n===F||n===T}function w(n){return n===F}function k(n){return n>=t&&n<=O||n>=v&&n<=ie}function q(n,i,c,g){let A="",f=0,h=-1,s=0,_=0;for(let U=0;U<=n.length;++U){if(U<n.length)_=n.charCodeAt(U);else{if(g(_))break;_=F}if(g(_)){if(!(h===U-1||s===1))if(s===2){if(A.length<2||f!==2||A.charCodeAt(A.length-1)!==X||A.charCodeAt(A.length-2)!==X){if(A.length>2){const I=A.lastIndexOf(c);I===-1?(A="",f=0):(A=A.slice(0,I),f=A.length-1-A.lastIndexOf(c)),h=U,s=0;continue}else if(A.length!==0){A="",f=0,h=U,s=0;continue}}i&&(A+=A.length>0?`${c}..`:"..",f=2)}else A.length>0?A+=`${c}${n.slice(h+1,U)}`:A=n.slice(h+1,U),f=U-h-1;h=U,s=0}else _===X&&s!==-1?++s:s=-1}return A}function ne(n,i){te(i,"pathObject");const c=i.dir||i.root,g=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${g}`:`${c}${n}${g}`:g}e.$ic={resolve(...n){let i="",c="",g=!1;for(let A=n.length-1;A>=-1;A--){let f;if(A>=0){if(f=n[A],P(f,"path"),f.length===0)continue}else i.length===0?f=a.cwd():(f=a.env[`=${i}`]||a.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==i.toLowerCase()&&f.charCodeAt(2)===T)&&(f=`${i}\\`));const h=f.length;let s=0,_="",U=!1;const I=f.charCodeAt(0);if(h===1)d(I)&&(s=1,U=!0);else if(d(I))if(U=!0,d(f.charCodeAt(1))){let u=2,B=u;for(;u<h&&!d(f.charCodeAt(u));)u++;if(u<h&&u!==B){const G=f.slice(B,u);for(B=u;u<h&&d(f.charCodeAt(u));)u++;if(u<h&&u!==B){for(B=u;u<h&&!d(f.charCodeAt(u));)u++;(u===h||u!==B)&&(_=`\\\\${G}\\${f.slice(B,u)}`,s=u)}}}else s=1;else k(I)&&f.charCodeAt(1)===W&&(_=f.slice(0,2),s=2,h>2&&d(f.charCodeAt(2))&&(U=!0,s=3));if(_.length>0)if(i.length>0){if(_.toLowerCase()!==i.toLowerCase())continue}else i=_;if(g){if(i.length>0)break}else if(c=`${f.slice(s)}\\${c}`,g=U,U&&i.length>0)break}return c=q(c,!g,"\\",d),g?`${i}\\${c}`:`${i}${c}`||"."},normalize(n){P(n,"path");const i=n.length;if(i===0)return".";let c=0,g,A=!1;const f=n.charCodeAt(0);if(i===1)return w(f)?"\\":n;if(d(f))if(A=!0,d(n.charCodeAt(1))){let s=2,_=s;for(;s<i&&!d(n.charCodeAt(s));)s++;if(s<i&&s!==_){const U=n.slice(_,s);for(_=s;s<i&&d(n.charCodeAt(s));)s++;if(s<i&&s!==_){for(_=s;s<i&&!d(n.charCodeAt(s));)s++;if(s===i)return`\\\\${U}\\${n.slice(_)}\\`;s!==_&&(g=`\\\\${U}\\${n.slice(_,s)}`,c=s)}}}else c=1;else k(f)&&n.charCodeAt(1)===W&&(g=n.slice(0,2),c=2,i>2&&d(n.charCodeAt(2))&&(A=!0,c=3));let h=c<i?q(n.slice(c),!A,"\\",d):"";return h.length===0&&!A&&(h="."),h.length>0&&d(n.charCodeAt(i-1))&&(h+="\\"),g===void 0?A?`\\${h}`:h:A?`${g}\\${h}`:`${g}${h}`},isAbsolute(n){P(n,"path");const i=n.length;if(i===0)return!1;const c=n.charCodeAt(0);return d(c)||i>2&&k(c)&&n.charCodeAt(1)===W&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,c;for(let f=0;f<n.length;++f){const h=n[f];P(h,"path"),h.length>0&&(i===void 0?i=c=h:i+=`\\${h}`)}if(i===void 0)return".";let g=!0,A=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++A;const f=c.length;f>1&&d(c.charCodeAt(1))&&(++A,f>2&&(d(c.charCodeAt(2))?++A:g=!1))}if(g){for(;A<i.length&&d(i.charCodeAt(A));)A++;A>=2&&(i=`\\${i.slice(A)}`)}return e.$ic.normalize(i)},relative(n,i){if(P(n,"from"),P(i,"to"),n===i)return"";const c=e.$ic.resolve(n),g=e.$ic.resolve(i);if(c===g||(n=c.toLowerCase(),i=g.toLowerCase(),n===i))return"";let A=0;for(;A<n.length&&n.charCodeAt(A)===T;)A++;let f=n.length;for(;f-1>A&&n.charCodeAt(f-1)===T;)f--;const h=f-A;let s=0;for(;s<i.length&&i.charCodeAt(s)===T;)s++;let _=i.length;for(;_-1>s&&i.charCodeAt(_-1)===T;)_--;const U=_-s,I=h<U?h:U;let u=-1,B=0;for(;B<I;B++){const V=n.charCodeAt(A+B);if(V!==i.charCodeAt(s+B))break;V===T&&(u=B)}if(B!==I){if(u===-1)return g}else{if(U>I){if(i.charCodeAt(s+B)===T)return g.slice(s+B+1);if(B===2)return g.slice(s+B)}h>I&&(n.charCodeAt(A+B)===T?u=B:B===2&&(u=3)),u===-1&&(u=0)}let G="";for(B=A+u+1;B<=f;++B)(B===f||n.charCodeAt(B)===T)&&(G+=G.length===0?"..":"\\..");return s+=u,G.length>0?`${G}${g.slice(s,_)}`:(g.charCodeAt(s)===T&&++s,g.slice(s,_))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$ic.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===T){if(i.charCodeAt(1)===T){const c=i.charCodeAt(2);if(c!==x&&c!==X)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(k(i.charCodeAt(0))&&i.charCodeAt(1)===W&&i.charCodeAt(2)===T)return`\\\\?\\${i}`;return n},dirname(n){P(n,"path");const i=n.length;if(i===0)return".";let c=-1,g=0;const A=n.charCodeAt(0);if(i===1)return d(A)?n:".";if(d(A)){if(c=g=1,d(n.charCodeAt(1))){let s=2,_=s;for(;s<i&&!d(n.charCodeAt(s));)s++;if(s<i&&s!==_){for(_=s;s<i&&d(n.charCodeAt(s));)s++;if(s<i&&s!==_){for(_=s;s<i&&!d(n.charCodeAt(s));)s++;if(s===i)return n;s!==_&&(c=g=s+1)}}}}else k(A)&&n.charCodeAt(1)===W&&(c=i>2&&d(n.charCodeAt(2))?3:2,g=c);let f=-1,h=!0;for(let s=i-1;s>=g;--s)if(d(n.charCodeAt(s))){if(!h){f=s;break}}else h=!1;if(f===-1){if(c===-1)return".";f=c}return n.slice(0,f)},basename(n,i){i!==void 0&&P(i,"ext"),P(n,"path");let c=0,g=-1,A=!0,f;if(n.length>=2&&k(n.charCodeAt(0))&&n.charCodeAt(1)===W&&(c=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let h=i.length-1,s=-1;for(f=n.length-1;f>=c;--f){const _=n.charCodeAt(f);if(d(_)){if(!A){c=f+1;break}}else s===-1&&(A=!1,s=f+1),h>=0&&(_===i.charCodeAt(h)?--h===-1&&(g=f):(h=-1,g=s))}return c===g?g=s:g===-1&&(g=n.length),n.slice(c,g)}for(f=n.length-1;f>=c;--f)if(d(n.charCodeAt(f))){if(!A){c=f+1;break}}else g===-1&&(A=!1,g=f+1);return g===-1?"":n.slice(c,g)},extname(n){P(n,"path");let i=0,c=-1,g=0,A=-1,f=!0,h=0;n.length>=2&&n.charCodeAt(1)===W&&k(n.charCodeAt(0))&&(i=g=2);for(let s=n.length-1;s>=i;--s){const _=n.charCodeAt(s);if(d(_)){if(!f){g=s+1;break}continue}A===-1&&(f=!1,A=s+1),_===X?c===-1?c=s:h!==1&&(h=1):c!==-1&&(h=-1)}return c===-1||A===-1||h===0||h===1&&c===A-1&&c===g+1?"":n.slice(c,A)},format:ne.bind(null,"\\"),parse(n){P(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const c=n.length;let g=0,A=n.charCodeAt(0);if(c===1)return d(A)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(d(A)){if(g=1,d(n.charCodeAt(1))){let u=2,B=u;for(;u<c&&!d(n.charCodeAt(u));)u++;if(u<c&&u!==B){for(B=u;u<c&&d(n.charCodeAt(u));)u++;if(u<c&&u!==B){for(B=u;u<c&&!d(n.charCodeAt(u));)u++;u===c?g=u:u!==B&&(g=u+1)}}}}else if(k(A)&&n.charCodeAt(1)===W){if(c<=2)return i.root=i.dir=n,i;if(g=2,d(n.charCodeAt(2))){if(c===3)return i.root=i.dir=n,i;g=3}}g>0&&(i.root=n.slice(0,g));let f=-1,h=g,s=-1,_=!0,U=n.length-1,I=0;for(;U>=g;--U){if(A=n.charCodeAt(U),d(A)){if(!_){h=U+1;break}continue}s===-1&&(_=!1,s=U+1),A===X?f===-1?f=U:I!==1&&(I=1):f!==-1&&(I=-1)}return s!==-1&&(f===-1||I===0||I===1&&f===s-1&&f===h+1?i.base=i.name=n.slice(h,s):(i.name=n.slice(h,f),i.base=n.slice(h,s),i.ext=n.slice(f,s))),h>0&&h!==g?i.dir=n.slice(0,h-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(l){const n=/\\/g;return()=>{const i=a.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>a.cwd()})();e.$jc={resolve(...n){let i="",c=!1;for(let g=n.length-1;g>=-1&&!c;g--){const A=g>=0?n[g]:p();P(A,"path"),A.length!==0&&(i=`${A}/${i}`,c=A.charCodeAt(0)===F)}return i=q(i,!c,"/",w),c?`/${i}`:i.length>0?i:"."},normalize(n){if(P(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F,c=n.charCodeAt(n.length-1)===F;return n=q(n,!i,"/",w),n.length===0?i?"/":c?"./":".":(c&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return P(n,"path"),n.length>0&&n.charCodeAt(0)===F},join(...n){if(n.length===0)return".";let i;for(let c=0;c<n.length;++c){const g=n[c];P(g,"path"),g.length>0&&(i===void 0?i=g:i+=`/${g}`)}return i===void 0?".":e.$jc.normalize(i)},relative(n,i){if(P(n,"from"),P(i,"to"),n===i||(n=e.$jc.resolve(n),i=e.$jc.resolve(i),n===i))return"";const c=1,g=n.length,A=g-c,f=1,h=i.length-f,s=A<h?A:h;let _=-1,U=0;for(;U<s;U++){const u=n.charCodeAt(c+U);if(u!==i.charCodeAt(f+U))break;u===F&&(_=U)}if(U===s)if(h>s){if(i.charCodeAt(f+U)===F)return i.slice(f+U+1);if(U===0)return i.slice(f+U)}else A>s&&(n.charCodeAt(c+U)===F?_=U:U===0&&(_=0));let I="";for(U=c+_+1;U<=g;++U)(U===g||n.charCodeAt(U)===F)&&(I+=I.length===0?"..":"/..");return`${I}${i.slice(f+_)}`},toNamespacedPath(n){return n},dirname(n){if(P(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F;let c=-1,g=!0;for(let A=n.length-1;A>=1;--A)if(n.charCodeAt(A)===F){if(!g){c=A;break}}else g=!1;return c===-1?i?"/":".":i&&c===1?"//":n.slice(0,c)},basename(n,i){i!==void 0&&P(i,"ext"),P(n,"path");let c=0,g=-1,A=!0,f;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let h=i.length-1,s=-1;for(f=n.length-1;f>=0;--f){const _=n.charCodeAt(f);if(_===F){if(!A){c=f+1;break}}else s===-1&&(A=!1,s=f+1),h>=0&&(_===i.charCodeAt(h)?--h===-1&&(g=f):(h=-1,g=s))}return c===g?g=s:g===-1&&(g=n.length),n.slice(c,g)}for(f=n.length-1;f>=0;--f)if(n.charCodeAt(f)===F){if(!A){c=f+1;break}}else g===-1&&(A=!1,g=f+1);return g===-1?"":n.slice(c,g)},extname(n){P(n,"path");let i=-1,c=0,g=-1,A=!0,f=0;for(let h=n.length-1;h>=0;--h){const s=n.charCodeAt(h);if(s===F){if(!A){c=h+1;break}continue}g===-1&&(A=!1,g=h+1),s===X?i===-1?i=h:f!==1&&(f=1):i!==-1&&(f=-1)}return i===-1||g===-1||f===0||f===1&&i===g-1&&i===c+1?"":n.slice(i,g)},format:ne.bind(null,"/"),parse(n){P(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const c=n.charCodeAt(0)===F;let g;c?(i.root="/",g=1):g=0;let A=-1,f=0,h=-1,s=!0,_=n.length-1,U=0;for(;_>=g;--_){const I=n.charCodeAt(_);if(I===F){if(!s){f=_+1;break}continue}h===-1&&(s=!1,h=_+1),I===X?A===-1?A=_:U!==1&&(U=1):A!==-1&&(U=-1)}if(h!==-1){const I=f===0&&c?1:f;A===-1||U===0||U===1&&A===h-1&&A===f+1?i.base=i.name=n.slice(I,h):(i.name=n.slice(I,A),i.base=n.slice(I,h),i.ext=n.slice(A,h))}return f>0?i.dir=n.slice(0,f-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=l?e.$ic.normalize:e.$jc.normalize,e.$lc=l?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=l?e.$ic.join:e.$jc.join,e.$nc=l?e.$ic.resolve:e.$jc.resolve,e.$oc=l?e.$ic.relative:e.$jc.relative,e.$pc=l?e.$ic.dirname:e.$jc.dirname,e.$qc=l?e.$ic.basename:e.$jc.basename,e.$rc=l?e.$ic.extname:e.$jc.extname,e.$sc=l?e.$ic.format:e.$jc.format,e.$tc=l?e.$ic.parse:e.$jc.parse,e.$uc=l?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=l?e.$ic.sep:e.$jc.sep,e.$wc=l?e.$ic.delimiter:e.$jc.delimiter}),define($e[6],be([0,1,4,3,2,7,30]),function(le,e,a,t,v,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=X,e.$zg=F,e.$Ag=T,e.$Bg=W,e.$Cg=x,e.$Dg=l,e.$Eg=d,e.$Fg=w,e.$Gg=k,e.$Hg=q,e.$Ig=ne,e.$Jg=p,e.$Kg=n,e.$Lg=i,e.$Mg=c,e.$Ng=g,e.$Og=h;function X(s){return s===a.CharCode.Slash||s===a.CharCode.Backslash}function F(s){return s.replace(/[\\/]/g,t.$jc.sep)}function T(s){return s.indexOf("/")===-1&&(s=F(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}function W(s,_=t.$jc.sep){if(!s)return"";const U=s.length,I=s.charCodeAt(0);if(X(I)){if(X(s.charCodeAt(1))&&!X(s.charCodeAt(2))){let B=3;const G=B;for(;B<U&&!X(s.charCodeAt(B));B++);if(G!==B&&!X(s.charCodeAt(B+1))){for(B+=1;B<U;B++)if(X(s.charCodeAt(B)))return s.slice(0,B+1).replace(/[\\/]/g,_)}}return _}else if(k(I)&&s.charCodeAt(1)===a.CharCode.Colon)return X(s.charCodeAt(2))?s.slice(0,2)+_:s.slice(0,2);let u=s.indexOf("://");if(u!==-1){for(u+=3;u<U;u++)if(X(s.charCodeAt(u)))return s.slice(0,u+1)}return""}function x(s){if(!v.$i||!s||s.length<5)return!1;let _=s.charCodeAt(0);if(_!==a.CharCode.Backslash||(_=s.charCodeAt(1),_!==a.CharCode.Backslash))return!1;let U=2;const I=U;for(;U<s.length&&(_=s.charCodeAt(U),_!==a.CharCode.Backslash);U++);return!(I===U||(_=s.charCodeAt(U+1),isNaN(_)||_===a.CharCode.Backslash))}const j=/[\\/:\*\?"<>\|]/g,te=/[/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(s,_=v.$i){const U=_?j:te;return!(!s||s.length===0||/^\s+$/.test(s)||(U.lastIndex=0,U.test(s))||_&&P.test(s)||s==="."||s===".."||_&&s[s.length-1]==="."||_&&s.length!==s.trim().length||s.length>255)}function d(s,_,U){const I=s===_;return!U||I?I:!s||!_?!1:(0,O.$Hf)(s,_)}function w(s,_,U,I=t.sep){if(s===_)return!0;if(!s||!_||_.length>s.length)return!1;if(U){if(!(0,O.$If)(s,_))return!1;if(_.length===s.length)return!0;let B=_.length;return _.charAt(_.length-1)===I&&B--,s.charAt(B)===I}return _.charAt(_.length-1)!==I&&(_+=I),s.indexOf(_)===0}function k(s){return s>=a.CharCode.A&&s<=a.CharCode.Z||s>=a.CharCode.a&&s<=a.CharCode.z}function q(s,_){return v.$i&&s.endsWith(":")&&(s+=t.sep),(0,t.$lc)(s)||(s=(0,t.$mc)(_,s)),s=(0,t.$kc)(s),ne(s)}function ne(s){return v.$i?(s=(0,O.$pf)(s,t.sep),s.endsWith(":")&&(s+=t.sep)):(s=(0,O.$pf)(s,t.sep),s||(s=t.sep)),s}function p(s){const _=(0,t.$kc)(s);return v.$i?s.length>3?!1:n(_)&&(s.length===2||_.charCodeAt(2)===a.CharCode.Backslash):_===t.$jc.sep}function n(s,_=v.$i){return _?k(s.charCodeAt(0))&&s.charCodeAt(1)===a.CharCode.Colon:!1}function i(s,_=v.$i){return n(s,_)?s[0]:void 0}function c(s,_,U){return _.length>s.length?-1:s===_?0:(U&&(s=s.toLowerCase(),_=_.toLowerCase()),s.indexOf(_))}function g(s){const _=s.split(":");let U,I,u;for(const B of _){const G=Number(B);(0,ie.$kg)(G)?I===void 0?I=G:u===void 0&&(u=G):U=U?[U,B].join(":"):B}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:I!==void 0?I:void 0,column:u!==void 0?u:I!==void 0?1:void 0}}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(s,_,U=8){let I="";for(let B=0;B<U;B++){let G;B===0&&v.$i&&!_&&(U===3||U===4)?G=f:G=A,I+=G.charAt(Math.floor(Math.random()*G.length))}let u;return _?u=`${_}-${I}`:u=I,s?(0,t.$mc)(s,u):u}}),define($e[8],be([0,1,4,25,3,2]),function(le,e,a,t,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=d,e.$zc=n,v=pe(v);const ie=/^\w[\w\d+.-]*$/,X=/^\//,F=/^\/\//;function T(f,h){if(!f.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!ie.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!X.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(F.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function W(f,h){return!f&&!h?"file":f}function x(f,h){switch(f){case"https":case"http":case"file":h?h[0]!==te&&(h=te+h):h=te;break}return h}const j="",te="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(h){return h instanceof l?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,s,_,U,I,u=!1){typeof h=="object"?(this.scheme=h.scheme||j,this.authority=h.authority||j,this.path=h.path||j,this.query=h.query||j,this.fragment=h.fragment||j):(this.scheme=W(h,u),this.authority=s||j,this.path=x(this.scheme,_||j),this.query=U||j,this.fragment=I||j,T(this,u))}get fsPath(){return n(this,!1)}with(h){if(!h)return this;let{scheme:s,authority:_,path:U,query:I,fragment:u}=h;return s===void 0?s=this.scheme:s===null&&(s=j),_===void 0?_=this.authority:_===null&&(_=j),U===void 0?U=this.path:U===null&&(U=j),I===void 0?I=this.query:I===null&&(I=j),u===void 0?u=this.fragment:u===null&&(u=j),s===this.scheme&&_===this.authority&&U===this.path&&I===this.query&&u===this.fragment?this:new k(s,_,U,I,u)}static parse(h,s=!1){const _=P.exec(h);return _?new k(_[2]||j,A(_[4]||j),A(_[5]||j),A(_[7]||j),A(_[9]||j),s):new k(j,j,j,j,j)}static file(h){let s=j;if(O.$i&&(h=h.replace(/\\/g,te)),h[0]===te&&h[1]===te){const _=h.indexOf(te,2);_===-1?(s=h.substring(2),h=te):(s=h.substring(2,_),h=h.substring(_)||te)}return new k("file",s,h,j,j)}static from(h,s){return new k(h.scheme,h.authority,h.path,h.query,h.fragment,s)}static joinPath(h,...s){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return O.$i&&h.scheme==="file"?_=l.file(v.$ic.join(n(h,!0),...s)).path:_=v.$jc.join(h.path,...s),h.with({path:_})}toString(h=!1){return i(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof l)return h;{const s=new k(h);return s._formatted=h.external??null,s._fsPath=h._sep===w?h.fsPath??null:null,s}}else return h}}e.URI=l;function d(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}const w=O.$i?1:void 0;class k extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(h=!1){return h?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const h={$mid:t.MarshalledId.Uri};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=w),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const q={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function ne(f,h,s){let _,U=-1;for(let I=0;I<f.length;I++){const u=f.charCodeAt(I);if(u>=a.CharCode.a&&u<=a.CharCode.z||u>=a.CharCode.A&&u<=a.CharCode.Z||u>=a.CharCode.Digit0&&u<=a.CharCode.Digit9||u===a.CharCode.Dash||u===a.CharCode.Period||u===a.CharCode.Underline||u===a.CharCode.Tilde||h&&u===a.CharCode.Slash||s&&u===a.CharCode.OpenSquareBracket||s&&u===a.CharCode.CloseSquareBracket||s&&u===a.CharCode.Colon)U!==-1&&(_+=encodeURIComponent(f.substring(U,I)),U=-1),_!==void 0&&(_+=f.charAt(I));else{_===void 0&&(_=f.substr(0,I));const B=q[u];B!==void 0?(U!==-1&&(_+=encodeURIComponent(f.substring(U,I)),U=-1),_+=B):U===-1&&(U=I)}}return U!==-1&&(_+=encodeURIComponent(f.substring(U))),_!==void 0?_:f}function p(f){let h;for(let s=0;s<f.length;s++){const _=f.charCodeAt(s);_===a.CharCode.Hash||_===a.CharCode.QuestionMark?(h===void 0&&(h=f.substr(0,s)),h+=q[_]):h!==void 0&&(h+=f[s])}return h!==void 0?h:f}function n(f,h){let s;return f.authority&&f.path.length>1&&f.scheme==="file"?s=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===a.CharCode.Slash&&(f.path.charCodeAt(1)>=a.CharCode.A&&f.path.charCodeAt(1)<=a.CharCode.Z||f.path.charCodeAt(1)>=a.CharCode.a&&f.path.charCodeAt(1)<=a.CharCode.z)&&f.path.charCodeAt(2)===a.CharCode.Colon?h?s=f.path.substr(1):s=f.path[1].toLowerCase()+f.path.substr(2):s=f.path,O.$i&&(s=s.replace(/\//g,"\\")),s}function i(f,h){const s=h?p:ne;let _="",{scheme:U,authority:I,path:u,query:B,fragment:G}=f;if(U&&(_+=U,_+=":"),(I||U==="file")&&(_+=te,_+=te),I){let V=I.indexOf("@");if(V!==-1){const D=I.substr(0,V);I=I.substr(V+1),V=D.lastIndexOf(":"),V===-1?_+=s(D,!1,!1):(_+=s(D.substr(0,V),!1,!1),_+=":",_+=s(D.substr(V+1),!1,!0)),_+="@"}I=I.toLowerCase(),V=I.lastIndexOf(":"),V===-1?_+=s(I,!1,!0):(_+=s(I.substr(0,V),!1,!0),_+=I.substr(V))}if(u){if(u.length>=3&&u.charCodeAt(0)===a.CharCode.Slash&&u.charCodeAt(2)===a.CharCode.Colon){const V=u.charCodeAt(1);V>=a.CharCode.A&&V<=a.CharCode.Z&&(u=`/${String.fromCharCode(V+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===a.CharCode.Colon){const V=u.charCodeAt(0);V>=a.CharCode.A&&V<=a.CharCode.Z&&(u=`${String.fromCharCode(V+32)}:${u.substr(2)}`)}_+=s(u,!0,!1)}return B&&(_+="?",_+=s(B,!1,!1)),G&&(_+="#",_+=h?G:ne(G,!1,!1)),_}function c(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+c(f.substr(3)):f}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(f){return f.match(g)?f.replace(g,h=>c(h)):f}}),define($e[35],be([0,1,5,2,7,8,3]),function(le,e,a,t,v,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=F,e.$Qg=T,e.$Ug=x,a=pe(a),t=pe(t),ie=pe(ie);var X;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeManagedRemoteResource="vscode-managed-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.vscodeChatCodeBlock="vscode-chat-code-block",P.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",P.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",P.vscodeChatSesssion="vscode-chat-editor",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm",P.commentsInput="comment",P.codeSetting="code-setting"})(X||(e.Schemas=X={}));function F(P,l){return O.URI.isUri(P)?(0,v.$Hf)(P.scheme,l):(0,v.$If)(P,l+":")}function T(P,...l){return l.some(d=>F(P,d))}e.$Rg="vscode-tkn",e.$Sg="tkn";class W{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,d){this.f=x(l,d)}getServerRootPath(){return this.f}get g(){return ie.$jc.join(this.f,X.vscodeRemoteResource)}set(l,d,w){this.a[l]=d,this.b[l]=w}setConnectionToken(l,d){this.c[l]=d}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(p){return a.$3(p),l}const d=l.authority;let w=this.a[d];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const k=this.b[d],q=this.c[d];let ne=`path=${encodeURIComponent(l.path)}`;return typeof q=="string"&&(ne+=`&${e.$Sg}=${encodeURIComponent(q)}`),O.URI.from({scheme:t.$o?this.d:X.vscodeRemoteResource,authority:`${w}:${k}`,path:this.g,query:ne})}}e.$Tg=new W;function x(P,l){return ie.$jc.join(l??"/",`${P.quality??"oss"}-${P.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class j{static{this.a=e.$Zg}asBrowserUri(l){const d=this.b(l,le);return this.uriToBrowserUri(d)}uriToBrowserUri(l){return l.scheme===X.vscodeRemote?e.$Tg.rewrite(l):l.scheme===X.file&&(t.$m||t.$q===`${X.vscodeFileResource}://${j.a}`)?l.with({scheme:X.vscodeFileResource,authority:l.authority||j.a,query:null,fragment:null}):l}asFileUri(l){const d=this.b(l,le);return this.uriToFileUri(d)}uriToFileUri(l){return l.scheme===X.vscodeFileResource?l.with({scheme:X.file,authority:l.authority!==j.a?l.authority:null,query:null,fragment:null}):l}b(l,d){return O.URI.isUri(l)?l:O.URI.parse(d.toUrl(l))}}e.$1g=new j;var te;(function(P){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(l.get("3"));const d="vscode-coi";function w(q){let ne;typeof q=="string"?ne=new URL(q).searchParams:q instanceof URL?ne=q.searchParams:O.URI.isUri(q)&&(ne=new URL(q.toString(!0)).searchParams);const p=ne?.get(d);if(p)return l.get(p)}P.getHeadersFromQuery=w;function k(q,ne,p){if(!globalThis.crossOriginIsolated)return;const n=ne&&p?"3":p?"2":"1";q instanceof URLSearchParams?q.set(d,n):q[d]=n}P.addSearchParam=k})(te||(e.COI=te={}))}),define($e[17],be([0,1,4,6,35,3,2,7,8]),function(le,e,a,t,v,O,ie,X,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=T,e.$qh=x,e.$rh=te,t=pe(t),O=pe(O);function T(P){return(0,F.$zc)(P,!0)}class W{constructor(l){this.a=l}compare(l,d,w=!1){return l===d?0:(0,X.$Af)(this.getComparisonKey(l,w),this.getComparisonKey(d,w))}isEqual(l,d,w=!1){return l===d?!0:!l||!d?!1:this.getComparisonKey(l,w)===this.getComparisonKey(d,w)}getComparisonKey(l,d=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,d,w=!1){if(l.scheme===d.scheme){if(l.scheme===v.Schemas.file)return t.$Fg(T(l),T(d),this.a(l))&&l.query===d.query&&(w||l.fragment===d.fragment);if((0,e.$mh)(l.authority,d.authority))return t.$Fg(l.path,d.path,this.a(l),"/")&&l.query===d.query&&(w||l.fragment===d.fragment)}return!1}joinPath(l,...d){return F.URI.joinPath(l,...d)}basenameOrAuthority(l){return(0,e.$eh)(l)||l.authority}basename(l){return O.$jc.basename(l.path)}extname(l){return O.$jc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let d;return l.scheme===v.Schemas.file?d=F.URI.file(O.$pc(T(l))).path:(d=O.$jc.dirname(l.path),l.authority&&d.length&&d.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),d="/")),l.with({path:d})}normalizePath(l){if(!l.path.length)return l;let d;return l.scheme===v.Schemas.file?d=F.URI.file(O.$kc(T(l))).path:d=O.$jc.normalize(l.path),l.with({path:d})}relativePath(l,d){if(l.scheme!==d.scheme||!(0,e.$mh)(l.authority,d.authority))return;if(l.scheme===v.Schemas.file){const q=O.$oc(T(l),T(d));return ie.$i?t.$zg(q):q}let w=l.path||"/";const k=d.path||"/";if(this.a(l)){let q=0;for(const ne=Math.min(w.length,k.length);q<ne&&!(w.charCodeAt(q)!==k.charCodeAt(q)&&w.charAt(q).toLowerCase()!==k.charAt(q).toLowerCase());q++);w=k.substr(0,q)+w.substr(q)}return O.$jc.relative(w,k)}resolvePath(l,d){if(l.scheme===v.Schemas.file){const w=F.URI.file(O.$nc(T(l),d));return l.with({authority:w.authority,path:w.path})}return d=t.$Ag(d),l.with({path:O.$jc.resolve(l.path,d)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,d){return l===d||l!==void 0&&d!==void 0&&(0,X.$Hf)(l,d)}hasTrailingPathSeparator(l,d=O.sep){if(l.scheme===v.Schemas.file){const w=T(l);return w.length>t.$Bg(w).length&&w[w.length-1]===d}else{const w=l.path;return w.length>1&&w.charCodeAt(w.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,d=O.sep){return(0,e.$nh)(l,d)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,d=O.sep){let w=!1;if(l.scheme===v.Schemas.file){const k=T(l);w=k!==void 0&&k.length===t.$Bg(k).length&&k[k.length-1]===d}else{d="/";const k=l.path;w=k.length===1&&k.charCodeAt(k.length-1)===a.CharCode.Slash}return!w&&!(0,e.$nh)(l,d)?l.with({path:l.path+"/"}):l}}e.$9g=W,e.$0g=new W(()=>!1),e.$$g=new W(P=>P.scheme===v.Schemas.file?!ie.$k:!0),e.$_g=new W(P=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function x(P,l){const d=[];for(let w=0;w<P.length;w++){const k=l(P[w]);P.some((q,ne)=>ne===w?!1:(0,e.$bh)(k,l(q)))||d.push(P[w])}return d}var j;(function(P){P.META_DATA_LABEL="label",P.META_DATA_DESCRIPTION="description",P.META_DATA_SIZE="size",P.META_DATA_MIME="mime";function l(d){const w=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(ne=>{const[p,n]=ne.split(":");p&&n&&w.set(p,n)});const q=d.path.substring(0,d.path.indexOf(";"));return q&&w.set(P.META_DATA_MIME,q),w}P.parseMetaData=l})(j||(e.DataUri=j={}));function te(P,l,d){if(l){let w=P.path;return w&&w[0]!==O.$jc.sep&&(w=O.$jc.sep+w),P.with({scheme:d,authority:l,path:w})}return P.with({scheme:d})}}),define($e[9],be([0,1,15,5,14,13,17,2,29,11]),function(le,e,a,t,v,O,ie,X,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=W,e.$th=x,e.$uh=j,e.$vh=te,e.$wh=P,e.$xh=l,e.$yh=d,e.$zh=w,e.$Hh=f,e.$Ih=h,e.$Jh=s,e.$Kh=_,e.$Lh=U,e.$1h=Z,e.$9h=R;function W(m){return!!m&&typeof m.then=="function"}function x(m){const r=new a.$ye,E=m(r.token),M=new Promise((z,oe)=>{const we=r.token.onCancellationRequested(()=>{we.dispose(),oe(new t.$8)});Promise.resolve(E).then(ee=>{we.dispose(),r.dispose(),z(ee)},ee=>{we.dispose(),r.dispose(),oe(ee)})});return new class{cancel(){r.cancel(),r.dispose()}then(z,oe){return M.then(z,oe)}catch(z){return this.then(void 0,z)}finally(z){return M.finally(z)}}}function j(m,r,E){return new Promise((M,z)=>{const oe=r.onCancellationRequested(()=>{oe.dispose(),M(E)});m.then(M,z).finally(()=>oe.dispose())})}function te(m,r){return new Promise((E,M)=>{const z=r.onCancellationRequested(()=>{z.dispose(),M(new t.$8)});m.then(E,M).finally(()=>z.dispose())})}async function P(m){let r=-1;const E=m.map((M,z)=>M.then(oe=>(r=z,oe)));try{return await Promise.race(E)}finally{m.forEach((M,z)=>{z!==r&&M.cancel()})}}function l(m,r,E){let M;const z=setTimeout(()=>{M?.(void 0),E?.()},r);return Promise.race([m.finally(()=>clearTimeout(z)),new Promise(oe=>M=oe)])}function d(m){return new Promise((r,E)=>{const M=m();W(M)?M.then(r,E):r(M)})}function w(){let m,r;return{promise:new Promise((M,z)=>{m=M,r=z}),resolve:m,reject:r}}class k{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const E=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(E,E).then(M)})}return new Promise((E,M)=>{this.b.then(E,M)})}return this.a=r(),new Promise((E,M)=>{this.a.then(z=>{this.a=null,E(z)},z=>{this.a=null,M(z)})})}dispose(){this.f=!0}}e.$Ah=k;class q{constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$Bh=q;class ne{constructor(){this.a=new Map}queue(r,E){const z=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(r)===z&&this.a.delete(r)});return this.a.set(r,z),z}}e.$Ch=ne;const p=(m,r)=>{let E=!0;const M=setTimeout(()=>{E=!1,r()},m);return{isTriggered:()=>E,dispose:()=>{clearTimeout(M),E=!1}}},n=m=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,m())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class i{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,E=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((z,oe)=>{this.d=z,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=E===F.$ie?n(M):p(E,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class c{constructor(r){this.a=new i(r),this.b=new k}trigger(r,E){return this.a.trigger(()=>this.b.queue(r),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=c;class g{constructor(){this.a=!1,this.b=new Promise((r,E)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=g;class A extends g{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$Gh=A;function f(m,r){return r?new Promise((E,M)=>{const z=setTimeout(()=>{oe.dispose(),E()},m),oe=r.onCancellationRequested(()=>{clearTimeout(z),oe.dispose(),M(new t.$8)})}):x(E=>f(m,E))}function h(m,r=0,E){const M=setTimeout(()=>{m(),E&&z.dispose()},r),z=(0,O.$Vc)(()=>{clearTimeout(M),E?.deleteAndLeak(z)});return E?.add(z),z}function s(m){const r=[];let E=0;const M=m.length;function z(){return E<M?m[E++]():null}function oe(we){we!=null&&r.push(we);const ee=z();return ee?ee.then(oe):Promise.resolve(r)}return Promise.resolve(null).then(oe)}function _(m,r=M=>!!M,E=null){let M=0;const z=m.length,oe=()=>{if(M>=z)return Promise.resolve(E);const we=m[M++];return Promise.resolve(we()).then(C=>r(C)?Promise.resolve(C):oe())};return oe()}function U(m,r=M=>!!M,E=null){if(m.length===0)return Promise.resolve(E);let M=m.length;const z=()=>{M=-1;for(const oe of m)oe.cancel?.()};return new Promise((oe,we)=>{for(const ee of m)ee.then(C=>{--M>=0&&r(C)?(z(),oe(C)):M===0&&oe(E)}).catch(C=>{--M>=0&&(z(),we(C))})})}class I{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new v.$ne}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((E,M)=>{this.g.push({factory:r,c:E,e:M}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const E=r.factory();E.then(r.c,r.e),E.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=I;class u extends I{constructor(){super(1)}}e.$Nh=u;class B{constructor(){this.a=new se,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$Oh=B;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new Re;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,E=ie.$0g){const M=E.getComparisonKey(r);return this.a.get(M)?.size??0}queueFor(r,E,M=ie.$0g){const z=M.getComparisonKey(r);let oe=this.a.get(z);if(!oe){oe=new u;const we=this.f++,ee=v.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(z),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$7c),this.d.set(we,ee),this.a.set(z,oe)}return oe.queue(E)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=G;class V{constructor(r,E){this.b=!1,this.a=-1,typeof r=="function"&&typeof E=="number"&&this.setIfNotSet(r,E)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,E){if(this.b)throw new t.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},E)}setIfNotSet(r,E){if(this.b)throw new t.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},E))}}e.$Qh=V;class D{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,E,M=globalThis){if(this.f)throw new t.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const z=M.setInterval(()=>{r()},E);this.d=(0,O.$Vc)(()=>{M.clearInterval(z),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=D;class Q{constructor(r,E){this.b=-1,this.a=r,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=Q;class S{constructor(r,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=r,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=S;class y extends Q{constructor(r,E){super(r,E),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$Uh=y;class H extends O.$Xc{constructor(r,E){super(),this.g=r,this.h=E,this.a=[],this.b=this.B(new O.$Yc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of r)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(m,r)=>{(0,X.$B)(()=>{if(E)return;const M=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:e.$Xh=(m,r,E)=>{const M=m.requestIdleCallback(r,typeof E=="number"?{timeout:E}:void 0);let z=!1;return{dispose(){z||(z=!0,m.cancelIdleCallback(M))}}},e.$Wh=m=>(0,e.$Xh)(globalThis,m)}();class K{constructor(r,E){this.g=!1,this.d=()=>{try{this.j=E()}catch(M){this.l=M}finally{this.g=!0}},this.f=(0,e.$Xh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=K;class J extends K{constructor(r){super(globalThis,r)}}e.$Zh=J;async function Z(m,r,E){let M;for(let z=0;z<E;z++)try{return await m()}catch(oe){M=oe,await f(r)}throw M}class se{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,E,M){return this.a={taskId:r,cancel:()=>M?.(),promise:E},E.then(()=>this.d(r),()=>this.d(r)),E}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:E,resolve:M,reject:z}=w();this.b={run:r,promise:E,promiseResolve:M,promiseReject:z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=se;class me{constructor(r,E=()=>Date.now()){this.d=r,this.f=E,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$3h=me;var ye;(function(m){m[m.Resolved=0]="Resolved",m[m.Rejected=1]="Rejected"})(ye||(ye={}));class Re{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((r,E)=>{this.a=r,this.b=E})}complete(r){return new Promise(E=>{this.a(r),this.d={outcome:ye.Resolved,value:r},E()})}error(r){return new Promise(E=>{this.b(r),this.d={outcome:ye.Rejected,value:r},E()})}cancel(){return this.error(new t.$8)}}e.$4h=Re;var Te;(function(m){async function r(M){let z;const oe=await Promise.all(M.map(we=>we.then(ee=>ee,ee=>{z||(z=ee)})));if(typeof z<"u")throw z;return oe}m.settled=r;function E(M){return new Promise(async(z,oe)=>{try{await M(z,oe)}catch(we){oe(we)}})}m.withAsyncBody=E})(Te||(e.Promises=Te={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(E=>(this.a=E,this.d=!0,E),E=>{throw this.b=E,this.d=!0,E})}requireValue(){if(!this.d)throw new t.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=fe;class ve{constructor(r){this.b=r,this.a=new T.$X(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=ve;var ge;(function(m){m[m.Initial=0]="Initial",m[m.DoneOK=1]="DoneOK",m[m.DoneError=2]="DoneError"})(ge||(ge={}));class Ee{static fromArray(r){return new Ee(E=>{E.emitMany(r)})}static fromPromise(r){return new Ee(async E=>{E.emitMany(await r)})}static fromPromises(r){return new Ee(async E=>{await Promise.all(r.map(async M=>E.emitOne(await M)))})}static merge(r){return new Ee(async E=>{await Promise.all(r.map(async M=>{for await(const z of M)E.emitOne(z)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(r,E){this.a=ge.Initial,this.b=[],this.d=null,this.f=E,this.g=new v.$ne,queueMicrotask(async()=>{const M={emitOne:z=>this.h(z),emitMany:z=>this.j(z),reject:z=>this.l(z)};try{await Promise.resolve(r(M)),this.k()}catch(z){this.l(z)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===ge.DoneError)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===ge.DoneOK)return{done:!0,value:void 0};await v.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(r,E){return new Ee(async M=>{for await(const z of r)M.emitOne(E(z))})}map(r){return Ee.map(this,r)}static filter(r,E){return new Ee(async M=>{for await(const z of r)E(z)&&M.emitOne(z)})}filter(r){return Ee.filter(this,r)}static coalesce(r){return Ee.filter(r,E=>!!E)}coalesce(){return Ee.coalesce(this)}static async toPromise(r){const E=[];for await(const M of r)E.push(M);return E}toPromise(){return Ee.toPromise(this)}h(r){this.a===ge.Initial&&(this.b.push(r),this.g.fire())}j(r){this.a===ge.Initial&&(this.b=this.b.concat(r),this.g.fire())}k(){this.a===ge.Initial&&(this.a=ge.DoneOK,this.g.fire())}l(r){this.a===ge.Initial&&(this.a=ge.DoneError,this.d=r,this.g.fire())}}e.$7h=Ee;class b extends Ee{constructor(r,E){super(E),this.m=r}cancel(){this.m.cancel()}}e.$8h=b;function R(m){const r=new a.$ye,E=m(r.token);return new b(r,async M=>{const z=r.token.onCancellationRequested(()=>{z.dispose(),r.dispose(),M.reject(new t.$8)});try{for await(const oe of E){if(r.token.isCancellationRequested)return;M.emitOne(oe)}z.dispose(),r.dispose()}catch(oe){z.dispose(),r.dispose(),M.reject(oe)}})}class L{constructor(r){this.a=new Re,this.b=new Ee(z=>{if(E){z.reject(E);return}return M&&z.emitMany(M),this.d=oe=>z.reject(oe),this.f=oe=>z.emitOne(oe),this.a.p},r);let E,M;this.f=z=>{M||(M=[]),M.push(z)},this.d=z=>{E||(E=z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$0h=L}),define($e[36],be([0,1,18,19,43,9,6,26,3,2,17,8]),function(le,e,a,t,v,O,ie,X,F,T,W,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=q,e.whenDeleted=n,e.configureFlushOnWrite=f,e.writeFileSync=s,a=pe(a);var j;(function(S){S[S.UNLINK=0]="UNLINK",S[S.MOVE=1]="MOVE"})(j||(e.RimRafMode=j={}));async function te(S,y=j.UNLINK,H){if((0,ie.$Jg)(S))throw new Error("rimraf - will refuse to recursively delete root");return y===j.UNLINK?l(S):P(S,H)}async function P(S,y=(0,ie.$Og)((0,t.tmpdir)())){try{try{await a.promises.rename(S,y)}catch(H){return H.code==="ENOENT"?void 0:l(S)}l(y).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function l(S){return a.promises.rm(S,{recursive:!0,force:!0,maxRetries:3})}function d(S){if((0,ie.$Jg)(S))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(S,{recursive:!0,force:!0,maxRetries:3})}async function w(S,y){return ne(await(y?k(S):a.promises.readdir(S)))}async function k(S){try{return await a.promises.readdir(S,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const y=[],H=await w(S);for(const K of H){let J=!1,Z=!1,se=!1;try{const me=await e.Promises.lstat((0,F.$mc)(S,K));J=me.isFile(),Z=me.isDirectory(),se=me.isSymbolicLink()}catch(me){console.warn("[node.js fs] unexpected error from lstat after readdir: ",me)}y.push({name:K,isFile:()=>J,isDirectory:()=>Z,isSymbolicLink:()=>se})}return y}function q(S){return ne(a.readdirSync(S))}function ne(S){return S.map(y=>typeof y=="string"?T.$j?(0,X.$nm)(y):y:(y.name=T.$j?(0,X.$nm)(y.name):y.name,y))}async function p(S){const y=await w(S),H=[];for(const K of y)await i.existsDirectory((0,F.$mc)(S,K))&&H.push(K);return H}function n(S,y=1e3){return new Promise(H=>{let K=!1;const J=setInterval(()=>{K||(K=!0,a.access(S,Z=>{K=!1,Z&&(clearInterval(J),H(void 0))}))},y)})}var i;(function(S){async function y(J){let Z;try{if(Z=await e.Promises.lstat(J),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(T.$i&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(me){if(me.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw me}throw se}}S.stat=y;async function H(J){try{const{stat:Z,symbolicLink:se}=await S.stat(J);return Z.isFile()&&se?.dangling!==!0}catch{}return!1}S.existsFile=H;async function K(J){try{const{stat:Z,symbolicLink:se}=await S.stat(J);return Z.isDirectory()&&se?.dangling!==!0}catch{}return!1}S.existsDirectory=K})(i||(e.SymlinkSupport=i={}));const c=new O.$Ph;function g(S,y,H){return c.queueFor(x.URI.file(S),()=>{const K=_(H);return new Promise((J,Z)=>h(S,y,K,se=>se?Z(se):J()))},W.$$g)}let A=!0;function f(S){A=S}function h(S,y,H,K){if(!A)return a.writeFile(S,y,{mode:H.mode,flag:H.flag},K);a.open(S,H.flag,H.mode,(J,Z)=>{if(J)return K(J);a.writeFile(Z,y,se=>{if(se)return a.close(Z,()=>K(se));a.fdatasync(Z,me=>(me&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",me),f(!1)),a.close(Z,ye=>K(ye))))})})}function s(S,y,H){const K=_(H);if(!A)return a.writeFileSync(S,y,{mode:K.mode,flag:K.flag});const J=a.openSync(S,K.flag,K.mode);try{a.writeFileSync(J,y);try{a.fdatasyncSync(J)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),f(!1)}}finally{a.closeSync(J)}}function _(S){return S?{mode:typeof S.mode=="number"?S.mode:438,flag:typeof S.flag=="string"?S.flag:"w"}:{mode:438,flag:"w"}}async function U(S,y,H=6e4){if(S!==y)try{T.$i&&typeof H=="number"?await I(S,y,Date.now(),H):await a.promises.rename(S,y)}catch(K){if(S.toLowerCase()!==y.toLowerCase()&&K.code==="EXDEV"||S.endsWith("."))await u(S,y,{preserveSymlinks:!1}),await te(S,j.MOVE);else throw K}}async function I(S,y,H,K,J=0){try{return await a.promises.rename(S,y)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-H>=K)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${Z}`),Z;if(J===0){let se=!1;try{const{stat:me}=await i.stat(y);me.isFile()||(se=!0)}catch{}if(se)throw Z}return await(0,O.$Hh)(Math.min(100,J*10)),I(S,y,H,K,J+1)}}async function u(S,y,H){return G(S,y,{root:{source:S,target:y},options:H,handledSourcePaths:new Set})}const B=511;async function G(S,y,H){if(H.handledSourcePaths.has(S))return;H.handledSourcePaths.add(S);const{stat:K,symbolicLink:J}=await i.stat(S);if(J){if(H.options.preserveSymlinks)try{return await Q(S,y,H)}catch{}if(J.dangling)return}return K.isDirectory()?V(S,y,K.mode&B,H):D(S,y,K.mode&B)}async function V(S,y,H,K){await e.Promises.mkdir(y,{recursive:!0,mode:H});const J=await w(S);for(const Z of J)await G((0,F.$mc)(S,Z),(0,F.$mc)(y,Z),K)}async function D(S,y,H){await e.Promises.copyFile(S,y),await e.Promises.chmod(y,H)}async function Q(S,y,H){let K=await e.Promises.readlink(S);(0,ie.$Fg)(K,H.root.source,!T.$k)&&(K=(0,F.$mc)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,y)}e.Promises=new class{get access(){return a.promises.access}get stat(){return a.promises.stat}get lstat(){return a.promises.lstat}get utimes(){return a.promises.utimes}get read(){return(S,y,H,K,J)=>new Promise((Z,se)=>{a.read(S,y,H,K,J,(me,ye,Re)=>me?se(me):Z({bytesRead:ye,buffer:Re}))})}get readFile(){return a.promises.readFile}get write(){return(S,y,H,K,J)=>new Promise((Z,se)=>{a.write(S,y,H,K,J,(me,ye,Re)=>me?se(me):Z({bytesWritten:ye,buffer:Re}))})}get appendFile(){return a.promises.appendFile}get fdatasync(){return(0,v.promisify)(a.fdatasync)}get truncate(){return a.promises.truncate}get copyFile(){return a.promises.copyFile}get open(){return(0,v.promisify)(a.open)}get close(){return(0,v.promisify)(a.close)}get symlink(){return a.promises.symlink}get readlink(){return a.promises.readlink}get chmod(){return a.promises.chmod}get mkdir(){return a.promises.mkdir}get unlink(){return a.promises.unlink}get rmdir(){return a.promises.rmdir}get realpath(){return(0,v.promisify)(a.realpath)}async exists(S){try{return await e.Promises.access(S),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return p}get writeFile(){return g}get rm(){return te}get rename(){return U}get copy(){return u}}}),define($e[37],be([0,1,38,2]),function(le,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CX=F;const v={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function O(T){const W=T.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return ie[W]||W}const ie={ibm866:"cp866",big5:"cp950"},X="utf8";async function F(T){let W;const x=process.env.VSCODE_CLI_ENCODING;x?(T&&console.log(`Found VSCODE_CLI_ENCODING variable: ${x}`),W=Promise.resolve(x)):t.$i?W=new Promise(te=>{T&&console.log('Running "chcp" to detect terminal encoding...'),(0,a.exec)("chcp",(P,l,d)=>{if(l){T&&console.log(`Output from "chcp" command is: ${l}`);const w=Object.keys(v);for(const k of w)if(l.indexOf(k)>=0)return te(v[k])}return te(void 0)})}):W=new Promise(te=>{T&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,a.exec)("locale charmap",(P,l,d)=>te(l))});const j=await W;return T&&console.log(`Detected raw terminal encoding: ${j}`),!j||j.toLowerCase()==="utf-8"||j.toLowerCase()===X?X:O(j)}}),define($e[39],be([33,34]),function(le,e){return le.create("vs/platform/environment/node/argv",e)});var Ze=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define($e[40],be([0,1,44,2,39]),function(le,e,a,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=X,e.$Em=T,e.$Fm=te,e.$Gm=P,a=Ze(a);const O={o:(0,v.localize)(0,null),e:(0,v.localize)(1,null),t:(0,v.localize)(2,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,v.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,v.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,v.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,v.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,v.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,v.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,v.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,v.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,v.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,v.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,v.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,v.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,v.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,v.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,v.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,v.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,v.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,v.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,v.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,v.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,v.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,v.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,v.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,v.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,v.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,v.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,v.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,v.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,v.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,v.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,v.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,v.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const ie={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function X(l,d,w=ie){const k=l.find(f=>f.length>0&&f[0]!=="-"),q={},ne=["_"],p=[],n={};let i;for(const f in d){const h=d[f];h.type==="subcommand"?f===k&&(i=h):(h.alias&&(q[f]=h.alias),h.type==="string"||h.type==="string[]"?(ne.push(f),h.deprecates&&ne.push(...h.deprecates)):h.type==="boolean"&&(p.push(f),h.deprecates&&p.push(...h.deprecates)),h.global&&(n[f]=h))}if(i&&k){const f=n;for(const U in i.options)f[U]=i.options[U];const h=l.filter(U=>U!==k),s=w.getSubcommandReporter?w.getSubcommandReporter(k):void 0,_=X(h,f,s);return{[k]:_,_:[]}}const c=(0,a.default)(l,{string:ne,boolean:p,alias:q}),g={},A=c;g._=c._.map(f=>String(f)).filter(f=>f.length>0),delete A._;for(const f in d){const h=d[f];if(h.type==="subcommand")continue;h.alias&&delete A[h.alias];let s=A[f];if(h.deprecates)for(const _ of h.deprecates)A.hasOwnProperty(_)&&(s||(s=A[_],s&&w.onDeprecatedOption(_,h.deprecationMessage||(0,v.localize)(39,null,f))),delete A[_]);if(typeof s<"u"){if(h.type==="string[]"){if(Array.isArray(s)||(s=[s]),!h.allowEmptyValue){const _=s.filter(U=>U.length>0);_.length!==s.length&&(w.onEmptyValue(f),s=_.length>0?_:void 0)}}else h.type==="string"&&(Array.isArray(s)?(s=s.pop(),w.onMultipleValues(f,s)):!s&&!h.allowEmptyValue&&(w.onEmptyValue(f),s=void 0));g[f]=s,h.deprecationMessage&&w.onDeprecatedOption(f,h.deprecationMessage)}delete A[f]}for(const f in A)w.onUnknownOption(f);return g}function F(l,d){let w="";return d.args&&(Array.isArray(d.args)?w=` <${d.args.join("> <")}>`:w=` <${d.args}>`),d.alias?`-${d.alias} --${l}${w}`:`--${l}${w}`}function T(l,d){const w=[];for(const k in l){const q=l[k],ne=F(k,q);w.push([ne,q.description])}return W(w,d)}function W(l,d){const k=l.reduce((p,n)=>Math.max(p,n[0].length),12)+2+1;if(d-k<25)return l.reduce((p,n)=>p.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const q=d-k-1,ne=[];for(const p of l){const n=p[0],i=j(p[1],q),c=x(k-n.length-2);ne.push("  "+n+c+i[0]);for(let g=1;g<i.length;g++)ne.push(x(k)+i[g])}return ne}function x(l){return" ".repeat(l)}function j(l,d){const w=[];for(;l.length;){const k=l.length<d?l.length:l.lastIndexOf(" ",d),q=l.slice(0,k).trim();l=l.slice(k),w.push(q)}return w}function te(l,d,w,k,q){const ne=process.stdout.isTTY&&process.stdout.columns||80,p=q?.noInputFiles!==!0?`[${(0,v.localize)(40,null)}...]`:"",n=[`${l} ${w}`];n.push(""),n.push(`${(0,v.localize)(41,null)}: ${d} [${(0,v.localize)(42,null)}]${p}`),n.push(""),q?.noPipe!==!0&&(t.$i?n.push((0,v.localize)(43,null,d)):n.push((0,v.localize)(44,null,d)),n.push(""));const i={},c=[];for(const g in k){const A=k[g];if(A.type==="subcommand")A.description&&c.push({command:g,description:A.description});else if(A.description&&A.cat){let f=i[A.cat];f||(i[A.cat]=f={}),f[g]=A}}for(const g in i){const A=g,f=i[A];f&&(n.push(O[A]),n.push(...T(f,ne)),n.push(""))}return c.length&&(n.push((0,v.localize)(45,null)),n.push(...W(c.map(g=>[g.command,g.description]),ne)),n.push("")),n.join(`
`)}function P(l,d){return`${l||(0,v.localize)(46,null)}
${d||(0,v.localize)(47,null)}
${process.arch}`}}),define($e[41],be([0,1,19,9,6,36,37]),function(le,e,a,t,v,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=X,e.$_gc=F,e.$ahc=T,e.$bhc=W;function X(){try{return!process.stdin.isTTY}catch{}return!1}function F(x){return new Promise(j=>{const te=()=>j(!0);setTimeout(()=>{process.stdin.removeListener("data",te),j(!1)},x),process.stdin.once("data",te)})}function T(){return(0,v.$Og)((0,a.tmpdir)(),"code-stdin",3)}async function W(x,j,te){let[P,l]=await Promise.all([(0,ie.$CX)(j),new Promise((k,q)=>{le(["@vscode/iconv-lite-umd"],k,q)}).then(pe),O.Promises.appendFile(x,"")]);l.encodingExists(P)||(console.log(`Unsupported terminal encoding: ${P}, falling back to UTF-8.`),P="utf8");const d=new t.$Nh,w=l.getDecoder(P);process.stdin.on("data",k=>{const q=w.write(k);d.queue(()=>O.Promises.appendFile(x,q))}),process.stdin.on("end",()=>{const k=w.end();d.queue(async()=>{try{typeof k=="string"&&await O.Promises.appendFile(x,k)}finally{te?.()}})})}}),define($e[42],be([0,1,18,19,6]),function(le,e,a,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=O;function O(ie){const X=(0,v.$Og)((0,t.tmpdir)());try{return(0,a.writeFileSync)(X,""),ie&&console.log(`Marker file for --wait created: ${X}`),X}catch(F){ie&&console.error(`Failed to create marker file for --wait: ${F}`);return}}}),define($e[45],be([0,1,18,46,38,47,16,3,40,42,41,9]),function(le,e,a,t,v,O,ie,X,F,T,W,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=q,a=pe(a),t=pe(t),v=pe(v),O=pe(O);const j=G=>{switch(G){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},te=G=>{switch(G){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"update-extensions":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":return!0;default:return!1}},P=process.env.VSCODE_IPC_HOOK_CLI,l=process.env.VSCODE_CLIENT_COMMAND,d=process.env.VSCODE_CLIENT_COMMAND_CWD,w=process.env.VSCODE_CLI_AUTHORITY,k=process.env.VSCODE_STDIN_FILE_PATH;async function q(G,V){if(!P&&!l){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const D={...F.$Cm,gitCredential:{type:"string"},openExternal:{type:"boolean"}},Q=l?j:te;for(const fe in F.$Cm){const ve=fe;Q(ve)||delete D[ve]}P&&(D.openExternal={type:"boolean"});const S={onMultipleValues:(fe,ve)=>{console.error(`Option '${fe}' can only be defined once. Using value ${ve}.`)},onEmptyValue:fe=>{console.error(`Ignoring option '${fe}': Value must not be empty.`)},onUnknownOption:fe=>{console.error(`Ignoring option '${fe}': not supported for ${G.executableName}.`)},onDeprecatedOption:(fe,ve)=>{console.warn(`Option '${fe}' is deprecated: ${ve}`)}},y=(0,F.$Dm)(V,D,S),H=w?s:fe=>fe,K=!!y.verbose;if(y.help){console.log((0,F.$Fm)(G.productName,G.executableName,G.version,D));return}if(y.version){console.log((0,F.$Gm)(G.version,G.commit));return}if(y["locate-shell-integration-path"]){let fe;switch(y["locate-shell-integration-path"]){case"bash":fe="shellIntegration-bash.sh";break;case"pwsh":fe="shellIntegration.ps1";break;case"zsh":fe="shellIntegration-rc.zsh";break;case"fish":fe="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,X.$nc)(__dirname,"../..","workbench","contrib","terminal","browser","media",fe));return}if(P&&y.openExternal){n(y._,K);return}let J=y.remote;(J==="local"||J==="false"||J==="")&&(J=null);const Z=(y["folder-uri"]||[]).map(H);y["folder-uri"]=Z;const se=(y["file-uri"]||[]).map(H);y["file-uri"]=se;const me=y._;let ye=!1;for(const fe of me)fe==="-"?ye=!0:h(fe,H,Z,se);y._=[];let Re;if(ye&&(0,W.$$gc)())try{let fe=k;if(!fe){fe=(0,W.$ahc)();const ve=new x.$4h;await(0,W.$bhc)(fe,K,()=>ve.complete()),y.wait||(Re=ve.p)}h(fe,H,Z,se),y["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${fe}`)}catch(fe){console.log(`Failed to create file to read via stdin: ${fe.toString()}`)}y.extensionDevelopmentPath&&(y.extensionDevelopmentPath=y.extensionDevelopmentPath.map(fe=>H(f(fe).href))),y.extensionTestsPath&&(y.extensionTestsPath=H(f(y.extensionTestsPath).href));const Te=y["crash-reporter-directory"];if(Te!==void 0&&!Te.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${Te}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(l){if(y["install-extension"]!==void 0||y["uninstall-extension"]!==void 0||y["list-extensions"]||y["update-extensions"]){const ge=[];y["install-extension"]?.forEach(b=>ge.push("--install-extension",b)),y["uninstall-extension"]?.forEach(b=>ge.push("--uninstall-extension",b)),["list-extensions","force","show-versions","category"].forEach(b=>{const R=y[b];R!==void 0&&ge.push(`--${b}=${R}`)}),y["update-extensions"]&&ge.push("--update-extensions"),v.fork((0,X.$mc)(__dirname,"../../../server-main.js"),ge,{stdio:"inherit"}).on("error",b=>console.log(b));return}const fe=[];for(const ge in y){const Ee=y[ge];if(typeof Ee=="boolean")Ee&&fe.push("--"+ge);else if(Array.isArray(Ee))for(const b of Ee)fe.push(`--${ge}=${b.toString()}`);else Ee&&fe.push(`--${ge}=${Ee.toString()}`)}J!==null&&fe.push(`--remote=${J||w}`);const ve=(0,X.$rc)(l);if(ve===".bat"||ve===".cmd"){const ge=d||(0,ie.cwd)();K&&console.log(`Invoking: cmd.exe /C ${l} ${fe.join(" ")} in ${ge}`),v.spawn("cmd.exe",["/C",l,...fe],{stdio:"inherit",cwd:ge})}else{const ge=(0,X.$pc)(l),Ee={...process.env,ELECTRON_RUN_AS_NODE:"1"};if(fe.unshift("resources/app/out/cli.js"),K&&console.log(`Invoking: cd "${ge}" && ELECTRON_RUN_AS_NODE=1 "${l}" "${fe.join('" "')}"`),ne()){K&&console.log("Using pipes for output.");const b=v.spawn(l,fe,{cwd:ge,env:Ee,stdio:["inherit","pipe","pipe"]});b.stdout.on("data",R=>process.stdout.write(R)),b.stderr.on("data",R=>process.stderr.write(R))}else v.spawn(l,fe,{cwd:ge,env:Ee,stdio:"inherit"})}}else{if(y.status){i({type:"status"},K).then(ve=>{console.log(ve)}).catch(ve=>{console.error("Error when requesting status:",ve)});return}if(y["install-extension"]!==void 0||y["uninstall-extension"]!==void 0||y["list-extensions"]||y["update-extensions"]){i({type:"extensionManagement",list:y["list-extensions"]?{showVersions:y["show-versions"],category:y.category}:void 0,install:c(y["install-extension"]),uninstall:c(y["uninstall-extension"]),force:y.force},K).then(ve=>{console.log(ve)}).catch(ve=>{console.error("Error when invoking the extension management command:",ve)});return}let fe;if(y.wait){if(!se.length){console.log("At least one file must be provided to wait for.");return}fe=(0,T.$Pgc)(K)}i({type:"open",fileURIs:se,folderURIs:Z,diffMode:y.diff,mergeMode:y.merge,addMode:y.add,gotoLineMode:y.goto,forceReuseWindow:y["reuse-window"],forceNewWindow:y["new-window"],waitMarkerFilePath:fe,remoteAuthority:J},K).catch(ve=>{console.error("Error when invoking the open command:",ve)}),fe&&p(fe),Re&&await Re}}function ne(){if(process.env.WSL_DISTRO_NAME)try{return v.execSync("uname -r",{encoding:"utf8"}).includes("-microsoft-")}catch{}return!1}async function p(G){for(;a.existsSync(G);)await new Promise(V=>setTimeout(V,1e3))}function n(G,V){const D=[];for(const Q of G)try{/^(http|https|file):\/\//.test(Q)?D.push(t.parse(Q).href):D.push(f(Q).href)}catch{console.log(`Invalid url: ${Q}`)}D.length&&i({type:"openExternal",uris:D},V).catch(Q=>{console.error("Error when invoking the open external command:",Q)})}function i(G,V){return V&&console.log(JSON.stringify(G,null,"  ")),new Promise((D,Q)=>{const S=JSON.stringify(G);if(!P){console.log("Message "+S),D("");return}const y={socketPath:P,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},H=O.request(y,K=>{if(K.headers["content-type"]!=="application/json"){Q("Error in response: Invalid content type: Expected 'application/json', is: "+K.headers["content-type"]);return}const J=[];K.setEncoding("utf8"),K.on("data",Z=>{J.push(Z)}),K.on("error",Z=>g("Error in response.",Z)),K.on("end",()=>{const Z=J.join("");try{const se=JSON.parse(Z);K.statusCode===200?D(se):Q(se)}catch{Q("Error in response: Unable to parse response as JSON: "+Z)}})});H.on("error",K=>g("Error in request.",K)),H.write(S),H.end()})}function c(G){return G?.map(V=>/\.vsix$/i.test(V)?f(V).href:V)}function g(G,V){console.error("Unable to connect to VS Code server: "+G),console.error(V),process.exit(1)}const A=process.env.PWD||(0,ie.cwd)();function f(G){return G=G.trim(),G=(0,X.$nc)(A,G),t.pathToFileURL(G)}function h(G,V,D,Q){const S=f(G),y=V(S.href);try{const H=a.lstatSync(a.realpathSync(G));H.isFile()?Q.push(y):H.isDirectory()?D.push(y):G==="/dev/null"&&Q.push(y)}catch(H){H.code==="ENOENT"?Q.push(y):console.log(`Problem accessing file ${G}. Ignoring file`,H)}}function s(G){return G.replace(/^file:\/\//,"vscode-remote://"+w)}const[,,_,U,I,u,...B]=process.argv;q({productName:_,version:U,commit:I,executableName:u},B).then(null,G=>{console.error(G.message||G.stack||G)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1962f48b7f71772dc2c060dbaa5a6b4c0792a549/core/vs/server/node/server.cli.js.map
