"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","fs","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stopwatch","vs/editor/common/core/range","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/encodedTokenAttributes","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","https","http","vs/server/node/server.main"],Se=function(se){for(var e=[],n=0,r=se.length;n<r;n++)e[n]=ve[se[n]];return e};define(ve[104],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var n;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(n||(e.LoaderEventType=n={}));class r{static get(){const k=new Map,R=new Map,A=new Map,y=new Map;function o(a,f){a.has(f.detail)||a.set(f.detail,-f.timestamp)}function D(a,f){const m=a.get(f.detail);m&&(m>=0||a.set(f.detail,m+f.timestamp))}let v=[];typeof se=="function"&&typeof se.getStats=="function"&&(v=se.getStats().slice(0).sort((a,f)=>a.timestamp-f.timestamp));for(const a of v)switch(a.type){case n.BeginLoadingScript:o(k,a);break;case n.EndLoadingScriptOK:case n.EndLoadingScriptError:D(k,a);break;case n.BeginInvokeFactory:o(R,a);break;case n.EndInvokeFactory:D(R,a);break;case n.NodeBeginNativeRequire:o(A,a);break;case n.NodeEndNativeRequire:D(A,a);break;case n.NodeBeginEvaluatingScript:o(y,a);break;case n.NodeEndEvaluatingScript:D(y,a);break}let h=0;A.forEach(a=>h+=a);function w(a){const f=[];return a.forEach((m,$)=>f.push([$,m])),f}return{amdLoad:w(k),amdInvoke:w(R),nodeRequire:w(A),nodeEval:w(y),nodeRequireTotal:h}}static toMarkdownTable(k,R){let A="";const y=[];return k.forEach((o,D)=>{y[D]=o.length}),R.forEach(o=>{o.forEach((D,v)=>{typeof D>"u"&&(D=o[v]="-");const h=D.toString().length;y[v]=Math.max(h,y[v])})}),k.forEach((o,D)=>{A+=`| ${o+" ".repeat(y[D]-o.toString().length)} `}),A+=`|
`,k.forEach((o,D)=>{A+=`| ${"-".repeat(y[D])} `}),A+=`|
`,R.forEach(o=>{o.forEach((D,v)=>{typeof D<"u"&&(A+=`| ${D+" ".repeat(y[v]-D.toString().length)} `)}),A+=`|
`}),A}}e.$W=r}),define(ve[105],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=n,e.$jb=r,e.$kb=E,e.$lb=k,e.$mb=R,e.$nb=A,e.$ob=y,e.$qb=D,e.$rb=v,e.$sb=h,e.$tb=w,e.$ub=a;function n(f,m){const $=r(f,m);if($!==-1)return f[$]}function r(f,m,$=f.length-1){for(let b=$;b>=0;b--){const d=f[b];if(m(d))return b}return-1}function E(f,m){const $=k(f,m);return $===-1?void 0:f[$]}function k(f,m,$=0,b=f.length){let d=$,p=b;for(;d<p;){const t=Math.floor((d+p)/2);m(f[t])?d=t+1:p=t}return d-1}function R(f,m){const $=A(f,m);return $===f.length?void 0:f[$]}function A(f,m,$=0,b=f.length){let d=$,p=b;for(;d<p;){const t=Math.floor((d+p)/2);m(f[t])?p=t:d=t+1}return d}function y(f,m,$=0,b=f.length){const d=A(f,m,$,b);return d===f.length?-1:d}class o{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(o.assertInvariants){if(this.d){for(const b of this.e)if(this.d(b)&&!m(b))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=k(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$pb=o;function D(f,m){if(f.length===0)return;let $=f[0];for(let b=1;b<f.length;b++){const d=f[b];m(d,$)>0&&($=d)}return $}function v(f,m){if(f.length===0)return;let $=f[0];for(let b=1;b<f.length;b++){const d=f[b];m(d,$)>=0&&($=d)}return $}function h(f,m){return D(f,($,b)=>-m($,b))}function w(f,m){if(f.length===0)return-1;let $=0;for(let b=1;b<f.length;b++){const d=f[b];m(d,f[$])>0&&($=b)}return $}function a(f,m){for(const $ of f){const b=m($);if(b!==void 0)return b}}}),define(ve[35],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ve[157],Se([1,0]),function(se,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=r,e.$L=E,e.$M=k,e.$N=R;function r(y,o){const D=Object.create(null);for(const v of y){const h=o(v);let w=D[h];w||(w=D[h]=[]),w.push(v)}return D}function E(y,o){const D=[],v=[];for(const h of y)o.has(h)||D.push(h);for(const h of o)y.has(h)||v.push(h);return{removed:D,added:v}}function k(y,o){const D=[],v=[];for(const[h,w]of y)o.has(h)||D.push(w);for(const[h,w]of o)y.has(h)||v.push(w);return{removed:D,added:v}}function R(y,o){const D=new Set;for(const v of o)y.has(v)&&D.add(v);return D}class A{static{n=Symbol.toStringTag}constructor(o,D){this.b=D,this.a=new Map,this[n]="SetWithKey";for(const v of o)this.add(v)}get size(){return this.a.size}add(o){const D=this.b(o);return this.a.set(D,o),this}delete(o){return this.a.delete(this.b(o))}has(o){return this.a.has(this.b(o))}*entries(){for(const o of this.a.values())yield[o,o]}keys(){return this.values()}*values(){for(const o of this.a.values())yield o}clear(){this.a.clear()}forEach(o,D){this.a.forEach(v=>o.call(D,v,v,this))}[Symbol.iterator](){return this.values()}}e.$O=A}),define(ve[78],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=r,e.$_h=E,e.$ai=k;function n(R){return(A,y,o)=>{let D=null,v=null;if(typeof o.value=="function"?(D="value",v=o.value):typeof o.get=="function"&&(D="get",v=o.get),!v)throw new Error("not supported");o[D]=R(v,y)}}function r(R,A,y){let o=null,D=null;if(typeof y.value=="function"?(o="value",D=y.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(o="get",D=y.get),!D)throw new Error("not supported");const v=`$memoize$${A}`;y[o]=function(...h){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,h)}),this[v]}}function E(R,A,y){return n((o,D)=>{const v=`$debounce$${D}`,h=`$debounce$result$${D}`;return function(...w){this[h]||(this[h]=y?y():void 0),clearTimeout(this[v]),A&&(this[h]=A(this[h],...w),w=[this[h]]),this[v]=setTimeout(()=>{o.apply(this,w),this[h]=y?y():void 0},R)}})}function k(R,A,y){return n((o,D)=>{const v=`$throttle$timer$${D}`,h=`$throttle$result$${D}`,w=`$throttle$lastRun$${D}`,a=`$throttle$pending$${D}`;return function(...f){if(this[h]||(this[h]=y?y():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...f)),this[a])return;const m=this[w]+R;m<=Date.now()?(this[w]=Date.now(),o.apply(this,[this[h]]),this[h]=y?y():void 0):(this[a]=!0,this[v]=setTimeout(()=>{this[a]=!1,this[w]=Date.now(),o.apply(this,[this[h]]),this[h]=y?y():void 0},m-Date.now()))}})}}),define(ve[10],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=r,e.$2=E,e.$3=k,e.$4=R,e.$5=A,e.$6=y,e.$7=D,e.$9=h,e.$0=w,e.$$=a,e.$ab=m;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(g=>{g(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=n,e.$Z=new n;function r(l){e.$Z.setUnexpectedErrorHandler(l)}function E(l){if(!l||typeof l!="object")return!1;const i=l;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function k(l){D(l)||e.$Z.onUnexpectedError(l)}function R(l){D(l)||e.$Z.onUnexpectedExternalError(l)}function A(l){if(l instanceof Error){const{name:i,message:g}=l,s=l.stacktrace||l.stack;return{$isError:!0,name:i,message:g,stack:s,noTelemetry:p.isErrorNoTelemetry(l)}}return l}function y(l){let i;return l.noTelemetry?i=new p:(i=new Error,i.name=l.name),i.message=l.message,i.stack=l.stack,i}const o="Canceled";function D(l){return l instanceof v?!0:l instanceof Error&&l.name===o&&l.message===o}class v extends Error{constructor(){super(o),this.name=this.message}}e.$8=v;function h(){const l=new Error(o);return l.name=l.message,l}function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function a(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=f;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=$;class b extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=b;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=d;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const g=new p;return g.message=i.message,g.stack=i.stack,g}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=p;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$fb=t}),define(ve[18],Se([1,0,10,105]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=E,e.$wb=k,e.$xb=R,e.$yb=A,e.$zb=y,e.$Ab=o,e.$Bb=D,e.$Cb=v,e.$Db=h,e.$Eb=w,e.$Fb=a,e.$Gb=f,e.$Hb=m,e.top=$,e.$Jb=b,e.$Kb=p,e.$Lb=t,e.$Mb=l,e.$Nb=i,e.$Ob=g,e.$Pb=s,e.$Qb=c,e.$Rb=u,e.$Sb=S,e.$Tb=P,e.$Ub=C,e.$Vb=L,e.$Wb=T,e.$Xb=I,e.$Yb=q,e.$Zb=Y,e.$1b=Q,e.$2b=re,e.$3b=te,e.$4b=_,e.$5b=de,e.$6b=J,e.$7b=ae,e.$8b=z,e.$9b=le,e.$0b=pe,e.$ac=x;function E(V,M=0){return V[V.length-(1+M)]}function k(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}function R(V,M,G=(X,F)=>X===F){if(V===M)return!0;if(!V||!M||V.length!==M.length)return!1;for(let X=0,F=V.length;X<F;X++)if(!G(V[X],M[X]))return!1;return!0}function A(V,M){const G=V.length-1;M<G&&(V[M]=V[G]),V.pop()}function y(V,M,G){return o(V.length,X=>G(V[X],M))}function o(V,M){let G=0,X=V-1;for(;G<=X;){const F=(G+X)/2|0,W=M(F);if(W<0)G=F+1;else if(W>0)X=F-1;else return F}return-(G+1)}function D(V,M,G){if(V=V|0,V>=M.length)throw new TypeError("invalid index");const X=M[Math.floor(M.length*Math.random())],F=[],W=[],oe=[];for(const he of M){const ke=G(he,X);ke<0?F.push(he):ke>0?W.push(he):oe.push(he)}return V<F.length?D(V,F,G):V<F.length+oe.length?oe[0]:D(V-(F.length+oe.length),W,G)}function v(V,M){const G=[];let X;for(const F of V.slice(0).sort(M))!X||M(X[0],F)!==0?(X=[F],G.push(X)):X.push(F);return G}function*h(V,M){let G,X;for(const F of V)X!==void 0&&M(X,F)?G.push(F):(G&&(yield G),G=[F]),X=F;G&&(yield G)}function w(V,M){for(let G=0;G<=V.length;G++)M(G===0?void 0:V[G-1],G===V.length?void 0:V[G])}function a(V,M){for(let G=0;G<V.length;G++)M(G===0?void 0:V[G-1],V[G],G+1===V.length?void 0:V[G+1])}function f(V,M,G){const X=[];function F(he,ke,Ne){if(ke===0&&Ne.length===0)return;const me=X[X.length-1];me&&me.start+me.deleteCount===he?(me.deleteCount+=ke,me.toInsert.push(...Ne)):X.push({start:he,deleteCount:ke,toInsert:Ne})}let W=0,oe=0;for(;;){if(W===V.length){F(W,0,M.slice(oe));break}if(oe===M.length){F(W,V.length-W,[]);break}const he=V[W],ke=M[oe],Ne=G(he,ke);Ne===0?(W+=1,oe+=1):Ne<0?(F(W,1,[]),W+=1):Ne>0&&(F(W,0,[ke]),oe+=1)}return X}function m(V,M,G){const X=f(V,M,G),F=[],W=[];for(const oe of X)F.push(...V.slice(oe.start,oe.start+oe.deleteCount)),W.push(...oe.toInsert);return{removed:F,added:W}}function $(V,M,G){if(G===0)return[];const X=V.slice(0,G).sort(M);return d(V,M,X,G,V.length),X}function b(V,M,G,X,F){return G===0?Promise.resolve([]):new Promise((W,oe)=>{(async()=>{const he=V.length,ke=V.slice(0,G).sort(M);for(let Ne=G,me=Math.min(G+X,he);Ne<he;Ne=me,me=Math.min(me+X,he)){if(Ne>G&&await new Promise($e=>setTimeout($e)),F&&F.isCancellationRequested)throw new n.$8;d(V,M,ke,Ne,me)}return ke})().then(W,oe)})}function d(V,M,G,X,F){for(const W=G.length;X<F;X++){const oe=V[X];if(M(oe,G[W-1])<0){G.pop();const he=(0,r.$nb)(G,ke=>M(oe,ke)<0);G.splice(he,0,oe)}}}function p(V){return V.filter(M=>!!M)}function t(V){let M=0;for(let G=0;G<V.length;G++)V[G]&&(V[M]=V[G],M+=1);V.length=M}function l(V,M,G){V.splice(G,0,V.splice(M,1)[0])}function i(V){return!Array.isArray(V)||V.length===0}function g(V){return Array.isArray(V)&&V.length>0}function s(V,M=G=>G){const G=new Set;return V.filter(X=>{const F=M(X);return G.has(F)?!1:(G.add(F),!0)})}function c(V){const M=new Set;return G=>{const X=V(G);return M.has(X)?!1:(M.add(X),!0)}}function u(V,M){return V.length>0?V[0]:M}function S(V,M){return V.length>0?V[V.length-1]:M}function P(V,M,G=(X,F)=>X===F){let X=0;for(let F=0,W=Math.min(V.length,M.length);F<W&&G(V[F],M[F]);F++)X++;return X}function C(V,M){let G=typeof M=="number"?V:0;typeof M=="number"?G=V:(G=0,M=V);const X=[];if(G<=M)for(let F=G;F<M;F++)X.push(F);else for(let F=G;F>M;F--)X.push(F);return X}function L(V,M,G){return V.reduce((X,F)=>(X[M(F)]=G?G(F):F,X),Object.create(null))}function T(V,M){return V.push(M),()=>I(V,M)}function I(V,M){const G=V.indexOf(M);if(G>-1)return V.splice(G,1),M}function q(V,M,G){const X=V.slice(0,M),F=V.slice(M);return X.concat(G,F)}function Y(V,M){let G;if(typeof M=="number"){let X=M;G=()=>{const F=Math.sin(X++)*179426549;return F-Math.floor(F)}}else G=Math.random;for(let X=V.length-1;X>0;X-=1){const F=Math.floor(G()*(X+1)),W=V[X];V[X]=V[F],V[F]=W}}function Q(V,M){const G=V.indexOf(M);G>-1&&(V.splice(G,1),V.unshift(M))}function re(V,M){const G=V.indexOf(M);G>-1&&(V.splice(G,1),V.push(M))}function te(V,M){for(const G of M)V.push(G)}function _(V,M){return Array.isArray(V)?V.map(M):M(V)}function de(V){return Array.isArray(V)?V:[V]}function J(V){return V[Math.floor(Math.random()*V.length)]}function ae(V,M,G){const X=B(V,M),F=V.length,W=G.length;V.length=F+W;for(let oe=F-1;oe>=X;oe--)V[oe+W]=V[oe];for(let oe=0;oe<W;oe++)V[oe+X]=G[oe]}function z(V,M,G,X){const F=B(V,M);let W=V.splice(F,G);return W===void 0&&(W=[]),ae(V,F,X),W}function B(V,M){return M<0?Math.max(M+V.length,0):Math.min(M,V.length)}var ie;(function(V){function M(W){return W<0}V.isLessThan=M;function G(W){return W<=0}V.isLessThanOrEqual=G;function X(W){return W>0}V.isGreaterThan=X;function F(W){return W===0}V.isNeitherLessOrGreaterThan=F,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function le(V,M){return(G,X)=>M(V(G),V(X))}function pe(...V){return(M,G)=>{for(const X of V){const F=X(M,G);if(!ie.isNeitherLessOrGreaterThan(F))return F}return ie.neitherLessOrGreaterThan}}const H=(V,M)=>V-M;e.$$b=H;const ce=(V,M)=>(0,e.$$b)(V?1:0,M?1:0);e.$_b=ce;function x(V){return(M,G)=>-V(M,G)}class U{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let G=this.c;for(;G<this.g.length&&M(this.g[G]);)G++;const X=G===this.c?null:this.g.slice(this.c,G);return this.c=G,X}takeFromEndWhile(M){let G=this.d;for(;G>=0&&M(this.g[G]);)G--;const X=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const G=this.g.slice(this.c,this.c+M);return this.c+=M,G}}e.$bc=U;class O{static{this.empty=new O(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(G=>(M(G),!0))}toArray(){const M=[];return this.iterate(G=>(M.push(G),!0)),M}filter(M){return new O(G=>this.iterate(X=>M(X)?G(X):!0))}map(M){return new O(G=>this.iterate(X=>G(M(X))))}some(M){let G=!1;return this.iterate(X=>(G=M(X),!G)),G}findFirst(M){let G;return this.iterate(X=>M(X)?(G=X,!1):!0),G}findLast(M){let G;return this.iterate(X=>(M(X)&&(G=X),!0)),G}findLastMaxBy(M){let G,X=!0;return this.iterate(F=>((X||ie.isGreaterThan(M(F,G)))&&(X=!1,G=F),!0)),G}}e.$cc=O;class Z{constructor(M){this.c=M}static createSortPermutation(M,G){const X=Array.from(M.keys()).sort((F,W)=>G(M[F],M[W]));return new Z(X)}apply(M){return M.map((G,X)=>M[this.c[X]])}inverse(){const M=this.c.slice();for(let G=0;G<this.c.length;G++)M[this.c[G]]=G;return new Z(M)}}e.$dc=Z}),define(ve[106],Se([1,0,10]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$hd=E,e.$id=k,e.$jd=R,e.$kd=A,e.$ld=y;function r(o,D){if(!o)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}function E(o,D="Unreachable"){throw new Error(D)}function k(o,D="unexpected state"){if(!o)throw new n.$fb(`Assertion Failed: ${D}`)}function R(o){o||(0,n.$3)(new n.$fb("Soft Assertion Failed"))}function A(o){if(!o()){debugger;o(),(0,n.$3)(new n.$fb("Assertion Failed"))}}function y(o,D){let v=0;for(;v<o.length-1;){const h=o[v],w=o[v+1];if(!D(h,w))return!1;v++}return!0}});var Pi=this&&this.__createBinding||(Object.create?function(se,e,n,r){r===void 0&&(r=n);var E=Object.getOwnPropertyDescriptor(e,n);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(se,r,E)}:function(se,e,n,r){r===void 0&&(r=n),se[r]=e[n]}),Ri=this&&this.__setModuleDefault||(Object.create?function(se,e){Object.defineProperty(se,"default",{enumerable:!0,value:e})}:function(se,e){se.default=e}),qe=this&&this.__importStar||function(se){if(se&&se.__esModule)return se;var e={};if(se!=null)for(var n in se)n!=="default"&&Object.prototype.hasOwnProperty.call(se,n)&&Pi(e,se,n);return Ri(e,se),e};define(ve[158],Se([1,0,18]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=E,e.$$c=k,e.$_c=R,e.$ad=A,e.$bd=y,e.$cd=o,n=qe(n);const r=(w,a)=>w===a;e.$9c=r;function E(w=e.$9c){return(a,f)=>n.$xb(a,f,w)}function k(){return(w,a)=>JSON.stringify(w)===JSON.stringify(a)}function R(){return(w,a)=>w.equals(a)}function A(w,a,f){if(f!==void 0){const m=w;return m==null||a===void 0||a===null?a===m:f(m,a)}else{const m=w;return($,b)=>$==null||b===void 0||b===null?b===$:m($,b)}}function y(w,a){if(w===a)return!0;if(Array.isArray(w)&&Array.isArray(a)){if(w.length!==a.length)return!1;for(let f=0;f<w.length;f++)if(!y(w[f],a[f]))return!1;return!0}if(w&&typeof w=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const f=w,m=a,$=Object.keys(f),b=Object.keys(m),d=new Set(b);if($.length!==b.length)return!1;for(const p of $)if(!d.has(p)||!y(f[p],m[p]))return!1;return!0}return!1}function o(w){return JSON.stringify(h(w))}let D=0;const v=new WeakMap;function h(w){if(Array.isArray(w))return w.map(h);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const a=w,f=Object.create(null);for(const m of Object.keys(a).sort())f[m]=h(a[m]);return f}else{let a=v.get(w);return a===void 0&&(a=D++,v.set(w,a)),a+"----2b76a038c20c4bcc"}return w}}),define(ve[79],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=n;function n(r,E){const k=this;let R=!1,A;return function(){if(R)return A;if(R=!0,E)try{A=r.apply(k,arguments)}finally{E()}else A=r.apply(k,arguments);return A}}}),define(ve[40],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function E(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=E;const k=Object.freeze([]);function R(){return k}r.empty=R;function*A(i){yield i}r.single=A;function y(i){return E(i)?i:A(i)}r.wrap=y;function o(i){return i||k}r.from=o;function*D(i){for(let g=i.length-1;g>=0;g--)yield i[g]}r.reverse=D;function v(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=v;function h(i){return i[Symbol.iterator]().next().value}r.first=h;function w(i,g){let s=0;for(const c of i)if(g(c,s++))return!0;return!1}r.some=w;function a(i,g){for(const s of i)if(g(s))return s}r.find=a;function*f(i,g){for(const s of i)g(s)&&(yield s)}r.filter=f;function*m(i,g){let s=0;for(const c of i)yield g(c,s++)}r.map=m;function*$(i,g){let s=0;for(const c of i)yield*g(c,s++)}r.flatMap=$;function*b(...i){for(const g of i)yield*g}r.concat=b;function d(i,g,s){let c=s;for(const u of i)c=g(c,u);return c}r.reduce=d;function*p(i,g,s=i.length){for(g<0&&(g+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);g<s;g++)yield i[g]}r.slice=p;function t(i,g=Number.POSITIVE_INFINITY){const s=[];if(g===0)return[s,i];const c=i[Symbol.iterator]();for(let u=0;u<g;u++){const S=c.next();if(S.done)return[s,r.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return c}}]}r.consume=t;async function l(i){const g=[];for await(const s of i)g.push(s);return Promise.resolve(g)}r.asyncToArray=l})(n||(e.Iterable=n={}))}),define(ve[43],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=R,e.$Xn=v,e.$Yn=h,e.$Zn=w,e.$1n=a,e.$2n=f,e.$3n=m,e.$4n=$,e.$5n=b,e.$6n=d,e.$7n=p;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function R(t,l=!1){let i=0;const g=t.length;let s="",c=0,u=r.Unknown,S=n.None;function P(Q){let re=0,te=0;for(;re<Q;){const _=t.charCodeAt(i);if(_>=D._0&&_<=D._9)te=te*16+_-D._0;else if(_>=D.A&&_<=D.F)te=te*16+_-D.A+10;else if(_>=D.a&&_<=D.f)te=te*16+_-D.a+10;else break;i++,re++}return re<Q&&(te=-1),te}function C(Q){i=Q,s="",c=0,u=r.Unknown,S=n.None}function L(){const Q=i;if(t.charCodeAt(i)===D._0)i++;else for(i++;i<t.length&&o(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===D.dot)if(i++,i<t.length&&o(t.charCodeAt(i)))for(i++;i<t.length&&o(t.charCodeAt(i));)i++;else return S=n.UnexpectedEndOfNumber,t.substring(Q,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===D.E||t.charCodeAt(i)===D.e))if(i++,(i<t.length&&t.charCodeAt(i)===D.plus||t.charCodeAt(i)===D.minus)&&i++,i<t.length&&o(t.charCodeAt(i))){for(i++;i<t.length&&o(t.charCodeAt(i));)i++;re=i}else S=n.UnexpectedEndOfNumber;return t.substring(Q,re)}function T(){let Q="",re=i;for(;;){if(i>=g){Q+=t.substring(re,i),S=n.UnexpectedEndOfString;break}const te=t.charCodeAt(i);if(te===D.doubleQuote){Q+=t.substring(re,i),i++;break}if(te===D.backslash){if(Q+=t.substring(re,i),i++,i>=g){S=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case D.doubleQuote:Q+='"';break;case D.backslash:Q+="\\";break;case D.slash:Q+="/";break;case D.b:Q+="\b";break;case D.f:Q+="\f";break;case D.n:Q+=`
`;break;case D.r:Q+="\r";break;case D.t:Q+="	";break;case D.u:{const de=P(4);de>=0?Q+=String.fromCharCode(de):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}re=i;continue}if(te>=0&&te<=31)if(y(te)){Q+=t.substring(re,i),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;i++}return Q}function I(){if(s="",S=n.None,c=i,i>=g)return c=g,u=r.EOF;let Q=t.charCodeAt(i);if(A(Q)){do i++,s+=String.fromCharCode(Q),Q=t.charCodeAt(i);while(A(Q));return u=r.Trivia}if(y(Q))return i++,s+=String.fromCharCode(Q),Q===D.carriageReturn&&t.charCodeAt(i)===D.lineFeed&&(i++,s+=`
`),u=r.LineBreakTrivia;switch(Q){case D.openBrace:return i++,u=r.OpenBraceToken;case D.closeBrace:return i++,u=r.CloseBraceToken;case D.openBracket:return i++,u=r.OpenBracketToken;case D.closeBracket:return i++,u=r.CloseBracketToken;case D.colon:return i++,u=r.ColonToken;case D.comma:return i++,u=r.CommaToken;case D.doubleQuote:return i++,s=T(),u=r.StringLiteral;case D.slash:{const re=i-1;if(t.charCodeAt(i+1)===D.slash){for(i+=2;i<g&&!y(t.charCodeAt(i));)i++;return s=t.substring(re,i),u=r.LineCommentTrivia}if(t.charCodeAt(i+1)===D.asterisk){i+=2;const te=g-1;let _=!1;for(;i<te;){if(t.charCodeAt(i)===D.asterisk&&t.charCodeAt(i+1)===D.slash){i+=2,_=!0;break}i++}return _||(i++,S=n.UnexpectedEndOfComment),s=t.substring(re,i),u=r.BlockCommentTrivia}return s+=String.fromCharCode(Q),i++,u=r.Unknown}case D.minus:if(s+=String.fromCharCode(Q),i++,i===g||!o(t.charCodeAt(i)))return u=r.Unknown;case D._0:case D._1:case D._2:case D._3:case D._4:case D._5:case D._6:case D._7:case D._8:case D._9:return s+=L(),u=r.NumericLiteral;default:for(;i<g&&q(Q);)i++,Q=t.charCodeAt(i);if(c!==i){switch(s=t.substring(c,i),s){case"true":return u=r.TrueKeyword;case"false":return u=r.FalseKeyword;case"null":return u=r.NullKeyword}return u=r.Unknown}return s+=String.fromCharCode(Q),i++,u=r.Unknown}}function q(Q){if(A(Q)||y(Q))return!1;switch(Q){case D.closeBrace:case D.closeBracket:case D.openBrace:case D.openBracket:case D.doubleQuote:case D.colon:case D.comma:case D.slash:return!1}return!0}function Y(){let Q;do Q=I();while(Q>=r.LineCommentTrivia&&Q<=r.Trivia);return Q}return{setPosition:C,getPosition:()=>i,scan:l?Y:I,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>S}}function A(t){return t===D.space||t===D.tab||t===D.verticalTab||t===D.formFeed||t===D.nonBreakingSpace||t===D.ogham||t>=D.enQuad&&t<=D.zeroWidthSpace||t===D.narrowNoBreakSpace||t===D.mathematicalSpace||t===D.ideographicSpace||t===D.byteOrderMark}function y(t){return t===D.lineFeed||t===D.carriageReturn||t===D.lineSeparator||t===D.paragraphSeparator}function o(t){return t>=D._0&&t<=D._9}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function v(t,l){const i=[],g=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function S(P,C,L,T){c.value=P,c.offset=C,c.length=L,c.type=T,c.colonOffset=void 0,s=c}try{d(t,{onObjectBegin:(P,C)=>{if(l<=P)throw g;s=void 0,u=l>P,i.push("")},onObjectProperty:(P,C,L)=>{if(l<C||(S(P,C,L,"property"),i[i.length-1]=P,l<=C+L))throw g},onObjectEnd:(P,C)=>{if(l<=P)throw g;s=void 0,i.pop()},onArrayBegin:(P,C)=>{if(l<=P)throw g;s=void 0,i.push(0)},onArrayEnd:(P,C)=>{if(l<=P)throw g;s=void 0,i.pop()},onLiteralValue:(P,C,L)=>{if(l<C||(S(P,C,L,p(P)),l<=C+L))throw g},onSeparator:(P,C,L)=>{if(l<=C)throw g;if(P===":"&&s&&s.type==="property")s.colonOffset=C,u=!1,s=void 0;else if(P===","){const T=i[i.length-1];typeof T=="number"?i[i.length-1]=T+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(P){if(P!==g)throw P}return{path:i,previousNode:s,isAtPropertyKey:u,matches:P=>{let C=0;for(let L=0;C<P.length&&L<i.length;L++)if(P[C]===i[L]||P[C]==="*")C++;else if(P[C]!=="**")return!1;return C===P.length}}}function h(t,l=[],i=k.DEFAULT){let g=null,s=[];const c=[];function u(P){Array.isArray(s)?s.push(P):g!==null&&(s[g]=P)}return d(t,{onObjectBegin:()=>{const P={};u(P),c.push(s),s=P,g=null},onObjectProperty:P=>{g=P},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const P=[];u(P),c.push(s),s=P,g=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(P,C,L)=>{l.push({error:P,offset:C,length:L})}},i),s[0]}function w(t,l=[],i=k.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){g.type==="property"&&(g.length=P-g.offset,g=g.parent)}function c(P){return g.children.push(P),P}d(t,{onObjectBegin:P=>{g=c({type:"object",offset:P,length:-1,parent:g,children:[]})},onObjectProperty:(P,C,L)=>{g=c({type:"property",offset:C,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:P,offset:C,length:L,parent:g})},onObjectEnd:(P,C)=>{g.length=P+C-g.offset,g=g.parent,s(P+C)},onArrayBegin:(P,C)=>{g=c({type:"array",offset:P,length:-1,parent:g,children:[]})},onArrayEnd:(P,C)=>{g.length=P+C-g.offset,g=g.parent,s(P+C)},onLiteralValue:(P,C,L)=>{c({type:p(P),offset:C,length:L,parent:g,value:P}),s(C+L)},onSeparator:(P,C,L)=>{g.type==="property"&&(P===":"?g.colonOffset=C:P===","&&s(C))},onError:(P,C,L)=>{l.push({error:P,offset:C,length:L})}},i);const S=g.children[0];return S&&delete S.parent,S}function a(t,l){if(!t)return;let i=t;for(const g of l)if(typeof g=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===g){i=c.children[1],s=!0;break}if(!s)return}else{const s=g;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function f(t){if(!t.parent||!t.parent.children)return[];const l=f(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;l.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&l.push(i)}return l}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const l=Object.create(null);for(const i of t.children){const g=i.children[1];g&&(l[i.children[0].value]=m(g))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,l,i=!1){return l>=t.offset&&l<t.offset+t.length||i&&l===t.offset+t.length}function b(t,l,i=!1){if($(t,l,i)){const g=t.children;if(Array.isArray(g))for(let s=0;s<g.length&&g[s].offset<=l;s++){const c=b(g[s],l,i);if(c)return c}return t}}function d(t,l,i=k.DEFAULT){const g=R(t,!1);function s(le){return le?()=>le(g.getTokenOffset(),g.getTokenLength()):()=>!0}function c(le){return le?pe=>le(pe,g.getTokenOffset(),g.getTokenLength()):()=>!0}const u=s(l.onObjectBegin),S=c(l.onObjectProperty),P=s(l.onObjectEnd),C=s(l.onArrayBegin),L=s(l.onArrayEnd),T=c(l.onLiteralValue),I=c(l.onSeparator),q=s(l.onComment),Y=c(l.onError),Q=i&&i.disallowComments,re=i&&i.allowTrailingComma;function te(){for(;;){const le=g.scan();switch(g.getTokenError()){case n.InvalidUnicode:_(E.InvalidUnicode);break;case n.InvalidEscapeCharacter:_(E.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:_(E.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:Q||_(E.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:_(E.UnexpectedEndOfString);break;case n.InvalidCharacter:_(E.InvalidCharacter);break}switch(le){case r.LineCommentTrivia:case r.BlockCommentTrivia:Q?_(E.InvalidCommentToken):q();break;case r.Unknown:_(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return le}}}function _(le,pe=[],H=[]){if(Y(le),pe.length+H.length>0){let ce=g.getToken();for(;ce!==r.EOF;){if(pe.indexOf(ce)!==-1){te();break}else if(H.indexOf(ce)!==-1)break;ce=te()}}}function de(le){const pe=g.getTokenValue();return le?T(pe):S(pe),te(),!0}function J(){switch(g.getToken()){case r.NumericLiteral:{let le=0;try{le=JSON.parse(g.getTokenValue()),typeof le!="number"&&(_(E.InvalidNumberFormat),le=0)}catch{_(E.InvalidNumberFormat)}T(le);break}case r.NullKeyword:T(null);break;case r.TrueKeyword:T(!0);break;case r.FalseKeyword:T(!1);break;default:return!1}return te(),!0}function ae(){return g.getToken()!==r.StringLiteral?(_(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(de(!1),g.getToken()===r.ColonToken?(I(":"),te(),ie()||_(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):_(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function z(){u(),te();let le=!1;for(;g.getToken()!==r.CloseBraceToken&&g.getToken()!==r.EOF;){if(g.getToken()===r.CommaToken){if(le||_(E.ValueExpected,[],[]),I(","),te(),g.getToken()===r.CloseBraceToken&&re)break}else le&&_(E.CommaExpected,[],[]);ae()||_(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),le=!0}return P(),g.getToken()!==r.CloseBraceToken?_(E.CloseBraceExpected,[r.CloseBraceToken],[]):te(),!0}function B(){C(),te();let le=!1;for(;g.getToken()!==r.CloseBracketToken&&g.getToken()!==r.EOF;){if(g.getToken()===r.CommaToken){if(le||_(E.ValueExpected,[],[]),I(","),te(),g.getToken()===r.CloseBracketToken&&re)break}else le&&_(E.CommaExpected,[],[]);ie()||_(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),le=!0}return L(),g.getToken()!==r.CloseBracketToken?_(E.CloseBracketExpected,[r.CloseBracketToken],[]):te(),!0}function ie(){switch(g.getToken()){case r.OpenBracketToken:return B();case r.OpenBraceToken:return z();case r.StringLiteral:return de(!0);default:return J()}}return te(),g.getToken()===r.EOF?i.allowEmptyContent?!0:(_(E.ValueExpected,[],[]),!1):ie()?(g.getToken()!==r.EOF&&_(E.EndOfFileExpected,[],[]),!0):(_(E.ValueExpected,[],[]),!1)}function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ve[159],Se([1,0,43]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=r,e.$9n=E,e.$0n=A,e.$$n=y;function r(o,D,v){let h,w,a,f,m;if(D){for(f=D.offset,m=f+D.length,a=f;a>0&&!y(o,a-1);)a--;let S=m;for(;S<o.length&&!y(o,S);)S++;w=o.substring(a,S),h=R(w,v)}else w=o,h=0,a=0,f=0,m=o.length;const $=A(v,o);let b=!1,d=0,p;v.insertSpaces?p=k(" ",v.tabSize||4):p="	";const t=(0,n.$Wn)(w,!1);let l=!1;function i(){return $+k(p,h+d)}function g(){let S=t.scan();for(b=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)b=b||S===n.SyntaxKind.LineBreakTrivia,S=t.scan();return l=S===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,S}const s=[];function c(S,P,C){!l&&P<m&&C>f&&o.substring(P,C)!==S&&s.push({offset:P,length:C-P,content:S})}let u=g();if(u!==n.SyntaxKind.EOF){const S=t.getTokenOffset()+a,P=k(p,h);c(P,a,S)}for(;u!==n.SyntaxKind.EOF;){let S=t.getTokenOffset()+t.getTokenLength()+a,P=g(),C="";for(;!b&&(P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia);){const T=t.getTokenOffset()+a;c(" ",S,T),S=t.getTokenOffset()+t.getTokenLength()+a,C=P===n.SyntaxKind.LineCommentTrivia?i():"",P=g()}if(P===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(d--,C=i());else if(P===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(d--,C=i());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:d++,C=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:C=i();break;case n.SyntaxKind.BlockCommentTrivia:b?C=i():C=" ";break;case n.SyntaxKind.ColonToken:C=" ";break;case n.SyntaxKind.StringLiteral:if(P===n.SyntaxKind.ColonToken){C="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia?C=" ":P!==n.SyntaxKind.CommaToken&&P!==n.SyntaxKind.EOF&&(l=!0);break;case n.SyntaxKind.Unknown:l=!0;break}b&&(P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia)&&(C=i())}const L=t.getTokenOffset()+a;c(C,S,L),u=P}return s}function E(o,D){const v=JSON.stringify(o,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?v.replace(/\r\n|\r|\n/g,D.eol):v}function k(o,D){let v="";for(let h=0;h<D;h++)v+=o;return v}function R(o,D){let v=0,h=0;const w=D.tabSize||4;for(;v<o.length;){const a=o.charAt(v);if(a===" ")h++;else if(a==="	")h+=w;else break;v++}return Math.floor(h/w)}function A(o,D){for(let v=0;v<D.length;v++){const h=D.charAt(v);if(h==="\r")return v+1<D.length&&D.charAt(v+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return o&&o.eol||`
`}function y(o,D){return`\r
`.indexOf(o.charAt(D))!==-1}}),define(ve[160],Se([1,0,43,159]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=E,e.$ao=k,e.$bo=R,e.$co=A,e.$do=y;function E(o,D,v){return k(o,D,void 0,v)}function k(o,D,v,h,w){const a=D.slice(),f=[],m=(0,n.$Zn)(o,f);let $,b;for(;a.length>0&&(b=a.pop(),$=(0,n.$1n)(m,a),$===void 0&&v!==void 0);)typeof b=="string"?v={[b]:v}:v=[v];if($)if($.type==="object"&&typeof b=="string"&&Array.isArray($.children)){const d=(0,n.$1n)($,[b]);if(d!==void 0)if(v===void 0){if(!d.parent)throw new Error("Malformed AST");const p=$.children.indexOf(d.parent);let t,l=d.parent.offset+d.parent.length;if(p>0){const i=$.children[p-1];t=i.offset+i.length}else t=$.offset+1,$.children.length>1&&(l=$.children[1].offset);return R(o,{offset:t,length:l-t,content:""},h)}else return R(o,{offset:d.offset,length:d.length,content:JSON.stringify(v)},h);else{if(v===void 0)return[];const p=`${JSON.stringify(b)}: ${JSON.stringify(v)}`,t=w?w($.children.map(i=>i.children[0].value)):$.children.length;let l;if(t>0){const i=$.children[t-1];l={offset:i.offset+i.length,length:0,content:","+p}}else $.children.length===0?l={offset:$.offset+1,length:0,content:p}:l={offset:$.offset+1,length:0,content:p+","};return R(o,l,h)}}else if($.type==="array"&&typeof b=="number"&&Array.isArray($.children))if(v!==void 0){const d=`${JSON.stringify(v)}`;let p;if($.children.length===0||b===0)p={offset:$.offset+1,length:0,content:$.children.length===0?d:d+","};else{const t=b===-1||b>$.children.length?$.children.length:b,l=$.children[t-1];p={offset:l.offset+l.length,length:0,content:","+d}}return R(o,p,h)}else{const d=b,p=$.children[d];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===d){const l=$.children[d-1],i=l.offset+l.length,g=$.offset+$.length;t={offset:i,length:g-2-i,content:""}}else t={offset:p.offset,length:$.children[d+1].offset-p.offset,content:""};return R(o,t,h)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${$.type}`);else return v===void 0?[]:R(o,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},h)}function R(o,D,v){let h=A(o,D),w=D.offset,a=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;w>0&&!(0,r.$$n)(h,w-1);)w--;for(;a<h.length&&!(0,r.$$n)(h,a);)a++}const f=(0,r.$8n)(h,{offset:w,length:a-w},v);for(let $=f.length-1;$>=0;$--){const b=f[$];h=A(h,b),w=Math.min(w,b.offset),a=Math.max(a,b.offset+b.length),a+=b.content.length-b.length}const m=o.length-(h.length-a)-w;return[{offset:w,length:m,content:h.substring(w,a)}]}function A(o,D){return o.substring(0,D.offset)+D.content+o.substring(D.offset+D.length)}function y(o,D){const v=D.slice(0).sort((w,a)=>{const f=w.offset-a.offset;return f===0?w.length-a.length:f});let h=o.length;for(let w=v.length-1;w>=0;w--){const a=v[w];if(a.offset+a.length<=h)o=A(o,a);else throw new Error("Overlapping edit");h=a.offset}return o}}),define(ve[65],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class n{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=n}),define(ve[80],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(k){this.element=k,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let k=this.a;for(;k!==n.Undefined;){const R=k.next;k.prev=n.Undefined,k.next=n.Undefined,k=R}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,R){const A=new n(k);if(this.a===n.Undefined)this.a=A,this.b=A;else if(R){const o=this.b;this.b=A,A.prev=o,o.next=A}else{const o=this.a;this.a=A,A.next=o,o.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==n.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==n.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==n.Undefined&&k.next!==n.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===n.Undefined&&k.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):k.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):k.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==n.Undefined;)yield k.element,k=k.next}}e.$8c=r}),define(ve[26],Se([1,0]),function(se,e){"use strict";var n,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=k,e.$Bc=R,e.$Cc=A,e.$Lc=p;function k(t,l,i){let g=t.get(l);return g===void 0&&(g=i,t.set(l,g)),g}function R(t){const l=[];return t.forEach((i,g)=>{l.push(`${g} => ${i}`)}),`Map(${t.size}) {${l.join(", ")}}`}function A(t){const l=[];return t.forEach(i=>{l.push(i)}),`Set(${t.size}) {${l.join(", ")}}`}class y{constructor(l,i){this.uri=l,this.value=i}}function o(t){return Array.isArray(t)}class D{static{this.c=l=>l.toString()}constructor(l,i){if(this[n]="ResourceMap",l instanceof D)this.d=new Map(l.d),this.e=i??D.c;else if(o(l)){this.d=new Map,this.e=i??D.c;for(const[g,s]of l)this.set(g,s)}else this.d=new Map,this.e=l??D.c}set(l,i){return this.d.set(this.e(l),new y(l,i)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,i){typeof i<"u"&&(l=l.bind(i));for(const[g,s]of this.d)l(s.value,s.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Dc=D;class v{constructor(l,i){this[r]="ResourceSet",!l||typeof l=="function"?this.c=new D(l):(this.c=new D(i),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,i){this.c.forEach((g,s)=>l.call(i,s,s,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=v;var h;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class w{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,i=h.None){const g=this.c.get(l);if(g)return i!==h.None&&this.m(g,i),g.value}set(l,i,g=h.None){let s=this.c.get(l);if(s)s.value=i,g!==h.None&&this.m(s,g);else{switch(s={key:l,value:i,next:void 0,previous:void 0},g){case h.None:this.k(s);break;case h.AsOld:this.j(s);break;case h.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(l,s),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const i=this.c.get(l);if(i)return this.c.delete(l),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.l(l),this.f--,l.value}forEach(l,i){const g=this.g;let s=this.d;for(;s;){if(i?l.bind(i)(s.value,s.key,this):l(s.value,s.key,this),this.g!==g)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:g.key,done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}values(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:g.value,done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}entries(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:[g.key,g.value],done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let i=this.d,g=this.size;for(;i&&g>l;)this.c.delete(i.key),i=i.next,g--;this.d=i,this.f=g,i&&(i.previous=void 0),this.g++}i(l){if(l>=this.size)return;if(l===0){this.clear();return}let i=this.e,g=this.size;for(;i&&g>l;)this.c.delete(i.key),i=i.previous,g--;this.e=i,this.f=g,i&&(i.next=void 0),this.g++}j(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}k(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}l(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const i=l.next,g=l.previous;if(!i||!g)throw new Error("Invalid list");i.previous=g,g.next=i}l.next=void 0,l.previous=void 0,this.g++}m(l,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==h.AsOld&&i!==h.AsNew)){if(i===h.AsOld){if(l===this.d)return;const g=l.next,s=l.previous;l===this.e?(s.next=void 0,this.e=s):(g.previous=s,s.next=g),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(i===h.AsNew){if(l===this.e)return;const g=l.next,s=l.previous;l===this.d?(g.previous=void 0,this.d=g):(g.previous=s,s.next=g),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((i,g)=>{l.push([g,i])}),l}fromJSON(l){this.clear();for(const[i,g]of l)this.set(i,g)}}e.$Fc=w;class a extends w{constructor(l,i=1){super(),this.n=l,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(l){this.n=l,this.p()}get ratio(){return this.o}set ratio(l){this.o=Math.min(Math.max(0,l),1),this.p()}get(l,i=h.AsNew){return super.get(l,i)}peek(l){return super.get(l,h.None)}set(l,i){return super.set(l,i,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends a{constructor(l,i=1){super(l,i)}q(l){this.h(l)}set(l,i){return super.set(l,i),this.p(),this}}e.$Gc=f;class m extends a{constructor(l,i=1){super(l,i)}q(l){this.i(l)}set(l,i){return this.n<=this.size&&!this.has(l)&&this.q(Math.round(this.n*this.o)-1),super.set(l,i),this}}e.$Hc=m;class ${constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let i=this.c.get(l)||0;return i===0?!1:(i--,i===0?this.c.delete(l):this.c.set(l,i),!0)}has(l){return this.c.has(l)}}e.$Ic=$;class b{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[i,g]of l)this.set(i,g)}clear(){this.c.clear(),this.d.clear()}set(l,i){this.c.set(l,i),this.d.set(i,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const i=this.c.get(l);return i===void 0?!1:(this.c.delete(l),this.d.delete(i),!0)}forEach(l,i){this.c.forEach((g,s)=>{l.call(i,g,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=b;class d{constructor(){this.c=new Map}add(l,i){let g=this.c.get(l);g||(g=new Set,this.c.set(l,g)),g.add(i)}delete(l,i){const g=this.c.get(l);g&&(g.delete(i),g.size===0&&this.c.delete(l))}forEach(l,i){const g=this.c.get(l);g&&g.forEach(i)}get(l){const i=this.c.get(l);return i||new Set}}e.$Kc=d;function p(t,l){if(t===l)return!0;if(t.size!==l.size)return!1;for(const[i,g]of t)if(!l.has(i)||l.get(i)!==g)return!1;for(const[i]of l)if(!t.has(i))return!1;return!0}}),define(ve[2],Se([1,0,18,157,26,79,40]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=D,e.$Oc=v,e.$Pc=h,e.$Qc=f,e.$Rc=m,e.$Sc=$,e.$Tc=b,e.$Uc=d,e.$Vc=p,e.$6c=C;const A=!1;let y=null;class o{constructor(){this.b=new Map}static{this.a=0}c(I){let q=this.b.get(I);return q||(q={parent:null,source:null,isSingleton:!1,value:I,idx:o.a++},this.b.set(I,q)),q}trackDisposable(I){const q=this.c(I);q.source||(q.source=new Error().stack)}setParent(I,q){const Y=this.c(I);Y.parent=q}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,q){const Y=q.get(I);if(Y)return Y;const Q=I.parent?this.f(this.c(I.parent),q):I;return q.set(I,Q),Q}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,I).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(I=10,q){let Y;if(q)Y=q;else{const de=new Map,J=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,de).isSingleton);if(J.length===0)return;const ae=new Set(J.map(z=>z.value));if(Y=J.filter(z=>!(z.parent&&ae.has(z.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function Q(de){function J(z,B){for(;z.length>0&&B.some(ie=>typeof ie=="string"?ie===z[0]:z[0].match(ie));)z.shift()}const ae=de.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return J(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const re=new E.$Kc;for(const de of Y){const J=Q(de);for(let ae=0;ae<=J.length;ae++)re.add(J.slice(0,ae).join(`
`),de)}Y.sort((0,n.$9b)(de=>de.idx,n.$$b));let te="",_=0;for(const de of Y.slice(0,I)){_++;const J=Q(de),ae=[];for(let z=0;z<J.length;z++){let B=J[z];B=`(shared with ${re.get(J.slice(0,z+1).join(`
`)).size}/${Y.length} leaks) at ${B}`;const le=re.get(J.slice(0,z).join(`
`)),pe=(0,r.$K)([...le].map(H=>Q(H)[z]),H=>H);delete pe[J[z]];for(const[H,ce]of Object.entries(pe))ae.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${H}`);ae.unshift(B)}te+=`


==================== Leaking disposable ${_}/${Y.length}: ${de.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return Y.length>I&&(te+=`


... and ${Y.length-I} more leaking disposables

`),{leaks:Y,details:te}}}e.$Mc=o;function D(T){y=T}if(A){const T="__is_disposable_tracked__";D(new class{trackDisposable(I){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[T]||console.log(q)},3e3)}setParent(I,q){if(I&&I!==l.None)try{I[T]=!0}catch{}}markAsDisposed(I){if(I&&I!==l.None)try{I[T]=!0}catch{}}markAsSingleton(I){}})}function v(T){return y?.trackDisposable(T),T}function h(T){y?.markAsDisposed(T)}function w(T,I){y?.setParent(T,I)}function a(T,I){if(y)for(const q of T)y.setParent(q,I)}function f(T){return y?.markAsSingleton(T),T}function m(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function $(T){if(R.Iterable.is(T)){const I=[];for(const q of T)if(q)try{q.dispose()}catch(Y){I.push(Y)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function b(T){for(const I of T)m(I)&&I.dispose();return[]}function d(...T){const I=p(()=>$(T));return a(T,I),I}function p(T){const I=v({dispose:(0,k.$gb)(()=>{h(I),T()})});return I}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return w(I,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),w(I,null))}}e.$Wc=t;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,v(this),w(this.q,this)}dispose(){h(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Xc=l;class i{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&w(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&w(I,null),I}}e.$Yc=i;class g{constructor(I){this.a=new i,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=g;class s{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=s;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(I){let q=I;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,h(this))},this}}e.$2c=c;class u{constructor(){this.a=new Map}acquire(I,...q){let Y=this.a.get(I);Y||(Y={counter:0,object:this.b(I,...q)},this.a.set(I,Y));const{object:Q}=Y,re=(0,k.$gb)(()=>{--Y.counter===0&&(this.c(I,Y.object),this.a.delete(I))});return Y.counter++,{object:Q,dispose:re}}}e.$3c=u;class S{constructor(I){this.a=I}async acquire(I,...q){const Y=this.a.acquire(I,...q);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(Q){throw Y.dispose(),Q}}}e.$4c=S;class P{constructor(I){this.object=I}dispose(){}}e.$5c=P;function C(T){const I=new t;try{T(I)}finally{I.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,q,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(I)?.dispose(),this.a.set(I,q)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}deleteAndLeak(I){const q=this.a.get(I);return this.a.delete(I),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=L}),function(se,e){typeof define=="function"&&define.amd?define(ve[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(M,G){for(var X=0;X<G.length;X++){var F=G[X];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(M,F.key,F)}}function n(M,G,X){return G&&e(M.prototype,G),X&&e(M,X),Object.defineProperty(M,"prototype",{writable:!1}),M}function r(M,G){if(M){if(typeof M=="string")return E(M,G);var X=Object.prototype.toString.call(M).slice(8,-1);if(X==="Object"&&M.constructor&&(X=M.constructor.name),X==="Map"||X==="Set")return Array.from(M);if(X==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(X))return E(M,G)}}function E(M,G){(G==null||G>M.length)&&(G=M.length);for(var X=0,F=new Array(G);X<G;X++)F[X]=M[X];return F}function k(M,G){var X=typeof Symbol<"u"&&M[Symbol.iterator]||M["@@iterator"];if(X)return(X=X.call(M)).next.bind(X);if(Array.isArray(M)||(X=r(M))||G&&M&&typeof M.length=="number"){X&&(M=X);var F=0;return function(){return F>=M.length?{done:!0}:{done:!1,value:M[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=R();function A(M){se.defaults=M}var y=/[&<>"']/,o=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(G){return h[G]};function a(M,G){if(G){if(y.test(M))return M.replace(o,w)}else if(D.test(M))return M.replace(v,w);return M}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(M){return M.replace(f,function(G,X){return X=X.toLowerCase(),X==="colon"?":":X.charAt(0)==="#"?X.charAt(1)==="x"?String.fromCharCode(parseInt(X.substring(2),16)):String.fromCharCode(+X.substring(1)):""})}var $=/(^|[^\[])\^/g;function b(M,G){M=typeof M=="string"?M:M.source,G=G||"";var X={replace:function(W,oe){return oe=oe.source||oe,oe=oe.replace($,"$1"),M=M.replace(W,oe),X},getRegex:function(){return new RegExp(M,G)}};return X}var d=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(M,G,X){if(M){var F;try{F=decodeURIComponent(m(X)).replace(d,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}G&&!p.test(X)&&(X=c(G,X));try{X=encodeURI(X).replace(/%25/g,"%")}catch{return null}return X}var l={},i=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(M,G){l[" "+M]||(i.test(M)?l[" "+M]=M+"/":l[" "+M]=C(M,"/",!0)),M=l[" "+M];var X=M.indexOf(":")===-1;return G.substring(0,2)==="//"?X?G:M.replace(g,"$1")+G:G.charAt(0)==="/"?X?G:M.replace(s,"$1")+G:M+G}var u={exec:function(){}};function S(M){for(var G=1,X,F;G<arguments.length;G++){X=arguments[G];for(F in X)Object.prototype.hasOwnProperty.call(X,F)&&(M[F]=X[F])}return M}function P(M,G){var X=M.replace(/\|/g,function(oe,he,ke){for(var Ne=!1,me=he;--me>=0&&ke[me]==="\\";)Ne=!Ne;return Ne?"|":" |"}),F=X.split(/ \|/),W=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>G)F.splice(G);else for(;F.length<G;)F.push("");for(;W<F.length;W++)F[W]=F[W].trim().replace(/\\\|/g,"|");return F}function C(M,G,X){var F=M.length;if(F===0)return"";for(var W=0;W<F;){var oe=M.charAt(F-W-1);if(oe===G&&!X)W++;else if(oe!==G&&X)W++;else break}return M.slice(0,F-W)}function L(M,G){if(M.indexOf(G[1])===-1)return-1;for(var X=M.length,F=0,W=0;W<X;W++)if(M[W]==="\\")W++;else if(M[W]===G[0])F++;else if(M[W]===G[1]&&(F--,F<0))return W;return-1}function T(M){M&&M.sanitize&&!M.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(M,G){if(G<1)return"";for(var X="";G>1;)G&1&&(X+=M),G>>=1,M+=M;return X+M}function q(M,G,X,F){var W=G.href,oe=G.title?a(G.title):null,he=M[1].replace(/\\([\[\]])/g,"$1");if(M[0].charAt(0)!=="!"){F.state.inLink=!0;var ke={type:"link",raw:X,href:W,title:oe,text:he,tokens:F.inlineTokens(he)};return F.state.inLink=!1,ke}return{type:"image",raw:X,href:W,title:oe,text:a(he)}}function Y(M,G){var X=M.match(/^(\s+)(?:```)/);if(X===null)return G;var F=X[1];return G.split(`
`).map(function(W){var oe=W.match(/^\s+/);if(oe===null)return W;var he=oe[0];return he.length>=F.length?W.slice(F.length):W}).join(`
`)}var Q=function(){function M(X){this.options=X||se.defaults}var G=M.prototype;return G.space=function(F){var W=this.rules.block.newline.exec(F);if(W&&W[0].length>0)return{type:"space",raw:W[0]}},G.code=function(F){var W=this.rules.block.code.exec(F);if(W){var oe=W[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:W[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:C(oe,`
`)}}},G.fences=function(F){var W=this.rules.block.fences.exec(F);if(W){var oe=W[0],he=Y(oe,W[3]||"");return{type:"code",raw:oe,lang:W[2]?W[2].trim():W[2],text:he}}},G.heading=function(F){var W=this.rules.block.heading.exec(F);if(W){var oe=W[2].trim();if(/#$/.test(oe)){var he=C(oe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(oe=he.trim())}return{type:"heading",raw:W[0],depth:W[1].length,text:oe,tokens:this.lexer.inline(oe)}}},G.hr=function(F){var W=this.rules.block.hr.exec(F);if(W)return{type:"hr",raw:W[0]}},G.blockquote=function(F){var W=this.rules.block.blockquote.exec(F);if(W){var oe=W[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:W[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},G.list=function(F){var W=this.rules.block.list.exec(F);if(W){var oe,he,ke,Ne,me,$e,Pe,Oe,fe,De,Re,ze,We=W[1].trim(),Qe=We.length>1,Ke={type:"list",raw:"",ordered:Qe,start:Qe?+We.slice(0,-1):"",loose:!1,items:[]};We=Qe?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=Qe?We:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(ze=!1,!(!(W=Ge.exec(F))||this.rules.block.hr.test(F)));){if(oe=W[0],F=F.substring(oe.length),Oe=W[2].split(`
`,1)[0],fe=F.split(`
`,1)[0],this.options.pedantic?(Ne=2,Re=Oe.trimLeft()):(Ne=W[2].search(/[^ ]/),Ne=Ne>4?1:Ne,Re=Oe.slice(Ne),Ne+=W[1].length),$e=!1,!Oe&&/^ *$/.test(fe)&&(oe+=fe+`
`,F=F.substring(fe.length+1),ze=!0),!ze)for(var xe=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}#");F&&(De=F.split(`
`,1)[0],Oe=De,this.options.pedantic&&(Oe=Oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(Oe)||rt.test(Oe)||xe.test(Oe)||st.test(F)));){if(Oe.search(/[^ ]/)>=Ne||!Oe.trim())Re+=`
`+Oe.slice(Ne);else if(!$e)Re+=`
`+Oe;else break;!$e&&!Oe.trim()&&($e=!0),oe+=De+`
`,F=F.substring(De.length+1)}Ke.loose||(Pe?Ke.loose=!0:/\n *\n *$/.test(oe)&&(Pe=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(Re),he&&(ke=he[0]!=="[ ] ",Re=Re.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:oe,task:!!he,checked:ke,loose:!1,text:Re}),Ke.raw+=oe}Ke.items[Ke.items.length-1].raw=oe.trimRight(),Ke.items[Ke.items.length-1].text=Re.trimRight(),Ke.raw=Ke.raw.trimRight();var nt=Ke.items.length;for(me=0;me<nt;me++){this.lexer.state.top=!1,Ke.items[me].tokens=this.lexer.blockTokens(Ke.items[me].text,[]);var tt=Ke.items[me].tokens.filter(function(Ze){return Ze.type==="space"}),et=tt.every(function(Ze){for(var be=Ze.raw.split(""),Le=0,Fe=k(be),ye;!(ye=Fe()).done;){var Ce=ye.value;if(Ce===`
`&&(Le+=1),Le>1)return!0}return!1});!Ke.loose&&tt.length&&et&&(Ke.loose=!0,Ke.items[me].loose=!0)}return Ke}},G.html=function(F){var W=this.rules.block.html.exec(F);if(W){var oe={type:"html",raw:W[0],pre:!this.options.sanitizer&&(W[1]==="pre"||W[1]==="script"||W[1]==="style"),text:W[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(W[0]):a(W[0]);oe.type="paragraph",oe.text=he,oe.tokens=this.lexer.inline(he)}return oe}},G.def=function(F){var W=this.rules.block.def.exec(F);if(W){W[3]&&(W[3]=W[3].substring(1,W[3].length-1));var oe=W[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:W[0],href:W[2],title:W[3]}}},G.table=function(F){var W=this.rules.block.table.exec(F);if(W){var oe={type:"table",header:P(W[1]).map(function(Pe){return{text:Pe}}),align:W[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:W[3]&&W[3].trim()?W[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=W[0];var he=oe.align.length,ke,Ne,me,$e;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(oe.align[ke])?oe.align[ke]="right":/^ *:-+: *$/.test(oe.align[ke])?oe.align[ke]="center":/^ *:-+ *$/.test(oe.align[ke])?oe.align[ke]="left":oe.align[ke]=null;for(he=oe.rows.length,ke=0;ke<he;ke++)oe.rows[ke]=P(oe.rows[ke],oe.header.length).map(function(Pe){return{text:Pe}});for(he=oe.header.length,Ne=0;Ne<he;Ne++)oe.header[Ne].tokens=this.lexer.inline(oe.header[Ne].text);for(he=oe.rows.length,Ne=0;Ne<he;Ne++)for($e=oe.rows[Ne],me=0;me<$e.length;me++)$e[me].tokens=this.lexer.inline($e[me].text);return oe}}},G.lheading=function(F){var W=this.rules.block.lheading.exec(F);if(W)return{type:"heading",raw:W[0],depth:W[2].charAt(0)==="="?1:2,text:W[1],tokens:this.lexer.inline(W[1])}},G.paragraph=function(F){var W=this.rules.block.paragraph.exec(F);if(W){var oe=W[1].charAt(W[1].length-1)===`
`?W[1].slice(0,-1):W[1];return{type:"paragraph",raw:W[0],text:oe,tokens:this.lexer.inline(oe)}}},G.text=function(F){var W=this.rules.block.text.exec(F);if(W)return{type:"text",raw:W[0],text:W[0],tokens:this.lexer.inline(W[0])}},G.escape=function(F){var W=this.rules.inline.escape.exec(F);if(W)return{type:"escape",raw:W[0],text:a(W[1])}},G.tag=function(F){var W=this.rules.inline.tag.exec(F);if(W)return!this.lexer.state.inLink&&/^<a /i.test(W[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(W[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(W[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(W[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:W[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):a(W[0]):W[0]}},G.link=function(F){var W=this.rules.inline.link.exec(F);if(W){var oe=W[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var he=C(oe.slice(0,-1),"\\");if((oe.length-he.length)%2===0)return}else{var ke=L(W[2],"()");if(ke>-1){var Ne=W[0].indexOf("!")===0?5:4,me=Ne+W[1].length+ke;W[2]=W[2].substring(0,ke),W[0]=W[0].substring(0,me).trim(),W[3]=""}}var $e=W[2],Pe="";if(this.options.pedantic){var Oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec($e);Oe&&($e=Oe[1],Pe=Oe[3])}else Pe=W[3]?W[3].slice(1,-1):"";return $e=$e.trim(),/^</.test($e)&&(this.options.pedantic&&!/>$/.test(oe)?$e=$e.slice(1):$e=$e.slice(1,-1)),q(W,{href:$e&&$e.replace(this.rules.inline._escapes,"$1"),title:Pe&&Pe.replace(this.rules.inline._escapes,"$1")},W[0],this.lexer)}},G.reflink=function(F,W){var oe;if((oe=this.rules.inline.reflink.exec(F))||(oe=this.rules.inline.nolink.exec(F))){var he=(oe[2]||oe[1]).replace(/\s+/g," ");if(he=W[he.toLowerCase()],!he||!he.href){var ke=oe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return q(oe,he,oe[0],this.lexer)}},G.emStrong=function(F,W,oe){oe===void 0&&(oe="");var he=this.rules.inline.emStrong.lDelim.exec(F);if(he&&!(he[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Ne=he[0].length-1,me,$e,Pe=Ne,Oe=0,fe=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,W=W.slice(-1*F.length+Ne);(he=fe.exec(W))!=null;)if(me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!me){if($e=me.length,he[3]||he[4]){Pe+=$e;continue}else if((he[5]||he[6])&&Ne%3&&!((Ne+$e)%3)){Oe+=$e;continue}if(Pe-=$e,!(Pe>0)){if($e=Math.min($e,$e+Pe+Oe),Math.min(Ne,$e)%2){var De=F.slice(1,Ne+he.index+$e);return{type:"em",raw:F.slice(0,Ne+he.index+$e+1),text:De,tokens:this.lexer.inlineTokens(De)}}var Re=F.slice(2,Ne+he.index+$e-1);return{type:"strong",raw:F.slice(0,Ne+he.index+$e+1),text:Re,tokens:this.lexer.inlineTokens(Re)}}}}}},G.codespan=function(F){var W=this.rules.inline.code.exec(F);if(W){var oe=W[2].replace(/\n/g," "),he=/[^ ]/.test(oe),ke=/^ /.test(oe)&&/ $/.test(oe);return he&&ke&&(oe=oe.substring(1,oe.length-1)),oe=a(oe,!0),{type:"codespan",raw:W[0],text:oe}}},G.br=function(F){var W=this.rules.inline.br.exec(F);if(W)return{type:"br",raw:W[0]}},G.del=function(F){var W=this.rules.inline.del.exec(F);if(W)return{type:"del",raw:W[0],text:W[2],tokens:this.lexer.inlineTokens(W[2])}},G.autolink=function(F,W){var oe=this.rules.inline.autolink.exec(F);if(oe){var he,ke;return oe[2]==="@"?(he=a(this.options.mangle?W(oe[1]):oe[1]),ke="mailto:"+he):(he=a(oe[1]),ke=he),{type:"link",raw:oe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},G.url=function(F,W){var oe;if(oe=this.rules.inline.url.exec(F)){var he,ke;if(oe[2]==="@")he=a(this.options.mangle?W(oe[0]):oe[0]),ke="mailto:"+he;else{var Ne;do Ne=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Ne!==oe[0]);he=a(oe[0]),oe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:oe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},G.inlineText=function(F,W){var oe=this.rules.inline.text.exec(F);if(oe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):a(oe[0]):oe[0]:he=a(this.options.smartypants?W(oe[0]):oe[0]),{type:"text",raw:oe[0],text:he}}},M}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=b(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=b(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=b(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=b(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=b(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=b(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=S({},re),re.gfm=S({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=b(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=b(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=S({},re.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:b(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=b(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=b(re._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=b(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=b(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=b(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=b(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=b(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=b(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=b(te.reflink).replace("label",te._label).replace("ref",re._label).getRegex(),te.nolink=b(te.nolink).replace("ref",re._label).getRegex(),te.reflinkSearch=b(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=S({},te),te.pedantic=S({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=S({},te.normal,{escape:b(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=b(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=S({},te.gfm,{br:b(te.br).replace("{2,}","*").getRegex(),text:b(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(M){return M.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function de(M){var G="",X,F,W=M.length;for(X=0;X<W;X++)F=M.charCodeAt(X),Math.random()>.5&&(F="x"+F.toString(16)),G+="&#"+F+";";return G}var J=function(){function M(X){this.tokens=[],this.tokens.links=Object.create(null),this.options=X||se.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:re.normal,inline:te.normal};this.options.pedantic?(F.block=re.pedantic,F.inline=te.pedantic):this.options.gfm&&(F.block=re.gfm,this.options.breaks?F.inline=te.breaks:F.inline=te.gfm),this.tokenizer.rules=F}M.lex=function(F,W){var oe=new M(W);return oe.lex(F)},M.lexInline=function(F,W){var oe=new M(W);return oe.inlineTokens(F)};var G=M.prototype;return G.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var W;W=this.inlineQueue.shift();)this.inlineTokens(W.src,W.tokens);return this.tokens},G.blockTokens=function(F,W){var oe=this;W===void 0&&(W=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(Pe,Oe,fe){return Oe+"    ".repeat(fe.length)});for(var he,ke,Ne,me;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Pe){return(he=Pe.call({lexer:oe},F,W))?(F=F.substring(he.raw.length),W.push(he),!0):!1}))){if(he=this.tokenizer.space(F)){F=F.substring(he.raw.length),he.raw.length===1&&W.length>0?W[W.length-1].raw+=`
`:W.push(he);continue}if(he=this.tokenizer.code(F)){F=F.substring(he.raw.length),ke=W[W.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):W.push(he);continue}if(he=this.tokenizer.fences(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.heading(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.hr(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.blockquote(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.list(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.html(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.def(F)){F=F.substring(he.raw.length),ke=W[W.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.lheading(F)){F=F.substring(he.raw.length),W.push(he);continue}if(Ne=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Pe=1/0,Oe=F.slice(1),fe=void 0;oe.options.extensions.startBlock.forEach(function(De){fe=De.call({lexer:this},Oe),typeof fe=="number"&&fe>=0&&(Pe=Math.min(Pe,fe))}),Pe<1/0&&Pe>=0&&(Ne=F.substring(0,Pe+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Ne))){ke=W[W.length-1],me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):W.push(he),me=Ne.length!==F.length,F=F.substring(he.raw.length);continue}if(he=this.tokenizer.text(F)){F=F.substring(he.raw.length),ke=W[W.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):W.push(he);continue}if(F){var $e="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return this.state.top=!0,W},G.inline=function(F,W){return W===void 0&&(W=[]),this.inlineQueue.push({src:F,tokens:W}),W},G.inlineTokens=function(F,W){var oe=this;W===void 0&&(W=[]);var he,ke,Ne,me=F,$e,Pe,Oe;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;($e=this.tokenizer.rules.inline.reflinkSearch.exec(me))!=null;)fe.includes($e[0].slice($e[0].lastIndexOf("[")+1,-1))&&(me=me.slice(0,$e.index)+"["+I("a",$e[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;($e=this.tokenizer.rules.inline.blockSkip.exec(me))!=null;)me=me.slice(0,$e.index)+"["+I("a",$e[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;($e=this.tokenizer.rules.inline.escapedEmSt.exec(me))!=null;)me=me.slice(0,$e.index)+"++"+me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Pe||(Oe=""),Pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Re){return(he=Re.call({lexer:oe},F,W))?(F=F.substring(he.raw.length),W.push(he),!0):!1}))){if(he=this.tokenizer.escape(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.tag(F)){F=F.substring(he.raw.length),ke=W[W.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):W.push(he);continue}if(he=this.tokenizer.link(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(he.raw.length),ke=W[W.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):W.push(he);continue}if(he=this.tokenizer.emStrong(F,me,Oe)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.codespan(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.br(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.del(F)){F=F.substring(he.raw.length),W.push(he);continue}if(he=this.tokenizer.autolink(F,de)){F=F.substring(he.raw.length),W.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(F,de))){F=F.substring(he.raw.length),W.push(he);continue}if(Ne=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Re=1/0,ze=F.slice(1),We=void 0;oe.options.extensions.startInline.forEach(function(Qe){We=Qe.call({lexer:this},ze),typeof We=="number"&&We>=0&&(Re=Math.min(Re,We))}),Re<1/0&&Re>=0&&(Ne=F.substring(0,Re+1))}(),he=this.tokenizer.inlineText(Ne,_)){F=F.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Oe=he.raw.slice(-1)),Pe=!0,ke=W[W.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):W.push(he);continue}if(F){var De="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return W},n(M,null,[{key:"rules",get:function(){return{block:re,inline:te}}}]),M}(),ae=function(){function M(X){this.options=X||se.defaults}var G=M.prototype;return G.code=function(F,W,oe){var he=(W||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(F,he);ke!=null&&ke!==F&&(oe=!0,F=ke)}return F=F.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+a(he,!0)+'">'+(oe?F:a(F,!0))+`</code></pre>
`:"<pre><code>"+(oe?F:a(F,!0))+`</code></pre>
`},G.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},G.html=function(F){return F},G.heading=function(F,W,oe,he){if(this.options.headerIds){var ke=this.options.headerPrefix+he.slug(oe);return"<h"+W+' id="'+ke+'">'+F+"</h"+W+`>
`}return"<h"+W+">"+F+"</h"+W+`>
`},G.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},G.list=function(F,W,oe){var he=W?"ol":"ul",ke=W&&oe!==1?' start="'+oe+'"':"";return"<"+he+ke+`>
`+F+"</"+he+`>
`},G.listitem=function(F){return"<li>"+F+`</li>
`},G.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},G.paragraph=function(F){return"<p>"+F+`</p>
`},G.table=function(F,W){return W&&(W="<tbody>"+W+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+W+`</table>
`},G.tablerow=function(F){return`<tr>
`+F+`</tr>
`},G.tablecell=function(F,W){var oe=W.header?"th":"td",he=W.align?"<"+oe+' align="'+W.align+'">':"<"+oe+">";return he+F+("</"+oe+`>
`)},G.strong=function(F){return"<strong>"+F+"</strong>"},G.em=function(F){return"<em>"+F+"</em>"},G.codespan=function(F){return"<code>"+F+"</code>"},G.br=function(){return this.options.xhtml?"<br/>":"<br>"},G.del=function(F){return"<del>"+F+"</del>"},G.link=function(F,W,oe){if(F=t(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var he='<a href="'+a(F)+'"';return W&&(he+=' title="'+W+'"'),he+=">"+oe+"</a>",he},G.image=function(F,W,oe){if(F=t(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var he='<img src="'+F+'" alt="'+oe+'"';return W&&(he+=' title="'+W+'"'),he+=this.options.xhtml?"/>":">",he},G.text=function(F){return F},M}(),z=function(){function M(){}var G=M.prototype;return G.strong=function(F){return F},G.em=function(F){return F},G.codespan=function(F){return F},G.del=function(F){return F},G.html=function(F){return F},G.text=function(F){return F},G.link=function(F,W,oe){return""+oe},G.image=function(F,W,oe){return""+oe},G.br=function(){return""},M}(),B=function(){function M(){this.seen={}}var G=M.prototype;return G.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},G.getNextSafeSlug=function(F,W){var oe=F,he=0;if(this.seen.hasOwnProperty(oe)){he=this.seen[F];do he++,oe=F+"-"+he;while(this.seen.hasOwnProperty(oe))}return W||(this.seen[F]=he,this.seen[oe]=0),oe},G.slug=function(F,W){W===void 0&&(W={});var oe=this.serialize(F);return this.getNextSafeSlug(oe,W.dryrun)},M}(),ie=function(){function M(X){this.options=X||se.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new z,this.slugger=new B}M.parse=function(F,W){var oe=new M(W);return oe.parse(F)},M.parseInline=function(F,W){var oe=new M(W);return oe.parseInline(F)};var G=M.prototype;return G.parse=function(F,W){W===void 0&&(W=!0);var oe="",he,ke,Ne,me,$e,Pe,Oe,fe,De,Re,ze,We,Qe,Ke,Ge,xe,st,lt,rt,nt=F.length;for(he=0;he<nt;he++){if(Re=F[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(rt=this.options.extensions.renderers[Re.type].call({parser:this},Re),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Re.type))){oe+=rt||"";continue}switch(Re.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Re.tokens),Re.depth,m(this.parseInline(Re.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Re.text,Re.lang,Re.escaped);continue}case"table":{for(fe="",Oe="",me=Re.header.length,ke=0;ke<me;ke++)Oe+=this.renderer.tablecell(this.parseInline(Re.header[ke].tokens),{header:!0,align:Re.align[ke]});for(fe+=this.renderer.tablerow(Oe),De="",me=Re.rows.length,ke=0;ke<me;ke++){for(Pe=Re.rows[ke],Oe="",$e=Pe.length,Ne=0;Ne<$e;Ne++)Oe+=this.renderer.tablecell(this.parseInline(Pe[Ne].tokens),{header:!1,align:Re.align[Ne]});De+=this.renderer.tablerow(Oe)}oe+=this.renderer.table(fe,De);continue}case"blockquote":{De=this.parse(Re.tokens),oe+=this.renderer.blockquote(De);continue}case"list":{for(ze=Re.ordered,We=Re.start,Qe=Re.loose,me=Re.items.length,De="",ke=0;ke<me;ke++)Ge=Re.items[ke],xe=Ge.checked,st=Ge.task,Ke="",Ge.task&&(lt=this.renderer.checkbox(xe),Qe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=lt+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=lt+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:lt}):Ke+=lt),Ke+=this.parse(Ge.tokens,Qe),De+=this.renderer.listitem(Ke,st,xe);oe+=this.renderer.list(De,ze,We);continue}case"html":{oe+=this.renderer.html(Re.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Re.tokens));continue}case"text":{for(De=Re.tokens?this.parseInline(Re.tokens):Re.text;he+1<nt&&F[he+1].type==="text";)Re=F[++he],De+=`
`+(Re.tokens?this.parseInline(Re.tokens):Re.text);oe+=W?this.renderer.paragraph(De):De;continue}default:{var tt='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}}return oe},G.parseInline=function(F,W){W=W||this.renderer;var oe="",he,ke,Ne,me=F.length;for(he=0;he<me;he++){if(ke=F[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ne=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){oe+=Ne||"";continue}switch(ke.type){case"escape":{oe+=W.text(ke.text);break}case"html":{oe+=W.html(ke.text);break}case"link":{oe+=W.link(ke.href,ke.title,this.parseInline(ke.tokens,W));break}case"image":{oe+=W.image(ke.href,ke.title,ke.text);break}case"strong":{oe+=W.strong(this.parseInline(ke.tokens,W));break}case"em":{oe+=W.em(this.parseInline(ke.tokens,W));break}case"codespan":{oe+=W.codespan(ke.text);break}case"br":{oe+=W.br();break}case"del":{oe+=W.del(this.parseInline(ke.tokens,W));break}case"text":{oe+=W.text(ke.text);break}default:{var $e='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return oe},M}();function le(M,G,X){if(typeof M>"u"||M===null)throw new Error("marked(): input parameter is undefined or null");if(typeof M!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(M)+", string expected");if(typeof G=="function"&&(X=G,G=null),G=S({},le.defaults,G||{}),T(G),X){var F=G.highlight,W;try{W=J.lex(M,G)}catch(me){return X(me)}var oe=function($e){var Pe;if(!$e)try{G.walkTokens&&le.walkTokens(W,G.walkTokens),Pe=ie.parse(W,G)}catch(Oe){$e=Oe}return G.highlight=F,$e?X($e):X(null,Pe)};if(!F||F.length<3||(delete G.highlight,!W.length))return oe();var he=0;le.walkTokens(W,function(me){me.type==="code"&&(he++,setTimeout(function(){F(me.text,me.lang,function($e,Pe){if($e)return oe($e);Pe!=null&&Pe!==me.text&&(me.text=Pe,me.escaped=!0),he--,he===0&&oe()})},0))}),he===0&&oe();return}function ke(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+a(me.message+"",!0)+"</pre>";throw me}try{var Ne=J.lex(M,G);if(G.walkTokens){if(G.async)return Promise.all(le.walkTokens(Ne,G.walkTokens)).then(function(){return ie.parse(Ne,G)}).catch(ke);le.walkTokens(Ne,G.walkTokens)}return ie.parse(Ne,G)}catch(me){ke(me)}}le.options=le.setOptions=function(M){return S(le.defaults,M),A(le.defaults),le},le.getDefaults=R,le.defaults=se.defaults,le.use=function(){for(var M=arguments.length,G=new Array(M),X=0;X<M;X++)G[X]=arguments[X];var F=S.apply(void 0,[{}].concat(G)),W=le.defaults.extensions||{renderers:{},childTokens:{}},oe;G.forEach(function(he){if(he.extensions&&(oe=!0,he.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var me=W.renderers?W.renderers[Ne.name]:null;me?W.renderers[Ne.name]=function(){for(var $e=arguments.length,Pe=new Array($e),Oe=0;Oe<$e;Oe++)Pe[Oe]=arguments[Oe];var fe=Ne.renderer.apply(this,Pe);return fe===!1&&(fe=me.apply(this,Pe)),fe}:W.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");W[Ne.level]?W[Ne.level].unshift(Ne.tokenizer):W[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?W.startBlock?W.startBlock.push(Ne.start):W.startBlock=[Ne.start]:Ne.level==="inline"&&(W.startInline?W.startInline.push(Ne.start):W.startInline=[Ne.start]))}Ne.childTokens&&(W.childTokens[Ne.name]=Ne.childTokens)})),he.renderer&&function(){var Ne=le.defaults.renderer||new ae,me=function(Oe){var fe=Ne[Oe];Ne[Oe]=function(){for(var De=arguments.length,Re=new Array(De),ze=0;ze<De;ze++)Re[ze]=arguments[ze];var We=he.renderer[Oe].apply(Ne,Re);return We===!1&&(We=fe.apply(Ne,Re)),We}};for(var $e in he.renderer)me($e);F.renderer=Ne}(),he.tokenizer&&function(){var Ne=le.defaults.tokenizer||new Q,me=function(Oe){var fe=Ne[Oe];Ne[Oe]=function(){for(var De=arguments.length,Re=new Array(De),ze=0;ze<De;ze++)Re[ze]=arguments[ze];var We=he.tokenizer[Oe].apply(Ne,Re);return We===!1&&(We=fe.apply(Ne,Re)),We}};for(var $e in he.tokenizer)me($e);F.tokenizer=Ne}(),he.walkTokens){var ke=le.defaults.walkTokens;F.walkTokens=function(Ne){var me=[];return me.push(he.walkTokens.call(this,Ne)),ke&&(me=me.concat(ke.call(this,Ne))),me}}oe&&(F.extensions=W),le.setOptions(F)})},le.walkTokens=function(M,G){for(var X=[],F=function(){var ke=oe.value;switch(X=X.concat(G.call(le,ke)),ke.type){case"table":{for(var Ne=k(ke.header),me;!(me=Ne()).done;){var $e=me.value;X=X.concat(le.walkTokens($e.tokens,G))}for(var Pe=k(ke.rows),Oe;!(Oe=Pe()).done;)for(var fe=Oe.value,De=k(fe),Re;!(Re=De()).done;){var ze=Re.value;X=X.concat(le.walkTokens(ze.tokens,G))}break}case"list":{X=X.concat(le.walkTokens(ke.items,G));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[ke.type]?le.defaults.extensions.childTokens[ke.type].forEach(function(We){X=X.concat(le.walkTokens(ke[We],G))}):ke.tokens&&(X=X.concat(le.walkTokens(ke.tokens,G)))}},W=k(M),oe;!(oe=W()).done;)F();return X},le.parseInline=function(M,G){if(typeof M>"u"||M===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof M!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(M)+", string expected");G=S({},le.defaults,G||{}),T(G);try{var X=J.lexInline(M,G);return G.walkTokens&&le.walkTokens(X,G.walkTokens),ie.parseInline(X,G)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+a(F.message+"",!0)+"</pre>";throw F}},le.Parser=ie,le.parser=ie.parse,le.Renderer=ae,le.TextRenderer=z,le.Lexer=J,le.lexer=J.lex,le.Tokenizer=Q,le.Slugger=B,le.parse=le;var pe=le.options,H=le.setOptions,ce=le.use,x=le.walkTokens,U=le.parseInline,O=le,Z=ie.parse,V=J.lex;se.Lexer=J,se.Parser=ie,se.Renderer=ae,se.Slugger=B,se.TextRenderer=z,se.Tokenizer=Q,se.getDefaults=R,se.lexer=V,se.marked=le,se.options=pe,se.parse=O,se.parseInline=U,se.parser=Z,se.setOptions=H,se.use=ce,se.walkTokens=x,Object.defineProperty(se,"__esModule",{value:!0})}),define(ve[81],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ve[162],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=n;function n(f){const m=k(f);if(m&&m.length>0)return new Uint32Array(m)}let r=0;const E=new Uint32Array(10);function k(f){if(r=0,R(f,v,y.InitialConsonant),r>0||(R(f,h,y.Vowel),r>0)||(R(f,w,y.FinalConsonant),r>0)||(R(f,a,y.CompatibilityJamo),r))return E.subarray(0,r);if(f>=44032&&f<=55203){const m=f-44032,$=m%588,b=Math.floor(m/588),d=Math.floor($/28),p=$%28-1;if(b<v.length?R(b,v,0):y.InitialConsonant+b-y.CompatibilityJamo<a.length&&R(y.InitialConsonant+b,a,y.CompatibilityJamo),d<h.length?R(d,h,0):y.Vowel+d-y.CompatibilityJamo<a.length&&R(y.Vowel+d-y.CompatibilityJamo,a,y.CompatibilityJamo),p>=0&&(p<w.length?R(p,w,0):y.FinalConsonant+p-y.CompatibilityJamo<a.length&&R(y.FinalConsonant+p-y.CompatibilityJamo,a,y.CompatibilityJamo)),r>0)return E.subarray(0,r)}}function R(f,m,$){f>=$&&f<$+m.length&&A(m[f-$])}function A(f){f!==o.NUL&&(E[r++]=f&255,f>>8&&(E[r++]=f>>8&255),f>>16&&(E[r++]=f>>16&255))}var y;(function(f){f[f.InitialConsonant=4352]="InitialConsonant",f[f.Vowel=4449]="Vowel",f[f.FinalConsonant=4520]="FinalConsonant",f[f.CompatibilityJamo=12593]="CompatibilityJamo"})(y||(y={}));var o;(function(f){f[f.NUL=0]="NUL",f[f.A=65]="A",f[f.B=66]="B",f[f.C=67]="C",f[f.D=68]="D",f[f.E=69]="E",f[f.F=70]="F",f[f.G=71]="G",f[f.H=72]="H",f[f.I=73]="I",f[f.J=74]="J",f[f.K=75]="K",f[f.L=76]="L",f[f.M=77]="M",f[f.N=78]="N",f[f.O=79]="O",f[f.P=80]="P",f[f.Q=81]="Q",f[f.R=82]="R",f[f.S=83]="S",f[f.T=84]="T",f[f.U=85]="U",f[f.V=86]="V",f[f.W=87]="W",f[f.X=88]="X",f[f.Y=89]="Y",f[f.Z=90]="Z",f[f.a=97]="a",f[f.b=98]="b",f[f.c=99]="c",f[f.d=100]="d",f[f.e=101]="e",f[f.f=102]="f",f[f.g=103]="g",f[f.h=104]="h",f[f.i=105]="i",f[f.j=106]="j",f[f.k=107]="k",f[f.l=108]="l",f[f.m=109]="m",f[f.n=110]="n",f[f.o=111]="o",f[f.p=112]="p",f[f.q=113]="q",f[f.r=114]="r",f[f.s=115]="s",f[f.t=116]="t",f[f.u=117]="u",f[f.v=118]="v",f[f.w=119]="w",f[f.x=120]="x",f[f.y=121]="y",f[f.z=122]="z"})(o||(o={}));var D;(function(f){f[f.fa=24934]="fa",f[f.fg=26470]="fg",f[f.fq=29030]="fq",f[f.fr=29286]="fr",f[f.ft=29798]="ft",f[f.fv=30310]="fv",f[f.fx=30822]="fx",f[f.hk=27496]="hk",f[f.hl=27752]="hl",f[f.ho=28520]="ho",f[f.ml=27757]="ml",f[f.nj=27246]="nj",f[f.nl=27758]="nl",f[f.np=28782]="np",f[f.qt=29809]="qt",f[f.rt=29810]="rt",f[f.sg=26483]="sg",f[f.sw=30579]="sw"})(D||(D={}));const v=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),h=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l]),w=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,D.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.E,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,o.Q,D.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l])}),define(ve[107],Se([1,0,26]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=E,e.$om=R;const r=new n.$Gc(1e4);function E(o){return y(o,"NFC",r)}const k=new n.$Gc(1e4);function R(o){return y(o,"NFD",k)}const A=/[^\u0000-\u0080]/;function y(o,D,v){if(!o)return o;const h=v.get(o);if(h)return h;let w;return A.test(o)?w=o.normalize(D):w=o,v.set(o,w),w}e.$pm=function(){const o=/[\u0300-\u036f]/g;return function(D){return R(D).replace(o,"")}}()}),define(ve[163],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=n,e.rot=r,e.$Qm=A;function n(y,o,D){return Math.min(Math.max(y,o),D)}function r(y,o){return(o+y%o)%o}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=E;class k{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=k;class R{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const D=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=R;function A(y,o,D,v,h,w,a,f){const m=a-D,$=f-v,b=h-D,d=w-v,p=y-D,t=o-v,l=m*m+$*$,i=m*b+$*d,g=m*p+$*t,s=b*b+d*d,c=b*p+d*t,u=1/(l*s-i*i),S=(s*g-i*c)*u,P=(l*c-i*g)*u;return S>=0&&P>=0&&S+P<1}}),define(ve[164],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=k,e.$fd=h;class n{constructor(a,f,m){this.owner=a,this.debugNameSource=f,this.referenceFn=m}getDebugName(a){return k(a,this)}}e.$dd=n;const r=new Map,E=new WeakMap;function k(w,a){const f=E.get(w);if(f)return f;const m=R(w,a);if(m){let $=r.get(m)??0;$++,r.set(m,$);const b=$===1?m:`${m}#${$}`;return E.set(w,b),b}}function R(w,a){const f=E.get(w);if(f)return f;const m=a.owner?D(a.owner)+".":"";let $;const b=a.debugNameSource;if(b!==void 0)if(typeof b=="function"){if($=b(),$!==void 0)return m+$}else return m+b;const d=a.referenceFn;if(d!==void 0&&($=h(d),$!==void 0))return m+$;if(a.owner!==void 0){const p=A(a.owner,w);if(p!==void 0)return m+p}}function A(w,a){for(const f in w)if(w[f]===a)return f}const y=new Map,o=new WeakMap;function D(w){const a=o.get(w);if(a)return a;const f=v(w);let m=y.get(f)??0;m++,y.set(f,m);const $=m===1?f:`${f}#${m}`;return o.set(w,$),$}function v(w){const a=w.constructor;return a?a.name:"Object"}function h(w){const a=w.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(m?m[1]:void 0)?.trim()}}),define(ve[165],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=r,e.$Nd=E;let n;function r(f){n=f}function E(){return n}class k{constructor(){this.a=0,this.d=new WeakMap}b(m){return R([A(w("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[A(" "),o(D(m.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),o(D(m.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),o(D(m.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([y("observable value changed"),o(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return o(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(b,d)=>(this.d.get(m).add(b),$.apply(m,[b,d]))}handleDerivedRecomputed(m,$){const b=this.d.get(m);console.log(...this.b([y("derived recomputed"),o(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(b),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),b.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([y("observable from event triggered"),o(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(b,d)=>(this.d.get(m).add(b),$.apply(m,[b,d]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([y("autorun"),o(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([y("transaction"),o($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=k;function R(f){const m=new Array,$=[];let b="";function d(t){if("length"in t)for(const l of t)l&&d(l);else"text"in t?(b+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}d(f);const p=[b,...m];return p.push(...$),p}function A(f){return o(f,{color:"black"})}function y(f){return o(a(`${f}: `,10),{color:"black",bold:!0})}function o(f,m={color:"black"}){function $(d){return Object.entries(d).reduce((p,[t,l])=>`${p}${t}:${l};`,"")}const b={color:m.color};return m.strikeThrough&&(b["text-decoration"]="line-through"),m.bold&&(b["font-weight"]="bold"),{text:f,style:$(b)}}function D(f,m){switch(typeof f){case"number":return""+f;case"string":return f.length+2<=m?`"${f}"`:`"${f.substr(0,m-7)}"+...`;case"boolean":return f?"true":"false";case"undefined":return"undefined";case"object":return f===null?"null":Array.isArray(f)?v(f,m):h(f,m);case"symbol":return f.toString();case"function":return`[[Function${f.name?" "+f.name:""}]]`;default:return""+f}}function v(f,m){let $="[ ",b=!0;for(const d of f){if(b||($+=", "),$.length-5>m){$+="...";break}b=!1,$+=`${D(d,m-$.length)}`}return $+=" ]",$}function h(f,m){let $="{ ",b=!0;for(const[d,p]of Object.entries(f)){if(b||($+=", "),$.length-5>m){$+="...";break}b=!1,$+=`${d}: ${D(p,m-$.length)}`}return $+=" }",$}function w(f,m){let $="";for(let b=1;b<=m;b++)$+=f;return $}function a(f,m){for(;f.length<m;)f+=" ";return f}}),define(ve[166],Se([1,0,158,164,165]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=R,e.$Yd=y,e.$Zd=D,e.$3d=w,e.$4d=f,e.$5d=m,e.$6d=$,e.$8d=d,e.$0d=t;let k;function R(i){k=i}let A;function y(i){A=i}let o;function D(i){o=i}class v{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,s){const c=s===void 0?void 0:g,u=s===void 0?g:s;return o({owner:c,debugName:()=>{const S=(0,r.$fd)(u);if(S!==void 0)return S;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(u.toString());if(C)return`${this.debugName}.${C[2]}`;if(!c)return`${this.debugName} (mapped)`},debugReferenceFn:u},S=>u(this.read(S),S))}recomputeInitiallyAndOnChange(g,s){return g.add(k(this,s)),this}keepObserved(g){return g.add(A(this)),this}get a(){return this.get()}}e.$1d=v;class h extends v{constructor(){super(...arguments),this.b=new Set}addObserver(g){const s=this.b.size;this.b.add(g),s===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=h;function w(i,g){const s=new b(i,g);try{i(s)}finally{s.finish()}}let a;function f(i){if(a)i(a);else{const g=new b(i,void 0);a=g;try{i(g)}finally{g.finish(),a=void 0}}}async function m(i,g){const s=new b(i,g);try{await i(s)}finally{s.finish()}}function $(i,g,s){i?g(i):w(g,s)}class b{constructor(g,s){this._fn=g,this.b=s,this.a=[],(0,E.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,r.$fd)(this._fn)}updateObserver(g,s){this.a.push({observer:g,observable:s}),g.beginUpdate(s)}finish(){const g=this.a;for(let s=0;s<g.length;s++){const{observer:c,observable:u}=g[s];c.endUpdate(u)}this.a=null,(0,E.$Nd)()?.handleEndTransaction()}}e.$7d=b;function d(i,g){let s;return typeof i=="string"?s=new r.$dd(void 0,i,void 0):s=new r.$dd(i,void 0,void 0),new p(s,g,n.$9c)}class p extends h{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,s,c){super(),this.e=g,this.g=c,this.d=s}get(){return this.d}set(g,s,c){if(c===void 0&&this.g(this.d,g))return;let u;s||(s=u=new b(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(g),(0,E.$Nd)()?.handleObservableChanged(this,{oldValue:S,newValue:g,change:c,didChange:!0,hadValue:!0});for(const P of this.b)s.updateObserver(P,this),P.handleChange(this,c)}finally{u&&u.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$9d=p;function t(i,g){let s;return typeof i=="string"?s=new r.$dd(void 0,i,void 0):s=new r.$dd(i,void 0,void 0),new l(s,g,n.$9c)}class l extends p{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$$d=l}),function(){function se(E){const k=[];typeof E=="number"&&k.push("code/timeOrigin",E);function R(y){k.push(y,Date.now())}function A(){const y=[];for(let o=0;o<k.length;o+=2)y.push({name:k[o],startTime:k[o+1]});return y}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(E+R.startTime)});return k}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function n(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(ve[167],Se([1,0,40]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=void 0;const r=Symbol("unset");class E{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||n.Iterable.empty()}insert(y,o,D){this.d(y,v=>v._value=o,D)}mutate(y,o){this.d(y,D=>D._value=o(D._value===r?void 0:D._value))}mutatePath(y,o){this.d(y,()=>{},D=>o(D))}delete(y){const o=this.c(y);if(!o)return;let D=o.length-1;const v=o[D].node._value;if(v!==r){for(this.b--,o[D].node._value=r;D>0;D--){const{node:h,part:w}=o[D];if(h.children?.size||h._value!==r)break;o[D-1].node.children.delete(w)}return v}}*deleteRecursive(y){const o=this.c(y);if(!o)return;const D=o[o.length-1].node;for(let v=o.length-1;v>0;v--){const h=o[v-1];if(h.node.children.delete(o[v].part),h.node.children.size>0||h.node._value!==r)break}for(const v of k(D))v._value!==r&&(this.b--,yield v._value)}find(y){let o=this.a;for(const D of y){const v=o.children?.get(D);if(!v)return;o=v}return o._value===r?void 0:o._value}hasKeyOrParent(y){let o=this.a;for(const D of y){const v=o.children?.get(D);if(!v)return!1;if(v._value!==r)return!0;o=v}return!1}hasKeyOrChildren(y){let o=this.a;for(const D of y){const v=o.children?.get(D);if(!v)return!1;o=v}return!0}hasKey(y){let o=this.a;for(const D of y){const v=o.children?.get(D);if(!v)return!1;o=v}return o._value!==r}c(y){const o=[{part:"",node:this.a}];let D=0;for(const v of y){const h=o[D].node.children?.get(v);if(!h)return;o.push({part:v,node:h}),D++}return o}d(y,o,D){let v=this.a;for(const a of y){if(v.children)if(v.children.has(a))v=v.children.get(a);else{const f=new R;v.children.set(a,f),v=f}else{const f=new R;v.children=new Map([[a,f]]),v=f}D?.(v)}const h=v._value===r?0:1;o(v);const w=v._value===r?0:1;this.b+=w-h}*values(){for(const{_value:y}of k(this.a))y!==r&&(yield y)}}e.$SI=E;function*k(A){const y=[A];for(;y.length>0;){const o=y.pop();if(yield o,o.children)for(const D of o.children.values())y.push(D)}}class R{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(y){this._value=y===void 0?r:y}}}),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:se)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function n(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return se[r].call(E.exports,E,E.exports,n),E.l=!0,E.exports}return n.m=se,n.c=e,n.d=function(r,E,k){n.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:k})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,E){if(1&E&&(r=n(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var k=Object.create(null);if(n.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var R in r)n.d(k,R,function(A){return r[A]}.bind(null,R));return k},n.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(E,"a",E),E},n.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},n.p="",n(n.s=0)}([function(se,e,n){(function(r){var E;e=se.exports=ce,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],o=0,D=o++;y[D]="0|[1-9]\\d*";var v=o++;y[v]="[0-9]+";var h=o++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=o++;y[w]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var a=o++;y[a]="("+y[v]+")\\.("+y[v]+")\\.("+y[v]+")";var f=o++;y[f]="(?:"+y[D]+"|"+y[h]+")";var m=o++;y[m]="(?:"+y[v]+"|"+y[h]+")";var $=o++;y[$]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var b=o++;y[b]="(?:-?("+y[m]+"(?:\\."+y[m]+")*))";var d=o++;y[d]="[0-9A-Za-z-]+";var p=o++;y[p]="(?:\\+("+y[d]+"(?:\\."+y[d]+")*))";var t=o++,l="v?"+y[w]+y[$]+"?"+y[p]+"?";y[t]="^"+l+"$";var i="[v=\\s]*"+y[a]+y[b]+"?"+y[p]+"?",g=o++;y[g]="^"+i+"$";var s=o++;y[s]="((?:<|>)?=?)";var c=o++;y[c]=y[v]+"|x|X|\\*";var u=o++;y[u]=y[D]+"|x|X|\\*";var S=o++;y[S]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[$]+")?"+y[p]+"?)?)?";var P=o++;y[P]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[b]+")?"+y[p]+"?)?)?";var C=o++;y[C]="^"+y[s]+"\\s*"+y[S]+"$";var L=o++;y[L]="^"+y[s]+"\\s*"+y[P]+"$";var T=o++;y[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=o++;y[I]="(?:~>?)";var q=o++;y[q]="(\\s*)"+y[I]+"\\s+",A[q]=new RegExp(y[q],"g");var Y=o++;y[Y]="^"+y[I]+y[S]+"$";var Q=o++;y[Q]="^"+y[I]+y[P]+"$";var re=o++;y[re]="(?:\\^)";var te=o++;y[te]="(\\s*)"+y[re]+"\\s+",A[te]=new RegExp(y[te],"g");var _=o++;y[_]="^"+y[re]+y[S]+"$";var de=o++;y[de]="^"+y[re]+y[P]+"$";var J=o++;y[J]="^"+y[s]+"\\s*("+i+")$|^$";var ae=o++;y[ae]="^"+y[s]+"\\s*("+l+")$|^$";var z=o++;y[z]="(\\s*)"+y[s]+"\\s*("+i+"|"+y[S]+")",A[z]=new RegExp(y[z],"g");var B=o++;y[B]="^\\s*("+y[S]+")\\s+-\\s+("+y[S]+")\\s*$";var ie=o++;y[ie]="^\\s*("+y[P]+")\\s+-\\s+("+y[P]+")\\s*$";var le=o++;y[le]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)E(pe,y[pe]),A[pe]||(A[pe]=new RegExp(y[pe]));function H(fe,De){if(fe instanceof ce)return fe;if(typeof fe!="string"||fe.length>k||!(De?A[g]:A[t]).test(fe))return null;try{return new ce(fe,De)}catch{return null}}function ce(fe,De){if(fe instanceof ce){if(fe.loose===De)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ce))return new ce(fe,De);E("SemVer",fe,De),this.loose=De;var Re=fe.trim().match(De?A[g]:A[t]);if(!Re)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+Re[1],this.minor=+Re[2],this.patch=+Re[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Re[4]?this.prerelease=Re[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<R)return We}return ze}):this.prerelease=[],this.build=Re[5]?Re[5].split("."):[],this.format()}e.parse=H,e.valid=function(fe,De){var Re=H(fe,De);return Re?Re.version:null},e.clean=function(fe,De){var Re=H(fe.trim().replace(/^[=v]+/,""),De);return Re?Re.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(fe){return E("SemVer.compare",this.version,this.loose,fe),fe instanceof ce||(fe=new ce(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},ce.prototype.compareMain=function(fe){return fe instanceof ce||(fe=new ce(fe,this.loose)),U(this.major,fe.major)||U(this.minor,fe.minor)||U(this.patch,fe.patch)},ce.prototype.comparePre=function(fe){if(fe instanceof ce||(fe=new ce(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var De=0;do{var Re=this.prerelease[De],ze=fe.prerelease[De];if(E("prerelease compare",De,Re,ze),Re===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Re===void 0)return-1;if(Re!==ze)return U(Re,ze)}while(++De)},ce.prototype.inc=function(fe,De){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Re=this.prerelease.length;--Re>=0;)typeof this.prerelease[Re]=="number"&&(this.prerelease[Re]++,Re=-2);Re===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,De,Re,ze){typeof Re=="string"&&(ze=Re,Re=void 0);try{return new ce(fe,Re).inc(De,ze).version}catch{return null}},e.diff=function(fe,De){if(M(fe,De))return null;var Re=H(fe),ze=H(De);if(Re.prerelease.length||ze.prerelease.length){for(var We in Re)if((We==="major"||We==="minor"||We==="patch")&&Re[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in Re)if((We==="major"||We==="minor"||We==="patch")&&Re[We]!==ze[We])return We},e.compareIdentifiers=U;var x=/^[0-9]+$/;function U(fe,De){var Re=x.test(fe),ze=x.test(De);return Re&&ze&&(fe=+fe,De=+De),Re&&!ze?-1:ze&&!Re?1:fe<De?-1:fe>De?1:0}function O(fe,De,Re){return new ce(fe,Re).compare(new ce(De,Re))}function Z(fe,De,Re){return O(fe,De,Re)>0}function V(fe,De,Re){return O(fe,De,Re)<0}function M(fe,De,Re){return O(fe,De,Re)===0}function G(fe,De,Re){return O(fe,De,Re)!==0}function X(fe,De,Re){return O(fe,De,Re)>=0}function F(fe,De,Re){return O(fe,De,Re)<=0}function W(fe,De,Re,ze){var We;switch(De){case"===":typeof fe=="object"&&(fe=fe.version),typeof Re=="object"&&(Re=Re.version),We=fe===Re;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof Re=="object"&&(Re=Re.version),We=fe!==Re;break;case"":case"=":case"==":We=M(fe,Re,ze);break;case"!=":We=G(fe,Re,ze);break;case">":We=Z(fe,Re,ze);break;case">=":We=X(fe,Re,ze);break;case"<":We=V(fe,Re,ze);break;case"<=":We=F(fe,Re,ze);break;default:throw new TypeError("Invalid operator: "+De)}return We}function oe(fe,De){if(fe instanceof oe){if(fe.loose===De)return fe;fe=fe.value}if(!(this instanceof oe))return new oe(fe,De);E("comparator",fe,De),this.loose=De,this.parse(fe),this.semver===he?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(fe,De){return U(De,fe)},e.major=function(fe,De){return new ce(fe,De).major},e.minor=function(fe,De){return new ce(fe,De).minor},e.patch=function(fe,De){return new ce(fe,De).patch},e.compare=O,e.compareLoose=function(fe,De){return O(fe,De,!0)},e.rcompare=function(fe,De,Re){return O(De,fe,Re)},e.sort=function(fe,De){return fe.sort(function(Re,ze){return e.compare(Re,ze,De)})},e.rsort=function(fe,De){return fe.sort(function(Re,ze){return e.rcompare(Re,ze,De)})},e.gt=Z,e.lt=V,e.eq=M,e.neq=G,e.gte=X,e.lte=F,e.cmp=W,e.Comparator=oe;var he={};function ke(fe,De){if(fe instanceof ke)return fe.loose===De?fe:new ke(fe.raw,De);if(fe instanceof oe)return new ke(fe.value,De);if(!(this instanceof ke))return new ke(fe,De);if(this.loose=De,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(Re){return this.parseRange(Re.trim())},this).filter(function(Re){return Re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function Ne(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function me(fe,De,Re,ze,We,Qe,Ke,Ge,xe,st,lt,rt,nt){return((De=Ne(Re)?"":Ne(ze)?">="+Re+".0.0":Ne(We)?">="+Re+"."+ze+".0":">="+De)+" "+(Ge=Ne(xe)?"":Ne(st)?"<"+(+xe+1)+".0.0":Ne(lt)?"<"+xe+"."+(+st+1)+".0":rt?"<="+xe+"."+st+"."+lt+"-"+rt:"<="+Ge)).trim()}function $e(fe,De){for(var Re=0;Re<fe.length;Re++)if(!fe[Re].test(De))return!1;if(De.prerelease.length){for(Re=0;Re<fe.length;Re++)if(E(fe[Re].semver),fe[Re].semver!==he&&fe[Re].semver.prerelease.length>0){var ze=fe[Re].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function Pe(fe,De,Re){try{De=new ke(De,Re)}catch{return!1}return De.test(fe)}function Oe(fe,De,Re,ze){var We,Qe,Ke,Ge,xe;switch(fe=new ce(fe,ze),De=new ke(De,ze),Re){case">":We=Z,Qe=F,Ke=V,Ge=">",xe=">=";break;case"<":We=V,Qe=X,Ke=Z,Ge="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(fe,De,ze))return!1;for(var st=0;st<De.set.length;++st){var lt=De.set[st],rt=null,nt=null;if(lt.forEach(function(tt){tt.semver===he&&(tt=new oe(">=0.0.0")),rt=rt||tt,nt=nt||tt,We(tt.semver,rt.semver,ze)?rt=tt:Ke(tt.semver,nt.semver,ze)&&(nt=tt)}),rt.operator===Ge||rt.operator===xe||(!nt.operator||nt.operator===Ge)&&Qe(fe,nt.semver)||nt.operator===xe&&Ke(fe,nt.semver))return!1}return!0}oe.prototype.parse=function(fe){var De=this.loose?A[J]:A[ae],Re=fe.match(De);if(!Re)throw new TypeError("Invalid comparator: "+fe);this.operator=Re[1],this.operator==="="&&(this.operator=""),Re[2]?this.semver=new ce(Re[2],this.loose):this.semver=he},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(fe){return E("Comparator.test",fe,this.loose),this.semver===he||(typeof fe=="string"&&(fe=new ce(fe,this.loose)),W(fe,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(fe,De){if(!(fe instanceof oe))throw new TypeError("a Comparator is required");var Re;if(this.operator==="")return Re=new ke(fe.value,De),Pe(this.value,Re,De);if(fe.operator==="")return Re=new ke(this.value,De),Pe(fe.semver,Re,De);var ze=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),Qe=this.semver.version===fe.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),Ge=W(this.semver,"<",fe.semver,De)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),xe=W(this.semver,">",fe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return ze||We||Qe&&Ke||Ge||xe},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(fe){var De=this.loose;fe=fe.trim(),E("range",fe,De);var Re=De?A[ie]:A[B];fe=fe.replace(Re,me),E("hyphen replace",fe),fe=fe.replace(A[z],"$1$2$3"),E("comparator trim",fe,A[z]),fe=(fe=(fe=fe.replace(A[q],"$1~")).replace(A[te],"$1^")).split(/\s+/).join(" ");var ze=De?A[J]:A[ae],We=fe.split(" ").map(function(Qe){return function(Ke,Ge){return E("comp",Ke),Ke=function(xe,st){return xe.trim().split(/\s+/).map(function(lt){return function(rt,nt){E("caret",rt,nt);var tt=nt?A[de]:A[_];return rt.replace(tt,function(et,Ze,be,Le,Fe){var ye;return E("caret",rt,et,Ze,be,Le,Fe),Ne(Ze)?ye="":Ne(be)?ye=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":Ne(Le)?ye=Ze==="0"?">="+Ze+"."+be+".0 <"+Ze+"."+(+be+1)+".0":">="+Ze+"."+be+".0 <"+(+Ze+1)+".0.0":Fe?(E("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),ye=Ze==="0"?be==="0"?">="+Ze+"."+be+"."+Le+Fe+" <"+Ze+"."+be+"."+(+Le+1):">="+Ze+"."+be+"."+Le+Fe+" <"+Ze+"."+(+be+1)+".0":">="+Ze+"."+be+"."+Le+Fe+" <"+(+Ze+1)+".0.0"):(E("no pr"),ye=Ze==="0"?be==="0"?">="+Ze+"."+be+"."+Le+" <"+Ze+"."+be+"."+(+Le+1):">="+Ze+"."+be+"."+Le+" <"+Ze+"."+(+be+1)+".0":">="+Ze+"."+be+"."+Le+" <"+(+Ze+1)+".0.0"),E("caret return",ye),ye})}(lt,st)}).join(" ")}(Ke,Ge),E("caret",Ke),Ke=function(xe,st){return xe.trim().split(/\s+/).map(function(lt){return function(rt,nt){var tt=nt?A[Q]:A[Y];return rt.replace(tt,function(et,Ze,be,Le,Fe){var ye;return E("tilde",rt,et,Ze,be,Le,Fe),Ne(Ze)?ye="":Ne(be)?ye=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":Ne(Le)?ye=">="+Ze+"."+be+".0 <"+Ze+"."+(+be+1)+".0":Fe?(E("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),ye=">="+Ze+"."+be+"."+Le+Fe+" <"+Ze+"."+(+be+1)+".0"):ye=">="+Ze+"."+be+"."+Le+" <"+Ze+"."+(+be+1)+".0",E("tilde return",ye),ye})}(lt,st)}).join(" ")}(Ke,Ge),E("tildes",Ke),Ke=function(xe,st){return E("replaceXRanges",xe,st),xe.split(/\s+/).map(function(lt){return function(rt,nt){rt=rt.trim();var tt=nt?A[L]:A[C];return rt.replace(tt,function(et,Ze,be,Le,Fe,ye){E("xRange",rt,et,Ze,be,Le,Fe,ye);var Ce=Ne(be),ne=Ce||Ne(Le),ee=ne||Ne(Fe);return Ze==="="&&ee&&(Ze=""),Ce?et=Ze===">"||Ze==="<"?"<0.0.0":"*":Ze&&ee?(ne&&(Le=0),ee&&(Fe=0),Ze===">"?(Ze=">=",ne?(be=+be+1,Le=0,Fe=0):ee&&(Le=+Le+1,Fe=0)):Ze==="<="&&(Ze="<",ne?be=+be+1:Le=+Le+1),et=Ze+be+"."+Le+"."+Fe):ne?et=">="+be+".0.0 <"+(+be+1)+".0.0":ee&&(et=">="+be+"."+Le+".0 <"+be+"."+(+Le+1)+".0"),E("xRange return",et),et})}(lt,st)}).join(" ")}(Ke,Ge),E("xrange",Ke),Ke=function(xe,st){return E("replaceStars",xe,st),xe.trim().replace(A[le],"")}(Ke,Ge),E("stars",Ke),Ke}(Qe,De)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(Qe){return!!Qe.match(ze)})),We=We.map(function(Qe){return new oe(Qe,De)})},ke.prototype.intersects=function(fe,De){if(!(fe instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(Re){return Re.every(function(ze){return fe.set.some(function(We){return We.every(function(Qe){return ze.intersects(Qe,De)})})})})},e.toComparators=function(fe,De){return new ke(fe,De).set.map(function(Re){return Re.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new ce(fe,this.loose));for(var De=0;De<this.set.length;De++)if($e(this.set[De],fe))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(fe,De,Re){var ze=null,We=null;try{var Qe=new ke(De,Re)}catch{return null}return fe.forEach(function(Ke){Qe.test(Ke)&&(ze&&We.compare(Ke)!==-1||(We=new ce(ze=Ke,Re)))}),ze},e.minSatisfying=function(fe,De,Re){var ze=null,We=null;try{var Qe=new ke(De,Re)}catch{return null}return fe.forEach(function(Ke){Qe.test(Ke)&&(ze&&We.compare(Ke)!==1||(We=new ce(ze=Ke,Re)))}),ze},e.validRange=function(fe,De){try{return new ke(fe,De).range||"*"}catch{return null}},e.ltr=function(fe,De,Re){return Oe(fe,De,"<",Re)},e.gtr=function(fe,De,Re){return Oe(fe,De,">",Re)},e.outside=Oe,e.prerelease=function(fe,De){var Re=H(fe,De);return Re&&Re.prerelease.length?Re.prerelease:null},e.intersects=function(fe,De,Re){return fe=new ke(fe,Re),De=new ke(De,Re),fe.intersects(De)},e.coerce=function(fe){if(fe instanceof ce)return fe;if(typeof fe!="string")return null;var De=fe.match(A[T]);return De==null?null:H((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,n(1))},function(se,e){var n,r,E=se.exports={};function k(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(m){if(n===setTimeout)return setTimeout(m,0);if((n===k||!n)&&setTimeout)return n=setTimeout,setTimeout(m,0);try{return n(m,0)}catch{try{return n.call(null,m,0)}catch{return n.call(this,m,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:k}catch{n=k}try{r=typeof clearTimeout=="function"?clearTimeout:R}catch{r=R}})();var y,o=[],D=!1,v=-1;function h(){D&&y&&(D=!1,y.length?o=y.concat(o):v=-1,o.length&&w())}function w(){if(!D){var m=A(h);D=!0;for(var $=o.length;$;){for(y=o,o=[];++v<$;)y&&y[v].run();v=-1,$=o.length}y=null,D=!1,function(b){if(r===clearTimeout)return clearTimeout(b);if((r===R||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(b);try{r(b)}catch{try{return r.call(null,b)}catch{return r.call(this,b)}}}(m)}}function a(m,$){this.fun=m,this.array=$}function f(){}E.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)$[b-1]=arguments[b];o.push(new a(m,$)),o.length!==1||D||A(w)},a.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=f,E.addListener=f,E.once=f,E.off=f,E.removeListener=f,E.removeAllListeners=f,E.emit=f,E.prependListener=f,E.prependOnceListener=f,E.listeners=function(m){return[]},E.binding=function(m){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(m){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(ve[168],Se([1,0]),function(se,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class r{constructor(A,y,o){this.level=A,this.key=y,this.value=o,this.forward=[]}}const E=void 0;class k{constructor(A,y=2**16){this.comparator=A,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(A){return!!k.g(this,A,this.comparator)}get(A){return k.g(this,A,this.comparator)?.value}set(A,y){return k.h(this,A,y,this.comparator)&&(this.f+=1),this}delete(A){const y=k.k(this,A,this.comparator);return y&&(this.f-=1),y}forEach(A,y){let o=this.e.forward[0];for(;o;)A.call(y,o.value,o.key,this),o=o.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",y=this.e.forward[0];for(;y;)A+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return A}static g(A,y,o){let D=A.e;for(let v=A.d-1;v>=0;v--)for(;D.forward[v]&&o(D.forward[v].key,y)<0;)D=D.forward[v];if(D=D.forward[0],D&&o(D.key,y)===0)return D}static h(A,y,o,D){const v=[];let h=A.e;for(let w=A.d-1;w>=0;w--){for(;h.forward[w]&&D(h.forward[w].key,y)<0;)h=h.forward[w];v[w]=h}if(h=h.forward[0],h&&D(h.key,y)===0)return h.value=o,!1;{const w=k.j(A);if(w>A.d){for(let a=A.d;a<w;a++)v[a]=A.e;A.d=w}h=new r(w,y,o);for(let a=0;a<w;a++)h.forward[a]=v[a].forward[a],v[a].forward[a]=h;return!0}}static j(A,y=.5){let o=1;for(;Math.random()<y&&o<A.c;)o+=1;return o}static k(A,y,o){const D=[];let v=A.e;for(let h=A.d-1;h>=0;h--){for(;v.forward[h]&&o(v.forward[h].key,y)<0;)v=v.forward[h];D[h]=v}if(v=v.forward[0],!v||o(v.key,y)!==0)return!1;for(let h=0;h<A.d&&D[h].forward[h]===v;h++)D[h].forward[h]=v.forward[h];for(;A.d>0&&A.e.forward[A.d-1]===E;)A.d-=1;return!0}}e.$Rs=k}),define(ve[48],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(k){return new r(k)}constructor(k){this.c=n&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=r}),define(ve[6],Se([1,0,10,79,2,80,48]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=w;const A=!1,y=!1,o=!1;var D;(function(Q){Q.None=()=>E.$Xc.None;function re(me){if(o){const{onDidAddListener:$e}=me,Pe=f.create();let Oe=0;me.onDidAddListener=()=>{++Oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),$e?.()}}}function te(me,$e){return H(me,()=>{},0,void 0,!0,void 0,$e)}Q.defer=te;function _(me){return($e,Pe=null,Oe)=>{let fe=!1,De;return De=me(Re=>{if(!fe)return De?De.dispose():fe=!0,$e.call(Pe,Re)},null,Oe),fe&&De.dispose(),De}}Q.once=_;function de(me,$e,Pe){return le((Oe,fe=null,De)=>me(Re=>Oe.call(fe,$e(Re)),null,De),Pe)}Q.map=de;function J(me,$e,Pe){return le((Oe,fe=null,De)=>me(Re=>{$e(Re),Oe.call(fe,Re)},null,De),Pe)}Q.forEach=J;function ae(me,$e,Pe){return le((Oe,fe=null,De)=>me(Re=>$e(Re)&&Oe.call(fe,Re),null,De),Pe)}Q.filter=ae;function z(me){return me}Q.signal=z;function B(...me){return($e,Pe=null,Oe)=>{const fe=(0,E.$Uc)(...me.map(De=>De(Re=>$e.call(Pe,Re))));return pe(fe,Oe)}}Q.any=B;function ie(me,$e,Pe,Oe){let fe=Pe;return de(me,De=>(fe=$e(fe,De),fe),Oe)}Q.reduce=ie;function le(me,$e){let Pe;const Oe={onWillAddFirstListener(){Pe=me(fe.fire,fe)},onDidRemoveLastListener(){Pe?.dispose()}};$e||re(Oe);const fe=new i(Oe);return $e?.add(fe),fe.event}function pe(me,$e){return $e instanceof Array?$e.push(me):$e&&$e.add(me),me}function H(me,$e,Pe=100,Oe=!1,fe=!1,De,Re){let ze,We,Qe,Ke=0,Ge;const xe={leakWarningThreshold:De,onWillAddFirstListener(){ze=me(lt=>{Ke++,We=$e(We,lt),Oe&&!Qe&&(st.fire(We),We=void 0),Ge=()=>{const rt=We;We=void 0,Qe=void 0,(!Oe||Ke>1)&&st.fire(rt),Ke=0},typeof Pe=="number"?(clearTimeout(Qe),Qe=setTimeout(Ge,Pe)):Qe===void 0&&(Qe=0,queueMicrotask(Ge))})},onWillRemoveListener(){fe&&Ke>0&&Ge?.()},onDidRemoveLastListener(){Ge=void 0,ze.dispose()}};Re||re(xe);const st=new i(xe);return Re?.add(st),st.event}Q.debounce=H;function ce(me,$e=0,Pe){return Q.debounce(me,(Oe,fe)=>Oe?(Oe.push(fe),Oe):[fe],$e,void 0,!0,void 0,Pe)}Q.accumulate=ce;function x(me,$e=(Oe,fe)=>Oe===fe,Pe){let Oe=!0,fe;return ae(me,De=>{const Re=Oe||!$e(De,fe);return Oe=!1,fe=De,Re},Pe)}Q.latch=x;function U(me,$e,Pe){return[Q.filter(me,$e,Pe),Q.filter(me,Oe=>!$e(Oe),Pe)]}Q.split=U;function O(me,$e=!1,Pe=[],Oe){let fe=Pe.slice(),De=me(We=>{fe?fe.push(We):ze.fire(We)});Oe&&Oe.add(De);const Re=()=>{fe?.forEach(We=>ze.fire(We)),fe=null},ze=new i({onWillAddFirstListener(){De||(De=me(We=>ze.fire(We)),Oe&&Oe.add(De))},onDidAddFirstListener(){fe&&($e?setTimeout(Re):Re())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Oe&&Oe.add(ze),ze.event}Q.buffer=O;function Z(me,$e){return(Oe,fe,De)=>{const Re=$e(new M);return me(function(ze){const We=Re.evaluate(ze);We!==V&&Oe.call(fe,We)},void 0,De)}}Q.chain=Z;const V=Symbol("HaltChainable");class M{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(Pe=>($e(Pe),Pe)),this}filter($e){return this.f.push(Pe=>$e(Pe)?Pe:V),this}reduce($e,Pe){let Oe=Pe;return this.f.push(fe=>(Oe=$e(Oe,fe),Oe)),this}latch($e=(Pe,Oe)=>Pe===Oe){let Pe=!0,Oe;return this.f.push(fe=>{const De=Pe||!$e(fe,Oe);return Pe=!1,Oe=fe,De?fe:V}),this}evaluate($e){for(const Pe of this.f)if($e=Pe($e),$e===V)break;return $e}}function G(me,$e,Pe=Oe=>Oe){const Oe=(...ze)=>Re.fire(Pe(...ze)),fe=()=>me.on($e,Oe),De=()=>me.removeListener($e,Oe),Re=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:De});return Re.event}Q.fromNodeEventEmitter=G;function X(me,$e,Pe=Oe=>Oe){const Oe=(...ze)=>Re.fire(Pe(...ze)),fe=()=>me.addEventListener($e,Oe),De=()=>me.removeEventListener($e,Oe),Re=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:De});return Re.event}Q.fromDOMEventEmitter=X;function F(me){return new Promise($e=>_(me)($e))}Q.toPromise=F;function W(me){const $e=new i;return me.then(Pe=>{$e.fire(Pe)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}Q.fromPromise=W;function oe(me,$e,Pe){return $e(Pe),me(Oe=>$e(Oe))}Q.runAndSubscribe=oe;class he{constructor($e,Pe){this._observable=$e,this.f=0,this.g=!1;const Oe={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};Pe||re(Oe),this.emitter=new i(Oe),Pe&&Pe.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,Pe){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ke(me,$e){return new he(me,$e).emitter.event}Q.fromObservable=ke;function Ne(me){return($e,Pe,Oe)=>{let fe=0,De=!1;const Re={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(me.reportChanges(),De&&(De=!1,$e.call(Pe)))},handlePossibleChange(){},handleChange(){De=!0}};me.addObserver(Re),me.reportChanges();const ze={dispose(){me.removeObserver(Re)}};return Oe instanceof E.$Wc?Oe.add(ze):Array.isArray(Oe)&&Oe.push(ze),ze}}Q.fromObservableLight=Ne})(D||(e.Event=D={}));class v{static{this.all=new Set}static{this.f=0}constructor(re){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${re}_${v.f++}`,v.all.add(this)}start(re){this.g=new R.$he,this.listenerCount=re}stop(){if(this.g){const re=this.g.elapsed();this.durations.push(re),this.elapsedOverall+=re,this.invocationCount+=1,this.g=void 0}}}e.$je=v;let h=-1;function w(Q){const re=h;return h=Q,{dispose(){h=re}}}class a{static{this.f=1}constructor(re,te,_=(a.f++).toString(16).padStart(3,"0")){this.j=re,this.threshold=te,this.name=_,this.h=0}dispose(){this.g?.clear()}check(re,te){const _=this.threshold;if(_<=0||te<_)return;this.g||(this.g=new Map);const de=this.g.get(re.value)||0;if(this.g.set(re.value,de+1),this.h-=1,this.h<=0){this.h=_*.5;const[J,ae]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${te} listeners already. MOST frequent listener (${ae}):`;console.warn(z),console.warn(J);const B=new m(z,J);this.j(B)}return()=>{const J=this.g.get(re.value)||0;this.g.set(re.value,J-1)}}getMostFrequentStack(){if(!this.g)return;let re,te=0;for(const[_,de]of this.g)(!re||te<de)&&(re=[_,de],te=de);return re}}class f{static create(){const re=new Error;return new f(re.stack??"")}constructor(re){this.value=re}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(re,te){super(re),this.name="ListenerLeakError",this.stack=te}}e.$le=m;class $ extends Error{constructor(re,te){super(re),this.name="ListenerRefusalError",this.stack=te}}e.$me=$;let b=0;class d{constructor(re){this.value=re,this.id=b++}}const p=2,t=(Q,re)=>{if(Q instanceof d)re(Q);else for(let te=0;te<Q.length;te++){const _=Q[te];_&&re(_)}};let l;if(A){const Q=[];setInterval(()=>{Q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Q.join(`
`)),Q.length=0)},3e3),l=new FinalizationRegistry(re=>{typeof re=="string"&&Q.push(re)})}class i{constructor(re){this.z=0,this.f=re,this.g=h>0||this.f?.leakWarningThreshold?new a(re?.onListenerError??n.$3,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const re=this.u;queueMicrotask(()=>{t(re,te=>te.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(re,te,_)=>{if(this.g&&this.z>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(B);const ie=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new $(`${B}. HINT: Stack shows most frequent listener (${ie[1]}-times)`,ie[0]);return(this.f?.onListenerError||n.$3)(le),E.$Xc.None}if(this.m)return E.$Xc.None;te&&(re=re.bind(te));const de=new d(re);let J,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(de.stack=f.create(),J=this.g.check(de.stack,this.z+1)),y&&(de.stack=ae??f.create()),this.u?this.u instanceof d?(this.w??=new s,this.u=[this.u,de]):this.u.push(de):(this.f?.onWillAddFirstListener?.(this),this.u=de,this.f?.onDidAddFirstListener?.(this)),this.z++;const z=(0,E.$Vc)(()=>{l?.unregister(z),J?.(),this.A(de)});if(_ instanceof E.$Wc?_.add(z):Array.isArray(_)&&_.push(z),l){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ie=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);l.register(z,ie?.[2]??B,z)}return z},this.q}A(re){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const te=this.u,_=te.indexOf(re);if(_===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,te[_]=void 0;const de=this.w.current===this;if(this.z*p<=te.length){let J=0;for(let ae=0;ae<te.length;ae++)te[ae]?te[J++]=te[ae]:de&&(this.w.end--,J<this.w.i&&this.w.i--);te.length=J}}B(re,te){if(!re)return;const _=this.f?.onListenerError||n.$3;if(!_){re.value(te);return}try{re.value(te)}catch(de){_(de)}}C(re){const te=re.current.u;for(;re.i<re.end;)this.B(te[re.i++],re.value);re.reset()}fire(re){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof d)this.B(this.u,re);else{const te=this.w;te.enqueue(this,re,this.u.length),this.C(te)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const g=()=>new s;e.$oe=g;class s{constructor(){this.i=-1,this.end=0}enqueue(re,te,_){this.i=0,this.end=_,this.current=re,this.value=te}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends i{async fireAsync(re,te,_){if(this.u)for(this.h||(this.h=new k.$8c),t(this.u,de=>this.h.push([de.value,re]));this.h.size>0&&!te.isCancellationRequested;){const[de,J]=this.h.shift(),ae=[],z={...J,token:te,waitUntil:B=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");_&&(B=_(B,de)),ae.push(B)}};try{de(z)}catch(B){(0,n.$3)(B);continue}Object.freeze(ae),await Promise.allSettled(ae).then(B=>{for(const ie of B)ie.status==="rejected"&&(0,n.$3)(ie.reason)})}}}e.$pe=c;class u extends i{get isPaused(){return this.h!==0}constructor(re){super(re),this.h=0,this.s=new k.$8c,this.t=re?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const re=Array.from(this.s);this.s.clear(),super.fire(this.t(re))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(re){this.z&&(this.h!==0?this.s.push(re):super.fire(re))}}e.$qe=u;class S extends u{constructor(re){super(re),this.k=re.delay??100}fire(re){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(re)}}e.$re=S;class P extends i{constructor(re){super(re),this.h=[],this.k=re?.merge}fire(re){this.hasListeners()&&(this.h.push(re),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(te=>super.fire(te)),this.h=[]}))}}e.$se=P;class C{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(re){const te={event:re,listener:null};this.h.push(te),this.g&&this.m(te);const _=()=>{this.g&&this.o(te);const de=this.h.indexOf(te);this.h.splice(de,1)};return(0,E.$Vc)((0,r.$gb)(_))}j(){this.g=!0,this.h.forEach(re=>this.m(re))}k(){this.g=!1,this.h.forEach(re=>this.o(re))}m(re){re.listener=re.event(te=>this.f.fire(te))}o(re){re.listener?.dispose(),re.listener=null}dispose(){this.f.dispose();for(const re of this.h)re.listener?.dispose();this.h=[]}}e.$te=C;class L{constructor(re,te,_,de){this.f=new E.$Wc;const J=this.f.add(new C),ae=this.f.add(new E.$7c);function z(B){ae.set(B,J.add(de(B)))}for(const B of re)z(B);this.f.add(te(B=>{z(B)})),this.f.add(_(B=>{ae.deleteAndDispose(B)})),this.event=J.event}dispose(){this.f.dispose()}}e.$ue=L;class T{constructor(){this.f=[]}wrapEvent(re,te,_){return(de,J,ae)=>re(z=>{const B=this.f[this.f.length-1];if(!te){B?B.buffers.push(()=>de.call(J,z)):de.call(J,z);return}const ie=B;if(!ie){de.call(J,te(_,z));return}ie.items??=[],ie.items.push(z),ie.buffers.length===0&&B.buffers.push(()=>{ie.reducedResult??=_?ie.items.reduce(te,_):ie.items.reduce(te),de.call(J,ie.reducedResult)})},void 0,ae)}bufferEvents(re){const te={buffers:new Array};this.f.push(te);const _=re();return this.f.pop(),te.buffers.forEach(de=>de()),_}}e.$ve=T;class I{constructor(){this.f=!1,this.g=D.None,this.h=E.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(re){this.g=re,this.f&&(this.h.dispose(),this.h=re(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=I;class q{static const(re){return new Y(re)}constructor(re){this.g=re,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(re){re!==this.g&&(this.g=re,this.f.fire(void 0))}}e.$xe=q;class Y{constructor(re){this.value=re,this.onDidChange=D.None}}}),define(ve[19],Se([1,0,6]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=A;const r=Object.freeze(function(y,o){const D=setTimeout(y.bind(o),0);return{dispose(){clearTimeout(D)}}});var E;(function(y){function o(D){return D===y.None||D===y.Cancelled||D instanceof k?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}y.isCancellationToken=o,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=E.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=E.None}}e.$ye=R;function A(y){const o=new R;return y.add({dispose(){o.cancel()}}),o.token}}),define(ve[169],Se([1,0,19]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=E;class r{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new n.$ye,o=this.b(y.token);return this.a={promise:o,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$$e=r;function E(A){return A}class k{constructor(y,o){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);return this.b!==o&&(this.b=o,this.a=this.c(y)),this.a}}e.$af=k;class R{get cachedValues(){return this.a}constructor(y,o){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);if(this.b.has(o))return this.b.get(o);const D=this.c(y);return this.a.set(y,D),this.b.set(o,D),D}}e.$bf=R}),define(ve[170],Se([1,0,6,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.ScrollbarVisibility=void 0;var E;(function(w){w[w.Auto=1]="Auto",w[w.Hidden=2]="Hidden",w[w.Visible=3]="Visible"})(E||(e.ScrollbarVisibility=E={}));class k{constructor(a,f,m,$,b,d,p){this.c=a,this._scrollStateBrand=void 0,this.c&&(f=f|0,m=m|0,$=$|0,b=b|0,d=d|0,p=p|0),this.rawScrollLeft=$,this.rawScrollTop=p,f<0&&(f=0),$+f>m&&($=m-f),$<0&&($=0),b<0&&(b=0),p+b>d&&(p=d-b),p<0&&(p=0),this.width=f,this.scrollWidth=m,this.scrollLeft=$,this.height=b,this.scrollHeight=d,this.scrollTop=p}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,f){return new k(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,f?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,f?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new k(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,f){const m=this.width!==a.width,$=this.scrollWidth!==a.scrollWidth,b=this.scrollLeft!==a.scrollLeft,d=this.height!==a.height,p=this.scrollHeight!==a.scrollHeight,t=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:f,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:b,heightChanged:d,scrollHeightChanged:p,scrollTopChanged:t}}}e.$bt=k;class R extends r.$Xc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$ne),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new k(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,f){const m=this.g.withScrollDimensions(a,f);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const f=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(f,!1)}setScrollPositionSmooth(a,f){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const m=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;f?$=new D(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(a);this.h=D.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),f=this.g.withScrollPosition(a);if(this.n(f,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,f){const m=this.g;m.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(m,f)))}}e.$ct=R;class A{constructor(a,f,m){this.scrollLeft=a,this.scrollTop=f,this.isDone=m}}e.$dt=A;function y(w,a){const f=a-w;return function(m){return w+f*h(m)}}function o(w,a,f){return function(m){return m<f?w(m/f):a((m-f)/(1-f))}}class D{constructor(a,f,m,$){this.from=a,this.to=f,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,f,m){if(Math.abs(a-f)>2.5*m){let b,d;return a<f?(b=a+.75*m,d=f-.75*m):(b=a-.75*m,d=f+.75*m),o(y(a,b),y(d,f),.33)}return y(a,f)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const f=(a-this.startTime)/this.duration;if(f<1){const m=this.c(f),$=this.d(f);return new A(m,$,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,f,m){return D.start(a,f,m)}static start(a,f,m){m=m+10;const $=Date.now()-10;return new D(a,f,$,m)}}e.$et=D;function v(w){return Math.pow(w,3)}function h(w){return 1-v(1-w)}}),define(ve[56],Se([1,0,10,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=E,e.$Be=k,e.$Ce=R,e.$De=A,e.$Ee=o,e.$Fe=D,e.$Ge=v,e.$He=h,e.$Ie=w,e.$Je=a,e.$Ke=f,e.$Le=m,e.$Me=$,e.$Ne=b,e.$Oe=d;function E(p){const t=p;return t?typeof t.read=="function":!1}function k(p){const t=p;return t?[t.on,t.pause,t.resume,t.destroy].every(l=>typeof l=="function"):!1}function R(p){const t=p;return t?k(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(p,t){return new y(p,t)}class y{constructor(t,l){this.e=t,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(l=>l(t))}h(t){this.c.error.length===0?(0,n.$3)(t):this.c.error.slice(0).forEach(l=>l(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,l){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(t,l){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const g=i.indexOf(l);g>=0&&i.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(p,t){const l=[];let i;for(;(i=p.read())!==null;)l.push(i);return t(l)}function D(p,t,l){const i=[];let g;for(;(g=p.read())!==null&&i.length<l;)i.push(g);return g===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g<"u"){const s=g;return g=void 0,s}return p.read()}}}function v(p,t){return new Promise((l,i)=>{const g=[];h(p,{onData:s=>{t&&g.push(s)},onError:s=>{t?i(s):l(void 0)},onEnd:()=>{l(t?t(g):void 0)}})})}function h(p,t,l){p.on("error",i=>{l?.isCancellationRequested||t.onError(i)}),p.on("end",()=>{l?.isCancellationRequested||t.onEnd()}),p.on("data",i=>{l?.isCancellationRequested||t.onData(i)})}function w(p,t){return new Promise((l,i)=>{const g=new r.$Wc,s=[],c=P=>{if(s.push(P),s.length>t)return g.dispose(),p.pause(),l({stream:p,buffer:s,ended:!1})},u=P=>(g.dispose(),i(P)),S=()=>(g.dispose(),l({stream:p,buffer:s,ended:!0}));g.add((0,r.$Vc)(()=>p.removeListener("error",u))),p.on("error",u),g.add((0,r.$Vc)(()=>p.removeListener("end",S))),p.on("end",S),g.add((0,r.$Vc)(()=>p.removeListener("data",c))),p.on("data",c)})}function a(p,t){const l=A(t);return l.end(p),l}function f(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}function m(p){let t=!1;return{read:()=>t?null:(t=!0,p)}}function $(p,t,l){const i=A(l);return h(p,{onData:g=>i.write(t.data(g)),onError:g=>i.error(t.error?t.error(g):g),onEnd:()=>i.end()}),i}function b(p,t,l){let i=!1;return{read:()=>{const g=t.read();return i?g:(i=!0,g!==null?l([p,g]):p)}}}function d(p,t,l){let i=!1;const g=A(l);return h(t,{onData:s=>i?g.write(s):(i=!0,g.write(l([p,s]))),onError:s=>g.error(s),onEnd:()=>{i||(i=!0,g.write(p)),g.end()}}),g}}),define(ve[15],Se([1,0,65,56]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=o,e.$Re=D,e.$Se=v,e.$Te=h,e.$Ue=w,e.$Ve=a,e.$We=f,e.$Xe=m,e.$Ye=$,e.$Ze=b,e.$1e=d,e.$2e=p,e.$3e=t,e.$4e=l,e.$5e=i,e.$6e=g,e.$7e=s,e.$8e=c,e.$9e=u,e.$0e=C,r=qe(r);const E=typeof Buffer<"u",k=new n.$X(()=>new Uint8Array(256));let R,A;class y{static alloc(T){return E?new y(Buffer.allocUnsafe(T)):new y(new Uint8Array(T))}static wrap(T){return E&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new y(T)}static fromString(T,I){return!(I?.dontUseNodeBuffer||!1)&&E?new y(Buffer.from(T)):(R||(R=new TextEncoder),new y(R.encode(T)))}static fromByteArray(T){const I=y.alloc(T.length);for(let q=0,Y=T.length;q<Y;q++)I.buffer[q]=T[q];return I}static concat(T,I){if(typeof I>"u"){I=0;for(let Q=0,re=T.length;Q<re;Q++)I+=T[Q].byteLength}const q=y.alloc(I);let Y=0;for(let Q=0,re=T.length;Q<re;Q++){const te=T[Q];q.set(te,Y),Y+=te.byteLength}return q}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=y.alloc(this.byteLength);return T.set(this),T}toString(){return E?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(T,I){return new y(this.buffer.subarray(T,I))}set(T,I){if(T instanceof y)this.buffer.set(T.buffer,I);else if(T instanceof Uint8Array)this.buffer.set(T,I);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),I);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return h(this.buffer,T)}writeUInt32BE(T,I){w(this.buffer,T,I)}readUInt32LE(T){return a(this.buffer,T)}writeUInt32LE(T,I){f(this.buffer,T,I)}readUInt8(T){return m(this.buffer,T)}writeUInt8(T,I){$(this.buffer,T,I)}indexOf(T,I=0){return o(this.buffer,T instanceof y?T.buffer:T,I)}}e.$Pe=y;function o(L,T,I=0){const q=T.byteLength,Y=L.byteLength;if(q===0)return 0;if(q===1)return L.indexOf(T[0]);if(q>Y-I)return-1;const Q=k.value;Q.fill(T.length);for(let de=0;de<T.length;de++)Q[T[de]]=T.length-de-1;let re=I+T.length-1,te=re,_=-1;for(;re<Y;)if(L[re]===T[te]){if(te===0){_=re;break}re--,te--}else re+=Math.max(T.length-te,Q[L[re]]),te=T.length-1;return _}function D(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0}function v(L,T,I){L[I+0]=T&255,T=T>>>8,L[I+1]=T&255}function h(L,T){return L[T]*2**24+L[T+1]*2**16+L[T+2]*2**8+L[T+3]}function w(L,T,I){L[I+3]=T,T=T>>>8,L[I+2]=T,T=T>>>8,L[I+1]=T,T=T>>>8,L[I]=T}function a(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0|L[T+2]<<16>>>0|L[T+3]<<24>>>0}function f(L,T,I){L[I+0]=T&255,T=T>>>8,L[I+1]=T&255,T=T>>>8,L[I+2]=T&255,T=T>>>8,L[I+3]=T&255}function m(L,T){return L[T]}function $(L,T,I){L[I]=T}function b(L){return r.$Ee(L,T=>y.concat(T))}function d(L){return r.$Le(L)}function p(L){return r.$Ge(L,T=>y.concat(T))}async function t(L){return L.ended?y.concat(L.buffer):y.concat([...L.buffer,await p(L.stream)])}function l(L){return r.$Je(L,T=>y.concat(T))}function i(L){return r.$Me(L,{data:T=>typeof T=="string"?y.fromString(T):y.wrap(T)},T=>y.concat(T))}function g(L){return r.$De(T=>y.concat(T),L)}function s(L,T){return r.$Ne(L,T,I=>y.concat(I))}function c(L,T){return r.$Oe(L,T,I=>y.concat(I))}function u(L){let T=0,I=0,q=0;const Y=new Uint8Array(Math.floor(L.length/4*3)),Q=te=>{switch(I){case 3:Y[q++]=T|te,I=0;break;case 2:Y[q++]=T|te>>>2,T=te<<6,I=3;break;case 1:Y[q++]=T|te>>>4,T=te<<4,I=2;break;default:T=te<<2,I=1}};for(let te=0;te<L.length;te++){const _=L.charCodeAt(te);if(_>=65&&_<=90)Q(_-65);else if(_>=97&&_<=122)Q(_-97+26);else if(_>=48&&_<=57)Q(_-48+52);else if(_===43||_===45)Q(62);else if(_===47||_===95)Q(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${L[te]}`)}}const re=q;for(;I>0;)Q(0);return y.wrap(Y).slice(0,re)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:L},T=!0,I=!1){const q=I?P:S;let Y="";const Q=L.byteLength%3;let re=0;for(;re<L.byteLength-Q;re+=3){const te=L[re+0],_=L[re+1],de=L[re+2];Y+=q[te>>>2],Y+=q[(te<<4|_>>>4)&63],Y+=q[(_<<2|de>>>6)&63],Y+=q[de&63]}if(Q===1){const te=L[re+0];Y+=q[te>>>2],Y+=q[te<<4&63],T&&(Y+="==")}else if(Q===2){const te=L[re+0],_=L[re+1];Y+=q[te>>>2],Y+=q[(te<<4|_>>>4)&63],Y+=q[_<<2&63],T&&(Y+="=")}return Y}}),define(ve[171],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(ve[11],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=n,e.$hg=r,e.$ig=E,e.$jg=k,e.$kg=R,e.$lg=A,e.$mg=y,e.$ng=o,e.$og=D,e.$pg=v,e.$qg=h,e.$rg=w,e.$sg=a,e.$tg=m,e.$ug=$,e.$vg=b,e.$wg=d,e.$xg=p;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(l=>n(l))}function E(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function k(t){const l=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof l}function R(t){return typeof t=="number"&&!isNaN(t)}function A(t){return!!t&&typeof t[Symbol.iterator]=="function"}function y(t){return t===!0||t===!1}function o(t){return typeof t>"u"}function D(t){return!v(t)}function v(t){return o(t)||t===null}function h(t,l){if(!t)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}function w(t){if(v(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function a(...t){const l=[];for(let i=0;i<t.length;i++){const g=t[i];if(v(g))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);l.push(g)}return l}const f=Object.prototype.hasOwnProperty;function m(t){if(!E(t))return!1;for(const l in t)if(f.call(t,l))return!1;return!0}function $(t){return typeof t=="function"}function b(...t){return t.length>0&&t.every($)}function d(t,l){const i=Math.min(t.length,l.length);for(let g=0;g<i;g++)p(t[g],l[g])}function p(t,l){if(n(l)){if(typeof t!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if($(l)){try{if(t instanceof l)return}catch{}if(!v(t)&&t.constructor===l||l.length===1&&l.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ve[108],Se([1,0,11]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=E,e.$2j=k;const r=Object.create(null);function E(R,A){if((0,n.$gg)(A)){const y=r[A];if(y===void 0)throw new Error(`${R} references an unknown codicon: ${A}`);A=y}return r[R]=A,{id:R}}function k(){return r}}),define(ve[172],Se([1,0,108]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,n.$1j)("add",6e4),plus:(0,n.$1j)("plus",6e4),gistNew:(0,n.$1j)("gist-new",6e4),repoCreate:(0,n.$1j)("repo-create",6e4),lightbulb:(0,n.$1j)("lightbulb",60001),lightBulb:(0,n.$1j)("light-bulb",60001),repo:(0,n.$1j)("repo",60002),repoDelete:(0,n.$1j)("repo-delete",60002),gistFork:(0,n.$1j)("gist-fork",60003),repoForked:(0,n.$1j)("repo-forked",60003),gitPullRequest:(0,n.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$1j)("record-keys",60005),keyboard:(0,n.$1j)("keyboard",60005),tag:(0,n.$1j)("tag",60006),gitPullRequestLabel:(0,n.$1j)("git-pull-request-label",60006),tagAdd:(0,n.$1j)("tag-add",60006),tagRemove:(0,n.$1j)("tag-remove",60006),person:(0,n.$1j)("person",60007),personFollow:(0,n.$1j)("person-follow",60007),personOutline:(0,n.$1j)("person-outline",60007),personFilled:(0,n.$1j)("person-filled",60007),gitBranch:(0,n.$1j)("git-branch",60008),gitBranchCreate:(0,n.$1j)("git-branch-create",60008),gitBranchDelete:(0,n.$1j)("git-branch-delete",60008),sourceControl:(0,n.$1j)("source-control",60008),mirror:(0,n.$1j)("mirror",60009),mirrorPublic:(0,n.$1j)("mirror-public",60009),star:(0,n.$1j)("star",60010),starAdd:(0,n.$1j)("star-add",60010),starDelete:(0,n.$1j)("star-delete",60010),starEmpty:(0,n.$1j)("star-empty",60010),comment:(0,n.$1j)("comment",60011),commentAdd:(0,n.$1j)("comment-add",60011),alert:(0,n.$1j)("alert",60012),warning:(0,n.$1j)("warning",60012),search:(0,n.$1j)("search",60013),searchSave:(0,n.$1j)("search-save",60013),logOut:(0,n.$1j)("log-out",60014),signOut:(0,n.$1j)("sign-out",60014),logIn:(0,n.$1j)("log-in",60015),signIn:(0,n.$1j)("sign-in",60015),eye:(0,n.$1j)("eye",60016),eyeUnwatch:(0,n.$1j)("eye-unwatch",60016),eyeWatch:(0,n.$1j)("eye-watch",60016),circleFilled:(0,n.$1j)("circle-filled",60017),primitiveDot:(0,n.$1j)("primitive-dot",60017),closeDirty:(0,n.$1j)("close-dirty",60017),debugBreakpoint:(0,n.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$1j)("primitive-square",60018),edit:(0,n.$1j)("edit",60019),pencil:(0,n.$1j)("pencil",60019),info:(0,n.$1j)("info",60020),issueOpened:(0,n.$1j)("issue-opened",60020),gistPrivate:(0,n.$1j)("gist-private",60021),gitForkPrivate:(0,n.$1j)("git-fork-private",60021),lock:(0,n.$1j)("lock",60021),mirrorPrivate:(0,n.$1j)("mirror-private",60021),close:(0,n.$1j)("close",60022),removeClose:(0,n.$1j)("remove-close",60022),x:(0,n.$1j)("x",60022),repoSync:(0,n.$1j)("repo-sync",60023),sync:(0,n.$1j)("sync",60023),clone:(0,n.$1j)("clone",60024),desktopDownload:(0,n.$1j)("desktop-download",60024),beaker:(0,n.$1j)("beaker",60025),microscope:(0,n.$1j)("microscope",60025),vm:(0,n.$1j)("vm",60026),deviceDesktop:(0,n.$1j)("device-desktop",60026),file:(0,n.$1j)("file",60027),fileText:(0,n.$1j)("file-text",60027),more:(0,n.$1j)("more",60028),ellipsis:(0,n.$1j)("ellipsis",60028),kebabHorizontal:(0,n.$1j)("kebab-horizontal",60028),mailReply:(0,n.$1j)("mail-reply",60029),reply:(0,n.$1j)("reply",60029),organization:(0,n.$1j)("organization",60030),organizationFilled:(0,n.$1j)("organization-filled",60030),organizationOutline:(0,n.$1j)("organization-outline",60030),newFile:(0,n.$1j)("new-file",60031),fileAdd:(0,n.$1j)("file-add",60031),newFolder:(0,n.$1j)("new-folder",60032),fileDirectoryCreate:(0,n.$1j)("file-directory-create",60032),trash:(0,n.$1j)("trash",60033),trashcan:(0,n.$1j)("trashcan",60033),history:(0,n.$1j)("history",60034),clock:(0,n.$1j)("clock",60034),folder:(0,n.$1j)("folder",60035),fileDirectory:(0,n.$1j)("file-directory",60035),symbolFolder:(0,n.$1j)("symbol-folder",60035),logoGithub:(0,n.$1j)("logo-github",60036),markGithub:(0,n.$1j)("mark-github",60036),github:(0,n.$1j)("github",60036),terminal:(0,n.$1j)("terminal",60037),console:(0,n.$1j)("console",60037),repl:(0,n.$1j)("repl",60037),zap:(0,n.$1j)("zap",60038),symbolEvent:(0,n.$1j)("symbol-event",60038),error:(0,n.$1j)("error",60039),stop:(0,n.$1j)("stop",60039),variable:(0,n.$1j)("variable",60040),symbolVariable:(0,n.$1j)("symbol-variable",60040),array:(0,n.$1j)("array",60042),symbolArray:(0,n.$1j)("symbol-array",60042),symbolModule:(0,n.$1j)("symbol-module",60043),symbolPackage:(0,n.$1j)("symbol-package",60043),symbolNamespace:(0,n.$1j)("symbol-namespace",60043),symbolObject:(0,n.$1j)("symbol-object",60043),symbolMethod:(0,n.$1j)("symbol-method",60044),symbolFunction:(0,n.$1j)("symbol-function",60044),symbolConstructor:(0,n.$1j)("symbol-constructor",60044),symbolBoolean:(0,n.$1j)("symbol-boolean",60047),symbolNull:(0,n.$1j)("symbol-null",60047),symbolNumeric:(0,n.$1j)("symbol-numeric",60048),symbolNumber:(0,n.$1j)("symbol-number",60048),symbolStructure:(0,n.$1j)("symbol-structure",60049),symbolStruct:(0,n.$1j)("symbol-struct",60049),symbolParameter:(0,n.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$1j)("symbol-type-parameter",60050),symbolKey:(0,n.$1j)("symbol-key",60051),symbolText:(0,n.$1j)("symbol-text",60051),symbolReference:(0,n.$1j)("symbol-reference",60052),goToFile:(0,n.$1j)("go-to-file",60052),symbolEnum:(0,n.$1j)("symbol-enum",60053),symbolValue:(0,n.$1j)("symbol-value",60053),symbolRuler:(0,n.$1j)("symbol-ruler",60054),symbolUnit:(0,n.$1j)("symbol-unit",60054),activateBreakpoints:(0,n.$1j)("activate-breakpoints",60055),archive:(0,n.$1j)("archive",60056),arrowBoth:(0,n.$1j)("arrow-both",60057),arrowDown:(0,n.$1j)("arrow-down",60058),arrowLeft:(0,n.$1j)("arrow-left",60059),arrowRight:(0,n.$1j)("arrow-right",60060),arrowSmallDown:(0,n.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$1j)("arrow-small-left",60062),arrowSmallRight:(0,n.$1j)("arrow-small-right",60063),arrowSmallUp:(0,n.$1j)("arrow-small-up",60064),arrowUp:(0,n.$1j)("arrow-up",60065),bell:(0,n.$1j)("bell",60066),bold:(0,n.$1j)("bold",60067),book:(0,n.$1j)("book",60068),bookmark:(0,n.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$1j)("briefcase",60076),broadcast:(0,n.$1j)("broadcast",60077),browser:(0,n.$1j)("browser",60078),bug:(0,n.$1j)("bug",60079),calendar:(0,n.$1j)("calendar",60080),caseSensitive:(0,n.$1j)("case-sensitive",60081),check:(0,n.$1j)("check",60082),checklist:(0,n.$1j)("checklist",60083),chevronDown:(0,n.$1j)("chevron-down",60084),chevronLeft:(0,n.$1j)("chevron-left",60085),chevronRight:(0,n.$1j)("chevron-right",60086),chevronUp:(0,n.$1j)("chevron-up",60087),chromeClose:(0,n.$1j)("chrome-close",60088),chromeMaximize:(0,n.$1j)("chrome-maximize",60089),chromeMinimize:(0,n.$1j)("chrome-minimize",60090),chromeRestore:(0,n.$1j)("chrome-restore",60091),circleOutline:(0,n.$1j)("circle-outline",60092),circle:(0,n.$1j)("circle",60092),debugBreakpointUnverified:(0,n.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$1j)("circle-slash",60093),circuitBoard:(0,n.$1j)("circuit-board",60094),clearAll:(0,n.$1j)("clear-all",60095),clippy:(0,n.$1j)("clippy",60096),closeAll:(0,n.$1j)("close-all",60097),cloudDownload:(0,n.$1j)("cloud-download",60098),cloudUpload:(0,n.$1j)("cloud-upload",60099),code:(0,n.$1j)("code",60100),collapseAll:(0,n.$1j)("collapse-all",60101),colorMode:(0,n.$1j)("color-mode",60102),commentDiscussion:(0,n.$1j)("comment-discussion",60103),creditCard:(0,n.$1j)("credit-card",60105),dash:(0,n.$1j)("dash",60108),dashboard:(0,n.$1j)("dashboard",60109),database:(0,n.$1j)("database",60110),debugContinue:(0,n.$1j)("debug-continue",60111),debugDisconnect:(0,n.$1j)("debug-disconnect",60112),debugPause:(0,n.$1j)("debug-pause",60113),debugRestart:(0,n.$1j)("debug-restart",60114),debugStart:(0,n.$1j)("debug-start",60115),debugStepInto:(0,n.$1j)("debug-step-into",60116),debugStepOut:(0,n.$1j)("debug-step-out",60117),debugStepOver:(0,n.$1j)("debug-step-over",60118),debugStop:(0,n.$1j)("debug-stop",60119),debug:(0,n.$1j)("debug",60120),deviceCameraVideo:(0,n.$1j)("device-camera-video",60121),deviceCamera:(0,n.$1j)("device-camera",60122),deviceMobile:(0,n.$1j)("device-mobile",60123),diffAdded:(0,n.$1j)("diff-added",60124),diffIgnored:(0,n.$1j)("diff-ignored",60125),diffModified:(0,n.$1j)("diff-modified",60126),diffRemoved:(0,n.$1j)("diff-removed",60127),diffRenamed:(0,n.$1j)("diff-renamed",60128),diff:(0,n.$1j)("diff",60129),diffSidebyside:(0,n.$1j)("diff-sidebyside",60129),discard:(0,n.$1j)("discard",60130),editorLayout:(0,n.$1j)("editor-layout",60131),emptyWindow:(0,n.$1j)("empty-window",60132),exclude:(0,n.$1j)("exclude",60133),extensions:(0,n.$1j)("extensions",60134),eyeClosed:(0,n.$1j)("eye-closed",60135),fileBinary:(0,n.$1j)("file-binary",60136),fileCode:(0,n.$1j)("file-code",60137),fileMedia:(0,n.$1j)("file-media",60138),filePdf:(0,n.$1j)("file-pdf",60139),fileSubmodule:(0,n.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$1j)("file-symlink-file",60142),fileZip:(0,n.$1j)("file-zip",60143),files:(0,n.$1j)("files",60144),filter:(0,n.$1j)("filter",60145),flame:(0,n.$1j)("flame",60146),foldDown:(0,n.$1j)("fold-down",60147),foldUp:(0,n.$1j)("fold-up",60148),fold:(0,n.$1j)("fold",60149),folderActive:(0,n.$1j)("folder-active",60150),folderOpened:(0,n.$1j)("folder-opened",60151),gear:(0,n.$1j)("gear",60152),gift:(0,n.$1j)("gift",60153),gistSecret:(0,n.$1j)("gist-secret",60154),gist:(0,n.$1j)("gist",60155),gitCommit:(0,n.$1j)("git-commit",60156),gitCompare:(0,n.$1j)("git-compare",60157),compareChanges:(0,n.$1j)("compare-changes",60157),gitMerge:(0,n.$1j)("git-merge",60158),githubAction:(0,n.$1j)("github-action",60159),githubAlt:(0,n.$1j)("github-alt",60160),globe:(0,n.$1j)("globe",60161),grabber:(0,n.$1j)("grabber",60162),graph:(0,n.$1j)("graph",60163),gripper:(0,n.$1j)("gripper",60164),heart:(0,n.$1j)("heart",60165),home:(0,n.$1j)("home",60166),horizontalRule:(0,n.$1j)("horizontal-rule",60167),hubot:(0,n.$1j)("hubot",60168),inbox:(0,n.$1j)("inbox",60169),issueReopened:(0,n.$1j)("issue-reopened",60171),issues:(0,n.$1j)("issues",60172),italic:(0,n.$1j)("italic",60173),jersey:(0,n.$1j)("jersey",60174),json:(0,n.$1j)("json",60175),kebabVertical:(0,n.$1j)("kebab-vertical",60176),key:(0,n.$1j)("key",60177),law:(0,n.$1j)("law",60178),lightbulbAutofix:(0,n.$1j)("lightbulb-autofix",60179),linkExternal:(0,n.$1j)("link-external",60180),link:(0,n.$1j)("link",60181),listOrdered:(0,n.$1j)("list-ordered",60182),listUnordered:(0,n.$1j)("list-unordered",60183),liveShare:(0,n.$1j)("live-share",60184),loading:(0,n.$1j)("loading",60185),location:(0,n.$1j)("location",60186),mailRead:(0,n.$1j)("mail-read",60187),mail:(0,n.$1j)("mail",60188),markdown:(0,n.$1j)("markdown",60189),megaphone:(0,n.$1j)("megaphone",60190),mention:(0,n.$1j)("mention",60191),milestone:(0,n.$1j)("milestone",60192),gitPullRequestMilestone:(0,n.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$1j)("mortar-board",60193),move:(0,n.$1j)("move",60194),multipleWindows:(0,n.$1j)("multiple-windows",60195),mute:(0,n.$1j)("mute",60196),noNewline:(0,n.$1j)("no-newline",60197),note:(0,n.$1j)("note",60198),octoface:(0,n.$1j)("octoface",60199),openPreview:(0,n.$1j)("open-preview",60200),package:(0,n.$1j)("package",60201),paintcan:(0,n.$1j)("paintcan",60202),pin:(0,n.$1j)("pin",60203),play:(0,n.$1j)("play",60204),run:(0,n.$1j)("run",60204),plug:(0,n.$1j)("plug",60205),preserveCase:(0,n.$1j)("preserve-case",60206),preview:(0,n.$1j)("preview",60207),project:(0,n.$1j)("project",60208),pulse:(0,n.$1j)("pulse",60209),question:(0,n.$1j)("question",60210),quote:(0,n.$1j)("quote",60211),radioTower:(0,n.$1j)("radio-tower",60212),reactions:(0,n.$1j)("reactions",60213),references:(0,n.$1j)("references",60214),refresh:(0,n.$1j)("refresh",60215),regex:(0,n.$1j)("regex",60216),remoteExplorer:(0,n.$1j)("remote-explorer",60217),remote:(0,n.$1j)("remote",60218),remove:(0,n.$1j)("remove",60219),replaceAll:(0,n.$1j)("replace-all",60220),replace:(0,n.$1j)("replace",60221),repoClone:(0,n.$1j)("repo-clone",60222),repoForcePush:(0,n.$1j)("repo-force-push",60223),repoPull:(0,n.$1j)("repo-pull",60224),repoPush:(0,n.$1j)("repo-push",60225),report:(0,n.$1j)("report",60226),requestChanges:(0,n.$1j)("request-changes",60227),rocket:(0,n.$1j)("rocket",60228),rootFolderOpened:(0,n.$1j)("root-folder-opened",60229),rootFolder:(0,n.$1j)("root-folder",60230),rss:(0,n.$1j)("rss",60231),ruby:(0,n.$1j)("ruby",60232),saveAll:(0,n.$1j)("save-all",60233),saveAs:(0,n.$1j)("save-as",60234),save:(0,n.$1j)("save",60235),screenFull:(0,n.$1j)("screen-full",60236),screenNormal:(0,n.$1j)("screen-normal",60237),searchStop:(0,n.$1j)("search-stop",60238),server:(0,n.$1j)("server",60240),settingsGear:(0,n.$1j)("settings-gear",60241),settings:(0,n.$1j)("settings",60242),shield:(0,n.$1j)("shield",60243),smiley:(0,n.$1j)("smiley",60244),sortPrecedence:(0,n.$1j)("sort-precedence",60245),splitHorizontal:(0,n.$1j)("split-horizontal",60246),splitVertical:(0,n.$1j)("split-vertical",60247),squirrel:(0,n.$1j)("squirrel",60248),starFull:(0,n.$1j)("star-full",60249),starHalf:(0,n.$1j)("star-half",60250),symbolClass:(0,n.$1j)("symbol-class",60251),symbolColor:(0,n.$1j)("symbol-color",60252),symbolConstant:(0,n.$1j)("symbol-constant",60253),symbolEnumMember:(0,n.$1j)("symbol-enum-member",60254),symbolField:(0,n.$1j)("symbol-field",60255),symbolFile:(0,n.$1j)("symbol-file",60256),symbolInterface:(0,n.$1j)("symbol-interface",60257),symbolKeyword:(0,n.$1j)("symbol-keyword",60258),symbolMisc:(0,n.$1j)("symbol-misc",60259),symbolOperator:(0,n.$1j)("symbol-operator",60260),symbolProperty:(0,n.$1j)("symbol-property",60261),wrench:(0,n.$1j)("wrench",60261),wrenchSubaction:(0,n.$1j)("wrench-subaction",60261),symbolSnippet:(0,n.$1j)("symbol-snippet",60262),tasklist:(0,n.$1j)("tasklist",60263),telescope:(0,n.$1j)("telescope",60264),textSize:(0,n.$1j)("text-size",60265),threeBars:(0,n.$1j)("three-bars",60266),thumbsdown:(0,n.$1j)("thumbsdown",60267),thumbsup:(0,n.$1j)("thumbsup",60268),tools:(0,n.$1j)("tools",60269),triangleDown:(0,n.$1j)("triangle-down",60270),triangleLeft:(0,n.$1j)("triangle-left",60271),triangleRight:(0,n.$1j)("triangle-right",60272),triangleUp:(0,n.$1j)("triangle-up",60273),twitter:(0,n.$1j)("twitter",60274),unfold:(0,n.$1j)("unfold",60275),unlock:(0,n.$1j)("unlock",60276),unmute:(0,n.$1j)("unmute",60277),unverified:(0,n.$1j)("unverified",60278),verified:(0,n.$1j)("verified",60279),versions:(0,n.$1j)("versions",60280),vmActive:(0,n.$1j)("vm-active",60281),vmOutline:(0,n.$1j)("vm-outline",60282),vmRunning:(0,n.$1j)("vm-running",60283),watch:(0,n.$1j)("watch",60284),whitespace:(0,n.$1j)("whitespace",60285),wholeWord:(0,n.$1j)("whole-word",60286),window:(0,n.$1j)("window",60287),wordWrap:(0,n.$1j)("word-wrap",60288),zoomIn:(0,n.$1j)("zoom-in",60289),zoomOut:(0,n.$1j)("zoom-out",60290),listFilter:(0,n.$1j)("list-filter",60291),listFlat:(0,n.$1j)("list-flat",60292),listSelection:(0,n.$1j)("list-selection",60293),selection:(0,n.$1j)("selection",60293),listTree:(0,n.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$1j)("circle-small-filled",60298),debugStackframeDot:(0,n.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$1j)("symbol-string",60301),debugReverseContinue:(0,n.$1j)("debug-reverse-continue",60302),debugStepBack:(0,n.$1j)("debug-step-back",60303),debugRestartFrame:(0,n.$1j)("debug-restart-frame",60304),debugAlt:(0,n.$1j)("debug-alt",60305),callIncoming:(0,n.$1j)("call-incoming",60306),callOutgoing:(0,n.$1j)("call-outgoing",60307),menu:(0,n.$1j)("menu",60308),expandAll:(0,n.$1j)("expand-all",60309),feedback:(0,n.$1j)("feedback",60310),gitPullRequestReviewer:(0,n.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$1j)("ungroup-by-ref-type",60312),account:(0,n.$1j)("account",60313),gitPullRequestAssignee:(0,n.$1j)("git-pull-request-assignee",60313),bellDot:(0,n.$1j)("bell-dot",60314),debugConsole:(0,n.$1j)("debug-console",60315),library:(0,n.$1j)("library",60316),output:(0,n.$1j)("output",60317),runAll:(0,n.$1j)("run-all",60318),syncIgnored:(0,n.$1j)("sync-ignored",60319),pinned:(0,n.$1j)("pinned",60320),githubInverted:(0,n.$1j)("github-inverted",60321),serverProcess:(0,n.$1j)("server-process",60322),serverEnvironment:(0,n.$1j)("server-environment",60323),pass:(0,n.$1j)("pass",60324),issueClosed:(0,n.$1j)("issue-closed",60324),stopCircle:(0,n.$1j)("stop-circle",60325),playCircle:(0,n.$1j)("play-circle",60326),record:(0,n.$1j)("record",60327),debugAltSmall:(0,n.$1j)("debug-alt-small",60328),vmConnect:(0,n.$1j)("vm-connect",60329),cloud:(0,n.$1j)("cloud",60330),merge:(0,n.$1j)("merge",60331),export:(0,n.$1j)("export",60332),graphLeft:(0,n.$1j)("graph-left",60333),magnet:(0,n.$1j)("magnet",60334),notebook:(0,n.$1j)("notebook",60335),redo:(0,n.$1j)("redo",60336),checkAll:(0,n.$1j)("check-all",60337),pinnedDirty:(0,n.$1j)("pinned-dirty",60338),passFilled:(0,n.$1j)("pass-filled",60339),circleLargeFilled:(0,n.$1j)("circle-large-filled",60340),circleLarge:(0,n.$1j)("circle-large",60341),circleLargeOutline:(0,n.$1j)("circle-large-outline",60341),combine:(0,n.$1j)("combine",60342),gather:(0,n.$1j)("gather",60342),table:(0,n.$1j)("table",60343),variableGroup:(0,n.$1j)("variable-group",60344),typeHierarchy:(0,n.$1j)("type-hierarchy",60345),typeHierarchySub:(0,n.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$1j)("git-pull-request-create",60348),runAbove:(0,n.$1j)("run-above",60349),runBelow:(0,n.$1j)("run-below",60350),notebookTemplate:(0,n.$1j)("notebook-template",60351),debugRerun:(0,n.$1j)("debug-rerun",60352),workspaceTrusted:(0,n.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$1j)("workspace-unknown",60355),terminalCmd:(0,n.$1j)("terminal-cmd",60356),terminalDebian:(0,n.$1j)("terminal-debian",60357),terminalLinux:(0,n.$1j)("terminal-linux",60358),terminalPowershell:(0,n.$1j)("terminal-powershell",60359),terminalTmux:(0,n.$1j)("terminal-tmux",60360),terminalUbuntu:(0,n.$1j)("terminal-ubuntu",60361),terminalBash:(0,n.$1j)("terminal-bash",60362),arrowSwap:(0,n.$1j)("arrow-swap",60363),copy:(0,n.$1j)("copy",60364),personAdd:(0,n.$1j)("person-add",60365),filterFilled:(0,n.$1j)("filter-filled",60366),wand:(0,n.$1j)("wand",60367),debugLineByLine:(0,n.$1j)("debug-line-by-line",60368),inspect:(0,n.$1j)("inspect",60369),layers:(0,n.$1j)("layers",60370),layersDot:(0,n.$1j)("layers-dot",60371),layersActive:(0,n.$1j)("layers-active",60372),compass:(0,n.$1j)("compass",60373),compassDot:(0,n.$1j)("compass-dot",60374),compassActive:(0,n.$1j)("compass-active",60375),azure:(0,n.$1j)("azure",60376),issueDraft:(0,n.$1j)("issue-draft",60377),gitPullRequestClosed:(0,n.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$1j)("git-pull-request-draft",60379),debugAll:(0,n.$1j)("debug-all",60380),debugCoverage:(0,n.$1j)("debug-coverage",60381),runErrors:(0,n.$1j)("run-errors",60382),folderLibrary:(0,n.$1j)("folder-library",60383),debugContinueSmall:(0,n.$1j)("debug-continue-small",60384),beakerStop:(0,n.$1j)("beaker-stop",60385),graphLine:(0,n.$1j)("graph-line",60386),graphScatter:(0,n.$1j)("graph-scatter",60387),pieChart:(0,n.$1j)("pie-chart",60388),bracket:(0,n.$1j)("bracket",60175),bracketDot:(0,n.$1j)("bracket-dot",60389),bracketError:(0,n.$1j)("bracket-error",60390),lockSmall:(0,n.$1j)("lock-small",60391),azureDevops:(0,n.$1j)("azure-devops",60392),verifiedFilled:(0,n.$1j)("verified-filled",60393),newline:(0,n.$1j)("newline",60394),layout:(0,n.$1j)("layout",60395),layoutActivitybarLeft:(0,n.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$1j)("layout-panel-right",60401),layoutPanel:(0,n.$1j)("layout-panel",60402),layoutSidebarLeft:(0,n.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$1j)("layout-statusbar",60405),layoutMenubar:(0,n.$1j)("layout-menubar",60406),layoutCentered:(0,n.$1j)("layout-centered",60407),target:(0,n.$1j)("target",60408),indent:(0,n.$1j)("indent",60409),recordSmall:(0,n.$1j)("record-small",60410),errorSmall:(0,n.$1j)("error-small",60411),terminalDecorationError:(0,n.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$1j)("layout-sidebar-left-off",60418),blank:(0,n.$1j)("blank",60419),heartFilled:(0,n.$1j)("heart-filled",60420),map:(0,n.$1j)("map",60421),mapHorizontal:(0,n.$1j)("map-horizontal",60421),foldHorizontal:(0,n.$1j)("fold-horizontal",60421),mapFilled:(0,n.$1j)("map-filled",60422),mapHorizontalFilled:(0,n.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$1j)("fold-horizontal-filled",60422),circleSmall:(0,n.$1j)("circle-small",60423),bellSlash:(0,n.$1j)("bell-slash",60424),bellSlashDot:(0,n.$1j)("bell-slash-dot",60425),commentUnresolved:(0,n.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$1j)("search-fuzzy",60429),commentDraft:(0,n.$1j)("comment-draft",60430),send:(0,n.$1j)("send",60431),sparkle:(0,n.$1j)("sparkle",60432),insert:(0,n.$1j)("insert",60433),mic:(0,n.$1j)("mic",60434),thumbsdownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$1j)("thumbsup-filled",60436),coffee:(0,n.$1j)("coffee",60437),snake:(0,n.$1j)("snake",60438),game:(0,n.$1j)("game",60439),vr:(0,n.$1j)("vr",60440),chip:(0,n.$1j)("chip",60441),piano:(0,n.$1j)("piano",60442),music:(0,n.$1j)("music",60443),micFilled:(0,n.$1j)("mic-filled",60444),repoFetch:(0,n.$1j)("repo-fetch",60445),copilot:(0,n.$1j)("copilot",60446),lightbulbSparkle:(0,n.$1j)("lightbulb-sparkle",60447),robot:(0,n.$1j)("robot",60448),sparkleFilled:(0,n.$1j)("sparkle-filled",60449),diffSingle:(0,n.$1j)("diff-single",60450),diffMultiple:(0,n.$1j)("diff-multiple",60451),surroundWith:(0,n.$1j)("surround-with",60452),share:(0,n.$1j)("share",60453),gitStash:(0,n.$1j)("git-stash",60454),gitStashApply:(0,n.$1j)("git-stash-apply",60455),gitStashPop:(0,n.$1j)("git-stash-pop",60456),vscode:(0,n.$1j)("vscode",60457),vscodeInsiders:(0,n.$1j)("vscode-insiders",60458),codeOss:(0,n.$1j)("code-oss",60459),runCoverage:(0,n.$1j)("run-coverage",60460),runAllCoverage:(0,n.$1j)("run-all-coverage",60461),coverage:(0,n.$1j)("coverage",60462),githubProject:(0,n.$1j)("github-project",60463),mapVertical:(0,n.$1j)("map-vertical",60464),foldVertical:(0,n.$1j)("fold-vertical",60464),mapVerticalFilled:(0,n.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$1j)("fold-vertical-filled",60465),goToSearch:(0,n.$1j)("go-to-search",60466),percentage:(0,n.$1j)("percentage",60467),sortPercentage:(0,n.$1j)("sort-percentage",60467),attach:(0,n.$1j)("attach",60468)}}),define(ve[57],Se([1,0,108,172]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=E;function E(){return Object.values(e.$6j)}e.$5j={dialogError:(0,n.$1j)("dialog-error","error"),dialogWarning:(0,n.$1j)("dialog-warning","warning"),dialogInfo:(0,n.$1j)("dialog-info","info"),dialogClose:(0,n.$1j)("dialog-close","close"),treeItemExpanded:(0,n.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$1j)("tree-filter-clear","close"),treeItemLoading:(0,n.$1j)("tree-item-loading","loading"),menuSelection:(0,n.$1j)("menu-selection","check"),menuSubmenu:(0,n.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$1j)("toolbar-more","more"),quickInputBack:(0,n.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$1j)("drop-down-button",60084),symbolCustomColor:(0,n.$1j)("symbol-customcolor",60252),exportIcon:(0,n.$1j)("export",60332),workspaceUnspecified:(0,n.$1j)("workspace-unspecified",60355),newLine:(0,n.$1j)("newline",60394),thumbsDownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$1j)("thumbsup-filled",60436),gitFetch:(0,n.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$1j)("debug-breakpoint-pending",60377)},e.$6j={...r.$3j,...e.$5j}}),define(ve[21],Se([1,0,11]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=r,e.$fo=E,e.$go=R,e.$ho=y,e.$io=o,e.$jo=D,e.$ko=v,e.$lo=h,e.$mo=w,e.$no=a,e.$oo=f,e.$po=m,e.$qo=$;function r(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const d=Array.isArray(b)?[]:{};return Object.entries(b).forEach(([p,t])=>{d[p]=t&&typeof t=="object"?r(t):t}),d}function E(b){if(!b||typeof b!="object")return b;const d=[b];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const t in p)if(k.call(p,t)){const l=p[t];typeof l=="object"&&!Object.isFrozen(l)&&!(0,n.$jg)(l)&&d.push(l)}}return b}const k=Object.prototype.hasOwnProperty;function R(b,d){return A(b,d,new Set)}function A(b,d,p){if((0,n.$pg)(b))return b;const t=d(b);if(typeof t<"u")return t;if(Array.isArray(b)){const l=[];for(const i of b)l.push(A(i,d,p));return l}if((0,n.$ig)(b)){if(p.has(b))throw new Error("Cannot clone recursive data-structure");p.add(b);const l={};for(const i in b)k.call(b,i)&&(l[i]=A(b[i],d,p));return p.delete(b),l}return b}function y(b,d,p=!0){return(0,n.$ig)(b)?((0,n.$ig)(d)&&Object.keys(d).forEach(t=>{t in b?p&&((0,n.$ig)(b[t])&&(0,n.$ig)(d[t])?y(b[t],d[t],p):b[t]=d[t]):b[t]=d[t]}),b):d}function o(b,d){if(b===d)return!0;if(b==null||d===null||d===void 0||typeof b!=typeof d||typeof b!="object"||Array.isArray(b)!==Array.isArray(d))return!1;let p,t;if(Array.isArray(b)){if(b.length!==d.length)return!1;for(p=0;p<b.length;p++)if(!o(b[p],d[p]))return!1}else{const l=[];for(t in b)l.push(t);l.sort();const i=[];for(t in d)i.push(t);if(i.sort(),!o(l,i))return!1;for(p=0;p<l.length;p++)if(!o(b[l[p]],d[l[p]]))return!1}return!0}function D(b){const d=new Set;return JSON.stringify(b,(p,t)=>{if((0,n.$ig)(t)||Array.isArray(t)){if(d.has(t))return"[Circular]";d.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function v(b,d){const p=Object.create(null);return!b||!d||Object.keys(d).forEach(l=>{const i=b[l],g=d[l];o(i,g)||(p[l]=g)}),p}function h(b,d){const p=d.toLowerCase(),t=Object.keys(b).find(l=>l.toLowerCase()===p);return t?b[t]:b[d]}function w(b,d){const p=Object.create(null);for(const[t,l]of Object.entries(b))d(t,l)&&(p[t]=l);return p}function a(b){let d=[];for(;Object.prototype!==b;)d=d.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return d}function f(b){const d=[];for(const p of a(b))typeof b[p]=="function"&&d.push(p);return d}function m(b,d){const p=l=>function(){const i=Array.prototype.slice.call(arguments,0);return d(l,i)},t={};for(const l of b)t[l]=p(l);return t}function $(b,d){const p={};for(const[t,l]of Object.entries(b))p[t]=d(l,t);return p}}),define(ve[82],Se([1,0,57]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=E;var r;(function(R){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}R.isThemeColor=A})(r||(e.ThemeColor=r={}));function E(R){return{id:R}}var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(b){const d=A.exec(b.id);if(!d)return y(n.$6j.error);const[,p,t]=d,l=["codicon","codicon-"+p];return t&&l.push("codicon-modifier-"+t.substring(1)),l}R.asClassNameArray=y;function o(b){return y(b).join(" ")}R.asClassName=o;function D(b){return"."+y(b).join(".")}R.asCSSSelector=D;function v(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(typeof b.color>"u"||r.isThemeColor(b.color))}R.isThemeIcon=v;const h=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(b){const d=h.exec(b);if(!d)return;const[,p]=d;return{id:p}}R.fromString=w;function a(b){return{id:b}}R.fromId=a;function f(b,d){let p=b.id;const t=p.lastIndexOf("~");return t!==-1&&(p=p.substring(0,t)),d&&(p=`${p}~${d}`),{id:p}}R.modify=f;function m(b){const d=b.id.lastIndexOf("~");if(d!==-1)return b.id.substring(d+1)}R.getModifier=m;function $(b,d){return b.id===d.id&&b.color?.id===d.color?.id}R.isEqual=$})(k||(e.ThemeIcon=k={}))}),define(ve[109],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=r,e.$df=E;var n;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(k){return k<0?0:k>n.MAX_UINT_8?n.MAX_UINT_8:k|0}function E(k){return k<0?0:k>n.MAX_UINT_32?n.MAX_UINT_32:k|0}}),define(ve[17],Se([1,0,169,35,65,109]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=R,e.$ff=y,e.$gf=D,e.$hf=v,e.$if=h,e.$jf=w,e.$kf=a,e.$lf=f,e.$mf=m,e.$nf=$,e.$of=b,e.$pf=d,e.$qf=p,e.$rf=t,e.$sf=l,e.$tf=i,e.$uf=g,e.$vf=s,e.$wf=c,e.$xf=u,e.$yf=S,e.$zf=P,e.$Af=C,e.$Bf=L,e.$Cf=T,e.$Df=I,e.$Ef=q,e.$Ff=Y,e.$Gf=Q,e.$Hf=re,e.$If=te,e.$Jf=_,e.$Kf=de,e.$Lf=J,e.$Mf=ae,e.$Nf=z,e.$Of=B,e.$Rf=H,e.$Sf=ce,e.$Tf=x,e.$Uf=U,e.$Vf=V,e.$Wf=G,e.$Yf=X,e.$Zf=F,e.$1f=W,e.$2f=oe,e.$3f=ke,e.$4f=Ne,e.$5f=$e,e.$7f=Pe,e.$8f=Oe,e.$9f=fe,e.$0f=De,e.$$f=Re,e.$_f=ze,e.$ag=We,e.$bg=Qe,e.$cg=lt;function R(be){return!be||typeof be!="string"?!0:be.trim().length===0}const A=/{(\d+)}/g;function y(be,...Le){return Le.length===0?be:be.replace(A,function(Fe,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=Le.length?Fe:Le[Ce]})}const o=/{([^}]+)}/g;function D(be,Le){return Object.keys(Le).length===0?be:be.replace(o,(Fe,ye)=>Le[ye]??Fe)}function v(be){return be.replace(/[<>"'&]/g,Le=>{switch(Le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Le})}function h(be){return be.replace(/[<>&]/g,function(Le){switch(Le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Le}})}function w(be){return be.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(be,Le){let Fe=0,ye=be.indexOf(Le);for(;ye!==-1;)Fe++,ye=be.indexOf(Le,ye+Le.length);return Fe}function f(be,Le,Fe="\u2026"){return be.length<=Le?be:`${be.substr(0,Le)}${Fe}`}function m(be,Le,Fe="\u2026"){if(be.length<=Le)return be;const ye=Math.ceil(Le/2)-Fe.length/2,Ce=Math.floor(Le/2)-Fe.length/2;return`${be.substr(0,ye)}${Fe}${be.substr(be.length-Ce)}`}function $(be,Le=" "){const Fe=b(be,Le);return d(Fe,Le)}function b(be,Le){if(!be||!Le)return be;const Fe=Le.length;if(Fe===0||be.length===0)return be;let ye=0;for(;be.indexOf(Le,ye)===ye;)ye=ye+Fe;return be.substring(ye)}function d(be,Le){if(!be||!Le)return be;const Fe=Le.length,ye=be.length;if(Fe===0||ye===0)return be;let Ce=ye,ne=-1;for(;ne=be.lastIndexOf(Le,Ce-1),!(ne===-1||ne+Fe!==Ce);){if(ne===0)return"";Ce=ne}return be.substring(0,Ce)}function p(be){return be.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(be){return be.replace(/\*/g,"")}function l(be,Le,Fe={}){if(!be)throw new Error("Cannot create regex from empty string");Le||(be=w(be)),Fe.wholeWord&&(/\B/.test(be.charAt(0))||(be="\\b"+be),/\B/.test(be.charAt(be.length-1))||(be=be+"\\b"));let ye="";return Fe.global&&(ye+="g"),Fe.matchCase||(ye+="i"),Fe.multiline&&(ye+="m"),Fe.unicode&&(ye+="u"),new RegExp(be,ye)}function i(be){return be.source==="^"||be.source==="^$"||be.source==="$"||be.source==="^\\s*$"?!1:!!(be.exec("")&&be.lastIndex===0)}function g(be){return be.split(/\r\n|\r|\n/)}function s(be){const Le=[],Fe=be.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(Fe.length/2);ye++)Le.push(Fe[2*ye]+(Fe[2*ye+1]??""));return Le}function c(be){for(let Le=0,Fe=be.length;Le<Fe;Le++){const ye=be.charCodeAt(Le);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return Le}return-1}function u(be,Le=0,Fe=be.length){for(let ye=Le;ye<Fe;ye++){const Ce=be.charCodeAt(ye);if(Ce!==r.CharCode.Space&&Ce!==r.CharCode.Tab)return be.substring(Le,ye)}return be.substring(Le,Fe)}function S(be,Le=be.length-1){for(let Fe=Le;Fe>=0;Fe--){const ye=be.charCodeAt(Fe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return Fe}return-1}function P(be,Le,Fe){const ye=[];let Ce=0;for(const ne of be.matchAll(Le)){if(ye.push(be.slice(Ce,ne.index)),ne.index===void 0)throw new Error("match.index should be defined");Ce=ne.index+ne[0].length,ye.push(Fe(ne[0],...ne.slice(1),ne.index,be,ne.groups))}return ye.push(be.slice(Ce)),Promise.all(ye).then(ne=>ne.join(""))}function C(be,Le){return be<Le?-1:be>Le?1:0}function L(be,Le,Fe=0,ye=be.length,Ce=0,ne=Le.length){for(;Fe<ye&&Ce<ne;Fe++,Ce++){const He=be.charCodeAt(Fe),Xe=Le.charCodeAt(Ce);if(He<Xe)return-1;if(He>Xe)return 1}const ee=ye-Fe,we=ne-Ce;return ee<we?-1:ee>we?1:0}function T(be,Le){return I(be,Le,0,be.length,0,Le.length)}function I(be,Le,Fe=0,ye=be.length,Ce=0,ne=Le.length){for(;Fe<ye&&Ce<ne;Fe++,Ce++){let He=be.charCodeAt(Fe),Xe=Le.charCodeAt(Ce);if(He===Xe)continue;if(He>=128||Xe>=128)return L(be.toLowerCase(),Le.toLowerCase(),Fe,ye,Ce,ne);Y(He)&&(He-=32),Y(Xe)&&(Xe-=32);const _e=He-Xe;if(_e!==0)return _e}const ee=ye-Fe,we=ne-Ce;return ee<we?-1:ee>we?1:0}function q(be){return be>=r.CharCode.Digit0&&be<=r.CharCode.Digit9}function Y(be){return be>=r.CharCode.a&&be<=r.CharCode.z}function Q(be){return be>=r.CharCode.A&&be<=r.CharCode.Z}function re(be,Le){return be.length===Le.length&&I(be,Le)===0}function te(be,Le){const Fe=Le.length;return Le.length>be.length?!1:I(be,Le,0,Fe)===0}function _(be,Le){const Fe=Math.min(be.length,Le.length);let ye;for(ye=0;ye<Fe;ye++)if(be.charCodeAt(ye)!==Le.charCodeAt(ye))return ye;return Fe}function de(be,Le){const Fe=Math.min(be.length,Le.length);let ye;const Ce=be.length-1,ne=Le.length-1;for(ye=0;ye<Fe;ye++)if(be.charCodeAt(Ce-ye)!==Le.charCodeAt(ne-ye))return ye;return Fe}function J(be){return 55296<=be&&be<=56319}function ae(be){return 56320<=be&&be<=57343}function z(be,Le){return(be-55296<<10)+(Le-56320)+65536}function B(be,Le,Fe){const ye=be.charCodeAt(Fe);if(J(ye)&&Fe+1<Le){const Ce=be.charCodeAt(Fe+1);if(ae(Ce))return z(ye,Ce)}return ye}function ie(be,Le){const Fe=be.charCodeAt(Le-1);if(ae(Fe)&&Le>1){const ye=be.charCodeAt(Le-2);if(J(ye))return z(ye,Fe)}return Fe}class le{get offset(){return this.e}constructor(Le,Fe=0){this.c=Le,this.d=Le.length,this.e=Fe}setOffset(Le){this.e=Le}prevCodePoint(){const Le=ie(this.c,this.e);return this.e-=Le>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Le}nextCodePoint(){const Le=B(this.c,this.d,this.e);return this.e+=Le>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Le}eol(){return this.e>=this.d}}e.$Pf=le;class pe{get offset(){return this.c.offset}constructor(Le,Fe=0){this.c=new le(Le,Fe)}nextGraphemeLength(){const Le=xe.getInstance(),Fe=this.c,ye=Fe.offset;let Ce=Le.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ne=Fe.offset,ee=Le.getGraphemeBreakType(Fe.nextCodePoint());if(Ke(Ce,ee)){Fe.setOffset(ne);break}Ce=ee}return Fe.offset-ye}prevGraphemeLength(){const Le=xe.getInstance(),Fe=this.c,ye=Fe.offset;let Ce=Le.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ne=Fe.offset,ee=Le.getGraphemeBreakType(Fe.prevCodePoint());if(Ke(ee,Ce)){Fe.setOffset(ne);break}Ce=ee}return ye-Fe.offset}eol(){return this.c.eol()}}e.$Qf=pe;function H(be,Le){return new pe(be,Le).nextGraphemeLength()}function ce(be,Le){return new pe(be,Le).prevGraphemeLength()}function x(be,Le){Le>0&&ae(be.charCodeAt(Le))&&Le--;const Fe=Le+H(be,Le);return[Fe-ce(be,Fe),Fe]}function U(be){const Le=new pe(be);let Fe=0;for(;!Le.eol();)Fe++,Le.nextGraphemeLength();return Fe}let O;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(be){return O||(O=Z()),O.test(be)}const M=/^[\t\n\r\x20-\x7E]*$/;function G(be){return M.test(be)}e.$Xf=/[\u2028\u2029]/;function X(be){return e.$Xf.test(be)}function F(be){return be>=11904&&be<=55215||be>=63744&&be<=64255||be>=65281&&be<=65374}function W(be){return be>=127462&&be<=127487||be===8986||be===8987||be===9200||be===9203||be>=9728&&be<=10175||be===11088||be===11093||be>=127744&&be<=128591||be>=128640&&be<=128764||be>=128992&&be<=129008||be>=129280&&be<=129535||be>=129648&&be<=129782}function oe(be,Le,Fe=""){const ye=be.trimStart();if(ye.length<Le)return ye;const Ce=/\b/g;let ne=0;for(;Ce.test(ye)&&!(ye.length-Ce.lastIndex<Le);)ne=Ce.lastIndex,Ce.lastIndex+=1;return ne===0?ye:Fe+ye.substring(ne).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ke(be){let Le=0;for(const Fe of be.matchAll(he))Le!==Fe.index&&(yield{isCode:!1,str:be.substring(Le,Fe.index)}),yield{isCode:!0,str:Fe[0]},Le=Fe.index+Fe[0].length;Le!==be.length&&(yield{isCode:!1,str:be.substring(Le)})}function Ne(be){return be&&(be=be.replace(he,"")),be}const me=/\\\[.*?\\\]/g;function $e(be){return Ne(be).replace(me,"")}e.$6f=String.fromCharCode(r.CharCode.UTF8_BOM);function Pe(be){return!!(be&&be.length>0&&be.charCodeAt(0)===r.CharCode.UTF8_BOM)}function Oe(be){return Pe(be)?be.substr(1):be}function fe(be,Le){if(!be||!Le||be.length<Le.length)return!1;const Fe=Le.length,ye=be.toLowerCase();let Ce=0,ne=-1;for(;Ce<Fe;){const ee=ye.indexOf(Le[Ce],ne+1);if(ee<0)return!1;ne=ee,Ce++}return!0}function De(be,Le=!1){return be?(Le&&(be=be.replace(/\\./g,"")),be.toLowerCase()!==be):!1}function Re(be){return be.charAt(0).toUpperCase()+be.slice(1)}function ze(be,Le=1){if(Le===0)return"";let Fe=-1;do Fe=be.indexOf(`
`,Fe+1),Le--;while(Le>0&&Fe>=0);return Fe===-1?be:(be[Fe-1]==="\r"&&Fe--,be.substr(0,Fe))}function We(be){const Le=r.CharCode.Z-r.CharCode.A+1;return be=be%(2*Le),be<Le?String.fromCharCode(r.CharCode.a+be):String.fromCharCode(r.CharCode.A+be-Le)}function Qe(be){return xe.getInstance().getGraphemeBreakType(be)}function Ke(be,Le){return be===Ge.Other?Le!==Ge.Extend&&Le!==Ge.SpacingMark:be===Ge.CR&&Le===Ge.LF?!1:be===Ge.Control||be===Ge.CR||be===Ge.LF||Le===Ge.Control||Le===Ge.CR||Le===Ge.LF?!0:!(be===Ge.L&&(Le===Ge.L||Le===Ge.V||Le===Ge.LV||Le===Ge.LVT)||(be===Ge.LV||be===Ge.V)&&(Le===Ge.V||Le===Ge.T)||(be===Ge.LVT||be===Ge.T)&&Le===Ge.T||Le===Ge.Extend||Le===Ge.ZWJ||Le===Ge.SpacingMark||be===Ge.Prepend||be===Ge.ZWJ&&Le===Ge.Extended_Pictographic||be===Ge.Regional_Indicator&&Le===Ge.Regional_Indicator)}var Ge;(function(be){be[be.Other=0]="Other",be[be.Prepend=1]="Prepend",be[be.CR=2]="CR",be[be.LF=3]="LF",be[be.Control=4]="Control",be[be.Extend=5]="Extend",be[be.Regional_Indicator=6]="Regional_Indicator",be[be.SpacingMark=7]="SpacingMark",be[be.L=8]="L",be[be.V=9]="V",be[be.T=10]="T",be[be.LV=11]="LV",be[be.LVT=12]="LVT",be[be.ZWJ=13]="ZWJ",be[be.Extended_Pictographic=14]="Extended_Pictographic"})(Ge||(e.GraphemeBreakType=Ge={}));class xe{static{this.c=null}static getInstance(){return xe.c||(xe.c=new xe),xe.c}constructor(){this.d=st()}getGraphemeBreakType(Le){if(Le<32)return Le===r.CharCode.LineFeed?Ge.LF:Le===r.CharCode.CarriageReturn?Ge.CR:Ge.Control;if(Le<127)return Ge.Other;const Fe=this.d,ye=Fe.length/3;let Ce=1;for(;Ce<=ye;)if(Le<Fe[3*Ce])Ce=2*Ce;else if(Le>Fe[3*Ce+1])Ce=2*Ce+1;else return Fe[3*Ce+2];return Ge.Other}}function st(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function lt(be,Le){if(be===0)return 0;const Fe=rt(be,Le);if(Fe!==void 0)return Fe;const ye=new le(Le,be);return ye.prevCodePoint(),ye.offset}function rt(be,Le){const Fe=new le(Le,be);let ye=Fe.prevCodePoint();for(;nt(ye)||ye===tt.emojiVariantSelector||ye===tt.enclosingKeyCap;){if(Fe.offset===0)return;ye=Fe.prevCodePoint()}if(!W(ye))return;let Ce=Fe.offset;return Ce>0&&Fe.prevCodePoint()===tt.zwj&&(Ce=Fe.offset),Ce}function nt(be){return 127995<=be&&be<=127999}var tt;(function(be){be[be.zwj=8205]="zwj",be[be.emojiVariantSelector=65039]="emojiVariantSelector",be[be.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.$dg="\xA0";class et{static{this.c=new E.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$af({getCacheKey:JSON.stringify},Le=>{function Fe(_e){const it=new Map;for(let ut=0;ut<_e.length;ut+=2)it.set(_e[ut],_e[ut+1]);return it}function ye(_e,it){const ut=new Map(_e);for(const[gt,bt]of it)ut.set(gt,bt);return ut}function Ce(_e,it){if(!_e)return it;const ut=new Map;for(const[gt,bt]of _e)it.has(gt)&&ut.set(gt,bt);return ut}const ne=this.c.value;let ee=Le.filter(_e=>!_e.startsWith("_")&&_e in ne);ee.length===0&&(ee=["_default"]);let we;for(const _e of ee){const it=Fe(ne[_e]);we=Ce(we,it)}const He=Fe(ne._common),Xe=ye(He,we);return new et(Xe)})}static getInstance(Le){return et.d.get(Array.from(Le))}static{this.e=new E.$X(()=>Object.keys(et.c.value).filter(Le=>!Le.startsWith("_")))}static getLocales(){return et.e.value}constructor(Le){this.f=Le}isAmbiguous(Le){return this.f.has(Le)}containsAmbiguousCharacter(Le){for(let Fe=0;Fe<Le.length;Fe++){const ye=Le.codePointAt(Fe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(Le){return this.f.get(Le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=et;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(Le){return Ze.e().has(Le)}static containsInvisibleCharacter(Le){for(let Fe=0;Fe<Le.length;Fe++){const ye=Le.codePointAt(Fe);if(typeof ye=="number"&&Ze.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ze.e()}}e.$fg=Ze}),define(ve[173],Se([1,0,35,26,162,17]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=R,e.$Jk=y,e.$Kk=o,e.$Lk=h,e.$Mk=S,e.$Nk=P,e.$Ok=Y,e.$Pk=Q,e.$Qk=re,e.$Rk=te,e.$Sk=Z,e.$Uk=X,e.$Vk=oe,e.$Wk=he,k=qe(k);function R(...me){return function($e,Pe){for(let Oe=0,fe=me.length;Oe<fe;Oe++){const De=me[Oe]($e,Pe);if(De)return De}return null}}e.$Hk=A.bind(void 0,!1),e.$Ik=A.bind(void 0,!0);function A(me,$e,Pe){if(!Pe||Pe.length<$e.length)return null;let Oe;return me?Oe=k.$If(Pe,$e):Oe=Pe.indexOf($e)===0,Oe?$e.length>0?[{start:0,end:$e.length}]:[]:null}function y(me,$e){const Pe=$e.toLowerCase().indexOf(me.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+me.length}]}function o(me,$e){return D(me.toLowerCase(),$e.toLowerCase(),0,0)}function D(me,$e,Pe,Oe){if(Pe===me.length)return[];if(Oe===$e.length)return null;if(me[Pe]===$e[Oe]){let fe=null;return(fe=D(me,$e,Pe+1,Oe+1))?t({start:Oe,end:Oe+1},fe):null}return D(me,$e,Pe,Oe+1)}function v(me){return n.CharCode.a<=me&&me<=n.CharCode.z}function h(me){return n.CharCode.A<=me&&me<=n.CharCode.Z}function w(me){return n.CharCode.Digit0<=me&&me<=n.CharCode.Digit9}function a(me){return me===n.CharCode.Space||me===n.CharCode.Tab||me===n.CharCode.LineFeed||me===n.CharCode.CarriageReturn}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>f.add(me.charCodeAt(0)));function m(me){return a(me)||f.has(me)}function $(me,$e){return me===$e||m(me)&&m($e)}const b=new Map;function d(me){if(b.has(me))return b.get(me);let $e;const Pe=(0,E.$Fk)(me);return Pe&&($e=Pe),b.set(me,$e),$e}function p(me){return v(me)||h(me)||w(me)}function t(me,$e){return $e.length===0?$e=[me]:me.end===$e[0].start?$e[0].start=me.start:$e.unshift(me),$e}function l(me,$e){for(let Pe=$e;Pe<me.length;Pe++){const Oe=me.charCodeAt(Pe);if(h(Oe)||w(Oe)||Pe>0&&!p(me.charCodeAt(Pe-1)))return Pe}return me.length}function i(me,$e,Pe,Oe){if(Pe===me.length)return[];if(Oe===$e.length)return null;if(me[Pe]!==$e[Oe].toLowerCase())return null;{let fe=null,De=Oe+1;for(fe=i(me,$e,Pe+1,Oe+1);!fe&&(De=l($e,De))<$e.length;)fe=i(me,$e,Pe+1,De),De++;return fe===null?null:t({start:Oe,end:Oe+1},fe)}}function g(me){let $e=0,Pe=0,Oe=0,fe=0,De=0;for(let Ke=0;Ke<me.length;Ke++)De=me.charCodeAt(Ke),h(De)&&$e++,v(De)&&Pe++,p(De)&&Oe++,w(De)&&fe++;const Re=$e/me.length,ze=Pe/me.length,We=Oe/me.length,Qe=fe/me.length;return{upperPercent:Re,lowerPercent:ze,alphaPercent:We,numericPercent:Qe}}function s(me){const{upperPercent:$e,lowerPercent:Pe}=me;return Pe===0&&$e>.6}function c(me){const{upperPercent:$e,lowerPercent:Pe,alphaPercent:Oe,numericPercent:fe}=me;return Pe>.2&&$e<.8&&Oe>.6&&fe<.2}function u(me){let $e=0,Pe=0,Oe=0,fe=0;for(let De=0;De<me.length;De++)Oe=me.charCodeAt(De),h(Oe)&&$e++,v(Oe)&&Pe++,a(Oe)&&fe++;return($e===0||Pe===0)&&fe===0?me.length<=30:$e<=5}function S(me,$e){if(!$e||($e=$e.trim(),$e.length===0)||!u(me))return null;$e.length>60&&($e=$e.substring(0,60));const Pe=g($e);if(!c(Pe)){if(!s(Pe))return null;$e=$e.toLowerCase()}let Oe=null,fe=0;for(me=me.toLowerCase();fe<$e.length&&(Oe=i(me,$e,0,fe))===null;)fe=l($e,fe+1);return Oe}function P(me,$e,Pe=!1){if(!$e||$e.length===0)return null;let Oe=null,fe=0;for(me=me.toLowerCase(),$e=$e.toLowerCase();fe<$e.length&&(Oe=C(me,$e,0,fe,Pe),Oe===null);)fe=L($e,fe+1);return Oe}function C(me,$e,Pe,Oe,fe){let De=0;if(Pe===me.length)return[];if(Oe===$e.length)return null;if(!$(me.charCodeAt(Pe),$e.charCodeAt(Oe))){const We=d(me.charCodeAt(Pe));if(!We)return null;for(let Qe=0;Qe<We.length;Qe++)if(!$(We[Qe],$e.charCodeAt(Oe+Qe)))return null;De+=We.length-1}let Re=null,ze=Oe+De+1;if(Re=C(me,$e,Pe+1,ze,fe),!fe)for(;!Re&&(ze=L($e,ze))<$e.length;)Re=C(me,$e,Pe+1,ze,fe),ze++;if(!Re)return null;if(me.charCodeAt(Pe)!==$e.charCodeAt(Oe)){const We=d(me.charCodeAt(Pe));if(!We)return Re;for(let Qe=0;Qe<We.length;Qe++)if(We[Qe]!==$e.charCodeAt(Oe+Qe))return Re}return t({start:Oe,end:Oe+De+1},Re)}function L(me,$e){for(let Pe=$e;Pe<me.length;Pe++)if(m(me.charCodeAt(Pe))||Pe>0&&m(me.charCodeAt(Pe-1)))return Pe;return me.length}const T=R(e.$Ik,S,y),I=R(e.$Ik,S,o),q=new r.$Gc(1e4);function Y(me,$e,Pe=!1){if(typeof me!="string"||typeof $e!="string")return null;let Oe=q.get(me);Oe||(Oe=new RegExp(k.$qf(me),"i"),q.set(me,Oe));const fe=Oe.exec($e);return fe?[{start:fe.index,end:fe.index+fe[0].length}]:Pe?I(me,$e):T(me,$e)}function Q(me,$e){const Pe=X(me,me.toLowerCase(),0,$e,$e.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Pe?te(Pe):null}function re(me,$e,Pe,Oe,fe,De){const Re=Math.min(13,me.length);for(;Pe<Re;Pe++){const ze=X(me,$e,Pe,Oe,fe,De,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ze)return ze}return[0,De]}function te(me){if(typeof me>"u")return[];const $e=[],Pe=me[1];for(let Oe=me.length-1;Oe>1;Oe--){const fe=me[Oe]+Pe,De=$e[$e.length-1];De&&De.end===fe?De.end=fe+1:$e.push({start:fe,end:fe+1})}return $e}const _=128;function de(){const me=[],$e=[];for(let Pe=0;Pe<=_;Pe++)$e[Pe]=0;for(let Pe=0;Pe<=_;Pe++)me.push($e.slice(0));return me}function J(me){const $e=[];for(let Pe=0;Pe<=me;Pe++)$e[Pe]=0;return $e}const ae=J(2*_),z=J(2*_),B=de(),ie=de(),le=de(),pe=!1;function H(me,$e,Pe,Oe,fe){function De(ze,We,Qe=" "){for(;ze.length<We;)ze=Qe+ze;return ze}let Re=` |   |${Oe.split("").map(ze=>De(ze,3)).join("|")}
`;for(let ze=0;ze<=Pe;ze++)ze===0?Re+=" |":Re+=`${$e[ze-1]}|`,Re+=me[ze].slice(0,fe+1).map(We=>De(We.toString(),3)).join("|")+`
`;return Re}function ce(me,$e,Pe,Oe){me=me.substr($e),Pe=Pe.substr(Oe),console.log(H(ie,me,me.length,Pe,Pe.length)),console.log(H(le,me,me.length,Pe,Pe.length)),console.log(H(B,me,me.length,Pe,Pe.length))}function x(me,$e){if($e<0||$e>=me.length)return!1;const Pe=me.codePointAt($e);switch(Pe){case n.CharCode.Underline:case n.CharCode.Dash:case n.CharCode.Period:case n.CharCode.Space:case n.CharCode.Slash:case n.CharCode.Backslash:case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.Colon:case n.CharCode.DollarSign:case n.CharCode.LessThan:case n.CharCode.GreaterThan:case n.CharCode.OpenParen:case n.CharCode.CloseParen:case n.CharCode.OpenSquareBracket:case n.CharCode.CloseSquareBracket:case n.CharCode.OpenCurlyBrace:case n.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!k.$1f(Pe)}}function U(me,$e){if($e<0||$e>=me.length)return!1;switch(me.charCodeAt($e)){case n.CharCode.Space:case n.CharCode.Tab:return!0;default:return!1}}function O(me,$e,Pe){return $e[me]!==Pe[me]}function Z(me,$e,Pe,Oe,fe,De,Re=!1){for(;$e<Pe&&fe<De;)me[$e]===Oe[fe]&&(Re&&(ae[$e]=fe),$e+=1),fe+=1;return $e===Pe}var V;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(V||(V={}));var M;(function(me){me.Default=[-100,0];function $e(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}me.isDefault=$e})(M||(e.FuzzyScore=M={}));class G{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor($e,Pe){this.firstMatchCanBeWeak=$e,this.boostFullMatch=Pe}}e.$Tk=G;function X(me,$e,Pe,Oe,fe,De,Re=G.default){const ze=me.length>_?_:me.length,We=Oe.length>_?_:Oe.length;if(Pe>=ze||De>=We||ze-Pe>We-De||!Z($e,Pe,ze,fe,De,We,!0))return;F(ze,We,Pe,De,$e,fe);let Qe=1,Ke=1,Ge=Pe,xe=De;const st=[!1];for(Qe=1,Ge=Pe;Ge<ze;Qe++,Ge++){const et=ae[Ge],Ze=z[Ge],be=Ge+1<ze?z[Ge+1]:We;for(Ke=et-De+1,xe=et;xe<be;Ke++,xe++){let Le=Number.MIN_SAFE_INTEGER,Fe=!1;xe<=Ze&&(Le=W(me,$e,Ge,Pe,Oe,fe,xe,We,De,B[Qe-1][Ke-1]===0,st));let ye=0;Le!==Number.MAX_SAFE_INTEGER&&(Fe=!0,ye=Le+ie[Qe-1][Ke-1]);const Ce=xe>et,ne=Ce?ie[Qe][Ke-1]+(B[Qe][Ke-1]>0?-5:0):0,ee=xe>et+1&&B[Qe][Ke-1]>0,we=ee?ie[Qe][Ke-2]+(B[Qe][Ke-2]>0?-5:0):0;if(ee&&(!Ce||we>=ne)&&(!Fe||we>=ye))ie[Qe][Ke]=we,le[Qe][Ke]=V.LeftLeft,B[Qe][Ke]=0;else if(Ce&&(!Fe||ne>=ye))ie[Qe][Ke]=ne,le[Qe][Ke]=V.Left,B[Qe][Ke]=0;else if(Fe)ie[Qe][Ke]=ye,le[Qe][Ke]=V.Diag,B[Qe][Ke]=B[Qe-1][Ke-1]+1;else throw new Error("not possible")}}if(pe&&ce(me,Pe,Oe,De),!st[0]&&!Re.firstMatchCanBeWeak)return;Qe--,Ke--;const lt=[ie[Qe][Ke],De];let rt=0,nt=0;for(;Qe>=1;){let et=Ke;do{const Ze=le[Qe][et];if(Ze===V.LeftLeft)et=et-2;else if(Ze===V.Left)et=et-1;else break}while(et>=1);rt>1&&$e[Pe+Qe-1]===fe[De+Ke-1]&&!O(et+De-1,Oe,fe)&&rt+1>B[Qe][et]&&(et=Ke),et===Ke?rt++:rt=1,nt||(nt=et),Qe--,Ke=et-1,lt.push(Ke)}We-De===ze&&Re.boostFullMatch&&(lt[0]+=2);const tt=nt-ze;return lt[0]-=tt,lt}function F(me,$e,Pe,Oe,fe,De){let Re=me-1,ze=$e-1;for(;Re>=Pe&&ze>=Oe;)fe[Re]===De[ze]&&(z[Re]=ze,Re--),ze--}function W(me,$e,Pe,Oe,fe,De,Re,ze,We,Qe,Ke){if($e[Pe]!==De[Re])return Number.MIN_SAFE_INTEGER;let Ge=1,xe=!1;return Re===Pe-Oe?Ge=me[Pe]===fe[Re]?7:5:O(Re,fe,De)&&(Re===0||!O(Re-1,fe,De))?(Ge=me[Pe]===fe[Re]?7:5,xe=!0):x(De,Re)&&(Re===0||!x(De,Re-1))?Ge=5:(x(De,Re-1)||U(De,Re-1))&&(Ge=5,xe=!0),Ge>1&&Pe===Oe&&(Ke[0]=!0),xe||(xe=O(Re,fe,De)||x(De,Re-1)||U(De,Re-1)),Pe===Oe?Re>We&&(Ge-=xe?3:5):Qe?Ge+=xe?2:0:Ge+=xe?0:1,Re+1===ze&&(Ge-=xe?3:5),Ge}function oe(me,$e,Pe,Oe,fe,De,Re){return ke(me,$e,Pe,Oe,fe,De,!0,Re)}function he(me,$e,Pe,Oe,fe,De,Re){return ke(me,$e,Pe,Oe,fe,De,!1,Re)}function ke(me,$e,Pe,Oe,fe,De,Re,ze){let We=X(me,$e,Pe,Oe,fe,De,ze);if(We&&!Re)return We;if(me.length>=3){const Qe=Math.min(7,me.length-1);for(let Ke=Pe+1;Ke<Qe;Ke++){const Ge=Ne(me,Ke);if(Ge){const xe=X(Ge,Ge.toLowerCase(),Pe,Oe,fe,De,ze);xe&&(xe[0]-=3,(!We||xe[0]>We[0])&&(We=xe))}}}return We}function Ne(me,$e){if($e+1>=me.length)return;const Pe=me[$e],Oe=me[$e+1];if(Pe!==Oe)return me.slice(0,$e)+Oe+Pe+me.slice($e+2)}}),define(ve[66],Se([1,0,17]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=r,e.$vj=E,e.$wj=k,e.$xj=A,e.$zj=f,n=qe(n);function r($){return E($,0)}function E($,b){switch(typeof $){case"object":return $===null?k(349,b):Array.isArray($)?y($,b):o($,b);case"string":return A($,b);case"boolean":return R($,b);case"number":return k($,b);case"undefined":return k(937,b);default:return k(617,b)}}function k($,b){return(b<<5)-b+$|0}function R($,b){return k($?433:863,b)}function A($,b){b=k(149417,b);for(let d=0,p=$.length;d<p;d++)b=k($.charCodeAt(d),b);return b}function y($,b){return b=k(104579,b),$.reduce((d,p)=>E(p,d),b)}function o($,b){return b=k(181387,b),Object.keys($).sort().reduce((d,p)=>(d=A(p,d),E($[p],d)),b)}class D{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=E(b,this.g),this.g}}e.$yj=D;var v;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function h($,b,d=32){const p=d-b,t=~((1<<p)-1);return($<<b|(t&$)>>>p)>>>0}function w($,b=0,d=$.byteLength,p=0){for(let t=0;t<d;t++)$[b+t]=p}function a($,b,d="0"){for(;$.length<b;)$=d+$;return $}function f($,b=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(d=>d.toString(16).padStart(2,"0")).join(""):a(($>>>0).toString(16),b/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(v.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const d=b.length;if(d===0)return;const p=this.p;let t=this.r,l=this.u,i,g;for(l!==0?(i=l,g=-1,l=0):(i=b.charCodeAt(0),g=0);;){let s=i;if(n.$Lf(i))if(g+1<d){const c=b.charCodeAt(g+1);n.$Mf(c)?(g++,s=n.$Nf(i,c)):s=v.UNICODE_REPLACEMENT}else{l=i;break}else n.$Mf(i)&&(s=v.UNICODE_REPLACEMENT);if(t=this.w(p,t,s),g++,g<d)i=b.charCodeAt(g);else break}this.r=t,this.u=l}w(b,d,p){return p<128?b[d++]=p:p<2048?(b[d++]=192|(p&1984)>>>6,b[d++]=128|(p&63)>>>0):p<65536?(b[d++]=224|(p&61440)>>>12,b[d++]=128|(p&4032)>>>6,b[d++]=128|(p&63)>>>0):(b[d++]=240|(p&1835008)>>>18,b[d++]=128|(p&258048)>>>12,b[d++]=128|(p&4032)>>>6,b[d++]=128|(p&63)>>>0),d>=v.BLOCK_SIZE&&(this.y(),d-=v.BLOCK_SIZE,this.t+=v.BLOCK_SIZE,b[0]=b[v.BLOCK_SIZE+0],b[1]=b[v.BLOCK_SIZE+1],b[2]=b[v.BLOCK_SIZE+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,v.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=m.g,d=this.q;for(let S=0;S<64;S+=4)b.setUint32(S,d.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)b.setUint32(S,h(b.getUint32(S-12,!1)^b.getUint32(S-32,!1)^b.getUint32(S-56,!1)^b.getUint32(S-64,!1),1),!1);let p=this.h,t=this.l,l=this.m,i=this.n,g=this.o,s,c,u;for(let S=0;S<80;S++)S<20?(s=t&l|~t&i,c=1518500249):S<40?(s=t^l^i,c=1859775393):S<60?(s=t&l|t&i|l&i,c=2400959708):(s=t^l^i,c=3395469782),u=h(p,5)+s+g+c+b.getUint32(S*4,!1)&4294967295,g=i,i=l,l=h(t,30),t=p,p=u;this.h=this.h+p&4294967295,this.l=this.l+t&4294967295,this.m=this.m+l&4294967295,this.n=this.n+i&4294967295,this.o=this.o+g&4294967295}}e.$Aj=m}),define(ve[174],Se([1,0,173,17,82]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=y,e.$Yk=D,e.$Zk=h,e.$1k=w,e.$2k=f,e.$3k=m;const k="$(",R=new RegExp(`\\$\\(${E.ThemeIcon.iconNameExpression}(?:${E.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function y($){return $.replace(A,(b,d)=>d?b:`\\${b}`)}const o=new RegExp(`\\\\${R.source}`,"g");function D($){return $.replace(o,b=>`\\${b}`)}const v=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function h($){return $.indexOf(k)===-1?$:$.replace(v,(b,d,p,t)=>p?b:d||t||"")}function w($){return $?$.replace(/\$\((.*?)\)/g,(b,d)=>` ${d} `).trim():""}const a=new RegExp(`\\$\\(${E.ThemeIcon.iconNameCharacter}+\\)`,"g");function f($){a.lastIndex=0;let b="";const d=[];let p=0;for(;;){const t=a.lastIndex,l=a.exec($),i=$.substring(t,l?.index);if(i.length>0){b+=i;for(let g=0;g<i.length;g++)d.push(p)}if(!l)break;p+=l[0].length}return{text:b,iconOffsets:d}}function m($,b,d=!1){const{text:p,iconOffsets:t}=b;if(!t||t.length===0)return(0,n.$Ok)($,p,d);const l=(0,r.$of)(p," "),i=p.length-l.length,g=(0,n.$Ok)($,l,d);if(g)for(const s of g){const c=t[s.start+i]+i;s.start+=c,s.end+=c}return g}}),define(ve[58],Se([1,0,17]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=qe(n);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const k="error",R="warning",A="warn",y="info",o="ignore";function D(h){return h?n.$Hf(k,h)?E.Error:n.$Hf(R,h)||n.$Hf(A,h)?E.Warning:n.$Hf(y,h)?E.Info:E.Ignore:E.Ignore}E.fromValue=D;function v(h){switch(h){case E.Error:return k;case E.Warning:return R;case E.Info:return y;default:return o}}E.toString=v}(r||(r={})),e.default=r}),define(ve[67],Se([1,0,18,35,17]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class k{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const f=a.charCodeAt(0),m=this.b.charCodeAt(this.c);return f-m}value(){return this.b[this.c]}}e.$Ii=k;class R{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,E.$Bf)(a,this.b,0,a.length,this.c,this.d):(0,E.$Df)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=R;class A{constructor(a=!0,f=!0){this.f=a,this.g=f}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let f=a.length-1;f>=0;f--,this.c--){const m=this.b.charCodeAt(f);if(!(m===r.CharCode.Slash||this.f&&m===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===r.CharCode.Slash||this.f&&f===r.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,E.$Bf)(a,this.b,0,a.length,this.d,this.e):(0,E.$Df)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=A;var y;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(y||(y={}));class o{constructor(a,f){this.f=a,this.g=f,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new A(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(y.Path)),this.g(a)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===y.Scheme)return(0,E.$Cf)(a,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,E.$Cf)(a,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(a);if(this.d[this.e]===y.Query)return(0,E.$Af)(a,this.c.query);if(this.d[this.e]===y.Fragment)return(0,E.$Af)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}e.$Li=o;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(v||(v={}));class h{static forUris(a=()=>!1,f=()=>!1){return new h(new o(a,f))}static forPaths(a=!1){return new h(new A(void 0,!a))}static forStrings(){return new h(new k)}static forConfigKeys(){return new h(new R)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,f){if(f){const m=f.slice(0);(0,n.$Zb)(m);for(const $ of m)this.set($,a)}else{const m=a.slice(0);(0,n.$Zb)(m);for(const $ of m)this.set($[0],$[1])}}set(a,f){const m=this.b.reset(a);let $;this.c||(this.c=new D,this.c.segment=m.value());const b=[];for($=this.c;;){const p=m.cmp($.segment);if(p>0)$.left||($.left=new D,$.left.segment=m.value()),b.push([v.Left,$]),$=$.left;else if(p<0)$.right||($.right=new D,$.right.segment=m.value()),b.push([v.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new D,$.mid.segment=m.value()),b.push([v.Mid,$]),$=$.mid;else break}const d=$.value;$.value=f,$.key=a;for(let p=b.length-1;p>=0;p--){const t=b[p][1];t.updateHeight();const l=t.balanceFactor();if(l<-1||l>1){const i=b[p][0],g=b[p+1][0];if(i===v.Right&&g===v.Right)b[p][1]=t.rotateLeft();else if(i===v.Left&&g===v.Left)b[p][1]=t.rotateRight();else if(i===v.Right&&g===v.Left)t.right=b[p+1][1]=b[p+1][1].rotateRight(),b[p][1]=t.rotateLeft();else if(i===v.Left&&g===v.Right)t.left=b[p+1][1]=b[p+1][1].rotateLeft(),b[p][1]=t.rotateRight();else throw new Error;if(p>0)switch(b[p-1][0]){case v.Left:b[p-1][1].left=b[p][1];break;case v.Right:b[p-1][1].right=b[p][1];break;case v.Mid:b[p-1][1].mid=b[p][1];break}else this.c=b[0][1]}}return d}get(a){return this.d(a)?.value}d(a){const f=this.b.reset(a);let m=this.c;for(;m;){const $=f.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(f.hasNext())f.next(),m=m.mid;else break}return m}has(a){const f=this.d(a);return!(f?.value===void 0&&f?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,f){const m=this.b.reset(a),$=[];let b=this.c;for(;b;){const d=m.cmp(b.segment);if(d>0)$.push([v.Left,b]),b=b.left;else if(d<0)$.push([v.Right,b]),b=b.right;else if(m.hasNext())m.next(),$.push([v.Mid,b]),b=b.mid;else break}if(b){if(f?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const d=this.f(b.right);if(d.key){const{key:p,value:t,segment:l}=d;this.e(d.key,!1),b.key=p,b.value=t,b.segment=l}}else{const d=b.left??b.right;if($.length>0){const[p,t]=$[$.length-1];switch(p){case v.Left:t.left=d;break;case v.Mid:t.mid=d;break;case v.Right:t.right=d;break}}else this.c=d}for(let d=$.length-1;d>=0;d--){const p=$[d][1];p.updateHeight();const t=p.balanceFactor();if(t>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),$[d][1]=p.rotateLeft()):t<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),$[d][1]=p.rotateRight()),d>0)switch($[d-1][0]){case v.Left:$[d-1][1].left=$[d][1];break;case v.Right:$[d-1][1].right=$[d][1];break;case v.Mid:$[d-1][1].mid=$[d][1];break}else this.c=$[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const f=this.b.reset(a);let m=this.c,$;for(;m;){const b=f.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(f.hasNext())f.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(a){return this.g(a,!1)}g(a,f){const m=this.b.reset(a);let $=this.c;for(;$;){const b=m.cmp($.segment);if(b>0)$=$.left;else if(b<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):f?$.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[f,m]of this)a(m,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const f=[];return this.j(a,f),f[Symbol.iterator]()}j(a,f){a&&(a.left&&this.j(a.left,f),a.value&&f.push([a.key,a.value]),a.mid&&this.j(a.mid,f),a.right&&this.j(a.right,f))}_isBalanced(){const a=f=>{if(!f)return!0;const m=f.balanceFactor();return m<-1||m>1?!1:a(f.left)&&a(f.right)};return a(this.c)}}e.$Mi=h}),define(ve[23],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return n.test(E)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const k=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,o="";return o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o+="-",o+=R[k[y++]],o+=R[k[y++]],o+="-",o+=R[k[y++]],o+=R[k[y++]],o+="-",o+=R[k[y++]],o+=R[k[y++]],o+="-",o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o+=R[k[y++]],o}}()}),define(ve[175],Se([1,0,18,40,23]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=k,e.$nu=R,e.$pu=o;function k(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function R(v,h,w){const a={id:(0,E.$3g)(),name:v,uri:h,data:w};return{asString:async()=>"",asFile:()=>a,value:void 0}}class A{constructor(){this.a=new Map}get size(){let h=0;for(const w of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const w=[...this.a.keys()];return r.Iterable.some(this,([a,f])=>f.asFile())&&w.push("files"),D(y(h),w)}get(h){return this.a.get(this.b(h))?.[0]}append(h,w){const a=this.a.get(h);a?a.push(w):this.a.set(this.b(h),[w])}replace(h,w){this.a.set(this.b(h),[w])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,w]of this.a)for(const a of w)yield[h,a]}b(h){return y(h)}}e.$ou=A;function y(v){return v.toLowerCase()}function o(v,h){return D(y(v),h.map(y))}function D(v,h){if(v==="*/*")return h.length>0;if(h.includes(v))return!0;const w=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[a,f,m]=w;return m==="*"?h.some($=>$.startsWith(f+"/")):!1}e.$qu=Object.freeze({create:v=>(0,n.$Pb)(v.map(h=>h.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$qu.split(v).filter(h=>!h.startsWith("#"))})}),function(){"use strict";function se(e,n,r){function E(w){return new Promise(a=>n.exists(w,a))}function k(w){return new Promise((a,f)=>{const m=new Date;n.utimes(w,m,m,$=>$?f($):a())})}function R(w){return new Promise((a,f)=>n.mkdir(w,{recursive:!0},m=>m&&m.code!=="EEXIST"?f(m):a(w)))}function A(w){return new Promise((a,f)=>n.rm(w,{recursive:!0,force:!0,maxRetries:3},m=>m?f(m):a()))}function y(w){return new Promise((a,f)=>n.readFile(w,"utf8",(m,$)=>m?f(m):a($)))}function o(w,a){return new Promise((f,m)=>n.writeFile(w,a,"utf8",$=>$?m($):f()))}async function D(w){const a=e.join(w,"languagepacks.json");try{return JSON.parse(await y(a))}catch{}}function v(w,a){try{for(;a;){if(w[a])return a;{const f=a.lastIndexOf("-");if(f>0)a=a.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function h(w,a,f,m,$){const b=function(p){return r.mark("code/didGenerateNls"),Promise.resolve({locale:p,osLocale:$,availableLanguages:{}})};if(r.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:$,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:$,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:$,availableLanguages:{}});const d=m;try{return w?D(a).then(p=>{if(!p)return b(d);const t=v(p,m);if(!t)return b(d);m=t;const l=p[m];let i;return!l||typeof l.hash!="string"||!l.translations||typeof(i=l.translations.vscode)!="string"?b(d):E(i).then(g=>{if(!g)return b(d);const s=l.hash+"."+m,c=e.join(a,"clp",s),u=e.join(c,w),S=e.join(c,"tcf.json"),P=e.join(c,"corrupted.info"),C={locale:d,osLocale:$,availableLanguages:{"*":m},_languagePackId:s,_translationsConfigFile:S,_cacheRoot:c,_resolvedLanguagePackCoreLocation:u,_corruptedFile:P};return E(P).then(L=>{let T;return L?T=A(c):T=Promise.resolve(void 0),T.then(()=>E(u).then(I=>I?(k(u).catch(()=>{}),r.mark("code/didGenerateNls"),C):R(u).then(()=>Promise.all([y(f),y(i)])).then(q=>{const Y=JSON.parse(q[0]),Q=JSON.parse(q[1]).contents,re=Object.keys(Y.bundles),te=[];for(const _ of re){const de=Y.bundles[_],J=Object.create(null);for(const ae of de){const z=Y.keys[ae],B=Y.messages[ae],ie=Q[ae];let le;if(ie){le=[];for(let pe=0;pe<z.length;pe++){const H=z[pe],ce=typeof H=="string"?H:H.key;let x=ie[ce];x===void 0&&(x=B[pe]),le.push(x)}}else le=B;J[ae]=le}te.push(o(e.join(u,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(J)))}return te.push(o(S,JSON.stringify(l.translations))),Promise.all(te)}).then(()=>(r.mark("code/didGenerateNls"),C)).catch(q=>(console.error("Generating translation files failed.",q),b(m)))))})})}):b(d)}catch(p){return console.error("Generating translation files failed.",p),b(m)}}return{getNLSConfiguration:h}}if(typeof define=="function")define(ve[176],Se([83,31,44]),function(e,n,r){return se(e,n,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("fs"),r=require("../common/performance");module.exports=se(e,n,r)}else throw new Error("Unknown context")}(),define(ve[177],Se([1,0,32]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=k;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(R){const A=R.replace(/\-/g,":").toLowerCase();return!r.has(A)}function k(){const R=(0,n.networkInterfaces)();for(const A in R){const y=R[A];if(y){for(const{mac:o}of y)if(E(o))return o}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ve[178],Se([1,0,84]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=r,e.$7g=k,n=qe(n);function r(A,y,o,D=1){let v=!1;return new Promise(h=>{const w=setTimeout(()=>{if(!v)return v=!0,h(0)},o);E(A,y,D,a=>{if(!v)return v=!0,clearTimeout(w),h(a)})})}function E(A,y,o,D){if(y===0)return D(0);const v=new n.Socket;v.once("connect",()=>(R(v),E(A+o,y-1,o,D))),v.once("data",()=>{}),v.once("error",h=>(R(v),h.code!=="ECONNREFUSED"?E(A+o,y-1,o,D):D(A))),v.connect(A,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(A,y,o,D="127.0.0.1"){let v=!1,h,w=1;const a=n.createServer({pauseOnConnect:!0});function f(m,$){v||(v=!0,a.removeAllListeners(),a.close(),h&&clearTimeout(h),$(m))}return new Promise(m=>{h=setTimeout(()=>{f(0,m)},o),a.on("listening",()=>{f(A,m)}),a.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<y?(A++,w++,a.listen(A,D)):f(0,m)}),a.on("close",()=>{f(0,m)}),a.listen(A,D)})}function R(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(y){console.error(y)}}}),function(){function se(){function e(){return process.uncHostAllowlist}function n(y){const o=new Set;if(Array.isArray(y))for(const D of y)typeof D=="string"&&o.add(D);return Array.from(o)}function r(){const y=e();return y?Array.from(y):[]}function E(y){if(process.platform!=="win32")return;const o=e();if(o)if(typeof y=="string")o.add(y.toLowerCase());else for(const D of n(y))E(D)}function k(y){if(typeof y!="string")return;const o=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let D;for(const v of o){if(y.indexOf(v)!==0)continue;const w=y.indexOf("\\",v.length);if(w===-1)continue;const a=y.substring(v.length,w);if(a){D=a;break}}return D}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function A(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:k,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:A}}typeof define=="function"?define("vs/base/node/unc",[],function(){return se()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=se():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ve[85],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class n{constructor(E,k){this.lineNumber=E,this.column=k}with(E=this.lineNumber,k=this.column){return E===this.lineNumber&&k===this.column?this:new n(E,k)}delta(E=0,k=0){return this.with(this.lineNumber+E,this.column+k)}equals(E){return n.equals(this,E)}static equals(E,k){return!E&&!k?!0:!!E&&!!k&&E.lineNumber===k.lineNumber&&E.column===k.column}isBefore(E){return n.isBefore(this,E)}static isBefore(E,k){return E.lineNumber<k.lineNumber?!0:k.lineNumber<E.lineNumber?!1:E.column<k.column}isBeforeOrEqual(E){return n.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,k){return E.lineNumber<k.lineNumber?!0:k.lineNumber<E.lineNumber?!1:E.column<=k.column}static compare(E,k){const R=E.lineNumber|0,A=k.lineNumber|0;if(R===A){const y=E.column|0,o=k.column|0;return y-o}return R-A}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new n(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Lt=n}),define(ve[49],Se([1,0,85]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class r{constructor(k,R,A,y){k>A||k===A&&R>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return r.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return r.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}static strictContainsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<=k.startColumn||R.lineNumber===k.endLineNumber&&R.column>=k.endColumn)}containsRange(k){return r.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return r.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return r.plusRange(this,k)}static plusRange(k,R){let A,y,o,D;return R.startLineNumber<k.startLineNumber?(A=R.startLineNumber,y=R.startColumn):R.startLineNumber===k.startLineNumber?(A=R.startLineNumber,y=Math.min(R.startColumn,k.startColumn)):(A=k.startLineNumber,y=k.startColumn),R.endLineNumber>k.endLineNumber?(o=R.endLineNumber,D=R.endColumn):R.endLineNumber===k.endLineNumber?(o=R.endLineNumber,D=Math.max(R.endColumn,k.endColumn)):(o=k.endLineNumber,D=k.endColumn),new r(A,y,o,D)}intersectRanges(k){return r.intersectRanges(this,k)}static intersectRanges(k,R){let A=k.startLineNumber,y=k.startColumn,o=k.endLineNumber,D=k.endColumn;const v=R.startLineNumber,h=R.startColumn,w=R.endLineNumber,a=R.endColumn;return A<v?(A=v,y=h):A===v&&(y=Math.max(y,h)),o>w?(o=w,D=a):o===w&&(D=Math.min(D,a)),A>o||A===o&&y>D?null:new r(A,y,o,D)}equalsRange(k){return r.equalsRange(this,k)}static equalsRange(k,R){return!k&&!R?!0:!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(k){return new n.$Lt(k.endLineNumber,k.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(k){return new n.$Lt(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new r(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new r(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(k){return new r(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(k){return new r(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new r(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,R=k){return new r(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new r(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const o=k.startLineNumber|0,D=R.startLineNumber|0;if(o===D){const v=k.startColumn|0,h=R.startColumn|0;if(v===h){const w=k.endLineNumber|0,a=R.endLineNumber|0;if(w===a){const f=k.endColumn|0,m=R.endColumn|0;return f-m}return w-a}return v-h}return o-D}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.$Mt=r}),define(ve[179],Se([1,0,49]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class r{static insert(k,R){return{range:new n.$Mt(k.lineNumber,k.column,k.lineNumber,k.column),text:R,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,R){return{range:k,text:R}}static replaceMove(k,R){return{range:k,text:R,forceMoveMarkers:!0}}}e.$Nt=r}),define(ve[180],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0,e.$jt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ve[181],Se([1,0,40,2,80]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=void 0,e.$mt=R,e.$nt=y,e.$ot=o,e.$kt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function k(v=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.$kt)v.indexOf(w)>=0||(h+="\\"+w);return h+="\\s]+)",new RegExp(h,"g")}e.$lt=k();function R(v){let h=e.$lt;if(v&&v instanceof RegExp)if(v.global)h=v;else{let w="g";v.ignoreCase&&(w+="i"),v.multiline&&(w+="m"),v.unicode&&(w+="u"),h=new RegExp(v.source,w)}return h.lastIndex=0,h}const A=new E.$8c;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(v){const h=A.unshift(v);return(0,r.$Vc)(h)}function o(v,h,w,a,f){if(h=R(h),f||(f=n.Iterable.first(A)),w.length>f.maxLen){let p=v-f.maxLen/2;return p<0?p=0:a+=p,w=w.substring(p,v+f.maxLen/2),o(v,h,w,a,f)}const m=Date.now(),$=v-1-a;let b=-1,d=null;for(let p=1;!(Date.now()-m>=f.timeBudget);p++){const t=$-f.windowSize*p;h.lastIndex=Math.max(0,t);const l=D(h,w,$,b);if(!l&&d||(d=l,t<=0))break;b=t}if(d){const p={word:d[0],startColumn:a+1+d.index,endColumn:a+1+d.index+d[0].length};return h.lastIndex=0,p}return null}function D(v,h,w,a){let f;for(;f=v.exec(h);){const m=f.index||0;if(m<=w&&v.lastIndex>=w)return f;if(a>0&&m>a)return null}return null}}),define(ve[110],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var n;(function(y){y[y.Null=0]="Null",y[y.PlainText=1]="PlainText"})(n||(e.LanguageId=n={}));var r;(function(y){y[y.NotSet=-1]="NotSet",y[y.None=0]="None",y[y.Italic=1]="Italic",y[y.Bold=2]="Bold",y[y.Underline=4]="Underline",y[y.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var E;(function(y){y[y.None=0]="None",y[y.DefaultForeground=1]="DefaultForeground",y[y.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var k;(function(y){y[y.Other=0]="Other",y[y.Comment=1]="Comment",y[y.String=2]="String",y[y.RegEx=3]="RegEx"})(k||(e.StandardTokenType=k={}));var R;(function(y){y[y.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",y[y.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",y[y.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",y[y.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",y[y.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",y[y.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",y[y.ITALIC_MASK=2048]="ITALIC_MASK",y[y.BOLD_MASK=4096]="BOLD_MASK",y[y.UNDERLINE_MASK=8192]="UNDERLINE_MASK",y[y.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",y[y.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",y[y.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",y[y.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",y[y.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",y[y.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",y[y.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",y[y.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",y[y.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",y[y.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",y[y.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",y[y.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",y[y.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R||(e.MetadataConsts=R={}));class A{static getLanguageId(o){return(o&R.LANGUAGEID_MASK)>>>R.LANGUAGEID_OFFSET}static getTokenType(o){return(o&R.TOKEN_TYPE_MASK)>>>R.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(o){return(o&R.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(o){return(o&R.FONT_STYLE_MASK)>>>R.FONT_STYLE_OFFSET}static getForeground(o){return(o&R.FOREGROUND_MASK)>>>R.FOREGROUND_OFFSET}static getBackground(o){return(o&R.BACKGROUND_MASK)>>>R.BACKGROUND_OFFSET}static getClassNameFromMetadata(o){let v="mtk"+this.getForeground(o);const h=this.getFontStyle(o);return h&r.Italic&&(v+=" mtki"),h&r.Bold&&(v+=" mtkb"),h&r.Underline&&(v+=" mtku"),h&r.Strikethrough&&(v+=" mtks"),v}static getInlineStyleFromMetadata(o,D){const v=this.getForeground(o),h=this.getFontStyle(o);let w=`color: ${D[v]};`;h&r.Italic&&(w+="font-style: italic;"),h&r.Bold&&(w+="font-weight: bold;");let a="";return h&r.Underline&&(a+=" underline"),h&r.Strikethrough&&(a+=" line-through"),a&&(w+=`text-decoration:${a};`),w}static getPresentationFromMetadata(o){const D=this.getForeground(o),v=this.getFontStyle(o);return{foreground:D,italic:!!(v&r.Italic),bold:!!(v&r.Bold),underline:!!(v&r.Underline),strikethrough:!!(v&r.Strikethrough)}}}e.$su=A}),define(ve[182],Se([1,0,21]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$bw=e.$aw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$cw=a,e.$gw=p;var r;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var E;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(E||(e.GlyphMarginLane=E={}));var k;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(k||(e.MinimapPosition=k={}));var R;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var A;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var y;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(y||(e.EndOfLinePreference=y={}));var o;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(o||(e.DefaultEndOfLine=o={}));var D;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(D||(e.EndOfLineSequence=D={}));class v{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,n.$io)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$aw=v;class h{constructor(l,i){this._findMatchBrand=void 0,this.range=l,this.matches=i}}e.$bw=h;var w;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function a(t){return t&&typeof t.read=="function"}var f;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(f||(e.PositionAffinity=f={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(l,i,g,s,c,u){this.identifier=l,this.range=i,this.text=g,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.$dw=$;class b{constructor(l,i,g){this.regex=l,this.wordSeparators=i,this.simpleSearch=g}}e.$ew=b;class d{constructor(l,i,g){this.reverseEdits=l,this.changes=i,this.trimAutoWhitespaceLineNumbers=g}}e.$fw=d;function p(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ve[183],Se([1,0,6,2,110]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$ne,this.onDidChange=this.c.event,this.d=null}handleChange(y){this.c.fire({changedLanguages:y,changedColorMap:!1})}register(y,o){return this.a.set(y,o),this.handleChange([y]),(0,r.$Vc)(()=>{this.a.get(y)===o&&(this.a.delete(y),this.handleChange([y]))})}get(y){return this.a.get(y)||null}registerFactory(y,o){this.b.get(y)?.dispose();const D=new R(this,y,o);return this.b.set(y,D),(0,r.$Vc)(()=>{const v=this.b.get(y);!v||v!==D||(this.b.delete(y),v.dispose())})}async getOrCreate(y){const o=this.get(y);if(o)return o;const D=this.b.get(y);return!D||D.isResolved?null:(await D.resolve(),this.get(y))}isResolved(y){if(this.get(y))return!0;const D=this.b.get(y);return!!(!D||D.isResolved)}setColorMap(y){this.d=y,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>E.ColorId.DefaultBackground?this.d[E.ColorId.DefaultBackground]:null}}e.$vu=k;class R extends r.$Xc{get isResolved(){return this.c}constructor(y,o,D){super(),this.f=y,this.g=o,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const y=await this.h.tokenizationSupport;this.c=!0,y&&!this.a&&this.B(this.f.register(this.g,y))}}}),define(ve[184],Se([7,8]),function(se,e){return se.create("vs/base/common/actions",e)}),define(ve[185],Se([1,0,6,2,184]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=D,E=qe(E);class k extends r.$Xc{constructor(h,w="",a="",f=!0,m){super(),this.j=this.B(new n.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=h,this.n=w,this.w=a,this.z=f,this.D=m}get id(){return this.m}get label(){return this.n}set label(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.j.fire({label:h}))}get tooltip(){return this.u||""}set tooltip(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.j.fire({tooltip:h}))}get class(){return this.w}set class(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.j.fire({class:h}))}get enabled(){return this.z}set enabled(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.j.fire({enabled:h}))}get checked(){return this.C}set checked(h){this.J(h)}J(h){this.C!==h&&(this.C=h,this.j.fire({checked:h}))}async run(h,w){this.D&&await this.D(h)}}e.$lj=k;class R extends r.$Xc{constructor(){super(...arguments),this.f=this.B(new n.$ne),this.onWillRun=this.f.event,this.m=this.B(new n.$ne),this.onDidRun=this.m.event}async run(h,w){if(!h.enabled)return;this.f.fire({action:h});let a;try{await this.u(h,w)}catch(f){a=f}this.m.fire({action:h,error:a})}async u(h,w){await h.run(w)}}e.$mj=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let w=[];for(const a of h)a.length&&(w.length?w=[...w,new A,...a]:w=a);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=A;class y{get actions(){return this.a}constructor(h,w,a,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=w,this.class=f,this.a=a}async run(){}}e.$oj=y;class o extends k{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,E.localize(0,null),void 0,!1)}}e.$pj=o;function D(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...h)=>v.run(...h)}}}),define(ve[186],Se([7,8]),function(se,e){return se.create("vs/base/common/date",e)}),define(ve[187],Se([1,0,186]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=o,e.$3m=D,e.$4m=v;const r=60,E=r*60,k=E*24,R=k*7,A=k*30,y=k*365;function o(h,w,a,f){typeof h!="number"&&(h=h.getTime());const m=Math.round((new Date().getTime()-h)/1e3);if(m<-30)return(0,n.localize)(0,null,o(new Date().getTime()+m*1e3,!1));if(!f&&m<30)return(0,n.localize)(1,null);let $;return m<r?($=m,w?$===1?a?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):a?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?a?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):a?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):m<E?($=Math.floor(m/r),w?$===1?a?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):a?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?a?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):a?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):m<k?($=Math.floor(m/E),w?$===1?a?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):a?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?a?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):a?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):m<R?($=Math.floor(m/k),w?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):m<A?($=Math.floor(m/R),w?$===1?a?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):a?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?a?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):a?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):m<y?($=Math.floor(m/A),w?$===1?a?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):a?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?a?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):a?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(m/y),w?$===1?a?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):a?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?a?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):a?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function D(h,w){const a=Math.abs(h/1e3);return a<1?w?(0,n.localize)(54,null,h):(0,n.localize)(55,null,h):a<r?w?(0,n.localize)(56,null,Math.round(h)/1e3):(0,n.localize)(57,null,Math.round(h)/1e3):a<E?w?(0,n.localize)(58,null,Math.round(h/(1e3*r))):(0,n.localize)(59,null,Math.round(h/(1e3*r))):a<k?w?(0,n.localize)(60,null,Math.round(h/(1e3*E))):(0,n.localize)(61,null,Math.round(h/(1e3*E))):(0,n.localize)(62,null,Math.round(h/(1e3*k)))}function v(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ve[188],Se([7,8]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(ve[45],Se([1,0,18,11,188]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=y,e.$sj=o,e.$tj=D,n=qe(n),r=qe(r),E=qe(E);function k(v,h){return h&&(v.stack||v.stacktrace)?E.localize(0,null,A(v),R(v.stack)||R(v.stacktrace)):A(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function A(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?E.localize(1,null,v.message):v.message||E.localize(2,null)}function y(v=null,h=!1){if(!v)return E.localize(3,null);if(Array.isArray(v)){const w=n.$Kb(v),a=y(w[0],h);return w.length>1?E.localize(4,null,a,w.length):a}if(r.$gg(v))return v;if(v.detail){const w=v.detail;if(w.error)return k(w.error,h);if(w.exception)return k(w.exception,h)}return v.stack?k(v,h):v.message?v.message:E.localize(5,null)}function o(v){const h=v;return h instanceof Error&&Array.isArray(h.actions)}function D(v,h){let w;return typeof v=="string"?w=new Error(v):w=v,w.actions=h,w}}),define(ve[189],Se([7,8]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(ve[190],Se([1,0,189,43]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=E;function E(k){switch(k){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(ve[191],Se([7,8]),function(se,e){return se.create("vs/base/common/platform",e)}),define(ve[3],Se([1,0,191]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=P,e.$J=C,n=qe(n),e.$g="en";let r=!1,E=!1,k=!1,R=!1,A=!1,y=!1,o=!1,D=!1,v=!1,h=!1,w,a=e.$g,f=e.$g,m,$;const b=globalThis;let d;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?d=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const p=typeof d?.versions?.electron=="string",t=p&&d?.type==="renderer";if(typeof d=="object"){r=d.platform==="win32",E=d.platform==="darwin",k=d.platform==="linux",R=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,o=p,v=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,a=e.$g;const L=d.env.VSCODE_NLS_CONFIG;if(L)try{const T=JSON.parse(L),I=T.availableLanguages["*"];w=T.locale,f=T.osLocale,a=I||e.$g,m=T._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,r=$.indexOf("Windows")>=0,E=$.indexOf("Macintosh")>=0,D=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=$.indexOf("Linux")>=0,h=$?.indexOf("Mobi")>=0,y=!0,w=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,a=w,f=navigator.language):console.error("Unable to resolve platform.");var l;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(l||(e.Platform=l={}));function i(L){switch(L){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let g=l.Web;E?g=l.Mac:r?g=l.Windows:k&&(g=l.Linux),e.$i=r,e.$j=E,e.$k=k,e.$l=R,e.$m=A,e.$n=o,e.$o=y,e.$p=y&&typeof b.importScripts=="function",e.$q=e.$p?b.origin:void 0,e.$r=D,e.$s=h,e.$t=v,e.$u=g,e.$v=$,e.$w=a;var s;(function(L){function T(){return e.$w}L.value=T;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=I;function q(){return e.$w==="en"}L.isDefault=q})(s||(e.Language=s={})),e.$x=w,e.$y=f,e.$z=m,e.$A=typeof b.postMessage=="function"&&!b.importScripts,e.$B=(()=>{if(e.$A){const L=[];b.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let q=0,Y=L.length;q<Y;q++){const Q=L[q];if(Q.id===I.data.vscodeScheduleAsyncWork){L.splice(q,1),Q.callback();return}}});let T=0;return I=>{const q=++T;L.push({id:q,callback:I}),b.postMessage({vscodeScheduleAsyncWork:q},"*")}}return L=>setTimeout(L)})();var c;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=E||D?c.Macintosh:r?c.Windows:c.Linux;let u=!0,S=!1;function P(){if(!S){S=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,u=new Uint16Array(L.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(L){return parseFloat(L)>=20}}),define(ve[33],Se([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const k=E.process;r={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$gc=r.platform,e.$hc=r.arch}),define(ve[9],Se([1,0,33]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,n=qe(n);const r=65,E=97,k=90,R=122,A=46,y=47,o=92,D=58,v=63;class h extends Error{constructor(i,g,s){let c;typeof g=="string"&&g.indexOf("not ")===0?(c="must not be",g=g.replace(/^not /,"")):c="must be";const u=i.indexOf(".")!==-1?"property":"argument";let S=`The "${i}" ${u} ${c} of type ${g}`;S+=`. Received type ${typeof s}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function w(l,i){if(l===null||typeof l!="object")throw new h(i,"Object",l)}function a(l,i){if(typeof l!="string")throw new h(i,"string",l)}const f=n.$gc==="win32";function m(l){return l===y||l===o}function $(l){return l===y}function b(l){return l>=r&&l<=k||l>=E&&l<=R}function d(l,i,g,s){let c="",u=0,S=-1,P=0,C=0;for(let L=0;L<=l.length;++L){if(L<l.length)C=l.charCodeAt(L);else{if(s(C))break;C=y}if(s(C)){if(!(S===L-1||P===1))if(P===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const T=c.lastIndexOf(g);T===-1?(c="",u=0):(c=c.slice(0,T),u=c.length-1-c.lastIndexOf(g)),S=L,P=0;continue}else if(c.length!==0){c="",u=0,S=L,P=0;continue}}i&&(c+=c.length>0?`${g}..`:"..",u=2)}else c.length>0?c+=`${g}${l.slice(S+1,L)}`:c=l.slice(S+1,L),u=L-S-1;S=L,P=0}else C===A&&P!==-1?++P:P=-1}return c}function p(l,i){w(i,"pathObject");const g=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return g?g===i.root?`${g}${s}`:`${g}${l}${s}`:s}e.$ic={resolve(...l){let i="",g="",s=!1;for(let c=l.length-1;c>=-1;c--){let u;if(c>=0){if(u=l[c],a(u,"path"),u.length===0)continue}else i.length===0?u=n.cwd():(u=n.env[`=${i}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===o)&&(u=`${i}\\`));const S=u.length;let P=0,C="",L=!1;const T=u.charCodeAt(0);if(S===1)m(T)&&(P=1,L=!0);else if(m(T))if(L=!0,m(u.charCodeAt(1))){let I=2,q=I;for(;I<S&&!m(u.charCodeAt(I));)I++;if(I<S&&I!==q){const Y=u.slice(q,I);for(q=I;I<S&&m(u.charCodeAt(I));)I++;if(I<S&&I!==q){for(q=I;I<S&&!m(u.charCodeAt(I));)I++;(I===S||I!==q)&&(C=`\\\\${Y}\\${u.slice(q,I)}`,P=I)}}}else P=1;else b(T)&&u.charCodeAt(1)===D&&(C=u.slice(0,2),P=2,S>2&&m(u.charCodeAt(2))&&(L=!0,P=3));if(C.length>0)if(i.length>0){if(C.toLowerCase()!==i.toLowerCase())continue}else i=C;if(s){if(i.length>0)break}else if(g=`${u.slice(P)}\\${g}`,s=L,L&&i.length>0)break}return g=d(g,!s,"\\",m),s?`${i}\\${g}`:`${i}${g}`||"."},normalize(l){a(l,"path");const i=l.length;if(i===0)return".";let g=0,s,c=!1;const u=l.charCodeAt(0);if(i===1)return $(u)?"\\":l;if(m(u))if(c=!0,m(l.charCodeAt(1))){let P=2,C=P;for(;P<i&&!m(l.charCodeAt(P));)P++;if(P<i&&P!==C){const L=l.slice(C,P);for(C=P;P<i&&m(l.charCodeAt(P));)P++;if(P<i&&P!==C){for(C=P;P<i&&!m(l.charCodeAt(P));)P++;if(P===i)return`\\\\${L}\\${l.slice(C)}\\`;P!==C&&(s=`\\\\${L}\\${l.slice(C,P)}`,g=P)}}}else g=1;else b(u)&&l.charCodeAt(1)===D&&(s=l.slice(0,2),g=2,i>2&&m(l.charCodeAt(2))&&(c=!0,g=3));let S=g<i?d(l.slice(g),!c,"\\",m):"";return S.length===0&&!c&&(S="."),S.length>0&&m(l.charCodeAt(i-1))&&(S+="\\"),s===void 0?c?`\\${S}`:S:c?`${s}\\${S}`:`${s}${S}`},isAbsolute(l){a(l,"path");const i=l.length;if(i===0)return!1;const g=l.charCodeAt(0);return m(g)||i>2&&b(g)&&l.charCodeAt(1)===D&&m(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let i,g;for(let u=0;u<l.length;++u){const S=l[u];a(S,"path"),S.length>0&&(i===void 0?i=g=S:i+=`\\${S}`)}if(i===void 0)return".";let s=!0,c=0;if(typeof g=="string"&&m(g.charCodeAt(0))){++c;const u=g.length;u>1&&m(g.charCodeAt(1))&&(++c,u>2&&(m(g.charCodeAt(2))?++c:s=!1))}if(s){for(;c<i.length&&m(i.charCodeAt(c));)c++;c>=2&&(i=`\\${i.slice(c)}`)}return e.$ic.normalize(i)},relative(l,i){if(a(l,"from"),a(i,"to"),l===i)return"";const g=e.$ic.resolve(l),s=e.$ic.resolve(i);if(g===s||(l=g.toLowerCase(),i=s.toLowerCase(),l===i))return"";let c=0;for(;c<l.length&&l.charCodeAt(c)===o;)c++;let u=l.length;for(;u-1>c&&l.charCodeAt(u-1)===o;)u--;const S=u-c;let P=0;for(;P<i.length&&i.charCodeAt(P)===o;)P++;let C=i.length;for(;C-1>P&&i.charCodeAt(C-1)===o;)C--;const L=C-P,T=S<L?S:L;let I=-1,q=0;for(;q<T;q++){const Q=l.charCodeAt(c+q);if(Q!==i.charCodeAt(P+q))break;Q===o&&(I=q)}if(q!==T){if(I===-1)return s}else{if(L>T){if(i.charCodeAt(P+q)===o)return s.slice(P+q+1);if(q===2)return s.slice(P+q)}S>T&&(l.charCodeAt(c+q)===o?I=q:q===2&&(I=3)),I===-1&&(I=0)}let Y="";for(q=c+I+1;q<=u;++q)(q===u||l.charCodeAt(q)===o)&&(Y+=Y.length===0?"..":"\\..");return P+=I,Y.length>0?`${Y}${s.slice(P,C)}`:(s.charCodeAt(P)===o&&++P,s.slice(P,C))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const i=e.$ic.resolve(l);if(i.length<=2)return l;if(i.charCodeAt(0)===o){if(i.charCodeAt(1)===o){const g=i.charCodeAt(2);if(g!==v&&g!==A)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(b(i.charCodeAt(0))&&i.charCodeAt(1)===D&&i.charCodeAt(2)===o)return`\\\\?\\${i}`;return l},dirname(l){a(l,"path");const i=l.length;if(i===0)return".";let g=-1,s=0;const c=l.charCodeAt(0);if(i===1)return m(c)?l:".";if(m(c)){if(g=s=1,m(l.charCodeAt(1))){let P=2,C=P;for(;P<i&&!m(l.charCodeAt(P));)P++;if(P<i&&P!==C){for(C=P;P<i&&m(l.charCodeAt(P));)P++;if(P<i&&P!==C){for(C=P;P<i&&!m(l.charCodeAt(P));)P++;if(P===i)return l;P!==C&&(g=s=P+1)}}}}else b(c)&&l.charCodeAt(1)===D&&(g=i>2&&m(l.charCodeAt(2))?3:2,s=g);let u=-1,S=!0;for(let P=i-1;P>=s;--P)if(m(l.charCodeAt(P))){if(!S){u=P;break}}else S=!1;if(u===-1){if(g===-1)return".";u=g}return l.slice(0,u)},basename(l,i){i!==void 0&&a(i,"ext"),a(l,"path");let g=0,s=-1,c=!0,u;if(l.length>=2&&b(l.charCodeAt(0))&&l.charCodeAt(1)===D&&(g=2),i!==void 0&&i.length>0&&i.length<=l.length){if(i===l)return"";let S=i.length-1,P=-1;for(u=l.length-1;u>=g;--u){const C=l.charCodeAt(u);if(m(C)){if(!c){g=u+1;break}}else P===-1&&(c=!1,P=u+1),S>=0&&(C===i.charCodeAt(S)?--S===-1&&(s=u):(S=-1,s=P))}return g===s?s=P:s===-1&&(s=l.length),l.slice(g,s)}for(u=l.length-1;u>=g;--u)if(m(l.charCodeAt(u))){if(!c){g=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(g,s)},extname(l){a(l,"path");let i=0,g=-1,s=0,c=-1,u=!0,S=0;l.length>=2&&l.charCodeAt(1)===D&&b(l.charCodeAt(0))&&(i=s=2);for(let P=l.length-1;P>=i;--P){const C=l.charCodeAt(P);if(m(C)){if(!u){s=P+1;break}continue}c===-1&&(u=!1,c=P+1),C===A?g===-1?g=P:S!==1&&(S=1):g!==-1&&(S=-1)}return g===-1||c===-1||S===0||S===1&&g===c-1&&g===s+1?"":l.slice(g,c)},format:p.bind(null,"\\"),parse(l){a(l,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return i;const g=l.length;let s=0,c=l.charCodeAt(0);if(g===1)return m(c)?(i.root=i.dir=l,i):(i.base=i.name=l,i);if(m(c)){if(s=1,m(l.charCodeAt(1))){let I=2,q=I;for(;I<g&&!m(l.charCodeAt(I));)I++;if(I<g&&I!==q){for(q=I;I<g&&m(l.charCodeAt(I));)I++;if(I<g&&I!==q){for(q=I;I<g&&!m(l.charCodeAt(I));)I++;I===g?s=I:I!==q&&(s=I+1)}}}}else if(b(c)&&l.charCodeAt(1)===D){if(g<=2)return i.root=i.dir=l,i;if(s=2,m(l.charCodeAt(2))){if(g===3)return i.root=i.dir=l,i;s=3}}s>0&&(i.root=l.slice(0,s));let u=-1,S=s,P=-1,C=!0,L=l.length-1,T=0;for(;L>=s;--L){if(c=l.charCodeAt(L),m(c)){if(!C){S=L+1;break}continue}P===-1&&(C=!1,P=L+1),c===A?u===-1?u=L:T!==1&&(T=1):u!==-1&&(T=-1)}return P!==-1&&(u===-1||T===0||T===1&&u===P-1&&u===S+1?i.base=i.name=l.slice(S,P):(i.name=l.slice(S,u),i.base=l.slice(S,P),i.ext=l.slice(u,P))),S>0&&S!==s?i.dir=l.slice(0,S-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(f){const l=/\\/g;return()=>{const i=n.cwd().replace(l,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.$jc={resolve(...l){let i="",g=!1;for(let s=l.length-1;s>=-1&&!g;s--){const c=s>=0?l[s]:t();a(c,"path"),c.length!==0&&(i=`${c}/${i}`,g=c.charCodeAt(0)===y)}return i=d(i,!g,"/",$),g?`/${i}`:i.length>0?i:"."},normalize(l){if(a(l,"path"),l.length===0)return".";const i=l.charCodeAt(0)===y,g=l.charCodeAt(l.length-1)===y;return l=d(l,!i,"/",$),l.length===0?i?"/":g?"./":".":(g&&(l+="/"),i?`/${l}`:l)},isAbsolute(l){return a(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let i;for(let g=0;g<l.length;++g){const s=l[g];a(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$jc.normalize(i)},relative(l,i){if(a(l,"from"),a(i,"to"),l===i||(l=e.$jc.resolve(l),i=e.$jc.resolve(i),l===i))return"";const g=1,s=l.length,c=s-g,u=1,S=i.length-u,P=c<S?c:S;let C=-1,L=0;for(;L<P;L++){const I=l.charCodeAt(g+L);if(I!==i.charCodeAt(u+L))break;I===y&&(C=L)}if(L===P)if(S>P){if(i.charCodeAt(u+L)===y)return i.slice(u+L+1);if(L===0)return i.slice(u+L)}else c>P&&(l.charCodeAt(g+L)===y?C=L:L===0&&(C=0));let T="";for(L=g+C+1;L<=s;++L)(L===s||l.charCodeAt(L)===y)&&(T+=T.length===0?"..":"/..");return`${T}${i.slice(u+C)}`},toNamespacedPath(l){return l},dirname(l){if(a(l,"path"),l.length===0)return".";const i=l.charCodeAt(0)===y;let g=-1,s=!0;for(let c=l.length-1;c>=1;--c)if(l.charCodeAt(c)===y){if(!s){g=c;break}}else s=!1;return g===-1?i?"/":".":i&&g===1?"//":l.slice(0,g)},basename(l,i){i!==void 0&&a(i,"ext"),a(l,"path");let g=0,s=-1,c=!0,u;if(i!==void 0&&i.length>0&&i.length<=l.length){if(i===l)return"";let S=i.length-1,P=-1;for(u=l.length-1;u>=0;--u){const C=l.charCodeAt(u);if(C===y){if(!c){g=u+1;break}}else P===-1&&(c=!1,P=u+1),S>=0&&(C===i.charCodeAt(S)?--S===-1&&(s=u):(S=-1,s=P))}return g===s?s=P:s===-1&&(s=l.length),l.slice(g,s)}for(u=l.length-1;u>=0;--u)if(l.charCodeAt(u)===y){if(!c){g=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(g,s)},extname(l){a(l,"path");let i=-1,g=0,s=-1,c=!0,u=0;for(let S=l.length-1;S>=0;--S){const P=l.charCodeAt(S);if(P===y){if(!c){g=S+1;break}continue}s===-1&&(c=!1,s=S+1),P===A?i===-1?i=S:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||s===-1||u===0||u===1&&i===s-1&&i===g+1?"":l.slice(i,s)},format:p.bind(null,"/"),parse(l){a(l,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return i;const g=l.charCodeAt(0)===y;let s;g?(i.root="/",s=1):s=0;let c=-1,u=0,S=-1,P=!0,C=l.length-1,L=0;for(;C>=s;--C){const T=l.charCodeAt(C);if(T===y){if(!P){u=C+1;break}continue}S===-1&&(P=!1,S=C+1),T===A?c===-1?c=C:L!==1&&(L=1):c!==-1&&(L=-1)}if(S!==-1){const T=u===0&&g?1:u;c===-1||L===0||L===1&&c===S-1&&c===u+1?i.base=i.name=l.slice(T,S):(i.name=l.slice(T,c),i.base=l.slice(T,S),i.ext=l.slice(c,S))}return u>0?i.dir=l.slice(0,u-1):g&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=f?e.$ic.normalize:e.$jc.normalize,e.$lc=f?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=f?e.$ic.join:e.$jc.join,e.$nc=f?e.$ic.resolve:e.$jc.resolve,e.$oc=f?e.$ic.relative:e.$jc.relative,e.$pc=f?e.$ic.dirname:e.$jc.dirname,e.$qc=f?e.$ic.basename:e.$jc.basename,e.$rc=f?e.$ic.extname:e.$jc.extname,e.$sc=f?e.$ic.format:e.$jc.format,e.$tc=f?e.$ic.parse:e.$jc.parse,e.$uc=f?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=f?e.$ic.sep:e.$jc.sep,e.$wc=f?e.$ic.delimiter:e.$jc.delimiter}),define(ve[37],Se([1,0,35,9,3,17,11]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=A,e.$zg=y,e.$Ag=o,e.$Bg=D,e.$Cg=v,e.$Dg=f,e.$Eg=m,e.$Fg=$,e.$Gg=b,e.$Hg=d,e.$Ig=p,e.$Jg=t,e.$Kg=l,e.$Lg=i,e.$Mg=g,e.$Ng=s,e.$Og=S;function A(P){return P===n.CharCode.Slash||P===n.CharCode.Backslash}function y(P){return P.replace(/[\\/]/g,r.$jc.sep)}function o(P){return P.indexOf("/")===-1&&(P=y(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function D(P,C=r.$jc.sep){if(!P)return"";const L=P.length,T=P.charCodeAt(0);if(A(T)){if(A(P.charCodeAt(1))&&!A(P.charCodeAt(2))){let q=3;const Y=q;for(;q<L&&!A(P.charCodeAt(q));q++);if(Y!==q&&!A(P.charCodeAt(q+1))){for(q+=1;q<L;q++)if(A(P.charCodeAt(q)))return P.slice(0,q+1).replace(/[\\/]/g,C)}}return C}else if(b(T)&&P.charCodeAt(1)===n.CharCode.Colon)return A(P.charCodeAt(2))?P.slice(0,2)+C:P.slice(0,2);let I=P.indexOf("://");if(I!==-1){for(I+=3;I<L;I++)if(A(P.charCodeAt(I)))return P.slice(0,I+1)}return""}function v(P){if(!E.$i||!P||P.length<5)return!1;let C=P.charCodeAt(0);if(C!==n.CharCode.Backslash||(C=P.charCodeAt(1),C!==n.CharCode.Backslash))return!1;let L=2;const T=L;for(;L<P.length&&(C=P.charCodeAt(L),C!==n.CharCode.Backslash);L++);return!(T===L||(C=P.charCodeAt(L+1),isNaN(C)||C===n.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,w=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(P,C=E.$i){const L=C?h:w;return!(!P||P.length===0||/^\s+$/.test(P)||(L.lastIndex=0,L.test(P))||C&&a.test(P)||P==="."||P===".."||C&&P[P.length-1]==="."||C&&P.length!==P.trim().length||P.length>255)}function m(P,C,L){const T=P===C;return!L||T?T:!P||!C?!1:(0,k.$Hf)(P,C)}function $(P,C,L,T=r.sep){if(P===C)return!0;if(!P||!C||C.length>P.length)return!1;if(L){if(!(0,k.$If)(P,C))return!1;if(C.length===P.length)return!0;let q=C.length;return C.charAt(C.length-1)===T&&q--,P.charAt(q)===T}return C.charAt(C.length-1)!==T&&(C+=T),P.indexOf(C)===0}function b(P){return P>=n.CharCode.A&&P<=n.CharCode.Z||P>=n.CharCode.a&&P<=n.CharCode.z}function d(P,C){return E.$i&&P.endsWith(":")&&(P+=r.sep),(0,r.$lc)(P)||(P=(0,r.$mc)(C,P)),P=(0,r.$kc)(P),p(P)}function p(P){return E.$i?(P=(0,k.$pf)(P,r.sep),P.endsWith(":")&&(P+=r.sep)):(P=(0,k.$pf)(P,r.sep),P||(P=r.sep)),P}function t(P){const C=(0,r.$kc)(P);return E.$i?P.length>3?!1:l(C)&&(P.length===2||C.charCodeAt(2)===n.CharCode.Backslash):C===r.$jc.sep}function l(P,C=E.$i){return C?b(P.charCodeAt(0))&&P.charCodeAt(1)===n.CharCode.Colon:!1}function i(P,C=E.$i){return l(P,C)?P[0]:void 0}function g(P,C,L){return C.length>P.length?-1:P===C?0:(L&&(P=P.toLowerCase(),C=C.toLowerCase()),P.indexOf(C))}function s(P){const C=P.split(":");let L,T,I;for(const q of C){const Y=Number(q);(0,R.$kg)(Y)?T===void 0?T=Y:I===void 0&&(I=Y):L=L?[L,q].join(":"):q}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:T!==void 0?T:void 0,column:I!==void 0?I:T!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(P,C,L=8){let T="";for(let q=0;q<L;q++){let Y;q===0&&E.$i&&!C&&(L===3||L===4)?Y=u:Y=c,T+=Y.charAt(Math.floor(Math.random()*Y.length))}let I;return C?I=`${C}-${T}`:I=T,P?(0,r.$mc)(P,I):I}}),define(ve[68],Se([1,0,9]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=k,e.$$s=R,e.$_s=A,e.$at=o,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(D){const v=(0,n.$rc)(D),h=r[v.toLowerCase()];return h!==void 0?h:R(D)}function R(D){const v=(0,n.$rc)(D);return E[v.toLowerCase()]}function A(D){for(const v in E)if(E[v]===D)return v}const y=/^(.+)\/(.+?)(;.+)?$/;function o(D,v){const h=y.exec(D);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:v?void 0:D}}),define(ve[69],Se([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=k,e.$mm=R;var r;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function k(A,...y){const o=y.reduce((h,w)=>(h[w]=!0,h),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(h=>!o[h]).forEach(h=>{for(let w=0;w<D.length;w++)if(h.search(D[w])!==-1){delete A[h];break}})}function R(A){A&&(delete A.DEBUG,n.$j&&delete A.DYLD_LIBRARY_PATH,n.$k&&delete A.LD_PRELOAD)}}),define(ve[4],Se([1,0,35,81,9,3]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=m,e.$zc=l,E=qe(E);const R=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function o(u,S){if(!u.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!R.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!A.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(u,S){return!u&&!S?"file":u}function v(u,S){switch(u){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const h="",w="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(S){return S instanceof f?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,P,C,L,T,I=!1){typeof S=="object"?(this.scheme=S.scheme||h,this.authority=S.authority||h,this.path=S.path||h,this.query=S.query||h,this.fragment=S.fragment||h):(this.scheme=D(S,I),this.authority=P||h,this.path=v(this.scheme,C||h),this.query=L||h,this.fragment=T||h,o(this,I))}get fsPath(){return l(this,!1)}with(S){if(!S)return this;let{scheme:P,authority:C,path:L,query:T,fragment:I}=S;return P===void 0?P=this.scheme:P===null&&(P=h),C===void 0?C=this.authority:C===null&&(C=h),L===void 0?L=this.path:L===null&&(L=h),T===void 0?T=this.query:T===null&&(T=h),I===void 0?I=this.fragment:I===null&&(I=h),P===this.scheme&&C===this.authority&&L===this.path&&T===this.query&&I===this.fragment?this:new b(P,C,L,T,I)}static parse(S,P=!1){const C=a.exec(S);return C?new b(C[2]||h,c(C[4]||h),c(C[5]||h),c(C[7]||h),c(C[9]||h),P):new b(h,h,h,h,h)}static file(S){let P=h;if(k.$i&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const C=S.indexOf(w,2);C===-1?(P=S.substring(2),S=w):(P=S.substring(2,C),S=S.substring(C)||w)}return new b("file",P,S,h,h)}static from(S,P){return new b(S.scheme,S.authority,S.path,S.query,S.fragment,P)}static joinPath(S,...P){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return k.$i&&S.scheme==="file"?C=f.file(E.$ic.join(l(S,!0),...P)).path:C=E.$jc.join(S.path,...P),S.with({path:C})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof f)return S;{const P=new b(S);return P._formatted=S.external??null,P._fsPath=S._sep===$?S.fsPath??null:null,P}}else return S}}e.URI=f;function m(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const $=k.$i?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:r.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=$),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const d={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function p(u,S,P){let C,L=-1;for(let T=0;T<u.length;T++){const I=u.charCodeAt(T);if(I>=n.CharCode.a&&I<=n.CharCode.z||I>=n.CharCode.A&&I<=n.CharCode.Z||I>=n.CharCode.Digit0&&I<=n.CharCode.Digit9||I===n.CharCode.Dash||I===n.CharCode.Period||I===n.CharCode.Underline||I===n.CharCode.Tilde||S&&I===n.CharCode.Slash||P&&I===n.CharCode.OpenSquareBracket||P&&I===n.CharCode.CloseSquareBracket||P&&I===n.CharCode.Colon)L!==-1&&(C+=encodeURIComponent(u.substring(L,T)),L=-1),C!==void 0&&(C+=u.charAt(T));else{C===void 0&&(C=u.substr(0,T));const q=d[I];q!==void 0?(L!==-1&&(C+=encodeURIComponent(u.substring(L,T)),L=-1),C+=q):L===-1&&(L=T)}}return L!==-1&&(C+=encodeURIComponent(u.substring(L))),C!==void 0?C:u}function t(u){let S;for(let P=0;P<u.length;P++){const C=u.charCodeAt(P);C===n.CharCode.Hash||C===n.CharCode.QuestionMark?(S===void 0&&(S=u.substr(0,P)),S+=d[C]):S!==void 0&&(S+=u[P])}return S!==void 0?S:u}function l(u,S){let P;return u.authority&&u.path.length>1&&u.scheme==="file"?P=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?S?P=u.path.substr(1):P=u.path[1].toLowerCase()+u.path.substr(2):P=u.path,k.$i&&(P=P.replace(/\//g,"\\")),P}function i(u,S){const P=S?t:p;let C="",{scheme:L,authority:T,path:I,query:q,fragment:Y}=u;if(L&&(C+=L,C+=":"),(T||L==="file")&&(C+=w,C+=w),T){let Q=T.indexOf("@");if(Q!==-1){const re=T.substr(0,Q);T=T.substr(Q+1),Q=re.lastIndexOf(":"),Q===-1?C+=P(re,!1,!1):(C+=P(re.substr(0,Q),!1,!1),C+=":",C+=P(re.substr(Q+1),!1,!0)),C+="@"}T=T.toLowerCase(),Q=T.lastIndexOf(":"),Q===-1?C+=P(T,!1,!0):(C+=P(T.substr(0,Q),!1,!0),C+=T.substr(Q))}if(I){if(I.length>=3&&I.charCodeAt(0)===n.CharCode.Slash&&I.charCodeAt(2)===n.CharCode.Colon){const Q=I.charCodeAt(1);Q>=n.CharCode.A&&Q<=n.CharCode.Z&&(I=`/${String.fromCharCode(Q+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===n.CharCode.Colon){const Q=I.charCodeAt(0);Q>=n.CharCode.A&&Q<=n.CharCode.Z&&(I=`${String.fromCharCode(Q+32)}:${I.substr(2)}`)}C+=P(I,!0,!1)}return q&&(C+="?",C+=P(q,!1,!1)),Y&&(C+="#",C+=S?Y:p(Y,!1,!1)),C}function g(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+g(u.substr(3)):u}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(u){return u.match(s)?u.replace(s,S=>g(S)):u}}),define(ve[192],Se([1,0,4]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=r,e.$cr=E,e.$dr=k,e.log=A;function r(o){const D=o;return D&&typeof D.type=="string"&&typeof D.severity=="string"}function E(o){const D=[];let v;try{const h=JSON.parse(o.arguments),w=h[h.length-1];w&&w.__$stack&&(h.pop(),v=w.__$stack),D.push(...h)}catch{D.push("Unable to log remote console arguments",o.arguments)}return{args:D,stack:v}}function k(o){if(typeof o!="string")return k(E(o).stack);const D=o;if(D){const v=R(D),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(h&&h.length===4)return{uri:n.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function R(o){if(!o)return o;const D=o.indexOf(`
`);return D===-1?o:o.substring(0,D)}function A(o,D){const{args:v,stack:h}=E(o),w=typeof v[0]=="string"&&v.length===1;let a=R(h);a&&(a=`(${a.trim()})`);let f=[];if(typeof v[0]=="string"?a&&w?f=[`%c[${D}] %c${v[0]} %c${a}`,y("blue"),y(""),y("grey")]:f=[`%c[${D}] %c${v[0]}`,y("blue"),y(""),...v.slice(1)]:f=[`%c[${D}]%`,y("blue"),...v],a&&!w&&f.push(a),typeof console[o.severity]!="function")throw new Error("Unknown console method");console[o.severity].apply(console,f)}function y(o){return`color: ${o}`}}),define(ve[50],Se([1,0,15,4,81]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=k,e.$ci=R,e.$di=y;function k(o){return JSON.stringify(o,A)}function R(o){let D=JSON.parse(o);return D=y(D),D}function A(o,D){return D instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:D.source,flags:D.flags}:D}function y(o,D=0){if(!o||D>200)return o;if(typeof o=="object"){switch(o.$mid){case E.MarshalledId.Uri:return r.URI.revive(o);case E.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case E.MarshalledId.Date:return new Date(o.source)}if(o instanceof n.$Pe||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let v=0;v<o.length;++v)o[v]=y(o[v],D+1);else for(const v in o)Object.hasOwnProperty.call(o,v)&&(o[v]=y(o[v],D+1))}return o}}),define(ve[13],Se([1,0,10,3,17,4,9]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=y,e.$Qg=o,e.$Ug=v,n=qe(n),r=qe(r),R=qe(R);var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(A||(e.Schemas=A={}));function y(a,f){return k.URI.isUri(a)?(0,E.$Hf)(a.scheme,f):(0,E.$If)(a,f+":")}function o(a,...f){return f.some(m=>y(a,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,m){this.f=v(f,m)}getServerRootPath(){return this.f}get g(){return R.$jc.join(this.f,A.vscodeRemoteResource)}set(f,m,$){this.a[f]=m,this.b[f]=$}setConnectionToken(f,m){this.c[f]=m}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(t){return n.$3(t),f}const m=f.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const b=this.b[m],d=this.c[m];let p=`path=${encodeURIComponent(f.path)}`;return typeof d=="string"&&(p+=`&${e.$Sg}=${encodeURIComponent(d)}`),k.URI.from({scheme:r.$o?this.d:A.vscodeRemoteResource,authority:`${$}:${b}`,path:this.g,query:p})}}e.$Tg=new D;function v(a,f){return R.$jc.join(f??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class h{static{this.a=e.$Zg}asBrowserUri(f){const m=this.b(f,se);return this.uriToBrowserUri(m)}uriToBrowserUri(f){return f.scheme===A.vscodeRemote?e.$Tg.rewrite(f):f.scheme===A.file&&(r.$m||r.$q===`${A.vscodeFileResource}://${h.a}`)?f.with({scheme:A.vscodeFileResource,authority:f.authority||h.a,query:null,fragment:null}):f}asFileUri(f){const m=this.b(f,se);return this.uriToFileUri(m)}uriToFileUri(f){return f.scheme===A.vscodeFileResource?f.with({scheme:A.file,authority:f.authority!==h.a?f.authority:null,query:null,fragment:null}):f}b(f,m){return k.URI.isUri(f)?f:k.URI.parse(m.toUrl(f))}}e.$1g=new h;var w;(function(a){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(f.get("3"));const m="vscode-coi";function $(d){let p;typeof d=="string"?p=new URL(d).searchParams:d instanceof URL?p=d.searchParams:k.URI.isUri(d)&&(p=new URL(d.toString(!0)).searchParams);const t=p?.get(m);if(t)return f.get(t)}a.getHeadersFromQuery=$;function b(d,p,t){if(!globalThis.crossOriginIsolated)return;const l=p&&t?"3":t?"2":"1";d instanceof URLSearchParams?d.set(m,l):d[m]=l}a.addSearchParam=b})(w||(e.COI=w={}))}),define(ve[193],Se([1,0,104,13,3,4]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=D,E=qe(E);class R{constructor(h,w,a){this.id=h,this.dependencies=w,this.callback=a}}class A{static{this.INSTANCE=new A}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,w,a)=>{typeof h!="string"&&(a=w,w=h,h=null),(typeof w!="object"||!Array.isArray(w))&&(a=w,w=null),this.c.push(new R(h,w,a))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const w=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!w)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(h){return new Promise((w,a)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const m=()=>{f.removeEventListener("load",$),f.removeEventListener("error",b)},$=d=>{m(),w(this.c.pop())},b=d=>{m(),a(d)};f.addEventListener("load",$),f.addEventListener("error",b),this.f&&(h=this.f.createScriptURL(h)),f.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(h){return new Promise((w,a)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),w(this.c.pop())}catch(f){a(f)}})}async j(h){try{const w=globalThis._VSCODE_NODE_MODULES.fs,a=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,m=k.URI.parse(h).fsPath,$=w.readFileSync(m).toString(),b=f.wrap($.replace(/^#!.*/,""));return new a.Script(b).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const y=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function D(v,h,w){if(n.$V){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[v]&&(v=o[v]);const a=`${v}/${h}`;if(y.has(a))return y.get(a);let f;if(/^\w[\w\d+.-]*:\/\//.test(a))f=a;else{const d=`${w&&!E.$o?r.$Xg:r.$Wg}/${a}`;f=r.$1g.asBrowserUri(d).toString(!0)}const m=A.INSTANCE.load(f);return y.set(a,m),m}else return await new Promise((a,f)=>{se([v],a,f)}).then(qe)}}),define(ve[20],Se([1,0,35,37,13,9,3,17,4]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=o,e.$qh=v,e.$rh=w,r=qe(r),k=qe(k);function o(a){return(0,y.$zc)(a,!0)}class D{constructor(f){this.a=f}compare(f,m,$=!1){return f===m?0:(0,A.$Af)(this.getComparisonKey(f,$),this.getComparisonKey(m,$))}isEqual(f,m,$=!1){return f===m?!0:!f||!m?!1:this.getComparisonKey(f,$)===this.getComparisonKey(m,$)}getComparisonKey(f,m=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,m,$=!1){if(f.scheme===m.scheme){if(f.scheme===E.Schemas.file)return r.$Fg(o(f),o(m),this.a(f))&&f.query===m.query&&($||f.fragment===m.fragment);if((0,e.$mh)(f.authority,m.authority))return r.$Fg(f.path,m.path,this.a(f),"/")&&f.query===m.query&&($||f.fragment===m.fragment)}return!1}joinPath(f,...m){return y.URI.joinPath(f,...m)}basenameOrAuthority(f){return(0,e.$eh)(f)||f.authority}basename(f){return k.$jc.basename(f.path)}extname(f){return k.$jc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let m;return f.scheme===E.Schemas.file?m=y.URI.file(k.$pc(o(f))).path:(m=k.$jc.dirname(f.path),f.authority&&m.length&&m.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),m="/")),f.with({path:m})}normalizePath(f){if(!f.path.length)return f;let m;return f.scheme===E.Schemas.file?m=y.URI.file(k.$kc(o(f))).path:m=k.$jc.normalize(f.path),f.with({path:m})}relativePath(f,m){if(f.scheme!==m.scheme||!(0,e.$mh)(f.authority,m.authority))return;if(f.scheme===E.Schemas.file){const d=k.$oc(o(f),o(m));return R.$i?r.$zg(d):d}let $=f.path||"/";const b=m.path||"/";if(this.a(f)){let d=0;for(const p=Math.min($.length,b.length);d<p&&!($.charCodeAt(d)!==b.charCodeAt(d)&&$.charAt(d).toLowerCase()!==b.charAt(d).toLowerCase());d++);$=b.substr(0,d)+$.substr(d)}return k.$jc.relative($,b)}resolvePath(f,m){if(f.scheme===E.Schemas.file){const $=y.URI.file(k.$nc(o(f),m));return f.with({authority:$.authority,path:$.path})}return m=r.$Ag(m),f.with({path:k.$jc.resolve(f.path,m)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,m){return f===m||f!==void 0&&m!==void 0&&(0,A.$Hf)(f,m)}hasTrailingPathSeparator(f,m=k.sep){if(f.scheme===E.Schemas.file){const $=o(f);return $.length>r.$Bg($).length&&$[$.length-1]===m}else{const $=f.path;return $.length>1&&$.charCodeAt($.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,m=k.sep){return(0,e.$nh)(f,m)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,m=k.sep){let $=!1;if(f.scheme===E.Schemas.file){const b=o(f);$=b!==void 0&&b.length===r.$Bg(b).length&&b[b.length-1]===m}else{m="/";const b=f.path;$=b.length===1&&b.charCodeAt(b.length-1)===n.CharCode.Slash}return!$&&!(0,e.$nh)(f,m)?f.with({path:f.path+"/"}):f}}e.$9g=D,e.$0g=new D(()=>!1),e.$$g=new D(a=>a.scheme===E.Schemas.file?!R.$k:!0),e.$_g=new D(a=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function v(a,f){const m=[];for(let $=0;$<a.length;$++){const b=f(a[$]);a.some((d,p)=>p===$?!1:(0,e.$bh)(b,f(d)))||m.push(a[$])}return m}var h;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function f(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(p=>{const[t,l]=p.split(":");t&&l&&$.set(t,l)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&$.set(a.META_DATA_MIME,d),$}a.parseMetaData=f})(h||(e.DataUri=h={}));function w(a,f,m){if(f){let $=a.path;return $&&$[0]!==k.$jc.sep&&($=k.$jc.sep+$),a.with({scheme:m,authority:f,path:$})}return a.with({scheme:m})}}),define(ve[14],Se([1,0,19,10,6,2,20,3,171,65]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=D,e.$th=v,e.$uh=h,e.$vh=w,e.$wh=a,e.$xh=f,e.$yh=m,e.$zh=$,e.$Hh=u,e.$Ih=S,e.$Jh=P,e.$Kh=C,e.$Lh=L,e.$1h=B,e.$9h=M;function D(X){return!!X&&typeof X.then=="function"}function v(X){const F=new n.$ye,W=X(F.token),oe=new Promise((he,ke)=>{const Ne=F.token.onCancellationRequested(()=>{Ne.dispose(),ke(new r.$8)});Promise.resolve(W).then(me=>{Ne.dispose(),F.dispose(),he(me)},me=>{Ne.dispose(),F.dispose(),ke(me)})});return new class{cancel(){F.cancel(),F.dispose()}then(he,ke){return oe.then(he,ke)}catch(he){return this.then(void 0,he)}finally(he){return oe.finally(he)}}}function h(X,F,W){return new Promise((oe,he)=>{const ke=F.onCancellationRequested(()=>{ke.dispose(),oe(W)});X.then(oe,he).finally(()=>ke.dispose())})}function w(X,F){return new Promise((W,oe)=>{const he=F.onCancellationRequested(()=>{he.dispose(),oe(new r.$8)});X.then(W,oe).finally(()=>he.dispose())})}async function a(X){let F=-1;const W=X.map((oe,he)=>oe.then(ke=>(F=he,ke)));try{return await Promise.race(W)}finally{X.forEach((oe,he)=>{he!==F&&oe.cancel()})}}function f(X,F,W){let oe;const he=setTimeout(()=>{oe?.(void 0),W?.()},F);return Promise.race([X.finally(()=>clearTimeout(he)),new Promise(ke=>oe=ke)])}function m(X){return new Promise((F,W)=>{const oe=X();D(oe)?oe.then(F,W):F(oe)})}function $(){let X,F;return{promise:new Promise((oe,he)=>{X=oe,F=he}),resolve:X,reject:F}}class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=F,!this.b){const W=()=>{if(this.b=null,this.f)return;const oe=this.queue(this.d);return this.d=null,oe};this.b=new Promise(oe=>{this.a.then(W,W).then(oe)})}return new Promise((W,oe)=>{this.b.then(W,oe)})}return this.a=F(),new Promise((W,oe)=>{this.a.then(he=>{this.a=null,W(he)},he=>{this.a=null,oe(he)})})}dispose(){this.f=!0}}e.$Ah=b;class d{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$Bh=d;class p{constructor(){this.a=new Map}queue(F,W){const he=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(F)===he&&this.a.delete(F)});return this.a.set(F,he),he}}e.$Ch=p;const t=(X,F)=>{let W=!0;const oe=setTimeout(()=>{W=!1,F()},X);return{isTriggered:()=>W,dispose:()=>{clearTimeout(oe),W=!1}}},l=X=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,X())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class i{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,W=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((he,ke)=>{this.d=he,this.f=ke}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const oe=()=>{this.a=null,this.d?.(null)};return this.a=W===y.$ie?l(oe):t(W,oe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class g{constructor(F){this.a=new i(F),this.b=new b}trigger(F,W){return this.a.trigger(()=>this.b.queue(F),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=g;class s{constructor(){this.a=!1,this.b=new Promise((F,W)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=s;class c extends s{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$Gh=c;function u(X,F){return F?new Promise((W,oe)=>{const he=setTimeout(()=>{ke.dispose(),W()},X),ke=F.onCancellationRequested(()=>{clearTimeout(he),ke.dispose(),oe(new r.$8)})}):v(W=>u(X,W))}function S(X,F=0,W){const oe=setTimeout(()=>{X(),W&&he.dispose()},F),he=(0,k.$Vc)(()=>{clearTimeout(oe),W?.deleteAndLeak(he)});return W?.add(he),he}function P(X){const F=[];let W=0;const oe=X.length;function he(){return W<oe?X[W++]():null}function ke(Ne){Ne!=null&&F.push(Ne);const me=he();return me?me.then(ke):Promise.resolve(F)}return Promise.resolve(null).then(ke)}function C(X,F=oe=>!!oe,W=null){let oe=0;const he=X.length,ke=()=>{if(oe>=he)return Promise.resolve(W);const Ne=X[oe++];return Promise.resolve(Ne()).then($e=>F($e)?Promise.resolve($e):ke())};return ke()}function L(X,F=oe=>!!oe,W=null){if(X.length===0)return Promise.resolve(W);let oe=X.length;const he=()=>{oe=-1;for(const ke of X)ke.cancel?.()};return new Promise((ke,Ne)=>{for(const me of X)me.then($e=>{--oe>=0&&F($e)?(he(),ke($e)):oe===0&&ke(W)}).catch($e=>{--oe>=0&&(he(),Ne($e))})})}class T{constructor(F){this.a=0,this.b=!1,this.f=F,this.g=[],this.d=0,this.h=new E.$ne}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(F){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((W,oe)=>{this.g.push({factory:F,c:W,e:oe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const F=this.g.shift();this.d++;const W=F.factory();W.then(F.c,F.e),W.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=T;class I extends T{constructor(){super(1)}}e.$Nh=I;class q{constructor(){this.a=new ie,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$Oh=q;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const F=new H;return this.b.add(F),F.p}g(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueSize(F,W=R.$0g){const oe=W.getComparisonKey(F);return this.a.get(oe)?.size??0}queueFor(F,W,oe=R.$0g){const he=oe.getComparisonKey(F);let ke=this.a.get(he);if(!ke){ke=new I;const Ne=this.f++,me=E.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(Ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$7c),this.d.set(Ne,me),this.a.set(he,ke)}return ke.queue(W)}h(){this.g()&&this.j()}j(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=Y;class Q{constructor(F,W){this.b=!1,this.a=-1,typeof F=="function"&&typeof W=="number"&&this.setIfNotSet(F,W)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,W){if(this.b)throw new r.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},W)}setIfNotSet(F,W){if(this.b)throw new r.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},W))}}e.$Qh=Q;class re{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(F,W,oe=globalThis){if(this.f)throw new r.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const he=oe.setInterval(()=>{F()},W);this.d=(0,k.$Vc)(()=>{oe.clearInterval(he),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=re;class te{constructor(F,W){this.b=-1,this.a=F,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=te;class _{constructor(F,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=F,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=_;class de extends te{constructor(F,W){super(F,W),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$Uh=de;class J extends k.$Xc{constructor(F,W){super(),this.g=F,this.h=W,this.a=[],this.b=this.B(new k.$Yc),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of F)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(X,F)=>{(0,A.$B)(()=>{if(W)return;const oe=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$Xh=(X,F,W)=>{const oe=X.requestIdleCallback(F,typeof W=="number"?{timeout:W}:void 0);let he=!1;return{dispose(){he||(he=!0,X.cancelIdleCallback(oe))}}},e.$Wh=X=>(0,e.$Xh)(globalThis,X)}();class ae{constructor(F,W){this.g=!1,this.d=()=>{try{this.j=W()}catch(oe){this.l=oe}finally{this.g=!0}},this.f=(0,e.$Xh)(F,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ae;class z extends ae{constructor(F){super(globalThis,F)}}e.$Zh=z;async function B(X,F,W){let oe;for(let he=0;he<W;he++)try{return await X()}catch(ke){oe=ke,await u(F)}throw oe}class ie{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,W,oe){return this.a={taskId:F,cancel:()=>oe?.(),promise:W},W.then(()=>this.d(F),()=>this.d(F)),W}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{const{promise:W,resolve:oe,reject:he}=$();this.b={run:F,promise:W,promiseResolve:oe,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=ie;class le{constructor(F,W=()=>Date.now()){this.d=F,this.f=W,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$3h=le;var pe;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(pe||(pe={}));class H{get isRejected(){return this.d?.outcome===pe.Rejected}get isResolved(){return this.d?.outcome===pe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===pe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((F,W)=>{this.a=F,this.b=W})}complete(F){return new Promise(W=>{this.a(F),this.d={outcome:pe.Resolved,value:F},W()})}error(F){return new Promise(W=>{this.b(F),this.d={outcome:pe.Rejected,value:F},W()})}cancel(){return this.error(new r.$8)}}e.$4h=H;var ce;(function(X){async function F(oe){let he;const ke=await Promise.all(oe.map(Ne=>Ne.then(me=>me,me=>{he||(he=me)})));if(typeof he<"u")throw he;return ke}X.settled=F;function W(oe){return new Promise(async(he,ke)=>{try{await oe(he,ke)}catch(Ne){ke(Ne)}})}X.withAsyncBody=W})(ce||(e.Promises=ce={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(F){this.a=void 0,this.b=void 0,this.d=!1,this.promise=F.then(W=>(this.a=W,this.d=!0,W),W=>{throw this.b=W,this.d=!0,W})}requireValue(){if(!this.d)throw new r.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=x;class U{constructor(F){this.b=F,this.a=new o.$X(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=U;var O;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(O||(O={}));class Z{static fromArray(F){return new Z(W=>{W.emitMany(F)})}static fromPromise(F){return new Z(async W=>{W.emitMany(await F)})}static fromPromises(F){return new Z(async W=>{await Promise.all(F.map(async oe=>W.emitOne(await oe)))})}static merge(F){return new Z(async W=>{await Promise.all(F.map(async oe=>{for await(const he of oe)W.emitOne(he)}))})}static{this.EMPTY=Z.fromArray([])}constructor(F,W){this.a=O.Initial,this.b=[],this.d=null,this.f=W,this.g=new E.$ne,queueMicrotask(async()=>{const oe={emitOne:he=>this.h(he),emitMany:he=>this.j(he),reject:he=>this.l(he)};try{await Promise.resolve(F(oe)),this.k()}catch(he){this.l(he)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===O.DoneError)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===O.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(F,W){return new Z(async oe=>{for await(const he of F)oe.emitOne(W(he))})}map(F){return Z.map(this,F)}static filter(F,W){return new Z(async oe=>{for await(const he of F)W(he)&&oe.emitOne(he)})}filter(F){return Z.filter(this,F)}static coalesce(F){return Z.filter(F,W=>!!W)}coalesce(){return Z.coalesce(this)}static async toPromise(F){const W=[];for await(const oe of F)W.push(oe);return W}toPromise(){return Z.toPromise(this)}h(F){this.a===O.Initial&&(this.b.push(F),this.g.fire())}j(F){this.a===O.Initial&&(this.b=this.b.concat(F),this.g.fire())}k(){this.a===O.Initial&&(this.a=O.DoneOK,this.g.fire())}l(F){this.a===O.Initial&&(this.a=O.DoneError,this.d=F,this.g.fire())}}e.$7h=Z;class V extends Z{constructor(F,W){super(W),this.m=F}cancel(){this.m.cancel()}}e.$8h=V;function M(X){const F=new n.$ye,W=X(F.token);return new V(F,async oe=>{const he=F.token.onCancellationRequested(()=>{he.dispose(),F.dispose(),oe.reject(new r.$8)});try{for await(const ke of W){if(F.token.isCancellationRequested)return;oe.emitOne(ke)}he.dispose(),F.dispose()}catch(ke){he.dispose(),F.dispose(),oe.reject(ke)}})}class G{constructor(F){this.a=new H,this.b=new Z(he=>{if(W){he.reject(W);return}return oe&&he.emitMany(oe),this.d=ke=>he.reject(ke),this.f=ke=>he.emitOne(ke),this.a.p},F);let W,oe;this.f=he=>{oe||(oe=[]),oe.push(he)},this.d=he=>{W||(W=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(F){this.d(F),this.a.complete()}emitOne(F){this.f(F)}}e.$0h=G}),define(ve[86],Se([1,0,18,14,35,37,26,9,3,17]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=D,e.$yk=f,e.$zk=q,e.$Ak=Y,e.$Bk=Q,e.$Ck=re,e.$Dk=te,e.$Ek=ae;function D(){return Object.create(null)}e.$wk="**",e.$xk="/";const v="[/\\\\]",h="[^/\\\\]",w=/\//g;function a(z,B){switch(z){case 0:return"";case 1:return`${h}*?`;default:return`(?:${v}|${h}+${v}${B?`|${v}${h}+`:""})*?`}}function f(z,B){if(!z)return[];const ie=[];let le=!1,pe=!1,H="";for(const ce of z){switch(ce){case B:if(!le&&!pe){ie.push(H),H="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}H+=ce}return H&&ie.push(H),ie}function m(z){if(!z)return"";let B="";const ie=f(z,e.$xk);if(ie.every(le=>le===e.$wk))B=".*";else{let le=!1;ie.forEach((pe,H)=>{if(pe===e.$wk){if(le)return;B+=a(2,H===ie.length-1)}else{let ce=!1,x="",U=!1,O="";for(const Z of pe){if(Z!=="}"&&ce){x+=Z;continue}if(U&&(Z!=="]"||!O)){let V;Z==="-"?V=Z:(Z==="^"||Z==="!")&&!O?V="^":Z===e.$xk?V="":V=(0,o.$jf)(Z),O+=V;continue}switch(Z){case"{":ce=!0;continue;case"[":U=!0;continue;case"}":{const M=`(?:${f(x,",").map(G=>m(G)).join("|")})`;B+=M,ce=!1,x="";break}case"]":{B+="["+O+"]",U=!1,O="";break}case"?":B+=h;continue;case"*":B+=a(1);continue;default:B+=(0,o.$jf)(Z)}}H<ie.length-1&&(ie[H+1]!==e.$wk||H+2<ie.length)&&(B+=v)}le=pe===e.$wk})}return B}const $=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.$Gc(1e4),g=function(){return!1},s=function(){return null};function c(z,B){if(!z)return s;let ie;typeof z!="string"?ie=z.pattern:ie=z,ie=ie.trim();const le=`${ie}_${!!B.trimForExclusions}`;let pe=i.get(le);if(pe)return u(pe,z);let H;return $.test(ie)?pe=P(ie.substr(4),ie):(H=b.exec(S(ie,B)))?pe=C(H[1],ie):(B.trimForExclusions?p:d).test(ie)?pe=L(ie,B):(H=t.exec(S(ie,B)))?pe=T(H[1].substr(1),ie,!0):(H=l.exec(S(ie,B)))?pe=T(H[1],ie,!1):pe=I(ie),i.set(le,pe),u(pe,z)}function u(z,B){if(typeof B=="string")return z;const ie=function(le,pe){return(0,k.$Fg)(le,B.base,!y.$k)?z((0,o.$of)(le.substr(B.base.length),A.sep),pe):null};return ie.allBasenames=z.allBasenames,ie.allPaths=z.allPaths,ie.basenames=z.basenames,ie.patterns=z.patterns,ie}function S(z,B){return B.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function P(z,B){return function(ie,le){return typeof ie=="string"&&ie.endsWith(z)?B:null}}function C(z,B){const ie=`/${z}`,le=`\\${z}`,pe=function(ce,x){return typeof ce!="string"?null:x?x===z?B:null:ce===z||ce.endsWith(ie)||ce.endsWith(le)?B:null},H=[z];return pe.basenames=H,pe.patterns=[B],pe.allBasenames=H,pe}function L(z,B){const ie=J(z.slice(1,-1).split(",").map(x=>c(x,B)).filter(x=>x!==s),z),le=ie.length;if(!le)return s;if(le===1)return ie[0];const pe=function(x,U){for(let O=0,Z=ie.length;O<Z;O++)if(ie[O](x,U))return z;return null},H=ie.find(x=>!!x.allBasenames);H&&(pe.allBasenames=H.allBasenames);const ce=ie.reduce((x,U)=>U.allPaths?x.concat(U.allPaths):x,[]);return ce.length&&(pe.allPaths=ce),pe}function T(z,B,ie){const le=A.sep===A.$jc.sep,pe=le?z:z.replace(w,A.sep),H=A.sep+pe,ce=A.$jc.sep+z;let x;return ie?x=function(U,O){return typeof U=="string"&&(U===pe||U.endsWith(H)||!le&&(U===z||U.endsWith(ce)))?B:null}:x=function(U,O){return typeof U=="string"&&(U===pe||!le&&U===z)?B:null},x.allPaths=[(ie?"*/":"./")+z],x}function I(z){try{const B=new RegExp(`^${m(z)}$`);return function(ie){return B.lastIndex=0,typeof ie=="string"&&B.test(ie)?z:null}}catch{return s}}function q(z,B,ie){return!z||typeof B!="string"?!1:Y(z)(B,void 0,ie)}function Y(z,B={}){if(!z)return g;if(typeof z=="string"||Q(z)){const ie=c(z,B);if(ie===s)return g;const le=function(pe,H){return!!ie(pe,H)};return ie.allBasenames&&(le.allBasenames=ie.allBasenames),ie.allPaths&&(le.allPaths=ie.allPaths),le}return _(z,B)}function Q(z){const B=z;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function re(z){return z.allBasenames||[]}function te(z){return z.allPaths||[]}function _(z,B){const ie=J(Object.getOwnPropertyNames(z).map(x=>de(x,z[x],B)).filter(x=>x!==s)),le=ie.length;if(!le)return s;if(!ie.some(x=>!!x.requiresSiblings)){if(le===1)return ie[0];const x=function(Z,V){let M;for(let G=0,X=ie.length;G<X;G++){const F=ie[G](Z,V);if(typeof F=="string")return F;(0,r.$sh)(F)&&(M||(M=[]),M.push(F))}return M?(async()=>{for(const G of M){const X=await G;if(typeof X=="string")return X}return null})():null},U=ie.find(Z=>!!Z.allBasenames);U&&(x.allBasenames=U.allBasenames);const O=ie.reduce((Z,V)=>V.allPaths?Z.concat(V.allPaths):Z,[]);return O.length&&(x.allPaths=O),x}const pe=function(x,U,O){let Z,V;for(let M=0,G=ie.length;M<G;M++){const X=ie[M];X.requiresSiblings&&O&&(U||(U=(0,A.$qc)(x)),Z||(Z=U.substr(0,U.length-(0,A.$rc)(x).length)));const F=X(x,U,Z,O);if(typeof F=="string")return F;(0,r.$sh)(F)&&(V||(V=[]),V.push(F))}return V?(async()=>{for(const M of V){const G=await M;if(typeof G=="string")return G}return null})():null},H=ie.find(x=>!!x.allBasenames);H&&(pe.allBasenames=H.allBasenames);const ce=ie.reduce((x,U)=>U.allPaths?x.concat(U.allPaths):x,[]);return ce.length&&(pe.allPaths=ce),pe}function de(z,B,ie){if(B===!1)return s;const le=c(z,ie);if(le===s)return s;if(typeof B=="boolean")return le;if(B){const pe=B.when;if(typeof pe=="string"){const H=(ce,x,U,O)=>{if(!O||!le(ce,x))return null;const Z=pe.replace("$(basename)",()=>U),V=O(Z);return(0,r.$sh)(V)?V.then(M=>M?z:null):V?z:null};return H.requiresSiblings=!0,H}}return le}function J(z,B){const ie=z.filter(x=>!!x.basenames);if(ie.length<2)return z;const le=ie.reduce((x,U)=>{const O=U.basenames;return O?x.concat(O):x},[]);let pe;if(B){pe=[];for(let x=0,U=le.length;x<U;x++)pe.push(B)}else pe=ie.reduce((x,U)=>{const O=U.patterns;return O?x.concat(O):x},[]);const H=function(x,U){if(typeof x!="string")return null;if(!U){let Z;for(Z=x.length;Z>0;Z--){const V=x.charCodeAt(Z-1);if(V===E.CharCode.Slash||V===E.CharCode.Backslash)break}U=x.substr(Z)}const O=le.indexOf(U);return O!==-1?pe[O]:null};H.basenames=le,H.patterns=pe,H.allBasenames=le;const ce=z.filter(x=>!x.basenames);return ce.push(H),ce}function ae(z,B){return(0,n.$xb)(z,B,(ie,le)=>typeof ie=="string"&&typeof le=="string"?ie===le:typeof ie!="string"&&typeof le!="string"?ie.base===le.base&&ie.pattern===le.pattern:!1)}}),define(ve[111],Se([1,0,10,174,20,17,4]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=o,e.$6k=D,e.$7k=v,e.$8k=h,e.$9k=w,e.$0k=a,e.$$k=f,e.$_k=m;var A;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class y{constructor(b="",d=!1){if(this.value=b,typeof this.value!="string")throw(0,n.$0)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(b,d=A.Paragraph){return this.value+=h(this.supportThemeIcons?(0,r.$Xk)(b):b).replace(/([ \t]+)/g,(p,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===A.Break?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,d){return this.value+=`
${w(d,b)}
`,this}appendLink(b,d,p){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(b),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(b,d){const p=new RegExp((0,k.$jf)(d),"g");return b.replace(p,(t,l)=>b.charAt(l-1)!=="\\"?`\\${t}`:t)}}e.$4k=y;function o($){return D($)?!$.value:Array.isArray($)?$.every(o):!0}function D($){return $ instanceof y?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function v($,b){return $===b?!0:!$||!b?!1:$.value===b.value&&$.isTrusted===b.isTrusted&&$.supportThemeIcons===b.supportThemeIcons&&$.supportHtml===b.supportHtml&&($.baseUri===b.baseUri||!!$.baseUri&&!!b.baseUri&&(0,E.$ah)(R.URI.from($.baseUri),R.URI.from(b.baseUri)))}function h($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w($,b){const d=$.match(/^`+/gm)?.reduce((t,l)=>t.length>l.length?t:l).length??0,p=d>=3?d+1:3;return[`${"`".repeat(p)}${b}`,$,`${"`".repeat(p)}`].join(`
`)}function a($){return $.replace(/"/g,"&quot;")}function f($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const b=[],d=$.split("|").map(t=>t.trim());$=d[0];const p=d[1];if(p){const t=/height=(\d+)/.exec(p),l=/width=(\d+)/.exec(p),i=t?t[1]:"",g=l?l[1]:"",s=isFinite(parseInt(g)),c=isFinite(parseInt(i));s&&b.push(`width="${g}"`),c&&b.push(`height="${i}"`)}return{href:$,dimensions:b}}}),define(ve[194],Se([1,0,18,37,9,3,20,17]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=y,e.$Xw=D,e.$Yw=h,e.$Zw=w,e.$1w=$,e.$2w=d,e.$3w=p,e.$4w=t,e.$5w=l,e.$6w=i;function y(s,c){const{os:u,tildify:S,relative:P}=c;if(P){const T=o(s,P,u);if(typeof T=="string")return T}let C=s.fsPath;if(u===k.OperatingSystem.Windows&&!k.$i?C=C.replace(/\//g,"\\"):u!==k.OperatingSystem.Windows&&k.$i&&(C=C.replace(/\\/g,"/")),u!==k.OperatingSystem.Windows&&S?.userHome){const T=S.userHome.fsPath;let I;s.scheme!==S.userHome.scheme&&s.path[0]===E.$jc.sep&&s.path[1]!==E.$jc.sep?I=S.userHome.with({path:s.path}).fsPath:I=C,C=h(I,T,u)}return(u===k.OperatingSystem.Windows?E.$ic:E.$jc).normalize(D(C,u===k.OperatingSystem.Windows))}function o(s,c,u){const S=u===k.OperatingSystem.Windows?E.$ic:E.$jc,P=u===k.OperatingSystem.Linux?R.$0g:R.$_g,C=c.getWorkspace(),L=(0,n.$Rb)(C.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===E.$jc.sep&&s.path[1]!==E.$jc.sep&&(s=L.uri.with({path:s.path}));const T=c.getWorkspaceFolder(s);if(!T)return;let I;if(P.isEqual(T.uri,s)?I="":I=P.relativePath(T.uri,s)??"",I&&(I=S.normalize(I)),C.folders.length>1&&!c.noPrefix){const q=T.name?T.name:P.basenameOrAuthority(T.uri);I=I?`${q} \u2022 ${I}`:q}return I}function D(s,c=k.$i){return(0,r.$Kg)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}let v=Object.create(null);function h(s,c,u=k.OS){if(u===k.OperatingSystem.Windows||!s||!c)return s;let S=v.original===c?v.normalized:void 0;S||(S=c,k.$i&&(S=(0,r.$zg)(S)),S=`${(0,A.$pf)(S,E.$jc.sep)}${E.$jc.sep}`,v={original:c,normalized:S});let P=s;return k.$i&&(P=(0,r.$zg)(P)),(u===k.OperatingSystem.Linux?P.startsWith(S):(0,A.$If)(P,S))?`~/${P.substr(S.length)}`:s}function w(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}const a="\u2026",f="\\\\",m="~";function $(s,c=E.sep){const u=new Array(s.length);let S=!1;for(let P=0;P<s.length;P++){const C=s[P];if(C===""){u[P]=`.${c}`;continue}if(!C){u[P]=C;continue}S=!0;let L="",T=C;T.indexOf(f)===0?(L=T.substr(0,T.indexOf(f)+f.length),T=T.substr(T.indexOf(f)+f.length)):T.indexOf(c)===0?(L=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(m)===0&&(L=T.substr(0,T.indexOf(m)+m.length),T=T.substr(T.indexOf(m)+m.length));const I=T.split(c);for(let q=1;S&&q<=I.length;q++)for(let Y=I.length-q;S&&Y>=0;Y--){S=!1;let Q=I.slice(Y,Y+q).join(c);for(let re=0;!S&&re<s.length;re++)if(re!==P&&s[re]&&s[re].indexOf(Q)>-1){const te=Y+q===I.length,_=Y>0&&s[re].indexOf(c)>-1?c+Q:Q,de=s[re].endsWith(_);S=!te||de}if(!S){let re="";(I[0].endsWith(":")||L!=="")&&(Y===1&&(Y=0,q++,Q=I[0]+c+Q),Y>0&&(re=I[0]+c),re=L+re),Y>0&&(re=re+a+c),re=re+Q,Y+q<I.length&&(re=re+c+a),u[P]=re}}S&&(u[P]=C)}return u}var b;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function d(s,c=Object.create(null)){const u=[];let S=!1,P="";for(const C of s)if(C==="$"||S&&C==="{")P&&u.push({value:P,type:b.TEXT}),P="",S=!0;else if(C==="}"&&S){const L=c[P];if(typeof L=="string")L.length&&u.push({value:L,type:b.VARIABLE});else if(L){const T=u[u.length-1];(!T||T.type!==b.SEPARATOR)&&u.push({value:L.label,type:b.SEPARATOR})}P="",S=!1}else P+=C;return P&&!S&&u.push({value:P,type:b.TEXT}),u.filter((C,L)=>{if(C.type===b.SEPARATOR){const T=u[L-1],I=u[L+1];return[T,I].every(q=>q&&(q.type===b.VARIABLE||q.type===b.TEXT)&&q.value.length>0)}return!0}).map(C=>C.value).join("")}function p(s,c){return k.$j||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.$j?"&":"&&"):s.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function t(s,c){return k.$j||c?s.replace(/\(&&\w\)|&&/g,""):k.$i?s.replace(/&&|&/g,u=>u==="&"?"&&":"&"):s.replace(/&&/g,"_")}function l(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const c=s.lastIndexOf(" [",s.length-2);if(c!==-1){const u=g(s.substring(0,c)),S=s.substring(c);return{name:u.name+S,parentPath:u.parentPath}}}return g(s)}function g(s){const c=s.indexOf("/")!==-1?E.$jc:E.$ic,u=c.basename(s),S=c.dirname(s);return u.length?{name:u,parentPath:S}:{name:S,parentPath:""}}}),define(ve[59],Se([1,0,15,81,4]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=y,e.$Pn=D,e.$Qn=v;function k(h){return h.toJSON()}class R{constructor(w){this.a=w}transformIncoming(w){const a=this.a.transformIncoming(w);return a===w?w:k(E.URI.from(a))}transformOutgoing(w){const a=this.a.transformOutgoing(w);return a===w?w:k(E.URI.from(a))}transformOutgoingURI(w){const a=this.a.transformOutgoing(w);return a===w?w:E.URI.from(a)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Mn=R,e.$Nn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function A(h,w,a){if(!h||a>200)return null;if(typeof h=="object"){if(h instanceof E.URI)return w.transformOutgoing(h);for(const f in h)if(Object.hasOwnProperty.call(h,f)){const m=A(h[f],w,a+1);m!==null&&(h[f]=m)}}return null}function y(h,w){const a=A(h,w,0);return a===null?h:a}function o(h,w,a,f){if(!h||f>200)return null;if(typeof h=="object"){if(h.$mid===r.MarshalledId.Uri)return a?E.URI.revive(w.transformIncoming(h)):w.transformIncoming(h);if(h instanceof n.$Pe)return null;for(const m in h)if(Object.hasOwnProperty.call(h,m)){const $=o(h[m],w,a,f+1);$!==null&&(h[m]=$)}}return null}function D(h,w){const a=o(h,w,!1,0);return a===null?h:a}function v(h,w){const a=o(h,w,!0,0);return a===null?h:a}}),define(ve[112],Se([1,0,32,67,23,177,3]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=y,e.$Un=v,e.$Vn=h,E=qe(E),e.$Sn=new class{c(w){return this.a||(this.a=r.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,a=0;const f=(0,n.networkInterfaces)();for(const m in f){const $=f[m];if($)for(const{mac:b,internal:d}of $)d||(a+=1,this.c(b.toUpperCase())&&(w+=1))}this.b=a>0?w/a:0}return this.b}};let A;async function y(w){return A||(A=(async()=>await o(w)||E.$3g())()),A}async function o(w){try{const a=await new Promise((m,$)=>{se(["crypto"],m,$)}).then(qe),f=(0,k.$Rn)();return a.createHash("sha256").update(f,"utf8").digest("hex")}catch(a){w(a);return}}const D="Software\\Microsoft\\SQMClient";async function v(w){if(R.$i){const a=await new Promise((f,m)=>{se(["@vscode/windows-registry"],f,m)}).then(qe);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(f){return w(f),""}}return""}async function h(w){try{return await(await new Promise((m,$)=>{se(["@vscode/deviceid"],m,$)}).then(qe)).getDeviceId()}catch(a){return w(a),""}}}),define(ve[195],Se([1,0,31,331,332,3]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=R,k=qe(k);async function R(A){if(k.$j||k.$i)return;let y;for(const o of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{y=await(0,r.open)(o,n.constants.R_OK);break}catch{}if(!y){A("Unable to retrieve release information from known identifier paths.");return}try{const o=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),D={id:"unknown"};for await(const v of(0,E.createInterface)({input:y.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const h=v.split("=")[0].toUpperCase().trim();if(o.has(h)){const w=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?D.id=w:h==="ID_LIKE"?D.id_like=w:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(D.version_id=w)}}return D}catch(o){A(o)}}}),define(ve[25],Se([1,0,31,32,333,14,37,107,9,3,20,4]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=d,e.whenDeleted=l,e.configureFlushOnWrite=u,e.writeFileSync=P,n=qe(n);var h;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function w(_,de=h.UNLINK,J){if((0,R.$Jg)(_))throw new Error("rimraf - will refuse to recursively delete root");return de===h.UNLINK?f(_):a(_,J)}async function a(_,de=(0,R.$Og)((0,r.tmpdir)())){try{try{await n.promises.rename(_,de)}catch(J){return J.code==="ENOENT"?void 0:f(_)}f(de).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function f(_){return n.promises.rm(_,{recursive:!0,force:!0,maxRetries:3})}function m(_){if((0,R.$Jg)(_))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}async function $(_,de){return p(await(de?b(_):n.promises.readdir(_)))}async function b(_){try{return await n.promises.readdir(_,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const de=[],J=await $(_);for(const ae of J){let z=!1,B=!1,ie=!1;try{const le=await e.Promises.lstat((0,y.$mc)(_,ae));z=le.isFile(),B=le.isDirectory(),ie=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}de.push({name:ae,isFile:()=>z,isDirectory:()=>B,isSymbolicLink:()=>ie})}return de}function d(_){return p(n.readdirSync(_))}function p(_){return _.map(de=>typeof de=="string"?o.$j?(0,A.$nm)(de):de:(de.name=o.$j?(0,A.$nm)(de.name):de.name,de))}async function t(_){const de=await $(_),J=[];for(const ae of de)await i.existsDirectory((0,y.$mc)(_,ae))&&J.push(ae);return J}function l(_,de=1e3){return new Promise(J=>{let ae=!1;const z=setInterval(()=>{ae||(ae=!0,n.access(_,B=>{ae=!1,B&&(clearInterval(z),J(void 0))}))},de)})}var i;(function(_){async function de(z){let B;try{if(B=await e.Promises.lstat(z),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(o.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw le}throw ie}}_.stat=de;async function J(z){try{const{stat:B,symbolicLink:ie}=await _.stat(z);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}_.existsFile=J;async function ae(z){try{const{stat:B,symbolicLink:ie}=await _.stat(z);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}_.existsDirectory=ae})(i||(e.SymlinkSupport=i={}));const g=new k.$Ph;function s(_,de,J){return g.queueFor(v.URI.file(_),()=>{const ae=C(J);return new Promise((z,B)=>S(_,de,ae,ie=>ie?B(ie):z()))},D.$$g)}let c=!0;function u(_){c=_}function S(_,de,J,ae){if(!c)return n.writeFile(_,de,{mode:J.mode,flag:J.flag},ae);n.open(_,J.flag,J.mode,(z,B)=>{if(z)return ae(z);n.writeFile(B,de,ie=>{if(ie)return n.close(B,()=>ae(ie));n.fdatasync(B,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),u(!1)),n.close(B,pe=>ae(pe))))})})}function P(_,de,J){const ae=C(J);if(!c)return n.writeFileSync(_,de,{mode:ae.mode,flag:ae.flag});const z=n.openSync(_,ae.flag,ae.mode);try{n.writeFileSync(z,de);try{n.fdatasyncSync(z)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{n.closeSync(z)}}function C(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function L(_,de,J=6e4){if(_!==de)try{o.$i&&typeof J=="number"?await T(_,de,Date.now(),J):await n.promises.rename(_,de)}catch(ae){if(_.toLowerCase()!==de.toLowerCase()&&ae.code==="EXDEV"||_.endsWith("."))await I(_,de,{preserveSymlinks:!1}),await w(_,h.MOVE);else throw ae}}async function T(_,de,J,ae,z=0){try{return await n.promises.rename(_,de)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-J>=ae)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${B}`),B;if(z===0){let ie=!1;try{const{stat:le}=await i.stat(de);le.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,k.$Hh)(Math.min(100,z*10)),T(_,de,J,ae,z+1)}}async function I(_,de,J){return Y(_,de,{root:{source:_,target:de},options:J,handledSourcePaths:new Set})}const q=511;async function Y(_,de,J){if(J.handledSourcePaths.has(_))return;J.handledSourcePaths.add(_);const{stat:ae,symbolicLink:z}=await i.stat(_);if(z){if(J.options.preserveSymlinks)try{return await te(_,de,J)}catch{}if(z.dangling)return}return ae.isDirectory()?Q(_,de,ae.mode&q,J):re(_,de,ae.mode&q)}async function Q(_,de,J,ae){await e.Promises.mkdir(de,{recursive:!0,mode:J});const z=await $(_);for(const B of z)await Y((0,y.$mc)(_,B),(0,y.$mc)(de,B),ae)}async function re(_,de,J){await e.Promises.copyFile(_,de),await e.Promises.chmod(de,J)}async function te(_,de,J){let ae=await e.Promises.readlink(_);(0,R.$Fg)(ae,J.root.source,!o.$k)&&(ae=(0,y.$mc)(J.root.target,ae.substr(J.root.source.length+1))),await e.Promises.symlink(ae,de)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(_,de,J,ae,z)=>new Promise((B,ie)=>{n.read(_,de,J,ae,z,(le,pe,H)=>le?ie(le):B({bytesRead:pe,buffer:H}))})}get readFile(){return n.promises.readFile}get write(){return(_,de,J,ae,z)=>new Promise((B,ie)=>{n.write(_,de,J,ae,z,(le,pe,H)=>le?ie(le):B({bytesWritten:pe,buffer:H}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,E.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,E.promisify)(n.open)}get close(){return(0,E.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,E.promisify)(n.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return I}}}),define(ve[196],Se([1,0,31,9,3,17,25]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=A,e.$kr=y,e.$lr=o,e.$mr=D,n=qe(n);function A(h){if(E.$k)return h;const w=(0,r.$pc)(h);if(h===w)return h;const a=((0,r.$qc)(h)||h).toLowerCase();try{const m=(0,R.readdirSync)(w).filter($=>$.toLowerCase()===a);if(m.length===1){const $=A(w);if($)return(0,r.$mc)($,m[0])}else if(m.length>1){const $=m.indexOf(a);if($>=0){const b=A(w);if(b)return(0,r.$mc)(b,m[$])}}}catch{}return null}async function y(h,w){if(E.$k)return h;const a=(0,r.$pc)(h);if(h===a)return h;const f=((0,r.$qc)(h)||h).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await R.Promises.readdir(a)).filter(b=>b.toLowerCase()===f);if($.length===1){const b=await y(a,w);if(b)return(0,r.$mc)(b,$[0])}else if($.length>1){const b=$.indexOf(f);if(b>=0){const d=await y(a,w);if(d)return(0,r.$mc)(d,$[b])}}}catch{}return null}async function o(h){try{return await R.Promises.realpath(h)}catch{const a=v(h);return await R.Promises.access(a,n.constants.R_OK),a}}function D(h){try{return n.realpathSync(h)}catch{const a=v(h);return n.accessSync(a,n.constants.R_OK),a}}function v(h){return(0,k.$pf)((0,r.$kc)(h),r.sep)}}),define(ve[113],Se([1,0,32,9,25]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=b,e.$xm=d,n=qe(n),r=qe(r),E=qe(E);const k=/^\d+$/,R=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(y||(y={}));let o;switch(process.arch){case"ia32":o=y.x86;break;case"arm":case"arm64":o=y.ARM;break;default:o=y.x64;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=y.x86:D=y.x64;class v{constructor(t,l,i){this.exePath=t,this.displayName=l,this.a=i}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:p=!1}={}){return p?o===y.x64?process.env["ProgramFiles(x86)"]||null:D===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:p=!1,findPreview:t=!1}={}){const l=h({useAlternateBitness:p});if(!l)return null;const i=r.$mc(l,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let g=-1,s=null;for(const S of await E.Promises.readdir(i)){let P=-1;if(t){const L=S.indexOf("-");if(L<0)continue;const T=S.substring(0,L);if(!k.test(T)||S.substring(L+1)!=="preview")continue;P=parseInt(T,10)}else{if(!k.test(S))continue;P=parseInt(S,10)}if(P<=g)continue;const C=r.$mc(i,S,"pwsh.exe");await E.SymlinkSupport.existsFile(C)&&(s=C,g=P)}if(!s)return null;const c=l.includes("x86")?" (x86)":"",u=t?" Preview":"";return new v(s,`PowerShell${u}${c}`,!0)}async function a({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:l,pwshMsixName:i}=p?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const g of await E.Promises.readdir(t))if(l.test(g)){const s=r.$mc(t,g,"pwsh.exe");return new v(s,i)}return null}function f(){const p=r.$mc(n.homedir(),".dotnet","tools","pwsh.exe");return new v(p,".NET Core PowerShell Global Tool")}function m(){const p=r.$mc(process.env.windir,o===y.x86&&D!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(p,"Windows PowerShell",!0)}async function*$(){let p=await w();p&&(yield p),p=await w({useAlternateBitness:!0}),p&&(yield p),p=await a(),p&&(yield p),p=f(),p&&(yield p),p=await w({findPreview:!0}),p&&(yield p),p=await a({findPreview:!0}),p&&(yield p),p=await w({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*b(){for await(const p of $())await p.exists()&&(yield p)}async function d(){for await(const p of b())return p;return null}}),define(ve[114],Se([1,0,9,3,33,69,11,25]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=y,e.$zm=o,n=qe(n),r=qe(r),E=qe(E),R=qe(R),A=qe(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function y(v=E.env){return v.comspec||"cmd.exe"}function o(v){let h=[],w=!1;const a=function(f){if(w){h.push(f);return}(!v.send(f,$=>{if($&&console.error($),w=!1,h.length>0){const b=h.slice(0);h=[],b.forEach(d=>a(d))}})||r.$i)&&(w=!0)};return{send:a}}var D;(function(v){async function h(w,a,f){if(n.$lc(w))return w;if(a===void 0&&(a=E.cwd()),n.$pc(w)!=="."||(f===void 0&&R.$gg(E.env.PATH)&&(f=E.env.PATH.split(n.$wc)),f===void 0||f.length===0))return n.$mc(a,w);async function $(b){if(await A.Promises.exists(b)){let d;try{d=await A.Promises.stat(b)}catch(p){p.message.startsWith("EACCES")&&(d=await A.Promises.lstat(b))}return d?!d.isDirectory():!1}return!1}for(const b of f){let d;if(n.$lc(b)?d=n.$mc(b,w):d=n.$mc(a,b,w),await $(d))return d;let p=d+".com";if(await $(p)||(p=d+".exe",await $(p)))return p}return n.$mc(a,w)}v.findExecutable=h})(D||(e.win32=D={}))}),define(ve[115],Se([1,0,60,13]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=E;function E(R){return new Promise((A,y)=>{let o;const D=new Map;function v(w,a,f,m,$){const b=D.get(a);if(w===R||b){const d={name:h(f),cmd:f,pid:w,ppid:a,load:m,mem:$};D.set(w,d),w===R&&(o=d),b&&(b.children||(b.children=[]),b.children.push(d),b.children.length>1&&(b.children=b.children.sort((p,t)=>p.pid-t.pid)))}}function h(w){const a=/--utility-sub-type=network/i,f=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(f.exec(w))return"electron-crash-reporter";if(m.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let d=b.exec(w);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(w)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const p=/[a-zA-Z-]+\.js/g;let t="";do d=p.exec(w),d&&(t+=d+" ");while(d);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,f)=>{se(["@vscode/windows-process-tree"],a,f)}).then(qe).then(a=>{a.getProcessList(R,f=>{if(!f){y(new Error(`Root process ${R} not found`));return}a.getProcessCpuUsage(f,m=>{const $=new Map;m.forEach(b=>{const d=w(b.commandLine||"");$.set(b.pid,{name:h(d),cmd:d,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),o=$.get(R),o?($.forEach(b=>{const d=$.get(b.ppid);d&&(d.children||(d.children=[]),d.children.push(b))}),$.forEach(b=>{b.children&&(b.children=b.children.sort((d,p)=>d.pid-p.pid))}),A(o)):y(new Error(`Root process ${R} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let w=function(){let a=[o];const f=[];for(;a.length;){const $=a.shift();$&&(f.push($.pid),$.children&&(a=a.concat($.children)))}let m=JSON.stringify(r.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+f.join(" "),(0,n.exec)(m,{},($,b,d)=>{if($||d)y($||new Error(d.toString()));else{const p=b.toString().split(`
`);for(let t=0;t<f.length;t++){const l=D.get(f[t]);l.load=parseFloat(p[t])}if(!o){y(new Error(`Root process ${R} not found`));return}A(o)}})};(0,n.exec)("which ps",{},(a,f,m)=>{if(a||m)if(process.platform!=="linux")y(a||new Error(m.toString()));else{const $=JSON.stringify(r.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(b,d,p)=>{b||p?y(b||new Error(p.toString())):(k(d,v),w())})}else{const $=f.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,p,t)=>{d||t&&!t.includes("screen size is bogus")?y(d||new Error(t.toString())):(k(p,v),process.platform==="linux"?w():o?A(o):y(new Error(`Root process ${R} not found`)))})}})}})}function k(R,A){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,o=R.toString().split(`
`);for(const D of o){const v=y.exec(D.trim());v&&v.length===6&&A(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ve[116],Se([1,0,32,3,113,114]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=R,r=qe(r),k=qe(k);async function R(v,h){return v===r.OperatingSystem.Windows?r.$i?D():k.$ym(h):y(v,h)}let A=null;function y(v,h){if(r.$k&&v===r.OperatingSystem.Macintosh||r.$j&&v===r.OperatingSystem.Linux)return"/bin/bash";if(!A){let w;if(r.$i)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}A=w}return A}let o=null;async function D(){return o||(o=(await(0,E.$xm)()).exePath),o}});var Be=this&&this.__decorate||function(se,e,n,r){var E=arguments.length,k=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(se,e,n,r);else for(var A=se.length-1;A>=0;A--)(R=se[A])&&(k=(E<3?R(k):E>3?R(e,n,k):R(e,n))||k);return E>3&&k&&Object.defineProperty(e,n,k),k};define(ve[51],Se([1,0,18,14,15,19,78,10,6,2,50,17,11]),function(se,e,n,r,E,k,R,A,y,o,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=u,e.$hi=S,e.$mi=q,e.$ni=Y,v=qe(v);var w;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(w||(w={}));function a(z){switch(z){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var f;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(f||(f={}));function m(z){switch(z){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var $;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})($||($={}));function b(z){let B=0;for(let ie=0;;ie+=7){const le=z.read(1);if(B|=(le.buffer[0]&127)<<ie,!(le.buffer[0]&128))return B}}const d=g(0);function p(z,B){if(B===0){z.write(d);return}let ie=0;for(let pe=B;pe!==0;pe=pe>>>7)ie++;const le=E.$Pe.alloc(ie);for(let pe=0;B!==0;pe++)le.buffer[pe]=B&127,B=B>>>7,B>0&&(le.buffer[pe]|=128);z.write(le)}class t{constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$ei=t;class l{constructor(){this.a=[]}get buffer(){return E.$Pe.concat(this.a)}write(B){this.a.push(B)}}e.$fi=l;var i;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(i||(i={}));function g(z){const B=E.$Pe.alloc(1);return B.writeUInt8(z,0),B}const s={Undefined:g(i.Undefined),String:g(i.String),Buffer:g(i.Buffer),VSBuffer:g(i.VSBuffer),Array:g(i.Array),Object:g(i.Object),Uint:g(i.Int)},c=typeof Buffer<"u";function u(z,B){if(typeof B>"u")z.write(s.Undefined);else if(typeof B=="string"){const ie=E.$Pe.fromString(B);z.write(s.String),p(z,ie.byteLength),z.write(ie)}else if(c&&Buffer.isBuffer(B)){const ie=E.$Pe.wrap(B);z.write(s.Buffer),p(z,ie.byteLength),z.write(ie)}else if(B instanceof E.$Pe)z.write(s.VSBuffer),p(z,B.byteLength),z.write(B);else if(Array.isArray(B)){z.write(s.Array),p(z,B.length);for(const ie of B)u(z,ie)}else if(typeof B=="number"&&(B|0)===B)z.write(s.Uint),p(z,B);else{const ie=E.$Pe.fromString(JSON.stringify(B));z.write(s.Object),p(z,ie.byteLength),z.write(ie)}}function S(z){switch(z.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return z.read(b(z)).toString();case i.Buffer:return z.read(b(z)).buffer;case i.VSBuffer:return z.read(b(z));case i.Array:{const ie=b(z),le=[];for(let pe=0;pe<ie;pe++)le.push(S(z));return le}case i.Object:return JSON.parse(z.read(b(z)).toString());case i.Int:return b(z)}}class P{constructor(B,ie,le=null,pe=1e3){this.h=B,this.j=ie,this.k=le,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(H=>this.q(H)),this.m({type:f.Initialize})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case f.Initialize:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,C.OtherSide,m(B.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,C.OtherSide,m(B.type),B.data);return}}}o(B,ie=void 0){const le=new l;return u(le,B),u(le,ie),this.p(le.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new t(B),le=S(ie),pe=S(ie),H=le[0];switch(H){case w.Promise:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(H)}: ${le[2]}.${le[3]}`,pe),this.s({type:H,id:le[1],channelName:le[2],name:le[3],arg:pe});case w.EventListen:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(H)}: ${le[2]}.${le[3]}`,pe),this.t({type:H,id:le[1],channelName:le[2],name:le[3],arg:pe});case w.PromiseCancel:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(H)}`),this.u({type:H,id:le[1]});case w.EventDispose:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(H)}`),this.u({type:H,id:le[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const le=new k.$ye;let pe;try{pe=ie.call(this.j,B.name,B.arg,le.token)}catch(x){pe=Promise.reject(x)}const H=B.id;pe.then(x=>{this.m({id:H,data:x,type:f.PromiseSuccess})},x=>{x instanceof Error?this.m({id:H,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split(`
`):void 0},type:f.PromiseError}):this.m({id:H,data:x,type:f.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(B.id)});const ce=(0,o.$Vc)(()=>le.cancel());this.d.set(B.id,ce)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const le=B.id,H=ie.listen(this.j,B.name,B.arg)(ce=>this.m({id:le,data:ce,type:f.EventFire}));this.d.set(B.id,H)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const le=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===w.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);ie.push({request:B,timeoutTimer:le})}w(B){const ie=this.g.get(B);if(ie){for(const le of ie)switch(clearTimeout(le.timeoutTimer),le.request.type){case w.Promise:this.s(le.request);break;case w.EventListen:this.t(le.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,o.$Sc)(this.d.values()),this.d.clear()}}e.$ii=P;var C;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class L{constructor(B,ie=null){this.l=B,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=ie}getChannel(B){const ie=this;return{call(le,pe,H){return ie.a?Promise.reject(new A.$8):ie.m(B,le,pe,H)},listen(le,pe){return ie.a?y.Event.None:ie.o(B,le,pe)}}}m(B,ie,le,pe=k.CancellationToken.None){const H=this.g++,ce=w.Promise,x={id:H,type:ce,channelName:B,name:ie,arg:le};if(pe.isCancellationRequested)return Promise.reject(new A.$8);let U;return new Promise((Z,V)=>{if(pe.isCancellationRequested)return V(new A.$8);const M=()=>{const W=oe=>{switch(oe.type){case f.PromiseSuccess:this.f.delete(H),Z(oe.data);break;case f.PromiseError:{this.f.delete(H);const he=new Error(oe.data.message);he.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,he.name=oe.data.name,V(he);break}case f.PromiseErrorObj:this.f.delete(H),V(oe.data);break}};this.f.set(H,W),this.p(x)};let G=null;this.b===$.Idle?M():(G=(0,r.$th)(W=>this.u()),G.then(()=>{G=null,M()}));const X=()=>{G?(G.cancel(),G=null):this.p({id:H,type:w.PromiseCancel}),V(new A.$8)},F=pe.onCancellationRequested(X);U=(0,o.$Uc)((0,o.$Vc)(X),F),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(B,ie,le){const pe=this.g++,H=w.EventListen,ce={id:pe,type:H,channelName:B,name:ie,arg:le};let x=null;const U=new y.$ne({onWillAddFirstListener:()=>{x=(0,r.$th)(Z=>this.u()),x.then(()=>{x=null,this.d.add(U),this.p(ce)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(U),this.p({id:pe,type:w.EventDispose}))}}),O=Z=>U.fire(Z.data);return this.f.set(pe,O),U.event}p(B){switch(B.type){case w.Promise:case w.EventListen:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,C.LocalSide,`${a(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case w.PromiseCancel:case w.EventDispose:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,C.LocalSide,a(B.type));return}}}q(B,ie=void 0){const le=new l;return u(le,B),u(le,ie),this.r(le.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new t(B),le=S(ie),pe=S(ie),H=le[0];switch(H){case f.Initialize:return this.j?.logIncoming(B.byteLength,0,C.LocalSide,m(H)),this.t({type:le[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,le[1],C.LocalSide,m(H),pe),this.t({type:le[0],id:le[1],data:pe})}}t(B){if(B.type===f.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,o.$Sc)(this.d.values()),this.d.clear()}}e.$ji=L,Be([R.$$h],L.prototype,"onDidInitializePromise",null);class T{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,le){this.a=new Map,this.f=new Set,this.g=new y.$ne,this.onDidAddConnection=this.g.event,this.h=new y.$ne,this.onDidRemoveConnection=this.h.event,this.j=new o.$Wc,this.j.add(B(({protocol:pe,onDidClientDisconnect:H})=>{const ce=y.Event.once(pe.onMessage);this.j.add(ce(x=>{const U=new t(x),O=S(U),Z=new P(pe,O,ie,le),V=new L(pe,ie);this.a.forEach((G,X)=>Z.registerChannel(X,G));const M={channelServer:Z,channelClient:V,ctx:O};this.f.add(M),this.g.fire(M),this.j.add(H(()=>{Z.dispose(),V.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(B,ie){const le=this;return{call(pe,H,ce){let x;if((0,h.$ug)(ie)){const O=(0,n.$6b)(le.connections.filter(ie));x=O?Promise.resolve(O):y.Event.toPromise(y.Event.filter(le.onDidAddConnection,ie))}else x=ie.routeCall(le,pe,H);const U=x.then(O=>O.channelClient.getChannel(B));return q(U).call(pe,H,ce)},listen(pe,H){if((0,h.$ug)(ie))return le.k(B,ie,pe,H);const ce=ie.routeEvent(le,pe,H).then(x=>x.channelClient.getChannel(B));return q(ce).listen(pe,H)}}}k(B,ie,le,pe){const H=this;let ce;const x=new y.$ne({onWillAddFirstListener:()=>{ce=new o.$Wc;const U=new y.$te,O=new Map,Z=M=>{const X=M.channelClient.getChannel(B).listen(le,pe),F=U.add(X);O.set(M,F)},V=M=>{const G=O.get(M);G&&(G.dispose(),O.delete(M))};H.connections.filter(ie).forEach(Z),y.Event.filter(H.onDidAddConnection,ie)(Z,void 0,ce),H.onDidRemoveConnection(V,void 0,ce),U.event(x.fire,x,ce),ce.add(U)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return x.event}registerChannel(B,ie){this.a.set(B,ie);for(const le of this.f)le.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=T;class I{constructor(B,ie,le=null){const pe=new l;u(pe,ie),B.send(pe.buffer),this.a=new L(B,le),this.d=new P(B,ie,le)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=I;function q(z){return{call(B,ie,le){return z.then(pe=>pe.call(B,ie,le))},listen(B,ie){const le=new y.$we;return z.then(pe=>le.input=pe.listen(B,ie)),le.event}}}function Y(z){let B=!1;return{call(ie,le,pe){return B?z.call(ie,le,pe):(0,r.$Hh)(0).then(()=>B=!0).then(()=>z.call(ie,le,pe))},listen(ie,le){if(B)return z.listen(ie,le);const pe=new y.$we;return(0,r.$Hh)(0).then(()=>B=!0).then(()=>pe.input=z.listen(ie,le)),pe.event}}}class Q{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await y.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$oi=Q;var re;(function(z){function B(H,ce,x){const U=H,O=x&&x.disableMarshalling,Z=new Map;for(const V in U)le(V)&&Z.set(V,y.Event.buffer(U[V],!0,void 0,ce));return new class{listen(V,M,G){const X=Z.get(M);if(X)return X;const F=U[M];if(typeof F=="function"){if(pe(M))return F.call(U,G);if(le(M))return Z.set(M,y.Event.buffer(U[M],!0,void 0,ce)),Z.get(M)}throw new A.$eb(`Event not found: ${M}`)}call(V,M,G){const X=U[M];if(typeof X=="function"){if(!O&&Array.isArray(G))for(let W=0;W<G.length;W++)G[W]=(0,D.$di)(G[W]);let F=X.apply(U,G);return F instanceof Promise||(F=Promise.resolve(F)),F}throw new A.$eb(`Method not found: ${M}`)}}}z.fromService=B;function ie(H,ce){const x=ce&&ce.disableMarshalling;return new Proxy({},{get(U,O){if(typeof O=="string")return ce?.properties?.has(O)?ce.properties.get(O):pe(O)?function(Z){return H.listen(O,Z)}:le(O)?H.listen(O):async function(...Z){let V;ce&&!(0,h.$pg)(ce.context)?V=[ce.context,...Z]:V=Z;const M=await H.call(O,V);return x?M:(0,D.$di)(M)};throw new A.$eb(`Property not found: ${String(O)}`)}})}z.toService=ie;function le(H){return H[0]==="o"&&H[1]==="n"&&v.$Gf(H.charCodeAt(2))}function pe(H){return/^onDynamic/.test(H)&&v.$Gf(H.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const B=z.toString();if(B!=="[object Object]")return B}return z}function de(z){return Array.isArray(z)?z.map(_):_(z)}function J(z,B,ie,le,pe,H,ce){ce=de(ce);const x=te[pe],U=x[le%x.length];let O=[`%c[${z}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(H)?(O=O.concat(ce),O.push(")")):O.push(ce),console.log.apply(console,O)}class ae{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,le,pe,H){this.b+=B,J(this.d,this.b,B,ie,le,pe,H)}logIncoming(B,ie,le,pe,H){this.a+=B,J(this.f,this.a,B,ie,le,pe,H)}}e.$pi=ae}),define(ve[61],Se([1,0,15,6,2,51]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var A;(function(s){s.enableDiagnostics=!1,s.records=[];const c=new WeakMap;let u=0;function S(C,L){if(!c.has(C)){const T=String(++u);c.set(C,T)}return c.get(C)}function P(C,L,T,I){if(!s.enableDiagnostics)return;const q=S(C,L);if(I instanceof n.$Pe||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const Y=n.$Pe.alloc(I.byteLength);Y.set(I),s.records.push({timestamp:Date.now(),id:q,label:L,type:T,buff:Y})}else s.records.push({timestamp:Date.now(),id:q,label:L,type:T,data:I})}s.traceSocketEvent=P})(A||(e.SocketDiagnostics=A={}));var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let o=null;function D(){return o||(o=n.$Pe.alloc(0)),o}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,u){if(c===0)return D();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const L=this.a[0];return u&&(this.a.shift(),this.b-=c),L}if(this.a[0].byteLength>c){const L=this.a[0].slice(0,c);return u&&(this.a[0]=this.a[0].slice(c),this.b-=c),L}const S=n.$Pe.alloc(c);let P=0,C=0;for(;c>0;){const L=this.a[C];if(L.byteLength>c){const T=L.slice(0,c);S.set(T,P),P+=c,u&&(this.a[C]=L.slice(c),this.b-=c),c-=c}else S.set(L,P),P+=L.byteLength,u?(this.a.shift(),this.b-=L.byteLength):C++,c-=L.byteLength}return S}}e.$qi=v;var h;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(h||(h={}));function w(s){switch(s){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var a;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class f{constructor(c,u,S,P){this.type=c,this.id=u,this.ack=S,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends E.$Xc{constructor(c){super(),this.f=this.B(new r.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:h.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new v,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(R.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,P=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(R.ProtocolMessageRead,u),this.f.fire(new f(S,P,C,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Pe.alloc(a.HeaderLength);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(R.ProtocolHeaderWrite,{messageType:w(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(R.ProtocolMessageWrite,c.data),this.j(u,c.data)}g(c,u){const S=this.f===0;return this.d.push(c,u),this.f+=c.byteLength+u.byteLength,S}h(){const c=n.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,u){this.g(c,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(R.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class b extends E.$Xc{constructor(c){super(),this.f=new r.$ne,this.onMessage=this.f.event,this.g=new r.$ne,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===h.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f(h.Regular,0,0,c))}}e.$ri=b;class d extends k.$li{static fromSocket(c,u){return new d(new b(c),u)}get onDidDispose(){return this.b.onDidDispose}constructor(c,u,S=null){super(c,u,S),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$si=d;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ti=p;class t{constructor(c){this.data=c,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let c=0,u=this.a;for(;u;)u=u.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let u=0,S=this.a;for(;S;)c[u++]=S.data,S=S.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const u=new t(c);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const c=Date.now();for(let u=0;u<i.a;u++)this.c[u]=c-1e3*u;setInterval(()=>{for(let u=i.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),u=(1+i.a)*1e3;let S=0;for(let P=0;P<i.a;P++)c-this.c[P]<=u&&S++;return 1-S/i.a}hasHighLoad(){return this.d()>=.5}}class g{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new p,this.onControlMessage=this.u.event,this.v=new p,this.onMessage=this.v.event,this.w=new p,this.onDidDispose=this.w.event,this.x=new p,this.onSocketClose=this.x.event,this.y=new p,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??i.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new E.$Wc,this.o=c.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},a.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new f(h.Disconnect,0,0,D());this.p.write(c),this.p.flush()}sendPause(){const c=new f(h.Pause,0,0,D());this.p.write(c)}sendResume(){const c=new f(h.Resume,0,0,D());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,u){this.a=!0,this.r.dispose(),this.r=new E.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new f(h.Ack,0,this.h,D());this.p.write(c);const u=this.b.toArray();for(let S=0,P=u.length;S<P;S++)this.p.write(u[S]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const u=this.b.peek();if(u&&u.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case h.None:break;case h.Regular:{if(c.id>this.g)if(c.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new f(h.ReplayRequest,0,0,D())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case h.Control:{this.u.fire(c.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const u=this.b.toArray();for(let S=0,P=u.length;S<P;S++)this.p.write(u[S]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const u=++this.c;this.h=this.g;const S=new f(h.Regular,u,this.h,c);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(c){const u=new f(h.Control,0,0,c);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=a.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},a.AcknowledgeTime-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),u=Date.now()-c.writtenTime,S=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(u>=a.TimeoutTime&&S>=a.TimeoutTime&&P>=a.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:S});return}const C=Math.max(a.TimeoutTime-u,a.TimeoutTime-S,a.TimeoutTime-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new f(h.Ack,0,this.h,D());this.p.write(c)}D(){this.h=this.g;const c=new f(h.KeepAlive,0,this.h,D());this.p.write(c)}}e.$ui=g}),define(ve[117],Se([1,0,60,14,15,19,192,10,6,2,21,114,69,51]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,A=qe(A);class a extends w.$ii{constructor($){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",b=>E.$Pe.wrap(Buffer.from(b,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$fr=a;class f{constructor($,b){this.i=$,this.j=b,this.c=new Set,this.g=new Map,this.h=new y.$ne,this.onDidProcessExit=this.h.event;const d=b&&b.timeout?b.timeout:6e4;this.b=new r.$Dh(d),this.d=null,this.f=null}getChannel($){const b=this;return{call(d,p,t){return b.k($,d,p,t)},listen(d,p){return b.l($,d,p)}}}k($,b,d,p=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(A.$9());this.b.cancel();const t=this.n($),l=(0,r.$th)(s=>t.call(b,d,s)),i=p.onCancellationRequested(()=>l.cancel()),g=(0,o.$Vc)(()=>l.cancel());return this.c.add(g),l.finally(()=>{i.dispose(),this.c.delete(g),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l($,b,d){if(!this.b)return y.Event.None;this.b.cancel();let p;const t=new y.$ne({onWillAddFirstListener:()=>{p=this.n($).listen(b,d)(t.fire,t),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,D.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,h.$mm)(b.env),this.d=(0,n.fork)(this.i,$,b);const d=new y.$ne,t=y.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,R.$br)(u)){(0,R.log)(u,`IPC Library: ${this.j.serverName}`);return}d.fire(E.$Pe.wrap(Buffer.from(u,"base64")))}),l=this.j.useQueue?(0,v.$zm)(this.d):this.d,i=u=>this.d&&this.d.connected&&l.send(u.buffer.toString("base64")),g=d.event,s={send:i,onMessage:g};this.f=new w.$ji(s);const c=()=>this.o();process.once("exit",c),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,S)=>{process.removeListener("exit",c),t.dispose(),this.c.forEach(P=>(0,o.$Sc)(P)),this.c.clear(),u!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:S})})}return this.f}n($){let b=this.g.get($);return b||(b=this.m.getChannel($),this.g.set($,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=f}),define(ve[197],Se([1,0,14,6,2,50,11]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=y;var A;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function y(h){const w=h;return w?.changed instanceof Map||w?.deleted instanceof Set}var o;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(o||(e.StorageState=o={}));class D extends E.$Xc{static{this.a=100}constructor(w,a=Object.create(null)){super(),this.r=w,this.s=a,this.b=this.B(new r.$qe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new n.$Eh(D.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((a,f)=>this.w(f,a)),w.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w(w,a){if(this.c===o.Closed)return;let f=!1;(0,R.$pg)(a)?f=this.f.delete(w):this.f.get(w)!==a&&(this.f.set(w,a),f=!0),f&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,a){const f=this.f.get(w);return(0,R.$pg)(f)?a:f}getBoolean(w,a){const f=this.get(w);return(0,R.$pg)(f)?a:f==="true"}getNumber(w,a){const f=this.get(w);return(0,R.$pg)(f)?a:parseInt(f,10)}getObject(w,a){const f=this.get(w);return(0,R.$pg)(f)?a:(0,k.$ci)(f)}async set(w,a,f=!1){if(this.c===o.Closed)return;if((0,R.$pg)(a))return this.delete(w,f);const m=(0,R.$ig)(a)||Array.isArray(a)?(0,k.$bi)(a):String(a);if(this.f.get(w)!==m)return this.f.set(w,m),this.j.set(w,m),this.h.delete(w),this.b.fire({key:w,external:f}),this.D()}async delete(w,a=!1){if(!(this.c===o.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:a}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===o.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$cq=D;class v{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((a,f)=>this.a.set(f,a)),w.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$dq=v}),define(ve[198],Se([7,8]),function(se,e){return se.create("vs/base/node/zip",e)}),define(ve[87],Se([1,0,31,14,9,11,25,198]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0,e.zip=m,e.$Bq=$,e.$Cq=d,E=qe(E),A=qe(A),e.$yq="end of central directory record signature not found";const y=new RegExp(e.$yq);class o extends Error{constructor(t,l){let i=l.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=l}}e.$zq=o;function D(p){const t=p.externalFileAttributes>>16||33188;return[448,56,7].map(l=>t&l).reduce((l,i)=>l+i,t&61440)}function v(p){if(p instanceof o)return p;let t;return y.test(p.message)&&(t="CorruptZip"),new o(t,p)}function h(p,t,l,i,g,s){const c=E.$pc(t),u=E.$mc(i,c);if(!u.startsWith(i))return Promise.reject(new Error(A.localize(0,null,t)));const S=E.$mc(i,t);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(R.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((C,L)=>{if(!s.isCancellationRequested)try{P=(0,n.createWriteStream)(S,{mode:l}),P.once("close",()=>C()),P.once("error",L),p.once("error",L),p.pipe(P)}catch(T){L(T)}}))}function w(p,t,l,i){let g=(0,r.$th)(()=>Promise.resolve()),s=0;const c=i.onCancellationRequested(()=>{g.cancel(),p.close()});return new Promise((u,S)=>{const P=new r.$Bh,C=L=>{L.isCancellationRequested||(s++,p.readEntry())};p.once("error",S),p.once("close",()=>g.then(()=>{i.isCancellationRequested||p.entryCount===s?u():S(new o("Incomplete",new Error(A.localize(1,null,s,p.entryCount))))},S)),p.readEntry(),p.on("entry",L=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(L.fileName)){C(i);return}const T=L.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(T)){const Y=E.$mc(t,T);g=(0,r.$th)(Q=>R.Promises.mkdir(Y,{recursive:!0}).then(()=>C(Q)).then(void 0,S));return}const I=f(p,L),q=D(L);g=(0,r.$th)(Y=>P.queue(()=>I.then(Q=>h(Q,T,q,t,l,Y).then(()=>C(Y)))).then(null,S))})}).finally(()=>c.dispose())}async function a(p,t=!1){const{open:l}=await new Promise((i,g)=>{se(["yauzl"],i,g)}).then(qe);return new Promise((i,g)=>{l(p,t?{lazyEntries:!0}:void 0,(s,c)=>{s?g(v(s)):i((0,k.$rg)(c))})})}function f(p,t){return new Promise((l,i)=>{p.openReadStream(t,(g,s)=>{g?i(v(g)):l((0,k.$rg)(s))})})}async function m(p,t){const{ZipFile:l}=await new Promise((i,g)=>{se(["yazl"],i,g)}).then(qe);return new Promise((i,g)=>{const s=new l;t.forEach(u=>{u.contents?s.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&s.addFile(u.localPath,u.path)}),s.end();const c=(0,n.createWriteStream)(p);s.outputStream.pipe(c),s.outputStream.once("error",g),c.once("error",g),c.once("finish",()=>i(p))})}function $(p,t,l={},i){const g=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let s=a(p,!0);return l.overwrite&&(s=s.then(c=>R.Promises.rm(t).then(()=>c))),s.then(c=>w(c,t,{sourcePathRegex:g},i))}function b(p,t){return a(p).then(l=>new Promise((i,g)=>{l.on("entry",s=>{s.fileName===t&&f(l,s).then(c=>i(c),c=>g(c))}),l.once("close",()=>g(new Error(A.localize(2,null,t))))}))}function d(p,t){return b(p,t).then(l=>new Promise((i,g)=>{const s=[];l.once("error",g),l.on("data",c=>s.push(c)),l.on("end",()=>i(Buffer.concat(s)))}))}}),define(ve[199],Se([7,8]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(ve[200],Se([7,8]),function(se,e){return se.create("vs/editor/common/languages",e)}),define(ve[201],Se([1,0,57,4,179,49,183,200]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ou=e.$Nu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Mu=e.$Lu=e.SymbolKinds=e.SymbolTag=e.$Ju=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Hu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Gu=e.$Fu=e.$Eu=void 0,e.$Iu=g,e.$Ku=c;class y{constructor(B,ie,le){this.offset=B,this.type=ie,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Eu=y;class o{constructor(B,ie){this.tokens=B,this.endState=ie,this._tokenizationResultBrand=void 0}}e.$Fu=o;class D{constructor(B,ie){this.tokens=B,this.endState=ie,this._encodedTokenizationResultBrand=void 0}}e.$Gu=D;var v;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(v||(e.HoverVerbosityAction=v={}));var h;(function(z){z[z.Method=0]="Method",z[z.Function=1]="Function",z[z.Constructor=2]="Constructor",z[z.Field=3]="Field",z[z.Variable=4]="Variable",z[z.Class=5]="Class",z[z.Struct=6]="Struct",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Event=10]="Event",z[z.Operator=11]="Operator",z[z.Unit=12]="Unit",z[z.Value=13]="Value",z[z.Constant=14]="Constant",z[z.Enum=15]="Enum",z[z.EnumMember=16]="EnumMember",z[z.Keyword=17]="Keyword",z[z.Text=18]="Text",z[z.Color=19]="Color",z[z.File=20]="File",z[z.Reference=21]="Reference",z[z.Customcolor=22]="Customcolor",z[z.Folder=23]="Folder",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue",z[z.Snippet=27]="Snippet"})(h||(e.CompletionItemKind=h={}));var w;(function(z){const B=new Map;B.set(h.Method,n.$6j.symbolMethod),B.set(h.Function,n.$6j.symbolFunction),B.set(h.Constructor,n.$6j.symbolConstructor),B.set(h.Field,n.$6j.symbolField),B.set(h.Variable,n.$6j.symbolVariable),B.set(h.Class,n.$6j.symbolClass),B.set(h.Struct,n.$6j.symbolStruct),B.set(h.Interface,n.$6j.symbolInterface),B.set(h.Module,n.$6j.symbolModule),B.set(h.Property,n.$6j.symbolProperty),B.set(h.Event,n.$6j.symbolEvent),B.set(h.Operator,n.$6j.symbolOperator),B.set(h.Unit,n.$6j.symbolUnit),B.set(h.Value,n.$6j.symbolValue),B.set(h.Enum,n.$6j.symbolEnum),B.set(h.Constant,n.$6j.symbolConstant),B.set(h.Enum,n.$6j.symbolEnum),B.set(h.EnumMember,n.$6j.symbolEnumMember),B.set(h.Keyword,n.$6j.symbolKeyword),B.set(h.Snippet,n.$6j.symbolSnippet),B.set(h.Text,n.$6j.symbolText),B.set(h.Color,n.$6j.symbolColor),B.set(h.File,n.$6j.symbolFile),B.set(h.Reference,n.$6j.symbolReference),B.set(h.Customcolor,n.$6j.symbolCustomColor),B.set(h.Folder,n.$6j.symbolFolder),B.set(h.TypeParameter,n.$6j.symbolTypeParameter),B.set(h.User,n.$6j.account),B.set(h.Issue,n.$6j.issues);function ie(H){let ce=B.get(H);return ce||(console.info("No codicon found for CompletionItemKind "+H),ce=n.$6j.symbolProperty),ce}z.toIcon=ie;const le=new Map;le.set("method",h.Method),le.set("function",h.Function),le.set("constructor",h.Constructor),le.set("field",h.Field),le.set("variable",h.Variable),le.set("class",h.Class),le.set("struct",h.Struct),le.set("interface",h.Interface),le.set("module",h.Module),le.set("property",h.Property),le.set("event",h.Event),le.set("operator",h.Operator),le.set("unit",h.Unit),le.set("value",h.Value),le.set("constant",h.Constant),le.set("enum",h.Enum),le.set("enum-member",h.EnumMember),le.set("enumMember",h.EnumMember),le.set("keyword",h.Keyword),le.set("snippet",h.Snippet),le.set("text",h.Text),le.set("color",h.Color),le.set("file",h.File),le.set("reference",h.Reference),le.set("customcolor",h.Customcolor),le.set("folder",h.Folder),le.set("type-parameter",h.TypeParameter),le.set("typeParameter",h.TypeParameter),le.set("account",h.User),le.set("issue",h.Issue);function pe(H,ce){let x=le.get(H);return typeof x>"u"&&!ce&&(x=h.Property),x}z.fromString=pe})(w||(e.CompletionItemKinds=w={}));var a;(function(z){z[z.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var f;(function(z){z[z.None=0]="None",z[z.KeepWhitespace=1]="KeepWhitespace",z[z.InsertAsSnippet=4]="InsertAsSnippet"})(f||(e.CompletionItemInsertTextRule=f={}));var m;(function(z){z[z.Word=0]="Word",z[z.Line=1]="Line",z[z.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var b;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(b||(e.InlineCompletionTriggerKind=b={}));class d{constructor(B,ie,le,pe){this.range=B,this.text=ie,this.completionKind=le,this.isSnippetText=pe}equals(B){return k.$Mt.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}e.$Hu=d;var p;(function(z){z[z.Invoke=1]="Invoke",z[z.Auto=2]="Auto"})(p||(e.CodeActionTriggerType=p={}));var t;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var l;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var i;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(i||(e.DocumentHighlightKind=i={}));function g(z){return z&&r.URI.isUri(z.uri)&&k.$Mt.isIRange(z.range)&&(k.$Mt.isIRange(z.originSelectionRange)||k.$Mt.isIRange(z.targetSelectionRange))}var s;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.$Ju={[s.Array]:(0,A.localize)(0,null),[s.Boolean]:(0,A.localize)(1,null),[s.Class]:(0,A.localize)(2,null),[s.Constant]:(0,A.localize)(3,null),[s.Constructor]:(0,A.localize)(4,null),[s.Enum]:(0,A.localize)(5,null),[s.EnumMember]:(0,A.localize)(6,null),[s.Event]:(0,A.localize)(7,null),[s.Field]:(0,A.localize)(8,null),[s.File]:(0,A.localize)(9,null),[s.Function]:(0,A.localize)(10,null),[s.Interface]:(0,A.localize)(11,null),[s.Key]:(0,A.localize)(12,null),[s.Method]:(0,A.localize)(13,null),[s.Module]:(0,A.localize)(14,null),[s.Namespace]:(0,A.localize)(15,null),[s.Null]:(0,A.localize)(16,null),[s.Number]:(0,A.localize)(17,null),[s.Object]:(0,A.localize)(18,null),[s.Operator]:(0,A.localize)(19,null),[s.Package]:(0,A.localize)(20,null),[s.Property]:(0,A.localize)(21,null),[s.String]:(0,A.localize)(22,null),[s.Struct]:(0,A.localize)(23,null),[s.TypeParameter]:(0,A.localize)(24,null),[s.Variable]:(0,A.localize)(25,null)};function c(z,B){return(0,A.localize)(26,null,z,e.$Ju[B])}var u;(function(z){z[z.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var S;(function(z){const B=new Map;B.set(s.File,n.$6j.symbolFile),B.set(s.Module,n.$6j.symbolModule),B.set(s.Namespace,n.$6j.symbolNamespace),B.set(s.Package,n.$6j.symbolPackage),B.set(s.Class,n.$6j.symbolClass),B.set(s.Method,n.$6j.symbolMethod),B.set(s.Property,n.$6j.symbolProperty),B.set(s.Field,n.$6j.symbolField),B.set(s.Constructor,n.$6j.symbolConstructor),B.set(s.Enum,n.$6j.symbolEnum),B.set(s.Interface,n.$6j.symbolInterface),B.set(s.Function,n.$6j.symbolFunction),B.set(s.Variable,n.$6j.symbolVariable),B.set(s.Constant,n.$6j.symbolConstant),B.set(s.String,n.$6j.symbolString),B.set(s.Number,n.$6j.symbolNumber),B.set(s.Boolean,n.$6j.symbolBoolean),B.set(s.Array,n.$6j.symbolArray),B.set(s.Object,n.$6j.symbolObject),B.set(s.Key,n.$6j.symbolKey),B.set(s.Null,n.$6j.symbolNull),B.set(s.EnumMember,n.$6j.symbolEnumMember),B.set(s.Struct,n.$6j.symbolStruct),B.set(s.Event,n.$6j.symbolEvent),B.set(s.Operator,n.$6j.symbolOperator),B.set(s.TypeParameter,n.$6j.symbolTypeParameter);function ie(le){let pe=B.get(le);return pe||(console.info("No codicon found for SymbolKind "+le),pe=n.$6j.symbolProperty),pe}z.toIcon=ie})(S||(e.SymbolKinds=S={}));class P{static asEditOperation(B){return E.$Nt.replace(k.$Mt.lift(B.range),B.text)}}e.$Lu=P;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(B){switch(B){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(B)}constructor(B){this.value=B}}e.$Mu=C;var L;(function(z){z[z.AIGenerated=1]="AIGenerated"})(L||(e.NewSymbolNameTag=L={}));var T;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(T||(e.NewSymbolNameTriggerKind=T={}));var I;(function(z){function B(ie){return!ie||typeof ie!="object"?!1:typeof ie.id=="string"&&typeof ie.title=="string"}z.is=B})(I||(e.Command=I={}));var q;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(q||(e.CommentThreadCollapsibleState=q={}));var Y;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Y||(e.CommentThreadState=Y={}));var Q;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Q||(e.CommentThreadApplicability=Q={}));var re;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(re||(e.CommentMode=re={}));var te;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(te||(e.CommentState=te={}));var _;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(_||(e.InlayHintKind=_={}));class de{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nu=de,e.$Ou=new R.$vu;var J;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(J||(e.ExternalUriOpenerPriority=J={}));var ae;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(ae||(e.InlineEditTriggerKind=ae={}))}),define(ve[202],Se([7,8]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[203],Se([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(ve[204],Se([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(ve[205],Se([7,8]),function(se,e){return se.create("vs/platform/environment/node/argv",e)}),define(ve[206],Se([7,8]),function(se,e){return se.create("vs/platform/environment/node/argvHelper",e)}),define(ve[207],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[208],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[209],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ve[210],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[211],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[212],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[213],Se([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[214],Se([7,8]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[215],Se([7,8]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(ve[216],Se([7,8]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(ve[217],Se([7,8]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(ve[218],Se([7,8]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[219],Se([7,8]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[220],Se([7,8]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(ve[221],Se([7,8]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(ve[222],Se([7,8]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(ve[223],Se([7,8]),function(se,e){return se.create("vs/platform/shell/node/shellEnv",e)}),define(ve[224],Se([7,8]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[225],Se([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[226],Se([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[227],Se([7,8]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[228],Se([7,8]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(ve[229],Se([7,8]),function(se,e){return se.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ve[230],Se([7,8]),function(se,e){return se.create("vs/server/node/serverEnvironmentService",e)}),define(ve[231],Se([7,8]),function(se,e){return se.create("vs/server/node/serverServices",e)}),define(ve[232],Se([7,8]),function(se,e){return se.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ve[233],Se([7,8]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(ve[234],Se([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ve[235],Se([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ve[236],Se([7,8]),function(se,e){return se.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[237],Se([7,8]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[238],Se([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ve[239],Se([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[240],Se([1,0,35,10,204]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var k;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(k||(e.TokenType=k={}));function R(...D){switch(D.length){case 1:return(0,E.localize)(0,null,D[0]);case 2:return(0,E.localize)(1,null,D[0],D[1]);case 3:return(0,E.localize)(2,null,D[0],D[1],D[2]);default:return}}const A=(0,E.localize)(3,null),y=(0,E.localize)(4,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return v.isTripleEq?"===":"==";case k.NotEq:return v.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return v.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return v.lexeme;case k.QuotedStr:return v.lexeme;case k.Error:return v.lexeme;case k.EOF:return"EOF";default:throw(0,r.$$)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(k.LParen);break;case n.CharCode.CloseParen:this.k(k.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const h=this.h(n.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:h})}else this.k(k.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const h=this.h(n.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:h})}else this.h(n.CharCode.Tilde)?this.k(k.RegexOp):this.l(R("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?k.LtEq:k.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?k.GtEq:k.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(k.And):this.l(R("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(k.Or):this.l(R("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const h=this.d,w=this.c.substring(this.d,this.e),a={type:k.Error,offset:this.d,lexeme:w};this.g.push({offset:h,lexeme:w,additionalInfo:v}),this.f.push(a)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const h=this.c.substring(this.d,this.e),w=o.b.get(h);w?this.k(w):this.f.push({type:k.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,h=!1,w=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(y);return}const f=this.c.charCodeAt(v);if(h)h=!1;else if(f===n.CharCode.Slash&&!w){v++;break}else f===n.CharCode.OpenSquareBracket?w=!0:f===n.CharCode.Backslash?h=!0:f===n.CharCode.CloseSquareBracket&&(w=!1);v++}for(;v<this.c.length&&o.a.has(this.c.charCodeAt(v));)v++;this.e=v;const a=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=o}),define(ve[241],Se([1,0,6,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;class E{constructor(){this.a=new n.$ne,this.b=new n.$ne,this.c=new n.$ne,this.d=new n.$ne}static{this.ChannelName="extensionhostdebugservice"}call(A,y,o){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:o[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:o[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:o[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:o[0],port:o[1],subId:o[2]}))}throw new Error("Method not implemented.")}listen(A,y,o){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Xo=E;class k extends r.$Xc{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,y,o){this.b.call("attach",[A,y,o])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,y){this.b.call("terminate",[A,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,y){return this.b.call("openExtensionDevelopmentHostWindow",[A,y])}}e.$Yo=k}),define(ve[242],Se([1,0,4]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=void 0;class r{constructor(R){this.a=R}listen(R,A,y){throw new Error("Invalid listen")}call(R,A,y){switch(A){case"download":return this.a.download(n.URI.revive(y[0]),n.URI.revive(y[1]))}throw new Error("Invalid call")}}e.$1o=r;class E{constructor(R,A){this.a=R,this.b=A}async download(R,A){const y=this.b();y&&(R=y.transformOutgoingURI(R),A=y.transformOutgoingURI(A)),await this.a.call("download",[R,A])}}e.$2o=E}),define(ve[243],Se([1,0,187,78,13,9,33,20,4]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=D,e.$8m=v,e.$5m=/^([^.]+\..+)[:=](.+)$/;class o{get appRoot(){return(0,k.$pc)(E.$1g.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,k.$mc)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,A.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$mc)(this.userDataPath,"logs",w)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$hh)(y.URI.file((0,k.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=R.env.VSCODE_PORTABLE;return w?y.URI.file((0,k.$mc)(w,"argv.json")):(0,A.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,k.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.$nc)(w):(0,k.$kc)((0,k.$mc)(E.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?y.URI.file((0,k.$nc)(w)):y.URI.file((0,k.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.$nc)(w);const a=R.env.VSCODE_EXTENSIONS;if(a)return a;const f=R.env.VSCODE_PORTABLE;return f?(0,k.$mc)(f,"extensions"):(0,A.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(a=>/^[^:/?#]+?:\/\//.test(a)?y.URI.parse(a):y.URI.file((0,k.$kc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?y.URI.parse(w):y.URI.file((0,k.$kc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$5m.test(w))}get extensionLogLevel(){const w=[];for(const a of this.args.log||[]){const f=e.$5m.exec(a);f&&f[1]&&f[2]&&w.push([f[1],f[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,A.$hh)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=R.env.VSCODE_PORTABLE;return w?y.URI.file((0,k.$mc)(w,"policy.json")):(0,A.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,a,f){this.a=w,this.b=a,this.c=f,this.editSessionId=this.args.editSessionId}}e.$6m=o,Be([r.$$h],o.prototype,"appRoot",null),Be([r.$$h],o.prototype,"userHome",null),Be([r.$$h],o.prototype,"userDataPath",null),Be([r.$$h],o.prototype,"appSettingsHome",null),Be([r.$$h],o.prototype,"tmpDir",null),Be([r.$$h],o.prototype,"cacheHome",null),Be([r.$$h],o.prototype,"stateResource",null),Be([r.$$h],o.prototype,"userRoamingDataHome",null),Be([r.$$h],o.prototype,"userDataSyncHome",null),Be([r.$$h],o.prototype,"sync",null),Be([r.$$h],o.prototype,"machineSettingsResource",null),Be([r.$$h],o.prototype,"workspaceStorageHome",null),Be([r.$$h],o.prototype,"localHistoryHome",null),Be([r.$$h],o.prototype,"keyboardLayoutResource",null),Be([r.$$h],o.prototype,"argvResource",null),Be([r.$$h],o.prototype,"isExtensionDevelopment",null),Be([r.$$h],o.prototype,"untitledWorkspacesHome",null),Be([r.$$h],o.prototype,"builtinExtensionsPath",null),Be([r.$$h],o.prototype,"extensionsPath",null),Be([r.$$h],o.prototype,"extensionDevelopmentLocationURI",null),Be([r.$$h],o.prototype,"extensionDevelopmentKind",null),Be([r.$$h],o.prototype,"extensionTestsLocationURI",null),Be([r.$$h],o.prototype,"debugExtensionHost",null),Be([r.$$h],o.prototype,"logLevel",null),Be([r.$$h],o.prototype,"extensionLogLevel",null),Be([r.$$h],o.prototype,"serviceMachineIdResource",null),Be([r.$$h],o.prototype,"disableTelemetry",null),Be([r.$$h],o.prototype,"disableWorkspaceTrust",null),Be([r.$$h],o.prototype,"useInMemorySecretStorage",null),Be([r.$$h],o.prototype,"policyFile",null);function D(h,w){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}function v(h,w,a,f,m,$){const d=Number(w||h)||(f?null:a),p=d?!!w:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:d,break:p,debugId:m,env:t}}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[70],Se([1,0,334,3,205]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=A,e.$Em=o,e.$Fm=w,e.$Gm=a,n=mt(n);const k={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(f,m,$=R){const b=f.find(u=>u.length>0&&u[0]!=="-"),d={},p=["_"],t=[],l={};let i;for(const u in m){const S=m[u];S.type==="subcommand"?u===b&&(i=S):(S.alias&&(d[u]=S.alias),S.type==="string"||S.type==="string[]"?(p.push(u),S.deprecates&&p.push(...S.deprecates)):S.type==="boolean"&&(t.push(u),S.deprecates&&t.push(...S.deprecates)),S.global&&(l[u]=S))}if(i&&b){const u=l;for(const L in i.options)u[L]=i.options[L];const S=f.filter(L=>L!==b),P=$.getSubcommandReporter?$.getSubcommandReporter(b):void 0,C=A(S,u,P);return{[b]:C,_:[]}}const g=(0,n.default)(f,{string:p,boolean:t,alias:d}),s={},c=g;s._=g._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in m){const S=m[u];if(S.type==="subcommand")continue;S.alias&&delete c[S.alias];let P=c[u];if(S.deprecates)for(const C of S.deprecates)c.hasOwnProperty(C)&&(P||(P=c[C],P&&$.onDeprecatedOption(C,S.deprecationMessage||(0,E.localize)(39,null,u))),delete c[C]);if(typeof P<"u"){if(S.type==="string[]"){if(Array.isArray(P)||(P=[P]),!S.allowEmptyValue){const C=P.filter(L=>L.length>0);C.length!==P.length&&($.onEmptyValue(u),P=C.length>0?C:void 0)}}else S.type==="string"&&(Array.isArray(P)?(P=P.pop(),$.onMultipleValues(u,P)):!P&&!S.allowEmptyValue&&($.onEmptyValue(u),P=void 0));s[u]=P,S.deprecationMessage&&$.onDeprecatedOption(u,S.deprecationMessage)}delete c[u]}for(const u in c)$.onUnknownOption(u);return s}function y(f,m){let $="";return m.args&&(Array.isArray(m.args)?$=` <${m.args.join("> <")}>`:$=` <${m.args}>`),m.alias?`-${m.alias} --${f}${$}`:`--${f}${$}`}function o(f,m){const $=[];for(const b in f){const d=f[b],p=y(b,d);$.push([p,d.description])}return D($,m)}function D(f,m){const b=f.reduce((t,l)=>Math.max(t,l[0].length),12)+2+1;if(m-b<25)return f.reduce((t,l)=>t.concat([`  ${l[0]}`,`      ${l[1]}`]),[]);const d=m-b-1,p=[];for(const t of f){const l=t[0],i=h(t[1],d),g=v(b-l.length-2);p.push("  "+l+g+i[0]);for(let s=1;s<i.length;s++)p.push(v(b)+i[s])}return p}function v(f){return" ".repeat(f)}function h(f,m){const $=[];for(;f.length;){const b=f.length<m?f.length:f.lastIndexOf(" ",m),d=f.slice(0,b).trim();f=f.slice(b),$.push(d)}return $}function w(f,m,$,b,d){const p=process.stdout.isTTY&&process.stdout.columns||80,t=d?.noInputFiles!==!0?`[${(0,E.localize)(40,null)}...]`:"",l=[`${f} ${$}`];l.push(""),l.push(`${(0,E.localize)(41,null)}: ${m} [${(0,E.localize)(42,null)}]${t}`),l.push(""),d?.noPipe!==!0&&(r.$i?l.push((0,E.localize)(43,null,m)):l.push((0,E.localize)(44,null,m)),l.push(""));const i={},g=[];for(const s in b){const c=b[s];if(c.type==="subcommand")c.description&&g.push({command:s,description:c.description});else if(c.description&&c.cat){let u=i[c.cat];u||(i[c.cat]=u={}),u[s]=c}}for(const s in i){const c=s,u=i[c];u&&(l.push(k[c]),l.push(...o(u,p)),l.push(""))}return g.length&&(l.push((0,E.localize)(45,null)),l.push(...D(g.map(s=>[s.command,s.description]),p)),l.push("")),l.join(`
`)}function a(f,m){return`${f||(0,E.localize)(46,null)}
${m||(0,E.localize)(47,null)}
${process.arch}`}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[244],Se([1,0,335,206,70]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=A,e.$Im=y,e.$Jm=o,e.$Km=D,n=mt(n);function k(v,h){const w=(d,p)=>{console.warn((0,r.localize)(0,null,d,p))},a=d=>{console.warn((0,r.localize)(1,null,d))},f=(d,p)=>{console.warn((0,r.localize)(2,null,d,p))},m=d=>({onUnknownOption:p=>{E.$Bm.includes(d)||console.warn((0,r.localize)(3,null,p,d))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:E.$Bm.includes(d)?m:void 0}),$={onUnknownOption:d=>{console.warn((0,r.localize)(4,null,d))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:m},b=(0,E.$Dm)(v,E.$Cm,h?$:void 0);return b.goto&&b._.forEach(d=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,r.localize)(5,null))),b}function R(v){const h=v.findIndex(w=>!/^-/.test(w));if(h>-1)return[...v.slice(0,h),...v.slice(h+1)]}function A(v){let[,...h]=v;process.env.VSCODE_DEV&&(h=R(h)||[]);const w=!D(process.env);return k(h,w)}function y(v){let[,,...h]=v;return process.env.VSCODE_DEV&&(h=R(h)||[]),k(h,!0)}function o(v,...h){const w=v.indexOf("--");return w===-1?v.push(...h):v.splice(w,0,...h),v}function D(v){return v.VSCODE_CLI==="1"}}),function(){"use strict";function se(e,n,r){function E(R,A){const y=k(R,A),o=[y];return e.isAbsolute(y)||o.unshift(r),e.resolve(...o)}function k(R,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let o=process.env.VSCODE_APPDATA;if(o)return e.join(o,A);const D=R["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(o=process.env.APPDATA,!o){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");o=e.join(v,"AppData","Roaming")}break;case"darwin":o=e.join(n.homedir(),"Library","Application Support");break;case"linux":o=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(o,A)}return{getUserDataPath:E}}if(typeof define=="function")define(ve[245],Se([83,32,33]),function(e,n,r){return se(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=se(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[118],Se([1,0,32,243,245]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=R,e.$$m=A;class k extends r.$6m{constructor(o,D){super(o,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,E.getUserDataPath)(o,D.nameShort)},D)}}e.$9m=k;function R(y,o){return(0,r.$8m)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,o,y.extensionEnvironment)}function A(y,o){return(0,r.$8m)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,o,y.extensionEnvironment)}}),define(ve[246],Se([1,0,11,210]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=E;function E(R,A,y,o){try{k(R,A,y,o)}catch(D){R.error(D?.message??D)}return A}function k(R,A,y,o){const D=(v,h,w)=>{const a=v[h];if((0,n.$gg)(a)){const f=a,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const $=f.substr(1,m-2);let b=y[$];b===void 0&&o&&(b=o[$]);const d=typeof b=="string"?b:b?.message,p=o?.[$],t=typeof p=="string"?p:p?.message;if(!d){t||R.warn(`[${A.name}]: ${(0,r.localize)(0,null,$)}`);return}if(w&&(h==="title"||h==="category")&&t&&t!==d){const l={value:d,original:t};v[h]=l}else v[h]=d}}else if((0,n.$ig)(a))for(const f in a)a.hasOwnProperty(f)&&(f==="commands"?D(a,f,!0):D(a,f,w));else if(Array.isArray(a))for(let f=0;f<a.length;f++)D(a,f,w)};for(const v in A)A.hasOwnProperty(v)&&D(A,v)}}),define(ve[119],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ve[71],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(E,k=[],R=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.$Di=n}),define(ve[120],Se([1,0,71]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=k,e.$Qs=R;const r=[];var E;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function k(A,y,o){y instanceof n.$Di||(y=new n.$Di(y,[],!!o)),r.push([A,y])}function R(){return r}}),define(ve[247],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class n{constructor(k,R){this.key=k,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$sr=n;class r{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const R of this.a.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const A=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(R);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(k){const R=this.b(k);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(k){const R=this.b(k);let A=this.a.get(R);return A||(A=new n(R,k),this.a.set(R,A)),A}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[R,A]of this.a)k.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,R]of this.a){const A=new Set([k]),y=this.c(R,A);if(y)return y}}c(k,R){for(const[A,y]of k.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const o=this.c(y,R);if(o)return o;R.delete(A)}}}e.$tr=r}),define(ve[5],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=E,e.$Hi=k;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n||(e._util=n={})),e.$Fi=E("instantiationService");function r(R,A,y){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:y}):(A[n.DI_DEPENDENCIES]=[{id:R,index:y}],A[n.DI_TARGET]=A)}function E(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(y,o,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(A,y,D)};return A.toString=()=>R,n.serviceIds.set(R,A),A}function k(R){return R}}),define(ve[27],Se([1,0,11,4,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=k,e.$cj=R,e.$dj=y,e.$ej=o,e.$fj=D,e.$gj=v,e.$hj=h,e.$ij=a,e.$jj=f,e.$kj=m,n=qe(n),e.$aj=(0,E.$Gi)("configurationService");function k($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof r.URI)}function R($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof r.URI)}var A;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function y($){switch($){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function o($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function D($,b){const d=Object.create(null);for(const p in $)v(d,p,$[p],b);return d}function v($,b,d,p){const t=b.split("."),l=t.pop();let i=$;for(let g=0;g<t.length;g++){const s=t[g];let c=i[s];switch(typeof c){case"undefined":c=i[s]=Object.create(null);break;case"object":if(c===null){p(`Ignoring ${b} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:p(`Ignoring ${b} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[l]=d}catch{p(`Ignoring ${b} as ${t.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${b} as ${t.join(".")} is ${JSON.stringify(i)}`)}function h($,b){const d=b.split(".");w($,d)}function w($,b){const d=b.shift();if(b.length===0){delete $[d];return}if(Object.keys($).indexOf(d)!==-1){const p=$[d];typeof p=="object"&&!Array.isArray(p)&&(w(p,b),Object.keys(p).length===0&&delete $[d])}}function a($,b,d){function p(i,g){let s=i;for(const c of g){if(typeof s!="object"||s===null)return;s=s[c]}return s}const t=b.split("."),l=p($,t);return typeof l>"u"?d:l}function f($,b,d){Object.keys(b).forEach(p=>{p!=="__proto__"&&(p in $?n.$ig($[p])&&n.$ig(b[p])?f($[p],b[p],d):d&&($[p]=b[p]):$[p]=b[p])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(ve[42],Se([1,0,35,3,17,240,5,203,10]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=D,e.$Fj=g,e.$Gj=s,e.$Zj=H;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",r.$j),o.set("isLinux",r.$k),o.set("isWindows",r.$i),o.set("isWeb",r.$o),o.set("isMacNative",r.$j&&!r.$o),o.set("isEdge",r.$H),o.set("isFirefox",r.$F),o.set("isChrome",r.$E),o.set("isSafari",r.$G);function D(U,O){if(o.get(U)!==void 0)throw(0,y.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(U,O)}const v=Object.prototype.hasOwnProperty;var h;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const w={regexParsingWithErrorRecovery:!0},a=(0,A.localize)(0,null),f=(0,A.localize)(1,null),m=(0,A.localize)(2,null),$=(0,A.localize)(3,null),b=(0,A.localize)(4,null),d=(0,A.localize)(5,null),p=(0,A.localize)(6,null),t=(0,A.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=w){this.k=O,this.d=new k.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const V=this.D(),M=V.type===k.TokenType.Str?d:void 0;throw this.h.push({message:b,offset:V.offset,lexeme:k.$Bj.getLexeme(V),additionalInfo:M}),l.c}return Z}catch(Z){if(Z!==l.c)throw Z;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(k.TokenType.Or);){const Z=this.o();O.push(Z)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(k.TokenType.And);){const Z=this.s();O.push(Z)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(k.TokenType.Neg)){const O=this.D();switch(O.type){case k.TokenType.True:return this.z(),u.INSTANCE;case k.TokenType.False:return this.z(),S.INSTANCE;case k.TokenType.LParen:{this.z();const Z=this.l();return this.A(k.TokenType.RParen,$),Z?.negate()}case k.TokenType.Str:return this.z(),q.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case k.TokenType.True:return this.z(),i.true();case k.TokenType.False:return this.z(),i.false();case k.TokenType.LParen:{this.z();const Z=this.l();return this.A(k.TokenType.RParen,$),Z}case k.TokenType.Str:{const Z=O.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==k.TokenType.RegexStr)throw this.B("REGEX",M);const G=M.lexeme,X=G.lastIndexOf("/"),F=X===G.length-1?void 0:this.w(G.substring(X+1));let W;try{W=new RegExp(G.substring(1,X),F)}catch{throw this.B("REGEX",M)}return de.create(Z,W)}switch(M.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const G=[M.lexeme];this.z();let X=this.D(),F=0;for(let Ne=0;Ne<M.lexeme.length;Ne++)M.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?F++:M.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&F--;for(;!this.E()&&X.type!==k.TokenType.And&&X.type!==k.TokenType.Or;){switch(X.type){case k.TokenType.LParen:F++;break;case k.TokenType.RParen:F--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Ne=0;Ne<X.lexeme.length;Ne++)X.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?F++:M.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&F--}if(F<0)break;G.push(k.$Bj.getLexeme(X)),this.z(),X=this.D()}const W=G.join(""),oe=W.lastIndexOf("/"),he=oe===W.length-1?void 0:this.w(W.substring(oe+1));let ke;try{ke=new RegExp(W.substring(1,oe),he)}catch{throw this.B("REGEX",M)}return i.regex(Z,ke)}case k.TokenType.QuotedStr:{const G=M.lexeme;this.z();let X=null;if(!(0,E.$ef)(G)){const F=G.indexOf("/"),W=G.lastIndexOf("/");if(F!==W&&F>=0){const oe=G.slice(F+1,W),he=G[W+1]==="i"?"i":"";try{X=new RegExp(oe,he)}catch{throw this.B("REGEX",M)}}}if(X===null)throw this.B("REGEX",M);return de.create(Z,X)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,m);const M=this.u();return i.notIn(Z,M)}switch(this.D().type){case k.TokenType.Eq:{this.z();const M=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.equals(Z,M);switch(M){case"true":return i.has(Z);case"false":return i.not(Z);default:return i.equals(Z,M)}}case k.TokenType.NotEq:{this.z();const M=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.notEquals(Z,M);switch(M){case"true":return i.not(Z);case"false":return i.has(Z);default:return i.notEquals(Z,M)}}case k.TokenType.Lt:return this.z(),te.create(Z,this.u());case k.TokenType.LtEq:return this.z(),_.create(Z,this.u());case k.TokenType.Gt:return this.z(),Q.create(Z,this.u());case k.TokenType.GtEq:return this.z(),re.create(Z,this.u());case k.TokenType.In:return this.z(),i.in(Z,this.u());default:return i.has(Z)}}case k.TokenType.EOF:throw this.h.push({message:p,offset:O.offset,lexeme:"",additionalInfo:t}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),O.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,Z){if(this.C(O))return this.z();throw this.B(Z,this.D())}B(O,Z,V){const M=(0,A.localize)(8,null,O,k.$Bj.getLexeme(Z)),G=Z.offset,X=k.$Bj.getLexeme(Z);return this.h.push({message:M,offset:G,lexeme:X,additionalInfo:V}),l.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Dj=l;class i{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(O){return P.create(O)}static equals(O,Z){return C.create(O,Z)}static notEquals(O,Z){return I.create(O,Z)}static regex(O,Z){return de.create(O,Z)}static in(O,Z){return L.create(O,Z)}static notIn(O,Z){return T.create(O,Z)}static not(O){return q.create(O)}static and(...O){return z.create(O,null,!0)}static or(...O){return B.create(O,null,!0)}static greater(O,Z){return Q.create(O,Z)}static greaterEquals(O,Z){return re.create(O,Z)}static smaller(O,Z){return te.create(O,Z)}static smallerEquals(O,Z){return _.create(O,Z)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ej=i;function g(U){const O=new l({regexParsingWithErrorRecovery:!1});return U.map(Z=>(O.parse(Z),O.lexingErrors.length>0?O.lexingErrors.map(V=>({errorMessage:V.additionalInfo?(0,A.localize)(9,null,V.additionalInfo):(0,A.localize)(10,null),offset:V.offset,length:V.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(V=>({errorMessage:V.additionalInfo?`${V.message}. ${V.additionalInfo}`:V.message,offset:V.offset,length:V.lexeme.length})):[]))}function s(U,O){const Z=U?U.substituteConstants():void 0,V=O?O.substituteConstants():void 0;return!Z&&!V?!0:!Z||!V?!1:Z.equals(V)}function c(U,O){return U.cmp(O)}class u{static{this.INSTANCE=new u}constructor(){this.type=h.False}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return S.INSTANCE}}e.$Hj=u;class S{static{this.INSTANCE=new S}constructor(){this.type=h.True}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return u.INSTANCE}}e.$Ij=S;class P{static create(O,Z=null){const V=o.get(O);return typeof V=="boolean"?V?S.INSTANCE:u.INSTANCE:new P(O,Z)}constructor(O,Z){this.key=O,this.c=Z,this.type=h.Defined}cmp(O){return O.type!==this.type?this.type-O.type:le(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=o.get(this.key);return typeof O=="boolean"?O?S.INSTANCE:u.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Jj=P;class C{static create(O,Z,V=null){if(typeof Z=="boolean")return Z?P.create(O,V):q.create(O,V);const M=o.get(O);return typeof M=="boolean"?Z===(M?"true":"false")?S.INSTANCE:u.INSTANCE:new C(O,Z,V)}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.Equals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=o.get(this.c);if(typeof O=="boolean"){const Z=O?"true":"false";return this.d===Z?S.INSTANCE:u.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Kj=C;class L{static create(O,Z){return new L(O,Z)}constructor(O,Z){this.d=O,this.f=Z,this.type=h.In,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const Z=O.getValue(this.f),V=O.getValue(this.d);return Array.isArray(Z)?Z.includes(V):typeof V=="string"&&typeof Z=="object"&&Z!==null?v.call(Z,V):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Lj=L;class T{static create(O,Z){return new T(O,Z)}constructor(O,Z){this.d=O,this.f=Z,this.type=h.NotIn,this.c=L.create(O,Z)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=T;class I{static create(O,Z,V=null){if(typeof Z=="boolean")return Z?q.create(O,V):P.create(O,V);const M=o.get(O);return typeof M=="boolean"?Z===(M?"true":"false")?u.INSTANCE:S.INSTANCE:new I(O,Z,V)}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.NotEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=o.get(this.c);if(typeof O=="boolean"){const Z=O?"true":"false";return this.d===Z?u.INSTANCE:S.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Nj=I;class q{static create(O,Z=null){const V=o.get(O);return typeof V=="boolean"?V?u.INSTANCE:S.INSTANCE:new q(O,Z)}constructor(O,Z){this.c=O,this.d=Z,this.type=h.Not}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=o.get(this.c);return typeof O=="boolean"?O?u.INSTANCE:S.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=P.create(this.c,this)),this.d}}e.$Oj=q;function Y(U,O){if(typeof U=="string"){const Z=parseFloat(U);isNaN(Z)||(U=Z)}return typeof U=="string"||typeof U=="number"?O(U):u.INSTANCE}class Q{static create(O,Z,V=null){return Y(Z,M=>new Q(O,M,V))}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.Greater}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Pj=Q;class re{static create(O,Z,V=null){return Y(Z,M=>new re(O,M,V))}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.GreaterEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Qj=re;class te{static create(O,Z,V=null){return Y(Z,M=>new te(O,M,V))}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.Smaller}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Rj=te;class _{static create(O,Z,V=null){return Y(Z,M=>new _(O,M,V))}constructor(O,Z,V){this.c=O,this.d=Z,this.f=V,this.type=h.SmallerEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Sj=_;class de{static create(O,Z){return new de(O,Z)}constructor(O,Z){this.d=O,this.f=Z,this.type=h.Regex,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const Z=this.f?this.f.source:"",V=O.f?O.f.source:"";return Z<V?-1:Z>V?1:0}equals(O){if(O.type===this.type){const Z=this.f?this.f.source:"",V=O.f?O.f.source:"";return this.d===O.d&&Z===V}return!1}substituteConstants(){return this}evaluate(O){const Z=O.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Tj=de;class J{static create(O){return new J(O)}constructor(O){this.c=O,this.type=h.NotRegex}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new J(this.c.map(O))}negate(){return this.c}}e.$Uj=J;function ae(U){let O=null;for(let Z=0,V=U.length;Z<V;Z++){const M=U[Z].substituteConstants();if(U[Z]!==M&&O===null){O=[];for(let G=0;G<Z;G++)O[G]=U[G]}O!==null&&(O[Z]=M)}return O===null?U:O}class z{static create(O,Z,V){return z.d(O,Z,V)}constructor(O,Z){this.expr=O,this.c=Z,this.type=h.And}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let Z=0,V=this.expr.length;Z<V;Z++){const M=c(this.expr[Z],O.expr[Z]);if(M!==0)return M}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let Z=0,V=this.expr.length;Z<V;Z++)if(!this.expr[Z].equals(O.expr[Z]))return!1;return!0}return!1}substituteConstants(){const O=ae(this.expr);return O===this.expr?this:z.create(O,this.c,!1)}evaluate(O){for(let Z=0,V=this.expr.length;Z<V;Z++)if(!this.expr[Z].evaluate(O))return!1;return!0}static d(O,Z,V){const M=[];let G=!1;for(const X of O)if(X){if(X.type===h.True){G=!0;continue}if(X.type===h.False)return u.INSTANCE;if(X.type===h.And){M.push(...X.expr);continue}M.push(X)}if(M.length===0&&G)return S.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(c);for(let X=1;X<M.length;X++)M[X-1].equals(M[X])&&(M.splice(X,1),X--);if(M.length===1)return M[0];for(;M.length>1;){const X=M[M.length-1];if(X.type!==h.Or)break;M.pop();const F=M.pop(),W=M.length===0,oe=B.create(X.expr.map(he=>z.create([he,F],null,V)),null,W);oe&&(M.push(oe),M.sort(c))}if(M.length===1)return M[0];if(V){for(let X=0;X<M.length;X++)for(let F=X+1;F<M.length;F++)if(M[X].negate().equals(M[F]))return u.INSTANCE;if(M.length===1)return M[0]}return new z(M,Z)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const Z of this.expr)O.push(...Z.keys());return O}map(O){return new z(this.expr.map(Z=>Z.map(O)),null)}negate(){if(!this.c){const O=[];for(const Z of this.expr)O.push(Z.negate());this.c=B.create(O,this,!0)}return this.c}}e.$Vj=z;class B{static create(O,Z,V){return B.d(O,Z,V)}constructor(O,Z){this.expr=O,this.c=Z,this.type=h.Or}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let Z=0,V=this.expr.length;Z<V;Z++){const M=c(this.expr[Z],O.expr[Z]);if(M!==0)return M}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let Z=0,V=this.expr.length;Z<V;Z++)if(!this.expr[Z].equals(O.expr[Z]))return!1;return!0}return!1}substituteConstants(){const O=ae(this.expr);return O===this.expr?this:B.create(O,this.c,!1)}evaluate(O){for(let Z=0,V=this.expr.length;Z<V;Z++)if(this.expr[Z].evaluate(O))return!0;return!1}static d(O,Z,V){let M=[],G=!1;if(O){for(let X=0,F=O.length;X<F;X++){const W=O[X];if(W){if(W.type===h.False){G=!0;continue}if(W.type===h.True)return S.INSTANCE;if(W.type===h.Or){M=M.concat(W.expr);continue}M.push(W)}}if(M.length===0&&G)return u.INSTANCE;M.sort(c)}if(M.length!==0){if(M.length===1)return M[0];for(let X=1;X<M.length;X++)M[X-1].equals(M[X])&&(M.splice(X,1),X--);if(M.length===1)return M[0];if(V){for(let X=0;X<M.length;X++)for(let F=X+1;F<M.length;F++)if(M[X].negate().equals(M[F]))return S.INSTANCE;if(M.length===1)return M[0]}return new B(M,Z)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const Z of this.expr)O.push(...Z.keys());return O}map(O){return new B(this.expr.map(Z=>Z.map(O)),null)}negate(){if(!this.c){const O=[];for(const Z of this.expr)O.push(Z.negate());for(;O.length>1;){const Z=O.shift(),V=O.shift(),M=[];for(const G of x(Z))for(const X of x(V))M.push(z.create([G,X],null,!1));O.unshift(B.create(M,null,!1))}this.c=B.create(O,this,!0)}return this.c}}e.$Wj=B;class ie extends P{static{this.d=[]}static all(){return ie.d.values()}constructor(O,Z,V){super(O,null),this.f=Z,typeof V=="object"?ie.d.push({...V,key:O}):V!==!0&&ie.d.push({key:O,description:V,type:Z!=null?typeof Z:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$Xj=ie,e.$Yj=(0,R.$Gi)("contextKeyService");function le(U,O){return U<O?-1:U>O?1:0}function pe(U,O,Z,V){return U<Z?-1:U>Z?1:O<V?-1:O>V?1:0}function H(U,O){if(U.type===h.False||O.type===h.True)return!0;if(U.type===h.Or)return O.type===h.Or?ce(U.expr,O.expr):!1;if(O.type===h.Or){for(const Z of O.expr)if(H(U,Z))return!0;return!1}if(U.type===h.And){if(O.type===h.And)return ce(O.expr,U.expr);for(const Z of U.expr)if(H(Z,O))return!0;return!1}return U.equals(O)}function ce(U,O){let Z=0,V=0;for(;Z<U.length&&V<O.length;){const M=U[Z].cmp(O[V]);if(M<0)return!1;M===0&&Z++,V++}return Z===U.length}function x(U){return U.type===h.Or?U.expr:[U]}}),define(ve[248],Se([1,0,42,5]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$qt=e.AccessibilitySupport=e.$pt=void 0,e.$rt=k,e.$pt=(0,r.$Gi)("accessibilityService");var E;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(E||(e.AccessibilitySupport=E={})),e.$qt=new n.$Xj("accessibilityModeEnabled",!1);function k(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$st="ACCESSIBLE_VIEW_SHOWN_"}),define(ve[249],Se([1,0,18,21,3,170,109,180,181,199,248]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=t,e.clampedFloat=i,e.stringSet=c,e.cursorStyleToString=Y,e.filterValidationDecorations=$e,n=qe(n),r=qe(r),E=qe(E),o=qe(o);var v;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(ee){this.c=ee}hasChanged(ee){return this.c[ee]}}e.ConfigurationChangedEvent=h;class w{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=w;class a{constructor(ee,we,He,Xe){this.id=ee,this.name=we,this.defaultValue=He,this.schema=Xe}applyUpdate(ee,we){return m(ee,we)}compute(ee,we,He){return He}}class f{constructor(ee,we){this.newValue=ee,this.didChange=we}}e.ApplyUpdateResult=f;function m(ne,ee){if(typeof ne!="object"||typeof ee!="object"||!ne||!ee)return new f(ee,ne!==ee);if(Array.isArray(ne)||Array.isArray(ee)){const He=Array.isArray(ne)&&Array.isArray(ee)&&n.$xb(ne,ee);return new f(ee,!He)}let we=!1;for(const He in ee)if(ee.hasOwnProperty(He)){const Xe=m(ne[He],ee[He]);Xe.didChange&&(ne[He]=Xe.newValue,we=!0)}return new f(ne,we)}class ${constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,we){return m(ee,we)}validate(ee){return this.defaultValue}}class b{constructor(ee,we,He,Xe){this.id=ee,this.name=we,this.defaultValue=He,this.schema=Xe}applyUpdate(ee,we){return m(ee,we)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,we,He){return He}}function d(ne,ee){return typeof ne>"u"?ee:ne==="false"?!1:!!ne}class p extends b{constructor(ee,we,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=He),super(ee,we,He,Xe)}validate(ee){return d(ee,this.defaultValue)}}function t(ne,ee,we,He){if(typeof ne>"u")return ee;let Xe=parseInt(ne,10);return isNaN(Xe)?ee:(Xe=Math.max(we,Xe),Xe=Math.min(He,Xe),Xe|0)}class l extends b{static clampedInt(ee,we,He,Xe){return t(ee,we,He,Xe)}constructor(ee,we,He,Xe,_e,it=void 0){typeof it<"u"&&(it.type="integer",it.default=He,it.minimum=Xe,it.maximum=_e),super(ee,we,He,it),this.minimum=Xe,this.maximum=_e}validate(ee){return l.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function i(ne,ee,we,He){if(typeof ne>"u")return ee;const Xe=g.float(ne,ee);return g.clamp(Xe,we,He)}class g extends b{static clamp(ee,we,He){return ee<we?we:ee>He?He:ee}static float(ee,we){if(typeof ee=="number")return ee;if(typeof ee>"u")return we;const He=parseFloat(ee);return isNaN(He)?we:He}constructor(ee,we,He,Xe,_e){typeof _e<"u"&&(_e.type="number",_e.default=He),super(ee,we,He,_e),this.validationFn=Xe}validate(ee){return this.validationFn(g.float(ee,this.defaultValue))}}class s extends b{static string(ee,we){return typeof ee!="string"?we:ee}constructor(ee,we,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=He),super(ee,we,He,Xe)}validate(ee){return s.string(ee,this.defaultValue)}}function c(ne,ee,we,He){return typeof ne!="string"?ee:He&&ne in He?He[ne]:we.indexOf(ne)===-1?ee:ne}class u extends b{constructor(ee,we,He,Xe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Xe,_e.default=He),super(ee,we,He,_e),this.c=Xe}validate(ee){return c(ee,this.defaultValue,this.c)}}class S extends a{constructor(ee,we,He,Xe,_e,it,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=Xe),super(ee,we,He,ut),this.c=_e,this.d=it}validate(ee){return typeof ee!="string"?this.defaultValue:this.c.indexOf(ee)===-1?this.defaultValue:this.d(ee)}}function P(ne){switch(ne){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class C extends a{constructor(){super(Ce.accessibilitySupport,"accessibilitySupport",D.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(ee){switch(ee){case"auto":return D.AccessibilitySupport.Unknown;case"off":return D.AccessibilitySupport.Disabled;case"on":return D.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,we,He){return He===D.AccessibilitySupport.Unknown?ee.accessibilitySupport:He}}class L extends a{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(Ce.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{insertSpace:d(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var T;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(T||(e.TextEditorCursorBlinkingStyle=T={}));function I(ne){switch(ne){case"blink":return T.Blink;case"smooth":return T.Smooth;case"phase":return T.Phase;case"expand":return T.Expand;case"solid":return T.Solid}}var q;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(q||(e.TextEditorCursorStyle=q={}));function Y(ne){switch(ne){case q.Line:return"line";case q.Block:return"block";case q.Underline:return"underline";case q.LineThin:return"line-thin";case q.BlockOutline:return"block-outline";case q.UnderlineThin:return"underline-thin"}}function Q(ne){switch(ne){case"line":return q.Line;case"block":return q.Block;case"underline":return q.Underline;case"line-thin":return q.LineThin;case"block-outline":return q.BlockOutline;case"underline-thin":return q.UnderlineThin}}class re extends ${constructor(){super(Ce.editorClassName)}compute(ee,we,He){const Xe=["monaco-editor"];return we.get(Ce.extraEditorClassName)&&Xe.push(we.get(Ce.extraEditorClassName)),ee.extraEditorClassName&&Xe.push(ee.extraEditorClassName),we.get(Ce.mouseStyle)==="default"?Xe.push("mouse-default"):we.get(Ce.mouseStyle)==="copy"&&Xe.push("mouse-copy"),we.get(Ce.showUnused)&&Xe.push("showUnused"),we.get(Ce.showDeprecated)&&Xe.push("showDeprecated"),Xe.join(" ")}}class te extends p{constructor(){super(Ce.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(ee,we,He){return He&&ee.emptySelectionClipboard}}class _ extends a{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ce.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(16,null),included:E.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(18,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{cursorMoveOnType:d(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":c(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":c(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(we.loop,this.defaultValue.loop)}}}class de extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ce.fontLigatures,"fontLigatures",de.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?de.OFF:ee==="true"?de.ON:ee:ee?de.ON:de.OFF}}e.EditorFontLigatures=de;class J extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ce.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?J.OFF:ee==="true"?J.TRANSLATE:ee:ee?J.TRANSLATE:J.OFF}compute(ee,we,He){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class ae extends ${constructor(){super(Ce.fontInfo)}compute(ee,we,He){return ee.fontInfo}}class z extends b{constructor(){super(Ce.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(ee){const we=g.float(ee,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(we,6,100)}compute(ee,we,He){return ee.fontInfo.fontSize}}class B extends a{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ce.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(l.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}class ie extends a{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ce.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:He,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:He,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:He,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:He,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:He,description:o.localize(41,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{multiple:c(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??c(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??c(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??c(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??c(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??c(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends a{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ce.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(45,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(46,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),delay:l.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:d(we.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(we.above,this.defaultValue.above)}}}var pe;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class H extends ${constructor(){super(Ce.layoutInfo)}compute(ee,we,He){return H.computeLayout(we,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const we=ee.height/ee.lineHeight,He=Math.floor(ee.paddingTop/ee.lineHeight);let Xe=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(Xe=Math.max(Xe,we-1));const _e=(He+ee.viewLineCount+Xe)/(ee.pixelRatio*ee.height),it=Math.floor(ee.viewLineCount/_e);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Xe,desiredRatio:_e,minimapLineCount:it}}static c(ee,we){const He=ee.outerWidth,Xe=ee.outerHeight,_e=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:pe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const it=we.stableMinimapLayoutInput,ut=it&&ee.outerHeight===it.outerHeight&&ee.lineHeight===it.lineHeight&&ee.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&ee.pixelRatio===it.pixelRatio&&ee.scrollBeyondLastLine===it.scrollBeyondLastLine&&ee.paddingTop===it.paddingTop&&ee.paddingBottom===it.paddingBottom&&ee.minimap.enabled===it.minimap.enabled&&ee.minimap.side===it.minimap.side&&ee.minimap.size===it.minimap.size&&ee.minimap.showSlider===it.minimap.showSlider&&ee.minimap.renderCharacters===it.minimap.renderCharacters&&ee.minimap.maxColumn===it.minimap.maxColumn&&ee.minimap.scale===it.minimap.scale&&ee.verticalScrollbarWidth===it.verticalScrollbarWidth&&ee.isViewportWrapping===it.isViewportWrapping,gt=ee.lineHeight,bt=ee.typicalHalfwidthCharacterWidth,Mt=ee.scrollBeyondLastLine,At=ee.minimap.renderCharacters;let ft=_e>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const wt=ee.minimap.maxColumn,Et=ee.minimap.size,kt=ee.minimap.side,Jt=ee.verticalScrollbarWidth,Ot=ee.viewLineCount,ht=ee.remainingWidth,pt=ee.isViewportWrapping,vt=At?2:3;let It=Math.floor(_e*Xe);const zt=It/_e;let Ct=!1,_t=!1,Pt=vt*ft,Lt=ft/_e,Bt=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:Wt,extraLinesBeforeFirstLine:Qt,extraLinesBeyondLastLine:en,desiredRatio:Vt,minimapLineCount:Dt}=H.computeContainedMinimapLineCount({viewLineCount:Ot,scrollBeyondLastLine:Mt,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:Xe,lineHeight:gt,pixelRatio:_e});if(Ot/Dt>1)Ct=!0,_t=!0,ft=1,Pt=1,Lt=ft/_e;else{let $t=!1,Yt=ft+1;if(Et==="fit"){const Zt=Math.ceil((Qt+Ot+en)*Pt);pt&&ut&&ht<=we.stableFitRemainingWidth?($t=!0,Yt=we.stableFitMaxMinimapScale):$t=Zt>It}if(Et==="fill"||$t){Ct=!0;const Zt=ft;Pt=Math.min(gt*_e,Math.max(1,Math.floor(1/Vt))),pt&&ut&&ht<=we.stableFitRemainingWidth&&(Yt=we.stableFitMaxMinimapScale),ft=Math.min(Yt,Math.max(1,Math.floor(Pt/vt))),ft>Zt&&(Bt=Math.min(2,ft/Zt)),Lt=ft/_e/Bt,It=Math.ceil(Math.max(Wt,Qt+Ot+en)*Pt),pt?(we.stableMinimapLayoutInput=ee,we.stableFitRemainingWidth=ht,we.stableFitMaxMinimapScale=ft):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Nt=Math.floor(wt*Lt),Tt=Math.min(Nt,Math.max(0,Math.floor((ht-Jt-2)*Lt/(bt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(_e*Tt);const Ut=St/_e;St=Math.floor(St*Bt);const qt=At?pe.Text:pe.Blocks,Ht=kt==="left"?0:He-Tt-Jt;return{renderMinimap:qt,minimapLeft:Ht,minimapWidth:Tt,minimapHeightIsEditorHeight:Ct,minimapIsSampling:_t,minimapScale:ft,minimapLineHeight:Pt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:It,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:zt}}static computeLayout(ee,we){const He=we.outerWidth|0,Xe=we.outerHeight|0,_e=we.lineHeight|0,it=we.lineNumbersDigitCount|0,ut=we.typicalHalfwidthCharacterWidth,gt=we.maxDigitWidth,bt=we.pixelRatio,Mt=we.viewLineCount,At=ee.get(Ce.wordWrapOverride2),ft=At==="inherit"?ee.get(Ce.wordWrapOverride1):At,wt=ft==="inherit"?ee.get(Ce.wordWrap):ft,Et=ee.get(Ce.wordWrapColumn),kt=we.isDominatedByLongLines,Jt=ee.get(Ce.glyphMargin),Ot=ee.get(Ce.lineNumbers).renderType!==Ne.Off,ht=ee.get(Ce.lineNumbersMinChars),pt=ee.get(Ce.scrollBeyondLastLine),vt=ee.get(Ce.padding),It=ee.get(Ce.minimap),zt=ee.get(Ce.scrollbar),Ct=zt.verticalScrollbarSize,_t=zt.verticalHasArrows,Pt=zt.arrowSize,Lt=zt.horizontalScrollbarSize,Bt=ee.get(Ce.folding),Nt=ee.get(Ce.showFoldingControls)!=="never";let Tt=ee.get(Ce.lineDecorationsWidth);Bt&&Nt&&(Tt+=16);let St=0;if(Ot){const ln=Math.max(it,ht);St=Math.round(ln*gt)}let Ut=0;Jt&&(Ut=_e*we.glyphMarginDecorationLaneCount);let qt=0,Ht=qt+Ut,Wt=Ht+St,Qt=Wt+Tt;const en=He-Ut-St-Tt;let Vt=!1,Dt=!1,Ft=-1;ft==="inherit"&&kt?(Vt=!0,Dt=!0):wt==="on"||wt==="bounded"?Dt=!0:wt==="wordWrapColumn"&&(Ft=Et);const $t=H.c({outerWidth:He,outerHeight:Xe,lineHeight:_e,typicalHalfwidthCharacterWidth:ut,pixelRatio:bt,scrollBeyondLastLine:pt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:It,verticalScrollbarWidth:Ct,viewLineCount:Mt,remainingWidth:en,isViewportWrapping:Dt},we.memory||new w);$t.renderMinimap!==pe.None&&$t.minimapLeft===0&&(qt+=$t.minimapWidth,Ht+=$t.minimapWidth,Wt+=$t.minimapWidth,Qt+=$t.minimapWidth);const Yt=en-$t.minimapWidth,Zt=Math.max(1,Math.floor((Yt-Ct-2)/ut)),an=_t?Pt:0;return Dt&&(Ft=Math.max(1,Zt),wt==="bounded"&&(Ft=Math.min(Ft,Et))),{width:He,height:Xe,glyphMarginLeft:qt,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Ht,lineNumbersWidth:St,decorationsLeft:Wt,decorationsWidth:Tt,contentLeft:Qt,contentWidth:Yt,minimap:$t,viewportColumn:Zt,isWordWrapMinified:Vt,isViewportWrapping:Dt,wrappingColumn:Ft,verticalScrollbarWidth:Ct,horizontalScrollbarHeight:Lt,overviewRuler:{top:an,width:Ct,height:Xe-2*an,right:0}}}}e.EditorLayoutInfoComputer=H;class ce extends a{constructor(){super(Ce.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(47,null),o.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(49,null)}})}validate(ee){return c(ee,"simple",["simple","advanced"])}compute(ee,we,He){return we.get(Ce.accessibilitySupport)===D.AccessibilitySupport.Enabled?"advanced":He}}var x;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(x||(e.ShowLightbulbIconMode=x={}));class U extends a{constructor(){const ee={enabled:x.On};super(Ce.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[x.Off,x.OnCode,x.On],default:ee.enabled,enumDescriptions:[o.localize(50,null),o.localize(51,null),o.localize(52,null)],description:o.localize(53,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:c(ee.enabled,this.defaultValue.enabled,[x.Off,x.OnCode,x.On])}}}class O extends a{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ce.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Z extends a{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ce.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(59,null),o.localize(60,null,E.$j?"Ctrl+Option":"Ctrl+Alt"),o.localize(61,null,E.$j?"Ctrl+Option":"Ctrl+Alt"),o.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(65,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:c(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily),padding:d(we.padding,this.defaultValue.padding)}}}class V extends a{constructor(){super(Ce.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):l.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,we,He){return He<0?l.clampedInt(-He*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class M extends g{constructor(){super(Ce.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>g.clamp(ee,0,150),{markdownDescription:o.localize(66,null)})}compute(ee,we,He){return ee.fontInfo.lineHeight}}class G extends a{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ce.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(69,null),o.localize(70,null),o.localize(71,null)],default:ee.size,description:o.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(74,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(81,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),autohide:d(we.autohide,this.defaultValue.autohide),size:c(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(we.side,this.defaultValue.side,["right","left"]),showSlider:c(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(we.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(we.scale,1,1,3),maxColumn:l.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d(we.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d(we.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(we.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(we.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function X(ne){return ne==="ctrlCmd"?E.$j?"metaKey":"ctrlKey":"altKey"}class F extends a{constructor(){super(Ce.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(83,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{top:l.clampedInt(we.top,0,0,1e3),bottom:l.clampedInt(we.bottom,0,0,1e3)}}}class W extends a{constructor(){const ee={enabled:!0,cycle:!0};super(Ce.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(85,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),cycle:d(we.cycle,this.defaultValue.cycle)}}}class oe extends ${constructor(){super(Ce.pixelRatio)}compute(ee,we,He){return ee.pixelRatio}}class he extends a{constructor(){super(Ce.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class ke extends a{constructor(){const ee={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(86,null),o.localize(87,null),o.localize(88,null)]}];super(Ce.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:ee.strings,description:o.localize(89,null)},comments:{anyOf:we,default:ee.comments,description:o.localize(90,null)},other:{anyOf:we,default:ee.other,description:o.localize(91,null)}},default:ee,markdownDescription:o.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const bt=ee?"on":"off";return{comments:bt,strings:bt,other:bt}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:we,comments:He,strings:Xe}=ee,_e=["on","inline","off"];let it,ut,gt;return typeof we=="boolean"?it=we?"on":"off":it=c(we,this.defaultValue.other,_e),typeof He=="boolean"?ut=He?"on":"off":ut=c(He,this.defaultValue.comments,_e),typeof Xe=="boolean"?gt=Xe?"on":"off":gt=c(Xe,this.defaultValue.strings,_e),{other:it,comments:ut,strings:gt}}}var Ne;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Ne||(e.RenderLineNumbersType=Ne={}));class me extends a{constructor(){super(Ce.lineNumbers,"lineNumbers",{renderType:Ne.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(93,null),o.localize(94,null),o.localize(95,null),o.localize(96,null)],default:"on",description:o.localize(97,null)})}validate(ee){let we=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(we=Ne.Custom,He=ee):ee==="interval"?we=Ne.Interval:ee==="relative"?we=Ne.Relative:ee==="on"?we=Ne.On:we=Ne.Off),{renderType:we,renderFn:He}}}function $e(ne){const ee=ne.get(Ce.renderValidationDecorations);return ee==="editable"?ne.get(Ce.readOnly):ee!=="on"}class Pe extends a{constructor(){const ee=[],we={type:"number",description:o.localize(98,null)};super(Ce.rulers,"rulers",ee,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:o.localize(99,null),format:"color-hex"}}}]},default:ee,description:o.localize(100,null)})}validate(ee){if(Array.isArray(ee)){const we=[];for(const He of ee)if(typeof He=="number")we.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Xe=He;we.push({column:l.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return we.sort((He,Xe)=>He.column-Xe.column),we}return this.defaultValue}}class Oe extends a{constructor(){super(Ce.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function fe(ne,ee){if(typeof ne!="string")return ee;switch(ne){case"hidden":return k.ScrollbarVisibility.Hidden;case"visible":return k.ScrollbarVisibility.Visible;default:return k.ScrollbarVisibility.Auto}}class De extends a{constructor(){const ee={vertical:k.ScrollbarVisibility.Auto,horizontal:k.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ce.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(101,null),o.localize(102,null),o.localize(103,null)],default:"auto",description:o.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(105,null),o.localize(106,null),o.localize(107,null)],default:"auto",description:o.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(112,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee,He=l.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=l.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:fe(we.vertical,this.defaultValue.vertical),horizontal:fe(we.horizontal,this.defaultValue.horizontal),useShadows:d(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(we.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:l.clampedInt(we.verticalSliderSize,Xe,0,1e3),scrollByPage:d(we.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(we.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Re extends a{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ce.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(119,null)}})}applyUpdate(ee,we){let He=!1;we.allowedCharacters&&ee&&(r.$io(ee.allowedCharacters,we.allowedCharacters)||(ee={...ee,allowedCharacters:we.allowedCharacters},He=!0)),we.allowedLocales&&ee&&(r.$io(ee.allowedLocales,we.allowedLocales)||(ee={...ee,allowedLocales:we.allowedLocales},He=!0));const Xe=super.applyUpdate(ee,we);return He?new f(Xe.newValue,!0):Xe}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{nonBasicASCII:Ge(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ge(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ge(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ee.allowedLocales,this.defaultValue.allowedLocales)}}c(ee,we){if(typeof ee!="object"||!ee)return we;const He={};for(const[Xe,_e]of Object.entries(ee))_e===!0&&(He[Xe]=!0);return He}}class ze extends a{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ce.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(121,null),o.localize(122,null),o.localize(123,null)],description:o.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(126,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),mode:c(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(we.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily)}}}class We extends a{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ce.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(128,null),o.localize(129,null),o.localize(130,null)],description:o.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ee.backgroundColoring,description:o.localize(133,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d(we.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:d(we.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Qe extends a{constructor(){const ee={enabled:A.$jt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$jt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ce.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(135,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ke extends a{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ce.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:ee.bracketPairs,description:o.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(140,null),o.localize(141,null),o.localize(142,null)],default:ee.bracketPairsHorizontal,description:o.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(146,null),o.localize(147,null),o.localize(148,null)],default:ee.highlightActiveIndentation,description:o.localize(149,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{bracketPairs:Ge(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ge(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ge(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ge(ne,ee,we){const He=we.indexOf(ne);return He===-1?ee:we[He]}class xe extends a{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ce.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(150,null),o.localize(151,null)],default:ee.insertMode,description:o.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(156,null),o.localize(157,null),o.localize(158,null),o.localize(159,null)],default:ee.selectionMode,markdownDescription:o.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(197,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{insertMode:c(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(we.showIcons,this.defaultValue.showIcons),showStatusBar:d(we.showStatusBar,this.defaultValue.showStatusBar),preview:d(we.preview,this.defaultValue.preview),previewMode:c(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(we.showMethods,this.defaultValue.showMethods),showFunctions:d(we.showFunctions,this.defaultValue.showFunctions),showConstructors:d(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(we.showFields,this.defaultValue.showFields),showVariables:d(we.showVariables,this.defaultValue.showVariables),showClasses:d(we.showClasses,this.defaultValue.showClasses),showStructs:d(we.showStructs,this.defaultValue.showStructs),showInterfaces:d(we.showInterfaces,this.defaultValue.showInterfaces),showModules:d(we.showModules,this.defaultValue.showModules),showProperties:d(we.showProperties,this.defaultValue.showProperties),showEvents:d(we.showEvents,this.defaultValue.showEvents),showOperators:d(we.showOperators,this.defaultValue.showOperators),showUnits:d(we.showUnits,this.defaultValue.showUnits),showValues:d(we.showValues,this.defaultValue.showValues),showConstants:d(we.showConstants,this.defaultValue.showConstants),showEnums:d(we.showEnums,this.defaultValue.showEnums),showEnumMembers:d(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(we.showKeywords,this.defaultValue.showKeywords),showWords:d(we.showWords,this.defaultValue.showWords),showColors:d(we.showColors,this.defaultValue.showColors),showFiles:d(we.showFiles,this.defaultValue.showFiles),showReferences:d(we.showReferences,this.defaultValue.showReferences),showFolders:d(we.showFolders,this.defaultValue.showFolders),showTypeParameters:d(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(we.showSnippets,this.defaultValue.showSnippets),showUsers:d(we.showUsers,this.defaultValue.showUsers),showIssues:d(we.showIssues,this.defaultValue.showIssues)}}}class st extends a{constructor(){super(Ce.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(199,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class lt extends a{constructor(){const ee=[];super(Ce.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(200,null),type:"string"},{description:o.localize(201,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const we=[];for(const He of ee)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&we.push(He)}catch{}return we}return this.defaultValue}}var rt;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class nt extends a{constructor(){super(Ce.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(202,null),o.localize(203,null),o.localize(204,null),o.localize(205,null)],description:o.localize(206,null),default:"same"}})}validate(ee){switch(ee){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(ee,we,He){return we.get(Ce.accessibilitySupport)===D.AccessibilitySupport.Enabled?rt.None:He}}class tt extends ${constructor(){super(Ce.wrappingInfo)}compute(ee,we,He){const Xe=we.get(Ce.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class et extends a{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(Ce.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(209,null),o.localize(210,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),showDropSelector:c(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends a{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(Ce.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(213,null),o.localize(214,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const we=ee;return{enabled:d(we.enabled,this.defaultValue.enabled),showPasteSelector:c(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const be="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",Fe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:E.$j?Le:E.$k?Fe:be,fontWeight:"normal",fontSize:E.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ye(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ce;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.placeholder=88]="placeholder",ne[ne.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=90]="quickSuggestions",ne[ne.quickSuggestionsDelay=91]="quickSuggestionsDelay",ne[ne.readOnly=92]="readOnly",ne[ne.readOnlyMessage=93]="readOnlyMessage",ne[ne.renameOnType=94]="renameOnType",ne[ne.renderControlCharacters=95]="renderControlCharacters",ne[ne.renderFinalNewline=96]="renderFinalNewline",ne[ne.renderLineHighlight=97]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=99]="renderValidationDecorations",ne[ne.renderWhitespace=100]="renderWhitespace",ne[ne.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ne[ne.roundedSelection=102]="roundedSelection",ne[ne.rulers=103]="rulers",ne[ne.scrollbar=104]="scrollbar",ne[ne.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=106]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=107]="scrollPredominantAxis",ne[ne.selectionClipboard=108]="selectionClipboard",ne[ne.selectionHighlight=109]="selectionHighlight",ne[ne.selectOnLineNumbers=110]="selectOnLineNumbers",ne[ne.showFoldingControls=111]="showFoldingControls",ne[ne.showUnused=112]="showUnused",ne[ne.snippetSuggestions=113]="snippetSuggestions",ne[ne.smartSelect=114]="smartSelect",ne[ne.smoothScrolling=115]="smoothScrolling",ne[ne.stickyScroll=116]="stickyScroll",ne[ne.stickyTabStops=117]="stickyTabStops",ne[ne.stopRenderingLineAfter=118]="stopRenderingLineAfter",ne[ne.suggest=119]="suggest",ne[ne.suggestFontSize=120]="suggestFontSize",ne[ne.suggestLineHeight=121]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ne[ne.suggestSelection=123]="suggestSelection",ne[ne.tabCompletion=124]="tabCompletion",ne[ne.tabIndex=125]="tabIndex",ne[ne.unicodeHighlighting=126]="unicodeHighlighting",ne[ne.unusualLineTerminators=127]="unusualLineTerminators",ne[ne.useShadowDOM=128]="useShadowDOM",ne[ne.useTabStops=129]="useTabStops",ne[ne.wordBreak=130]="wordBreak",ne[ne.wordSegmenterLocales=131]="wordSegmenterLocales",ne[ne.wordSeparators=132]="wordSeparators",ne[ne.wordWrap=133]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=136]="wordWrapColumn",ne[ne.wordWrapOverride1=137]="wordWrapOverride1",ne[ne.wordWrapOverride2=138]="wordWrapOverride2",ne[ne.wrappingIndent=139]="wrappingIndent",ne[ne.wrappingStrategy=140]="wrappingStrategy",ne[ne.showDeprecated=141]="showDeprecated",ne[ne.inlayHints=142]="inlayHints",ne[ne.editorClassName=143]="editorClassName",ne[ne.pixelRatio=144]="pixelRatio",ne[ne.tabFocusMode=145]="tabFocusMode",ne[ne.layoutInfo=146]="layoutInfo",ne[ne.wrappingInfo=147]="wrappingInfo",ne[ne.defaultColorDecorators=148]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ce||(e.EditorOption=Ce={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(Ce.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(215,null)})),acceptSuggestionOnEnter:ye(new u(Ce.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(216,null),""],markdownDescription:o.localize(217,null)})),accessibilitySupport:ye(new C),accessibilityPageSize:ye(new l(Ce.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(218,null),tags:["accessibility"]})),ariaLabel:ye(new s(Ce.ariaLabel,"ariaLabel",o.localize(219,null))),ariaRequired:ye(new p(Ce.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ye(new p(Ce.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ye(new u(Ce.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(221,null),o.localize(222,null),""],description:o.localize(223,null)})),autoClosingComments:ye(new u(Ce.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(224,null),o.localize(225,null),""],description:o.localize(226,null)})),autoClosingDelete:ye(new u(Ce.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(227,null),""],description:o.localize(228,null)})),autoClosingOvertype:ye(new u(Ce.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(229,null),""],description:o.localize(230,null)})),autoClosingQuotes:ye(new u(Ce.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(231,null),o.localize(232,null),""],description:o.localize(233,null)})),autoIndent:ye(new S(Ce.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],P,{enumDescriptions:[o.localize(234,null),o.localize(235,null),o.localize(236,null),o.localize(237,null),o.localize(238,null)],description:o.localize(239,null)})),automaticLayout:ye(new p(Ce.automaticLayout,"automaticLayout",!1)),autoSurround:ye(new u(Ce.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(240,null),o.localize(241,null),o.localize(242,null),""],description:o.localize(243,null)})),bracketPairColorization:ye(new Qe),bracketPairGuides:ye(new Ke),stickyTabStops:ye(new p(Ce.stickyTabStops,"stickyTabStops",!1,{description:o.localize(244,null)})),codeLens:ye(new p(Ce.codeLens,"codeLens",!0,{description:o.localize(245,null)})),codeLensFontFamily:ye(new s(Ce.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(246,null)})),codeLensFontSize:ye(new l(Ce.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(247,null)})),colorDecorators:ye(new p(Ce.colorDecorators,"colorDecorators",!0,{description:o.localize(248,null)})),colorDecoratorActivatedOn:ye(new u(Ce.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(249,null),o.localize(250,null),o.localize(251,null)],description:o.localize(252,null)})),colorDecoratorsLimit:ye(new l(Ce.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(253,null)})),columnSelection:ye(new p(Ce.columnSelection,"columnSelection",!1,{description:o.localize(254,null)})),comments:ye(new L),contextmenu:ye(new p(Ce.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(Ce.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(255,null)})),cursorBlinking:ye(new S(Ce.cursorBlinking,"cursorBlinking",T.Blink,"blink",["blink","smooth","phase","expand","solid"],I,{description:o.localize(256,null)})),cursorSmoothCaretAnimation:ye(new u(Ce.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(257,null),o.localize(258,null),o.localize(259,null)],description:o.localize(260,null)})),cursorStyle:ye(new S(Ce.cursorStyle,"cursorStyle",q.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],Q,{description:o.localize(261,null)})),cursorSurroundingLines:ye(new l(Ce.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(262,null)})),cursorSurroundingLinesStyle:ye(new u(Ce.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],markdownDescription:o.localize(265,null)})),cursorWidth:ye(new l(Ce.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(266,null)})),disableLayerHinting:ye(new p(Ce.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(Ce.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(Ce.domReadOnly,"domReadOnly",!1)),dragAndDrop:ye(new p(Ce.dragAndDrop,"dragAndDrop",!0,{description:o.localize(267,null)})),emptySelectionClipboard:ye(new te),dropIntoEditor:ye(new et),stickyScroll:ye(new O),experimentalWhitespaceRendering:ye(new u(Ce.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(268,null),o.localize(269,null),o.localize(270,null)],description:o.localize(271,null)})),extraEditorClassName:ye(new s(Ce.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ye(new g(Ce.fastScrollSensitivity,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:o.localize(272,null)})),find:ye(new _),fixedOverflowWidgets:ye(new p(Ce.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ye(new p(Ce.folding,"folding",!0,{description:o.localize(273,null)})),foldingStrategy:ye(new u(Ce.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(274,null),o.localize(275,null)],description:o.localize(276,null)})),foldingHighlight:ye(new p(Ce.foldingHighlight,"foldingHighlight",!0,{description:o.localize(277,null)})),foldingImportsByDefault:ye(new p(Ce.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(278,null)})),foldingMaximumRegions:ye(new l(Ce.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(279,null)})),unfoldOnClickAfterEndOfLine:ye(new p(Ce.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(280,null)})),fontFamily:ye(new s(Ce.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(281,null)})),fontInfo:ye(new ae),fontLigatures2:ye(new de),fontSize:ye(new z),fontWeight:ye(new B),fontVariations:ye(new J),formatOnPaste:ye(new p(Ce.formatOnPaste,"formatOnPaste",!1,{description:o.localize(282,null)})),formatOnType:ye(new p(Ce.formatOnType,"formatOnType",!1,{description:o.localize(283,null)})),glyphMargin:ye(new p(Ce.glyphMargin,"glyphMargin",!0,{description:o.localize(284,null)})),gotoLocation:ye(new ie),hideCursorInOverviewRuler:ye(new p(Ce.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(285,null)})),hover:ye(new le),inDiffEditor:ye(new p(Ce.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ye(new g(Ce.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>g.clamp(ne,-5,20),{description:o.localize(286,null)})),lightbulb:ye(new U),lineDecorationsWidth:ye(new V),lineHeight:ye(new M),lineNumbers:ye(new me),lineNumbersMinChars:ye(new l(Ce.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(Ce.linkedEditing,"linkedEditing",!1,{description:o.localize(287,null)})),links:ye(new p(Ce.links,"links",!0,{description:o.localize(288,null)})),matchBrackets:ye(new u(Ce.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(289,null)})),minimap:ye(new G),mouseStyle:ye(new u(Ce.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new g(Ce.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:o.localize(290,null)})),mouseWheelZoom:ye(new p(Ce.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:E.$j?o.localize(291,null):o.localize(292,null)})),multiCursorMergeOverlapping:ye(new p(Ce.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(293,null)})),multiCursorModifier:ye(new S(Ce.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],X,{markdownEnumDescriptions:[o.localize(294,null),o.localize(295,null)],markdownDescription:o.localize(296,null)})),multiCursorPaste:ye(new u(Ce.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(297,null),o.localize(298,null)],markdownDescription:o.localize(299,null)})),multiCursorLimit:ye(new l(Ce.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(300,null)})),occurrencesHighlight:ye(new u(Ce.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],markdownDescription:o.localize(304,null)})),overviewRulerBorder:ye(new p(Ce.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(305,null)})),overviewRulerLanes:ye(new l(Ce.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ye(new F),pasteAs:ye(new Ze),parameterHints:ye(new W),peekWidgetDefaultFocus:ye(new u(Ce.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),placeholder:ye(new he),definitionLinkOpensInPeek:ye(new p(Ce.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(309,null)})),quickSuggestions:ye(new ke),quickSuggestionsDelay:ye(new l(Ce.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(310,null)})),readOnly:ye(new p(Ce.readOnly,"readOnly",!1)),readOnlyMessage:ye(new Oe),renameOnType:ye(new p(Ce.renameOnType,"renameOnType",!1,{description:o.localize(311,null),markdownDeprecationMessage:o.localize(312,null)})),renderControlCharacters:ye(new p(Ce.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(313,null),restricted:!0})),renderFinalNewline:ye(new u(Ce.renderFinalNewline,"renderFinalNewline",E.$k?"dimmed":"on",["off","on","dimmed"],{description:o.localize(314,null)})),renderLineHighlight:ye(new u(Ce.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(315,null)],description:o.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(Ce.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(317,null)})),renderValidationDecorations:ye(new u(Ce.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new u(Ce.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(318,null),o.localize(319,null),o.localize(320,null),""],description:o.localize(321,null)})),revealHorizontalRightPadding:ye(new l(Ce.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ye(new p(Ce.roundedSelection,"roundedSelection",!0,{description:o.localize(322,null)})),rulers:ye(new Pe),scrollbar:ye(new De),scrollBeyondLastColumn:ye(new l(Ce.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(323,null)})),scrollBeyondLastLine:ye(new p(Ce.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(324,null)})),scrollPredominantAxis:ye(new p(Ce.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(325,null)})),selectionClipboard:ye(new p(Ce.selectionClipboard,"selectionClipboard",!0,{description:o.localize(326,null),included:E.$k})),selectionHighlight:ye(new p(Ce.selectionHighlight,"selectionHighlight",!0,{description:o.localize(327,null)})),selectOnLineNumbers:ye(new p(Ce.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ye(new u(Ce.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(328,null),o.localize(329,null),o.localize(330,null)],description:o.localize(331,null)})),showUnused:ye(new p(Ce.showUnused,"showUnused",!0,{description:o.localize(332,null)})),showDeprecated:ye(new p(Ce.showDeprecated,"showDeprecated",!0,{description:o.localize(333,null)})),inlayHints:ye(new Z),snippetSuggestions:ye(new u(Ce.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(334,null),o.localize(335,null),o.localize(336,null),o.localize(337,null)],description:o.localize(338,null)})),smartSelect:ye(new st),smoothScrolling:ye(new p(Ce.smoothScrolling,"smoothScrolling",!1,{description:o.localize(339,null)})),stopRenderingLineAfter:ye(new l(Ce.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ye(new xe),inlineSuggest:ye(new ze),inlineEdit:ye(new We),inlineCompletionsAccessibilityVerbose:ye(new p(Ce.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(340,null)})),suggestFontSize:ye(new l(Ce.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ye(new l(Ce.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ye(new p(Ce.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(343,null)})),suggestSelection:ye(new u(Ce.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(344,null),o.localize(345,null),o.localize(346,null)],description:o.localize(347,null)})),tabCompletion:ye(new u(Ce.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(348,null),o.localize(349,null),o.localize(350,null)],description:o.localize(351,null)})),tabIndex:ye(new l(Ce.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ye(new Re),unusualLineTerminators:ye(new u(Ce.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(352,null),o.localize(353,null),o.localize(354,null)],description:o.localize(355,null)})),useShadowDOM:ye(new p(Ce.useShadowDOM,"useShadowDOM",!0)),useTabStops:ye(new p(Ce.useTabStops,"useTabStops",!0,{description:o.localize(356,null)})),wordBreak:ye(new u(Ce.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(357,null),o.localize(358,null)],description:o.localize(359,null)})),wordSegmenterLocales:ye(new lt),wordSeparators:ye(new s(Ce.wordSeparators,"wordSeparators",y.$kt,{description:o.localize(360,null)})),wordWrap:ye(new u(Ce.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(361,null),o.localize(362,null),o.localize(363,null),o.localize(364,null)],description:o.localize(365,null)})),wordWrapBreakAfterCharacters:ye(new s(Ce.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new s(Ce.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new l(Ce.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(366,null)})),wordWrapOverride1:ye(new u(Ce.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new u(Ce.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ye(new re),defaultColorDecorators:ye(new p(Ce.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(367,null)})),pixelRatio:ye(new oe),tabFocusMode:ye(new p(Ce.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(368,null)})),layoutInfo:ye(new H),wrappingInfo:ye(new tt),wrappingIndent:ye(new nt),wrappingStrategy:ye(new ce)}}),define(ve[250],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=r,e.ID="diagnosticsService",e.$Tm=(0,n.$Gi)(e.ID);function r(k){return!!k.hostName&&!!k.errorMessage}class E{async getPerformanceInfo(R,A){return{}}async getSystemInfo(R,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,A){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$Vm=E}),define(ve[88],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0,e.$Zo=(0,n.$Gi)("downloadService")}),define(ve[28],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,n.$Gi)("environmentService"),e.$Oi=(0,n.$Hi)(e.$Ni)}),define(ve[16],Se([1,0,67,9,17,11,4,216,5,3,13,65]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=h,e.$cl=m,e.$dl=b,e.$el=d,e.$fl=p,e.$gl=t,e.$hl=l,e.$il=i,e.$jl=g,e.$kl=s,e.$ll=c,e.$nl=P,e.$ol=C,e.$pl=L,e.$ql=T,e.$rl=I,e.$ul=te,e.$Gl=B,e.$Hl=ie,e.$Jl=pe,e.$al=(0,y.$Gi)("fileService");function h(H){return H.create===!0}var w;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var a;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var f;(function(H){H[H.UPDATED=2]="UPDATED",H[H.ADDED=4]="ADDED",H[H.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function m(H){const ce=H;return!!ce&&typeof ce.onDidChange=="function"}var $;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function b(H){return!!(H.capabilities&$.FileReadWrite)}function d(H){return!!(H.capabilities&$.FileFolderCopy)}function p(H){return!!(H.capabilities&$.FileClone)}function t(H){return!!(H.capabilities&$.FileOpenReadWriteClose)}function l(H){return!!(H.capabilities&$.FileReadStream)}function i(H){return b(H)?!!(H.capabilities&$.FileAtomicRead):!1}function g(H){return b(H)?!!(H.capabilities&$.FileAtomicWrite):!1}function s(H){return!!(H.capabilities&$.FileAtomicDelete)}function c(H){return!!(H.capabilities&$.Readonly)}var u;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class S extends Error{static create(ce,x){const U=new S(ce.toString(),x);return L(U,x),U}constructor(ce,x){super(ce),this.code=x}}e.$ml=S;function P(H,ce){return S.create(H,ce)}function C(H){return H||P((0,A.localize)(0,null),u.Unknown)}function L(H,ce){return H.name=ce?`${ce} (FileSystemError)`:"FileSystemError",H}function T(H){if(!H)return u.Unknown;if(H instanceof S)return H.code;const ce=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!ce)return u.Unknown;switch(ce[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function I(H){if(H instanceof _)return H.fileOperationResult;switch(T(H)){case u.FileNotFound:return ae.FILE_NOT_FOUND;case u.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case u.NoPermissions:return ae.FILE_PERMISSION_DENIED;case u.FileExists:return ae.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var q;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(q||(e.FileOperation=q={}));class Y{constructor(ce,x,U){this.resource=ce,this.operation=x,this.target=U}isOperation(ce){return this.operation===ce}}e.$sl=Y;var Q;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(Q||(e.FileChangeType=Q={}));class re{static{this.a=null}constructor(ce,x){this.c=x,this.b=void 0,this.d=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawAdded.map(O=>[O,!0])),U}),this.f=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(O=>[O,!0])),U}),this.g=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(O=>[O,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ce){switch(U.type){case Q.ADDED:this.rawAdded.push(U.resource);break;case Q.UPDATED:this.rawUpdated.push(U.resource);break;case Q.DELETED:this.rawDeleted.push(U.resource);break}this.b!==re.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=re.a):this.b!==void 0&&(this.b=re.a))}}contains(ce,...x){return this.h(ce,{includeChildren:!1},...x)}affects(ce,...x){return this.h(ce,{includeChildren:!0},...x)}h(ce,x,...U){if(!ce)return!1;const O=U.length>0;return!!((!O||U.includes(Q.ADDED))&&(this.d.value.get(ce)||x.includeChildren&&this.d.value.findSuperstr(ce))||(!O||U.includes(Q.UPDATED))&&(this.f.value.get(ce)||x.includeChildren&&this.f.value.findSuperstr(ce))||(!O||U.includes(Q.DELETED))&&(this.g.value.findSubstr(ce)||x.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$tl=re;function te(H,ce,x){return!H||!ce||H===ce||ce.length>H.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),x?(0,E.$If)(H,ce):H.indexOf(ce)===0)}class _ extends Error{constructor(ce,x,U){super(ce),this.fileOperationResult=x,this.options=U}}e.$vl=_;class de extends _{constructor(ce,x,U,O){super(ce,x,O),this.fileOperationResult=x,this.size=U}}e.$wl=de;class J extends _{constructor(ce,x,U){super(ce,ae.FILE_NOT_MODIFIED_SINCE,U),this.stat=x}}e.$xl=J;var ae;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var z;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$Fl="";function B(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}async function ie(H,ce){if(!ce.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(x=>{const U=ce.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===H.scheme&&O.added&&(U.dispose(),x())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(ce){return(0,k.$kg)(ce)||(ce=0),ce<le.KB?(0,A.localize)(1,null,ce.toFixed(0)):ce<le.MB?(0,A.localize)(2,null,(ce/le.KB).toFixed(2)):ce<le.GB?(0,A.localize)(3,null,(ce/le.MB).toFixed(2)):ce<le.TB?(0,A.localize)(4,null,(ce/le.GB).toFixed(2)):(0,A.localize)(5,null,(ce/le.TB).toFixed(2))}}e.$Il=le;function pe(H){const ce=typeof H=="string"||H?.scheme===D.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===D.Schemas.file?1024*le.MB:ce?10*le.MB:o.$o?50*le.MB:1024*le.MB}}),define(ve[121],Se([1,0,15,10,217,16]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=R;async function R(D,v,h,w,a,f){let m;try{await A(D,v,h,w,a,f)}catch($){m=$}finally{m&&a.errorTransformer&&(m=a.errorTransformer(m)),typeof m<"u"&&h.error(m),h.end()}}async function A(D,v,h,w,a,f){y(f);const m=await D.open(v,{create:!1});try{y(f);let $=0,b=0,d=a&&typeof a.length=="number"?a.length:void 0,p=n.$Pe.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),t=a&&typeof a.position=="number"?a.position:0,l=0;do b=await D.read(m,t,p.buffer,l,p.byteLength-l),t+=b,l+=b,$+=b,typeof d=="number"&&(d-=b),l===p.byteLength&&(await h.write(w(p)),p=n.$Pe.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),l=0);while(b>0&&(typeof d!="number"||d>0)&&y(f)&&o($,a));if(l>0){let i=l;typeof d=="number"&&(i=Math.min(l,d)),h.write(w(p.slice(0,i)))}}catch($){throw(0,k.$ol)($)}finally{await D.close(m)}}function y(D){if(D.isCancellationRequested)throw(0,r.$9)();return!0}function o(D,v){if(typeof v?.limits?.size=="number"&&D>v.limits.size)throw(0,k.$nl)((0,E.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ve[52],Se([1,0,86,2,9,3,4,16]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=y,e.$3q=o,e.$7q=w,e.$8q=a,e.$9q=f,e.$0q=m,e.$$q=b,e.$_q=d;function y(p){return typeof p.correlationId=="number"}function o(p){return p.recursive===!0}class D extends r.$Xc{static{this.a=5}constructor(t,l,i,g){super(),this.h=t,this.j=l,this.m=i,this.n=g,this.c=this.B(new r.$Yc),this.f=void 0,this.g=0}s(){const t=new r.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(l=>this.h(l))),t.add(this.b.onDidLogMessage(l=>this.j(l))),t.add(this.b.onDidError(l=>this.t(l.error,l.request)))}t(t,l){this.u(t,l)?this.g<D.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,l){return!(!this.n.restartOnError||l||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=D;class v extends D{constructor(t,l,i){super(t,l,i,{type:"node.js",restartOnError:!1})}}e.$5q=v;class h extends D{constructor(t,l,i){super(t,l,i,{type:"universal",restartOnError:!0})}}e.$6q=h;function w(p){return p.map(t=>({type:t.type,resource:R.URI.revive(t.resource),cId:t.cId}))}function a(p){const t=new $;for(const l of p)t.processEvent(l);return t.coalesce()}function f(p,t){return typeof t=="string"&&!t.startsWith(n.$wk)&&!(0,E.$lc)(t)?{base:p,pattern:t}:t}function m(p,t){const l=[];for(const i of t)l.push((0,n.$Ak)(f(p,i)));return l}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return k.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const l=this.b.get(this.c(t));let i=!1;if(l){const g=l.type,s=t.type;l.resource.fsPath!==t.resource.fsPath&&(t.type===A.FileChangeType.DELETED||t.type===A.FileChangeType.ADDED)?i=!0:g===A.FileChangeType.ADDED&&s===A.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(l)):g===A.FileChangeType.DELETED&&s===A.FileChangeType.ADDED?l.type=A.FileChangeType.UPDATED:g===A.FileChangeType.ADDED&&s===A.FileChangeType.UPDATED||(l.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],l=[];return Array.from(this.a).filter(i=>i.type!==A.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,g)=>i.resource.fsPath.length-g.resource.fsPath.length).filter(i=>l.some(g=>(0,A.$ul)(i.resource.fsPath,g,!k.$k))?!1:(l.push(i.resource.fsPath),!0)).concat(t)}}function b(p,t){if(typeof t=="number")switch(p.type){case A.FileChangeType.ADDED:return(t&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(t&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(t&A.FileChangeFilter.UPDATED)===0}return!1}function d(p){if(typeof p=="number"){const t=[];return p&A.FileChangeFilter.ADDED&&t.push("Added"),p&A.FileChangeFilter.DELETED&&t.push("Deleted"),p&A.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ve[251],Se([1,0,15,45,10,6,2,56,23,16,52]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class v extends R.$Xc{constructor(w,a){super(),this.a=w,this.b=a,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$ne),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$ne),this.onDidWatchError=this.g.event,this.h=(0,y.$3g)(),this.j()}get capabilities(){return this.c||(this.c=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=o.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=o.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,a){const{buffer:f}=await this.a.call("readFile",[w,a]);return f}readFileStream(w,a,f){const m=(0,A.$De)(b=>n.$Pe.concat(b.map(d=>n.$Pe.wrap(d))).buffer),$=new R.$Wc;return $.add(this.a.listen("readFileStream",[w,a])(b=>{if(b instanceof n.$Pe)m.write(b.buffer);else{if(b==="end")m.end();else{let d;if(b instanceof Error)d=b;else{const p=b;d=(0,o.$nl)(p.message??(0,r.$rj)(p),p.code??o.FileSystemProviderErrorCode.Unknown)}m.error(d),m.end()}$.dispose()}})),$.add(f.onCancellationRequested(()=>{m.error((0,E.$9)()),m.end(),$.dispose()})),m}writeFile(w,a,f){return this.a.call("writeFile",[w,n.$Pe.wrap(a),f])}open(w,a){return this.a.call("open",[w,a])}close(w){return this.a.call("close",[w])}async read(w,a,f,m,$){const[b,d]=await this.a.call("read",[w,a,$]);return f.set(b.buffer.slice(0,d),m),d}write(w,a,f,m,$){return this.a.call("write",[w,a,n.$Pe.wrap(f),m,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,a){return this.a.call("delete",[w,a])}rename(w,a,f){return this.a.call("rename",[w,a,f])}copy(w,a,f){return this.a.call("copy",[w,a,f])}cloneFile(w,a){return this.a.call("cloneFile",[w,a])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const a=w;this.f.fire((0,D.$7q)(a))}else{const a=w;this.g.fire(a)}}))}watch(w,a){const f=(0,y.$3g)();return this.a.call("watch",[this.h,f,w,a]),(0,R.$Vc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$0Q=v}),define(ve[252],Se([1,0,31,2,52,6,16,4,14]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class o extends r.$Xc{constructor(){super(),this.a=this.B(new k.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$7c),this.m=new Set,this.n=this.B(new y.$Eh(this.y())),this.r=5007,this.s=new y.$4h,this.R=!1,this.B(this.f(v=>this.t(v)))}t(v){this.u(v)&&this.z(v)}u(v){return(0,E.$2q)(v)}async watch(v){this.s.isSettled||this.s.complete(),this.s=new y.$4h;try{this.h.clear(),this.g.clear();for(const h of v)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(v){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),v?this.y():0)}y(){return 800}isSuspended(v){return typeof v.correlationId!="number"?!1:this.m.has(v.correlationId)?"polling":this.j.has(v.correlationId)}async z(v){if(this.j.has(v.correlationId))return;const h=new r.$Wc;this.j.set(v.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(v,h),this.w(!0))}C(v){this.j.deleteAndDispose(v.correlationId),this.m.delete(v.correlationId),this.w(!1)}D(v,h){this.F(v,h)?(this.P(`reusing an existing recursive watcher to monitor ${v.path}`),this.m.delete(v.correlationId)):(this.G(v,h),this.m.add(v.correlationId))}F(v,h){const w=this.O?.subscribe(v.path,(a,f)=>{h.isDisposed||(a?this.D(v,h):f?.type===R.FileChangeType.ADDED&&this.H(v))});return w?(h.add(w),!0):!1}G(v,h){let w=!1;const a=(f,m)=>{if(h.isDisposed)return;const $=this.I(f),b=this.I(m),d=w;w=$,!$&&(b||d)&&this.H(v)};this.P(`starting fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,n.watchFile)(v.path,{persistent:!1,interval:this.r},a)}catch(f){this.Q(`fs.watchFile() failed with error ${f} on path ${v.path} (correlationId: ${v.correlationId})`)}h.add((0,r.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,n.unwatchFile)(v.path,a)}catch(f){this.Q(`fs.unwatchFile() failed with error ${f} on path ${v.path} (correlationId: ${v.correlationId})`)}}))}H(v){this.P(`detected ${v.path} exists again, resuming watcher (correlationId: ${v.correlationId})`);const h={resource:A.URI.file(v.path),type:R.FileChangeType.ADDED,cId:v.correlationId};this.a.fire([h]),this.J(h,v),this.C(v)}I(v){return v.ctimeMs===0&&v.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(v,h){if(this.R){const w=` >> normalized ${v.type===R.FileChangeType.ADDED?"[ADDED]":v.type===R.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`;this.L(w,h)}}L(v,h){this.R&&this.P(`${v}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(v){return`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, filter: ${(0,E.$_q)(v.filter)}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`}async setVerboseLogging(v){this.R=v}}e.$ir=o}),define(ve[253],Se([1,0,31,14,19,37,2,107,9,3,20,4,196,25,16,52]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=$;class m extends R.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,p,t,l,i,g){super(),this.s=d,this.t=p,this.u=t,this.w=l,this.y=i,this.z=g,this.c=this.B(new r.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Uh(s=>this.M(s),m.b)),this.g=(0,f.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,f.$2q)(this.s)?this.s.filter:void 0,this.m=new E.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const p=await w.Promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,p.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let p=d.path;try{p=await w.Promises.realpath(d.path),d.path===p&&(p=await(0,h.$kr)(d.path,this.m.token)??d.path),d.path!==p&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${p})`)}catch{}return p}async G(d,p){const t=new R.$Wc;return this.H(d,p,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,p,t)),t}H(d,p,t){if(p)return!1;const l=v.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(g,s)=>{if(!t.isDisposed)if(g){const c=await this.G(d,p);t.isDisposed?c.dispose():t.add(c)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:l,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(d,p,t){if(o.$j&&(0,k.$Fg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const l=new E.$ye(this.m.token);t.add((0,R.$Vc)(()=>l.dispose(!0)));const i=new R.$Wc;t.add(i);try{const g=v.URI.file(this.s.path),s=(0,y.$qc)(d),c=(0,n.watch)(d);i.add((0,R.$Vc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${d}'`);const u=new Set;if(p)try{for(const P of await w.Promises.readdir(d))u.add(P)}catch(P){this.O(P)}if(l.token.isCancellationRequested)return;const S=new Map;i.add((0,R.$Vc)(()=>{for(const[,P]of S)P.dispose();S.clear()})),c.on("error",(P,C)=>{l.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${P}, ${C})`),this.D())}),c.on("change",(P,C)=>{if(l.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${P}"] ${C}`);let L="";if(C&&(L=C.toString(),o.$j&&(L=(0,A.$nm)(L))),!(!L||P!=="change"&&P!=="rename"))if(p)if(P==="rename"){S.get(L)?.dispose();const T=setTimeout(async()=>{if(S.delete(L),L===s&&!await w.Promises.exists(d)){this.J(g);return}if(l.token.isCancellationRequested)return;const I=await this.N((0,y.$mc)(d,L));if(l.token.isCancellationRequested)return;let q;I?u.has(L)?q=a.FileChangeType.UPDATED:(q=a.FileChangeType.ADDED,u.add(L)):(u.delete(L),q=a.FileChangeType.DELETED),this.L({resource:(0,D.$hh)(g,L),type:q,cId:this.s.correlationId})},m.a);S.set(L,(0,R.$Vc)(()=>clearTimeout(T)))}else{let T;u.has(L)?T=a.FileChangeType.UPDATED:(T=a.FileChangeType.ADDED,u.add(L)),this.L({resource:(0,D.$hh)(g,L),type:T,cId:this.s.correlationId})}else if(P==="rename"||L!==s){const T=setTimeout(async()=>{const I=await w.Promises.exists(d);l.token.isCancellationRequested||(I?(this.L({resource:g,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(d,!1))):this.J(g))},m.a);i.clear(),i.add((0,R.$Vc)(()=>clearTimeout(T)))}else this.L({resource:g,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(g){l.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${g.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,p=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===a.FileChangeType.ADDED?"[ADDED]":d.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!p&&this.g.some(t=>t(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!p&&this.h&&this.h.length>0&&!this.h.some(t=>t(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const p=(0,f.$8q)(d),t=[];for(const i of p){if((0,f.$$q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===a.FileChangeType.ADDED?"[ADDED]":i.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(o.$k)return w.Promises.exists(d);try{const p=(0,y.$qc)(d);return(await w.Promises.readdir((0,y.$pc)(d))).some(l=>l===p)}catch(p){return this.Q(p),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=m;async function $(b,d,p,t,l=512){const i=await w.Promises.open(b,"r"),g=Buffer.allocUnsafe(l),s=new E.$ye(t);let c,u=!1;const S={path:b,excludes:[],recursive:!1},P=new m(S,void 0,C=>{(async()=>{for(const{type:L}of C)if(L===a.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:T}=await w.Promises.read(i,g,0,l,null);if(!T||s.token.isCancellationRequested)break;d(g.slice(0,T))}}catch(T){c=new Error(T),s.dispose(!0)}finally{u=!1}}})()});return await P.ready,p(),new Promise((C,L)=>{s.token.onCancellationRequested(async()=>{P.dispose();try{await w.Promises.close(i)}catch(T){c=new Error(T)}c?L(c):C()})})}}),define(ve[254],Se([1,0,6,86,252,3,253,37]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class y extends E.$ir{constructor(D){super(),this.O=D,this.onDidError=n.Event.None,this.watchers=new Set}async N(D){D=this.Z(D);const v=[],h=new Set(Array.from(this.watchers));for(const w of D){const a=this.W(w);a&&(0,r.$Ek)(a.request.excludes,w.excludes)&&(0,r.$Ek)(a.request.includes,w.includes)?h.delete(a):v.push(w)}v.length&&this.P(`Request to start watching: ${v.map(w=>this.M(w)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(w=>this.M(w.request)).join(",")}`);for(const w of h)this.Y(w);for(const w of v)this.X(w)}W(D){for(const v of this.watchers)if(typeof D.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===D.correlationId)return v}else if((0,A.$Eg)(v.request.path,D.path,!k.$k))return v}X(D){const v=new R.$nr(D,this.O,w=>this.a.fire(w),()=>this.c.fire(D),w=>this.b.fire(w),this.R),h={request:D,instance:v};this.watchers.add(h)}async stop(){await super.stop();for(const D of this.watchers)this.Y(D)}Y(D){this.P("stopping file watcher",D),this.watchers.delete(D),D.instance.dispose()}Z(D){const v=new Map;for(const h of D){const w=k.$k?h.path:h.path.toLowerCase();let a=v.get(h.correlationId);a||(a=new Map,v.set(h.correlationId,a)),a.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),a.set(w,h)}return Array.from(v.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(D){super.setVerboseLogging(D);for(const v of this.watchers)v.instance.setVerboseLogging(D)}P(D,v){this.R&&this.b.fire({type:"trace",message:this.bb(D,v)})}Q(D){this.b.fire({type:"warn",message:this.bb(D)})}bb(D,v){return v?`[File Watcher (node.js)] ${D} (${this.M(v.request)})`:`[File Watcher (node.js)] ${D}`}}e.$pr=y}),define(ve[255],Se([1,0,52,254]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class E extends n.$5q{constructor(R,A,y){super(R,A,y),this.s()}r(R){return R.add(new r.$pr(void 0))}}e.$qr=E}),define(ve[256],Se([1,0,13,51,117,52]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class R extends k.$6q{constructor(y,o,D){super(y,o,D),this.s()}r(y){const o=y.add(new E.$gr(n.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(o.onDidProcessExit(({code:D,signal:v})=>this.t(`terminated by itself with code ${D}, signal: ${v} (ETERM)`))),r.ProxyChannel.toService((0,r.$ni)(o.getChannel("watcher")))}}e.$hr=R}),define(ve[89],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class n{constructor(...E){this.a=new Map;for(const[k,R]of E)this.set(k,R)}set(E,k){const R=this.a.get(E);return this.a.set(E,k),R}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ei=n}),define(ve[122],Se([1,0,14,10,2,71,247,5,89,80]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const D=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class h{constructor(m=new y.$Ei,$=!1,b,d=D){this.i=m,this.j=$,this.k=b,this.l=d,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Fi,this),this._globalGraph=d?b?._globalGraph??new R.$tr(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Sc)(this.h),this.h.clear();for(const m of this.g)(0,E.$Rc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const b=this,d=new class extends h{dispose(){b.h.delete(d),super.dispose()}}(m,this.j,this,this.l);return this.h.add(d),$?.add(d),d}invokeFunction(m,...$){this.m();const b=a.traceInvocation(this.l,m);let d=!1;try{return m({get:t=>{if(d)throw(0,r.$$)("service accessor is only valid during the invocation of its target method");const l=this.s(t,b);if(!l)throw new Error(`[invokeFunction] unknown service '${t}'`);return l}},...$)}finally{d=!0,b.stop()}}createInstance(m,...$){this.m();let b,d;return m instanceof k.$Di?(b=a.traceCreation(this.l,m.ctor),d=this.o(m.ctor,m.staticArguments.concat($),b)):(b=a.traceCreation(this.l,m),d=this.o(m,$,b)),b.stop(),d}o(m,$=[],b){const d=A._util.getServiceDependencies(m).sort((l,i)=>l.index-i.index),p=[];for(const l of d){const i=this.s(l.id,b);i||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),p.push(i)}const t=d.length>0?d[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const l=t-$.length;l>0?$=$.concat(new Array(l)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(p))}q(m,$){if(this.i.get(m)instanceof k.$Di)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const b=this.r(m);return b instanceof k.$Di?this.u(m,b,$.branch(m,!0)):($.branch(m,!1),b)}u(m,$,b){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,b)}finally{this.t.delete(m)}}v(m,$,b){const d=new R.$tr(l=>l.id.toString());let p=0;const t=[{id:m,desc:$,_trace:b}];for(;t.length;){const l=t.pop();if(d.lookupOrInsertNode(l),p++>1e3)throw new v(d);for(const i of A._util.getServiceDependencies(l.desc.ctor)){const g=this.r(i.id);if(g||this.y(`[createInstance] ${m} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(i.id)),g instanceof k.$Di){const s={id:i.id,desc:g,_trace:l._trace.branch(i.id,!0)};d.insertEdge(l,s),t.push(s)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new v(d);break}for(const{data:i}of l){if(this.r(i.id)instanceof k.$Di){const s=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,s)}d.removeNode(i)}}return this.r(m)}w(m,$,b=[],d,p){if(this.i.get(m)instanceof k.$Di)return this.x(m,$,b,d,p,this.g);if(this.k)return this.k.w(m,$,b,d,p);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,b=[],d,p,t){if(d){const l=new h(void 0,this.j,this,this.l);l.c=String(m);const i=new Map,g=new n.$Zh(()=>{const s=l.o($,b,p);for(const[c,u]of i){const S=s[c];if(typeof S=="function")for(const P of u)P.disposable=S.apply(s,P.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,c){if(!g.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let P=i.get(c);return P||(P=new o.$8c,i.set(c,P)),(L,T,I)=>{if(g.isInitialized)return g.value[c](L,T,I);{const q={listener:[L,T,I],disposable:void 0},Y=P.push(q);return(0,E.$Vc)(()=>{Y(),q.disposable?.dispose()})}}}if(c in s)return s[c];const u=g.value;let S=u[c];return typeof S!="function"||(S=S.bind(u),s[c]=S),S},set(s,c,u){return g.value[c]=u,!0},getPrototypeOf(s){return $.prototype}})}else{const l=this.o($,b,p);return t.add(l),l}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$ur=h;var w;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(w||(w={}));class a{static{this.all=new Set}static{this.c=new class extends a{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new a(w.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(m,$){return m?new a(w.Creation,$.name):a.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const b=new a(w.Branch,m.toString());return this.h.push([m,$,b]),b}stop(){const m=Date.now()-this.g;a.f+=m;let $=!1;function b(p,t){const l=[],i=new Array(p+1).join("	");for(const[g,s,c]of t.h)if(s&&c){$=!0,l.push(`${i}CREATES -> ${g}`);const u=b(p+1,c);u&&l.push(u)}else l.push(`${i}uses -> ${g}`);return l.join(`
`)}const d=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(m>2||$)&&a.all.add(d.join(`
`))}}e.$vr=a}),define(ve[257],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$pw=void 0,e.$pw=(0,n.$Gi)("labelService");var r;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(ve[12],Se([1,0,220,45,6,66,2,26,3,20,11,4,42,5]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=f,e.log=$,e.$ok=S,e.$pk=P,e.$qk=C,e.$rk=L,n=qe(n),e.$ak=(0,w.$Gi)("logService"),e.$bk=(0,w.$Gi)("loggerService");function a(){return new Date().toISOString()}function f(T){return(0,D.$kg)(T)}var m;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$dk=m.Info;function $(T,I,q){switch(I){case m.Trace:T.trace(q);break;case m.Debug:T.debug(q);break;case m.Info:T.info(q);break;case m.Warning:T.warn(q);break;case m.Error:T.error(q);break;case m.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function b(T,I=!1){let q="";for(let Y=0;Y<T.length;Y++){let Q=T[Y];if(Q instanceof Error&&(Q=(0,r.$rj)(Q,I)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}q+=(Y>0?" ":"")+Q}return q}class d extends R.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new E.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==m.Off&&this.b<=I}}e.$fk=d;class p extends d{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...q){this.f(m.Trace)&&this.g(m.Trace,b([I,...q],!0))}debug(I,...q){this.f(m.Debug)&&this.g(m.Debug,b([I,...q]))}info(I,...q){this.f(m.Info)&&this.g(m.Info,b([I,...q]))}warn(I,...q){this.f(m.Warning)&&this.g(m.Warning,b([I,...q]))}error(I,...q){if(this.f(m.Error))if(I instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=I.stack,this.g(m.Error,b(Y))}else this.g(m.Error,b([I,...q]))}flush(){}}e.$gk=p;class t extends d{constructor(I=e.$dk){super(),this.setLevel(I),this.g=!y.$i}trace(I,...q){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,I,...q):console.log(`[main ${a()}]`,I,...q))}debug(I,...q){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,I,...q):console.log(`[main ${a()}]`,I,...q))}info(I,...q){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,I,...q):console.log(`[main ${a()}]`,I,...q))}warn(I,...q){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,I,...q):console.warn(`[main ${a()}]`,I,...q))}error(I,...q){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,I,...q):console.error(`[main ${a()}]`,I,...q))}flush(){}}e.$hk=t;class l extends d{constructor(I=e.$dk,q=!0){super(),this.g=q,this.setLevel(I)}trace(I,...q){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...q):console.log(I,...q))}debug(I,...q){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...q):console.log(I,...q))}info(I,...q){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...q):console.log(I,...q))}warn(I,...q){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...q):console.log(I,...q))}error(I,...q){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...q):console.error(I,...q))}flush(){}}e.$ik=l;class i extends d{constructor(I,q=e.$dk){super(),this.g=I,this.setLevel(q)}trace(I,...q){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(I),...q])}debug(I,...q){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(I),...q])}info(I,...q){this.f(m.Info)&&this.g.log(m.Info,[this.h(I),...q])}warn(I,...q){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(I),...q])}error(I,...q){this.f(m.Error)&&this.g.log(m.Error,[this.h(I),...q])}h(I){return typeof I=="string"?I:(0,r.$rj)(I,this.f(m.Trace))}flush(){}}e.$jk=i;class g extends d{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const q of this.g)q.setLevel(I);super.setLevel(I)}trace(I,...q){for(const Y of this.g)Y.trace(I,...q)}debug(I,...q){for(const Y of this.g)Y.debug(I,...q)}info(I,...q){for(const Y of this.g)Y.info(I,...q)}warn(I,...q){for(const Y of this.g)Y.warn(I,...q)}error(I,...q){for(const Y of this.g)Y.error(I,...q)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$kk=g;class s extends R.$Xc{constructor(I,q,Y){if(super(),this.h=I,this.j=q,this.b=new A.$Dc,this.c=this.B(new E.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$ne),this.onDidChangeVisibility=this.g.event,Y)for(const Q of Y)this.b.set(Q.resource,{logger:void 0,info:Q})}m(I){return(0,D.$gg)(I)?[...this.b.values()].find(q=>q.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,q){const Y=this.n(I),Q=(0,D.$gg)(I)?I:q?.id??(0,k.$uj)(Y.toString()).toString(16);let re=this.b.get(Y)?.logger;const te=q?.logLevel==="always"?m.Trace:q?.logLevel;re||(re=this.s(Y,te??this.getLogLevel(Y)??this.h,{...q,id:Q}));const _={logger:re,info:{resource:Y,id:Q,logLevel:te,name:q?.name,hidden:q?.hidden,extensionId:q?.extensionId,when:q?.when}};return this.registerLogger(_.info),this.b.set(Y,_),re}n(I){return(0,D.$gg)(I)?(0,o.$hh)(this.j,`${I}.log`):I}setLogLevel(I,q){if(v.URI.isUri(I)){const Y=I,Q=q,re=this.b.get(Y);re&&Q!==re.info.logLevel&&(re.info.logLevel=Q===this.h?void 0:Q,re.logger?.setLevel(Q),this.b.set(re.info.resource,re),this.f.fire([Y,Q]))}else{this.h=I;for(const[Y,Q]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,q){const Y=this.m(I);Y&&q!==!Y.info.hidden&&(Y.info.hidden=!q,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,q]))}getLogLevel(I){let q;return I&&(q=this.b.get(I)?.info.logLevel),q??this.h}registerLogger(I){const q=this.b.get(I.resource);q?q.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const q=this.b.get(I);q&&(q.logger&&q.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[q.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=s;class c{constructor(){this.onDidChangeLogLevel=new E.$ne().event}setLevel(I){}getLevel(){return m.Info}trace(I,...q){}debug(I,...q){}info(I,...q){}warn(I,...q){}error(I,...q){}critical(I,...q){}dispose(){}flush(){}}e.$mk=c;class u extends c{}e.$nk=u;function S(T){if(T.verbose)return m.Trace;if(typeof T.logLevel=="string"){const I=L(T.logLevel.toLowerCase());if(I!==void 0)return I}return e.$dk}function P(T){switch(T){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function C(T){switch(T){case m.Trace:return{original:"Trace",value:n.localize(0,null)};case m.Debug:return{original:"Debug",value:n.localize(1,null)};case m.Info:return{original:"Info",value:n.localize(2,null)};case m.Warning:return{original:"Warning",value:n.localize(3,null)};case m.Error:return{original:"Error",value:n.localize(4,null)};case m.Off:return{original:"Off",value:n.localize(5,null)}}}function L(T){switch(T){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$sk=new h.$Xj("logLevel",P(m.Info))}),define(ve[258],Se([1,0,18,14,10,6,37,2,9,52,12]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class v extends A.$Xc{constructor(w,a){super(),this.a=w,this.b=a,this.c=this.B(new k.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Eh(0)),this.w=[],this.y=this.B(new r.$Eh(0))}watch(w,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n(w,a):this.z(w,a)}n(w,a){const f={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},m=(0,n.$Wb)(this.j,f);return this.r(),(0,A.$Vc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,E.$3)(w))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,o.$7q)(a)),a=>this.G(a),this.a.getLevel()===D.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===D.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const a of this.j)(0,o.$3q)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const a of this.j)(0,o.$3q)(a)&&w.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,a){const f={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},m=(0,n.$Wb)(this.w,f);return this.C(),(0,A.$Vc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,E.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,o.$7q)(w)),w=>this.G(w),this.a.getLevel()===D.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===D.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,y.$kc)(w.fsPath)}J(w){const a=this.I(w);return(0,R.$Ig)(a)}}e.$ar=v});var je=this&&this.__param||function(se,e){return function(n,r){e(n,r,se)}};define(ve[123],Se([1,0,18,14,15,19,6,66,40,2,67,13,44,20,56,215,16,121,12,10]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let t=class extends o.$Xc{static{p=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new R.$ne),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$ne),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$ne),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$ne),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$ne),this.Y=this.B(new R.$ne),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$ne),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Ph)}registerProvider(i,g){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${i}`);const s=new o.$Wc;return this.h.set(i,g),this.c.fire({added:!0,scheme:i,provider:g}),s.add(g.onDidChangeFile(c=>{const u=new m.$tl(c,!this.S(g));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof g.onDidWatchError=="function"&&s.add(g.onDidWatchError(c=>this.Z.fire(new Error(c)))),s.add(g.onDidChangeCapabilities(()=>this.g.fire({provider:g,scheme:i}))),(0,o.$Vc)(()=>{this.c.fire({added:!1,scheme:i,provider:g}),this.h.delete(i),(0,o.$Sc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const g=[];this.f.fire({scheme:i,join(s){g.push(s)}}),!this.h.has(i)&&await r.Promises.settled(g)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,g){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&g)}listCapabilities(){return y.Iterable.map(this.h,([i,g])=>({scheme:i,capabilities:g.capabilities}))}async j(i){if(!(0,w.$lh)(i))throw new m.$vl((0,f.localize)(0,null,this.sb(i)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const g=this.h.get(i.scheme);if(!g){const s=new d.$eb;throw s.message=(0,f.localize)(1,null,i.toString()),s}return g}async m(i){const g=await this.j(i);if((0,m.$gl)(g)||(0,m.$dl)(g)||(0,m.$hl)(g))return g;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const g=await this.j(i);if((0,m.$gl)(g)||(0,m.$dl)(g))return g;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,g){try{return await this.s(i,g)}catch(s){throw(0,m.$ql)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.$vl((0,f.localize)(2,null,this.sb(i)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$ol)(s)}}async s(i,g){const s=await this.j(i),c=this.S(s),u=g?.resolveTo,S=g?.resolveSingleChildDescendants,P=g?.resolveMetadata,C=await s.stat(i);let L;return this.t(s,i,C,void 0,!!P,(T,I)=>(L||(L=D.$Mi.forUris(()=>!c),L.set(i,!0),u&&L.fill(!0,u)),L.get(T.resource)||L.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&S?I===1:!1))}async t(i,g,s,c,u,S){const{providerExtUri:P}=this.R(i),C={resource:g,name:P.basename(g),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(i.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Gl)({mtime:s.mtime,size:s.size}),children:void 0};if(C.isDirectory&&S(C,c)){try{const L=await i.readdir(g),T=await r.Promises.settled(L.map(async([I,q])=>{try{const Y=P.joinPath(g,I),Q=u?await i.stat(Y):{type:q};return await this.t(i,Y,Q,L.length,u,S)}catch(Y){return this.b.trace(Y),null}}));C.children=(0,n.$Kb)(T)}catch(L){this.b.trace(L),C.children=[]}return C}return C}async resolveAll(i){return r.Promises.settled(i.map(async g=>{try{return{stat:await this.s(g.resource,g.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const g=await this.j(i),s=await g.stat(i);return this.t(g,i,s,void 0,!0,()=>!1)}async exists(i){const g=await this.j(i);try{return!!await g.stat(i)}catch{return!1}}async canCreateFile(i,g){try{await this.u(i,g)}catch(s){return s}return!0}async u(i,g){if(!g?.overwrite&&await this.exists(i))throw new m.$vl((0,f.localize)(3,null,this.sb(i)),m.FileOperationResult.FILE_MODIFIED_SINCE,g)}async createFile(i,g=E.$Pe.fromString(""),s){await this.u(i,s);const c=await this.writeFile(i,g);return this.r.fire(new m.$sl(i,m.FileOperation.CREATE,c)),c}async writeFile(i,g,s){const c=this.qb(await this.n(i),i),{providerExtUri:u}=this.R(c);let S=s;if((0,m.$jl)(c)&&!S?.atomic){const P=c.enforceAtomicWriteFile?.(i);P&&(S={...s,atomic:P})}try{await this.w(c,i,S)||await this.U(c,u.dirname(i));let C;if((0,m.$dl)(c)&&!(g instanceof E.$Pe))if((0,a.$Be)(g)){const L=await(0,a.$Ie)(g,3);L.ended?C=E.$Pe.concat(L.buffer):C=L}else C=(0,a.$Fe)(g,L=>E.$Pe.concat(L),3);else C=g;!(0,m.$gl)(c)||(0,m.$dl)(c)&&C instanceof E.$Pe||(0,m.$dl)(c)&&(0,m.$jl)(c)&&S?.atomic?await this.hb(c,i,S,C):await this.db(c,i,S,C instanceof E.$Pe?(0,E.$1e)(C):C),this.r.fire(new m.$sl(i,m.FileOperation.WRITE))}catch(P){throw new m.$vl((0,f.localize)(4,null,this.sb(i),(0,m.$ol)(P).toString()),(0,m.$rl)(P),S)}return this.resolve(i,{resolveMetadata:!0})}async w(i,g,s){const c=!!s?.unlock;if(c&&!(i.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(5,null,this.sb(g)));if(!!s?.atomic){if(!(i.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(6,null,this.sb(g)));if(!(i.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(7,null,this.sb(g)));if(c)throw new Error((0,f.localize)(8,null,this.sb(g)))}let S;try{S=await i.stat(g)}catch{return}if(S.type&m.FileType.Directory)throw new m.$vl((0,f.localize)(9,null,this.sb(g)),m.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(g,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.$Fl&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,m.$Gl)({mtime:s.mtime,size:S.size}))throw new m.$vl((0,f.localize)(10,null),m.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(i,g,s){const c=await this.m(i);return g?.atomic?this.z(c,i,g,s):this.C(c,i,g,s)}async z(i,g,s,c){return new Promise((u,S)=>{this.cb.queueFor(g,async()=>{try{const P=await this.C(i,g,s,c);u(P)}catch(P){S(P)}},this.R(i).providerExtUri)})}async C(i,g,s,c){const u=await this.D(i,g,{...s,preferUnbuffered:!0},c);return{...u,value:await(0,E.$2e)(u.value)}}async readFileStream(i,g,s){const c=await this.m(i);return this.D(c,i,g,s)}async D(i,g,s,c){const u=new k.$ye(c);let S=s;(0,m.$il)(i)&&i.enforceAtomicReadFile?.(g)&&(S={...s,atomic:!0});const P=this.J(g,S).then(L=>L,L=>{throw u.dispose(!0),L});let C;try{return typeof S?.etag=="string"&&S.etag!==m.$Fl&&await P,S?.atomic&&(0,m.$il)(i)||!((0,m.$gl)(i)||(0,m.$hl)(i))||(0,m.$dl)(i)&&S?.preferUnbuffered?C=this.I(i,g,S):(0,m.$hl)(i)?C=this.G(i,g,u.token,S):C=this.H(i,g,u.token,S),C.on("end",()=>u.dispose()),C.on("error",()=>u.dispose()),{...await P,value:C}}catch(L){throw C&&await(0,a.$Ge)(C),this.F(L,g,S)}}F(i,g,s){const c=(0,f.localize)(11,null,this.sb(g),(0,m.$ol)(i).toString());return i instanceof m.$xl?new m.$xl(c,i.stat,s):i instanceof m.$wl?new m.$wl(c,i.fileOperationResult,i.size,i.options):new m.$vl(c,(0,m.$rl)(i),s)}G(i,g,s,c=Object.create(null)){const u=i.readFileStream(g,c,s);return(0,a.$Me)(u,{data:S=>S instanceof E.$Pe?S:E.$Pe.wrap(S),error:S=>this.F(S,g,c)},S=>E.$Pe.concat(S))}H(i,g,s,c=Object.create(null)){const u=(0,E.$6e)();return(0,$.$Zq)(i,g,u,S=>S,{...c,bufferSize:this.a,errorTransformer:S=>this.F(S,g,c)},s),u}I(i,g,s){const c=(0,a.$De)(u=>E.$Pe.concat(u));return(async()=>{try{let u;s?.atomic&&(0,m.$il)(i)?u=await i.readFile(g,{atomic:!0}):u=await i.readFile(g),typeof s?.position=="number"&&(u=u.slice(s.position)),typeof s?.length=="number"&&(u=u.slice(0,s.length)),this.L(g,u.byteLength,s),c.end(E.$Pe.wrap(u))}catch(u){c.error(u),c.end()}})(),c}async J(i,g){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new m.$vl((0,f.localize)(12,null,this.sb(i)),m.FileOperationResult.FILE_IS_DIRECTORY,g);if(typeof g?.etag=="string"&&g.etag!==m.$Fl&&g.etag===s.etag)throw new m.$xl((0,f.localize)(13,null),s,g);return this.L(i,s.size,g),s}L(i,g,s){if(typeof s?.limits?.size=="number"&&g>s.limits.size)throw new m.$wl((0,f.localize)(14,null,this.sb(i)),m.FileOperationResult.FILE_TOO_LARGE,g,s)}async canMove(i,g,s){return this.M(i,g,"move",s)}async canCopy(i,g,s){return this.M(i,g,"copy",s)}async M(i,g,s,c){if(i.toString()!==g.toString())try{const u=s==="move"?this.qb(await this.n(i),i):await this.m(i),S=this.qb(await this.n(g),g);await this.Q(u,i,S,g,s,c)}catch(u){return u}return!0}async move(i,g,s){const c=this.qb(await this.n(i),i),u=this.qb(await this.n(g),g),S=await this.N(c,i,u,g,"move",!!s),P=await this.resolve(g,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,S==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,P)),P}async copy(i,g,s){const c=await this.m(i),u=this.qb(await this.n(g),g),S=await this.N(c,i,u,g,"copy",!!s),P=await this.resolve(g,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,S==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,P)),P}async N(i,g,s,c,u,S){if(g.toString()===c.toString())return u;const{exists:P,isSameResourceWithDifferentPathCase:C}=await this.Q(i,g,s,c,u,S);if(P&&!C&&S&&await this.del(c,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(c)),u==="copy"){if(i===s&&(0,m.$el)(i))await i.copy(g,c,{overwrite:S});else{const L=await this.resolve(g);L.isDirectory?await this.P(i,L,s,c):await this.O(i,g,s,c)}return u}else return i===s?(await i.rename(g,c,{overwrite:S}),u):(await this.N(i,g,s,c,"copy",S),await this.del(g,{recursive:!0}),"copy")}async O(i,g,s,c){if((0,m.$gl)(i)&&(0,m.$gl)(s))return this.jb(i,g,s,c);if((0,m.$gl)(i)&&(0,m.$dl)(s))return this.pb(i,g,s,c);if((0,m.$dl)(i)&&(0,m.$gl)(s))return this.nb(i,g,s,c);if((0,m.$dl)(i)&&(0,m.$dl)(s))return this.lb(i,g,s,c)}async P(i,g,s,c){await s.mkdir(c),Array.isArray(g.children)&&await r.Promises.settled(g.children.map(async u=>{const S=this.R(s).providerExtUri.joinPath(c,u.name);return u.isDirectory?this.P(i,await this.resolve(u.resource),s,S):this.O(i,u.resource,s,S)}))}async Q(i,g,s,c,u,S){let P=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:T}=this.R(i);if(T||(P=L.isEqual(g,c)),P&&u==="copy")throw new Error((0,f.localize)(15,null,this.sb(g),this.sb(c)));if(!P&&L.isEqualOrParent(c,g))throw new Error((0,f.localize)(16,null,this.sb(g),this.sb(c)))}const C=await this.exists(c);if(C&&!P){if(!S)throw new m.$vl((0,f.localize)(17,null,this.sb(g),this.sb(c)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(g,c))throw new Error((0,f.localize)(18,null,this.sb(g),this.sb(c)))}}return{exists:C,isSameResourceWithDifferentPathCase:P}}R(i){const g=this.S(i);return{providerExtUri:g?w.$0g:w.$_g,isPathCaseSensitive:g}}S(i){return!!(i.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const g=this.qb(await this.j(i),i);await this.U(g,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,m.FileOperation.CREATE,s)),s}async U(i,g){const s=[],{providerExtUri:c}=this.R(i);for(;!c.isEqual(g,c.dirname(g));)try{if(!((await i.stat(g)).type&m.FileType.Directory))throw new Error((0,f.localize)(19,null,this.sb(g)));break}catch(u){if((0,m.$ql)(u)!==m.FileSystemProviderErrorCode.FileNotFound)throw u;s.push(c.basename(g)),g=c.dirname(g)}for(let u=s.length-1;u>=0;u--){g=c.joinPath(g,s[u]);try{await i.mkdir(g)}catch(S){if((0,m.$ql)(S)!==m.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(i,g){try{await this.W(i,g)}catch(s){return s}return!0}async W(i,g){const s=this.qb(await this.j(i),i),c=!!g?.useTrash;if(c&&!(s.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(20,null,this.sb(i)));const u=g?.atomic;if(u&&!(s.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(21,null,this.sb(i)));if(c&&u)throw new Error((0,f.localize)(22,null,this.sb(i)));let S;try{S=await s.stat(i)}catch{}if(S)this.rb(i,S);else throw new m.$vl((0,f.localize)(23,null,this.sb(i)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!g?.recursive){const C=await this.resolve(i);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,f.localize)(24,null,this.sb(i)))}return s}async del(i,g){const s=await this.W(i,g);let c=g;if((0,m.$kl)(s)&&!c?.atomic){const C=s.enforceAtomicDelete?.(i);C&&(c={...g,atomic:C})}const u=!!c?.useTrash,S=!!c?.recursive,P=c?.atomic??!1;await s.delete(i,{recursive:S,useTrash:u,atomic:P}),this.r.fire(new m.$sl(i,m.FileOperation.DELETE))}async cloneFile(i,g){const s=await this.j(i),c=this.qb(await this.n(g),g);if(!(s===c&&this.R(s).providerExtUri.isEqual(i,g)))return s===c&&(0,m.$fl)(s)?s.cloneFile(i,g):(await this.U(c,this.R(c).providerExtUri.dirname(g)),s===c&&(0,m.$el)(s)?this.cb.queueFor(i,()=>s.copy(i,g,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,c,g),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,g){return this.watch(i,{...g,correlationId:p.ab++})}watch(i,g={recursive:!1,excludes:[]}){const s=new o.$Wc;let c=!1,u=()=>{c=!0};s.add((0,o.$Vc)(()=>u())),(async()=>{try{const P=await this.bb(i,g);c?(0,o.$Sc)(P):u=()=>(0,o.$Sc)(P)}catch(P){this.b.error(P)}})();const S=g.correlationId;if(typeof S=="number"){const P=s.add(new R.$ne);return s.add(this.X.event(L=>{L.correlates(S)&&P.fire(L)})),{onDidChange:P.event,dispose:()=>s.dispose()}}return s}async bb(i,g){const s=await this.j(i),c=(0,A.$uj)([this.R(s).providerExtUri.getComparisonKey(i),g]);let u=this.$.get(c);return u||(u={count:0,disposable:s.watch(i,g)},this.$.set(c,u)),u.count+=1,(0,o.$Vc)(()=>{u&&(u.count--,u.count===0&&((0,o.$Sc)(u.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,o.$Sc)(i.disposable);this.$.clear()}async db(i,g,s,c){return this.cb.queueFor(g,async()=>{const u=await i.open(g,{create:!0,unlock:s?.unlock??!1});try{(0,a.$Be)(c)||(0,a.$Ce)(c)?await this.eb(i,u,c):await this.fb(i,u,c)}catch(S){throw(0,m.$ol)(S)}finally{await i.close(u)}},this.R(i).providerExtUri)}async eb(i,g,s){let c=0,u;if((0,a.$Ce)(s)){if(s.buffer.length>0){const S=E.$Pe.concat(s.buffer);await this.gb(i,g,S,S.byteLength,c,0),c+=S.byteLength}if(s.ended)return;u=s.stream}else u=s;return new Promise((S,P)=>{(0,a.$He)(u,{onData:async C=>{u.pause();try{await this.gb(i,g,C,C.byteLength,c,0)}catch(L){return P(L)}c+=C.byteLength,setTimeout(()=>u.resume())},onError:C=>P(C),onEnd:()=>S()})})}async fb(i,g,s){let c=0,u;for(;(u=s.read())!==null;)await this.gb(i,g,u,u.byteLength,c,0),c+=u.byteLength}async gb(i,g,s,c,u,S){let P=0;for(;P<c;){const C=await i.write(g,u+P,s.buffer,S+P,c-P);P+=C}}async hb(i,g,s,c){return this.cb.queueFor(g,()=>this.ib(i,g,s,c),this.R(i).providerExtUri)}async ib(i,g,s,c){let u;c instanceof E.$Pe?u=c:(0,a.$Be)(c)?u=await(0,E.$2e)(c):(0,a.$Ce)(c)?u=await(0,E.$3e)(c):u=(0,E.$Ze)(c),await i.writeFile(g,u.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,g,s,c){return this.cb.queueFor(c,()=>this.kb(i,g,s,c),this.R(s).providerExtUri)}async kb(i,g,s,c){let u,S;try{u=await i.open(g,{create:!1}),S=await s.open(c,{create:!0,unlock:!1});const P=E.$Pe.alloc(this.a);let C=0,L=0,T=0;do T=await i.read(u,C,P.buffer,L,P.byteLength-L),await this.gb(s,S,P,T,C,L),C+=T,L+=T,L===P.byteLength&&(L=0);while(T>0)}catch(P){throw(0,m.$ol)(P)}finally{await r.Promises.settled([typeof u=="number"?i.close(u):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(i,g,s,c){return this.cb.queueFor(c,()=>this.mb(i,g,s,c),this.R(s).providerExtUri)}async mb(i,g,s,c){return s.writeFile(c,await i.readFile(g),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,g,s,c){return this.cb.queueFor(c,()=>this.ob(i,g,s,c),this.R(s).providerExtUri)}async ob(i,g,s,c){const u=await s.open(c,{create:!0,unlock:!1});try{const S=await i.readFile(g);await this.gb(s,u,E.$Pe.wrap(S),S.byteLength,0,0)}catch(S){throw(0,m.$ol)(S)}finally{await s.close(u)}}async pb(i,g,s,c){const u=await(0,E.$2e)(this.H(i,g,k.CancellationToken.None));await this.hb(s,c,void 0,u)}qb(i,g){if(i.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$vl((0,f.localize)(25,null,this.sb(g)),m.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,g){if((g.permissions??0)&m.FilePermission.Readonly)throw new m.$vl((0,f.localize)(26,null,this.sb(i)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}};e.$1q=t,e.$1q=t=p=Be([je(0,b.$ak)],t)}),define(ve[72],Se([1,0,14,26,15,6,37,2,9,3,20,56,25,218,16,121,258,256,255]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class d extends m.$ar{static{this.L=!1}constructor(t,l){super(t,l),this.onDidChangeCapabilities=k.Event.None,this.P=new r.$Dc(i=>D.$$g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,o.$k&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:l,symbolicLink:i}=await h.SymlinkSupport.stat(this.I(t));return{type:this.O(l,i),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:a.FilePermission.Locked}}catch(l){throw this.hb(l)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const l=await h.Promises.readdir(this.I(t),{withFileTypes:!0}),i=[];return await Promise.all(l.map(async g=>{try{let s;g.isSymbolicLink()?s=(await this.stat((0,D.$hh)(t,g.name))).type:s=this.O(g),i.push([g.name,s])}catch(s){this.a.trace(s)}})),i}catch(l){throw this.hb(l)}}O(t,l){let i;return l?.dangling?i=a.FileType.Unknown:t.isFile()?i=a.FileType.File:t.isDirectory()?i=a.FileType.Directory:i=a.FileType.Unknown,l&&(i|=a.FileType.SymbolicLink),i}async Q(t){const l=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let i;for(;i=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await i.wait();const g=new n.$Fh;return this.P.set(t,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,A.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.P.get(t)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),g.open()})}async readFile(t,l){let i;try{l?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),i=await this.Q(t));const g=this.I(t);return await h.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{i?.dispose()}}R(t){d.L&&this.a.trace(t)}readFileStream(t,l,i){const g=(0,v.$De)(s=>E.$Pe.concat(s.map(c=>E.$Pe.wrap(c))).buffer);return(0,f.$Zq)(this,t,g,s=>s.buffer,{...l,bufferSize:256*1024},i),g}async writeFile(t,l,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(t)?this.U(t,(0,D.$hh)((0,D.$gh)(t),`${(0,D.$eh)(t)}${i.atomic.postfix}`),l,i):this.W(t,l,i)}async S(t){try{const l=this.I(t),{symbolicLink:i}=await h.SymlinkSupport.stat(l);if(i)return!1}catch{}return!0}async U(t,l,i,g){const s=new A.$Wc;try{s.add(await this.Q(t)),s.add(await this.Q(l)),await this.W(l,i,g,!0);try{await this.rename(l,t,{overwrite:!0})}catch(c){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}finally{s.dispose()}}async W(t,l,i,g){let s;try{const c=this.I(t);if(!i.create||!i.overwrite){if(await h.Promises.exists(c)){if(!i.overwrite)throw(0,a.$nl)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,a.$nl)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:i.unlock},g),await this.write(s,0,l,0,l.byteLength)}catch(c){throw await this.ib(t,c)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(t){d.$=t}async open(t,l,i){const g=this.I(t);let s;(0,a.$bl)(l)&&!i&&(s=await this.Q(t));let c;try{if((0,a.$bl)(l)&&l.unlock)try{const{stat:S}=await h.SymlinkSupport.stat(g);S.mode&128||await h.Promises.chmod(g,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let u;if((0,a.$bl)(l)){if(o.$i)try{await h.Promises.truncate(g,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}u||(u="w")}else u="r";c=await h.Promises.open(g,u)}catch(u){throw s?.dispose(),(0,a.$bl)(l)?await this.ib(t,u):this.hb(u)}if(this.X.set(c,0),(0,a.$bl)(l)&&this.Z.set(c,t),s){const u=this.Y.get(c);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${g})`),this.Y.set(c,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${g})`),u.dispose())}return c}async close(t){const l=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&d.$)try{await h.Promises.fdatasync(t)}catch(i){d.configureFlushOnWrite(!1),this.a.error(i)}return await h.Promises.close(t)}catch(i){throw this.hb(i)}finally{l&&(this.Y.get(t)===l&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),l.dispose())}}async read(t,l,i,g,s){const c=this.ab(t,l);let u=null;try{u=(await h.Promises.read(t,i,g,s,c)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(t,c,u)}return u}ab(t,l){return l===this.X.get(t)?null:l}bb(t,l,i){const g=this.X.get(t);typeof g=="number"&&(typeof l=="number"||(typeof i=="number"?this.X.set(t,g+i):this.X.delete(t)))}async write(t,l,i,g,s){return(0,n.$1h)(()=>this.cb(t,l,i,g,s),100,3)}async cb(t,l,i,g,s){const c=this.ab(t,l);let u=null;try{u=(await h.Promises.write(t,i,g,s,c)).bytesWritten}catch(S){throw await this.ib(this.Z.get(t),S)}finally{this.bb(t,c,u)}return u}async mkdir(t){try{await h.Promises.mkdir(this.I(t))}catch(l){throw this.hb(l)}}async delete(t,l){try{const i=this.I(t);if(l.recursive){let g;l?.atomic!==!1&&l.atomic.postfix&&(g=(0,y.$mc)((0,y.$pc)(i),`${(0,y.$qc)(i)}${l.atomic.postfix}`)),await h.Promises.rm(i,h.RimRafMode.MOVE,g)}else try{await h.Promises.unlink(i)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let s=!1;try{const{stat:c,symbolicLink:u}=await h.SymlinkSupport.stat(i);s=c.isDirectory()&&!u}catch{}if(s)await h.Promises.rmdir(i);else throw g}else throw g}}catch(i){throw this.hb(i)}}async rename(t,l,i){const g=this.I(t),s=this.I(l);if(g!==s)try{await this.db(t,l,"move",i.overwrite),await h.Promises.rename(g,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,w.localize)(2,null,(0,y.$qc)(g),(0,y.$qc)((0,y.$pc)(s)),c.toString()))),this.hb(c)}}async copy(t,l,i){const g=this.I(t),s=this.I(l);if(g!==s)try{await this.db(t,l,"copy",i.overwrite),await h.Promises.copy(g,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,w.localize)(3,null,(0,y.$qc)(g),(0,y.$qc)((0,y.$pc)(s)),c.toString()))),this.hb(c)}}async db(t,l,i,g){const s=this.I(t),c=this.I(l);let u=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,R.$Eg)(s,c,!0)),u){if(i==="copy")throw(0,a.$nl)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const P=await this.N(t);if(!P)throw(0,a.$nl)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(l);if(C){if(!g)throw(0,a.$nl)((0,w.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);P.type&a.FileType.File&&C.type&a.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,l){return this.eb(t,l,!1)}async eb(t,l,i){const g=this.I(t),s=this.I(l),c=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Eg)(g,s,!c))return;const u=new A.$Wc;try{u.add(await this.Q(t)),u.add(await this.Q(l)),i&&await h.Promises.mkdir((0,y.$pc)(s),{recursive:!0}),await h.Promises.copyFile(g,s)}catch(S){if(S.code==="ENOENT"&&!i)return this.eb(t,l,!0);throw this.hb(S)}finally{u.dispose()}}t(t,l,i){return new $.$hr(g=>t(g),g=>l(g),i)}F(t,l,i){return new b.$qr(g=>t(g),g=>l(g),i)}hb(t){if(t instanceof a.$ml)return t;let l=t,i;switch(t.code){case"ENOENT":i=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=a.FileSystemProviderErrorCode.Unknown;break;default:i=a.FileSystemProviderErrorCode.Unknown}return(0,a.$nl)(l,i)}async ib(t,l){let i=this.hb(l);if(t&&i.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await h.SymlinkSupport.stat(this.I(t));g.mode&128||(i=(0,a.$nl)(l,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return i}}e.$rr=d}),define(ve[259],Se([1,0,6,72,2,15,56,19]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;class y extends E.$Xc{constructor(v,h){super(),this.a=v,this.b=h,this.F=new Map,this.G=new Map}call(v,h,w){const a=this.c(v);switch(h){case"stat":return this.g(a,w[0]);case"readdir":return this.h(a,w[0]);case"open":return this.r(a,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(a,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(a,w[0],w[1],w[2]);case"rename":return this.z(a,w[0],w[1],w[2]);case"copy":return this.C(a,w[0],w[1],w[2]);case"cloneFile":return this.D(a,w[0],w[1]);case"mkdir":return this.w(a,w[0]);case"delete":return this.y(a,w[0],w[1]);case"watch":return this.I(a,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${h} not found`)}listen(v,h,w){const a=this.c(v);switch(h){case"fileChange":return this.H(a,w[0]);case"readFileStream":return this.m(a,w[0],w[1])}throw new Error(`Unknown event ${h}`)}g(v,h){const w=this.f(v,h,!0);return this.a.stat(w)}h(v,h){const w=this.f(v,h);return this.a.readdir(w)}async j(v,h,w){const a=this.f(v,h,!0),f=await this.a.readFile(a,w);return k.$Pe.wrap(f)}m(v,h,w){const a=this.f(v,h,!0),f=new A.$ye,m=new n.$ne({onDidRemoveLastListener:()=>{f.cancel()}}),$=this.a.readFileStream(a,w,f.token);return(0,R.$He)($,{onData:b=>m.fire(k.$Pe.wrap(b)),onError:b=>m.fire(b),onEnd:()=>{m.fire("end"),m.dispose(),f.dispose()}}),m.event}n(v,h,w,a){const f=this.f(v,h);return this.a.writeFile(f,w.buffer,a)}r(v,h,w){const a=this.f(v,h,!0);return this.a.open(a,w)}s(v){return this.a.close(v)}async t(v,h,w){const a=k.$Pe.alloc(w),m=await this.a.read(v,h,a.buffer,0,w);return[a,m]}u(v,h,w,a,f){return this.a.write(v,h,w.buffer,a,f)}w(v,h){const w=this.f(v,h);return this.a.mkdir(w)}y(v,h,w){const a=this.f(v,h);return this.a.delete(a,w)}z(v,h,w,a){const f=this.f(v,h),m=this.f(v,w);return this.a.rename(f,m,a)}C(v,h,w,a){const f=this.f(v,h),m=this.f(v,w);return this.a.copy(f,m,a)}D(v,h,w){const a=this.f(v,h),f=this.f(v,w);return this.a.cloneFile(a,f)}H(v,h){const w=new n.$ne({onWillAddFirstListener:()=>{this.F.set(h,this.L(v,w))},onDidRemoveLastListener:()=>{(0,E.$Sc)(this.F.get(h)),this.F.delete(h)}});return w.event}async I(v,h,w,a,f){const m=this.F.get(h);if(m){const $=this.f(v,a),b=m.watch(w,$,f);this.G.set(h+w,b)}}async J(v,h){const w=v+h,a=this.G.get(w);a&&((0,E.$Sc)(a),this.G.delete(w))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$2s=y;class o extends E.$Xc{constructor(v,h,w,a){super(),this.c=v,this.f=w,this.g=a,this.a=new Map,this.b=this.B(new r.$rr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(h)}h(v){const h=this.B(new n.$ne);this.B(h.event(w=>{v.fire(w.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile(w=>h.fire(w))),this.B(this.b.onDidWatchError(w=>v.fire(w)))}j(v){}m(v){}watch(v,h,w){const a=this.m(this.g);return Array.isArray(a)&&(w.excludes=[...w.excludes,...a]),this.a.set(v,this.b.watch(h,w)),(0,E.$Vc)(()=>{(0,E.$Sc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$3s=o}),define(ve[124],Se([1,0,4,6,12,2]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=void 0;class R extends E.$lk{constructor(v,h,w,a,f){super(h,w,a),this.r=v,this.t=f,this.B(f.listen("onDidChangeLogLevel",v)(m=>{(0,E.$ck)(m)?super.setLogLevel(m):super.setLogLevel(n.URI.revive(m[0]),m[1])})),this.B(f.listen("onDidChangeVisibility",v)(([m,$])=>super.setVisibility(n.URI.revive(m),$))),this.B(f.listen("onDidChangeLoggers",v)(({added:m,removed:$})=>{for(const b of m)super.registerLogger({...b,resource:n.URI.revive(b.resource)});for(const b of $)super.deregisterLogger(b.resource)}))}createConsoleMainLogger(){return new E.$jk({log:(v,h)=>{this.t.call("consoleLog",[v,h])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,h){super.setLogLevel(v,h),this.t.call("setLogLevel",[v,h])}setVisibility(v,h){super.setVisibility(v,h),this.t.call("setVisibility",[this.n(v),h])}s(v,h,w){return new A(this.t,v,h,w,this.r)}static setLogLevel(v,h,w){return v.call("setLogLevel",[h,w])}}e.$rs=R;class A extends E.$gk{constructor(v,h,w,a,f){super(a?.logLevel==="always"),this.r=v,this.s=h,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[h,a,f]).then(()=>{this.u(this.n),this.m=!0})}g(v,h){const w=[[v,h]];this.m?this.u(w):this.n.push(...w)}u(v){this.r.call("log",[this.s,v])}}class y{constructor(v,h){this.a=v,this.b=h}listen(v,h){const w=this.b(v);switch(h){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(f=>this.c(f,w)),removed:[...a.removed].map(f=>this.c(f,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,a=>[w.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$ck)(a)?a:[w.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${h}`)}async call(v,h,w){const a=this.b(v);switch(h){case"setLogLevel":return(0,E.$ck)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(a.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,a)))}throw new Error(`Call not found: ${h}`)}c(v,h){return{...v,resource:h.transformOutgoingURI(v.resource)}}}e.$ss=y;class o extends k.$Xc{constructor(v,h){super(),h.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(w=>h.call("setLogLevel",[w]))),h.call("getRegisteredLoggers").then(w=>{for(const a of w)v.registerLogger({...a,resource:n.URI.revive(a.resource)})}),this.B(h.listen("onDidChangeVisibility")(([w,a])=>v.setVisibility(n.URI.revive(w),a))),this.B(h.listen("onDidChangeLoggers")(({added:w,removed:a})=>{for(const f of w)v.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of a)v.deregisterLogger(f.resource)}))}}e.$ts=o}),define(ve[125],Se([1,0,2,12]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class E extends n.$Xc{constructor(R,A=[]){super(),this.a=new r.$kk([R,...A]),this.B(R.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.$oR=E}),define(ve[260],Se([1,0,16,12]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var E;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(E||(E={}));async function k(o,D,v,h,w){try{const a=await new Promise((m,$)=>{se(["@vscode/spdlog"],m,$)}).then(qe);a.setFlushOn(E.Trace);const f=await a.createAsyncRotatingLogger(o,D,v,h);return w?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(a){console.error(a)}return null}function R(o,D,v){switch(D){case r.LogLevel.Trace:o.trace(v);break;case r.LogLevel.Debug:o.debug(v);break;case r.LogLevel.Info:o.info(v);break;case r.LogLevel.Warning:o.warn(v);break;case r.LogLevel.Error:o.error(v);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function A(o,D){switch(D){case r.LogLevel.Trace:o.setLevel(E.Trace);break;case r.LogLevel.Debug:o.setLevel(E.Debug);break;case r.LogLevel.Info:o.setLevel(E.Info);break;case r.LogLevel.Warning:o.setLevel(E.Warning);break;case r.LogLevel.Error:o.setLevel(E.Error);break;case r.LogLevel.Off:o.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class y extends r.$gk{constructor(D,v,h,w,a){super(),this.m=[],this.setLevel(a),this.n=this.s(D,v,h,w),this.B(this.onDidChangeLogLevel(f=>{this.r&&A(this.r,f)}))}async s(D,v,h,w){const a=h?6:1,f=30/a*n.$Il.MB,m=await k(D,v,f,a,w);if(m){this.r=m,A(this.r,this.getLevel());for(const{level:$,message:b}of this.m)R(this.r,$,b);this.m=[]}}g(D,v){this.r?R(this.r,D,v):this.getLevel()<=D&&this.m.push({level:D,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=y}),define(ve[126],Se([1,0,23,12,260]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class k extends r.$lk{s(A,y,o){return new E.$dR((0,n.$3g)(),A.fsPath,!o?.donotRotate,!!o?.donotUseFormatters,y)}}e.$eR=k});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[261],Se([1,0,58,221,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,n=mt(n);var k;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(y){function o(a,f){return f-a}y.compare=o;const D=Object.create(null);D[y.Error]=(0,r.localize)(0,null),D[y.Warning]=(0,r.localize)(1,null),D[y.Info]=(0,r.localize)(2,null);function v(a){return D[a]||""}y.toString=v;function h(a){switch(a){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=h;function w(a){switch(a){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=w}(R||(e.MarkerSeverity=R={}));var A;(function(y){const o="";function D(h){return v(h,!0)}y.makeKey=D;function v(h,w){const a=[o];return h.source?a.push(h.source.replace("\xA6","\\\xA6")):a.push(o),h.code?typeof h.code=="string"?a.push(h.code.replace("\xA6","\\\xA6")):a.push(h.code.value.replace("\xA6","\\\xA6")):a.push(o),h.severity!==void 0&&h.severity!==null?a.push(R.toString(h.severity)):a.push(o),h.message&&w?a.push(h.message.replace("\xA6","\\\xA6")):a.push(o),h.startLineNumber!==void 0&&h.startLineNumber!==null?a.push(h.startLineNumber.toString()):a.push(o),h.startColumn!==void 0&&h.startColumn!==null?a.push(h.startColumn.toString()):a.push(o),h.endLineNumber!==void 0&&h.endLineNumber!==null?a.push(h.endLineNumber.toString()):a.push(o),h.endColumn!==void 0&&h.endColumn!==null?a.push(h.endColumn.toString()):a.push(o),a.push(o),a.join("\xA6")}y.makeKeyOptionalMessage=v})(A||(e.IMarkerData=A={})),e.$Du=(0,E.$Gi)("markerService")}),define(ve[73],Se([1,0,6,40,2,5]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,k.$Gi)("policy");class R extends E.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ne),this.onDidChange=this.h.event}async updatePolicyDefinitions(o){const D=Object.keys(this.f).length;return this.f={...o,...this.f},D!==Object.keys(this.f).length&&await this.j(o),r.Iterable.reduce(this.g.entries(),(v,[h,w])=>({...v,[h]:w}),{})}getPolicyValue(o){return this.g.get(o)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(o,[D,v])=>({...o,[D]:{definition:v,value:this.g.get(D)}}),{})}}e.$uo=R;class A{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=A}),define(ve[62],Se([1,0,33]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const k=E.context.configuration();if(k)r=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:k.version})}}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.91.0",sha256:"53b99146c7fa280f00c74414e09721530c622bf3e5eac2c967ddfb9906b51c80",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.91.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.91.1",commit:"1962f48b7f71772dc2c060dbaa5a6b4c0792a549",date:"2024-07-20T15:19:11.900Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ve[29],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,n.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(ve[262],Se([1,0,14,19,2,5]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,k.$Gi)("progressService");var R;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$ww=A;class y{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const w=this.d;this.d=()=>{w?.(),h()}}):Promise.resolve()}}e.$xw=y;let o=class extends E.$Xc{constructor(h,w){super(),this.a=new n.$4h,w.withProgress(h,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,E.$Vc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$yw=o,e.$yw=o=Be([je(1,e.$uw)],o);class D extends E.$Xc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new E.$Wc)}start(h){this.stop();const w=++this.a,a=new r.$ye;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,E.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,E.$Vc)(()=>a.cancel())),this.b.add((0,E.$Vc)(()=>this.c?this.c.done():void 0)),{id:w,token:a.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$zw=D,e.$Aw=(0,k.$Gi)("editorProgressService")}),define(ve[38],Se([1,0,106,11]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,n=qe(n),r=qe(r);class E{constructor(){this.a=new Map}add(R,A){n.ok(r.$gg(R)),n.ok(r.$ig(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ro=new E}),define(ve[127],Se([1,0,6,38]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,r=qe(r),e.$so={JSONContribution:"base.contributions.json"};function E(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class k{constructor(){this.b=new n.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,o){this.a[E(y)]=o,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const R=new k;r.$ro.add(e.$so.JSONContribution,R)}),define(ve[46],Se([1,0,18,6,11,202,27,127,38]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=f,e.$Io=m,e.$Jo=$,e.$Ko=d,e.$Lo=p,E=qe(E),k=qe(k);var o;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$wo={Configuration:"base.contributions.configuration"};var D;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const v=y.$ro.as(A.$so.JSONContribution);class h{constructor(){this.h=new Set,this.i=new r.$ne,this.onDidSchemaChange=this.i.event,this.j=new r.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Do,this.g),this.v()}registerConfiguration(l,i=!0){this.registerConfigurations([l],i)}registerConfigurations(l,i=!0){const g=new Set;this.n(l,i,g),v.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(l){const i=new Set;this.o(l,i),v.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:l,remove:i}){const g=new Set;this.o(i,g),this.n(l,!1,g),v.registerSchema(e.$Do,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(l){const i=new Set;this.k(l,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(l,i){const g=[];for(const{overrides:s,source:c}of l)for(const u in s)if(i.add(u),e.$Go.test(u)){const S=this.a.get(u),P=S?.valuesSources??new Map,C=S?.value||{};for(const I of Object.keys(s[u])){const q=s[u][I];if(E.$ig(q)&&(E.$ng(C[I])||E.$ig(C[I]))){if(C[I]={...C[I]??{},...q},c){let Q=P.get(I);if(Q||(Q=new Map,P.set(I,Q)),!(Q instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const re in q)Q.set(re,c)}}else C[I]=q,c&&P.set(I,c)}this.a.set(u,{source:c,value:C,valuesSources:P});const L=(0,R.$kj)(u),T={type:"object",default:C,description:k.localize(1,null,L),$ref:e.$Do,defaultDefaultValue:C,source:E.$gg(c)?void 0:c,defaultValueSource:c};g.push(...f(u)),this.d[u]=T,this.b.properties[u]=T}else{const S=this.d[u],P=this.a.get(u);let C=P?.value??S?.defaultDefaultValue,L=s[u],T=c;if(E.$ig(L)&&(S!==void 0&&S.type==="object"||S===void 0&&(E.$ng(C)||E.$ig(C)))){if(E.$ig(C)||(C={}),L={...C,...L},T=P?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const q in s[u])c?T.set(q,c):T.delete(q)}this.a.set(u,{value:L,source:T}),S&&(this.w(u,S),this.r(u,S))}this.m(g)}deregisterDefaultConfigurations(l){const i=new Set;this.l(l,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(l,i){for(const{overrides:g,source:s}of l)for(const c in g){const u=E.$gg(s)?s:s?.id,S=this.a.get(c);if(S){if(e.$Go.test(c)){for(const C of Object.keys(g[c])){const L=g[c][C];if(E.$ig(L)){const T=S.valuesSources?.get(C);for(const I of Object.keys(L)){const q=T?.get(I);(E.$gg(q)?q:q?.id)===u&&(T?.delete(I),delete S.value[C][I])}Object.keys(S.value[C]).length===0&&(delete S.value[C],S.valuesSources?.delete(C))}else{const T=S.valuesSources?.get(C);(E.$gg(T)?T:T?.id)===u&&(S.valuesSources?.delete(C),delete S.value[C])}}const P=this.a.get(c);P&&Object.keys(P.value).length===0&&(this.a.delete(c),delete this.d[c],delete this.b.properties[c])}else{if(S.source instanceof Map){const C=S.source;for(const L in g[c]){const T=C.get(L);(E.$gg(T)?T:T?.id)===u&&(C.delete(L),delete S.value[L])}C.size===0&&this.a.delete(c)}else{const C=E.$gg(S.source)?S.source:S.source?.id;if(u!==C)continue;this.a.delete(c)}const P=this.d[c];P&&(this.w(c,P),this.r(c,P))}i.add(c)}}this.u()}deltaConfiguration(l){let i=!1;const g=new Set;l.removedDefaults&&(this.l(l.removedDefaults,g),i=!0),l.addedDefaults&&(this.k(l.addedDefaults,g),i=!0),l.removedConfigurations&&this.o(l.removedConfigurations,g),l.addedConfigurations&&this.n(l.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...l){this.i.fire()}registerOverrideIdentifiers(l){this.m(l),this.i.fire()}m(l){for(const i of l)this.h.add(i);this.u()}n(l,i,g){l.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,g),this.c.push(s),this.q(s)})}o(l,i){const g=s=>{if(s.properties)for(const c in s.properties){i.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,s.properties[c])}s.allOf?.forEach(c=>g(c))};for(const s of l){g(s);const c=this.c.indexOf(s);c!==-1&&this.c.splice(c,1)}}p(l,i=!0,g,s,c=D.WINDOW,u){c=E.$pg(l.scope)?c:l.scope;const S=l.properties;if(S)for(const C in S){const L=S[C];if(i&&d(C,L)){delete S[C];continue}if(L.source=g,L.defaultDefaultValue=S[C].default,this.w(C,L),e.$Go.test(C)?L.scope=void 0:(L.scope=E.$pg(L.scope)?c:L.scope,L.restricted=E.$pg(L.restricted)?!!s?.includes(C):L.restricted),S[C].hasOwnProperty("included")&&!S[C].included){this.f[C]=S[C],delete S[C];continue}else this.d[C]=S[C],S[C].policy?.name&&this.e.set(S[C].policy.name,C);!S[C].deprecationMessage&&S[C].markdownDeprecationMessage&&(S[C].deprecationMessage=S[C].markdownDeprecationMessage),u.add(C)}const P=l.allOf;if(P)for(const C of P)this.p(C,i,g,s,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(l){const i=g=>{const s=g.properties;if(s)for(const u in s)this.r(u,s[u]);g.allOf?.forEach(i)};i(l)}r(l,i){switch(e.$xo.properties[l]=i,i.scope){case D.APPLICATION:e.$yo.properties[l]=i;break;case D.MACHINE:e.$zo.properties[l]=i;break;case D.MACHINE_OVERRIDABLE:e.$Ao.properties[l]=i;break;case D.WINDOW:e.$Bo.properties[l]=i;break;case D.RESOURCE:e.$Co.properties[l]=i;break;case D.LANGUAGE_OVERRIDABLE:e.$Co.properties[l]=i,this.g.properties[l]=i;break}}s(l,i){switch(delete e.$xo.properties[l],i.scope){case D.APPLICATION:delete e.$yo.properties[l];break;case D.MACHINE:delete e.$zo.properties[l];break;case D.MACHINE_OVERRIDABLE:delete e.$Ao.properties[l];break;case D.WINDOW:delete e.$Bo.properties[l];break;case D.RESOURCE:case D.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[l],delete this.g.properties[l];break}}u(){for(const l of this.h.values()){const i=`[${l}]`,g={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$Do};this.w(i,g),e.$xo.properties[i]=g,e.$yo.properties[i]=g,e.$zo.properties[i]=g,e.$Ao.properties[i]=g,e.$Bo.properties[i]=g,e.$Co.properties[i]=g}}v(){const l={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=l,e.$yo.patternProperties[e.$Fo]=l,e.$zo.patternProperties[e.$Fo]=l,e.$Ao.patternProperties[e.$Fo]=l,e.$Bo.patternProperties[e.$Fo]=l,e.$Co.patternProperties[e.$Fo]=l,this.i.fire()}w(l,i){const g=this.a.get(l);let s=g?.value,c=g?.source;E.$ng(s)&&(s=i.defaultDefaultValue,c=void 0),E.$ng(s)&&(s=$(i.type)),i.default=s,i.defaultValueSource=c}}const w="\\[([^\\]]+)\\]",a=new RegExp(w,"g");e.$Fo=`^(${w})+$`,e.$Go=new RegExp(e.$Fo);function f(t){const l=[];if(e.$Go.test(t)){let i=a.exec(t);for(;i?.length;){const g=i[1].trim();g&&l.push(g),i=a.exec(t)}}return(0,n.$Pb)(l)}function m(t){return t.reduce((l,i)=>`${l}[${i}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const b=new h;y.$ro.add(e.$wo.Configuration,b);function d(t,l){return t.trim()?e.$Go.test(t)?k.localize(7,null,t):b.getConfigurationProperties()[t]!==void 0?k.localize(8,null,t):l.policy?.name&&b.getPolicyConfigurations().get(l.policy?.name)!==void 0?k.localize(9,null,t,l.policy?.name,b.getPolicyConfigurations().get(l.policy?.name)):null:k.localize(6,null)}function p(){const t=[],l=b.getConfigurationProperties();for(const i of Object.keys(l))t.push([i,l[i].scope]);return t.push(["launch",D.RESOURCE]),t.push(["task",D.RESOURCE]),t}}),define(ve[128],Se([1,0,18,6,43,2,26,21,11,4,27,46,16,38]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=p,n=qe(n),E=qe(E),A=qe(A),y=qe(y);function a(g){return Object.isFrozen(g)?g:A.$fo(g)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,c,u,S,P){this.b=s,this.c=c,this.d=u,this.raw=S,this.f=P,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof f)return c;const u=new m("",this.f);return u.parseRaw(c),u.configurationModel});this.g=s.reduce((c,u)=>u===c?u:c.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,D.$ij)(this.contents,s):this.contents}inspect(s,c){const u=this;return{get value(){return a(u.rawConfiguration.getValue(s))},get override(){return c?a(u.rawConfiguration.getOverrideValue(s,c)):void 0},get merged(){return a(c?u.rawConfiguration.override(c).getValue(s):u.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:P,identifiers:C,keys:L}of u.rawConfiguration.overrides){const T=new f(P,L,[],void 0,u.f).getValue(s);T!==void 0&&S.push({identifiers:C,value:T})}return S.length?a(S):void 0}}}getOverrideValue(s,c){const u=this.j(c);return u?s?(0,D.$ij)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const u of this.overrides)u.identifiers.includes(s)&&c.push(...u.keys);return n.$Pb(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return n.$Pb(s)}override(s){let c=this.a.get(s);return c||(c=this.h(s),this.a.set(s,c)),c}merge(...s){const c=A.$eo(this.contents),u=A.$eo(this.overrides),S=[...this.keys],P=this.raw?.length?[...this.raw]:[this];for(const C of s)if(P.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(c,C.contents);for(const L of C.overrides){const[T]=u.filter(I=>n.$xb(I.identifiers,L.identifiers));T?(this.i(T.contents,L.contents),T.keys.push(...L.keys),T.keys=n.$Pb(T.keys)):u.push(A.$eo(L))}for(const L of C.keys)S.indexOf(L)===-1&&S.push(L)}return new f(c,S,u,P.every(C=>C instanceof f)?void 0:P,this.f)}h(s){const c=this.j(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const S of n.$Pb([...Object.keys(this.contents),...Object.keys(c)])){let P=this.contents[S];const C=c[S];C&&(typeof P=="object"&&typeof C=="object"?(P=A.$eo(P),this.i(P,C)):P=C),u[S]=P}return new f(u,this.keys,this.overrides,void 0,this.f)}i(s,c){for(const u of Object.keys(c)){if(u in s&&y.$ig(s[u])&&y.$ig(c[u])){this.i(s[u],c[u]);continue}s[u]=A.$eo(c[u])}}j(s){let c=null,u=null;const S=P=>{P&&(u?this.i(u,P):u=A.$eo(P))};for(const P of this.overrides)P.identifiers.length===1&&P.identifiers[0]===s?c=P.contents:P.identifiers.includes(s)&&S(P.contents);return S(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.k(s,c,!0)}setValue(s,c){this.k(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,D.$hj)(this.contents,s),v.$Go.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>n.$xb(u.identifiers,(0,v.$Ho)(s))),1))}k(s,c,u){(0,D.$gj)(this.contents,s,c,S=>this.f.error(S)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),v.$Go.test(s)&&this.overrides.push({identifiers:(0,v.$Ho)(s),keys:Object.keys(this.contents[s]),contents:(0,D.$fj)(this.contents[s],S=>this.f.error(S))})}}e.$Mo=f;class m{constructor(s,c){this.f=s,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!y.$pg(s)){const u=this.h(s);this.parseRaw(u,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:u,keys:S,overrides:P,restricted:C,hasExcludedProperties:L}=this.i(s,c);this.b=new f(u,S,P,L?[s]:void 0,this.g),this.c=C||[]}h(s){let c={},u=null,S=[];const P=[],C=[];function L(I){Array.isArray(S)?S.push(I):u!==null&&(S[u]=I)}const T={onObjectBegin:()=>{const I={};L(I),P.push(S),S=I,u=null},onObjectProperty:I=>{u=I},onObjectEnd:()=>{S=P.pop()},onArrayBegin:()=>{const I=[];L(I),P.push(S),S=I,u=null},onArrayEnd:()=>{S=P.pop()},onLiteralValue:L,onError:(I,q,Y)=>{C.push({error:I,offset:q,length:Y})}};if(s)try{E.$6n(s,T),c=S[0]||{}}catch(I){this.g.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return c}i(s,c){const u=w.$ro.as(v.$wo.Configuration).getConfigurationProperties(),S=this.j(s,u,!0,c);s=S.raw;const P=(0,D.$fj)(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`)),C=Object.keys(s),L=this.l(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:P,keys:C,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,c,u,S){let P=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:P};const C={},L=[];for(const T in s)if(v.$Go.test(T)&&u){const I=this.j(s[T],c,!1,S);C[T]=I.raw,P=P||I.hasExcludedProperties,L.push(...I.restricted)}else{const I=c[T],q=I?typeof I.scope<"u"?I.scope:v.ConfigurationScope.WINDOW:void 0;I?.restricted&&L.push(T),!S.exclude?.includes(T)&&(S.include?.includes(T)||(q===void 0||S.scopes===void 0||S.scopes.includes(q))&&!(S.skipRestricted&&I?.restricted))?C[T]=s[T]:P=!0}return{raw:C,restricted:L,hasExcludedProperties:P}}l(s,c){const u=[];for(const S of Object.keys(s))if(v.$Go.test(S)){const P={};for(const C in s[S])P[C]=s[S][C];u.push({identifiers:(0,v.$Ho)(S),keys:Object.keys(P),contents:(0,D.$fj)(P,c)})}return u}}e.$No=m;class $ extends k.$Xc{constructor(s,c,u,S,P){super(),this.c=s,this.f=c,this.g=S,this.h=P,this.b=this.B(new r.$ne),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),P),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(h.FileOperation.CREATE)||C.isOperation(h.FileOperation.COPY)||C.isOperation(h.FileOperation.DELETE)||C.isOperation(h.FileOperation.WRITE))&&u.isEqual(C.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=$;class b{constructor(s,c,u,S,P,C,L,T,I,q,Y,Q,re){this.a=s,this.b=c,this.c=u,this.overrideIdentifiers=S,this.d=P,this.f=C,this.g=L,this.h=T,this.i=I,this.j=q,this.k=Y,this.l=Q,this.m=re}get value(){return a(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(s,c,u,S,P,C,L,T,I,q){this.j=s,this.l=c,this.m=u,this.n=S,this.p=P,this.q=C,this.r=L,this.s=T,this.t=I,this.u=q,this.h=null,this.i=new R.$Dc,this.v=null}getValue(s,c,u){return this.w(s,c,u).getValue(s)}updateValue(s,c,u={}){let S;u.resource?(S=this.t.get(u.resource),S||(S=f.createEmptyModel(this.u),this.t.set(u.resource,S))):S=this.s,c===void 0?S.removeValue(s):S.setValue(s,c),u.resource||(this.h=null)}inspect(s,c,u){const S=this.w(s,c,u),P=this.A(c.resource,u),C=c.resource?this.t.get(c.resource)||this.s:this.s,L=new Set;for(const T of S.overrides)for(const I of T.identifiers)S.getOverrideValue(s,I)!==void 0&&L.add(I);return new b(s,c,S.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,P||void 0,C)}keys(s){const c=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,c){this.r.set(s,c),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const u=[];if(!c){const{added:S,updated:P,removed:C}=l(this.j,s);c=[...S,...P,...C]}for(const S of c)for(const P of(0,v.$Ho)(S)){const C=this.j.getKeysForOverrideIdentifier(P),L=s.getKeysForOverrideIdentifier(P),T=[...L.filter(I=>C.indexOf(I)===-1),...C.filter(I=>L.indexOf(I)===-1),...C.filter(I=>!A.$io(this.j.override(P).getValue(I),s.override(P).getValue(I)))];u.push([P,T])}return this.updateDefaultConfiguration(s),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:u,removed:S}=l(this.l,s),P=[...c,...u,...S];return P.length&&this.updatePolicyConfiguration(s),{keys:P,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:u,removed:S,overrides:P}=l(this.applicationConfiguration,s),C=[...c,...u,...S];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:P}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:u,removed:S,overrides:P}=l(this.localUserConfiguration,s),C=[...c,...u,...S];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:P}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:u,removed:S,overrides:P}=l(this.remoteUserConfiguration,s),C=[...c,...u,...S];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:P}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:u,removed:S,overrides:P}=l(this.workspaceConfiguration,s),C=[...c,...u,...S];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:P}}compareAndUpdateFolderConfiguration(s,c){const u=this.folderConfigurations.get(s),{added:S,updated:P,removed:C,overrides:L}=l(u,c),T=[...S,...P,...C];return(T.length||!u)&&this.updateFolderConfiguration(s,c),{keys:T,overrides:L}}compareAndDeleteFolderConfiguration(s){const c=this.folderConfigurations.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:S,removed:P,overrides:C}=l(c,void 0);return{keys:[...u,...S,...P],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,c,u){let S=this.x(c,u);return c.overrideIdentifier&&(S=S.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},c){let u=this.y();if(c&&s){const S=c.getFolder(s);S&&(u=this.z(S.uri)||u);const P=this.t.get(s);P&&(u=u.merge(P))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let c=this.i.get(s);if(!c){const u=this.y(),S=this.r.get(s);S?(c=u.merge(S),this.i.set(s,c)):c=u}return c}A(s,c){if(c&&s){const u=c.getFolder(s);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,c)=>{const{contents:u,overrides:S,keys:P}=this.r.get(c);return s.push([c,{contents:u,overrides:S,keys:P}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.q.keys.forEach(c=>s.add(c)),this.r.forEach(c=>c.keys.forEach(u=>s.add(u))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}D(s){const c=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.q.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(S=>c.add(S))),[...c.values()]}static parse(s,c){const u=this.E(s.defaults,c),S=this.E(s.policy,c),P=this.E(s.application,c),C=this.E(s.user,c),L=this.E(s.workspace,c),T=s.folders.reduce((I,q)=>(I.set(o.URI.revive(q[0]),this.E(q[1],c)),I),new R.$Dc);return new d(u,S,P,C,f.createEmptyModel(c),L,T,f.createEmptyModel(c),new R.$Dc,c)}static E(s,c){return new f(s.contents,s.keys,s.overrides,void 0,c)}}e.$Po=d;function p(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const s=new Set,c=new Map;for(const S of g)S.keys.forEach(P=>s.add(P)),S.overrides.forEach(([P,C])=>{const L=(0,R.$Ac)(c,P,new Set);C.forEach(T=>L.add(T))});const u=[];return c.forEach((S,P)=>u.push([P,[...S.values()]])),{keys:[...s.values()],overrides:u}}class t{constructor(s,c,u,S,P){this.change=s,this.f=c,this.g=u,this.h=S,this.i=P,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of s.keys)this.affectedKeys.add(C);for(const[,C]of s.overrides)for(const L of C)this.affectedKeys.add(L);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,c){const u=this.a+s,S=this.d.indexOf(u);if(S<0)return!1;const P=S+u.length;if(P>=this.d.length)return!1;const C=this.d.charCodeAt(P);if(C!==this.b&&C!==this.c)return!1;if(c){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,T=this.g.getValue(s,c,this.h);return!A.$io(L,T)}return!0}}e.$Ro=t;function l(g,s){const{added:c,removed:u,updated:S}=i(s?.rawConfiguration,g?.rawConfiguration),P=[],C=g?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const T=L.filter(I=>!C.includes(I));for(const I of T)P.push([I,s.getKeysForOverrideIdentifier(I)])}if(g){const T=C.filter(I=>!L.includes(I));for(const I of T)P.push([I,g.getKeysForOverrideIdentifier(I)])}if(s&&g){for(const T of C)if(L.includes(T)){const I=i({contents:g.getOverrideValue(void 0,T)||{},keys:g.getKeysForOverrideIdentifier(T)},{contents:s.getOverrideValue(void 0,T)||{},keys:s.getKeysForOverrideIdentifier(T)});P.push([T,[...I.added,...I.removed,...I.updated]])}}return{added:c,removed:u,updated:S,overrides:P}}function i(g,s){const c=g?s?g.keys.filter(P=>s.keys.indexOf(P)===-1):[...g.keys]:[],u=s?g?s.keys.filter(P=>g.keys.indexOf(P)===-1):[...s.keys]:[],S=[];if(g&&s){for(const P of s.keys)if(g.keys.indexOf(P)!==-1){const C=(0,D.$ij)(s.contents,P),L=(0,D.$ij)(g.contents,P);A.$io(C,L)||S.push(P)}}return{added:c,removed:u,updated:S}}}),define(ve[263],Se([1,0,18,6,2,21,11,128,46,12,73,38]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class h extends E.$Xc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new r.$ne),this.onDidChangeConfiguration=this.a.event,this.b=A.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$ro.as(y.$wo.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:$})=>this.f(Array.from(m),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,$){this.j(m,v.$ro.as(y.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=A.$Mo.createEmptyModel(this.c);const m=v.$ro.as(y.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,$){const b=this.g();for(const d of m){const p=b[d],t=$[d];p!==void 0?this.b.addValue(d,p):t?this.b.addValue(d,t.default):this.b.removeValue(d)}}}e.$So=h;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=A.$Mo.createEmptyModel(new o.$nk)}async initialize(){return this.configurationModel}}e.$To=w;let a=class extends E.$Xc{get configurationModel(){return this.b}constructor(m,$,b){super(),this.c=m,this.f=$,this.g=b,this.a=this.B(new r.$ne),this.onDidChangeConfiguration=this.a.event,this.b=A.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const $={},b=[],d=v.$ro.as(y.$wo.Configuration).getConfigurationProperties();for(const p of m){const t=d[p];if(!t){b.push(p);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}b.push(p),$[t.policy.name]={type:t.type}}}return(0,R.$tg)($)||await this.f.updatePolicyDefinitions($),b}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const $=v.$ro.as(y.$wo.Configuration).getPolicyConfigurations(),b=(0,n.$Kb)(m.map(d=>$.get(d)));this.m(b,!0)}m(m,$){this.g.trace("PolicyConfiguration#update",m);const b=v.$ro.as(y.$wo.Configuration).getConfigurationProperties(),d=[],p=this.b.isEmpty();for(const t of m){const l=b[t]?.policy?.name;if(l){const i=this.f.getPolicyValue(l);(p?i!==void 0:!(0,k.$io)(this.b.getValue(t),i))&&d.push([t,i])}else this.b.getValue(t)!==void 0&&d.push([t,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const t=this.b;this.b=A.$Mo.createEmptyModel(this.g);for(const l of t.keys)this.b.setValue(l,t.getValue(l));for(const[l,i]of d)i===void 0?this.b.removeValue(l):this.b.setValue(l,i);$&&this.a.fire(this.b)}}};e.$Uo=a,e.$Uo=a=Be([je(1,D.$to),je(2,o.$ak)],a)}),define(ve[129],Se([1,0,18,14,15,6,43,160,2,26,21,3,20,27,128,46,263,16,73]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class d extends y.$Xc{constructor(l,i,g,s){super(),this.m=l,this.n=s,this.h=this.B(new k.$ne),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$So(s)),this.c=g instanceof b.$vo?new m.$To:this.B(new m.$Uo(this.b,g,s)),this.f=this.B(new a.$Oo(this.m,{},h.$$g,i,s)),this.a=new a.$Po(this.b.configurationModel,this.c.configurationModel,a.$Mo.createEmptyModel(s),a.$Mo.createEmptyModel(s),a.$Mo.createEmptyModel(s),a.$Mo.createEmptyModel(s),new o.$Dc,a.$Mo.createEmptyModel(s),new o.$Dc,s),this.j=new p(l,i,this),this.g=this.B(new r.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.s(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,i,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Po(l,i,a.$Mo.createEmptyModel(this.n),g,a.$Mo.createEmptyModel(this.n),a.$Mo.createEmptyModel(this.n),new o.$Dc,a.$Mo.createEmptyModel(this.n),new o.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,i){const g=typeof l=="string"?l:void 0,s=(0,w.$bj)(l)?l:(0,w.$bj)(i)?i:{};return this.a.getValue(g,s,void 0)}async updateValue(l,i,g,s,c){const u=(0,w.$cj)(g)?g:(0,w.$bj)(g)?{resource:g.resource,overrideIdentifiers:g.overrideIdentifier?[g.overrideIdentifier]:void 0}:void 0,S=u?s:g;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${S}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.$Pb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const P=this.inspect(l,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(P.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,D.$io)(i,P.defaultValue)&&(i=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const L=u.overrideIdentifiers.sort(),T=this.a.localUserConfiguration.overrides.find(I=>(0,n.$xb)([...I.identifiers].sort(),L));T&&(u.overrideIdentifiers=T.identifiers)}const C=u?.overrideIdentifiers?.length?[(0,f.$Io)(u.overrideIdentifiers),l]:[l];await this.j.write(C,i),await this.reloadConfiguration()}inspect(l,i={}){return this.a.inspect(l,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const i=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(g,i,w.ConfigurationTarget.USER)}s(l,i){const g=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(l,i);this.u(s,g,w.ConfigurationTarget.DEFAULT)}t(l){const i=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(l);this.u(g,i,w.ConfigurationTarget.DEFAULT)}u(l,i,g){const s=new a.$Ro(l,{data:i},this.a,void 0,this.n);s.source=g,this.h.fire(s)}}e.$Vo=d;class p{constructor(l,i,g){this.b=l,this.c=i,this.d=g,this.a=new r.$Nh}write(l,i){return this.a.queue(()=>this.e(l,i))}async e(l,i){let g;try{g=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)g="{}";else throw u}const s=[];if((0,R.$Yn)(g,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(g,l,i);g=(0,A.$do)(g,c),await this.c.writeFile(this.b,E.$Pe.fromString(g))}f(l,i,g){const{tabSize:s,insertSpaces:c,eol:u}=this.h;if(!i.length){const S=JSON.stringify(g,null,c?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,A.$ao)(l,i,g,{tabSize:s,insertSpaces:c,eol:u})}get h(){if(!this.g){let l=v.OS===v.OperatingSystem.Linux||v.OS===v.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(l=i),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ve[90],Se([1,0,10,5]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=o,e.$Rl=(0,r.$Gi)("remoteAuthorityResolverService");var E;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class k{constructor(v){this.id=v,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=k;class R{constructor(v,h){this.host=v,this.port=h,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=R;var A;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class y extends n.$eb{static isNotAvailable(v){return v instanceof y&&v._code===A.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof y&&v._code===A.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof y&&v._code===A.NoResolverFound}static isInvalidAuthority(v){return v instanceof y&&v._code===A.InvalidAuthority}static isHandled(v){return v instanceof y&&v.isHandled}constructor(v,h=A.Unknown,w){super(v),this._message=v,this._code=h,this._detail=w,this.isHandled=h===A.NotAvailable&&w===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Ul=y;function o(D){const v=D.indexOf("+");return v===-1?D:D.substring(0,v)}}),define(ve[264],Se([1,0,14,15,19,10,6,2,13,44,48,23,61,90]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=P,e.$2l=C,e.$3l=T,o=qe(o);const a=30*1e3;var f;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function m(x){switch(x){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function $(x){const U=new E.$ye;return setTimeout(()=>U.cancel(),x),U.token}function b(x,U){if(x.isCancellationRequested||U.isCancellationRequested)return E.CancellationToken.Cancelled;const O=new E.$ye;return x.onCancellationRequested(()=>O.cancel()),U.onCancellationRequested(()=>O.cancel()),O.token}class d{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new A.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$zh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function p(x,U){const O=new d(U);return O.registerDisposable(x.onControlMessage(Z=>{const V=JSON.parse(Z.toString()),M=B(V);M?O.reject(M):O.resolve(V)})),O.promise}function t(x,U,O,Z,V,M,G,X){const F=new d(X),W=D.$he.create(!1);return x.info(`Creating a socket (${G})...`),o.mark(`code/willCreateSocket/${M}`),U.connect(O,Z,V,G).then(oe=>{F.didTimeout?(o.mark(`code/didCreateSocketError/${M}`),x.info(`Creating a socket (${G}) finished after ${W.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(o.mark(`code/didCreateSocketOK/${M}`),x.info(`Creating a socket (${G}) was successful after ${W.elapsed()} ms.`),F.resolve(oe))},oe=>{o.mark(`code/didCreateSocketError/${M}`),x.info(`Creating a socket (${G}) returned an error after ${W.elapsed()} ms.`),x.error(oe),F.reject(oe)}),F.promise}function l(x,U){const O=new d(U);return x.then(Z=>{O.didTimeout||O.resolve(Z)},Z=>{O.didTimeout||O.reject(Z)}),O.promise}async function i(x,U,O,Z){const V=H(x,U);x.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let M;try{M=await t(x.logService,x.remoteSocketFactoryService,x.connectTo,y.$Tg.getServerRootPath(),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${x.reconnectionToken}`,Z)}catch(oe){throw x.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),x.logService.error(oe),oe}x.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let G,X;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(M,null),G=x.reconnectionProtocol,X=!1):(G=new h.$ui({socket:M}),X=!0),x.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const F=await l(x.signService.createNewMessage((0,v.$3g)()),Z),W={type:"auth",auth:x.connectionToken||"00000000000000000000",data:F.data};G.sendControl(r.$Pe.fromString(JSON.stringify(W)));try{const oe=await p(G,b(Z,$(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(x.logService.trace(`${V} 4/6. received SignRequest control message.`),!await l(x.signService.validate(F,oe.signedData),Z)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const ke=await l(x.signService.sign(oe.data),Z),Ne={type:"connectionType",commit:x.commit,signedData:ke,desiredConnectionType:U};return O&&(Ne.args=O),x.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(r.$Pe.fromString(JSON.stringify(Ne))),{protocol:G,ownsProtocol:X}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(x.logService.error(`${V} the handshake timed out. Error:`),x.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${V} received error control message when negotiating connection. Error:`),x.logService.error(oe)),X&&z(G),oe}}async function g(x,U,O,Z){const V=Date.now(),M=H(x,U),{protocol:G,ownsProtocol:X}=await i(x,U,O,Z),F=new d(Z);return F.registerDisposable(G.onControlMessage(W=>{const oe=JSON.parse(W.toString()),he=B(oe);he?(x.logService.error(`${M} received error control message when negotiating connection. Error:`),x.logService.error(he),X&&z(G),F.reject(he)):(x.reconnectionProtocol?.endAcceptReconnection(),x.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${ce(V)}!`),F.resolve({protocol:G,firstMessage:oe}))})),F.promise}async function s(x,U){const{protocol:O}=await g(x,f.Management,void 0,U);return{protocol:O}}async function c(x,U,O){const{protocol:Z,firstMessage:V}=await g(x,f.ExtensionHost,U,O),M=V&&V.debugPort;return{protocol:Z,debugPort:M}}async function u(x,U,O){const Z=Date.now(),V=H(x,f.Tunnel),{protocol:M}=await i(x,f.Tunnel,U,O);return x.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ce(Z)}!`),M}async function S(x,U,O){const{connectTo:Z,connectionToken:V}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,connectTo:Z,connectionToken:V,reconnectionToken:U,reconnectionProtocol:O,remoteSocketFactoryService:x.remoteSocketFactoryService,signService:x.signService,logService:x.logService}}async function P(x,U,O){return L(x,async Z=>{const{protocol:V}=await s(Z,E.CancellationToken.None);return new J(x,U,O,Z.reconnectionToken,V)})}async function C(x,U){return L(x,async O=>{const{protocol:Z,debugPort:V}=await c(O,U,E.CancellationToken.None);return new ae(x,U,O.reconnectionToken,Z,V)})}async function L(x,U){for(let Z=1;;Z++)try{const V=(0,v.$3g)(),M=await S(x,V,null);return await U(M)}catch(V){if(Z<5)x.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),x.logService.error(V);else throw x.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),x.logService.error(V),de.triggerPermanentFailure(0,0,w.$Ul.isHandled(V)),V}}async function T(x,U,O){const Z=await S(x,(0,v.$3g)(),null);return await u(Z,{host:U,port:O},E.CancellationToken.None)}function I(x){return(0,n.$th)(U=>new Promise((O,Z)=>{const V=setTimeout(O,x*1e3);U.onCancellationRequested(()=>{clearTimeout(V),O()})}))}var q;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(q||(e.PersistentConnectionEventType=q={}));class Y{constructor(U,O){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.type=q.ConnectionLost}}e.$4l=Y;class Q{constructor(U,O,Z,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.durationSeconds=Z,this.c=V,this.type=q.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=Q;class re{constructor(U,O,Z){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=Z,this.type=q.ReconnectionRunning}}e.$6l=re;class te{constructor(U,O,Z){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=Z,this.type=q.ConnectionGain}}e.$7l=te;class _{constructor(U,O,Z,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=Z,this.handled=V,this.type=q.ReconnectionPermanentFailure}}e.$8l=_;class de extends A.$Xc{static triggerPermanentFailure(U,O,Z){this._permanentFailure=!0,this.f=U,this.g=O,this.h=Z,this.j.forEach(V=>V.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||de._permanentFailure}constructor(U,O,Z,V,M){super(),this.t=U,this.u=O,this.reconnectionToken=Z,this.protocol=V,this.w=M,this.m=this.B(new R.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new te(this.reconnectionToken,0,0)),this.B(V.onSocketClose(G=>{const X=pe(this.t,this.reconnectionToken,!0);G?G.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(V.onSocketTimeout(G=>{const X=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),de.j.push(this),this.B((0,A.$Vc)(()=>{const G=de.j.indexOf(this);G>=0&&de.j.splice(G,1)})),this.n&&this.D(de.f,de.g,de.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const V=Z<O.length?O[Z]:O[O.length-1];try{if(V>0){const G=I(V);this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,G)),this.u.logService.info(`${U} waiting for ${V} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this.u.logService.info(`${U} resolving connection...`);const M=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${M.connectTo}...`),await this.G(M,$(a)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(w.$Ul.isTemporarilyNotAvailable(M)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((0,k.$7)(M)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if(M instanceof w.$Ul){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,w.$Ul.isHandled(M));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this.n&&!this.s)}C(U,O,Z){this.w?de.triggerPermanentFailure(U,O,Z):this.D(U,O,Z)}D(U,O,Z){this.m.fire(new _(this.reconnectionToken,U,O,Z)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=de;class J extends de{constructor(U,O,Z,V,M){super(f.Management,U,V,M,!0),this.client=this.B(new h.$si(M,{remoteAuthority:O,clientId:Z},U.ipcLogger))}async G(U,O){await s(U,O)}}e.$0l=J;class ae extends de{constructor(U,O,Z,V,M){super(f.ExtensionHost,U,Z,V,!1),this.H=O,this.debugPort=M}async G(U,O){await c(U,this.H,O)}}e.$$l=ae;function z(x){try{x.acceptDisconnect();const U=x.getSocket();x.dispose(),U.dispose()}catch(U){(0,k.$3)(U)}}function B(x){if(x&&x.type==="error"){const U=new Error(`Connection error: ${x.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function ie(x,U){for(;x.length<U;)x+=" ";return x}function le(x,U){return`[remote-connection][${ie(m(x),13)}][${U.substr(0,5)}\u2026]`}function pe(x,U,O){return`${le(x,U)}[${O?"reconnect":"initial"}]`}function H(x,U){return`${pe(U,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.connectTo}]`}function ce(x){return`${Date.now()-x} ms`}}),define(ve[265],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=e.$qR=void 0,e.$qR=(0,n.$Gi)("IRemoteExtensionsScannerService"),e.$rR="remoteExtensionsScanner"}),define(ve[91],Se([1,0,13]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=r,e.$in=E,e.$jn=k,e.$kn=R;function r(y){return y.scheme===n.Schemas.vscodeRemote?y.authority:void 0}function E(y){if(!y)return;const o=y.indexOf("+");return o<0?y:y.substr(0,o)}function k(y){const{host:o,port:D}=A(y);if(typeof D>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:D}}function R(y,o){let{host:D,port:v}=A(y);return typeof v>"u"&&(v=o),{host:D,port:v}}function A(y){const o=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const D=y.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const v=y.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:y,port:void 0}}}),define(ve[22],Se([1,0,17,5,91]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=k,e.$un=v,e.$vn=h,e.$wn=w,e.$xn=a,e.$yn=f,e.$zn=m,n=qe(n),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function k($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function($){$[$.System=0]="System",$[$.User=1]="User"})(R||(e.ExtensionType=R={}));var A;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class y{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,d){if(typeof b>"u"||b===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof b=="string"||typeof d=="string"){const p=typeof b=="string"?b:b.value,t=typeof d=="string"?d:d.value;return n.$Hf(p,t)}return b._lower===d._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$rn=y;class o{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const d of b)this.add(d)}add(b){this.c.add(y.toKey(b))}delete(b){return this.c.delete(y.toKey(b))}has(b){return this.c.has(y.toKey(b))}}e.$sn=o;class D{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(y.toKey(b))}get(b){return this.c.get(y.toKey(b))}has(b){return this.c.has(y.toKey(b))}set(b,d){this.c.set(y.toKey(b),d)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=D;function v($){return h($)}function h($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function w($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function a($,b){if(b){const d=`onResolveRemoteAuthority:${(0,E.$in)(b)}`;return!!$.activationEvents?.includes(d)}return!1}function f($){return $.map(b=>{const[d,p]=b.split("@");return{proposalName:d,version:p?parseInt(p):void 0}})}function m($){return $.map(b=>b.split("@")[0])}e.$An=(0,r.$Gi)("IBuiltinExtensionsScannerService")}),define(ve[30],Se([1,0,3,208,22,5]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=A,e.$ep=y,e.$fp=o,e.$gp=D,e.$hp=v,e.$ip=h,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function A(t){switch(t){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function y(t){switch(t){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function o(t,l){switch(t){case n.Platform.Windows:return l==="x64"?E.TargetPlatform.WIN32_X64:l==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Linux:return l==="x64"?E.TargetPlatform.LINUX_X64:l==="arm64"?E.TargetPlatform.LINUX_ARM64:l==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?E.TargetPlatform.ALPINE_X64:l==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Mac:return l==="x64"?E.TargetPlatform.DARWIN_X64:l==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Web:return E.TargetPlatform.WEB}}function D(t,l){return l===E.TargetPlatform.WEB&&!t.includes(E.TargetPlatform.WEB)}function v(t,l,i){return D(l,i)?!1:t===E.TargetPlatform.UNDEFINED||t===E.TargetPlatform.UNIVERSAL?!0:t===E.TargetPlatform.UNKNOWN?!1:t===i}function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var a;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var f;(function(t){t.Install="install",t.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$jp=(0,k.$Gi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class b extends Error{constructor(l,i){super(l),this.code=i,this.name=i}}e.$kp=b;var d;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class p extends Error{constructor(l,i){super(l),this.code=i,this.name=i}}e.$lp=p,e.$mp=(0,k.$Gi)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,k.$Gi)("IGlobalExtensionEnablementService"),e.$qp=(0,k.$Gi)("IExtensionTipsService"),e.$rp=(0,r.localize2)(0,"Extensions"),e.$sp=(0,r.localize2)(1,"Preferences")}),define(ve[266],Se([1,0,6,2,21,4,59,30]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0;function y(m,$){return m?k.URI.revive($?$.transformIncoming(m):m):void 0}function o(m,$){return $?$.transformOutgoingURI(m):m}function D(m,$){$=$||R.$Nn;const b=m.manifest;return{...(0,R.$Qn)({...m,manifest:void 0},$),manifest:b}}function v(m,$){return m?.profileLocation?(0,R.$Qn)(m,$??R.$Nn):m}function h(m,$){return $?(0,E.$go)(m,b=>b instanceof k.URI?$.transformOutgoingURI(b):void 0):m}class w{constructor($,b){this.a=$,this.b=b,this.onInstallExtension=n.Event.buffer($.onInstallExtension,!0),this.onDidInstallExtensions=n.Event.buffer($.onDidInstallExtensions,!0),this.onUninstallExtension=n.Event.buffer($.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer($.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=n.Event.buffer($.onDidUpdateExtensionMetadata,!0)}listen($,b){const d=this.b($);switch(b){case"onInstallExtension":return n.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?o(p.profileLocation,d):p.profileLocation}));case"onDidInstallExtensions":return n.Event.map(this.onDidInstallExtensions,p=>p.map(t=>({...t,local:t.local?h(t.local,d):t.local,profileLocation:t.profileLocation?o(t.profileLocation,d):t.profileLocation})));case"onUninstallExtension":return n.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?o(p.profileLocation,d):p.profileLocation}));case"onDidUninstallExtension":return n.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?o(p.profileLocation,d):p.profileLocation}));case"onDidUpdateExtensionMetadata":return n.Event.map(this.onDidUpdateExtensionMetadata,p=>({local:h(p.local,d),profileLocation:o(p.profileLocation,d)}))}throw new Error("Invalid listen")}async call($,b,d){const p=this.b($);switch(b){case"zip":{const t=D(d[0],p),l=await this.a.zip(t);return o(l,p)}case"unzip":return this.a.unzip(y(d[0],p));case"install":return this.a.install(y(d[0],p),v(d[1],p));case"installFromLocation":return this.a.installFromLocation(y(d[0],p),y(d[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],y(d[1],p),y(d[2],p));case"getManifest":return this.a.getManifest(y(d[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],v(d[1],p));case"installGalleryExtensions":{const t=d[0];return this.a.installGalleryExtensions(t.map(({extension:l,options:i})=>({extension:l,options:v(i,p)??{}})))}case"uninstall":return this.a.uninstall(D(d[0],p),v(d[1],p));case"reinstallFromGallery":return this.a.reinstallFromGallery(D(d[0],p));case"getInstalled":return(await this.a.getInstalled(d[0],y(d[1],p),d[2])).map(l=>h(l,p));case"toggleAppliationScope":{const t=await this.a.toggleAppliationScope(D(d[0],p),y(d[1],p));return h(t,p)}case"copyExtensions":return this.a.copyExtensions(y(d[0],p),y(d[1],p));case"updateMetadata":{const t=await this.a.updateMetadata(D(d[0],p),d[1],y(d[2],p));return h(t,p)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$vq=w;class a extends r.$Xc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor($){super(),this.m=$,this.c=this.B(new n.$ne),this.f=this.B(new n.$ne),this.g=this.B(new n.$ne),this.h=this.B(new n.$ne),this.j=this.B(new n.$ne),this.B(this.m.listen("onInstallExtension")(b=>this.n(this.c,{...b,source:this.r(b.source)?k.URI.revive(b.source):b.source,profileLocation:k.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(b=>this.n(this.f,b.map(d=>({...d,local:d.local?D(d.local,null):d.local,source:this.r(d.source)?k.URI.revive(d.source):d.source,profileLocation:k.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(b=>this.n(this.g,{...b,profileLocation:k.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(b=>this.n(this.h,{...b,profileLocation:k.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(b=>this.n(this.j,{profileLocation:k.URI.revive(b.profileLocation),local:D(b.local,null)})))}n($,b){$.fire(b)}r($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall($){const b=await this.getTargetPlatform();return $.allTargetPlatforms.some(d=>(0,A.$hp)(d,$.allTargetPlatforms,b))}zip($){return Promise.resolve(this.m.call("zip",[$]).then(b=>k.URI.revive(b)))}unzip($){return Promise.resolve(this.m.call("unzip",[$]))}install($,b){return Promise.resolve(this.m.call("install",[$,b])).then(d=>D(d,null))}installFromLocation($,b){return Promise.resolve(this.m.call("installFromLocation",[$,b])).then(d=>D(d,null))}async installExtensionsFromProfile($,b,d){return(await this.m.call("installExtensionsFromProfile",[$,b,d])).map(t=>D(t,null))}getManifest($){return Promise.resolve(this.m.call("getManifest",[$]))}installFromGallery($,b){return Promise.resolve(this.m.call("installFromGallery",[$,b])).then(d=>D(d,null))}async installGalleryExtensions($){return(await this.m.call("installGalleryExtensions",[$])).map(d=>({...d,local:d.local?D(d.local,null):d.local,source:this.r(d.source)?k.URI.revive(d.source):d.source,profileLocation:k.URI.revive(d.profileLocation)}))}uninstall($,b){if($.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[$,b]))}reinstallFromGallery($){return Promise.resolve(this.m.call("reinstallFromGallery",[$])).then(b=>D(b,null))}getInstalled($=null,b,d){return Promise.resolve(this.m.call("getInstalled",[$,b,d])).then(p=>p.map(t=>D(t,null)))}updateMetadata($,b,d){return Promise.resolve(this.m.call("updateMetadata",[$,b,d])).then(p=>D(p,null))}toggleAppliationScope($,b){return this.m.call("toggleAppliationScope",[$,b]).then(d=>D(d,null))}copyExtensions($,b){return this.m.call("copyExtensions",[$,b])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download($,b,d){const p=await this.m.call("download",[$,b,d]);return k.URI.revive(p)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$wq=a;class f{constructor($){this.a=$}listen($,b){throw new Error("Invalid listen")}call($,b,d){switch(b){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$xq=f}),define(ve[130],Se([1,0,10,22]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=void 0;class E{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const y of R){const o=this.readActivationEvents(y);o.length>0&&(A[r.$rn.toKey(y.identifier)]=o)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let y=0;y<A.length;y++)A[y]==="onUri"&&(A[y]=`onUri:${r.$rn.toKey(R.identifier)}`);if(!R.contributes)return A;for(const y in R.contributes){const o=this.a.get(y);if(!o)continue;const D=R.contributes[y],v=Array.isArray(D)?D:[D];try{o(v,A)}catch(h){(0,n.$3)(h)}}return A}}e.$LG=E,e.$MG=new E}),define(ve[267],Se([1,0,2,22,16]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class k extends n.$Xc{constructor(A,y,o,D,v){super(),this.a=A,this.b=y,this.c=o,this.f=v,this.B(D.onDidInstallExtensions(h=>this.g(h))),this.B(D.onDidUninstallExtension(h=>this.h(h)))}g(A){for(const y of A)y.local&&this.invalidate(y.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const y of this.a.profiles)this.c.extUri.isEqual(y.extensionsResource,A)&&await this.j(y);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,r.$ln))}catch(y){(0,E.$rl)(y)!==E.FileOperationResult.FILE_NOT_FOUND&&this.f.error(y)}}}e.$Uq=k});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[74],Se([1,0,20,58,214,63,22,119]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=D,e.$Yp=v,e.$Zp=h,e.$1p=w,e.$2p=a,e.$3p=f,e.$4p=m,e.$5p=$,r=mt(r),E=qe(E),k=qe(k);const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function D(p){return p=p.trim(),p==="*"||y.test(p)}function v(p){if(!D(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=p.match(y);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function h(p){if(!p)return null;const t=p.majorBase,l=p.majorMustEqual,i=p.minorBase;let g=p.minorMustEqual;const s=p.patchBase;let c=p.patchMustEqual;p.hasCaret&&(t===0||(g=!1),c=!1);let u=0;if(p.preRelease){const S=o.exec(p.preRelease);if(S){const[,P,C,L]=S;u=Date.UTC(Number(P),Number(C)-1,Number(L))}}return{majorBase:t,majorMustEqual:l,minorBase:i,minorMustEqual:g,patchBase:s,patchMustEqual:c,isMinimum:p.hasGreaterEquals,notBefore:u}}function w(p,t,l){let i;typeof p=="string"?i=h(v(p)):i=p;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let s;if(typeof l=="string"?s=h(v(l)):s=l,!i||!s)return!1;const c=i.majorBase,u=i.minorBase,S=i.patchBase;let P=s.majorBase,C=s.minorBase,L=s.patchBase;const T=s.notBefore;let I=s.majorMustEqual,q=s.minorMustEqual,Y=s.patchMustEqual;return s.isMinimum?c>P?!0:c<P?!1:u>C?!0:u<C||g&&g<T?!1:S>=L:(c===1&&P===0&&(!I||!q||!Y)&&(P=1,C=0,L=0,I=!0,q=!1,Y=!1),c<P?!1:c>P?!I:u<C?!1:u>C?!q:S<L?!1:S>L?!Y:!(g&&g<T))}function a(p,t,l,i,g,s){const c=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return c.push([r.default.Error,E.localize(0,null)]),c;if(typeof i.name!="string")return c.push([r.default.Error,E.localize(1,null,"name")]),c;if(typeof i.version!="string")return c.push([r.default.Error,E.localize(2,null,"version")]),c;if(!i.engines)return c.push([r.default.Error,E.localize(3,null,"engines")]),c;if(typeof i.engines.vscode!="string")return c.push([r.default.Error,E.localize(4,null,"engines.vscode")]),c;if(typeof i.extensionDependencies<"u"&&!d(i.extensionDependencies))return c.push([r.default.Error,E.localize(5,null,"extensionDependencies")]),c;if(typeof i.activationEvents<"u"){if(!d(i.activationEvents))return c.push([r.default.Error,E.localize(6,null,"activationEvents")]),c;if(typeof i.main>"u"&&typeof i.browser>"u")return c.push([r.default.Error,E.localize(7,null,"activationEvents","main","browser")]),c}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&c.push([r.default.Warning,E.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return c.push([r.default.Error,E.localize(9,null,"main")]),c;{const P=(0,n.$hh)(l,i.main);(0,n.$bh)(P,l)||c.push([r.default.Warning,E.localize(10,null,P.path,l.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return c.push([r.default.Error,E.localize(11,null,"browser")]),c;{const P=(0,n.$hh)(l,i.browser);(0,n.$bh)(P,l)||c.push([r.default.Warning,E.localize(12,null,P.path,l.path)])}}if(!k.valid(i.version))return c.push([r.default.Error,E.localize(13,null)]),c;const u=[];if(!f(p,t,i,g,u))for(const P of u)c.push([r.default.Error,P]);if(s&&i.enabledApiProposals?.length){const P=[];if(!$([...i.enabledApiProposals],P))for(const C of P)c.push([r.default.Error,C])}return c}function f(p,t,l,i,g){return i||typeof l.main>"u"&&typeof l.browser>"u"?!0:b(p,t,l.engines.vscode,g)}function m(p,t,l){return p==="*"||b(t,l,p)}function $(p,t){if(p.length===0)return!0;const l=Array.isArray(t)?t:void 0,i=(l?void 0:t)??A.allApiProposals,g=[],s=(0,R.$yn)(p);for(const{proposalName:c,version:u}of s){const S=i[c];S&&u&&S.version!==u&&g.push(E.localize(14,null,c))}return l?.push(...g),g.length===0}function b(p,t,l,i=[]){const g=h(v(l));if(!g)return i.push(E.localize(15,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return i.push(E.localize(16,null,l)),!1}else if(!g.majorMustEqual)return i.push(E.localize(17,null,l)),!1;return w(p,t,g)?!0:(i.push(E.localize(18,null,p,l)),!1)}function d(p){if(!Array.isArray(p))return!1;for(let t=0,l=p.length;t<l;t++)if(typeof p[t]!="string")return!1;return!0}}),define(ve[92],Se([1,0,19,2,3,219,30,5]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0,e.$9r=y;function y(D){return D.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$0r=(0,A.$Gi)("languagePackService");let o=class extends r.$Xc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new n.$ye;setTimeout(()=>v.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const a=h.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],$=y(f);return{...this.f($,m,f),extensionId:f.identifier.id,galleryExtension:f}});return a.push(this.f("en","English")),a}f(v,h,w){const a=h??v;let f;if(a!==v&&(f=`(${v})`),v.toLowerCase()===E.$w.toLowerCase()&&(f??="",f+=(0,k.localize)(0,null)),w?.installCount){f??="";const m=w.installCount;let $;m>1e6?$=`${Math.floor(m/1e5)/10}M`:m>1e3?$=`${Math.floor(m/1e3)}K`:$=String(m),f+=` $(cloud-download) ${$}`}return{id:v,label:a,description:f}}};e.$$r=o,e.$$r=o=Be([je(0,R.$jp)],o)}),define(ve[47],Se([1,0,15,10,2,222,46,5,12,38]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=h,e.$9p=w,e.$0p=a,e.$$p=f,e.$_p=m,e.$aq=$,e.$6p=(0,A.$Gi)("requestService");class D{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?t[l]="*****":t[l]=this.b[l];this.a=t}return this.a}}class v extends E.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,k.localize)(0,null),when:y.$sk.isEqualTo((0,y.$pk)(y.LogLevel.Trace)).serialize()})}async c(t,l,i){const g=`${t} #${++this.b}: ${l.url}`;this.a.trace(`${g} - begin`,l.type,new D(l.headers??{}));try{const s=await i();return this.a.trace(`${g} - end`,l.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${g} - error`,l.type,(0,r.$ab)(s)),s}}}e.$7p=v;function h(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function w(p){return p.res.statusCode===204}async function a(p){return w(p)?null:(await(0,n.$2e)(p.stream)).toString()}async function f(p){if(!h(p))throw new Error("Server returned "+p.res.statusCode);return a(p)}async function m(p){if(!h(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const l=(await(0,n.$2e)(p.stream)).toString();try{return JSON.parse(l)}catch(i){throw i.message+=`:
`+l,i}}function $(p){d(p)}let b;function d(p){const t=o.$ro.as(R.$wo.Configuration),l=b;b={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null),(0,k.localize)(10,null)],default:"override",description:(0,k.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[b],remove:l?[l]:[]})}d(R.ConfigurationScope.APPLICATION)}),define(ve[268],Se([1,0,19,13,16,47]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let R=class{constructor(y,o){this.a=y,this.b=o}async download(y,o,D=n.CancellationToken.None){if(y.scheme===r.Schemas.file||y.scheme===r.Schemas.vscodeRemote){await this.b.copy(y,o);return}const v={type:"GET",url:y.toString(!0)},h=await this.a.request(v,D);if(h.res.statusCode===200)await this.b.writeFile(o,h.stream);else{const w=await(0,k.$$p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${w}`)}}};e.$DR=R,e.$DR=R=Be([je(0,k.$6p),je(1,E.$al)],R)}),define(ve[269],Se([1,0,15,19]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class E{constructor(A){this.a=A}listen(A,y){throw new Error("Invalid listen")}call(A,y,o,D=r.CancellationToken.None){switch(y){case"request":return this.a.request(o[0],D).then(async({res:v,stream:h})=>{const w=await(0,n.$2e)(h);return[{statusCode:v.statusCode,headers:v.headers},w]});case"resolveProxy":return this.a.resolveProxy(o[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$as=E;class k{constructor(A){this.a=A}async request(A,y){const[o,D]=await this.a.call("request",[A],y);return{res:o,stream:(0,n.$4e)(D)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$bs=k}),define(ve[270],Se([1,0,93,11]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=k;function E(R,A){return R.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:R.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function k(R,A,y={}){const o=(0,n.parse)(R),D=y.proxyUrl||E(o,A);if(!D)return null;const v=(0,n.parse)(D);if(!/^https?:$/.test(v.protocol||""))return null;const h={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,r.$mg)(y.strictSSL)?y.strictSSL:!0};return o.protocol==="http:"?new(await new Promise((w,a)=>{se(["http-proxy-agent"],w,a)}).then(qe)).HttpProxyAgent(D,h):new(await new Promise((w,a)=>{se(["https-proxy-agent"],w,a)}).then(qe)).HttpsProxyAgent(D,h)}}),define(ve[94],Se([1,0,60,9,223,19,45,10,3,23,116,244,14,163]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=f;let a;async function f($,b,d,p){return d["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.$i?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Km)(p)&&!d["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Km)(p)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=h.Promises.withAsyncBody(async(t,l)=>{const i=new k.$ye;let g=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(g=(0,w.$Lm)(s,1,120)*1e3);const c=setTimeout(()=>{i.dispose(!0),l(new Error((0,E.localize)(0,null)))},g);try{t(await m(b,i.token))}catch(u){!(0,A.$7)(u)&&!i.token.isCancellationRequested?l(new Error((0,E.localize)(1,null,(0,R.$rj)(u)))):t({})}finally{clearTimeout(c),i.dispose()}})),a)}async function m($,b){const d=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",d);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",p);const t=(0,o.$3g)().replace(/-/g,"").substr(0,12),l=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",i);const g=await(0,D.$Am)(y.OS,i);return $.trace("getUnixShellEnvironment#shell",g),new Promise((s,c)=>{if(b.isCancellationRequested)return c(new A.$8);const u=(0,r.$qc)(g);let S,P;const C="";/^pwsh(-preview)?$/.test(u)?(S=`& '${process.execPath}' ${C} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,P=["-Login","-Command"]):u==="nu"?(S=`^'${process.execPath}' ${C} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,P=["-i","-l","-c"]):u==="xonsh"?(S=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,P=["-i","-l","-c"]):(S=`'${process.execPath}' ${C} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u==="tcsh"||u==="csh"?P=["-ic"]:P=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),S);const L=(0,n.spawn)(g,[...P,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});b.onCancellationRequested(()=>(L.kill(),c(new A.$8))),L.on("error",q=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,R.$rj)(q)),c(q)});const T=[];L.stdout.on("data",q=>T.push(q));const I=[];L.stderr.on("data",q=>I.push(q)),L.on("close",(q,Y)=>{const Q=Buffer.concat(T).toString("utf8");$.trace("getUnixShellEnvironment#raw",Q);const re=Buffer.concat(I).toString("utf8");if(re.trim()&&$.trace("getUnixShellEnvironment#stderr",re),q||Y)return c(new Error((0,E.localize)(2,null,q,Y)));const te=l.exec(Q),_=te?te[1]:"{}";try{const de=JSON.parse(_);d?de.ELECTRON_RUN_AS_NODE=d:delete de.ELECTRON_RUN_AS_NODE,p?de.ELECTRON_NO_ATTACH_CONSOLE=p:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",de),s(de)}catch(de){$.error("getUnixShellEnvironment#errorCaught",(0,R.$rj)(de)),c(de)}})})}}),define(ve[271],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,n.$Gi)("stateReadService"),e.$gR=(0,n.$Gi)("stateService")}),define(ve[272],Se([1,0,14,15,2,11,28,16,12]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var o;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(o||(e.SaveStrategy=o={}));class D extends E.$Xc{constructor(a,f,m,$){super(),this.h=a,this.j=f,this.m=m,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Eh(this.j===o.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,f){const m=this.a[a];return(0,k.$pg)(m)?f:m}setItem(a,f){this.setItems([{key:a,data:f}])}setItems(a){let f=!1;for(const{key:m,data:$}of a)this.a[m]!==$&&((0,k.$pg)($)?(0,k.$ng)(this.a[m])||(this.a[m]=void 0,f=!0):(this.a[m]=$,f=!0));f&&this.s()}removeItem(a){(0,k.$ng)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,r.$Pe.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(f){this.m.error(f)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=D;let v=class extends E.$Xc{constructor(a,f,m,$){super(),this.a=this.B(new D(f.stateResource,a,m,$))}async init(){await this.a.init()}getItem(a,f){return this.a.getItem(a,f)}};e.$iR=v,e.$iR=v=Be([je(1,R.$Ni),je(2,y.$ak),je(3,A.$al)],v);class h extends v{setItem(a,f){this.a.setItem(a,f)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$jR=h}),define(ve[131],Se([1,0,3,33,23]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=R,e.$up=A;function k(y){if(n.$u===n.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function R(y,o,D,v,h,w,a,f,m,$){const b=Object.create(null);b["common.machineId"]=w,b["common.sqmId"]=a,b["common.devDeviceId"]=f,b.sessionID=(0,E.$3g)()+Date.now(),b.commitHash=v,b.version=h,b["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.$h)(n.$u),b["common.nodePlatform"]=r.$gc,b["common.nodeArch"]=D,b["common.product"]=$||"desktop",m&&(b["common.msftInternal"]=m);let d=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),n.$l&&(b["common.snap"]="true");const t=k(o);return t&&(b["common.platformDetail"]=t),b}function A(y){const o=r.env.USERDNSDOMAIN;if(!o)return!1;const D=o.toLowerCase();return y.some(v=>D===v)}}),define(ve[273],Se([1,0,18,10,2,21,16]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(o){function D(v,h){return v.callstack<h.callstack?-1:v.callstack>h.callstack?1:0}o.compare=D})(A||(e.ErrorEvent=A={}));class y{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(D,v=y.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new E.$Wc,this.c=D,this.d=v;const h=r.$Z.addListener(w=>this.j(w));this.h.add((0,E.$Vc)(h)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(D){if(!D||D.code||(D.detail&&D.detail.stack&&(D=D.detail),r.$eb.isErrorNoTelemetry(D)||D instanceof R.$vl||typeof D?.message=="string"&&D.message.includes("Unable to read file")))return;const v=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,h=D.message?D.message:(0,k.$jo)(D);v&&this.k({msg:h,callstack:v})}k(D){const v=(0,n.$zb)(this.g,D,A.compare);v<0?(D.count=1,this.g.splice(~v,0,D)):(this.g[v].count||(this.g[v].count=0),this.g[v].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const D of this.g)this.c.publicLogError2("UnhandledError",D);this.g.length=0}}e.default=y}),define(ve[24],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,n.$Gi)("telemetryService"),e.$am=(0,n.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var r;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(ve[274],Se([1,0,32,14,43,13,9,3,48,4,112,25,115,250,16,29,24]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Ws=b,e.$Xs=p,e.$Ys=t,n=qe(n);const $=new Map;async function b(i,g){const s=`${i}::${g.join(":")}`,c=$.get(s);if(c)return c;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],S=new Map,P=new Map,C=2e4;function L(I,q,Y,Q){const re=q.substring(I.length+1);return r.Promises.withAsyncBody(async te=>{let _;Q.readdirCount++;try{_=await v.Promises.readdir(q,{withFileTypes:!0})}catch{te();return}if(Q.count>=C){Q.count+=_.length,Q.maxReached=!0,te();return}let de=_.length;if(de===0){te();return}let J=_;Q.count+_.length>C&&(Q.maxReached=!0,de=C-Q.count,J=_.slice(0,de)),Q.count+=_.length;for(const ae of J)if(ae.isDirectory()){if(Y.includes(ae.name)||await L(I,(0,R.$mc)(q,ae.name),Y,Q),--de===0){te();return}}else{const z=ae.name.lastIndexOf(".");if(z>=0){const B=ae.name.substring(z+1);B&&S.set(B,(S.get(B)??0)+1)}for(const B of u)B.relativePathPattern?.test(re)!==!1&&B.filePattern.test(ae.name)&&P.set(B.tag,(P.get(B.tag)??0)+1);if(--de===0){te();return}}})}const T=r.Promises.withAsyncBody(async I=>{const q={count:0,maxReached:!1,readdirCount:0},Y=new y.$he(!0);await L(i,i,g,q);const Q=await t(i);I({configFiles:d(P),fileTypes:d(S),fileCount:q.count,maxFilesReached:q.maxReached,launchConfigFiles:Q,totalScanTime:Y.elapsed(),totalReaddirCount:q.readdirCount})});return $.set(s,T),T}function d(i){return Array.from(i.entries(),([g,s])=>({name:g,count:s})).sort((g,s)=>s.count-g.count)}function p(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/a.$Il.GB).toFixed(2)}GB (${(n.freemem()/a.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.$Sn.value()*100)}%`},g=n.cpus();return g&&g.length>0&&(i.cpus=`${g[0].model} (${g.length} x ${g[0].speed})`),i}async function t(i){try{const g=new Map,s=(0,R.$mc)(i,".vscode","launch.json"),c=await v.Promises.readFile(s),u=[],S=(0,E.$Yn)(c.toString(),u);if(u.length)return console.log(`Unable to parse ${s}`),[];if((0,E.$7n)(S)==="object"&&S.configurations)for(const P of S.configurations){const C=P.type;C&&(g.has(C)?g.set(C,g.get(C)+1):g.set(C,1))}return d(g)}catch{return[]}}let l=class{constructor(g,s){this.c=g,this.d=s}f(g){const s=[];return s.push(`OS Version:       ${g.os}`),s.push(`CPUs:             ${g.cpus}`),s.push(`Memory (System):  ${g.memory}`),s.push(`VM:               ${g.vmHint}`),s.join(`
`)}g(g){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const c=n.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/a.$Il.GB).toFixed(2)}GB (${(n.freemem()/a.$Il.GB).toFixed(2)}GB free)`),A.$i||s.push(`Load (avg):       ${n.loadavg().map(u=>Math.round(u)).join(", ")}`),s.push(`VM:               ${Math.round(D.$Sn.value()*100)}%`),s.push(`Screen Reader:    ${g.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${g.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(g.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(g,s){return Promise.all([(0,h.$Vs)(g.mainPID),this.k(g)]).then(async c=>{let[u,S]=c,P=this.m(g,u);return s.forEach(C=>{if((0,w.$Um)(C))P+=`
${C.errorMessage}`,S+=`
${C.errorMessage}`;else if(P+=`

Remote: ${C.hostName}`,C.processes&&(P+=`
${this.m(g,C.processes)}`),C.workspaceMetadata){S+=`
|  Remote: ${C.hostName}`;for(const L of Object.keys(C.workspaceMetadata)){const T=C.workspaceMetadata[L];let I=`${T.fileCount} files`;T.maxFilesReached&&(I=`more than ${I}`),S+=`|    Folder (${L}): ${I}`,S+=this.h(T)}}}),{processInfo:P,workspaceInfo:S}})}async getSystemInfo(g,s){const{memory:c,vmHint:u,os:S,cpus:P}=p(),C={os:S,memory:c,cpus:P,vmHint:u,processArgs:`${g.mainArguments.join(" ")}`,gpuStatus:g.gpuFeatureStatus,screenReader:`${g.screenReader?"yes":"no"}`,remoteData:s};return A.$i||(C.load=`${n.loadavg().map(L=>Math.round(L)).join(", ")}`),A.$k&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(g,s){const c=[];return(0,h.$Vs)(g.mainPID).then(async u=>(c.push(""),c.push(this.g(g)),c.push(""),c.push(this.m(g,u)),g.windows.some(S=>S.folderURIs&&S.folderURIs.length>0&&!S.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.k(g))),s.forEach(S=>{if((0,w.$Um)(S))c.push(`
${S.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${S.hostName}`),c.push(this.f(S.machineInfo)),S.processes&&c.push(this.m(g,S.processes)),S.workspaceMetadata)for(const P of Object.keys(S.workspaceMetadata)){const C=S.workspaceMetadata[P];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),c.push(`Folder (${P}): ${L}`),c.push(this.h(C))}}),c.push(""),c.push(""),c.join(`
`)))}h(g){const s=[];let u=0;const S=(T,I)=>{const q=` ${T}(${I})`;u+q.length>60?(s.push(P),P="|                 ",u=P.length):u+=q.length,P+=q};let P="|      File types:";const C=10,L=g.fileTypes.length>C?C:g.fileTypes.length;for(let T=0;T<L;T++){const I=g.fileTypes[T];S(I.name,I.count)}if(s.push(P),g.configFiles.length>=0&&(P="|      Conf files:",u=0,g.configFiles.forEach(T=>{S(T.name,T.count)}),s.push(P)),g.launchConfigFiles.length>0){let T="|      Launch Configs:";g.launchConfigFiles.forEach(I=>{const q=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;T+=q}),s.push(T)}return s.join(`
`)}j(g){const s=Math.max(...Object.keys(g).map(c=>c.length));return Object.keys(g).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${g[c]}`).join(`
                  `)}k(g){const s=[],c=[];return g.windows.forEach(u=>{u.folderURIs.length===0||u.remoteAuthority||(s.push(`|  Window (${u.title})`),u.folderURIs.forEach(S=>{const P=o.URI.revive(S);if(P.scheme===k.Schemas.file){const C=P.fsPath;c.push(b(C,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,R.$qc)(C)}): ${T}`),s.push(this.h(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${C} (${L.toString()})`)}))}else s.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(u=>s.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}m(g,s){const c=new Map;g.windows.forEach(S=>c.set(S.pid,`window [${S.id}] (${S.title})`)),g.pidToNames.forEach(({pid:S,name:P})=>c.set(S,P));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),s&&this.n(g.mainPID,c,u,s,0),u.join(`
`)}n(g,s,c,u,S){const P=S===0;let C;P?C=u.pid===g?`${this.d.applicationName} main`:"remote agent":s.has(u.pid)?C=s.get(u.pid):C=`${"  ".repeat(S)} ${u.name}`;const L=process.platform==="win32"?u.mem:n.totalmem()*(u.mem/100);c.push(`${u.load.toFixed(0).padStart(5," ")}	${(L/a.$Il.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(u.children)&&u.children.forEach(T=>this.n(g,s,c,T,S+1))}async getWorkspaceFileExtensions(g){const s=new Set;for(const{uri:c}of g.folders){const u=o.URI.revive(c);if(u.scheme!==k.Schemas.file)continue;const S=u.fsPath;try{(await b(S,["node_modules",".git"])).fileTypes.forEach(C=>s.add(C.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(g){for(const{uri:s}of g.folders){const c=o.URI.revive(s);if(c.scheme!==k.Schemas.file)continue;const u=c.fsPath;try{const S=await b(u,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":g.telemetryId,rendererSessionId:g.rendererSessionId}),S.fileTypes.forEach(P=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),S.launchConfigFiles.forEach(P=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),S.configFiles.forEach(P=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:S.totalScanTime,reachedLimit:S.maxFilesReached,fileCount:S.fileCount,readdirCount:S.totalReaddirCount})}catch{}}}};e.$Zs=l,e.$Zs=l=Be([je(0,m.$_l),je(1,f.$tk)],l)}),define(ve[95],Se([1,0,10,5,12,24]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.ExtensionSignatureVerificationCode=e.$rq=void 0,e.$rq=(0,r.$Gi)("IExtensionSignatureVerificationService");var R;(function(o){o.Success="Success",o.RequiredArgumentMissing="RequiredArgumentMissing",o.InvalidArgument="InvalidArgument",o.PackageIsUnreadable="PackageIsUnreadable",o.UnhandledException="UnhandledException",o.SignatureManifestIsMissing="SignatureManifestIsMissing",o.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",o.SignatureIsMissing="SignatureIsMissing",o.SignatureIsUnreadable="SignatureIsUnreadable",o.CertificateIsUnreadable="CertificateIsUnreadable",o.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",o.FileAlreadyExists="FileAlreadyExists",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",o.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",o.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",o.SignatureIsInvalid="SignatureIsInvalid",o.SignatureManifestIsInvalid="SignatureManifestIsInvalid",o.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",o.EntryIsMissing="EntryIsMissing",o.EntryIsTampered="EntryIsTampered",o.Untrusted="Untrusted",o.CertificateRevoked="CertificateRevoked",o.SignatureIsNotValid="SignatureIsNotValid",o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(R||(e.ExtensionSignatureVerificationCode=R={}));class A extends Error{constructor(D){super(D),this.code=D}}e.$sq=A;let y=class{constructor(D,v){this.b=D,this.c=v}d(){return this.a||(this.a=new Promise((D,v)=>se(["@vscode/vsce-sign"],async h=>D(h),v))),this.a}async verify(D,v,h,w){let a;const f=D.identifier.id;try{a=await this.d()}catch(d){return this.b.error("Could not load vsce-sign module",(0,n.$ab)(d)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const m=new Date().getTime();let $;try{this.b.trace(`Verifying extension signature for ${f}...`),$=await a.verify(v,h,this.b.getLevel()===E.LogLevel.Trace)}catch(d){$={code:R.UnknownError,didExecute:!1,output:(0,n.$ab)(d)}}const b=new Date().getTime()-m;if(this.b.info(`Extension signature verification result for ${f}: ${$.code}. Executed: ${$.didExecute}. Duration: ${b}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${$.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,extensionVersion:D.version,code:$.code,internalCode:$.internalCode,duration:b,didExecute:$.didExecute,clientTargetPlatform:w}),$.code===R.Success)return!0;throw new A($.code)}};e.$tq=y,e.$tq=y=Be([je(0,E.$ak),je(1,k.$_l)],y)}),define(ve[275],Se([1,0,2,24]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class E extends n.$Xc{constructor(R,A){super(),this.a=R,this.b=A}async call(R,A,y){switch(A){case"updateTelemetryLevel":{const{telemetryLevel:o}=y;return this.a.updateInjectedTelemetryLevel(o)}case"logTelemetry":{const{eventName:o,data:D}=y;return this.b?this.b.log(o,D):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${A} not found`)}listen(R,A,y){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.$8s=E}),define(ve[41],Se([1,0,21,11,91,131,24]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=D,e.$Dp=v,e.$Ep=h,e.$Fp=w,e.$Gp=f,e.$Hp=$,e.$Ip=b,e.$Jp=t;class A{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$vp=A;class y{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=y,e.$xp=new y;class o{async publicLog(i,g,s){}async publicLogError(i,g,s){}}e.$yp=o,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function D(l,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!l.enableTelemetry)}function v(l,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function h(l){const i=l.getValue(R.$im),g=l.getValue(R.$jm);if(l.getValue(R.$km)===!1||g===!1)return R.TelemetryLevel.NONE;switch(i??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function w(l){const i={},g={},s={};m(l,s);for(let c in s){c=c.length>150?c.substr(c.length-149):c;const u=s[c];typeof u=="number"?g[c]=u:typeof u=="boolean"?g[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),i[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(i[c]=u)}return{properties:i,measurements:g}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(l){if(!l)return"none";const i=(0,E.$in)(l);return a.has(i)?i:"other"}function m(l,i,g=0,s){if(l)for(const c of Object.getOwnPropertyNames(l)){const u=l[c],S=s?s+c:c;Array.isArray(u)?i[S]=(0,n.$jo)(u):u instanceof Date?i[S]=u.toISOString():(0,r.$ig)(u)?g<2?m(u,i,g+1,S+"."):i[S]=(0,n.$jo)(u):i[S]=u}}function $(l,i){const g=l.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,k.$up)(g)||s}function b(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function d(l,i){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let g=l;const s=[];for(const P of i)for(;;){const C=P.exec(l);if(!C)break;s.push([C.index,P.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(g="";;){const P=u.exec(l);if(!P)break;const C=s.some(([L,T])=>P.index<T&&L<u.lastIndex);!c.test(P[0])&&!C&&(g+=l.substring(S,P.index)+"<REDACTED: user-file-path>",S=u.lastIndex)}return S<l.length&&(g+=l.substr(S)),g}function p(l){if(!l)return l;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of i)if(g.regex.test(l))return`<REDACTED: ${g.label}>`;return l}function t(l,i){return(0,n.$go)(l,g=>{if(g instanceof A||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let s=g.replaceAll("%20"," ");s=d(s,i);for(const c of i)s=s.replace(c,"");return s=p(s),s}})}}),define(ve[39],Se([1,0,17,30,22,3,4,10,33,41]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=D,e.$Mp=a,e.$Np=f,e.$Op=m,e.$Pp=$,e.$Qp=b,e.$Rp=d,e.$Sp=p,e.$Up=t,e.$Vp=i;function D(g,s){return g.uuid&&s.uuid?g.uuid===s.uuid:g.id===s.id?!0:(0,n.$Cf)(g.id,s.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(s){const c=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new h(s.identifier,c,u)}static parse(s){const c=v.exec(s);return c&&c[1]&&c[2]?new h({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,u=E.TargetPlatform.UNDEFINED){this.identifier=s,this.version=c,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof h?D(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Lp=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(g){const s=w.exec(g);return s&&s[1]?[m(s[1]),s[2]]:[m(g),void 0]}function f(g,s){return`${g}.${s}`}function m(g){return g.toLowerCase()}function $(g,s){return m(f(g??E.$nn,s))}function b(g,s){const c=[],u=S=>{for(const P of c)if(P.some(C=>D(s(C),s(S))))return P;return null};for(const S of g){const P=u(S);P?P.push(S):c.push([S])}return c}function d(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function p(g){return{id:new o.$vp(g.identifier.id),name:new o.$vp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Tp=new E.$rn("pprice.better-merge");function t(g,s){const c=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const S=u.shift();if(S&&c.every(P=>!D(P.identifier,{id:S}))){const P=g.filter(C=>D(C.identifier,{id:S}));P.length===1&&(c.push(P[0]),u.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function l(g,s){if(!k.$k)return!1;let c;try{c=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,A.$ab)(S))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(g,s){const c=await l(g,s),u=(0,r.$fp)(c?"alpine":k.$u,y.$hc);return s.debug("ComputeTargetPlatform:",u),u}}),define(ve[132],Se([1,0,19,10,13,20,63,4,209,30,39,22]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;const h=f=>(0,y.localize)(0,null,f),w=(0,y.localize)(1,null,"ms-dotnettools.csharp");let a=class{constructor(m,$,b){this.a=m,this.b=$,this.d=b}get f(){}async listExtensions(m,$,b){let d=await this.b.getInstalled(v.ExtensionType.User,b);const p=v.$qn.map(l=>l.toLowerCase());if($&&$!==""){if(p.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(l=>l.manifest.categories?l.manifest.categories.map(g=>g.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),p.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,y.localize)(2,null,this.f)),d=d.sort((l,i)=>l.identifier.id.localeCompare(i.identifier.id));let t;for(const l of d)t!==l.identifier.id&&(t=l.identifier.id,this.a.info(m?`${t}@${l.manifest.version}`:t))}async installExtensions(m,$,b,d){const p=[];try{m.length&&this.a.info(this.f?(0,y.localize)(3,null,this.f):(0,y.localize)(4,null));const t=[],l=[],i=(s,c,u)=>{l.push({id:s,version:c!=="prerelease"?c:void 0,installOptions:{...b,isBuiltin:u,installPreReleaseVersion:c==="prerelease"||b.installPreReleaseVersion}})};for(const s of m)if(s instanceof A.URI)t.push({vsix:s,installOptions:b});else{const[c,u]=(0,D.$Mp)(s);i(c,u,!1)}for(const s of $)if(s instanceof A.URI)t.push({vsix:s,installOptions:{...b,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,u]=(0,D.$Mp)(s);i(c,u,!0)}const g=await this.b.getInstalled(void 0,b.profileLocation);if(t.length&&await Promise.all(t.map(async({vsix:s,installOptions:c})=>{try{await this.h(s,c,d,g)}catch(u){this.a.error(u),p.push(s.toString())}})),l.length){const s=await this.g(l,g,d);p.push(...s)}}catch(t){throw this.a.error((0,y.localize)(5,null,(0,r.$ab)(t))),t}if(p.length)throw new Error((0,y.localize)(6,null,p.join(", ")))}async updateExtensions(m){const $=await this.b.getInstalled(v.ExtensionType.User,m),b=[];for(const l of $)l.identifier.uuid&&b.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,y.localize)(7,null,b.length));const d=await this.d.getExtensions(b,{compatible:!0},n.CancellationToken.None),p=[];for(const l of d)for(const i of $)(0,D.$Kp)(i.identifier,l.identifier)&&(0,R.gt)(l.version,i.manifest.version)&&p.push({extension:l,options:{operation:o.InstallOperation.Update,installPreReleaseVersion:i.preRelease,profileLocation:m,isApplicationScoped:i.isApplicationScoped}});if(!p.length){this.a.info((0,y.localize)(8,null));return}this.a.info((0,y.localize)(9,null,p.map(l=>l.extension.identifier.id).join(", ")));const t=await this.b.installGalleryExtensions(p);for(const l of t)l.error?this.a.error((0,y.localize)(10,null,l.identifier.id,(0,r.$ab)(l.error))):this.a.info((0,y.localize)(11,null,l.identifier.id,l.local?.manifest.version))}async g(m,$,b){if(m=m.filter(({id:l,version:i})=>{const g=$.find(s=>(0,D.$Kp)(s.identifier,{id:l}));if(g){if(!b&&(!i||i==="prerelease"&&g.preRelease))return this.a.info((0,y.localize)(12,null,l,g.manifest.version,l)),!1;if(i&&g.manifest.version===i)return this.a.info((0,y.localize)(13,null,`${l}@${i}`)),!1}return!0}),!m.length)return[];const d=[],p=[],t=await this.j(m);if(await Promise.all(m.map(async({id:l,version:i,installOptions:g})=>{const s=t.get(l.toLowerCase());if(!s){this.a.error(`${h(i?`${l}@${i}`:l)}
${w}`),d.push(l);return}try{const u=await this.d.getManifest(s,n.CancellationToken.None);if(u&&!this.k(u))return}catch(u){this.a.error(u.message||u.stack||u),d.push(l);return}const c=$.find(u=>(0,D.$Kp)(u.identifier,s.identifier));if(c){if(s.version===c.manifest.version){this.a.info((0,y.localize)(14,null,i?`${l}@${i}`:l));return}this.a.info((0,y.localize)(15,null,l,s.version))}g.isBuiltin?this.a.info(i?(0,y.localize)(16,null,l,i):(0,y.localize)(17,null,l)):this.a.info(i?(0,y.localize)(18,null,l,i):(0,y.localize)(19,null,l)),p.push({extension:s,options:{...g,installGivenVersion:!!i,isApplicationScoped:g.isApplicationScoped||c?.isApplicationScoped}})})),p.length){const l=await this.b.installGalleryExtensions(p);for(const i of l)i.error?(this.a.error((0,y.localize)(20,null,i.identifier.id,(0,r.$ab)(i.error))),d.push(i.identifier.id)):this.a.info((0,y.localize)(21,null,i.identifier.id,i.local?.manifest.version))}return d}async h(m,$,b,d){const p=await this.b.getManifest(m);if(!p)throw new Error("Invalid vsix");if(await this.l(p,b,$.profileLocation,d))try{await this.b.install(m,$),this.a.info((0,y.localize)(22,null,(0,k.$eh)(m)))}catch(l){if((0,r.$7)(l))this.a.info((0,y.localize)(23,null,(0,k.$eh)(m)));else throw l}}async j(m){const $=new Map,b=m.some(t=>t.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),p=[];for(const t of m)o.$0o.test(t.id)&&p.push({...t,preRelease:b});if(p.length){const t=await this.d.getExtensions(p,{targetPlatform:d},n.CancellationToken.None);for(const l of t)$.set(l.identifier.id.toLowerCase(),l)}return $}k(m){return!0}async l(m,$,b,d){if(!$){const p={id:(0,D.$Pp)(m.publisher,m.name)},t=d.find(l=>(0,D.$Kp)(p,l.identifier)&&(0,R.gt)(l.manifest.version,m.version));if(t)return this.a.info((0,y.localize)(24,null,t.identifier.id,t.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,$,b){const d=async t=>{if(t instanceof A.URI){const l=await this.b.getManifest(t);return(0,D.$Np)(l.publisher,l.name)}return t},p=[];for(const t of m){const l=await d(t),g=(await this.b.getInstalled(void 0,b)).filter(s=>(0,D.$Kp)(s.identifier,{id:l}));if(!g.length)throw new Error(`${this.m(l)}
${w}`);if(g.some(s=>s.type===v.ExtensionType.System)){this.a.info((0,y.localize)(25,null,l));return}if(!$&&g.some(s=>s.isBuiltin)){this.a.info((0,y.localize)(26,null,l));return}this.a.info((0,y.localize)(27,null,l));for(const s of g)await this.b.uninstall(s,{profileLocation:b}),p.push(s);this.f?this.a.info((0,y.localize)(28,null,l,this.f)):this.a.info((0,y.localize)(29,null,l))}}async locateExtension(m){const $=await this.b.getInstalled();m.forEach(b=>{$.forEach(d=>{if(d.identifier.id===b&&d.location.scheme===E.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(m){return this.f?(0,y.localize)(30,null,m,this.f):(0,y.localize)(31,null,m)}};e.$uq=a,e.$uq=a=Be([je(1,o.$mp),je(2,o.$jp)],a)}),define(ve[276],Se([1,0,6,2,26,39,22,16]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class y extends r.$Xc{constructor(D,v,h,w,a,f,m){super(),this.f=D,this.g=v,this.h=h,this.j=w,this.m=a,this.n=f,this.r=m,this.a=this.B(new n.$ne),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new r.$7c),this.s().then(null,$=>m.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(D=>this.u(D.added))),this.B(this.j.onAddExtensions(D=>this.w(D))),this.B(this.j.onDidAddExtensions(D=>this.y(D))),this.B(this.j.onRemoveExtensions(D=>this.z(D))),this.B(this.j.onDidRemoveExtensions(D=>this.C(D))),this.B(this.n.onDidFilesChange(D=>this.D(D)))}async u(D){try{D.length&&await Promise.all(D.map(v=>(this.c.set(v.id,(0,r.$Uc)(this.n.watch(this.m.extUri.dirname(v.extensionsResource)),this.n.watch(v.extensionsResource))),this.G(v.extensionsResource))))}catch(v){throw this.r.error(v),v}}async w(D){for(const v of D.extensions)this.I(this.L(v.identifier,v.version),D.profileLocation)}async y(D){for(const v of D.extensions){const h=this.L(v.identifier,v.version);D.error?this.J(h,D.profileLocation):this.I(h,D.profileLocation)}}async z(D){for(const v of D.extensions)this.J(this.L(v.identifier,v.version),D.profileLocation)}async C(D){const v=[],h=[];for(const w of D.extensions){const a=this.L(w.identifier,w.version);D.error?this.I(a,D.profileLocation):(this.J(a,D.profileLocation),this.b.has(a)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),h.push(this.f.scanInstalledExtensionAtLocation(w.location).then(f=>{f?v.push(f):this.r.info("Extension not found at the location",w.location.toString())},f=>this.r.error(f)))))}try{await Promise.all(h),v.length&&await this.H(v)}catch(w){this.r.error(w)}}D(D){for(const v of this.h.profiles)D.contains(v.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(v.extensionsResource)}async F(D){const v=[],h=[],w=await this.j.scanProfileExtensions(D),a=new Set,f=new Set;for(const[m,$]of this.b)$.has(D)&&f.add(m);for(const m of w){const $=this.L(m.identifier,m.version);a.add($),f.has($)||(v.push(m.identifier),this.I($,D))}for(const m of f)if(!a.has(m)){const $=this.M(m);$&&(h.push($.identifier),this.J(m,D))}(v.length||h.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:D}:void 0,removed:h.length?{extensions:h,profileLocation:D}:void 0})}async G(D){const v=await this.j.scanProfileExtensions(D);for(const h of v)this.I(this.L(h.identifier,h.version),D)}async H(D){D||(D=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),D.length&&await this.f.markAsUninstalled(...D)}I(D,v){let h=this.b.get(D);h||this.b.set(D,h=new E.$Ec(w=>this.m.extUri.getComparisonKey(w))),h.add(v)}J(D,v){const h=this.b.get(D);h&&h.delete(v),h?.size||this.b.delete(D)}L(D,v){return`${R.$rn.toKey(D.id)}@${v}`}M(D){const[v,h]=(0,k.$Mp)(D);return h?{identifier:{id:v},version:h}:void 0}}e.$Vq=y}),define(ve[133],Se([1,0,96,18,14,2,13,9,25,28,30,39,12,92,4]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;let f=class extends w.$$r{constructor(d,p,t,l){super(t),this.h=d,this.j=l,this.g=this.B(new m(p,l)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(d,p){const l=(await this.g.getLanguagePacks())[p];if(!l){this.j.warn(`No language pack found for ${p}`);return}const i=l.translations[d];return i?a.URI.file(i):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),p=Object.keys(d).map(t=>{const l=d[t];return{...this.f(t,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((t,l)=>t.label.localeCompare(l.label)),p}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const p=await this.g.getLanguagePacks();Object.keys(p).some(t=>p[t]&&p[t].extensions.some(l=>(0,v.$Kp)(l.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(p);return!(0,r.$xb)(Object.keys(d),Object.keys(t))}};e.$_r=f,e.$_r=f=Be([je(0,D.$mp),je(1,o.$Oi),je(2,D.$jp),je(3,h.$ak)],f);let m=class extends k.$Xc{constructor(d,p){super(),this.j=p,this.c={},this.f=(0,A.$mc)(d.userDataPath,"languagepacks.json"),this.g=new E.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(p=>{Object.keys(p).forEach(t=>delete p[t]),this.m(p,...d)}).then(()=>this.c)}m(d,...p){for(const t of p)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.n(d,t);Object.keys(d).forEach(t=>this.r(d[t]))}n(d,p){const t=p.identifier,l=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const i of l)if(p.location.scheme===R.Schemas.file&&$(i)){let g=d[i.languageId];g||(g={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=g);const s=g.extensions.filter(c=>(0,v.$Kp)(c.extensionIdentifier,t))[0];s?s.version=p.manifest.version:g.extensions.push({extensionIdentifier:t,version:p.manifest.version});for(const c of i.translations)g.translations[c.id]=(0,A.$mc)(p.location.fsPath,c.path)}}r(d){if(d){const p=(0,n.createHash)("md5");for(const t of d.extensions)p.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);d.hash=p.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let p=null;return y.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(p=d(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const l=JSON.stringify(this.c);return this.j.debug("Writing language packs",l),y.Promises.writeFile(this.f,l)}).then(()=>p,t=>this.j.error(t))})}};m=Be([je(0,o.$Oi),je(1,h.$ak)],m);function $(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const d of b.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(ve[277],Se([1,0,193,10,21,41]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function y(D,v,h){const w=await(0,n.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,n.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),f=new w.AppInsightsCore,m=new a.PostChannel,$={instrumentationKey:D,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(h){$.extensionConfig={};const b={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};$.extensionConfig[m.identifier]=b}return f.initialize($,[]),f.addTelemetryInitializer(b=>{b.ext=b.ext??{},b.ext.web=b.ext.web??{},b.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),f}class o{constructor(v,h,w,a,f){this.e=v,this.f=h,this.g=w,this.h=f,this.c=R,this.d=A,this.g||(this.g={}),typeof a=="function"?this.a=a():this.a=a,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=y(this.a,this.e,this.h)),this.b.then(h=>{v(h)},h=>{(0,r.$3)(h),console.error(h)})}}log(v,h){if(!this.a)return;h=(0,E.$ho)(h,this.g),h=(0,k.$Fp)(h);const w=this.f+"/"+v;try{this.i(a=>{a.pluginVersionString=h?.properties.version??"Unknown",a.track({name:w,baseData:{name:w,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$bR=o});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[278],Se([1,0,2,21,3,17,224,27,46,62,29,38,24,41]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,o=mt(o);let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,b,d){this.k=b,this.l=d,this.d={},this.i=new n.$Wc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,k.$jf)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$jf)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(h.$im)||p.affectsConfiguration(h.$km)||p.affectsConfiguration(h.$jm))&&this.m()}))}setExperimentProperty($,b){this.d[$]=b}m(){let $=(0,w.$Ep)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const d=b.usage?h.TelemetryLevel.USAGE:b.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;$=Math.min($,d)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,b,d){this.g<b||(d=(0,r.$ho)(d,this.d),d=(0,w.$Jp)(d,this.j),d=(0,r.$ho)(d,this.c),this.b.forEach(p=>p.log($,d)))}publicLog($,b){this.n($,h.TelemetryLevel.USAGE,b)}publicLog2($,b){this.publicLog($,b)}publicLogError($,b){this.h&&this.n($,h.TelemetryLevel.ERROR,b)}publicLogError2($,b){this.publicLogError($,b)}};e.$fs=a,e.$fs=a=Be([je(1,A.$aj),je(2,D.$tk)],a);function f(){const m=(0,R.localize)(0,null,o.default.nameLong),$=o.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",o.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=E.$o?"":(0,R.localize)(3,null),d=(0,R.localize)(4,null),p=(0,R.localize)(5,null),t=(0,R.localize)(6,null),l=(0,R.localize)(7,null),i=`
|       | ${d} | ${p} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,g=(0,R.localize)(8,null);return`
${m} ${$} ${b}

&nbsp;

${l}
${i}

&nbsp;

${g}
`}v.$ro.as(y.$wo.Configuration).registerConfiguration({id:h.$hm,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[h.$im]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:f(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),v.$ro.as(y.$wo.Configuration).registerConfiguration({id:h.$hm,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[h.$km]:{type:"boolean",markdownDescription:o.default.privacyStatementUrl?(0,R.localize)(16,null,o.default.nameLong,o.default.privacyStatementUrl):(0,R.localize)(15,null,o.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${h.$im}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[279],Se([1,0,27,5,29,24,278,41]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=void 0;let y=class extends R.$fs{constructor(D,v,h,w){super(D,h,w),this.o=v}publicLog(D,v){if(!(this.o<k.TelemetryLevel.USAGE))return super.publicLog(D,v)}publicLog2(D,v){return this.publicLog(D,v)}publicLogError(D,v){return this.o<k.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(D,v)}publicLogError2(D,v){return this.publicLogError(D,v)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this.o=k.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,D):D,this.o===k.TelemetryLevel.NONE&&this.dispose()}};e.$5s=y,e.$5s=y=Be([je(2,n.$aj),je(3,E.$tk)],y),e.$6s=new class extends A.$wp{async updateInjectedTelemetryLevel(){}},e.$7s=(0,r.$Hi)(k.$_l)}),define(ve[280],Se([1,0,15,19,336,277]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,E=qe(E);async function R(D,v){const h=await v.request(D,r.CancellationToken.None),w=(await(0,n.$2e)(h.stream)).toString(),a=h.res.statusCode??200;return{headers:h.res.headers,statusCode:a,responseData:w}}async function A(D){const v={method:D.type,headers:D.headers};return new Promise((w,a)=>{const f=E.request(D.url??"",v,m=>{m.on("data",function($){w({headers:m.headers,statusCode:m.statusCode??200,responseData:$.toString()})}),m.on("error",function($){a($)})});f.write(D.data,m=>{m&&a(m)}),f.end()})}async function y(D,v,h){const w=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),a={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:w};try{const f=D?await R(a,D):await A(a);h(f.statusCode,f.headers,f.responseData)}catch{h(0,{})}}class o extends k.$bR{constructor(v,h,w,a,f){const m={sendPOST:($,b)=>{y(v,$,b)}};super(h,w,a,f,m)}}e.$cR=o});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[281],Se([1,0,10,273]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=mt(r);class E extends r.default{i(){(0,n.setUnexpectedErrorHandler)(A=>console.error(A));const R=[];process.on("unhandledRejection",(A,y)=>{R.push(y),setTimeout(()=>{const o=R.indexOf(y);o>=0&&y.catch(D=>{R.splice(o,1),(0,n.$7)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),A&&(0,n.$3)(A))})},1e3)}),process.on("rejectionHandled",A=>{const y=R.indexOf(A);y>=0&&R.splice(y,1)}),process.on("uncaughtException",A=>{(0,n.$2)(A)||(0,n.$3)(A)})}}e.default=E}),define(ve[134],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ve[135],Se([1,0,3,134]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(D){this.collections=D,this.a=new Map,this.b=new Map,D.forEach((v,h)=>{this.d(v,h);const w=v.map.entries();let a=w.next();for(;!a.done;){const f=a.value[1],m=a.value[0];let $=this.a.get(m);if($||($=[],this.a.set(m,$)),$.length>0&&$[0].type===r.EnvironmentVariableMutatorType.Replace){a=w.next();continue}const b={extensionIdentifier:h,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};b.scope||delete b.scope,$.unshift(b),a=w.next()}})}async applyToProcessEnvironment(D,v,h){let w;n.$i&&(w={},Object.keys(D).forEach(a=>w[a.toLowerCase()]=a));for(const[a,f]of this.getVariableMap(v)){const m=n.$i&&w[a.toLowerCase()]||a;for(const $ of f){const b=h?await h($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case r.EnvironmentVariableMutatorType.Append:D[m]=(D[m]||"")+b;break;case r.EnvironmentVariableMutatorType.Prepend:D[m]=b+(D[m]||"");break;case r.EnvironmentVariableMutatorType.Replace:D[m]=b;break}if($.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${E.get($.type)}`;D[d]=(D[d]?D[d]+":":"")+a+"="+this.c(b)}}}}c(D){return D.replaceAll(":","\\x3a")}diff(D,v){const h=new Map,w=new Map,a=new Map;if(D.getVariableMap(v).forEach((f,m)=>{const $=this.getVariableMap(v).get(m),b=A(f,$);b&&h.set(m,b)}),this.getVariableMap(v).forEach((f,m)=>{const $=D.getVariableMap(v).get(m),b=A(f,$);b&&a.set(m,b)}),this.getVariableMap(v).forEach((f,m)=>{const $=D.getVariableMap(v).get(m),b=y(f,$);b&&w.set(m,b)}),!(h.size===0&&w.size===0&&a.size===0))return{added:h,changed:w,removed:a}}getVariableMap(D){const v=new Map;for(const h of this.a.values()){const w=h.filter(a=>R(a,D));w.length>0&&v.set(w[0].variable,w)}return v}getDescriptionMap(D){const v=new Map;for(const h of this.b.values()){const w=h.filter(a=>R(a,D,!0));for(const a of w)v.set(a.extensionIdentifier,a.description)}return v}d(D,v){if(!D.descriptionMap)return;const h=D.descriptionMap.entries();let w=h.next();for(;!w.done;){const a=w.value[1],f=w.value[0];let m=this.b.get(f);m||(m=[],this.b.set(f,m));const $={extensionIdentifier:v,scope:a.scope,description:a.description};$.scope||delete $.scope,m.push($),w=h.next()}}}e.$Js=k;function R(o,D,v=!1){return o.scope?!!(o.scope.workspaceFolder&&D?.workspaceFolder&&o.scope.workspaceFolder.index===D.workspaceFolder.index):v?D===o.scope:!0}function A(o,D){if(!D)return o;const v=new Set;D.forEach(w=>v.add(w.extensionIdentifier));const h=[];return o.forEach(w=>{v.has(w.extensionIdentifier)||h.push(w)}),h.length===0?void 0:h}function y(o,D){if(!D)return;const v=new Map;D.forEach(w=>v.set(w.extensionIdentifier,w));const h=[];return o.forEach(w=>{const a=v.get(w.extensionIdentifier);a&&(w.type!==a.type||w.value!==a.value||w.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&h.push(a)}),h.length===0?void 0:h}}),define(ve[97],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=n,e.$Es=r,e.$Fs=E,e.$Gs=k,e.$Hs=R,e.$Is=A;function n(y){return[...y.entries()]}function r(y){return y?[...y.entries()]:[]}function E(y){return new Map(y)}function k(y){return new Map(y??[])}function R(y){return Array.from(y.entries()).map(o=>[o[0],n(o[1].map),r(o[1].descriptionMap)])}function A(y){return new Map(y.map(o=>[o[0],{map:E(o[1]),descriptionMap:k(o[2])}]))}}),define(ve[282],Se([1,0,14,19,6,2,12]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;let A=class extends k.$Xc{constructor(o,D){super(),this.h=D,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$ne),this.onCreateRequest=this.g.event,this.b=o===void 0?15e3:o,this.B((0,k.$Vc)(()=>{for(const v of this.f.values())(0,k.$Sc)(v)}))}createRequest(o){return new Promise((D,v)=>{const h=++this.a;this.c.set(h,D),this.g.fire({requestId:h,...o});const w=new r.$ye;(0,n.$Hh)(this.b,w.token).then(()=>v(`Request ${h} timed out (${this.b}ms)`)),this.f.set(h,[(0,k.$Vc)(()=>w.cancel())])})}acceptReply(o,D){const v=this.c.get(o);v?(this.c.delete(o),(0,k.$Sc)(this.f.get(o)||[]),this.f.delete(o),v(D)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${o}`)}};e.$us=A,e.$us=A=Be([je(1,R.$ak)],A)}),define(ve[53],Se([1,0,5,42,38]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new r.$Xj("terminalTabFocusMode",!1,!0);var k;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var A;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(A||(e.PosixShellType=A={}));var y;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(y||(e.WindowsShellType=y={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var D;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(D||(e.TerminalIpcChannels=D={}));var v;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$ns=(0,n.$Gi)("ptyService");var h;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(h||(e.HeartbeatConstants=h={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var a;(function(t){t.TerminalView="view",t.Editor="editor"})(a||(e.TerminalLocationString=a={}));var f;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(f||(e.LocalReconnectConstants=f={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var b;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(b||(e.ShellIntegrationStatus=b={}));var d;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class p{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(l){const i=this.b(l.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,l)}getTerminalBackend(l){return this.a.get(this.b(l))}b(l){return l?.toLowerCase()??""}}E.$ro.add(e.$os.Backend,new p),e.$ps=(0,n.$Gi)("localPtyService"),e.$qs=(0,n.$Gi)("terminalLogService")}),define(ve[136],Se([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=r,e.$RQ=E,e.$SQ=k,e.$TQ=R;function r(A){let y=A;y.includes("\\")&&(y=y.replace(/\\/g,"\\\\"));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return y=y.replace(o,""),`'${y}'`}function E(A,y,o){if(!A)return"";if(!y)return A;y.match(/[\/\\]$/)&&(y=y.slice(0,y.length-1));const D=A.replace(/\\/g,"/").toLowerCase(),v=y.replace(/\\/g,"/").toLowerCase();return D.includes(v)?`~${o}${A.slice(y.length+1)}`:A}function k(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),n.OS===n.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function R(A){return!A.strictEnv}}),define(ve[283],Se([1,0,57,4,226,82]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=R,e.$ws=o,e.$xs=D,e.$ys=v;function R(h,w){const a=[{name:null,description:(0,E.localize)(0,null)}];return a.push(...h.map(f=>({name:f.profileName,description:A(f)}))),w&&a.push(...w.map(f=>({name:f.title,description:y(f)}))),{values:a.map(f=>f.name),markdownDescriptions:a.map(f=>f.description)}}function A(h){let w=`$(${k.ThemeIcon.isThemeIcon(h.icon)?h.icon.id:h.icon?h.icon:n.$6j.terminal.id}) ${h.profileName}
- path: ${h.path}`;return h.args&&(typeof h.args=="string"?w+=`
- args: "${h.args}"`:w+=`
- args: [${h.args.length===0?"":`'${h.args.join("','")}'`}]`),h.overrideName!==void 0&&(w+=`
- overrideName: ${h.overrideName}`),h.color&&(w+=`
- color: ${h.color}`),h.env&&(w+=`
- env: ${JSON.stringify(h.env)}`),w}function y(h){return`$(${k.ThemeIcon.isThemeIcon(h.icon)?h.icon.id:h.icon?h.icon:n.$6j.terminal.id}) ${h.title}
- extensionIdentifier: ${h.extensionIdentifier}`}function o(h,w){if(!h&&!w)return!0;if(typeof h=="string"&&typeof w=="string")return h===w;if(Array.isArray(h)&&Array.isArray(w)){if(h.length!==w.length)return!1;for(let a=0;a<h.length;a++)if(h[a]!==w[a])return!1;return!0}return!1}function D(h,w){if(!h&&!w)return!0;if(!h||!w)return!1;if(k.ThemeIcon.isThemeIcon(h)&&k.ThemeIcon.isThemeIcon(w))return h.id===w.id&&h.color===w.color;if(typeof h=="object"&&"light"in h&&"dark"in h&&typeof w=="object"&&"light"in w&&"dark"in w){const a=h,f=w;if((r.URI.isUri(a.light)||v(a.light))&&(r.URI.isUri(a.dark)||v(a.dark))&&(r.URI.isUri(f.light)||v(f.light))&&(r.URI.isUri(f.dark)||v(f.dark)))return a.light.path===f.light.path&&a.dark.path===f.dark.path}if(r.URI.isUri(h)&&r.URI.isUri(w)||v(h)||v(w)){const a=h,f=w;return a.path===f.path&&a.scheme===f.scheme}return!1}function v(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}}),define(ve[284],Se([1,0,57,3,225,46,38,53,283]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=void 0,e.$Bs=a,e.$Cs=m,e.$zs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$As={type:"string",enum:Array.from((0,n.$4j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,n.$4j)(),$=>`$(${$.id})`)};const o={args:{description:(0,E.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(1,null),type:"boolean"},icon:{description:(0,E.localize)(2,null),...e.$As},color:{description:(0,E.localize)(3,null),...e.$zs},env:{markdownDescription:(0,E.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},D={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(5,null),type:["string","array"],items:{type:"string"}},...o}},v={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(6,null),type:["string"],items:{type:"string"}},...o}};function h($){const b=$===r.Platform.Linux?"linux":$===r.Platform.Mac?"osx":"windows";return(0,E.localize)(7,null,(0,r.$h)($),'```json\n"terminal.integrated.profile.'+b+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,E.localize)(8,null),type:"object",properties:{[A.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:h(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(12,null),enum:["PowerShell","Git Bash"]},...o}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(13,null),type:"string"},id:{description:(0,E.localize)(14,null),type:"string"},title:{description:(0,E.localize)(15,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:h(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(16,null),type:"string"},id:{description:(0,E.localize)(17,null),type:"string"},title:{description:(0,E.localize)(18,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:h(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(19,null),type:"string"},id:{description:(0,E.localize)(20,null),type:"string"},title:{description:(0,E.localize)(21,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(22,null),type:"boolean",default:!0},[A.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,E.localize)(23,null),type:"boolean",default:!0},[A.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(24,null),type:"number",default:100},[A.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,E.localize)(25,null),type:"boolean",default:!0},[A.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){R.$ro.as(k.$wo.Configuration).registerConfiguration(w),m()}let f;function m($,b){const d=R.$ro.as(k.$wo.Configuration);let p;$&&(p=(0,y.$vs)($?.profiles,b));const t=f;f={id:"terminal",order:100,title:(0,E.localize)(27,null),type:"object",properties:{[A.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(28,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Linux?p?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Linux?p?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(29,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Macintosh?p?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Macintosh?p?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(30,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Windows?p?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Windows?p?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[f],remove:t?[t]:[]})}}),define(ve[285],Se([1,0,2,13,117,28,118]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=void 0;let A=class extends n.$Xc{constructor(o,D){super(),this.a=o,this.b=D}start(){const o={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},D=(0,R.$0m)(this.b.args,this.b.isBuilt);D&&(D.break&&D.port?o.debugBrk=D.port:!D.break&&D.port&&(o.debug=D.port));const v=new E.$gr(r.$1g.asFileUri("bootstrap-fork").fsPath,o),h=new n.$Wc;return h.add(v),{client:v,store:h,onDidProcessExit:v.onDidProcessExit}}};e.$wR=A,e.$wR=A=Be([je(1,k.$Ni)],A)}),define(ve[286],Se([1,0,32,13,21,9,3,33,17,11,25,134,97,135]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=a,e.$Ls=f,e.$Ms=m,n=qe(n),k=qe(k),A=qe(A),D=qe(D);function a(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return u&&u.length===4&&(S=parseInt(u[3])),S}async function f(u,S,P,C=A.env,L=D.Promises.exists){if(k.$lc(u))return await L(u)?u:void 0;if(S===void 0&&(S=A.cwd()),k.$pc(u)!=="."){const Y=k.$mc(S,u);return await L(Y)?Y:void 0}const I=(0,E.$lo)(C,"PATH");if(P===void 0&&(0,o.$gg)(I)&&(P=I.split(k.$wc)),P===void 0||P.length===0){const Y=k.$mc(S,u);return await L(Y)?Y:void 0}for(const Y of P){let Q;if(k.$lc(Y)?Q=k.$mc(Y,u):Q=k.$mc(S,Y,u),await L(Q))return Q;if(R.$i){let re=Q+".com";if(await L(re)||(re=Q+".exe",await L(re)))return re}}const q=k.$mc(S,u);return await L(q)?q:void 0}function m(u,S,P,C,L){const T=R.$i&&(!S.windowsEnableConpty||a()<18309);if(!S.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||T)return;const I=u.args,q=A.$gc==="win32"?k.$qc(u.executable).toLowerCase():k.$qc(u.executable),Y=k.$pc(r.$1g.asFileUri("").fsPath);let Q;const re={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(re.VSCODE_NONCE=S.shellIntegration.nonce),R.$i){if(q==="pwsh.exe"||q==="powershell.exe")return!I||s(I)?Q=d.get(b.WindowsPwsh):g(I)&&(Q=d.get(b.WindowsPwshLogin)),Q?(Q=[...Q],Q[Q.length-1]=(0,y.$ff)(Q[Q.length-1],Y,""),re.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),{newArgs:Q,envMixin:re}):void 0;if(q==="bash.exe")return!I||I.length===0?Q=d.get(b.Bash):c(I)&&(re.VSCODE_SHELL_LOGIN="1",$(S,re),Q=d.get(b.Bash)),Q?(Q=[...Q],Q[Q.length-1]=(0,y.$ff)(Q[Q.length-1],Y),re.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:Q,envMixin:re}):void 0;C.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(q){case"bash":return!I||I.length===0?Q=d.get(b.Bash):c(I)&&(re.VSCODE_SHELL_LOGIN="1",$(S,re),Q=d.get(b.Bash)),Q?(Q=[...Q],Q[Q.length-1]=(0,y.$ff)(Q[Q.length-1],Y),re.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:Q,envMixin:re}):void 0;case"fish":{const te=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=k.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return re.XDG_DATA_DIRS=`${te}:${_}`,$(S,re),{newArgs:void 0,envMixin:re}}case"pwsh":return!I||s(I)?Q=d.get(b.Pwsh):g(I)&&(Q=d.get(b.PwshLogin)),Q?(S.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),Q=[...Q],Q[Q.length-1]=(0,y.$ff)(Q[Q.length-1],Y,""),re.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:Q,envMixin:re}):void 0;case"zsh":{if(!I||I.length===0?Q=d.get(b.Zsh):c(I)?(Q=d.get(b.ZshLogin),$(S,re)):(I===d.get(b.Zsh)||I===d.get(b.ZshLogin))&&(Q=I),!Q)return;Q=[...Q],Q[Q.length-1]=(0,y.$ff)(Q[Q.length-1],Y);let te;try{te=n.userInfo().username}catch{te="unknown"}const _=k.$mc(n.tmpdir(),`${te}-${L.applicationName}-zsh`);re.ZDOTDIR=_;const de=P?.ZDOTDIR??n.homedir()??"~";re.USER_ZDOTDIR=de;const J=[];return J.push({source:k.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.$mc(_,".zshrc")}),J.push({source:k.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.$mc(_,".zprofile")}),J.push({source:k.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.$mc(_,".zshenv")}),J.push({source:k.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.$mc(_,".zlogin")}),{newArgs:Q,envMixin:re,filesToCopy:J}}}C.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function $(u,S){if(R.$j&&u.environmentVariableCollections){const P=(0,h.$Is)(u.environmentVariableCollections),L=new w.$Js(P).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),T=[];if(L)for(const I of L)I.type===v.EnvironmentVariableMutatorType.Prepend&&T.push(I.value);T.length>0&&(S.VSCODE_PATH_PREFIX=T.join(""))}}var b;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(b||(b={}));const d=new Map;d.set(b.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(b.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(b.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(b.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(b.Zsh,["-i"]),d.set(b.ZshLogin,["-il"]),d.set(b.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],t=["--login","-l"],l=["-i","--interactive"],i=["-nol","-nologo"];function g(u){return typeof u=="string"?p.includes(u.toLowerCase()):u.length===1&&p.includes(u[0].toLowerCase())||u.length===2&&(p.includes(u[0].toLowerCase())||p.includes(u[1].toLowerCase()))&&(i.includes(u[0].toLowerCase())||i.includes(u[1].toLowerCase()))}function s(u){return typeof u=="string"?i.includes(u.toLowerCase()):u.length===0||u?.length===1&&i.includes(u[0].toLowerCase())}function c(u){return typeof u!="string"&&(u=u.filter(S=>!l.includes(S.toLowerCase()))),u==="string"&&t.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&t.includes(u[0].toLowerCase())}}),define(ve[287],Se([1,0,60,57,9,3,11,25,113,53,286,83]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=f,n=qe(n),A=qe(A);var h;(function(S){S.UnixShellsPath="/etc/shells"})(h||(h={}));let w,a=!0;function f(S,P,C,L,T=process.env,I,q,Y,Q){return I=I||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},k.$i?m(C,I,T,q,L.getValue(o.TerminalSettingId.UseWslProfiles)!==!1,S&&typeof S=="object"?{...S}:L.getValue(o.TerminalSettingId.ProfilesWindows),typeof P=="string"?P:L.getValue(o.TerminalSettingId.DefaultProfileWindows),Q,Y):s(I,q,C,S&&typeof S=="object"?{...S}:L.getValue(k.$k?o.TerminalSettingId.ProfilesLinux:o.TerminalSettingId.ProfilesMacOs),typeof P=="string"?P:L.getValue(k.$k?o.TerminalSettingId.DefaultProfileLinux:o.TerminalSettingId.DefaultProfileMacOs),Q,Y,T)}async function m(S,P,C,L,T,I,q,Y,Q){const re=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),te=`${process.env.windir}\\${re?"Sysnative":"System32"}`;let _=!1;(0,D.$Ks)()>=16299&&(_=!0),await p(Y);const de=new Map;if(S){de.set("PowerShell",{source:o.ProfileSource.Pwsh,icon:r.$6j.terminalPowershell,isAutoDetected:!0}),de.set("Windows PowerShell",{path:`${te}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$6j.terminalPowershell,isAutoDetected:!0}),de.set("Git Bash",{source:o.ProfileSource.GitBash,isAutoDetected:!0}),de.set("Command Prompt",{path:`${te}\\cmd.exe`,icon:r.$6j.terminalCmd,isAutoDetected:!0}),de.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),de.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$6j.terminalBash,isAutoDetected:!0});const ae=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;de.set("Cmder",{path:`${te}\\cmd.exe`,args:["/K",ae],requiresPath:process.env.CMDER_ROOT?ae:{path:ae,isUnsafe:!0},isAutoDetected:!0})}c(I,de);const J=await $(de.entries(),q,P,C,L,Q);if(S&&T)try{const ae=await i(`${te}\\${_?"wsl":"bash"}.exe`,q);for(const z of ae)(!I||!(z.profileName in I))&&J.push(z)}catch{a&&(L?.trace("WSL is not installed, so could not detect WSL profiles"),a=!1)}return J}async function $(S,P,C,L=process.env,T,I){const q=[];for(const[Y,Q]of S)q.push(b(Y,Q,P,C,L,T,I));return(await Promise.all(q)).filter(Y=>!!Y)}async function b(S,P,C,L,T=process.env,I,q){if(P===null)return;let Y,Q,re;if("source"in P&&!("path"in P)){const J=w?.get(P.source);if(!J)return;Y=J.paths,Q=P.args||J.args,P.icon?re=d(P.icon):J.icon&&(re=J.icon)}else Y=Array.isArray(P.path)?P.path:[P.path],Q=k.$i||Array.isArray(P.args)?P.args:void 0,re=d(P.icon);let te;if(q){const J=Y.map(z=>typeof z=="string"?z:z.path),ae=await q(J);te=new Array(Y.length);for(let z=0;z<Y.length;z++)typeof Y[z]=="string"?te[z]=ae[z]:te[z]={path:ae[z],isUnsafe:!0}}else te=Y.slice();let _;if(P.requiresPath){let J;if((0,R.$gg)(P.requiresPath)?J=P.requiresPath:(J=P.requiresPath.path,P.requiresPath.isUnsafe&&(_=J)),!await L.existsFile(J))return}const de=await u(S,C,te,L,T,Q,P.env,P.overrideName,P.isAutoDetected,_);if(!de){I?.debug("Terminal profile not validated",S,Y);return}return de.isAutoDetected=P.isAutoDetected,de.icon=re,de.color=P.color,de}function d(S){return typeof S=="string"?{id:S}:S}async function p(S){if(w&&!S)return;const[P,C]=await Promise.all([t(),S||l()]);w=new Map,w.set(o.ProfileSource.GitBash,{profileName:"Git Bash",paths:P,args:["--login","-i"]}),w.set(o.ProfileSource.Pwsh,{profileName:"PowerShell",paths:C,icon:r.$6j.terminalPowershell})}async function t(){const S=new Set,P=await(0,D.$Ls)("git.exe");if(P){const T=(0,v.dirname)(P);S.add((0,v.resolve)(T,"../.."))}function C(T,I){I&&T.add(I)}C(S,process.env.ProgramW6432),C(S,process.env.ProgramFiles),C(S,process.env["ProgramFiles(X86)"]),C(S,`${process.env.LocalAppData}\\Program`);const L=[];for(const T of S)L.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function l(){const S=[];for await(const P of(0,y.$wm)())S.push(P.exePath);return S}async function i(S,P){const C=[],L=await new Promise((q,Y)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Q,re)=>{if(Q)return Y("Problem occurred when getting wsl distros");q(re)})});if(!L)return[];const T=new RegExp(/[\r?\n]/),I=L.split(T).filter(q=>q.trim().length>0&&q!=="");for(const q of I){if(q===""||q.startsWith("docker-desktop"))continue;const Y=`${q} (WSL)`,Q={profileName:Y,path:S,args:["-d",`${q}`],isDefault:Y===P,icon:g(q),isAutoDetected:!1};C.push(Q)}return C}function g(S){return S.includes("Ubuntu")?r.$6j.terminalUbuntu:S.includes("Debian")?r.$6j.terminalDebian:r.$6j.terminalLinux}async function s(S,P,C,L,T,I,q,Y){const Q=new Map;if(C&&await S.existsFile(h.UnixShellsPath)){const re=(await S.readFile(h.UnixShellsPath)).toString(),te=(I||re.split(`
`)).map(de=>{const J=de.indexOf("#");return J===-1?de:de.substring(0,J)}).filter(de=>de.trim().length>0),_=new Map;for(const de of te){let J=(0,E.$qc)(de),ae=_.get(J)||0;ae++,ae>1&&(J=`${J} (${ae})`),_.set(J,ae),Q.set(J,{path:de,isAutoDetected:!0})}}return c(L,Q),await $(Q.entries(),T,S,Y,P,q)}function c(S,P){if(S)for(const[C,L]of Object.entries(S))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?P.delete(C):(L.icon=L.icon||P.get(C)?.icon,P.set(C,L))}async function u(S,P,C,L,T,I,q,Y,Q,re){if(C.length===0)return Promise.resolve(void 0);const te=C.shift();if(te==="")return u(S,P,C,L,T,I,q,Y,Q);const _=typeof te!="string"&&te.isUnsafe,de=typeof te=="string"?te:te.path,J={profileName:S,path:de,args:I,env:q,overrideName:Y,isAutoDetected:Q,isDefault:S===P,isUnsafePath:_,requiresUnsafePath:re};if((0,E.$qc)(de)===de){const z=T.PATH?T.PATH.split(E.$wc):void 0,B=await(0,D.$Ls)(de,void 0,z,void 0,L.existsFile);return B?(J.path=B,J.isFromPath=!0,J):u(S,P,C,L,T,I)}return await L.existsFile((0,E.$kc)(de))?J:u(S,P,C,L,T,I,q,Y,Q)}}),define(ve[288],Se([1,0,6,2,3,51,27,12,124,94,282,53,284,287,116,48]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;var m;(function(b){b[b.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let $=class extends r.$Xc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,p,t,l){super(),this.M=d,this.N=p,this.O=t,this.P=l,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ne),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ne),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ne),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ne),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ne),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ne),this.onProcessData=this.D.event,this.F=this.B(new n.$ne),this.onProcessReady=this.F.event,this.G=this.B(new n.$ne),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ne),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ne),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ne),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ne),this.onProcessExit=this.L.event,(0,h.$Bs)(),this.B(this.M),this.B((0,r.$Vc)(()=>this.W())),this.j=this.B(new D.$us(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(v.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$i)return process.env;try{return await(0,o.$Rm)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),p=d.client;this.O.getLevel()===A.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(p.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const l=k.ProxyChannel.toService(p.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(i=>this.D.fire(i))),this.B(l.onProcessReady(i=>this.F.fire(i))),this.B(l.onProcessExit(i=>this.L.fire(i))),this.B(l.onDidChangeProperty(i=>this.J.fire(i))),this.B(l.onProcessReplay(i=>this.G.fire(i))),this.B(l.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(l.onDidRequestDetach(i=>this.I.fire(i))),this.B(new y.$ts(this.P,p.getChannel(v.TerminalIpcChannels.Logger))),this.a=d,this.b=l,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(v.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[d,l]}async createProcess(d,p,t,l,i,g,s,c,u,S,P){const C=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(d,p,t,l,i,g,s,c,u,S,P);return clearTimeout(C),L}updateTitle(d,p,t){return this.f.updateTitle(d,p,t)}updateIcon(d,p,t,l){return this.f.updateIcon(d,p,t,l)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,p){return this.f.detachFromProcess(d,p)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,p){return this.f.shutdown(d,p)}input(d,p){return this.f.input(d,p)}processBinary(d,p){return this.f.processBinary(d,p)}resize(d,p,t){return this.f.resize(d,p,t)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,p){return this.f.acknowledgeDataEvent(d,p)}setUnicodeVersion(d,p){return this.f.setUnicodeVersion(d,p)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new f.$he,p=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...p]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,p){return this.f.installAutoReply(d,p)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,a.$Am)(d??E.OS,process.env)}async getProfiles(d,p,t,l=!1){const i=await this.S();return(0,w.$Ns)(p,t,l,this.N,i,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,p){return this.f.getWslPath(d,p)}getRevivedPtyNewId(d,p){return this.f.getRevivedPtyNewId(d,p)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,p){return this.f.requestDetachInstance(d,p)}async acceptDetachInstanceReply(d,p){return this.f.acceptDetachInstanceReply(d,p)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,p,t){return this.f.reviveTerminalProcesses(d,p,t)}async refreshProperty(d,p){return this.f.refreshProperty(d,p)}async updateProperty(d,p,t){return this.f.updateProperty(d,p,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,p){return this.j.createRequest({workspaceId:d,originalText:p})}async acceptPtyHostResolvedVariables(d,p){this.j.acceptReply(d,p)}};e.$Os=$,e.$Os=$=Be([je(1,R.$aj),je(2,A.$ak),je(3,A.$bk)],$)}),define(ve[36],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,n.$Gi)("IUriIdentityService")}),define(ve[137],Se([1,0,36,120,16,20,168,6,2]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class o{static{this._clock=0}constructor(h){this.uri=h,this.time=o._clock++}touch(){return this.time=o._clock++,this}}let D=class{constructor(h){this.g=h,this.c=new y.$Wc,this.f=2**16;const w=new Map,a=f=>{let m=w.get(f.scheme);return m===void 0&&(m=h.hasProvider(f)&&!this.g.hasCapability(f,E.FileSystemProviderCapabilities.PathCaseSensitive),w.set(f.scheme,m)),m};this.c.add(A.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(f=>{w.delete(f.scheme)})),this.extUri=new k.$9g(a),this.d=new R.$Rs((f,m)=>this.extUri.compare(f,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,k.$ih)(h));const w=this.d.get(h);return w?w.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new o(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((a,f)=>a[1].time<f[1].time?1:a[1].time>f[1].time?-1:0);o._clock=0,this.d.clear();const w=this.f*.5;for(let a=0;a<w;a++)this.d.set(h[a][0],h[a][1].touch())}};e.$Ss=D,e.$Ss=D=Be([je(0,E.$al)],D),(0,r.$Ps)(n.$Kl,D,r.InstantiationType.Delayed)}),define(ve[98],Se([1,0,228,9,67,20,4,5,13]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=o,e.$Ri=D,e.$Ui=v,e.$Vi=h,e.$Wi=w,e.$Xi=f,e.$Yi=m,e.$2i=d,e.$7i=p,e.$8i=t,e.$0i=l,e.$$i=i,e.$_i=g,e.$Pi=(0,A.$Gi)("contextService");function o(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}function D(s){return typeof s?.id=="string"&&!o(s)&&!h(s)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function v(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$qc)(s)}:c?e.$Si:e.$Ti;const u=s;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function h(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}function w(s){const c=s;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const u=s;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(s?.id)return{id:s.id}}var a;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function f(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(s){const c=s;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class ${constructor(c,u,S,P,C){this.h=c,this.j=S,this.k=P,this.l=C,this.c=E.$Mi.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=E.$Mi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=$;class b{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,k.$hh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=b;function d(s){return new b({uri:s,index:0,name:(0,k.$dh)(s)},{uri:s.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,n.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function p(s,c){return k.$$g.isEqualOrParent(s,c.untitledWorkspacesHome)}function t(s){let c;return R.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===y.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(s){return s.id===e.$9i}function i(s,c){return!p(s,c)&&!t(s)}function g(s){return(typeof s=="string"?(0,r.$rc)(s):(0,k.$fh)(s))===e.$4i}}),define(ve[34],Se([1,0,66,6,2,20,4,227,28,16,5,12,98,26,36,14,23,17,11]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=p,e.$Nl=t,e.$Ol=l;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function p(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Ml=(0,D.$Gi)("IUserDataProfilesService");function t(s,c){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:c}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:c}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function l(s,c,u,S,P,C){return{id:s,name:c,location:u,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:C&&P?.useDefaultFlags?.globalState?C.globalStorageHome:(0,k.$hh)(u,"globalStorage"),settingsResource:C&&P?.useDefaultFlags?.settings?C.settingsResource:(0,k.$hh)(u,"settings.json"),keybindingsResource:C&&P?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,k.$hh)(u,"keybindings.json"),tasksResource:C&&P?.useDefaultFlags?.tasks?C.tasksResource:(0,k.$hh)(u,"tasks.json"),snippetsHome:C&&P?.useDefaultFlags?.snippets?C.snippetsHome:(0,k.$hh)(u,"snippets"),extensionsResource:C&&P?.useDefaultFlags?.extensions?C.extensionsResource:(0,k.$hh)(u,"extensions.json"),cacheHome:(0,k.$hh)(S,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let i=class extends E.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,u,S,P){super(),this.t=c,this.u=u,this.w=S,this.y=P,this.f=!0,this.h=this.B(new r.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Dc,workspaces:new w.$Dc,emptyWindows:new Map},this.profilesHome=(0,k.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),u=[c];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,b.$gg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}u.push(l((0,k.$eh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},c))}}catch(C){this.y.error(C)}const S=new w.$Dc,P=new Map;if(u.length)try{const C=this.Q();if(C.workspaces)for(const[L,T]of Object.entries(C.workspaces)){const I=R.URI.parse(L),q=u.find(Y=>Y.id===T);q&&S.set(I,q)}if(C.emptyWindows)for(const[L,T]of Object.entries(C.emptyWindows)){const I=u.find(q=>q.id===T);I&&P.set(L,I)}}catch(C){this.y.error(C)}this.z={profiles:u,workspaces:S,emptyWindows:P}}return this.z}D(){const c=l("__default__profile__",(0,A.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",S=new RegExp(`${(0,$.$jf)(u)}\\s(\\d+)`);let P=0;for(const L of this.profiles){const T=S.exec(L.name),I=T?parseInt(T[1]):0;P=I>P?I:P}const C=`${u} ${P+1}`;return this.createProfile((0,n.$uj)((0,m.$3g)()).toString(16),C,{transient:!0},c)}async createNamedProfile(c,u,S){return this.createProfile((0,n.$uj)((0,m.$3g)()).toString(16),c,u,S)}async createProfile(c,u,S,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(c,u,S);return P&&await this.setProfileForWorkspace(P,C),C}async F(c,u,S){if(!(0,b.$gg)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(u);return P||(P=(async()=>{try{if(this.profiles.find(I=>I.name===u||I.id===c))throw new Error(`Profile with ${u} name already exists`);const L=l(c,u,(0,k.$hh)(this.profilesHome,c),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const T=[];return this.j.fire({profile:L,join(I){T.push(I)}}),await f.Promises.settled(T),this.I([L],[],[]),L}finally{this.r.delete(u)}})(),this.r.set(u,P)),P}async updateProfile(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(P=>P.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);return S=l(S.id,u.name??S.name,S.location,this.g,{shortName:u.shortName??S.shortName,icon:u.icon===null?void 0:u.icon??S.icon,transient:u.transient??S.isTransient,useDefaultFlags:u.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(P=>P.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const S=[];this.m.fire({profile:u,join(P){S.push(P)}});try{await Promise.allSettled(S)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(P){(0,o.$rl)(P)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(P)}}async setProfileForWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(P=>P.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);this.L(c,S)}unsetWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,u)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.G(c),S=R.URI.isUri(u)?this.C.workspaces.get(u):this.C.emptyWindows.get(u);return S||((0,h.$Qi)(c)?this.s.folders.get(c.uri):(0,h.$Vi)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,h.$Qi)(c)?c.uri:(0,h.$Vi)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.folders.values()].some(u=>this.w.extUri.isEqual(u.location,c.location)))}I(c,u,S){const P=[...this.profiles,...c],C=[],L=this.s.profiles;this.s.profiles=[];for(let T of P){if(T.isDefault||u.some(q=>T.id===q.id))continue;T=S.find(q=>T.id===q.id)??T;const I=L.find(q=>T.id===q.id);if(T.isTransient)this.s.profiles.push(T);else{if(I){for(const[q,Y]of this.s.emptyWindows.entries())if(T.id===Y.id){this.L({id:q},T);break}for(const[q,Y]of this.s.workspaces.entries())if(T.id===Y.id){this.L({id:"",configPath:q},T);break}for(const[q,Y]of this.s.folders.entries())if(T.id===Y.id){this.L({id:"",uri:q},T);break}}C.push({location:T.location,name:T.name,shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(c,u,S)}J(c,u,S){this.h.fire({added:c,removed:u,updated:S,all:this.profiles})}L(c,u,S){if(S=u?.isTransient?!0:S,S)(0,h.$Qi)(c)?(this.s.folders.delete(c.uri),u&&this.s.folders.set(c.uri,u)):(0,h.$Vi)(c)?(this.s.workspaces.delete(c.configPath),u&&this.s.workspaces.set(c.configPath,u)):(this.s.emptyWindows.delete(c.id),u&&this.s.emptyWindows.set(c.id,u));else{this.L(c,void 0,!0);const P=this.G(c);R.URI.isUri(P)?(this.C.workspaces.delete(P),u&&this.C.workspaces.set(P,u)):(this.C.emptyWindows.delete(P),u&&this.C.emptyWindows.set(P,u)),this.M()}}M(){const c={};for(const[S,P]of this.C.workspaces.entries())c[S.toString()]=P.id;const u={};for(const[S,P]of this.C.emptyWindows.entries())u[S.toString()]=P.id;this.R({workspaces:c,emptyWindows:u}),this.z=void 0}N(c){const u={},S=this.D();if(c.workspaces)for(const[C,L]of Object.entries(c.workspaces)){const T=R.URI.parse(L);u[C]=this.w.extUri.isEqual(T,S.location)?S.id:this.w.extUri.basename(T)}const P={};if(c.emptyWindows)for(const[C,L]of Object.entries(c.emptyWindows)){const T=R.URI.parse(L);P[C]=this.w.extUri.isEqual(T,S.location)?S.id:this.w.extUri.basename(T)}return{workspaces:u,emptyWindows:P}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Pl=i,e.$Pl=i=Be([je(0,y.$Ni),je(1,o.$al),je(2,a.$Kl),je(3,v.$ak)],i);class g extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Ql=g}),define(ve[99],Se([1,0,18,14,19,10,6,2,3,11,4,207,30,39,22,74,12,29,24,36,34]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=void 0,e.$Eq=l,v=qe(v);let t=class extends A.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(c,u,S,P,C,L){super(),this.z=c,this.C=u,this.D=S,this.F=P,this.G=C,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new R.$ne),this.s=this.B(new R.$ne),this.t=this.B(new R.$ne),this.u=this.B(new R.$ne),this.w=this.B(new R.$ne),this.y=[],this.B((0,A.$Vc)(()=>{this.j.forEach(({task:T})=>T.cancel()),this.m.forEach(T=>T.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(S=>(0,h.$hp)(S,c.allTargetPlatforms,u))}async installFromGallery(c,u={}){try{const P=(await this.installGalleryExtensions([{extension:c,options:u}])).find(({identifier:C})=>(0,w.$Kp)(C,c.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new h.$lp(`Unknown error while installing extension ${c.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(S){throw l(S)}}async installGalleryExtensions(c){if(!this.z.isEnabled())throw new h.$lp(v.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const u=[],S=[];return await Promise.allSettled(c.map(async({extension:P,options:C})=>{try{const L=await this.N(P,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.G.version,date:this.G.date});S.push({...L,options:C})}catch(L){u.push({identifier:P.identifier,operation:h.InstallOperation.Install,source:P,error:L,profileLocation:C.profileLocation??this.X()})}})),S.length&&u.push(...await this.I(S)),u}async uninstall(c,u={}){return this.F.trace("ExtensionManagementService#uninstall",c.identifier.id),this.P(c,u)}async toggleAppliationScope(c,u){if((0,a.$un)(c.manifest)||c.isBuiltin)return c;if(c.isApplicationScoped){let S=await this.updateMetadata(c,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)||(S=await this.$(c,this.H.defaultProfile.extensionsResource,u));for(const P of this.H.profiles){const C=(await this.getInstalled(a.ExtensionType.User,P.extensionsResource)).find(L=>(0,w.$Kp)(L.identifier,c.identifier));C?this.w.fire({local:C,profileLocation:P.extensionsResource}):this.u.fire({identifier:c.identifier,profileLocation:P.extensionsResource})}return S}else{const S=this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(c,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(c,u,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:S.identifier,operation:h.InstallOperation.Install,local:S,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),S}}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.g||c-this.h>1e3*60*5)&&(this.g=this.W(),this.h=c),this.g}registerParticipant(c){this.y.push(c)}async I(c){const u=new Map,S=new Map,P=[],C=(T,I)=>`${w.$Lp.create(T).toString()}-${I.toString()}`,L=(T,I,q,Y)=>{const Q=this.Y(T,I,q),re=`${(0,w.$Pp)(T.publisher,T.name)}-${q.profileLocation.toString()}`;S.set(re,{task:Q,root:Y}),this.n.fire({identifier:Q.identifier,source:I,profileLocation:q.profileLocation}),this.F.info("Installing extension:",Q.identifier.id,q),D.URI.isUri(I)||this.j.set(C(I,q.profileLocation),{task:Q,waitingTasks:[]})};try{for(const{manifest:T,extension:I,options:q}of c){const Y=q.isApplicationScoped||q.isBuiltin||(0,a.$un)(T),Q={...q,installOnlyNewlyAddedFromExtensionPack:q.installOnlyNewlyAddedFromExtensionPack??!D.URI.isUri(I),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:q.profileLocation??this.X(),productVersion:q.productVersion??{version:this.G.version,date:this.G.date}},re=D.URI.isUri(I)?void 0:this.j.get(C(I,Q.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id,Q.profileLocation.toString()),P.push(re.task.waitUntilTaskIsFinished())):L(T,I,Q,void 0)}return await Promise.all([...S.values()].map(async({task:T})=>{if(T.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const I=await this.M(T.identifier,T.manifest,!!T.options.installOnlyNewlyAddedFromExtensionPack,!!T.options.installPreReleaseVersion,T.options.profileLocation,T.options.productVersion),q=await this.getInstalled(void 0,T.options.profileLocation,T.options.productVersion),Y={...T.options,context:{...T.options.context,[h.$bp]:!0}};for(const{gallery:Q,manifest:re}of(0,n.$Pb)(I,({gallery:te})=>te.identifier.id)){if(S.has(`${Q.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const te=this.j.get(C(Q,Y.profileLocation));if(te){if(this.J(T,te.task)){const _=te.task.identifier;this.F.info("Waiting for already requested installing extension",_.id,T.identifier.id,Y.profileLocation.toString()),te.waitingTasks.push(T),P.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,de=>de.some(J=>(0,w.$Kp)(J.identifier,_)))).then(de=>{if(this.F.info("Finished waiting for already requested installing extension",_.id,T.identifier.id,Y.profileLocation.toString()),!de.find(ae=>(0,w.$Kp)(ae.identifier,_))?.local)throw new Error(`Extension ${_.id} is not installed`)}))}}else q.some(({identifier:_})=>(0,w.$Kp)(_,Q.identifier))||L(re,Q,Y,T)}}catch(I){if(D.URI.isUri(T.source))(0,n.$Ob)(T.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,I.message),(0,n.$Ob)(T.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,I.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),I}})),await this.L([...S.entries()].map(async([T,{task:I}])=>{const q=new Date().getTime();let Y;try{Y=await I.run(),await this.L(this.y.map(Q=>Q.postInstall(Y,I.source,I.options,E.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(Q){const re=l(Q);throw D.URI.isUri(I.source)||i(this.C,I.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Sp)(I.source),error:re,source:I.options.context?.[h.$ap]}),u.set(T,{error:re,identifier:I.identifier,operation:I.operation,source:I.source,context:I.options.context,profileLocation:I.options.profileLocation,applicationScoped:I.options.isApplicationScoped}),this.F.error("Error while installing the extension",I.identifier.id,(0,k.$ab)(re),I.options.profileLocation.toString()),re}if(!D.URI.isUri(I.source)){const Q=I.operation===h.InstallOperation.Update,re=Q?void 0:(new Date().getTime()-I.source.lastUpdated)/1e3;if(i(this.C,Q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Sp)(I.source),verificationStatus:I.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:re,source:I.options.context?.[h.$ap]}),y.$o&&I.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,h.StatisticType.Install)}catch{}}u.set(T,{local:Y,identifier:I.identifier,operation:I.operation,source:I.source,context:I.options.context,profileLocation:I.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),P.length&&await this.L(P),[...u.values()]}catch(T){const I=(Q,re,te)=>{const _=[];Q.manifest.extensionDependencies?.length&&_.push(...Q.manifest.extensionDependencies),Q.manifest.extensionPack?.length&&_.push(...Q.manifest.extensionPack);for(const de of _){if(te.includes(de.toLowerCase()))continue;te.push(de.toLowerCase());const J=u.get(`${de.toLowerCase()}-${re.toString()}`);J?.local&&(te=I(J.local,re,te))}return te},q=Q=>({identifier:Q.identifier,operation:h.InstallOperation.Install,source:Q.source,context:Q.options.context,profileLocation:Q.options.profileLocation,error:T}),Y=[];for(const[Q,{task:re,root:te}]of S){const _=u.get(Q);_?_.local&&te&&!u.get(`${te.identifier.id.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local&&(Y.push(this.Z(_.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),u.set(Q,q(re))):(re.cancel(),u.set(Q,q(re)))}for(const[Q,{task:re}]of S){const te=u.get(Q);if(!te?.local||re.options.donotIncludePackAndDependencies)continue;I(te.local,re.options.profileLocation,[te.local.identifier.id.toLowerCase()]).slice(1).some(de=>S.has(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)&&!u.get(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Z(te.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),u.set(Q,q(re)))}throw Y.length&&await Promise.allSettled(Y.map(async Q=>{try{await Q.run(),this.F.info("Rollback: Uninstalled extension",Q.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",Q.extension.identifier.id,(0,k.$ab)(re))}})),T}finally{for(const{task:T}of S.values())T.source&&!D.URI.isUri(T.source)&&this.j.delete(C(T.source,T.options.profileLocation));if(u.size){const T=[...u.values()];for(const I of T)I.local&&this.F.info("Extension installed successfully:",I.identifier.id,I.profileLocation.toString());this.s.fire(T)}}}J(c,u){for(const[,{task:S,waitingTasks:P}]of this.j.entries())if(S===c&&(P.includes(u)||P.some(C=>this.J(C,u)))||S===u&&P[0]&&!this.J(c,P[0]))return!1;return!0}async L(c,u){const S=[],P=[],C=await Promise.allSettled(c);for(const T of C)T.status==="fulfilled"?S.push(T.value):P.push(l(T.reason,u));if(!P.length)return S;if(P.length===1)throw P[0];let L=new h.$lp("",h.ExtensionManagementErrorCode.Unknown);for(const T of P)L=new h.$lp(L.message?`${L.message}, ${T.message}`:T.message,T.code!==h.ExtensionManagementErrorCode.Unknown&&T.code!==h.ExtensionManagementErrorCode.Internal?T.code:L.code);throw L}async M(c,u,S,P,C,L){if(!this.z.isEnabled())return[];const T=await this.getInstalled(void 0,C,L),I=[],q=[],Y=async(Q,re)=>{I.push(Q);const te=re.extensionDependencies||[],_=[...te];if(re.extensionPack){const de=S?T.find(J=>(0,w.$Kp)(J.identifier,Q)):void 0;for(const J of re.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(ae=>(0,w.$Kp)({id:ae},{id:J}))||_.every(ae=>!(0,w.$Kp)({id:ae},{id:J}))&&_.push(J)}if(_.length){const de=_.filter(J=>I.every(ae=>!(0,w.$Kp)(ae,{id:J})));if(de.length){const J=await this.z.getExtensions(de.map(ae=>({id:ae,preRelease:P})),E.CancellationToken.None);for(const ae of J){if(I.find(ie=>(0,w.$Kp)(ie,ae.identifier)))continue;const z=te.some(ie=>(0,w.$Kp)({id:ie},ae.identifier));let B;try{B=await this.N(ae,!1,P,L)}catch(ie){if(z)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",ae.identifier.id,(0,k.$ab)(ie));continue}q.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(c,u),q}async N(c,u,S,P){let C;const L=await this.getExtensionsControlManifest();if(L.malicious.some(q=>(0,w.$Kp)(c.identifier,q)))throw new h.$lp(v.localize(1,null,c.identifier.id),h.ExtensionManagementErrorCode.Malicious);const T=L.deprecated[c.identifier.id.toLowerCase()];if(T?.extension?.autoMigrate){if(this.F.info(`The '${c.identifier.id}' extension is deprecated, fetching the compatible '${T.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:T.extension.id,preRelease:T.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},E.CancellationToken.None))[0],!C)throw new h.$lp(v.localize(2,null,c.identifier.id,T.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(c)){const q=await this.getTargetPlatform();throw new h.$lp(v.localize(3,null,c.identifier.id,this.G.nameLong,(0,h.$dp)(q)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.O(c,u,S,P),!C){const q=[];throw(0,f.$5p)(c.properties.enabledApiProposals??[],q)?!S&&c.properties.isPreReleaseVersion&&(await this.z.getExtensions([c.identifier],E.CancellationToken.None))[0]?new h.$lp(v.localize(5,null,c.displayName??c.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$lp(v.localize(6,null,c.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible):new h.$lp(v.localize(4,null,c.displayName??c.identifier.id,q[0]),h.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",C.identifier.id);const I=await this.z.getManifest(C,E.CancellationToken.None);if(I===null)throw new h.$lp(`Missing manifest for extension ${C.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(I.version!==C.version)throw new h.$lp(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:I}}async O(c,u,S,P){const C=await this.getTargetPlatform();let L=null;return!u&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==S&&(L=(await this.z.getExtensions([{...c.identifier,preRelease:S}],{targetPlatform:C,compatible:!0,productVersion:P},E.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(c,S,C,P)&&(L=c),L||(u?L=(await this.z.getExtensions([{...c.identifier,version:c.version}],{targetPlatform:C,compatible:!0,productVersion:P},E.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(c,S,C,P)),L}async P(c,u){const S={...u,profileLocation:c.isApplicationScoped?this.H.defaultProfile.extensionsResource:u.profileLocation??this.X()},P=Y=>`${Y.id.toLowerCase()}${S.versionOnly?`-${c.manifest.version}`:""}${S.profileLocation?`@${S.profileLocation.toString()}`:""}`,C=this.m.get(P(c.identifier));if(C)return this.F.info("Extensions is already requested to uninstall",c.identifier.id),C.waitUntilTaskIsFinished();const L=Y=>{const Q=this.Z(Y,S);return this.m.set(P(Q.extension.identifier),Q),S.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,S.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:S.profileLocation,applicationScoped:Y.isApplicationScoped}),Q},T=(Y,Q)=>{Q?S.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,S.profileLocation.toString(),Q.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,Q.message):S.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,S.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Rp)(Y),error:Q}),this.u.fire({identifier:Y.identifier,error:Q?.code,profileLocation:S.profileLocation,applicationScoped:Y.isApplicationScoped})},I=[],q=[];try{I.push(L(c));const Y=await this.getInstalled(a.ExtensionType.User,S.profileLocation);if(S.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${c.identifier.id}@${c.manifest.version}`);else{const Q=this.S(c,Y);for(const re of Q)this.m.has(P(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):I.push(L(re))}S.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${c.identifier.id}@${c.manifest.version}`):this.Q(I.map(Q=>Q.extension),Y,c),await this.L(I.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(re=>re.postUninstall(Q.extension,S,E.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,h.StatisticType.Uninstall)}catch{}T(Q.extension)}catch(re){const te=l(re);throw T(Q.extension,te),te}finally{q.push(Q)}}))}catch(Y){const Q=l(Y);for(const re of I){try{re.cancel()}catch{}q.includes(re)||T(re.extension,Q)}throw Q}finally{for(const Y of I)this.m.delete(P(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(c,u,S){for(const P of c){const C=this.U(P,u);if(C.length){const L=C.filter(T=>!c.some(I=>(0,w.$Kp)(I.identifier,T.identifier)));if(L.length)throw new Error(this.R(P,L,S))}}}R(c,u,S){return S===c?u.length===1?v.localize(7,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?v.localize(8,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):v.localize(9,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?v.localize(10,null,S.manifest.displayName||S.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?v.localize(11,null,S.manifest.displayName||S.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):v.localize(12,null,S.manifest.displayName||S.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}S(c,u,S=[]){if(S.indexOf(c)!==-1)return[];S.push(c);const P=c.manifest.extensionPack?c.manifest.extensionPack:[];if(P.length){const C=u.filter(T=>!T.isBuiltin&&P.some(I=>(0,w.$Kp)({id:I},T.identifier))),L=[];for(const T of C)L.push(...this.S(T,u,S));return[...C,...L]}return[]}U(c,u){return u.filter(S=>S.manifest.extensionDependencies&&S.manifest.extensionDependencies.some(P=>(0,w.$Kp)({id:P},c.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(c){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$ab)(c)),{malicious:[],deprecated:{},search:[]}}}};e.$Dq=t,e.$Dq=t=Be([je(0,h.$jp),je(1,b.$_l),je(2,d.$Kl),je(3,m.$ak),je(4,$.$tk),je(5,p.$Ml)],t);function l(s,c){if(s instanceof h.$lp)return s;let u;return s instanceof h.$kp?u=new h.$lp(s.message,s.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):u=new h.$lp(s.message,(0,k.$7)(s)?h.ExtensionManagementErrorCode.Cancelled:c??h.ExtensionManagementErrorCode.Internal),u.stack=s.stack,u}function i(s,c,{extensionData:u,verificationStatus:S,duration:P,error:C,source:L,durationSinceUpdate:T}){let I,q;(0,o.$og)(S)&&(S===!0?S="Verified":(S===!1||(I=h.ExtensionManagementErrorCode.Signature,q=S),S="Unverified")),C&&(I=C.code,C.code===h.ExtensionManagementErrorCode.Signature&&(q=C.message)),s.publicLog(c,{...u,verificationStatus:S,success:!C,duration:P,errorcode:I,errorcodeDetail:q,durationSinceUpdate:T,source:L})}class g{constructor(){this.d=new r.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,r.$th)(c=>this.h(c))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,r.$th)(c=>new Promise((u,S)=>{const P=c.onCancellationRequested(()=>{P.dispose(),S(new k.$8)})})),this.d.open()),this.g.cancel()}}e.$Fq=g}),define(ve[54],Se([1,0,14,15,2,6,26,4,30,39,16,5,12,34,36,11,10,24]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b||(e.ExtensionsProfileScanningErrorCode=b={}));class d extends Error{constructor(g,s){super(g),this.code=s}}e.$Gq=d,e.$Hq=(0,v.$Gi)("IExtensionsProfileScannerService");let p=class extends E.$Xc{constructor(g,s,c,u,S,P){super(),this.j=g,this.m=s,this.n=c,this.r=u,this.s=S,this.t=P,this.b=this.B(new k.$ne),this.onAddExtensions=this.b.event,this.c=this.B(new k.$ne),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$ne),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$ne),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Dc}scanProfileExtensions(g,s){return this.u(g,void 0,s)}async addExtensionsToProfile(g,s,c){const u=[],S=[];try{return await this.u(s,P=>{const C=[];if(c)C.push(...P);else for(const L of P)g.some(([T])=>(0,o.$Kp)(T.identifier,L.identifier)&&T.manifest.version!==L.version)?u.push(L):C.push(L);for(const[L,T]of g){const I=C.findIndex(Y=>(0,o.$Kp)(Y.identifier,L.identifier)&&Y.version===L.manifest.version),q={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:T};I===-1?(S.push(q),C.push(q)):C.splice(I,1,q)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),u.length&&this.f.fire({extensions:u,profileLocation:s}),C}),S.length&&this.c.fire({extensions:S,profileLocation:s}),u.length&&this.g.fire({extensions:u,profileLocation:s}),S}catch(P){throw S.length&&this.c.fire({extensions:S,error:P,profileLocation:s}),u.length&&this.g.fire({extensions:u,error:P,profileLocation:s}),P}}async updateMetadata(g,s){const c=[];return await this.u(s,u=>{const S=[];for(const P of u){const C=g.find(([L])=>(0,o.$Kp)(L.identifier,P.identifier)&&L.manifest.version===P.version);C&&(P.metadata={...P.metadata,...C[1]},c.push(P)),S.push(P)}return S}),c}async removeExtensionFromProfile(g,s){const c=[];try{await this.u(s,u=>{const S=[];for(const P of u)(0,o.$Kp)(P.identifier,g.identifier)?c.push(P):S.push(P);return c.length&&this.f.fire({extensions:c,profileLocation:s}),S}),c.length&&this.g.fire({extensions:c,profileLocation:s})}catch(u){throw c.length&&this.g.fire({extensions:c,error:u,profileLocation:s}),u}}async u(g,s,c){return this.F(g).queue(async()=>{let u=[],S;try{const P=await this.m.readFile(g);S=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,D.$rl)(P)!==D.FileOperationResult.FILE_NOT_FOUND)throw P;if(this.r.extUri.isEqual(g,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&c?.bailOutWhenFileNotFound)throw new d((0,m.$ab)(P),b.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(g);let P=!1;for(const C of S){t(C)||this.w(g);let L;if((0,f.$gg)(C.relativeLocation)&&C.relativeLocation)L=this.z(C.relativeLocation);else if((0,f.$gg)(C.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${C.location}`);continue}else{L=A.URI.revive(C.location);const T=this.y(L);T&&(P=!0,C.relativeLocation=T)}(0,f.$ng)(C.metadata?.hasPreReleaseVersion)&&C.metadata?.preRelease&&(P=!0,C.metadata.hasPreReleaseVersion=!0),u.push({identifier:C.identifier,location:L,version:C.version,metadata:C.metadata})}P&&await this.m.writeFile(g,r.$Pe.fromString(JSON.stringify(S)))}if(s){u=s(u);const P=u.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(g,r.$Pe.fromString(JSON.stringify(P)))}return u})}w(g){const s=new d(`Invalid extensions content in ${g.toString()}`,b.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(g){return this.r.extUri.isEqual(this.r.extUri.dirname(g),this.j)?this.r.extUri.basename(g):void 0}z(g){return this.r.extUri.joinPath(this.j,g)}async D(){return this.C||(this.C=(async()=>{const g=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(g)).value.toString()}catch(S){if((0,D.$rl)(S)===D.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",g.toString());let u;try{const S=JSON.parse(c);Array.isArray(S)&&S.every(P=>t(P))?u=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Pe.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",g.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,D.$rl)(S)===D.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",g.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(g)}catch(S){(0,D.$rl)(S)!==D.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,D.$rl)(S)!==D.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return u})()),this.C}F(g){let s=this.h.get(g);return s||(s=new n.$Nh,this.h.set(g,s)),s}};e.$Iq=p,e.$Iq=p=Be([je(1,D.$al),je(2,w.$Ml),je(3,a.$Kl),je(4,$.$_l),je(5,h.$ak)],p);function t(i){return(0,f.$ig)(i)&&(0,y.$ip)(i.identifier)&&(l(i.location)||(0,f.$gg)(i.location)&&i.location)&&((0,f.$ng)(i.relativeLocation)||(0,f.$gg)(i.relativeLocation))&&i.version&&(0,f.$gg)(i.version)}function l(i){return i?(0,f.$gg)(i.path)&&(0,f.$gg)(i.scheme):!1}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[64],Se([1,0,18,14,21,15,10,43,190,2,13,9,3,20,63,58,11,4,211,28,39,22,74,16,5,12,29,6,50,54,34,36,246]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=te,E=qe(E),v=qe(v),h=qe(h),a=qe(a),f=mt(f);var I;(function(de){function J(ae,z){if(ae===z)return!0;const B=Object.keys(ae),ie=new Set;for(const le of Object.keys(z))ie.add(le);if(B.length!==ie.size)return!1;for(const le of B){if(ae[le]!==z[le])return!1;ie.delete(le)}return ie.size===0}de.equals=J})(I||(e.Translations=I={})),e.$Lq=(0,g.$Gi)("IExtensionsScannerService");let q=class extends o.$Xc{constructor(J,ae,z,B,ie,le,pe,H,ce,x,U,O){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=ae,this.r=z,this.s=B,this.t=ie,this.u=le,this.w=pe,this.y=H,this.z=ce,this.C=x,this.D=U,this.F=O,this.g=this.B(new u.$ne),this.onDidChangeCache=this.g.event,this.h=(0,w.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(Q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(J,ae,z){const[B,ie]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(ae)]),le=z?await this.scanExtensionsUnderDevelopment(J,[...B,...ie]):[];return this.L(B,ie,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const ae=[];ae.push(this.M(!!J.useCache,J.language)),ae.push(this.N(J.language,!!J.checkControlFile));const[z,B]=await Promise.all(ae);return this.J([...z,...B],t.ExtensionType.System,J,!1)}async scanUserExtensions(J){const ae=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ae);const z=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(ae,!!J.profileLocation,t.ExtensionType.User,!J.includeUninstalled,J.language,!0,z,J.productVersion??this.R()),ie=J.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let le;try{le=await ie.scanExtensions(B)}catch(pe){if(pe instanceof P.$Gq&&pe.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),le=await ie.scanExtensions(B);else throw pe}return le=await this.J(le,t.ExtensionType.User,J,!0),this.y.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(J,ae){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===D.Schemas.file).map(async B=>{const ie=await this.P(B,!1,t.ExtensionType.User,!0,J.language,!1,void 0,J.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(pe=>(pe.type=ae.find(H=>(0,p.$Kp)(H.identifier,pe.identifier))?.type??pe.type,this.n.validate(pe,ie)))}))).flat();return this.J(z,"development",J,!0)}return[]}async scanExistingExtension(J,ae,z){const B=await this.P(J,!1,ae,!0,z.language,!0,void 0,z.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!z.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(J,ae,z){const B=await this.P(J,!1,ae,!0,z.language,!0,void 0,z.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,ae,z,!0)}async scanMultipleExtensions(J,ae,z){const B=[];return await Promise.all(J.map(async ie=>{const le=await this.scanOneOrMultipleExtensions(ie,ae,z);B.push(...le)})),this.J(B,ae,z,!0)}async scanMetadata(J){const ae=(0,w.$hh)(J,"package.json"),z=(await this.w.readFile(ae)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(J,ae){const z=(0,w.$hh)(J,"package.json"),B=(await this.w.readFile(z)).value.toString(),ie=JSON.parse(B);ae.isMachineScoped===!1&&delete ae.isMachineScoped,ae.isBuiltin===!1&&delete ae.isBuiltin,ie.__metadata={...ie.__metadata,...ae},await this.w.writeFile((0,w.$hh)(J,"package.json"),k.$Pe.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof P.$Gq&&J.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(ae=>[ae,ae.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Pe.fromString(JSON.stringify([])))}catch(ae){(0,i.$rl)(ae)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$ab)(ae))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,ae,z,B){return z.includeAllVersions||(J=this.L(ae===t.ExtensionType.System?J:void 0,ae===t.ExtensionType.User?J:void 0,ae==="development"?J:void 0,await this.getTargetPlatform(),B)),z.includeInvalid||(J=J.filter(ie=>ie.isValid)),J.sort((ie,le)=>{const pe=v.$qc(ie.location.fsPath),H=v.$qc(le.location.fsPath);return pe<H?-1:pe>H?1:0})}L(J,ae,z,B,ie){const le=(H,ce,x)=>{if(H.isValid&&!ce.isValid)return!1;if(H.isValid===ce.isValid){if(ie&&a.gt(H.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(a.eq(H.manifest.version,ce.manifest.version)){if(H.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===B)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return x?this.y.warn(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`),!0},pe=new t.$tn;return J?.forEach(H=>{const ce=pe.get(H.identifier.id);(!ce||le(ce,H,!1))&&pe.set(H.identifier.id,H)}),ae?.forEach(H=>{const ce=pe.get(H.identifier.id);if(!ce&&J&&H.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!ce||le(ce,H,!1))&&pe.set(H.identifier.id,H)}),z?.forEach(H=>{const ce=pe.get(H.identifier.id);(!ce||le(ce,H,!0))&&pe.set(H.identifier.id,H),pe.set(H.identifier.id,H)}),[...pe.values()]}async M(J,ae){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ae,!0,void 0,this.R()),ie=await(J&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(J,ae){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const B=ae?await this.O():{},ie=[],le=$.URI.file(v.$kc(v.$mc(D.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of z){const ce=B[H.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":ie.push((0,w.$hh)(le,H.name));break;default:ie.push($.URI.file(ce));break}}const pe=await Promise.all(ie.map(async H=>this.n.scanExtension(await this.P(H,!1,t.ExtensionType.System,!0,J,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",pe.length),(0,n.$Kb)(pe)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,ae,z,B,ie,le,pe,H){const ce=await this.f(ie??h.$w),x=await this.Q(J),U=ae&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=U?await this.Q(U):void 0;return new Y(J,x,U,O,ae,pe,z,B,le,H.version,H.date,this.C.commit,!this.z.isBuilt,ie,ce)}async Q(J){try{const ae=await this.w.stat(J);if(typeof ae.mtime=="number")return ae.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=q,e.$Mq=q=Be([je(4,C.$Ml),je(5,P.$Hq),je(6,i.$al),je(7,s.$ak),je(8,d.$Ni),je(9,c.$tk),je(10,L.$Kl),je(11,g.$Fi)],q);class Y{constructor(J,ae,z,B,ie,le,pe,H,ce,x,U,O,Z,V,M){this.location=J,this.mtime=ae,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=le,this.type=pe,this.excludeObsolete=H,this.validate=ce,this.productVersion=x,this.productDate=U,this.productCommit=O,this.devMode=Z,this.language=V,this.translations=M}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,ae){return(0,w.$ah)(J.location,ae.location)&&J.mtime===ae.mtime&&(0,w.$ah)(J.applicationExtensionslocation,ae.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===ae.applicationExtensionslocationMtime&&J.profile===ae.profile&&E.$io(J.profileScanOptions,ae.profileScanOptions)&&J.type===ae.type&&J.excludeObsolete===ae.excludeObsolete&&J.validate===ae.validate&&J.productVersion===ae.productVersion&&J.productDate===ae.productDate&&J.productCommit===ae.productCommit&&J.devMode===ae.devMode&&J.language===ae.language&&I.equals(J.translations,ae.translations)}}e.$Nq=Y;let Q=class extends o.$Xc{constructor(J,ae,z,B,ie,le){super(),this.g=J,this.h=ae,this.j=z,this.m=B,this.n=le,this.f=ie.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[]}async scanExtensions(J){const ae=J.profile?await this.s(J):await this.r(J);let z={};if(J.excludeObsolete&&J.type===t.ExtensionType.User)try{const B=(await this.m.readFile(this.g)).value.toString();z=JSON.parse(B)}catch{}return(0,m.$tg)(z)?ae:ae.filter(B=>!z[p.$Lp.create(B).toString()])}async r(J){const ae=await this.m.resolve(J.location);if(!ae.children?.length)return[];const z=await Promise.all(ae.children.map(async B=>{if(!B.isDirectory||J.type===t.ExtensionType.User&&(0,w.$eh)(B.resource).indexOf(".")===0)return null;const ie=new Y(B.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(ie)}));return(0,n.$Kb)(z).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async s(J){let ae=await this.t(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.j.extUri.isEqual(J.location,J.applicationExtensionslocation)){ae=ae.filter(B=>!B.metadata?.isApplicationScoped);const z=await this.t(J.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,J);ae.push(...z)}return ae}async t(J,ae,z){const B=await this.h.scanProfileExtensions(J,z.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async le=>{if(ae(le)){const pe=new Y(le.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(pe,le.metadata)}return null}));return(0,n.$Kb)(ie)}async scanOneOrMultipleExtensions(J){try{if(await this.m.exists((0,w.$hh)(J.location,"package.json"))){const ae=await this.scanExtension(J);return ae?[ae]:[]}else return await this.scanExtensions(J)}catch(ae){return this.n.error(`Error scanning extensions at ${J.location.path}:`,(0,R.$ab)(ae)),[]}}async scanExtension(J,ae){try{let z=await this.u(J.location);if(z){z.publisher||(z.publisher=t.$nn),ae=ae??z.__metadata,delete z.__metadata;const B=(0,p.$Pp)(z.publisher,z.name),ie=ae?.id?{id:B,uuid:ae.id}:{id:B},le=ae?.isSystem?t.ExtensionType.System:J.type,pe=le===t.ExtensionType.System||!!ae?.isBuiltin;z=await this.w(J.location,z,Y.createNlsConfiguration(J));let H={type:le,identifier:ie,manifest:z,location:J.location,isBuiltin:pe,targetPlatform:ae?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ae?.publisherDisplayName,metadata:ae,isValid:!0,validations:[]};return J.validate&&(H=this.validate(H,J)),z.enabledApiProposals&&this.f.includes(B.toLowerCase())&&(z.enabledApiProposals=(0,t.$zn)([...z.enabledApiProposals])),H}}catch(z){J.type!==t.ExtensionType.System&&this.n.error(z)}return null}validate(J,ae){let z=!0;const B=this.f.includes(J.identifier.id.toLowerCase()),ie=(0,l.$2p)(ae.productVersion,ae.productDate,ae.location,J.manifest,J.isBuiltin,B);for(const[le,pe]of ie)le===f.default.Error&&(z=!1,this.n.error(this.D(ae.location,pe)));return J.isValid=z,J.validations=ie,J}async u(J){const ae=(0,w.$hh)(J,"package.json");let z;try{z=(await this.m.readFile(ae)).value.toString()}catch(ie){return(0,i.$rl)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(J,(0,b.localize)(0,null,ae.path,ie.message))),null}let B;try{B=JSON.parse(z)}catch{const le=[];(0,A.$Yn)(z,le);for(const pe of le)this.n.error(this.D(J,(0,b.localize)(1,null,ae.path,pe.offset,pe.length,(0,y.$Jq)(pe.error))));return null}return(0,A.$7n)(B)!=="object"?(this.n.error(this.D(J,(0,b.localize)(2,null,ae.path))),null):B}async w(J,ae,z){const B=await this.y(J,ae,z);if(B)try{const ie=[],le=await this.z(B.default,ie);if(ie.length>0)return ie.forEach(H=>{this.n.error(this.D(J,(0,b.localize)(3,null,B.default?.path,(0,y.$Jq)(H.error))))}),ae;if((0,A.$7n)(B)!=="object")return this.n.error(this.D(J,(0,b.localize)(4,null,B.default?.path))),ae;const pe=B.values||Object.create(null);return(0,T.$Kq)(this.n,ae,pe,le)}catch{}return ae}async y(J,ae,z){const B=(0,w.$hh)(J,"package.nls.json"),ie=(ce,x)=>{x.forEach(U=>{this.n.error(this.D(J,(0,b.localize)(5,null,ce?.path,(0,y.$Jq)(U.error))))})},le=ce=>{this.n.error(this.D(J,(0,b.localize)(6,null,ce?.path)))},pe=`${ae.publisher}.${ae.name}`,H=z.translations[pe];if(H)try{const ce=$.URI.file(H),x=(await this.m.readFile(ce)).value.toString(),U=[],O=(0,A.$Yn)(x,U);return U.length>0?(ie(ce,U),{values:void 0,default:B}):(0,A.$7n)(O)!=="object"?(le(ce),{values:void 0,default:B}):{values:O.contents?O.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.m.exists(B))return;let x;try{x=await this.C(J,z)}catch{return}if(!x.localized)return{values:void 0,default:x.original};try{const U=(await this.m.readFile(x.localized)).value.toString(),O=[],Z=(0,A.$Yn)(U,O);return O.length>0?(ie(x.localized,O),{values:void 0,default:x.original}):(0,A.$7n)(Z)!=="object"?(le(x.localized),{values:void 0,default:x.original}):{values:Z,default:x.original}}catch{return{values:void 0,default:x.original}}}}async z(J,ae){if(J)try{const z=(await this.m.readFile(J)).value.toString();return(0,A.$Yn)(z,ae)}catch{}}C(J,ae){return new Promise((z,B)=>{const ie=le=>{const pe=(0,w.$hh)(J,`package.nls.${le}.json`);this.m.exists(pe).then(H=>{H&&z({localized:pe,original:(0,w.$hh)(J,"package.nls.json")});const ce=le.lastIndexOf("-");ce===-1?z({localized:(0,w.$hh)(J,"package.nls.json"),original:null}):(le=le.substring(0,ce),ie(le))})};if(ae.devMode||ae.pseudo||!ae.language)return z({localized:(0,w.$hh)(J,"package.nls.json"),original:null});ie(ae.language)})}D(J,ae){return`[${J.path}]: ${ae}`}};Q=Be([je(1,P.$Hq),je(2,L.$Kl),je(3,i.$al),je(4,c.$tk),je(5,s.$ak)],Q);let re=class extends Q{constructor(J,ae,z,B,ie,le,pe,H){super(ae,B,ie,le,pe,H),this.I=J,this.J=z,this.G=this.B(new r.$Eh(3e3)),this.H=this.B(new u.$ne),this.onDidChangeCache=this.H.event}async scanExtensions(J){const ae=this.O(J),z=await this.L(ae);if(this.F=J,z&&z.input&&Y.equals(z.input,this.F))return this.n.debug("Using cached extensions scan result",J.type===t.ExtensionType.System?"system":"user",J.location.toString()),this.G.trigger(()=>this.N()),z.result.map(ie=>(ie.location=$.URI.revive(ie.location),ie));const B=await super.scanExtensions(J);return await this.M(ae,{input:J,result:B}),B}async L(J){try{const ae=await this.m.readFile(J),z=JSON.parse(ae.value.toString());return{result:z.result,input:(0,S.$di)(z.input)}}catch(ae){this.n.debug("Error while reading the extension cache file:",J.path,(0,R.$ab)(ae))}return null}async M(J,ae){try{await this.m.writeFile(J,k.$Pe.fromString(JSON.stringify(ae)))}catch(z){this.n.debug("Error while writing the extension cache file:",J.path,(0,R.$ab)(z))}}async N(){if(!this.F)return;const J=this.O(this.F),ae=await this.L(J);if(!ae)return;const z=ae.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!E.$io(B,z))try{this.n.info("Invalidating Cache",z,B),await this.m.del(J),this.H.fire()}catch(ie){this.n.error(ie)}}O(J){const ae=this.P(J);return this.j.extUri.joinPath(ae.cacheHome,J.type===t.ExtensionType.System?t.$mn:t.$ln)}P(J){return J.type===t.ExtensionType.System?this.J.defaultProfile:J.profile?this.j.extUri.isEqual(J.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ae=>this.j.extUri.isEqual(J.location,ae.extensionsResource))??this.I:this.J.defaultProfile}};re=Be([je(2,C.$Ml),je(3,P.$Hq),je(4,L.$Kl),je(5,i.$al),je(6,c.$tk),je(7,s.$ak)],re);function te(de,J){const ae=(0,p.$Np)(de.manifest.publisher,de.manifest.name);return{id:ae,identifier:new t.$rn(ae),isBuiltin:de.type===t.ExtensionType.System,isUserBuiltin:de.type===t.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:J,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class _ extends q{constructor(J,ae,z,B,ie,le,pe,H,ce,x,U,O){super(J,ae,(0,w.$hh)(z,".vscode-oss-dev","extensions","control.json"),B,ie,le,pe,H,ce,x,U,O),this.S=(async()=>{if(h.$z)try{const Z=await this.w.readFile($.URI.file(h.$z));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}f(J){return this.S}}e.$Pq=_}),define(ve[289],Se([1,0,60,14,45,6,2,13,9,25,12,34]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let h=class extends R.$Xc{constructor(a,f){super(),this.b=a,this.f=f,this.a=new r.$Mh(5)}async postUninstall(a){const f=this.g(a,"uninstall");f&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(f.script,"uninstall",f.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(m)}}));try{await o.Promises.rm(this.m(a))}catch(m){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(m)}}g(a,f){const m=`vscode:${f}`;if(a.location.scheme===A.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[m]=="string"){const $=a.manifest.scripts[m].split(" ");return $.length<2||$[0]!=="node"||!$[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${m} should be a node script`),null):{script:(0,y.$mc)(a.location.fsPath,$[1]),args:$.slice(2)||[]}}return null}h(a,f,m,$,b){return new Promise((d,p)=>{const t=this.j(a,f,m,b);let l;const i=g=>{l&&(clearTimeout(l),l=null),g?p(g):d(void 0)};t.on("error",g=>{i((0,E.$rj)(g)||"Unknown")}),t.on("exit",(g,s)=>{i(g?`post-${f} process exited with code ${g}`:void 0)}),$&&(l=setTimeout(()=>{l=null,t.kill(),p("timed out")},5e3))})}j(a,f,m,$){const b={silent:!0,execArgv:void 0},d=(0,n.fork)(a,[`--type=extension-post-${f}`,...m],b);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const p=k.Event.fromNodeEventEmitter(d.stdout,"data"),t=k.Event.fromNodeEventEmitter(d.stderr,"data");this.B(p(g=>this.f.info($.identifier.id,$.manifest.version,`post-${f}`,g))),this.B(t(g=>this.f.error($.identifier.id,$.manifest.version,`post-${f}`,g)));const l=k.Event.any(k.Event.map(p,g=>({data:`%c${g}`,format:[""]}),this.q),k.Event.map(t,g=>({data:`%c${g}`,format:["color: red"]}),this.q));return k.Event.debounce(l,(g,s)=>g?{data:g.data+s.data,format:[...g.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this.q)(g=>{console.group($.identifier.id),console.log(g.data,...g.format),console.groupEnd()}),d}m(a){return(0,y.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$Tq=h,e.$Tq=h=Be([je(0,v.$Ml),je(1,D.$ak)],h)}),define(ve[138],Se([1,0,87,213,99,30]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=R,e.$Rq=A;function R(y){let o=k.ExtensionManagementErrorCode.Extract;return y instanceof n.$zq&&(y.type==="CorruptZip"?o=k.ExtensionManagementErrorCode.CorruptZip:y.type==="Incomplete"&&(o=k.ExtensionManagementErrorCode.IncompleteZip)),(0,E.$Eq)(y,o)}async function A(y){let o;try{o=await(0,n.$Cq)(y,"extension/package.json")}catch(D){throw R(D)}try{return JSON.parse(o.toString("utf8"))}catch{throw new k.$lp((0,r.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(ve[290],Se([1,0,14,10,2,13,20,63,11,23,25,87,27,28,99,30,39,138,95,16,12,24]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,A=qe(A);let i=class extends E.$Xc{static{l=this}static{this.c=".sigzip"}constructor(s,c,u,S,P,C,L){super(),this.h=c,this.j=u,this.m=S,this.n=P,this.r=C,this.t=L,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(s,c,u,S){await this.g;const P=await this.w(s,c);let C=!1;if(u&&this.u(s)){let L;try{L=await this.y(s)}catch(T){try{await this.delete(P)}catch(I){this.t.error(I)}throw T}try{C=await this.n.verify(s,P.fsPath,L.fsPath,S)}catch(T){if(C=T.code,C===b.ExtensionSignatureVerificationCode.PackageIsInvalidZip||C===b.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(P)}catch(I){this.t.error(I)}throw new f.$lp(v.$yq,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(T){this.t.error(T)}}}return{location:P,verificationStatus:C}}u(s){if(!s.isSigned)return this.t.info(`Extension is not signed: ${s.identifier.id}`),!1;const c=this.m.getValue("extensions.verifySignature");return(0,y.$mg)(c)?c:!0}async w(s,c){try{const u=(0,R.$hh)(this.extensionsDownloadDir,this.G(s)),S=await this.C(s,"vsix",async()=>{await this.z(s,u,P=>this.j.download(s,P,c));try{await this.D(u.fsPath,"extension/package.json")}catch(P){try{await this.h.del(u)}catch(C){this.t.warn(`Error while deleting: ${u.path}`,(0,r.$ab)(C))}throw P}},2);return S>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:s.identifier.id,attempts:S}),u}catch(u){throw(0,a.$Eq)(u,f.ExtensionManagementErrorCode.Download)}}async y(s){try{const c=(0,R.$hh)(this.extensionsDownloadDir,`.${(0,o.$3g)()}`),u=await this.C(s,"sigzip",async()=>{await this.j.downloadSignatureArchive(s,c);try{await this.D(c.fsPath,".signature.p7s")}catch(S){try{await this.h.del(c)}catch(P){this.t.warn(`Error while deleting: ${c.path}`,(0,r.$ab)(P))}throw S}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:s.identifier.id,attempts:u}),c}catch(c){throw(0,a.$Eq)(c,f.ExtensionManagementErrorCode.DownloadSignature)}}async z(s,c,u){if(await this.h.exists(c))return;if(c.scheme!==k.Schemas.file){await u(c);return}const S=(0,R.$hh)(this.extensionsDownloadDir,`.${(0,o.$3g)()}`);try{await u(S)}catch(P){try{await this.h.del(S)}catch{}throw P}try{await D.Promises.rename(S.fsPath,c.fsPath,2*60*1e3)}catch(P){try{await this.h.del(S)}catch{}let C=!1;try{C=await this.h.exists(c)}catch{}if(C)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,c.path);else throw this.t.info(`Rename failed because of ${(0,r.$ab)(P)}. Deleted the file from downloaded location`,S.path),P}}async C(s,c,u,S){let P=1;for(;;)try{return await u(),P}catch(C){if(P++>S)throw C;this.t.warn(`Failed downloading ${c}. ${(0,r.$ab)(C)}. Retry again...`,s.identifier.id)}}async D(s,c){try{await(0,v.$Cq)(s,c)}catch(u){throw(0,$.$Qq)(u)}}async delete(s){await this.g,await this.h.del(s)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const c=[],u=[],S=[];for(const L of s.children)if(L.name.endsWith(l.c))S.push(L.resource);else{const T=m.$Lp.parse(L.name);T&&u.push([T,L])}const P=(0,m.$Qp)(u,([L])=>L),C=[];for(const L of P)L.sort((T,I)=>A.rcompare(T[0].version,I[0].version)),c.push(...L.slice(1).map(T=>T[1].resource)),C.push(L[0][1]);C.sort((L,T)=>L.mtime-T.mtime),c.push(...C.slice(0,Math.max(0,C.length-this.f)).map(L=>L.resource)),c.push(...S),await n.Promises.settled(c.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(s){this.t.error(s)}}G(s){return this.f?m.$Lp.create(s).toString().toLowerCase():(0,o.$3g)()}};e.$Sq=i,e.$Sq=i=l=Be([je(0,w.$Oi),je(1,d.$al),je(2,f.$jp),je(3,h.$aj),je(4,b.$rq),je(5,t.$_l),je(6,p.$ak)],i)}),define(ve[139],Se([1,0,14,15,19,45,10,6,66,2,26,13,9,20,63,11,4,23,25,87,212,88,28,99,30,39,54,64,290,289,138,267,276,22,74,16,5,12,29,24,36,34]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T,I,q,Y,Q,re,te,_,de,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,h=qe(h),a=qe(a),b=qe(b),p=qe(p),e.$Wq=(0,Q.$Hi)(g.$mp);const ae=".vsctmp";let z=class extends i.$Dq{constructor(H,ce,x,U,O,Z,V,M,G,X,F,W){super(H,ce,F,x,X,W),this.eb=O,this.fb=Z,this.gb=V,this.hb=M,this.ib=G,this.db=new Map,this.tb=new D.$Ec;const oe=this.B(M.createInstance(P.$Tq));this.ab=this.B(M.createInstance(B,ke=>oe.postUninstall(ke))),this.bb=this.B(new L.$Uq(W,G,F,this,this.F)),this.cb=this.B(M.createInstance(S.$Sq));const he=this.B(new T.$Vq(this,this.eb,W,Z,F,G,x));this.B(he.onDidChangeExtensionsByAnotherSource(ke=>this.sb(ke))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Vp)(this.ib,this.F)),this.jb}async zip(H){this.F.trace("ExtensionManagementService#zip",H.identifier.id);const ce=await this.rb(H),x=await(0,d.zip)((0,w.$hh)(this.cb.extensionsDownloadDir,(0,$.$3g)()).fsPath,ce);return m.URI.file(x)}async unzip(H){return this.F.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:ce,cleanup:x}=await this.lb(H),U=h.$nc(ce.fsPath);try{return await(0,C.$Rq)(U)}finally{await x()}}getInstalled(H,ce=this.H.defaultProfile.extensionsResource,x={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(H??null,ce,x)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.ab.scanUserExtensionAtLocation(H)}async install(H,ce={}){this.F.trace("ExtensionManagementService#install",H.toString());const{location:x,cleanup:U}=await this.lb(H);try{const O=await(0,C.$Rq)(h.$nc(x.fsPath)),Z=(0,s.$Pp)(O.publisher,O.name);if(O.engines&&O.engines.vscode&&!(0,q.$4p)(O.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,Z,this.G.version));const M=(await this.I([{manifest:O,extension:x,options:ce}])).find(({identifier:G})=>(0,s.$Kp)(G,{id:Z}));if(M?.local)return M.local;throw M?.error?M.error:(0,i.$Eq)(new Error(`Unknown error while installing extension ${Z}`))}finally{await U()}}async installFromLocation(H,ce){this.F.trace("ExtensionManagementService#installFromLocation",H.toString());const x=await this.ab.scanUserExtensionAtLocation(H);if(!x||!x.manifest.name||!x.manifest.version)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.wb([[x,{source:"resource"}]],ce),this.F.info("Successfully installed extension",x.identifier.id,ce.toString()),x}async installExtensionsFromProfile(H,ce,x){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",H,ce.toString(),x.toString());const U=(await this.getInstalled(I.ExtensionType.User,ce)).filter(O=>H.some(Z=>(0,s.$Kp)(Z,O.identifier)));if(U.length){const O=await Promise.all(U.map(Z=>this.ab.scanMetadata(Z,ce)));await this.wb(U.map((Z,V)=>[Z,O[V]]),x),this.F.info("Successfully installed extensions",U.map(Z=>Z.identifier.id),x.toString())}return U}async updateMetadata(H,ce,x){return this.F.trace("ExtensionManagementService#updateMetadata",H.identifier.id),ce.isPreReleaseVersion&&(ce.preRelease=!0,ce.hasPreReleaseVersion=!0),ce.isMachineScoped===!1&&(ce.isMachineScoped=void 0),ce.isBuiltin===!1&&(ce.isBuiltin=void 0),ce.pinned===!1&&(ce.pinned=void 0),H=await this.ab.updateMetadata(H,ce,x),this.bb.invalidate(x),this.w.fire({local:H,profileLocation:x}),H}async reinstallFromGallery(H){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const ce=await this.getTargetPlatform(),[x]=await this.z.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:ce,compatible:!0},E.CancellationToken.None);if(!x)throw new Error(p.localize(2,null));await this.ab.setUninstalled(H);try{await this.ab.removeUninstalledExtension(H)}catch(U){throw new Error(p.localize(3,null,(0,k.$rj)(U)))}return this.installFromGallery(x)}$(H,ce,x,U){return this.ab.copyExtension(H,ce,x,U)}copyExtensions(H,ce){return this.ab.copyExtensions(H,ce,{version:this.G.version,date:this.G.date})}markAsUninstalled(...H){return this.ab.setUninstalled(...H)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(H){this.F.error(H)}}async download(H,ce,x){const{location:U}=await this.cb.download(H,ce,!x);return U}async lb(H){if(H.scheme===v.Schemas.file)return{location:H,async cleanup(){}};this.F.trace("Downloading extension from",H.toString());const ce=(0,w.$hh)(this.cb.extensionsDownloadDir,(0,$.$3g)());return await this.gb.download(H,ce),this.F.info("Downloaded extension to",ce.toString()),{location:ce,cleanup:async()=>{try{await this.ib.del(ce)}catch(U){this.F.error(U)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(H,ce,x){const U=ce instanceof m.URI?new s.$Lp({id:(0,s.$Pp)(H.publisher,H.name)},H.version):s.$Lp.create(ce);return this.hb.createInstance(ie,U,H,ce,x,(O,Z)=>{if(ce instanceof m.URI)return this.qb(U,ce,x,Z);let V=this.db.get(U.toString());return V||(this.db.set(U.toString(),V=this.pb(U,ce,O,x,Z)),V.finally(()=>this.db.delete(U.toString()))),V},this.ab)}Z(H,ce){return new le(H,ce.profileLocation,this.fb)}async pb(H,ce,x,U,O){const{verificationStatus:Z,location:V}=await this.cb.download(ce,x,!U.donotVerifySignature,U.context?.[g.$cp]);try{if(O.isCancellationRequested)throw new R.$8;return await(0,C.$Rq)(V.fsPath),{local:await this.ab.extractUserExtension(H,V.fsPath,{id:ce.identifier.uuid,publisherId:ce.publisherId,publisherDisplayName:ce.publisherDisplayName,targetPlatform:ce.properties.targetPlatform,isApplicationScoped:U.isApplicationScoped,isMachineScoped:U.isMachineScoped,isBuiltin:U.isBuiltin,isPreReleaseVersion:ce.properties.isPreReleaseVersion,hasPreReleaseVersion:ce.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:U.installGivenVersion?!0:!!U.pinned,preRelease:(0,f.$mg)(U.preRelease)?U.preRelease:U.installPreReleaseVersion||ce.properties.isPreReleaseVersion,source:"gallery"},!1,O),verificationStatus:Z}}catch(M){try{await this.cb.delete(V)}catch(G){this.F.warn("Error while deleting the downloaded file",V.toString(),(0,R.$ab)(G))}throw(0,i.$Eq)(M)}}async qb(H,ce,x,U){return{local:await this.ab.extractUserExtension(H,h.$nc(ce.fsPath),{isApplicationScoped:x.isApplicationScoped,isMachineScoped:x.isMachineScoped,isBuiltin:x.isBuiltin,installedTimestamp:Date.now(),pinned:x.installGivenVersion?!0:!!x.pinned,source:"vsix"},!0,U)}}async rb(H){const ce=async U=>{let O=await b.Promises.readdir(U);O=O.map(M=>h.$mc(U,M));const Z=await Promise.all(O.map(M=>b.Promises.stat(M)));let V=Promise.resolve([]);return Z.forEach((M,G)=>{const X=O[G];M.isFile()&&(V=V.then(F=>[...F,X])),M.isDirectory()&&(V=V.then(F=>ce(X).then(W=>[...F,...W])))}),V};return(await ce(H.location.fsPath)).map(U=>({path:`extension/${h.$oc(H.location.fsPath,U)}`,localPath:U}))}async sb({added:H,removed:ce}){if(ce){const x=H&&this.D.extUri.isEqual(ce.profileLocation,H.profileLocation)?ce.extensions.filter(U=>H.extensions.every(O=>!(0,s.$Kp)(O,U))):ce.extensions;for(const U of x)this.F.info("Extensions removed from another source",U.id,ce.profileLocation.toString()),this.u.fire({identifier:U,profileLocation:ce.profileLocation})}if(H){const U=(await this.getInstalled(I.ExtensionType.User,H.profileLocation)).filter(O=>H.extensions.some(Z=>(0,s.$Kp)(Z,O.identifier)));this.s.fire(U.map(O=>(this.F.info("Extensions added from another source",O.identifier.id,H.profileLocation.toString()),{identifier:O.identifier,local:O,profileLocation:H.profileLocation,operation:g.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(ce=>this.tb.add(ce)));const H=await this.ib.resolve(this.eb.userExtensionsLocation);for(const ce of H.children??[])ce.isDirectory&&this.tb.add(ce.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(ce=>this.vb(ce)))}async vb(H){if(!H.affects(this.eb.userExtensionsLocation,Y.FileChangeType.ADDED))return;const ce=[];for(const x of H.rawAdded){if(this.tb.has(x)||!this.D.extUri.isEqual(this.D.extUri.dirname(x),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(x,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(x).startsWith(".")||!(await this.ib.stat(x)).isDirectory)continue;const U=await this.ab.scanUserExtensionAtLocation(x);U&&U.installedTimestamp===void 0&&(this.tb.add(x),ce.push(U))}ce.length&&(await this.wb(ce.map(x=>[x,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",ce.map(x=>x.identifier.id)))}async wb(H,ce){const x=H.map(U=>U[0]);await this.xb(x),await this.fb.addExtensionsToProfile(H,ce),this.s.fire(x.map(U=>({local:U,identifier:U.identifier,operation:g.InstallOperation.None,profileLocation:ce})))}async xb(H){const ce=await this.ab.getUninstalledExtensions();for(const x of H){const U=s.$Lp.create(x);ce[U.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",U.id),await this.ab.setInstalled(U),this.F.info("Removed the extension from uninstalled list:",U.id))}}};e.$Xq=z,e.$Xq=z=Be([je(0,g.$jp),je(1,_.$_l),je(2,re.$ak),je(3,l.$Oi),je(4,u.$Lq),je(5,c.$Hq),je(6,t.$Zo),je(7,Q.$Fi),je(8,Y.$al),je(9,te.$tk),je(10,de.$Kl),je(11,J.$Ml)],z);let B=class extends o.$Xc{constructor(H,ce,x,U,O,Z,V){super(),this.n=H,this.s=ce,this.t=x,this.u=U,this.w=O,this.y=Z,this.z=V,this.h=this.B(new A.$ne),this.onExtract=this.h.event,this.j=new D.$Dc,this.m=new D.$Dc,this.c=(0,w.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new n.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(H,ce,x){try{const U={includeInvalid:!0,profileLocation:ce,productVersion:x};let O=[];if(H===null||H===I.ExtensionType.System){let Z=this.j.get(ce);Z||(Z=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},U,!1).finally(()=>this.j.delete(ce)),this.j.set(ce,Z)),O.push(...await Z)}else if(H===I.ExtensionType.User){let Z=this.m.get(ce);Z||(Z=this.t.scanUserExtensions(U).finally(()=>this.m.delete(ce)),this.m.set(ce,Z)),O.push(...await Z)}return O=H!==null?O.filter(Z=>Z.type===H):O,await Promise.all(O.map(Z=>this.H(Z)))}catch(U){throw(0,i.$Eq)(U,g.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(H){try{const ce=await this.t.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return await Promise.all(ce.map(x=>this.H(x)))}catch(ce){throw(0,i.$Eq)(ce,g.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(H){try{const ce=await this.t.scanExistingExtension(H,I.ExtensionType.User,{includeInvalid:!0});if(ce)return await this.H(ce)}catch(ce){this.z.error(ce)}return null}async extractUserExtension(H,ce,x,U,O){const Z=H.toString(),V=m.URI.file(h.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,$.$3g)()}`)),M=m.URI.file(h.$mc(this.t.userExtensionsLocation.fsPath,Z));let G=await this.s.exists(M);if(G&&U){try{await this.D(H.id,M,"removeExisting")}catch{throw new g.$lp(p.localize(4,null,M.fsPath,H.id),g.ExtensionManagementErrorCode.Delete)}G=!1}if(G)try{await this.t.updateMetadata(M,x)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:H.id,code:`${(0,Y.$rl)(X)}`}),(0,i.$Eq)(X,g.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(O.isCancellationRequested)throw new R.$8;try{this.z.trace(`Started extracting the extension from ${ce} to ${M.fsPath}`),await(0,d.$Bq)(ce,V.fsPath,{sourcePath:"extension",overwrite:!0},O),this.z.info(`Extracted extension to ${M}:`,H.id)}catch(X){throw(0,C.$Qq)(X)}try{await this.t.updateMetadata(V,x)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:H.id,code:`${(0,Y.$rl)(X)}`}),(0,i.$Eq)(X,g.ExtensionManagementErrorCode.UpdateMetadata)}if(O.isCancellationRequested)throw new R.$8;try{this.z.trace(`Started renaming the extension from ${V.fsPath} to ${M.fsPath}`),await this.G(V.fsPath,M.fsPath),this.z.info("Renamed to",M.fsPath)}catch(X){if(X.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);try{await this.s.del(V,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,R.$ab)(X)}. Deleted from extracted location`,V),X}this.h.fire(M)}catch(X){try{await this.s.del(V,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(M,I.ExtensionType.User)}async scanMetadata(H,ce){return ce?(await this.C(H,ce))?.metadata:this.t.scanMetadata(H.location)}async C(H,ce){return(await this.u.scanProfileExtensions(ce)).find(U=>(0,s.$Kp)(U.identifier,H.identifier))}async updateMetadata(H,ce,x){try{x?await this.u.updateMetadata([[H,ce]],x):await this.t.updateMetadata(H.location,ce)}catch(U){throw this.y.publicLog2("extension:extract",{extensionId:H.identifier.id,code:`${(0,Y.$rl)(U)}`}),(0,i.$Eq)(U,g.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(H.location,H.type,x)}async getUninstalledExtensions(){try{return await this.F()}catch(H){throw(0,i.$Eq)(H,g.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...H){const ce=H.map(x=>s.$Lp.create(x));await this.F(x=>ce.forEach(U=>{x[U.toString()]=!0,this.z.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(H){try{await this.F(ce=>delete ce[H.toString()])}catch(ce){throw(0,i.$Eq)(ce,g.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(H,ce){if(this.w.extUri.isEqualOrParent(H.location,this.t.userExtensionsLocation))return this.D(H.identifier.id,H.location,ce)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.F(ce=>delete ce[s.$Lp.create(H).toString()])}async copyExtension(H,ce,x,U){const O=await this.C(H,ce),Z=await this.C(H,x);if(U={...O?.metadata,...U},Z)if(this.w.extUri.isEqual(Z.location,H.location))await this.u.updateMetadata([[H,{...Z.metadata,...U}]],x);else{const V=await this.scanLocalExtension(Z.location,H.type,x);await this.u.removeExtensionFromProfile(V,x),await this.u.addExtensionsToProfile([[H,{...Z.metadata,...U}]],x)}else await this.u.addExtensionsToProfile([[H,U]],x);return this.scanLocalExtension(H.location,H.type,x)}async copyExtensions(H,ce,x){const U=await this.scanExtensions(I.ExtensionType.User,H,x),O=await Promise.all(U.filter(Z=>!Z.isApplicationScoped).map(async Z=>[Z,await this.scanMetadata(Z,H)]));await this.u.addExtensionsToProfile(O,ce)}async D(H,ce,x){this.z.trace(`Deleting ${x} extension from disk`,H,ce.fsPath);const U=this.w.extUri.joinPath(this.w.extUri.dirname(ce),`${this.w.extUri.basename(ce)}.${(0,y.$uj)((0,$.$3g)()).toString(16)}${ae}`);await this.G(ce.fsPath,U.fsPath),await this.s.del(U,{recursive:!0}),this.z.info(`Deleted ${x} extension from disk`,H,ce.fsPath)}F(H){return this.g.queue(async()=>{let ce;try{ce=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,Y.$rl)(U)!==Y.FileOperationResult.FILE_NOT_FOUND)throw U}let x={};if(ce)try{x=JSON.parse(ce)}catch{}return H&&(H(x),Object.keys(x).length?await this.s.writeFile(this.c,r.$Pe.fromString(JSON.stringify(x))):await this.s.del(this.c)),x})}async G(H,ce){try{await b.Promises.rename(H,ce,2*60*1e3)}catch(x){throw(0,i.$Eq)(x,g.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(H,ce,x){try{if(x){const O=(await this.t.scanUserExtensions({profileLocation:x})).find(Z=>this.w.extUri.isEqual(Z.location,H));if(O)return await this.H(O)}else{const U=await this.t.scanExistingExtension(H,ce,{includeInvalid:!0});if(U)return await this.H(U)}throw new g.$lp(p.localize(5,null,H.path),g.ExtensionManagementErrorCode.ScanningExtension)}catch(U){throw(0,i.$Eq)(U,g.ExtensionManagementErrorCode.ScanningExtension)}}async H(H){const ce=await this.s.resolve(H.location);let x,U;return ce.children&&(x=ce.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,U=ce.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:x,changelogUrl:U,publisherDisplayName:H.metadata?.publisherDisplayName,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!H.metadata?.hasPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned,isWorkspaceScoped:!1,source:H.metadata?.source??(H.identifier.uuid?"gallery":"vsix")}}async I(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(H));const ce=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=new Set;for(const O of ce)H[s.$Lp.create(O).toString()]||x.add(O.identifier.id.toLowerCase());try{const O=(0,s.$Qp)(ce,Z=>Z.identifier);await n.Promises.settled(O.map(async Z=>{const V=Z.sort((M,G)=>a.rcompare(M.manifest.version,G.manifest.version))[0];x.has(V.identifier.id.toLowerCase())||await this.n(await this.H(V))}))}catch(O){this.z.error(O)}const U=ce.filter(O=>O.metadata&&H[s.$Lp.create(O).toString()]);await Promise.allSettled(U.map(O=>this.removeUninstalledExtension(O)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let H;try{H=await this.s.resolve(this.t.userExtensionsLocation)}catch(ce){(0,Y.$rl)(ce)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(ce);return}if(H?.children)try{await Promise.allSettled(H.children.map(async ce=>{if(!(!ce.isDirectory||!ce.name.endsWith(ae))){this.z.trace("Deleting the temporarily deleted folder",ce.resource.toString());try{await this.s.del(ce.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",ce.resource.toString())}catch(x){(0,Y.$rl)(x)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(x)}}}))}catch{}}};e.$Yq=B,e.$Yq=B=Be([je(1,Y.$al),je(2,u.$Lq),je(3,c.$Hq),je(4,de.$Kl),je(5,_.$_l),je(6,re.$ak)],B);let ie=class extends i.$Fq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(H,ce,x,U,O,Z,V,M,G,X,F,W){super(),this.l=H,this.manifest=ce,this.source=x,this.options=U,this.m=O,this.n=Z,this.o=V,this.p=M,this.q=G,this.s=X,this.t=F,this.u=W,this.j=g.InstallOperation.Install,this.identifier=this.l.identifier}async h(H){const x=(await this.n.scanExtensions(I.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(V=>(0,s.$Kp)(V.identifier,this.identifier));x&&(this.j=g.InstallOperation.Update);const U={isApplicationScoped:this.options.isApplicationScoped||x?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||x?.isMachineScoped,isBuiltin:this.options.isBuiltin||x?.isBuiltin,isSystem:x?.type===I.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??x?.pinned,source:this.source instanceof m.URI?"vsix":"gallery"};let O;if(this.source instanceof m.URI){if(x&&this.l.equals(new s.$Lp(x.identifier,x.manifest.version)))try{await this.n.removeExtension(x,"existing")}catch{throw new Error(p.localize(6,null,this.manifest.displayName||this.manifest.name))}const V=await this.w(this.l);if(V)try{await this.n.removeExtension(V,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(U.id=this.source.identifier.uuid,U.publisherId=this.source.publisherId,U.publisherDisplayName=this.source.publisherDisplayName,U.targetPlatform=this.source.properties.targetPlatform,U.updated=!!x,U.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,U.hasPreReleaseVersion=x?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,U.preRelease=(0,f.$mg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||x?.preRelease,x&&x.type!==I.ExtensionType.System&&x.manifest.version===this.source.version)return this.n.updateMetadata(x,U,this.options.profileLocation);O=await this.w(this.l)}if(H.isCancellationRequested)throw(0,i.$Eq)(new R.$8);if(!O){const V=await this.m(this.operation,H);O=V.local,this.k=V.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(V){throw(0,i.$Eq)(V,g.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(H.isCancellationRequested)throw(0,i.$Eq)(new R.$8);try{await this.t.addExtensionsToProfile([[O,U]],this.options.profileLocation,!O.isValid)}catch(V){throw(0,i.$Eq)(V,g.ExtensionManagementErrorCode.AddToProfile)}const Z=await this.n.scanLocalExtension(O.location,I.ExtensionType.User,this.options.profileLocation);if(!Z)throw new g.$lp("Cannot find the installed extension",g.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof m.URI&&this.x(O,H),Z}async w(H){return(await this.n.getUninstalledExtensions())[H.toString()]?(this.u.trace("Removing the extension from uninstalled list:",H.id),await this.n.setInstalled(H),this.u.info("Removed the extension from uninstalled list:",H.id),(await this.n.scanAllUserExtensions(!0)).find(U=>s.$Lp.create(U).equals(H))):void 0}async x(H,ce){try{let[x]=await this.p.getExtensions([{id:H.identifier.id,version:H.manifest.version}],ce);if(x||([x]=await this.p.getExtensions([{id:H.identifier.id}],ce)),x){const U={id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:H.hasPreReleaseVersion||x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(H,U,this.options.profileLocation)}}catch{}}};ie=Be([je(6,de.$Kl),je(7,g.$jp),je(8,J.$Ml),je(9,u.$Lq),je(10,c.$Hq),je(11,re.$ak)],ie);class le extends i.$Fq{constructor(H,ce,x){super(),this.extension=H,this.j=ce,this.k=x}async h(H){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ve[140],Se([1,0,12,34,36,24,54,16,28,4]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let D=class extends R.$Iq{constructor(h,w,a,f,m,$){super(o.URI.file(h.extensionsPath),w,a,f,m,$)}};e.$nR=D,e.$nR=D=Be([je(0,y.$Oi),je(1,A.$al),je(2,r.$Ml),je(3,E.$Kl),je(4,k.$_l),je(5,n.$ak)],D)}),define(ve[100],Se([1,0,14,6,2,44,11,197,5,34]),function(se,e,n,r,E,k,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=w,e.$jq=f,e.$lq=$,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,y.$Gi)("storageService");var D;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var v;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var h;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function w(b){const d=b.get(e.$fq);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}class a extends E.$Xc{static{this.a=60*1e3}constructor(d={flushInterval:a.a}){super(),this.m=d,this.b=this.B(new r.$qe),this.c=this.B(new r.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,p,t){return r.Event.filter(this.b.event,l=>l.scope===d&&(p===void 0||l.key===p),t)}n(){this.j.value=(0,n.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,p){const{key:t,external:l}=p;if(t===e.$fq){switch(d){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:t,target:this.J(d)[t],external:l})}w(d){this.f.fire({reason:d})}get(d,p,t){return this.P(p)?.get(d,t)}getBoolean(d,p,t){return this.P(p)?.getBoolean(d,t)}getNumber(d,p,t){return this.P(p)?.getNumber(d,t)}getObject(d,p,t){return this.P(p)?.getObject(d,t)}storeAll(d,p){this.y(()=>{for(const t of d)this.store(t.key,t.value,t.scope,t.target,p)})}store(d,p,t,l,i=!1){if((0,R.$pg)(p)){this.remove(d,t,i);return}this.y(()=>{this.z(d,t,l),this.P(t)?.set(d,p,i)})}remove(d,p,t=!1){this.y(()=>{this.z(d,p,void 0),this.P(p)?.delete(d,t)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,p){const t=[],l=this.J(d);for(const i of Object.keys(l))l[i]===p&&t.push(i);return t}z(d,p,t,l=!1){const i=this.J(p);typeof t=="number"?i[d]!==t&&(i[d]=t,this.P(p)?.set(e.$fq,JSON.stringify(i),l)):typeof i[d]=="number"&&(delete i[d],this.P(p)?.set(e.$fq,JSON.stringify(i),l))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(d){switch(d){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(d){const p=this.P(d);return p?w(p):Object.create(null)}isNew(d){return this.getBoolean(e.$eq,d)===!0}async flush(d=D.NONE){this.f.fire({reason:d});const p=this.P(v.APPLICATION),t=this.P(v.PROFILE),l=this.P(v.WORKSPACE);switch(d){case D.NONE:await n.Promises.settled([p?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await n.Promises.settled([p?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(v.APPLICATION)?.items??new Map,p=this.P(v.PROFILE)?.items??new Map,t=this.P(v.WORKSPACE)?.items??new Map;return $(d,p,t,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,p){return this.w(D.NONE),(0,o.$Ll)(d)?this.R(d,p):this.S(d,p)}M(d,p){return!(d.id===p.id||f(p)&&f(d))}N(d,p,t){this.y(()=>{const l=new Set;for(const[i,g]of d)l.add(i),p.get(i)!==g&&this.u(t,{key:i,external:!0});for(const[i]of p.items)l.has(i)||this.u(t,{key:i,external:!0})})}}e.$iq=a;function f(b){return b.isDefault||!!b.useDefaultFlags?.globalState}class m extends a{constructor(){super(),this.U=this.B(new A.$cq(new A.$dq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$cq(new A.$dq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$cq(new A.$dq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(v.WORKSPACE,d))),this.B(this.W.onDidChangeStorage(d=>this.u(v.PROFILE,d))),this.B(this.U.onDidChangeStorage(d=>this.u(v.APPLICATION,d)))}P(d){switch(d){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(d){switch(d){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$kq=m;async function $(b,d,p,t,l,i){const g=I=>{try{return JSON.parse(I)}catch{return I}},s=new Map,c=new Map;b.forEach((I,q)=>{s.set(q,I),c.set(q,g(I))});const u=new Map,S=new Map;d.forEach((I,q)=>{u.set(q,I),S.set(q,g(I))});const P=new Map,C=new Map;p.forEach((I,q)=>{P.set(q,I),C.set(q,g(I))}),console.group(t!==l?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((I,q)=>{L.push({key:q,value:I})}),console.table(L),console.groupEnd(),console.log(c),t!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const I=[];u.forEach((q,Y)=>{I.push({key:Y,value:q})}),console.table(I),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${i})`);const T=[];P.forEach((I,q)=>{T.push({key:q,value:I})}),console.table(T),console.groupEnd(),console.log(C)}}),define(ve[291],Se([1,0,15,23,100]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;async function k(R,A,y){let o=y&&y.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(o)return o;try{const v=(await A.readFile(R.serviceMachineIdResource)).value.toString();o=(0,r.$2g)(v)?v:null}catch{o=null}if(!o){o=(0,r.$3g)();try{await A.writeFile(R.serviceMachineIdResource,n.$Pe.fromString(o))}catch{}}return y?.store("storage.serviceMachineId",o,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),o}}),define(ve[292],Se([1,0,291,24,41]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=k;async function k(R,A,y,o,D,v,h){const w={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,E.$Cp)(A,y)&&(0,E.$Ep)(o)===r.TelemetryLevel.USAGE){const a=await(0,n.$mq)(y,D,v);w["X-Market-User-Id"]=a,w["VSCode-SessionId"]=h.machineId||a}return w}}),define(ve[141],Se([1,0,18,19,10,3,33,11,4,27,28,30,39,22,74,16,12,29,47,292,100,24,48]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0,e.$oq=H;const i=k.$o?w.TargetPlatform.WEB:(0,v.$fp)(k.$u,R.$hc),g="X-Market-Search-Activity-Id";var s;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished",V[V.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function c(...V){return String(V.reduce((M,G)=>M|G,0))}var u;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const S={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},P={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:v.SortBy.NoneOrRelevance,sortOrder:v.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class T{constructor(M=L){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,G=this.d.pageSize){return new T({...this.d,pageNumber:M,pageSize:G})}withFilter(M,...G){const X=[...this.d.criteria,...G.length?G.map(F=>({filterType:M,value:F})):[{filterType:M}]];return new T({...this.d,criteria:X})}withSortBy(M){return new T({...this.d,sortBy:M})}withSortOrder(M){return new T({...this.d,sortOrder:M})}withFlags(...M){return new T({...this.d,flags:M.reduce((G,X)=>G|X,0)})}withAssetTypes(...M){return new T({...this.d,assetTypes:M})}withSource(M){return new T({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:G,pageSize:X,sortBy:F,sortOrder:W,flags:oe,assetTypes:he}=this.d;return{filters:[{criteria:M,pageNumber:G,pageSize:X,sortBy:F,sortOrder:W}],assetTypes:he,flags:oe}}get searchText(){const M=this.d.criteria.filter(G=>G.filterType===u.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function I(V,M){const G=(V||[]).filter(X=>X.statisticName===M)[0];return G?G.value:0}function q(V){const M="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(X=>X.assetType.indexOf(M)===0).reduce((X,F)=>{const W=re(V,F.assetType);return W&&X.push([F.assetType.substring(M.length),W]),X},[])}function Y(V){if(V.properties){const M=V.properties.filter(F=>F.key===S.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=M.filter(F=>G.test(F.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return re(V,S.Repository)}function Q(V){return{uri:`${V.fallbackAssetUri}/${S.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${S.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function re(V,M){return V.files.filter(X=>X.assetType===M)[0]?{uri:`${V.assetUri}/${M}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${M}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}:null}function te(V,M){const G=V.properties?V.properties.filter(F=>F.key===M):[],X=G.length>0&&G[0].value;return X?X.split(",").map(F=>(0,h.$Op)(F)):[]}function _(V){const M=V.properties?V.properties.filter(G=>G.key===P.Engine):[];return M.length>0&&M[0].value||""}function de(V){const M=V.properties?V.properties.filter(G=>G.key===P.PreRelease):[];return M.length>0&&M[0].value==="true"}function J(V){const M=V.properties?V.properties.filter(X=>X.key===P.EnabledApiProposals):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function ae(V){const M=V.properties?V.properties.filter(X=>X.key===P.LocalizedLanguages):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function z(V){return V.properties?.find(M=>M.key===P.SponsorLink)?.value}function B(V){return V.properties?.find(M=>M.key===P.SupportLink)?.value}function ie(V){return V.indexOf("preview")!==-1}function le(V){return V.targetPlatform?(0,v.$ep)(V.targetPlatform):w.TargetPlatform.UNDEFINED}function pe(V){const M=(0,n.$Pb)(V.versions.map(le)),G=!!V.tags?.includes(v.$$o),X=M.indexOf(w.TargetPlatform.WEB);return G?X===-1&&M.push(w.TargetPlatform.WEB):X!==-1&&M.splice(X,1),M}function H(V,M){for(let G=0;G<V.length;G++){const X=V[G];if(X.version===V[G-1]?.version){let F=G;if(le(X)===M)for(;F>0&&V[F-1].version===X.version;)F--;F!==G&&(V.splice(G,1),V.splice(F,0,X))}}return V}function ce(V,M,G){V.telemetryData={index:M,querySource:G,queryActivityId:V.queryContext?.[g]}}function x(V,M,G,X){const F=V.versions[0],W={manifest:re(M,S.Manifest),readme:re(M,S.Details),changelog:re(M,S.Changelog),license:re(M,S.License),repository:Y(M),download:Q(M),icon:re(M,S.Icon),signature:re(M,S.Signature),coreTranslations:q(M)};return{type:"gallery",identifier:{id:(0,h.$Pp)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:M.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(F),description:V.shortDescription??"",installCount:I(V.statistics,"install"),rating:I(V.statistics,"averagerating"),ratingCount:I(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:G,assets:W,properties:{dependencies:te(M,P.Dependency),extensionPack:te(M,P.ExtensionPack),engine:_(M),enabledApiProposals:J(M),localizedLanguages:ae(M),targetPlatform:le(M),isPreReleaseVersion:de(M)},hasPreReleaseVersion:de(F),hasReleaseVersion:!0,preview:ie(V.flags),isSigned:!!W.signature,queryContext:X,supportLink:B(F)}}let U=class{constructor(M,G,X,F,W,oe,he,ke){this.l=G,this.n=X,this.o=F,this.q=W,this.u=oe,this.w=he,this.x=ke;const Ne=he.extensionsGallery,me=Ne?.servicePPEUrl&&ke.getValue("_extensionsGallery.enablePPE");this.d=me?Ne.servicePPEUrl:Ne?.serviceUrl,this.g=me?void 0:Ne?.searchUrl,this.h=Ne?.controlUrl,this.k=he.extensionsEnabledWithApiProposalVersion?.map($e=>$e.toLowerCase())??[],this.j=(0,d.$nq)(he.version,he,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,G,X){const F=r.CancellationToken.isCancellationToken(G)?{}:G,W=r.CancellationToken.isCancellationToken(G)?G:X,oe=[],he=[],ke=[],Ne=[];let me=!0;for(const Oe of M){Oe.uuid?he.push(Oe.uuid):oe.push(Oe.id);const fe=!!(Oe.version||Oe.preRelease);ke.push({id:Oe.id,uuid:Oe.uuid,includePreRelease:fe}),Oe.version&&Ne.push({id:Oe.id,uuid:Oe.uuid,version:Oe.version}),me=me&&!!Oe.hasPreRelease&&!fe}if(!he.length&&!oe.length)return[];let $e=new T().withPage(1,M.length);he.length&&($e=$e.withFilter(u.ExtensionId,...he)),oe.length&&($e=$e.withFilter(u.ExtensionName,...oe)),(F.queryAllVersions||me)&&($e=$e.withFlags($e.flags,s.IncludeVersions)),F.source&&($e=$e.withSource(F.source));const{extensions:Pe}=await this.B($e,{targetPlatform:F.targetPlatform??i,includePreRelease:ke,versions:Ne,compatible:!!F.compatible,productVersion:F.productVersion??{version:this.w.version,date:this.w.date}},W);return F.source&&Pe.forEach((Oe,fe)=>ce(Oe,fe,F.source)),Pe}async getCompatibleExtension(M,G,X,F={version:this.w.version,date:this.w.date}){if((0,v.$gp)(M.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(M,G,X))return M;const W=new T().withFlags(s.IncludeVersions).withPage(1,1).withFilter(u.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.B(W,{targetPlatform:X,compatible:!0,includePreRelease:G,productVersion:F},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,G,X,F={version:this.w.version,date:this.w.date}){if(!(0,v.$hp)(M.properties.targetPlatform,M.allTargetPlatforms,X)||!G&&M.properties.isPreReleaseVersion)return!1;let W=M.properties.engine;if(!W){const oe=await this.getManifest(M,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");W=oe.engines.vscode}return!(!(0,a.$4p)(W,F.version,F.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,G){return!G||!this.k.includes(M.id.toLowerCase())?!0:(0,a.$5p)(G)}async A(M,G,X,F,W,oe,he={version:this.w.version,date:this.w.date}){if(!(0,v.$hp)(le(G),W,oe)||X!=="any"&&de(G)!==(X==="prerelease"))return!1;if(F)try{const ke=await this.G(M,G);if(!(0,a.$4p)(ke,he.version,he.date))return!1}catch(ke){return this.n.error(`Error while getting the engine for the version ${G.version}.`,(0,E.$ab)(ke)),!1}return!0}async query(M,G){let X=M.text||"";const F=M.pageSize??50;let W=new T().withPage(1,F);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,$e,Pe)=>(W=W.withFilter(u.Category,Pe||$e),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,$e,Pe)=>(W=W.withFilter(u.Tag,Pe||$e),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(u.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),W=W.withFilter(u.SearchText,X)),W=W.withSortBy(v.SortBy.NoneOrRelevance)):M.ids?W=W.withFilter(u.ExtensionId,...M.ids):M.names?W=W.withFilter(u.ExtensionName,...M.names):W=W.withSortBy(v.SortBy.InstallCount),typeof M.sortBy=="number"&&(W=W.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(W=W.withSortOrder(M.sortOrder)),M.source&&(W=W.withSource(M.source));const oe=async(me,$e)=>{const{extensions:Pe,total:Oe}=await this.B(me,{targetPlatform:i,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},$e);return Pe.forEach((fe,De)=>ce(fe,(me.pageNumber-1)*me.pageSize+De,M.source)),{extensions:Pe,total:Oe}},{extensions:he,total:ke}=await oe(W,G),Ne=async(me,$e)=>{if($e.isCancellationRequested)throw new E.$8;const{extensions:Pe}=await oe(W.withPage(me+1),$e);return Pe};return{firstPage:he,total:ke,pageSize:W.pageSize,getPage:Ne}}async B(M,G,X){const F=M.flags;M.flags&s.IncludeLatestVersionOnly&&M.flags&s.IncludeVersions&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),G.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:W,total:oe,context:he}=await this.D(M,X);if(!(M.flags&s.IncludeLatestVersionOnly)){const $e=[];for(const Pe of W){const Oe=await this.C(Pe,G,he);Oe&&$e.push(Oe)}return{extensions:$e,total:oe}}const Ne=[],me=new Map;for(let $e=0;$e<W.length;$e++){const Pe=W[$e],Oe={id:(0,h.$Pp)(Pe.publisher.publisherName,Pe.extensionName),uuid:Pe.extensionId},fe=(0,A.$mg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Re=>(0,h.$Kp)(Re,Oe))?.includePreRelease;if(G.compatible&&(0,v.$gp)(pe(Pe),G.targetPlatform))continue;const De=await this.C(Pe,G,he);!De||De.properties.isPreReleaseVersion&&(!fe||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==G.targetPlatform&&De.hasPreReleaseVersion?me.set(Pe.extensionId,$e):Ne.push([$e,De])}if(me.size){const $e=new l.$he,Pe=new T().withFlags(F&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,me.size).withFilter(u.ExtensionId,...me.keys()),{extensions:Oe}=await this.B(Pe,G,X);this.q.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:me.size});for(const fe of Oe){const De=me.get(fe.identifier.uuid);Ne.push([De,fe])}}return{extensions:Ne.sort(($e,Pe)=>$e[0]-Pe[0]).map(([,$e])=>$e),total:oe}}async C(M,G,X){const F={id:(0,h.$Pp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},W=G.versions?.find(Ne=>(0,h.$Kp)(Ne,F))?.version,oe=(0,A.$mg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ne=>(0,h.$Kp)(Ne,F))?.includePreRelease,he=pe(M),ke=H(M.versions,G.targetPlatform);if(G.compatible&&(0,v.$gp)(he,G.targetPlatform))return null;for(let Ne=0;Ne<ke.length;Ne++){const me=ke[Ne];if(!(W&&me.version!==W)){if(await this.A(F.id,me,oe?"any":"release",G.compatible,he,G.targetPlatform,G.productVersion))return G.compatible&&!this.z(F,J(me))?null:x(M,me,he,X);if(W&&me.version===W)return null}}return W||G.compatible?null:x(M,M.versions[0],he)}async D(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(u.Target,"Microsoft.VisualStudio.Code").withFilter(u.ExcludeWithFlags,c(s.Unpublished));const X=await this.j,F=JSON.stringify(M.raw),W={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)},oe=new l.$he;let he,ke,Ne=0;try{if(he=await this.l.request({type:"POST",url:this.g&&M.criteria.some($e=>$e.filterType===u.SearchText)?this.g:this.y("/extensionquery"),data:F,headers:W},G),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:Ne};const me=await(0,b.$_p)(he);if(me){const $e=me.results[0],Pe=$e.extensions,Oe=$e.resultMetadata&&$e.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return Ne=Oe&&Oe.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:Pe,total:Ne,context:{[g]:he.res.headers.activityid}}}return{galleryExtensions:[],total:Ne}}catch(me){if((0,E.$7)(me))throw ke=v.ExtensionGalleryErrorCode.Cancelled,me;{const $e=(0,E.$ab)(me);throw ke=$e.startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed,new v.$kp($e,ke)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(F.length),duration:oe.elapsed(),success:!!he&&(0,b.$8p)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ke,count:String(Ne)})}}async reportStatistic(M,G,X,F){if(!this.isEnabled())return;const W=k.$o?this.y(`/itemName/${M}.${G}/version/${X}/statType/${F===v.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${G}/${X}/stats?statType=${F}`),oe=k.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ke={...await this.j,Accept:oe};try{await this.l.request({type:"POST",url:W,headers:ke},r.CancellationToken.None)}catch{}}async download(M,G,X){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const F=(0,h.$Sp)(M),W=new Date().getTime(),oe=X===v.InstallOperation.Install?"install":X===v.InstallOperation.Update?"update":"",he=oe?{uri:`${M.assets.download.uri}${y.URI.parse(M.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${M.assets.download.fallbackUri}${y.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:M.assets.download,ke=M.queryContext?.[g]?{[g]:M.queryContext[g]}:void 0,Ne=await this.F(M.identifier.id,he,S.VSIX,ke?{headers:ke}:void 0);try{await this.u.writeFile(G,Ne.stream)}catch(me){try{await this.u.del(G)}catch($e){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,E.$ab)($e))}throw new v.$kp((0,E.$ab)(me),v.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...F,duration:new Date().getTime()-W})}async downloadSignatureArchive(M,G){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const X=await this.F(M.identifier.id,M.assets.signature,S.Signature);try{await this.u.writeFile(G,X.stream)}catch(F){try{await this.u.del(G)}catch(W){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,E.$ab)(W))}throw new v.$kp((0,E.$ab)(F),v.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,G){if(M.assets.readme){const X=await this.F(M.identifier.id,M.assets.readme,S.Details,{},G);return await(0,b.$$p)(X)||""}return""}async getManifest(M,G){if(M.assets.manifest){const X=await this.F(M.identifier.id,M.assets.manifest,S.Manifest,{},G),F=await(0,b.$$p)(X);return F?JSON.parse(F):null}return null}async E(M,G,X){const F=re(G,S.Manifest);if(!F)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},oe=await this.F(M,F,S.Manifest,{headers:W});return await(0,b.$_p)(oe)}async getCoreTranslation(M,G){const X=M.assets.coreTranslations.filter(F=>F[0]===G.toUpperCase())[0];if(X){const F=await this.F(M.identifier.id,X[1],X[0]),W=await(0,b.$$p)(F);return W?JSON.parse(W):null}return null}async getChangelog(M,G){if(M.assets.changelog){const X=await this.F(M.identifier.id,M.assets.changelog,S.Changelog,{},G);return await(0,b.$$p)(X)||""}return""}async getAllCompatibleVersions(M,G,X){let F=new T().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.uuid?F=F.withFilter(u.ExtensionId,M.uuid):F=F.withFilter(u.ExtensionName,M.id);const{galleryExtensions:W}=await this.D(F,r.CancellationToken.None);if(!W.length)return[];const oe=pe(W[0]);if((0,v.$gp)(oe,X))return[];const he=[];await Promise.all(W[0].versions.map(async me=>{try{await this.A(M.id,me,G?"any":"release",!0,oe,X)&&this.z(M,J(me))&&he.push(me)}catch{}}));const ke=[],Ne=new Set;for(const me of H(he,X))Ne.has(me.version)||(Ne.add(me.version),ke.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:de(me)}));return ke}async F(M,G,X,F={},W=r.CancellationToken.None){const oe=await this.j,he={type:"GET"},ke={...oe,...F.headers||{}};F={...F,...he,headers:ke};const Ne=G.uri,me=G.fallbackUri,$e={...F,url:Ne};try{const Pe=await this.l.request($e,W);if(Pe.res.statusCode===200)return Pe;const Oe=await(0,b.$$p)(Pe);throw new Error(`Expected 200, got back ${Pe.res.statusCode} instead.

${Oe}`)}catch(Pe){if((0,E.$7)(Pe))throw Pe;const Oe=(0,E.$ab)(Pe);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:X,message:Oe});const fe={...F,url:me};return this.l.request(fe,W)}}async G(M,G){let X=_(G);if(!X){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:G.version});const F=await this.E(M,G,r.CancellationToken.None);if(!F)throw new Error("Manifest was not found");X=F.engines.vscode}return X}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},r.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,b.$_p)(M),X=[],F={},W=[],oe=[];if(G){for(const he of G.malicious)X.push({id:he});if(G.migrateToPreRelease)for(const[he,ke]of Object.entries(G.migrateToPreRelease))(!ke.engine||(0,a.$4p)(ke.engine,this.w.version,this.w.date))&&(F[he.toLowerCase()]={disallowInstall:!0,extension:{id:ke.id,displayName:ke.displayName,autoMigrate:{storage:!!ke.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[he,ke]of Object.entries(G.deprecated))ke&&(F[he.toLowerCase()]=(0,A.$mg)(ke)?{}:ke);if(G.search)for(const he of G.search)W.push(he);if(Array.isArray(G.extensionsEnabledWithPreRelease))for(const he of G.extensionsEnabledWithPreRelease)oe.push(he.toLowerCase())}return{malicious:X,deprecated:F,search:W,extensionsEnabledWithPreRelease:oe}}};U=Be([je(1,b.$6p),je(2,m.$ak),je(3,D.$Ni),je(4,t.$_l),je(5,f.$al),je(6,$.$tk),je(7,o.$aj)],U);let O=class extends U{constructor(M,G,X,F,W,oe,he,ke){super(M,G,X,F,W,oe,he,ke)}};e.$pq=O,e.$pq=O=Be([je(0,p.$gq),je(1,b.$6p),je(2,m.$ak),je(3,D.$Ni),je(4,t.$_l),je(5,f.$al),je(6,$.$tk),je(7,o.$aj)],O);let Z=class extends U{constructor(M,G,X,F,W,oe,he){super(void 0,M,G,X,F,W,oe,he)}};e.$qq=Z,e.$qq=Z=Be([je(0,b.$6p),je(1,m.$ak),je(2,D.$Ni),je(3,t.$_l),je(4,f.$al),je(5,$.$tk),je(6,o.$aj)],Z)}),define(ve[293],Se([1,0,6,2,34,59]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0;class R{constructor(o,D){this.a=o,this.b=D}listen(o,D){const v=this.b(o);switch(D){case"onDidChangeProfiles":return n.Event.map(this.a.onDidChangeProfiles,h=>({all:h.all.map(w=>(0,k.$On)({...w},v)),added:h.added.map(w=>(0,k.$On)({...w},v)),removed:h.removed.map(w=>(0,k.$On)({...w},v)),updated:h.updated.map(w=>(0,k.$On)({...w},v))}))}throw new Error(`Invalid listen ${D}`)}async call(o,D,v){const h=this.b(o);switch(D){case"createProfile":{const w=await this.a.createProfile(v[0],v[1],v[2]);return(0,k.$On)({...w},h)}case"updateProfile":{let w=(0,E.$Nl)((0,k.$Pn)(v[0],h),this.a.profilesHome.scheme);return w=await this.a.updateProfile(w,v[1]),(0,k.$On)({...w},h)}case"removeProfile":{const w=(0,E.$Nl)((0,k.$Pn)(v[0],h),this.a.profilesHome.scheme);return this.a.removeProfile(w)}}throw new Error(`Invalid call ${D}`)}}e.$uR=R;class A extends r.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(o,D,v){super(),this.profilesHome=D,this.f=v,this.a=[],this.b=this.B(new n.$ne),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=o.map(h=>(0,E.$Nl)(h,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(h=>{const w=h.added.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),a=h.removed.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),f=h.updated.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme));this.a=h.all.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),this.b.fire({added:w,removed:a,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(o){this.c=o}isEnabled(){return this.c}async createNamedProfile(o,D,v){const h=await this.f.call("createNamedProfile",[o,D,v]);return(0,E.$Nl)(h,this.profilesHome.scheme)}async createProfile(o,D,v,h){const w=await this.f.call("createProfile",[o,D,v,h]);return(0,E.$Nl)(w,this.profilesHome.scheme)}async createTransientProfile(o){const D=await this.f.call("createTransientProfile",[o]);return(0,E.$Nl)(D,this.profilesHome.scheme)}async setProfileForWorkspace(o,D){await this.f.call("setProfileForWorkspace",[o,D])}removeProfile(o){return this.f.call("removeProfile",[o])}async updateProfile(o,D){const v=await this.f.call("updateProfile",[o,D]);return(0,E.$Nl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$vR=A}),define(ve[142],Se([1,0,4,28,16,12,271,36,34,11,272]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";var v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let w=class extends y.$Pl{static{v=this}static{this.a="profileAssociationsMigration"}constructor($,b,d,p,t){super(d,p,b,t),this.U=$,this.W=d}O(){return this.U.getItem(v.b,[]).map(b=>({...b,location:(0,o.$gg)(b.location)?this.w.extUri.joinPath(this.profilesHome,b.location):n.URI.revive(b.location)}))}Q(){const $=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=w,e.$kR=w=v=Be([je(0,R.$fR),je(1,A.$Kl),je(2,r.$Oi),je(3,E.$al),je(4,k.$ak)],w);let a=h=class extends w{constructor($,b,d,p,t){super($,b,d,p,t),this.$=$}P($){$.length?this.$.setItem(h.b,$.map(b=>({...b,location:this.w.extUri.basename(b.location)}))):this.$.removeItem(h.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(h.c,$):this.$.removeItem(h.c)}Q(){const $="workspaceAndProfileInfo",b=this.$.getItem($,void 0);if(b){this.$.removeItem($);const p=b.reduce((t,{workspace:l,profile:i})=>(t[n.URI.revive(l).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(h.c,{workspaces:p})}const d=super.Q();return this.$.getItem(h.a,!1)||(this.R(d),this.$.setItem(h.a,!0)),d}};e.$lR=a,e.$lR=a=h=Be([je(0,R.$gR),je(1,A.$Kl),je(2,r.$Oi),je(3,E.$al),je(4,k.$ak)],a);let f=class extends a{constructor($,b,d,p){super(new D.$jR(D.SaveStrategy.IMMEDIATE,b,p,d),$,b,d,p)}async init(){return await this.$.init(),super.init()}};e.$mR=f,e.$mR=f=Be([je(0,A.$Kl),je(1,r.$Oi),je(2,E.$al),je(3,k.$ak)],f)}),define(ve[143],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$Ym=(0,n.$Gi)("extensionHostStatusService");class r{constructor(){this.a=new Map}setExitInfo(k,R){this.a.set(k,R)}getExitInfo(k){return this.a.get(k)||null}}e.$Zm=r}),define(ve[294],Se([1,0,61,6,14]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0;function k(A){let y=0,o=0,D=0;A>=1e3&&(D=Math.floor(A/1e3),A-=D*1e3),D>=60&&(o=Math.floor(D/60),D-=o*60),o>=60&&(y=Math.floor(o/60),o-=y*60);const v=y?`${y}h`:"",h=o?`${o}m`:"",w=D?`${D}s`:"",a=A?`${A}ms`:"";return`${v}${h}${w}${a}`}class R{constructor(y,o,D,v){this.i=y,this.j=o,this.a=new r.$ne,this.onClose=this.a.event,this.b=n.ProtocolConstants.ReconnectionGraceTime,this.c=n.ProtocolConstants.ReconnectionShortGraceTime,this.d=D,this.protocol=v,this.e=!1,this.f=new E.$Th(()=>{this.k(`The reconnection grace time of ${k(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new E.$Th(()=>{this.k(`The reconnection short grace time of ${k(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${k(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(y){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${y}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${k(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const y=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),y.end(),this.a.fire(void 0)}acceptReconnection(y,o,D){this.d=y,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(o,D),this.protocol.endAcceptReconnection()}}e.$Fn=R});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[144],Se([1,0,31,13,9,176,62]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.$1m=D,n=qe(n),E=qe(E),k=qe(k),R=mt(R);const A=E.$mc(r.$1g.asFileUri("").fsPath,"nls.metadata.json"),y=new Map;function o(h){return new Promise(w=>n.exists(h,w))}function D(h,w){return o(A).then(a=>{if(!a||!R.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const f=`${h}||${w}`;let m=y.get(f);return m||(m=k.getNLSConfiguration(R.default.commit,w,A,h,h).then($=>(v.is($)&&($._languagePackSupport=!0),$)),y.set(f,m)),m})}var v;(function(h){function w(a){const f=a;return f&&typeof f._languagePackId=="string"}h.is=w})(v||(e.InternalNLSConfiguration=v={}))}),define(ve[145],Se([1,0,20,4,28,54,64,16,5,12,29,36,34,144]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=void 0;let a=class extends R.$Mq{constructor(m,$,b,d,p,t,l,i){super(r.URI.file(p.builtinExtensionsPath),r.URI.file(p.extensionsPath),(0,n.$hh)(p.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,$,b,d,p,t,l,i),this.S=p}async f(m){const $=await(0,w.$1m)(m,this.S.userDataPath);if(w.InternalNLSConfiguration.is($))try{const b=await this.w.readFile(r.URI.file($._translationsConfigFile));return JSON.parse(b.value.toString())}catch{}return Object.create(null)}};e.$aR=a,e.$aR=a=Be([je(0,h.$Ml),je(1,k.$Hq),je(2,A.$al),je(3,o.$ak),je(4,E.$Oi),je(5,D.$tk),je(6,v.$Kl),je(7,y.$Fi)],a)}),define(ve[101],Se([1,0,295,31,9,23,13,25]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.ServerConnectionTokenType=void 0,e.$Jn=w,e.$Kn=a,e.$Ln=f,n=qe(n),r=qe(r),E=qe(E);const y=/^[0-9A-Za-z_-]+$/;var o;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(o||(e.ServerConnectionTokenType=o={}));class D{constructor(){this.type=o.None}validate($){return!0}}e.$Gn=D;class v{constructor($){this.value=$,this.type=o.Mandatory}validate($){return $===this.value}}e.$Hn=v;class h{constructor($){this.message=$}}e.$In=h;async function w(m,$){const b=m["without-connection-token"],d=m["connection-token"],p=m["connection-token-file"];if(b)return typeof d<"u"||typeof p<"u"?new h("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof p<"u"){if(typeof d<"u")return new h("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let t;try{t=r.readFileSync(p).toString().replace(/\r?\n$/,"")}catch{return new h(`Unable to read the connection token file at '${p}'.`)}return y.test(t)?new v(t):new h(`The connection token defined in '${p} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof d<"u"?y.test(d)?new v(d):new h(`The connection token '${d} does not adhere to the characters 0-9, a-z, A-Z or -.`):new v(await $())}async function a(m){return w(m,async()=>{if(!m["user-data-dir"])return(0,k.$3g)();const b=E.$mc(m["user-data-dir"],"token");try{const t=(await A.Promises.readFile(b)).toString().replace(/\r?\n$/,"");if(y.test(t))return t}catch{}const d=(0,k.$3g)();try{await A.Promises.writeFile(b,d,{mode:384})}catch{}return d})}function f(m,$,b){if(m.validate(b.query[R.$Sg]))return!0;const d=n.parse($.headers.cookie||"");return m.validate(d[R.$Rg])}}),define(ve[55],Se([1,0,230,118,70,5,28,78]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,n=qe(n),e.$_m={host:{type:"string",cat:"o",args:"ip-address",description:n.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:n.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:n.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:n.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:n.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:n.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:n.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:n.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:n.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:n.localize(9,null)},"user-data-dir":E.$Cm["user-data-dir"],"enable-smoke-test-driver":E.$Cm["enable-smoke-test-driver"],"disable-telemetry":E.$Cm["disable-telemetry"],"disable-workspace-trust":E.$Cm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:E.$Cm.log,logsPath:E.$Cm.logsPath,"force-disable-user-env":E.$Cm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:n.localize(10,null)},"default-workspace":{type:"string",description:n.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":E.$Cm["extensions-dir"],"extensions-download-dir":E.$Cm["extensions-download-dir"],"builtin-extensions-dir":E.$Cm["builtin-extensions-dir"],"install-extension":E.$Cm["install-extension"],"install-builtin-extension":E.$Cm["install-builtin-extension"],"update-extensions":E.$Cm["update-extensions"],"uninstall-extension":E.$Cm["uninstall-extension"],"list-extensions":E.$Cm["list-extensions"],"locate-extension":E.$Cm["locate-extension"],"show-versions":E.$Cm["show-versions"],category:E.$Cm.category,force:E.$Cm.force,"do-not-sync":E.$Cm["do-not-sync"],"pre-release":E.$Cm["pre-release"],"start-server":{type:"boolean",cat:"e",description:n.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:E.$Cm.help,version:E.$Cm.version,"locate-shell-integration-path":E.$Cm["locate-shell-integration-path"],compatibility:{type:"string"},_:E.$Cm._},e.$an=(0,k.$Hi)(R.$Ni);class y extends r.$9m{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$bn=y,Be([A.$$h],y.prototype,"userRoamingDataHome",null)}),define(ve[296],Se([1,0,31,25,83,93,295,96,37,68,3,12,55,9,13,23,29,101,47,19,4,15,11,35]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=e.CacheControl=void 0,e.$zR=s,e.$AR=u,E=qe(E),k=qe(k),R=qe(R),A=qe(A);const g={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(C,L,T,I){L.writeHead(T,{"Content-Type":"text/plain"}),L.end(I)}var c;(function(C){C[C.NO_CACHING=0]="NO_CACHING",C[C.ETAG=1]="ETAG",C[C.NO_EXPIRY=2]="NO_EXPIRY"})(c||(e.CacheControl=c={}));async function u(C,L,T,I,q,Y){try{const Q=await r.Promises.stat(C);if(L===c.ETAG){const re=`W/"${[Q.ino,Q.size,Q.mtime.getTime()].join("-")}"`;if(I.headers["if-none-match"]===re)return q.writeHead(304),void q.end();Y.Etag=re}else L===c.NO_EXPIRY?Y["Cache-Control"]="public, max-age=31536000":L===c.NO_CACHING&&(Y["Cache-Control"]="no-store");Y["Content-Type"]=g[(0,w.$rc)(C)]||(0,o.$$s)(C)||"text/plain",q.writeHead(200,Y),(0,n.createReadStream)(C).pipe(q)}catch(Q){return Q.code!=="ENOENT"?(T.error(Q),console.error(Q.toString())):console.error(`File not found: ${C}`),q.writeHead(404,{"Content-Type":"text/plain"}),void q.end("Not found")}}const S=(0,w.$pc)(a.$1g.asFileUri("").fsPath);let P=class{constructor(L,T,I,q,Y,Q,re){this.f=L,this.g=T,this.serverRootPath=I,this.h=q,this.i=Y,this.j=Q,this.k=re,this.a=this.k.extensionsGallery?.resourceUrlTemplate?p.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${I}/static`,this.c=`${I}/callback`,this.d=`${I}/web-extension-resource`}async handle(L,T,I){try{const q=I.pathname;return q.startsWith(this.b)&&q.charCodeAt(this.b.length)===i.CharCode.Slash?this.l(L,T,I):q===this.g?this.o(L,T,I):q===this.c?this.q(T):q.startsWith(this.d)&&q.charCodeAt(this.d.length)===i.CharCode.Slash?this.n(L,T,I):s(L,T,404,"Not found.")}catch(q){return this.i.error(q),console.error(q.toString()),s(L,T,500,"Internal Server Error.")}}async l(L,T,I){const q=Object.create(null),Q=decodeURIComponent(I.pathname).substring(this.b.length+1),re=(0,w.$mc)(S,Q);return(0,y.$Fg)(re,S,!D.$k)?u(re,this.h.isBuilt?c.NO_EXPIRY:c.ETAG,this.i,L,T,q):s(L,T,400,"Bad request.")}m(L){const T=L.authority.indexOf(".");return T!==-1?L.authority.substring(T+1):void 0}async n(L,T,I){if(!this.a)return s(L,T,500,"No extension gallery service configured.");const q=decodeURIComponent(I.pathname),Y=(0,w.$kc)(q.substring(this.d.length+1)),Q=p.URI.parse(Y).with({scheme:this.a.scheme,authority:Y.substring(0,Y.indexOf("/")),path:Y.substring(Y.indexOf("/")+1)});if(this.m(this.a)!==this.m(Q))return s(L,T,403,"Request Forbidden");const re={},te=B=>{const ie=L.headers[B];ie&&((0,l.$gg)(ie)||ie[0])?re[B]=(0,l.$gg)(ie)?ie:ie[0]:B!==B.toLowerCase()&&te(B.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const _=await this.j.request({type:"GET",url:Q.toString(!0),headers:re},d.CancellationToken.None),de=_.res.statusCode||500;if(de!==200){let B=null;try{B=await(0,b.$$p)(_)}catch{}return s(L,T,de,B||`Request failed with status ${de}`)}const J=Object.create(null),ae=B=>{const ie=_.res.headers[B];ie?J[B]=ie:B!==B.toLowerCase()&&ae(B.toLowerCase())};ae("Cache-Control"),ae("Content-Type"),T.writeHead(200,J);const z=await(0,t.$2e)(_.stream);return void T.end(z.buffer)}async o(L,T,I){const q=I.query[a.$Sg];if(typeof q=="string"){const U=Object.create(null);U["Set-Cookie"]=R.serialize(a.$Rg,q,{sameSite:"lax",maxAge:60*60*24*7});const O=Object.create(null);for(const V in I.query)V!==a.$Sg&&(O[V]=I.query[V]);const Z=k.format({pathname:I.pathname,query:O});return U.Location=Z,T.writeHead(302,U),void T.end()}const Y=U=>{const O=L.headers[U];return Array.isArray(O)?O[0]:O},Q=!this.h.isBuilt&&this.h.args["use-test-resolver"],re=Q?"test+test":Y("x-original-host")||Y("x-forwarded-host")||L.headers.host;if(!re)return s(L,T,400,"Bad request.");function te(U){return JSON.stringify(U).replace(/"/g,"&quot;")}let _;this.h.args["enable-smoke-test-driver"]&&(_=!1);const de=U=>U&&p.URI.file(E.resolve(U)).with({scheme:a.Schemas.vscodeRemote,authority:re}),J=a.$1g.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ae=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,f.$3g)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,z={embedderIdentifier:"server-distro",extensionsGallery:this.a&&this.k.extensionsGallery?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:re,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const U=JSON.parse((await r.Promises.readFile((0,w.$mc)(S,"product.overrides.json"))).toString());Object.assign(z,U)}catch{}const B={remoteAuthority:re,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:_,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:de(this.h.args["default-folder"]),workspaceUri:de(this.h.args["default-workspace"]),productConfiguration:z,callbackRoute:this.c},ie=this.k.extensionsGallery?.nlsBaseUrl,le={WORKBENCH_WEB_CONFIGURATION:te(B),WORKBENCH_AUTH_SESSION:ae?te(ae):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:ie?`${ie}${ie.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""};if(Q){const U=[];for(const O of["vscode-test-resolver","github-authentication"]){const Z=JSON.parse((await r.Promises.readFile(a.$1g.asFileUri(`${a.$Vg}/${O}/package.json`).fsPath)).toString());U.push({extensionPath:O,packageJSON:Z})}le.WORKBENCH_BUILTIN_EXTENSIONS=te(U)}let pe;try{pe=(await r.Promises.readFile(J)).toString().replace(/\{\{([^}]+)\}\}/g,(O,Z)=>le[Z]??"undefined")}catch{return T.writeHead(404,{"Content-Type":"text/plain"}),void T.end("Not found")}const x={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(pe).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${Q?"":`http://${re}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==$.ServerConnectionTokenType.None&&(x["Set-Cookie"]=R.serialize(a.$Rg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),T.writeHead(200,x),void T.end(pe)}p(L){const T=/<script>([\s\S]+?)<\/script>/img,I=[];let q;for(;q=T.exec(L);){const Y=A.createHash("sha256"),Q=q[1].replace(/\r\n/g,`
`),re=Y.update(Buffer.from(Q)).digest().toString("base64");I.push(`'sha256-${re}'`)}return I}async q(L){const T=a.$1g.asFileUri("vs/code/browser/workbench/callback.html").fsPath,I=(await r.Promises.readFile(T)).toString(),q=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(I).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return L.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":q}),void L.end(I)}};e.$BR=P,e.$BR=P=Be([je(3,h.$an),je(4,v.$ak),je(5,b.$6p),je(6,m.$tk)],P)}),define(ve[297],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,n.$Gi)("IExtHostInitDataService")}),define(ve[298],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,n.$Gi)("IExtHostRpcService");class r{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.$2P=r}),define(ve[75],Se([1,0,59]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=E;function r(k){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:k,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function E(k){return new n.$Mn(r(k))}}),define(ve[299],Se([1,0,3,44,4,75,59,115,274,9,101,20]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0,n=qe(n),r=qe(r);class h{static{this.a=1}constructor(a,f,m,$){this.b=a,this.c=f,this.d=m,this.e=$}async call(a,f,m){switch(f){case"getEnvironmentData":{const $=m,b=(0,k.$Ts)($.remoteAuthority);let d=await this.f($.profile);return d=(0,R.$On)(d,b),d}case"getExtensionHostExitInfo":{const $=m;return this.e.getExitInfo($.reconnectionToken)}case"getDiagnosticInfo":{const $=m,b={machineInfo:(0,y.$Xs)()},d=$.includeProcesses?(0,A.$Vs)(process.pid):Promise.resolve();let p=[];const t={};if($.folders){const l=(0,k.$Ts)("");p=$.folders.map(g=>E.URI.revive(l.transformIncoming(g))).filter(g=>g.scheme==="file").map(g=>(0,y.$Ws)(g.fsPath,["node_modules",".git"]).then(s=>{t[(0,o.$qc)(g.fsPath)]=s}))}return Promise.all([d,...p]).then(([l,i])=>(b.processes=l||void 0,b.workspaceMetadata=$.folders?t:void 0,b))}}throw new Error(`IPC Command ${f} not found`)}listen(a,f,m){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(m=>m.id===a)&&await this.d.createProfile(a,a);let f=!1;if(process.platform==="linux"){const m=process.glibcVersion;f=(m?parseInt(m.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==D.ServerConnectionTokenType.None?this.b.value:"",appRoot:E.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,v.$hh)(this.c.logsHome,`exthost${h.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:n.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(m=>({...m}))},isUnsupportedGlibc:f}}}e.$1s=h}),define(ve[300],Se([1,0,4,75,72,9,259]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0;class A extends R.$2s{constructor(D,v){super(new E.$rr(D),D),this.N=v,this.M=new Map,this.B(this.a)}c(D){let v=this.M.get(D.remoteAuthority);return v||(v=(0,r.$Ts)(D.remoteAuthority),this.M.set(D.remoteAuthority,v)),v}f(D,v,h=!1){if(h&&v.path==="/vscode-resource"&&v.query){const w=JSON.parse(v.query).requestResourcePath;return n.URI.from({scheme:"file",path:w})}return n.URI.revive(D.transformIncoming(v))}L(D,v){return new y(D,v,this.b,this.N)}}e.$4s=A;class y extends R.$3s{constructor(D,v,h,w){super(D,v,h,w)}j(D){const v=D.args["file-watcher-polling"];if(v){const h=v.split(k.$wc),w=Number(h[0]);if(w>0)return{usePolling:h.length>1?h.slice(1):!0,pollingInterval:w}}}m(D){if(D.extensionsPath)return[k.$jc.join(D.extensionsPath,"**")]}}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[102],Se([1,0,233,11,4,2,5,38,16,13,45,185,58]),function(se,e,n,r,E,k,R,A,y,o,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$eG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$7F=e.EditorInputCapabilities=e.$6F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$WF=f,e.$XF=m,e.$YF=$,e.$ZF=b,e.$1F=d,e.$2F=p,e.$3F=t,e.$4F=l,e.$5F=i,e.$8F=P,e.$9F=L,e.$0F=T,e.$$F=I,e.$_F=q,e.$aG=Y,e.$bG=Q,e.$cG=re,e.$dG=z,e.$fG=le,e.$gG=H,e.$hG=ce,e.$iG=x,h=mt(h),e.$RF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SF={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.$TF="workbench.editor.sidebysideEditor",e.$UF="workbench.editors.textDiffEditor",e.$VF="workbench.editors.binaryResourceDiffEditor";var w;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var a;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function f(U){const O=U;return!!O&&typeof O.getSelection=="function"&&!!O.onDidChangeSelection}function m(U){const O=U;return!!O&&typeof O.getScrollPosition=="function"&&typeof O.setScrollPosition=="function"&&!!O.onDidChangeScroll}function $(U,O,Z){for(const V of Z.visibleEditorPanes)if(V.group.id===O&&U.matches(V.input))return V.getViewState()}function b(U){if(P(U))return!1;const O=U;return E.URI.isUri(O?.resource)}function d(U){if(P(U))return!1;const O=U;return O?.original!==void 0&&O.modified!==void 0}function p(U){if(P(U))return!1;const O=U;return!O||O.resources&&!Array.isArray(O.resources)?!1:!!O.resources||!!O.multiDiffSource}function t(U){if(P(U)||d(U))return!1;const O=U;return O?.primary!==void 0&&O.secondary!==void 0}function l(U){if(P(U))return!1;const O=U;return O?O.resource===void 0||O.resource.scheme===o.Schemas.untitled||O.forceUntitled===!0:!1}function i(U){if(P(U))return!1;const O=U;return E.URI.isUri(O?.base?.resource)&&E.URI.isUri(O?.input1?.resource)&&E.URI.isUri(O?.input2?.resource)&&E.URI.isUri(O?.result?.resource)}var g;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var s;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(O,Z){let V=this.a.get(O);return V||(V={source:O,label:Z},this.a.set(O,V)),V.source}getSourceLabel(O){return this.a.get(O)?.label??O}}e.$6F=new c;var u;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors",U[U.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class S extends k.$Xc{}e.$7F=S;function P(U){return U instanceof S}function C(U){const O=U;return E.URI.isUri(O?.preferredResource)}function L(U){const O=U;return P(O?.primary)&&P(O?.secondary)}function T(U){const O=U;return P(O?.modified)&&P(O?.original)}function I(U,O,Z,V,M){return x(V,[(0,v.$qj)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const G={...Z,limits:{size:Number.MAX_VALUE}};U.openEditor(O,G)}}),(0,v.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>M.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function q(U){return P(U?.editor)}function Y(U){const O=U;return q(U)&&O?.group!==void 0}function Q(U){const O=U;return typeof O?.groupId=="number"&&P(O.editor)}function re(U){return typeof U?.groupId=="number"}var te;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(te||(e.EditorCloseContext=te={}));var _;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LABEL=2]="GROUP_LABEL",U[U.GROUP_LOCKED=3]="GROUP_LOCKED",U[U.EDITORS_SELECTION=4]="EDITORS_SELECTION",U[U.EDITOR_OPEN=5]="EDITOR_OPEN",U[U.EDITOR_CLOSE=6]="EDITOR_CLOSE",U[U.EDITOR_MOVE=7]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=9]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=11]="EDITOR_PIN",U[U.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",U[U.EDITOR_STICKY=13]="EDITOR_STICKY",U[U.EDITOR_DIRTY=14]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(_||(e.GroupModelChangeKind=_={}));var de;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(de||(e.SideBySideEditor=de={}));class J{getOriginalUri(O,Z){if(!O)return;if(i(O))return e.$eG.getOriginalUri(O.result,Z);if(Z?.supportSideBySide){const{primary:M,secondary:G}=this.a(O);if(M&&G){if(Z?.supportSideBySide===de.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===de.ANY)return this.getOriginalUri(M,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(G,{filterByScheme:Z.filterByScheme});O=Z.supportSideBySide===de.PRIMARY?M:G}}if(d(O)||p(O)||t(O)||i(O))return;const V=C(O)?O.preferredResource:O.resource;return!V||!Z||!Z.filterByScheme?V:this.b(V,Z.filterByScheme)}a(O){return L(O)||t(O)?{primary:O.primary,secondary:O.secondary}:T(O)||d(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,Z){if(!O)return;if(i(O))return e.$eG.getCanonicalUri(O.result,Z);if(Z?.supportSideBySide){const{primary:M,secondary:G}=this.a(O);if(M&&G){if(Z?.supportSideBySide===de.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===de.ANY)return this.getCanonicalUri(M,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:Z.filterByScheme});O=Z.supportSideBySide===de.PRIMARY?M:G}}if(d(O)||p(O)||t(O)||i(O))return;const V=O.resource;return!V||!Z||!Z.filterByScheme?V:this.b(V,Z.filterByScheme)}b(O,Z){if(Array.isArray(Z)){if(Z.some(V=>O.scheme===V))return O}else if(Z===O.scheme)return O}}var ae;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.KEYBOARD=1]="KEYBOARD",U[U.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function z(U,O,Z,V){if(!U.isSticky(O))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return Z===ae.MOUSE||Z===ae.KEYBOARD;case"mouse":return Z===ae.MOUSE;case"keyboard":return Z===ae.KEYBOARD}return!1}e.$eG=new J;var B;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class ie{constructor(){this.c=new Map,this.d=new Map}start(O){const Z=this.a=O.get(R.$Fi);for(const[V,M]of this.c)this.e(V,M,Z);this.c.clear()}e(O,Z,V){const M=V.createInstance(Z);this.d.set(O,M)}registerFileEditorFactory(O){if(this.b)throw new Error("Can only register one file editor factory.");this.b=O}getFileEditorFactory(){return(0,r.$rg)(this.b)}registerEditorSerializer(O,Z){if(this.c.has(O)||this.d.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.a?this.e(O,Z,this.a):this.c.set(O,Z),(0,k.$Vc)(()=>{this.c.delete(O),this.d.delete(O)})}getEditorSerializer(O){return this.d.get(typeof O=="string"?O:O.typeId)}}A.$ro.add(e.$RF.EditorFactory,new ie);async function le(U,O,Z){return!U||!U.length?[]:await Promise.all(U.map(async V=>{const M=E.URI.revive(V.fileUri);if(!M){Z.info("Cannot resolve the path because it is not valid.",V);return}if(!await O.canHandleResource(M)){Z.info("Cannot resolve the path because it cannot be handled",V);return}let X=V.exists,F=V.type;if(typeof X!="boolean"||typeof F!="number")try{F=(await O.stat(M)).isDirectory?y.FileType.Directory:y.FileType.Unknown,X=!0}catch(oe){Z.error(oe),X=!1}if(!X&&V.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",V);return}if(F===y.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",V);return}const W={...V.options,pinned:!0};return X?{resource:M,options:W}:{resource:M,options:W,forceUntitled:!0}}))}var pe;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function H(U){const O=U;if(!O)return!1;const Z=O;if(Z.modified)return H(Z.modified);const V=O;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}function ce(U){return(0,D.$sj)(U)}function x(U,O,Z){const V=(0,D.$tj)(U,O);return V.forceMessage=Z?.forceMessage,V.forceSeverity=Z?.forceSeverity,V.allowDialog=Z?.allowDialog,V}}),define(ve[301],Se([1,0,234,42]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG=new r.$Xj("chatSessionResponseVote","",{type:"string",description:(0,n.localize)(0,null)}),e.$vG=new r.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,n.localize)(1,null)}),e.$wG=new r.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,n.localize)(2,null)}),e.$xG=new r.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,n.localize)(3,null)}),e.$yG=new r.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,n.localize)(4,null)}),e.$zG=new r.$Xj("chatResponse",!1,{type:"boolean",description:(0,n.localize)(5,null)}),e.$AG=new r.$Xj("chatRequest",!1,{type:"boolean",description:(0,n.localize)(6,null)}),e.$BG=new r.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,n.localize)(7,null)}),e.$CG=new r.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,n.localize)(8,null)}),e.$DG=new r.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,n.localize)(9,null)}),e.$EG=new r.$Xj("inChatInput",!1,{type:"boolean",description:(0,n.localize)(10,null)}),e.$FG=new r.$Xj("inChat",!1,{type:"boolean",description:(0,n.localize)(11,null)}),e.$GG=new r.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,n.localize)(12,null)}),e.$HG=new r.$Xj("chatCursorAtTop",!1),e.$IG=new r.$Xj("chatInputHasAgent",!1),e.$JG=new r.$Xj("chatLocation",void 0),e.$KG=new r.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,n.localize)(13,null)})}),define(ve[302],Se([1,0,105,14,19,6,40,2,50,166,17,42,22,5,12,29,47,100,301]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.ChatAgentLocation=void 0,e.$OH=g,e.$PH=s;var p;(function(c){c.Panel="panel",c.Terminal="terminal",c.Notebook="notebook",c.Editor="editor"})(p||(e.ChatAgentLocation=p={})),function(c){function u(S){switch(S){case"panel":return c.Panel;case"terminal":return c.Terminal;case"notebook":return c.Notebook;case"editor":return c.Editor}return c.Panel}c.fromRaw=u}(p||(e.ChatAgentLocation=p={})),e.$JH=(0,w.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=new Map,this.d=new k.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=b.$GG.bindTo(this.f)}registerAgent(u,S){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const C=this,L=S.slashCommands;S={...S,get slashCommands(){return L.filter(I=>!I.when||C.f.contextMatchesRules(v.$Ej.deserialize(I.when)))}};const T={data:S};return this.b.set(u,T),(0,A.$Vc)(()=>{this.b.delete(u),this.d.fire(void 0)})}registerAgentImplementation(u,S){const P=this.b.get(u);if(!P)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(P.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return P.data.isDefault&&this.e.set(!0),P.impl=S,this.d.fire(new l(P.data,S)),(0,A.$Vc)(()=>{P.impl=void 0,this.d.fire(void 0),P.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,S){u.isDynamic=!0;const P={data:u,impl:S};return this.b.set(u.id,P),this.d.fire(new l(u,S)),(0,A.$Vc)(()=>{this.b.delete(u.id),this.d.fire(void 0)})}registerAgentCompletionProvider(u,S){return this.g.set(u,S),{dispose:()=>{this.g.delete(u)}}}async getAgentCompletionItems(u,S,P){return await this.g.get(u)?.(S,P)??[]}updateAgent(u,S){const P=this.b.get(u);if(!P?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);P.data.metadata={...P.data.metadata,...S},this.d.fire(new l(P.data,P.impl))}getDefaultAgent(u){return(0,n.$ib)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(u))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}getAgent(u){if(this.h(u))return this.b.get(u)?.data}h(u){const S=this.b.get(u);return!S?.data.when||this.f.contextMatchesRules(v.$Ej.deserialize(S.data.when))}getAgentByFullyQualifiedId(u){const S=R.Iterable.find(this.b.values(),P=>g(P.data)===u)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(u=>u.data).filter(u=>this.h(u.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).filter(u=>this.h(u.data.id)).map(u=>new l(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(S=>S.name===u)}agentHasDupeName(u){const S=this.getAgent(u);return S?this.getAgentsByName(S.name).filter(P=>P.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(u,S,P,C,L){const T=this.b.get(u);if(!T?.impl)throw new Error(`No activated agent with id "${u}"`);return await T.impl.invoke(S,P,C,L)}async getFollowups(u,S,P,C,L){const T=this.b.get(u);if(!T?.impl)throw new Error(`No activated agent with id "${u}"`);return T.impl?.provideFollowups?T.impl.provideFollowups(S,P,C,L):[]}};e.$KH=t,e.$KH=t=Be([je(0,v.$Yj)],t);class l{constructor(u,S){this.b=u,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,S,P,C){return this.d.invoke(u,S,P,C)}async provideFollowups(u,S,P,C){return this.d.provideFollowups?this.d.provideFollowups(u,S,P,C):[]}provideWelcomeMessage(u,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,S)}provideSampleQuestions(u,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,S)}}e.$LH=l,e.$MH=(0,w.$Gi)("chatAgentNameService");let i=class{static{d=this}static{this.b="chat.participantNameRegistry"}constructor(u,S,P,C){if(this.g=S,this.h=P,this.i=C,this.e=(0,o.$8d)(this,Object.create(null)),this.f=!1,!u.chatParticipantRegistry)return;this.d=u.chatParticipantRegistry;const L=C.get(d.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(L??"{}"),void 0)}catch{C.remove(d.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(u=>this.h.warn("Failed to fetch chat participant registry",u)).then(()=>(0,r.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const u=await this.g.request({type:"GET",url:this.d},E.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,m.$_p)(u);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const P=S.restrictedChatParticipants;this.e.set(P,void 0),this.i.store(d.b,JSON.stringify(P),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(u){const S=this.l(u.name,u).get(),P=!u.fullName||this.l(u.fullName.replace(/\s/g,""),u).get();return S&&P}l(u,S){return this.e.map(C=>C[u.toLowerCase()]).map(C=>C?C.some(L=>(0,D.$Hf)(L,L.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$NH=i,e.$NH=i=d=Be([je(0,f.$tk),je(1,m.$6p),je(2,a.$ak),je(3,$.$gq)],i);function g(c){return`${c.extensionId.value}.${c.id}`}function s(c){const u="name"in c?c:{...c,name:c.id};return"extensionPublisherId"in u||(u.extensionPublisherId=u.extensionPublisher??""),"extensionDisplayName"in u||(u.extensionDisplayName=""),"extensionId"in u||(u.extensionId=new h.$rn("")),(0,y.$di)(u)}}),define(ve[303],Se([1,0,4,236,42,5]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AK=e.MemoryRangeType=e.State=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$zK=y,e.$BK=D,r=qe(r),e.$nJ="workbench.view.debug",e.$oJ="workbench.debug.variablesView",e.$pJ="workbench.debug.watchExpressionsView",e.$qJ="workbench.debug.callStackView",e.$rJ="workbench.debug.loadedScriptsView",e.$sJ="workbench.debug.breakPointsView",e.$tJ="workbench.debug.disassemblyView",e.$uJ="workbench.panel.repl",e.$vJ="workbench.panel.repl.view",e.$wJ=new E.$Xj("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.$xJ=new E.$Xj("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.$yJ=new E.$Xj("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.$zJ="debugUx",e.$AJ=new E.$Xj(e.$zJ,"default",{type:"string",description:r.localize(3,null)}),e.$BJ=new E.$Xj("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.$CJ=new E.$Xj("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.$DJ=new E.$Xj("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.$EJ=new E.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.$FJ=new E.$Xj("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.$GJ=new E.$Xj("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.$HJ=new E.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.$IJ=new E.$Xj("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.$JJ=new E.$Xj("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.$KJ=new E.$Xj("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.$LJ=new E.$Xj("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.$MJ=new E.$Xj("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.$NJ=new E.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.$OJ=new E.$Xj("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.$PJ=new E.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.$QJ=new E.$Xj("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.$RJ=new E.$Xj("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.$SJ=new E.$Xj("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.$TJ=new E.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(22,null)}),e.$UJ=new E.$Xj("breakpointHasModes",!1,{type:"boolean",description:r.localize(23,null)}),e.$VJ=new E.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(24,null)}),e.$WJ=new E.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(25,null)}),e.$XJ=new E.$Xj("loadedScriptsItemType",void 0,{type:"string",description:r.localize(26,null)}),e.$YJ=new E.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(27,null)}),e.$ZJ=new E.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(28,null)}),e.$1J=new E.$Xj("stepBackSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.$2J=new E.$Xj("restartFrameSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.$3J=new E.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(31,null)}),e.$4J=new E.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(32,null)}),e.$5J=new E.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(33,null)}),e.$6J=new E.$Xj("breakpointsExist",!1,{type:"boolean",description:r.localize(34,null)}),e.$7J=new E.$Xj("debuggersAvailable",!1,{type:"boolean",description:r.localize(35,null)}),e.$8J=new E.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(36,null)}),e.$9J=new E.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(37,null)}),e.$0J=new E.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.$$J=new E.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.$_J=new E.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.$aK=new E.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.$bK=new E.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(42,null)}),e.$cK=new E.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(43,null)}),e.$dK=new E.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(44,null)}),e.$eK=new E.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(45,null)}),e.$fK=new E.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(46,null)}),e.$gK=new E.$Xj("variableIsReadonly",!1,{type:"boolean",description:r.localize(47,null)}),e.$hK=new E.$Xj("variableValue",!1,{type:"string",description:r.localize(48,null)}),e.$iK=new E.$Xj("variableType",!1,{type:"string",description:r.localize(49,null)}),e.$jK=new E.$Xj("variableInterfaces",!1,{type:"array",description:r.localize(50,null)}),e.$kK=new E.$Xj("variableName",!1,{type:"string",description:r.localize(51,null)}),e.$lK=new E.$Xj("variableLanguage",!1,{type:"string",description:r.localize(52,null)}),e.$mK=new E.$Xj("variableExtensionId",!1,{type:"string",description:r.localize(53,null)}),e.$nK=new E.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(54,null)}),e.$oK=new E.$Xj("multiSessionRepl",!1,{type:"boolean",description:r.localize(55,null)}),e.$pK=new E.$Xj("multiSessionDebug",!1,{type:"boolean",description:r.localize(56,null)}),e.$qK=new E.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(57,null)}),e.$rK=new E.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(58,null)}),e.$sK=new E.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(59,null)}),e.$tK=new E.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(60,null)});const R=d=>r.localize(61,null,d);e.$uK=R,e.$vK="editor.contrib.debug",e.$wK="editor.contrib.breakpoint",e.$xK="debug",e.$yK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(62,null)};var A;(function(d){d[d.Inactive=0]="Inactive",d[d.Initializing=1]="Initializing",d[d.Stopped=2]="Stopped",d[d.Running=3]="Running"})(A||(e.State=A={}));function y(d){switch(d){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var o;(function(d){d[d.Valid=0]="Valid",d[d.Unreadable=1]="Unreadable",d[d.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$AK="vscode-debug-memory";function D(d){const p=d.presentationHint??d.source.presentationHint;return p==="deemphasize"||p==="subtle"}var v;(function(d){d[d.Variable=0]="Variable",d[d.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var h;(function(d){d[d.Initial=1]="Initial",d[d.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var w;(function(d){d.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$CK=(0,k.$Gi)("debugService");var a;(function(d){d[d.CONDITION=0]="CONDITION",d[d.HIT_COUNT=1]="HIT_COUNT",d[d.LOG_MESSAGE=2]="LOG_MESSAGE",d[d.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var f;(function(d){d[d.Command=0]="Command",d[d.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var m;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(d){d.deserialize=p=>p,d.serialize=p=>p})($||(e.IDebugVisualizationTreeItem=$={}));var b;(function(d){d.deserialize=p=>({id:p.id,name:p.name,iconPath:p.iconPath&&{light:n.URI.revive(p.iconPath.light),dark:n.URI.revive(p.iconPath.dark)},iconClass:p.iconClass,visualization:p.visualization}),d.serialize=p=>p})(b||(e.IDebugVisualization=b={}))}),define(ve[304],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=void 0,e.$rQ=(0,n.$Gi)("environmentVariableService")}),define(ve[146],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$NQ=void 0,e.$NQ="remoteterminal";var n;(function(E){E.OnPtyHostExitEvent="$onPtyHostExitEvent",E.OnPtyHostStartEvent="$onPtyHostStartEvent",E.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",E.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",E.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",E.OnProcessDataEvent="$onProcessDataEvent",E.OnProcessReadyEvent="$onProcessReadyEvent",E.OnProcessExitEvent="$onProcessExitEvent",E.OnProcessReplayEvent="$onProcessReplayEvent",E.OnProcessOrphanQuestion="$onProcessOrphanQuestion",E.OnExecuteCommand="$onExecuteCommand",E.OnDidRequestDetach="$onDidRequestDetach",E.OnDidChangeProperty="$onDidChangeProperty"})(n||(e.RemoteTerminalChannelEvent=n={}));var r;(function(E){E.RestartPtyHost="$restartPtyHost",E.CreateProcess="$createProcess",E.AttachToProcess="$attachToProcess",E.DetachFromProcess="$detachFromProcess",E.ListProcesses="$listProcesses",E.GetLatency="$getLatency",E.GetPerformanceMarks="$getPerformanceMarks",E.OrphanQuestionReply="$orphanQuestionReply",E.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",E.Start="$start",E.Input="$input",E.AcknowledgeDataEvent="$acknowledgeDataEvent",E.Shutdown="$shutdown",E.Resize="$resize",E.ClearBuffer="$clearBuffer",E.GetInitialCwd="$getInitialCwd",E.GetCwd="$getCwd",E.ProcessBinary="$processBinary",E.SendCommandResult="$sendCommandResult",E.InstallAutoReply="$installAutoReply",E.UninstallAllAutoReplies="$uninstallAllAutoReplies",E.GetDefaultSystemShell="$getDefaultSystemShell",E.GetProfiles="$getProfiles",E.GetEnvironment="$getEnvironment",E.GetWslPath="$getWslPath",E.GetTerminalLayoutInfo="$getTerminalLayoutInfo",E.SetTerminalLayoutInfo="$setTerminalLayoutInfo",E.SerializeTerminalState="$serializeTerminalState",E.ReviveTerminalProcesses="$reviveTerminalProcesses",E.GetRevivedPtyNewId="$getRevivedPtyNewId",E.SetUnicodeVersion="$setUnicodeVersion",E.ReduceConnectionGraceTime="$reduceConnectionGraceTime",E.UpdateIcon="$updateIcon",E.UpdateTitle="$updateTitle",E.UpdateProperty="$updateProperty",E.RefreshProperty="$refreshProperty",E.RequestDetachInstance="$requestDetachInstance",E.AcceptDetachInstanceReply="$acceptDetachInstanceReply",E.AcceptDetachedInstance="$acceptDetachedInstance",E.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(ve[305],Se([1,0,9,4,69,53,3,136,11]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=o,e.$WQ=v,e.$XQ=a,e.$YQ=f,e.$ZQ=m,e.$1Q=b,e.$2Q=d,e.$3Q=p,e.$4Q=t,n=qe(n);function o(l,i){if(i)if(R.$i)for(const g in i){let s=g;for(const u in l)if(g.toLowerCase()===u.toLowerCase()){s=u;break}const c=i[g];c!==void 0&&D(l,s,c)}else Object.keys(i).forEach(g=>{const s=i[g];s!==void 0&&D(l,g,s)})}function D(l,i,g){typeof g=="string"?l[i]=g:delete l[i]}function v(l,i,g,s){l.TERM_PROGRAM="vscode",i&&(l.TERM_PROGRAM_VERSION=i),a(l,s)&&(l.LANG=f(g)),l.COLORTERM="truecolor"}function h(l,i){if(i)for(const g of Object.keys(i)){const s=i[g];s!=null&&(l[g]=s)}}async function w(l,i){return await Promise.all(Object.entries(i).map(async([g,s])=>{if(typeof s=="string")try{i[g]=await l(s)}catch{i[g]=s}})),i}function a(l,i){if(i==="on")return!0;if(i==="auto"){const g=l.LANG;return!g||g.search(/\.UTF\-8$/)===-1&&g.search(/\.utf8$/)===-1&&g.search(/\.euc.+/)===-1}return!1}function f(l){const i=l?l.split("-"):[],g=i.length;if(g===0)return"en_US.UTF-8";if(g===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};i[0]in s&&i.push(s[i[0]])}else i[1]=i[1].toUpperCase();return i.join("_")+".UTF-8"}async function m(l,i,g,s,c,u){if(l.cwd){const P=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,C=await $(P,g);return(0,A.$SQ)(C||P)}let S;return!l.ignoreConfigurationCwd&&c&&(g&&(c=await $(c,g,u)),c&&(n.$lc(c)?S=c:s&&(S=n.$mc(s.fsPath,c)))),S||(S=s?s.fsPath:i||""),(0,A.$SQ)(S)}async function $(l,i,g){if(i)try{return await i(l)}catch(s){g?.error("Could not resolve terminal cwd",s);return}return l}function b(l,i,g){if(g)return s=>g.resolveWithEnvironment(i,l,s)}async function d(l,i,g,s,c,u){const S={};if(l.strictEnv)h(S,l.env);else{h(S,u);const P={...i};g&&(P&&await w(g,P),l.env&&await w(g,l.env)),R.$j&&(S.VSCODE_NODE_OPTIONS&&(S.NODE_OPTIONS=S.VSCODE_NODE_OPTIONS,delete S.VSCODE_NODE_OPTIONS),S.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(S.NODE_REPL_EXTERNAL_MODULE=S.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete S.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,E.$lm)(S,"VSCODE_IPC_HOOK_CLI"),o(S,P),o(S,l.env),v(S,s,R.$w,c)}return S}async function p(l,i,g,s,c,u,S=R.$i){let P;if((0,y.$gg)(l)?P=l:(P=l.fsPath,S&&u!==R.OperatingSystem.Windows?P=P.replace(/\\/g,"/"):!S&&u===R.OperatingSystem.Windows&&(P=P.replace(/\//g,"\\"))),!i)return P;const C=P.includes(" "),L=P.includes("(")||P.includes(")"),T=n.$qc(i,".exe"),I=T==="pwsh"||g==="pwsh"||T==="powershell"||g==="powershell";if(I&&(C||P.includes("'")))return`& '${P.replace(/'/g,"''")}'`;if(L&&I)return`& '${P}'`;if(u===R.OperatingSystem.Windows){if(s!==void 0)return s===k.WindowsShellType.GitBash?(0,A.$QQ)(P.replace(/\\/g,"/")):s===k.WindowsShellType.Wsl?c?.getWslPath(P,"win-to-unix")||P:C?`"${P}"`:P;const q=i.toLowerCase();return q.includes("wsl")||q.includes("bash.exe")&&!q.toLowerCase().includes("git")?c?.getWslPath(P,"win-to-unix")||P:C?`"${P}"`:P}return(0,A.$QQ)(P)}function t(l,i,g){const s=typeof l=="string"?r.URI.parse(l):l;let c=s?i.getWorkspaceFolder(s)??void 0:void 0;if(!c){const u=g.getLastActiveWorkspaceRoot();c=u?i.getWorkspaceFolder(u)??void 0:void 0}return c}}),define(ve[76],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(k){k.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var r;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class E{static fromExtHostTestItem(R,A,y=R.parent){if(R._isRoot)return new E([A]);const o=[R.id];for(let D=y;D&&D.id!==A;D=D.parent)o.push(D.id);return o.push(A),new E(o.reverse())}static isRoot(R){return!R.includes(n.Delimiter)}static root(R){const A=R.indexOf(n.Delimiter);return A===-1?R:R.slice(0,A)}static fromString(R){return new E(R.split(n.Delimiter))}static join(R,A){return new E([...R.path,A])}static joinToString(R,A){return R.toString()+n.Delimiter+A}static parentId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?R:R.slice(A+n.Delimiter.length)}static isChild(R,A){return A.startsWith(R)&&A[R.length]===n.Delimiter}static compare(R,A){return R===A?r.IsSame:E.isChild(R,A)?r.IsChild:E.isChild(A,R)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(R,A){if(R===0)return 0;let y=0;for(;y<R-1;){for(let o=1;o<R;o++){const D=A(o-1),v=A(o);if(D.path[y]!==v.path[y])return y}y++}return y}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new E(this.path,1)}get parentId(){return this.d>1?new E(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new E(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return r.Disconnected;return R.d>this.d?r.IsChild:R.d<this.d?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=n.Delimiter,this.c+=this.path[R]}return this.c}}e.$TI=E}),define(ve[103],Se([1,0,4,85,49,76]),function(se,e,n,r,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$2I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$1I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$ZI=e.$YI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$XI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$WI=e.$VI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$UI=e.TestResultState=void 0;var R;(function(te){te[te.Unset=0]="Unset",te[te.Queued=1]="Queued",te[te.Running=2]="Running",te[te.Passed=3]="Passed",te[te.Failed=4]="Failed",te[te.Skipped=5]="Skipped",te[te.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$UI={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var A;(function(te){te[te.Run=1]="Run",te[te.Debug=2]="Debug",te[te.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var y;(function(te){te[te.Run=2]="Run",te[te.Debug=4]="Debug",te[te.Coverage=8]="Coverage",te[te.HasNonDefaultProfile=16]="HasNonDefaultProfile",te[te.HasConfigurable=32]="HasConfigurable",te[te.SupportsContinuousRun=64]="SupportsContinuousRun"})(y||(e.TestRunProfileBitset=y={})),e.$VI=[y.Run,y.Debug,y.Coverage,y.HasNonDefaultProfile,y.HasConfigurable,y.SupportsContinuousRun];const o=te=>"runId"in te;e.$WI=o;var D;(function(te){te.serialize=_=>({range:_.range.toJSON(),uri:_.uri.toJSON()}),te.deserialize=(_,de)=>({range:E.$Mt.lift(de.range),uri:_.asCanonicalUri(n.URI.revive(de.uri))})})(D||(e.IRichLocation=D={}));var v;(function(te){te[te.Error=0]="Error",te[te.Output=1]="Output"})(v||(e.TestMessageType=v={}));var h;(function(te){te.serialize=_=>({message:_.message,type:v.Error,expected:_.expected,actual:_.actual,contextValue:_.contextValue,location:_.location&&D.serialize(_.location)}),te.deserialize=(_,de)=>({message:de.message,type:v.Error,expected:de.expected,actual:de.actual,contextValue:de.contextValue,location:de.location&&D.deserialize(_,de.location)})})(h||(e.ITestErrorMessage=h={}));const w=(te,_)=>`${_?"s":"e"}${te}`;e.$XI=w;var a;(function(te){te.serialize=_=>({message:_.message,type:v.Output,offset:_.offset,length:_.length,location:_.location&&D.serialize(_.location)}),te.deserialize=(_,de)=>({message:de.message,type:v.Output,offset:de.offset,length:de.length,location:de.location&&D.deserialize(_,de.location)})})(a||(e.ITestOutputMessage=a={}));var f;(function(te){te.serialize=_=>_.type===v.Error?h.serialize(_):a.serialize(_),te.deserialize=(_,de)=>de.type===v.Error?h.deserialize(_,de):a.deserialize(_,de)})(f||(e.ITestMessage=f={}));var m;(function(te){te.serializeWithoutMessages=_=>({state:_.state,duration:_.duration,messages:[]}),te.serialize=_=>({state:_.state,duration:_.duration,messages:_.messages.map(f.serialize)}),te.deserialize=(_,de)=>({state:de.state,duration:de.duration,messages:de.messages.map(J=>f.deserialize(_,J))})})(m||(e.ITestTaskState=m={}));const $="\0",b=(te,_)=>te+$+_;e.$YI=b;const d=te=>{const _=te.indexOf($);return{ctrlId:te.slice(0,_),tagId:te.slice(_+1)}};e.$ZI=d;var p;(function(te){te.serialize=_=>({extId:_.extId,label:_.label,tags:_.tags,busy:_.busy,children:void 0,uri:_.uri?.toJSON(),range:_.range?.toJSON()||null,description:_.description,error:_.error,sortText:_.sortText}),te.deserialize=(_,de)=>({extId:de.extId,label:de.label,tags:de.tags,busy:de.busy,children:void 0,uri:de.uri?_.asCanonicalUri(n.URI.revive(de.uri)):void 0,range:de.range?E.$Mt.lift(de.range):null,description:de.description,error:de.error,sortText:de.sortText})})(p||(e.ITestItem=p={}));var t;(function(te){te[te.NotExpandable=0]="NotExpandable",te[te.Expandable=1]="Expandable",te[te.BusyExpanding=2]="BusyExpanding",te[te.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var l;(function(te){te.serialize=_=>({expand:_.expand,item:p.serialize(_.item)}),te.deserialize=(_,de)=>({controllerId:k.$TI.root(de.item.extId),expand:de.expand,item:p.deserialize(_,de.item)})})(l||(e.InternalTestItem=l={}));var i;(function(te){te.serialize=_=>{let de;return _.item&&(de={},_.item.label!==void 0&&(de.label=_.item.label),_.item.tags!==void 0&&(de.tags=_.item.tags),_.item.busy!==void 0&&(de.busy=_.item.busy),_.item.uri!==void 0&&(de.uri=_.item.uri?.toJSON()),_.item.range!==void 0&&(de.range=_.item.range?.toJSON()),_.item.description!==void 0&&(de.description=_.item.description),_.item.error!==void 0&&(de.error=_.item.error),_.item.sortText!==void 0&&(de.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:de}},te.deserialize=_=>{let de;return _.item&&(de={},_.item.label!==void 0&&(de.label=_.item.label),_.item.tags!==void 0&&(de.tags=_.item.tags),_.item.busy!==void 0&&(de.busy=_.item.busy),_.item.range!==void 0&&(de.range=_.item.range?E.$Mt.lift(_.item.range):null),_.item.description!==void 0&&(de.description=_.item.description),_.item.error!==void 0&&(de.error=_.item.error),_.item.sortText!==void 0&&(de.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:de}}})(i||(e.ITestItemUpdate=i={}));const g=(te,_)=>{_.expand!==void 0&&(te.expand=_.expand),_.item!==void 0&&(te.item=te.item?Object.assign(te.item,_.item):_.item)};e.$1I=g;var s;(function(te){te.serializeWithoutMessages=_=>({...l.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(m.serializeWithoutMessages)}),te.serialize=_=>({...l.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(m.serialize)}),te.deserialize=(_,de)=>({...l.deserialize(_,de),ownComputedState:de.ownComputedState,computedState:de.computedState,tasks:de.tasks.map(J=>m.deserialize(_,J)),retired:!0})})(s||(e.TestResultItem=s={}));var c;(function(te){te.empty=()=>({covered:0,total:0}),te.sum=(_,de)=>{_.covered+=de.covered,_.total+=de.total}})(c||(e.ICoverageCount=c={}));var u;(function(te){te.serialize=_=>({id:_.id,statement:_.statement,branch:_.branch,declaration:_.declaration,testIds:_.testIds,uri:_.uri.toJSON()}),te.deserialize=(_,de)=>({id:de.id,statement:de.statement,branch:de.branch,declaration:de.declaration,testIds:de.testIds,uri:_.asCanonicalUri(n.URI.revive(de.uri))}),te.empty=(_,de)=>({id:_,uri:de,statement:c.empty()})})(u||(e.IFileCoverage=u={}));function S(te){return{...te,location:te.location?.toJSON()}}function P(te){return te.location=te.location?r.$Lt.isIPosition(te.location)?r.$Lt.lift(te.location):E.$Mt.lift(te.location):void 0,te}e.$2I=3;var C;(function(te){te[te.Declaration=0]="Declaration",te[te.Statement=1]="Statement",te[te.Branch=2]="Branch"})(C||(e.DetailType=C={}));var L;(function(te){te.serialize=_=>_.type===C.Declaration?I.serialize(_):q.serialize(_),te.deserialize=_=>_.type===C.Declaration?I.deserialize(_):q.deserialize(_)})(L||(e.CoverageDetails=L={}));var T;(function(te){te.serialize=S,te.deserialize=P})(T||(e.IBranchCoverage=T={}));var I;(function(te){te.serialize=S,te.deserialize=P})(I||(e.IDeclarationCoverage=I={}));var q;(function(te){te.serialize=_=>({...S(_),branches:_.branches?.map(T.serialize)}),te.deserialize=_=>({...P(_),branches:_.branches?.map(T.deserialize)})})(q||(e.IStatementCoverage=q={}));var Y;(function(te){te[te.Add=0]="Add",te[te.Update=1]="Update",te[te.DocumentSynced=2]="DocumentSynced",te[te.Remove=3]="Remove",te[te.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",te[te.Retire=5]="Retire",te[te.AddTag=6]="AddTag",te[te.RemoveTag=7]="RemoveTag"})(Y||(e.TestDiffOpType=Y={}));var Q;(function(te){te.deserialize=(_,de)=>de.op===Y.Add?{op:de.op,item:l.deserialize(_,de.item)}:de.op===Y.Update?{op:de.op,item:i.deserialize(de.item)}:de.op===Y.DocumentSynced?{op:de.op,uri:_.asCanonicalUri(n.URI.revive(de.uri)),docv:de.docv}:de,te.serialize=_=>_.op===Y.Add?{op:_.op,item:l.serialize(_.item)}:_.op===Y.Update?{op:_.op,item:i.serialize(_.item)}:_})(Q||(e.TestsDiffOp=Q={}));class re{constructor(_){this.k=_,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(_){const de=this.w();for(const J of _)switch(J.op){case Y.Add:this.l(l.deserialize(this.k,J.item),de);break;case Y.Update:this.p(i.deserialize(J.item),de);break;case Y.Remove:this.q(J.itemId,de);break;case Y.Retire:this.v(J.itemId);break;case Y.IncrementPendingExtHosts:this.updatePendingRoots(J.amount);break;case Y.AddTag:this.c.set(J.tag.id,J.tag);break;case Y.RemoveTag:this.c.delete(J.id);break}de.complete?.()}l(_,de){const J=k.$TI.parentId(_.item.extId)?.toString();let ae;if(!J)ae=this.x(_),this.g.add(ae),this.f.set(_.item.extId,ae);else if(this.f.has(J)){const z=this.f.get(J);z.children.add(_.item.extId),ae=this.x(_,z),this.f.set(_.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(_)}`);return}return de.add?.(ae),_.expand===t.BusyExpanding&&this.h++,ae}p(_,de){const J=this.f.get(_.extId);if(J)return _.expand!==void 0&&(J.expand===t.BusyExpanding&&this.h--,_.expand===t.BusyExpanding&&this.h++),(0,e.$1I)(J,_),de.update?.(J),J}q(_,de){const J=this.f.get(_);if(!J)return;const ae=k.$TI.parentId(J.item.extId)?.toString();ae?this.f.get(ae).children.delete(J.item.extId):this.g.delete(J);const z=[[_]];for(;z.length;)for(const B of z.pop()){const ie=this.f.get(B);ie&&(z.push(ie.children),this.f.delete(B),de.remove?.(ie,ie!==J),ie.expand===t.BusyExpanding&&this.h--)}}v(_){}updatePendingRoots(_){this.j+=_}w(){return{}}}e.$3I=re}),define(ve[147],Se([1,0,14,6,2,106,103,76]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var y;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const o=(b,d)=>b===d,v=Object.entries({range:(b,d)=>b===d?!0:!b||!d?!1:b.equalsRange(d),busy:o,label:o,description:o,error:o,sortText:o,tags:(b,d)=>!(b.length!==d.length||b.some(p=>!d.includes(p)))}),h=(b,d)=>{let p;for(const[t,l]of v)l(b[t],d[t])||(p?p[t]=d[t]:p={[t]:d[t]});return p};class w extends E.$Xc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new n.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new r.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(d){this.h=d;for(const p of this.tree.values())this.J(p)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case R.TestDiffOpType.DocumentSynced:{for(const p of this.m)if(p.op===R.TestDiffOpType.DocumentSynced&&p.uri===d.uri){p.docv=d.docv;return}break}case R.TestDiffOpType.Update:{const p=this.m[this.m.length-1];if(p){if(p.op===R.TestDiffOpType.Update&&p.item.extId===d.item.extId){(0,R.$1I)(p.item,d.item);return}if(p.op===R.TestDiffOpType.Add&&p.item.item.extId===d.item.extId){(0,R.$1I)(p.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,p){const t=this.tree.get(d);if(t){if((t.expandLevels===void 0||p>t.expandLevels)&&(t.expandLevels=p),t.expand===R.TestItemExpandState.Expandable){const l=this.M(t);return l.isOpen()?this.L(t,p-1):l.wait().then(()=>this.L(t,p-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,p-1)):this.L(t,p-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(d,p){switch(p.op){case y.RemoveChild:this.O(A.$TI.joinToString(d.fullId,p.id));break;case y.Upsert:this.z(p.item,d);break;case y.Bulk:for(const t of p.ops)this.w(d,t);break;case y.SetTags:this.C(p.new,p.old,d.fullId.toString());break;case y.UpdateCanResolveChildren:this.J(d);break;case y.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),item:p.update}});break;case y.DocumentSynced:this.y(d.actual.uri);break;default:(0,k.$hd)(p)}}y(d){d&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:d,docv:this.s.getDocumentVersion(d)})}z(d,p){const t=A.$TI.fromExtHostTestItem(d,this.root.id,p?.actual),l=this.s.getApiFor(d);l.parent&&l.parent!==p?.actual&&this.s.getChildren(l.parent).delete(d.id);let i=this.tree.get(t.toString());if(!i){i={fullId:t,actual:d,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},d.tags.forEach(this.D,this),this.tree.set(i.fullId.toString(),i),this.G(d,p),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(d)}}),this.I(d,i,p);return}if(i.actual===d){this.H(d,i,p);return}if(i.actual.uri?.toString()!==d.uri?.toString())return this.O(t.toString()),this.z(d,p);const g=this.s.getChildren(i.actual),s=i.actual,c=h(this.s.toITestItem(s),this.s.toITestItem(d));this.s.getApiFor(s).listener=void 0,i.actual=d,i.resolveBarrier=void 0,i.expand=R.TestItemExpandState.NotExpandable,c&&(c.hasOwnProperty("tags")&&(this.C(d.tags,s.tags,t.toString()),delete c.tags),this.w(i,{op:y.SetProp,update:c})),this.I(d,i,p);for(const[S,P]of g)this.s.getChildren(d).get(P.id)||this.O(A.$TI.joinToString(t,P.id));const u=i.expandLevels;u!==void 0&&queueMicrotask(()=>{i.expand===R.TestItemExpandState.Expandable&&(i.expandLevels=void 0,this.expand(t.toString(),u))}),this.y(i.actual.uri)}C(d,p,t){const l=new Set(p.map(i=>i.id));for(const i of d)l.delete(i.id)||this.D(i);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:d.map(i=>(0,R.$YI)(this.s.controllerId,i.id))}}}),l.forEach(this.F,this)}D(d){const p=this.j.get(d.id);p?p.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$YI)(this.s.controllerId,d.id)}}))}F(d){const p=this.j.get(d);p&&!--p.refCount&&(this.j.delete(d),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$YI)(this.s.controllerId,d)}))}G(d,p){this.s.getApiFor(d).parent=p&&p.actual!==this.root?p.actual:void 0}H(d,p,t){this.G(d,t);const l=this.s.getApiFor(d);l.parent=t?.actual,l.listener=i=>this.w(p,i),this.J(p)}I(d,p,t){this.H(d,p,t);for(const[l,i]of this.s.getChildren(d))this.z(i,p)}J(d){let p;this.h?d.resolveBarrier?p=d.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:p=d.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:p=R.TestItemExpandState.NotExpandable,p!==d.expand&&(d.expand=p,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:p}}),p===R.TestItemExpandState.Expandable&&d.expandLevels!==void 0&&this.M(d))}L(d,p){if(p<0)return;const t=[];for(const[l,i]of this.s.getChildren(d.actual)){const g=this.expand(A.$TI.joinToString(d.fullId,i.id),p);(0,n.$sh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const i=new n.$Fh;return i.open(),i}d.expand=R.TestItemExpandState.BusyExpanding,this.N(d);const p=d.resolveBarrier=new n.$Fh,t=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let l;try{l=this.h(d.actual===this.root?void 0:d.actual)}catch(i){t(i)}return(0,n.$sh)(l)?l.catch(t).then(()=>{p.open(),this.J(d)}):(p.open(),this.J(d)),d.resolveBarrier}N(d){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:d.expand}})}O(d){const p=this.tree.get(d);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:d});const t=[p];for(;t.length;){const l=t.pop();if(l){this.s.getApiFor(l.actual).listener=void 0;for(const i of l.actual.tags)this.F(i.id);this.tree.delete(l.fullId.toString());for(const[i,g]of this.s.getChildren(l.actual))t.push(this.tree.get(A.$TI.joinToString(l.fullId,g.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$QP=w;class a extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$RP=a;class f extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=f;class m extends Error{constructor(d,p,t){super(`TestItem with ID "${d}" is from controller "${p}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=m;const $=(b,d,p)=>{let t=new Map;return{get size(){return t.size},forEach(l,i){for(const g of t.values())l.call(i,g,this)},[Symbol.iterator](){return t.entries()},replace(l){const i=new Map,g=new Set(t.keys()),s={op:y.Bulk,ops:[]};for(const c of l){if(!(c instanceof p))throw new f(c.id);const u=d(c).controllerId;if(u!==b.controllerId)throw new m(c.id,u,b.controllerId);if(i.has(c.id))throw new a(c.id);i.set(c.id,c),g.delete(c.id),s.ops.push({op:y.Upsert,item:c})}for(const c of g.keys())s.ops.push({op:y.RemoveChild,id:c});b.listener?.(s),t=i},add(l){if(!(l instanceof p))throw new f(l.id);t.set(l.id,l),b.listener?.({op:y.Upsert,item:l})},delete(l){t.delete(l)&&b.listener?.({op:y.RemoveChild,id:l})},get(l){return t.get(l)},toJSON(){return Array.from(t.values())}}};e.$UP=$}),define(ve[148],Se([1,0,147]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const r=new WeakMap,E=(R,A)=>{const y={controllerId:A};return r.set(R,y),y};e.$VP=E;const k=R=>{const A=r.get(R);if(!A)throw new n.$SP(R?.id||"<unknown>");return A};e.$WP=k}),define(ve[306],Se([1,0,46,27,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=void 0,e.$bF=".vscode",e.$cF="settings",e.$dF=`${e.$bF}/${e.$cF}.json`,e.$eF="vscode://schemas/settings/default",e.$fF="vscode://schemas/settings/user",e.$gF="vscode://schemas/settings/profile",e.$hF="vscode://schemas/settings/machine",e.$iF="vscode://schemas/settings/workspace",e.$jF="vscode://schemas/settings/folder",e.$kF="vscode://schemas/launch",e.$lF="vscode://schemas/tasks",e.$mF=[n.ConfigurationScope.APPLICATION],e.$nF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$oF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$pF=[n.ConfigurationScope.APPLICATION,...e.$oF],e.$qF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$rF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$sF=[n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$tF="tasks",e.$uF="launch",e.$vF=Object.create(null),e.$vF[e.$tF]=`${e.$bF}/${e.$tF}.json`,e.$vF[e.$uF]=`${e.$bF}/${e.$uF}.json`,e.$wF=Object.create(null),e.$wF[e.$tF]=`${e.$tF}.json`,e.$xF=(0,E.$Hi)(r.$aj),e.$yF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$zF="workbench.settings.applyToAllProfiles"}),define(ve[149],Se([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,n.$Gi)("configurationResolverService");var r;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(r||(e.VariableKind=r={}));class E extends Error{constructor(R,A){super(A),this.variable=R}}e.$PQ=E}),define(ve[307],Se([1,0,9,33,11,21,3,194,237,149,17]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,n=qe(n),r=qe(r),E=qe(E),k=qe(k);class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,a,f,m){this.h=new Map,this.a=w,this.b=a,this.g=f,m&&(this.c=m.then($=>this.i($)))}i(w){if(R.$i){const a=Object.create(null);return Object.keys(w).forEach(f=>{a[f.toLowerCase()]=w[f]}),a}return w}resolveWithEnvironment(w,a,f){return this.l({env:this.i(w),userHome:void 0},a?a.uri:void 0,f)}async resolveAsync(w,a){const f={env:await this.c,userHome:await this.g};return this.l(f,w?w.uri:void 0,a)}async j(w,a,f,m){const $=k.$eo(a);R.$i&&$.windows?Object.keys($.windows).forEach(d=>$[d]=$.windows[d]):R.$j&&$.osx?Object.keys($.osx).forEach(d=>$[d]=$.osx[d]):R.$k&&$.linux&&Object.keys($.linux).forEach(d=>$[d]=$.linux[d]),delete $.windows,delete $.osx,delete $.linux;const b={env:await this.c,userHome:await this.g};return this.l(b,w?w.uri:void 0,$,f,m)}async resolveAnyAsync(w,a,f){return this.j(w,a,f)}async resolveAnyMap(w,a,f){const m=new Map;return{newConfig:await this.j(w,a,f,m),resolvedVariables:m}}resolveWithInteractionReplace(w,a,f,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,a,f,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,a){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,a)}async l(w,a,f,m,$){if(E.$gg(f))return this.m(w,a,f,m,$);if(Array.isArray(f))return Promise.all(f.map(b=>this.l(w,a,b,m,$)));if(E.$ig(f)){const b=Object.create(null),d=await Promise.all(Object.keys(f).map(async p=>[await this.m(w,a,p,m,$),await this.l(w,a,f[p],m,$)]));for(const[p,t]of d)b[p]=t;return b}return f}m(w,a,f,m,$){return(0,D.$zf)(f,v.VARIABLE_REGEXP,async(b,d)=>{if(d.includes(v.VARIABLE_LHS))return b;let p=await this.o(w,b,d,a,m);return $?.set(d,p),p!==b&&E.$gg(p)&&p.match(v.VARIABLE_REGEXP)&&(p=await this.m(w,a,p,m,$)),p})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,a,f,m,$){let b;const d=f.split(":");d.length>1&&(f=d[0],b=d[1]);const p=i=>{const g=this.a.getFilePath();if(g)return(0,A.$Xw)(g);throw new o.$PQ(i,(0,y.localize)(0,null,a))},t=i=>{const g=p(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,A.$Xw)(s)}throw new o.$PQ(i,(0,y.localize)(1,null,a,n.$qc(g)))},l=i=>{if(b){const g=this.a.getFolderUri(b);if(g)return g;throw new o.$PQ(i,(0,y.localize)(2,null,a,b))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new o.$PQ(i,(0,y.localize)(3,null,a)):new o.$PQ(i,(0,y.localize)(4,null,a))};switch(f){case"env":if(b){if(w.env){const i=w.env[R.$i?b.toLowerCase():b];if(E.$gg(i))return i}return""}throw new o.$PQ(o.VariableKind.Env,(0,y.localize)(5,null,a));case"config":if(b){const i=this.a.getConfigurationValue(m,b);if(E.$pg(i))throw new o.$PQ(o.VariableKind.Config,(0,y.localize)(6,null,a,b));if(E.$ig(i))throw new o.$PQ(o.VariableKind.Config,(0,y.localize)(7,null,a,b));return i}throw new o.$PQ(o.VariableKind.Config,(0,y.localize)(8,null,a));case"command":return this.p(o.VariableKind.Command,a,b,$,"command");case"input":return this.p(o.VariableKind.Input,a,b,$,"input");case"extensionInstallFolder":if(b){const i=await this.a.getExtension(b);if(!i)throw new o.$PQ(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,a,b));return this.n(i.extensionLocation)}throw new o.$PQ(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,a));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.$Xw)(this.n(l(o.VariableKind.WorkspaceFolder)));case"cwd":return m||b?(0,A.$Xw)(this.n(l(o.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$Xw)(n.$qc(this.n(l(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new o.$PQ(o.VariableKind.UserHome,(0,y.localize)(11,null,a))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new o.$PQ(o.VariableKind.LineNumber,(0,y.localize)(12,null,a))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new o.$PQ(o.VariableKind.SelectedText,(0,y.localize)(13,null,a))}case"file":return p(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return n.$qc(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||b?n.$oc(this.n(l(o.VariableKind.RelativeFile)),p(o.VariableKind.RelativeFile)):p(o.VariableKind.RelativeFile);case"relativeFileDirname":{const i=n.$pc(p(o.VariableKind.RelativeFileDirname));if(m||b){const g=n.$oc(this.n(l(o.VariableKind.RelativeFileDirname)),i);return g.length===0?".":g}return i}case"fileDirname":return n.$pc(p(o.VariableKind.FileDirname));case"fileExtname":return n.$rc(p(o.VariableKind.FileExtname));case"fileBasename":return n.$qc(p(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=n.$qc(p(o.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-n.$rc(i).length)}case"fileDirnameBasename":return n.$qc(n.$pc(p(o.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||a}case"execInstallFolder":{const i=this.a.getAppRoot();return i||a}case"pathSeparator":case"/":return n.sep;default:try{const i=b?`${f}:${b}`:f;return this.p(o.VariableKind.Unknown,a,i,$,void 0)}catch{return a}}}}p(w,a,f,m,$){if(f&&m){const b=$===void 0?m[f]:m[$+":"+f];if(typeof b=="string")return b;throw new o.$PQ(w,(0,y.localize)(14,null,a))}return a}}e.$5Q=v}),define(ve[308],Se([1,0,5,102]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=o,e.$lE=h,e.$mE=w,e.$jE=(0,n.$Gi)("editorGroupsService");var E;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(E||(e.GroupDirection=E={}));var k;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var R;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var A;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var y;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function o(a){const f=a;return(0,r.$8F)(f?.editor)&&(0,r.$8F)(f?.replacement)}var D;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D||(e.GroupsOrder=D={}));var v;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function h(a){const f=a;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}function w(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?E.DOWN:E.RIGHT}}),define(ve[150],Se([1,0,5,308]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=E,e.$nE=(0,n.$Gi)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function E(k){const R=k;return typeof k=="number"||(0,r.$lE)(R)}}),define(ve[309],Se([1,0,306,90,98,97,149,102,150,13,257,304,53,146]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Q=e.$7Q=void 0,e.$7Q="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen(w.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(m,$,b,d,p,t,l,i,g,s){this.a=m,this.b=$,this.c=b,this.d=d,this.e=p,this.f=t,this.g=l,this.h=i,this.i=g,this.j=s}restartPtyHost(){return this.b.call(w.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(m,$,b,d,p,t,l,i){await this.c.whenRemoteConfigurationLoaded();const g=Object.create(null),s=b?this.d.getWorkspaceFolder(b)??void 0:void 0;let c;try{c=(await this.e.resolveAnyMap(s,{shellLaunchConfig:m,configuration:$})).resolvedVariables}catch(Y){this.h.error(Y)}if(c)for(const[Y,Q]of c.entries())(/^config:/.test(Y)||Y==="selectedText"||Y==="lineNumber")&&(g[Y]=Q);const u=[];for(const[Y,Q]of this.f.collections.entries())u.push([Y,(0,k.$Ds)(Q.map),(0,k.$Es)(Q.descriptionMap)]);const S=await this.g.resolveAuthority(this.a),P=S.options&&S.options.extensionHostEnv,C=this.d.getWorkspace(),L=C.folders,T=b?this.d.getWorkspaceFolder(b):null,I=A.$eG.getOriginalUri(this.i.activeEditor,{supportSideBySide:A.SideBySideEditor.PRIMARY,filterByScheme:[o.Schemas.file,o.Schemas.vscodeUserData,o.Schemas.vscodeRemote]}),q={configuration:$,resolvedVariables:g,envVariableCollections:u,shellLaunchConfig:m,workspaceId:C.id,workspaceName:this.j.getWorkspaceLabel(C),workspaceFolders:L,activeWorkspaceFolder:T,activeFileResource:I,shouldPersistTerminal:p,options:d,cols:t,rows:l,unicodeVersion:i,resolverEnv:P};return await this.b.call(w.RemoteTerminalChannelRequest.CreateProcess,q)}requestDetachInstance(m,$){return this.b.call(w.RemoteTerminalChannelRequest.RequestDetachInstance,[m,$])}acceptDetachInstanceReply(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[m,$])}attachToProcess(m){return this.b.call(w.RemoteTerminalChannelRequest.AttachToProcess,[m])}detachFromProcess(m,$){return this.b.call(w.RemoteTerminalChannelRequest.DetachFromProcess,[m,$])}listProcesses(){return this.b.call(w.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call(w.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call(w.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call(w.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(m,$){return this.b.call(w.RemoteTerminalChannelRequest.ProcessBinary,[m,$])}start(m){return this.b.call(w.RemoteTerminalChannelRequest.Start,[m])}input(m,$){return this.b.call(w.RemoteTerminalChannelRequest.Input,[m,$])}acknowledgeDataEvent(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[m,$])}setUnicodeVersion(m,$){return this.b.call(w.RemoteTerminalChannelRequest.SetUnicodeVersion,[m,$])}shutdown(m,$){return this.b.call(w.RemoteTerminalChannelRequest.Shutdown,[m,$])}resize(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.Resize,[m,$,b])}clearBuffer(m){return this.b.call(w.RemoteTerminalChannelRequest.ClearBuffer,[m])}getInitialCwd(m){return this.b.call(w.RemoteTerminalChannelRequest.GetInitialCwd,[m])}getCwd(m){return this.b.call(w.RemoteTerminalChannelRequest.GetCwd,[m])}orphanQuestionReply(m){return this.b.call(w.RemoteTerminalChannelRequest.OrphanQuestionReply,[m])}sendCommandResult(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.SendCommandResult,[m,$,b])}freePortKillProcess(m){return this.b.call(w.RemoteTerminalChannelRequest.FreePortKillProcess,[m])}installAutoReply(m,$){return this.b.call(w.RemoteTerminalChannelRequest.InstallAutoReply,[m,$])}uninstallAllAutoReplies(){return this.b.call(w.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(m){return this.b.call(w.RemoteTerminalChannelRequest.GetDefaultSystemShell,[m])}getProfiles(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,m,$,b])}acceptPtyHostResolvedVariables(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[m,$])}getEnvironment(){return this.b.call(w.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(m,$){return this.b.call(w.RemoteTerminalChannelRequest.GetWslPath,[m,$])}setTerminalLayoutInfo(m){const b={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call(w.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,b)}updateTitle(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.UpdateTitle,[m,$,b])}updateIcon(m,$,b,d){return this.b.call(w.RemoteTerminalChannelRequest.UpdateIcon,[m,$,b,d])}refreshProperty(m,$){return this.b.call(w.RemoteTerminalChannelRequest.RefreshProperty,[m,$])}updateProperty(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.UpdateProperty,[m,$,b])}getTerminalLayoutInfo(){const $={workspaceId:this.d.getWorkspace().id};return this.b.call(w.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,$)}reviveTerminalProcesses(m,$,b){return this.b.call(w.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[m,$,b])}getRevivedPtyNewId(m){return this.b.call(w.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[m])}serializeTerminalState(m){return this.b.call(w.RemoteTerminalChannelRequest.SerializeTerminalState,[m])}};e.$8Q=a,e.$8Q=a=Be([je(2,n.$xF),je(3,E.$Pi),je(4,R.$OQ),je(5,v.$rQ),je(6,r.$Rl),je(7,h.$qs),je(8,y.$nE),je(9,D.$pw)],a)}),define(ve[310],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.ExtHostConnectionType=void 0,e.$fn=A,e.$gn=y;var n;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(n||(e.ExtHostConnectionType=n={}));class r{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(v){this.pipeName=v,this.type=n.IPC}serialize(v){v[r.ENV_KEY]=this.pipeName}}e.$cn=r;class E{constructor(){this.type=n.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(v){v[E.ENV_KEY]="1"}}e.$dn=E;class k{constructor(){this.type=n.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(v){v[k.ENV_KEY]="1"}}e.$en=k;function R(D){delete D[r.ENV_KEY],delete D[E.ENV_KEY],delete D[k.ENV_KEY]}function A(D,v){R(v),D.serialize(v)}function y(D){if(D[r.ENV_KEY])return o(D,new r(D[r.ENV_KEY]));if(D[E.ENV_KEY])return o(D,new E);if(D[k.ENV_KEY])return o(D,new k);throw new Error("No connection information defined in environment!")}function o(D,v){return R(D),v}}),define(ve[311],Se([1,0,15]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=R,e.$Cn=A;var r;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(r||(e.UIKind=r={}));var E;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(E||(e.ExtensionHostExitCode=E={}));var k;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function R(o){const D=n.$Pe.alloc(1);switch(o){case k.Initialized:D.writeUInt8(1,0);break;case k.Ready:D.writeUInt8(2,0);break;case k.Terminate:D.writeUInt8(3,0);break}return D}function A(o,D){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return D===k.Initialized;case 2:return D===k.Ready;case 3:return D===k.Terminate;default:return!1}}var y;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(ve[312],Se([1,0,5,6,24,12,297,311,91,41,21,4,2,232]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=m;let a=class extends h.$Xc{constructor(b,d){super(),this.s=b,this.t=d,this.a=this.B(new r.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new r.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=E.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:o.$Ap,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel(p=>{(0,k.$ck)(p)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===E.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=E.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=E.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=E.TelemetryLevel.USAGE:!1}}instantiateLogger(b,d,p){const t=this.getTelemetryDetails(),l=new f(d,p,b,this.n,this.j,this.getBuiltInCommonProperties(b),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),i=this.r.get(b.identifier.value)??[];return this.r.set(b.identifier.value,[...i,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(b,d,p){this.f=b,this.g=d,this.c=p??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(b){const d=Object.create(null);switch(d["common.extname"]=`${b.publisher}.${b.name}`,d["common.extversion"]=b.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:d["common.uikind"]="web";break;case A.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,y.$in)((0,o.$Gp)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(b){this.h=this.getTelemetryConfiguration(),this.f=b;const d=this.getTelemetryDetails();this.r.forEach((p,t)=>{const l=p.filter(i=>!i.isDisposed);l.length===0?this.r.delete(t):this.r.set(t,l)}),this.r.forEach(p=>{for(const t of p)t.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(b,d){const t=this.r.get(b.value)?.filter(i=>!i.isDisposed);if(!t)return this.r.delete(b.value),!1;let l=!1;for(const i of t)i.ignoreUnhandledExtHostErrors||(i.logError(d),l=!0);return l}};e.$fQ=a,e.$fQ=a=Be([je(0,R.$eQ),je(1,k.$bk)],a);class f{static validateSender(b){if(typeof b!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof b.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof b.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof b.flush<"u"&&typeof b.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(b,d,p,t,l,i,g){this.g=p,this.h=t,this.i=l,this.j=i,this.a=new r.$ne,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=b,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(b,d){this.e&&(this.d={isUsageEnabled:b,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(b){let d="properties"in b?b.properties??{}:b;return d=(0,o.$Jp)(d,[]),this.c&&(d=(0,D.$ho)(d,this.c)),this.b||(d=(0,D.$ho)(d,this.j)),"properties"in b?b.properties=d:b=d,b}k(b,d){this.f&&(this.g.publisher==="vscode"?b=this.g.name+"/"+b:b=this.g.identifier.value+"/"+b,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(b,d),this.h.trace(b,d))}logUsage(b,d){this.d.isUsageEnabled&&this.k(b,d)}logError(b,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof b=="string")this.k(b,d);else{const p={name:b.name,message:b.message,stack:b.stack,cause:b.cause},t=(0,o.$Jp)(p,[]),l=new Error(t.message,{cause:t.cause});l.stack=t.stack,l.name=t.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(l,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const b=this,d={logUsage:b.logUsage.bind(b),get isUsageEnabled(){return b.d.isUsageEnabled},get isErrorsEnabled(){return b.d.isErrorsEnabled},logError:b.logError.bind(b),dispose:b.dispose.bind(b),onDidChangeEnableStates:b.a.event.bind(b)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let b=this.f;this.f=void 0,Promise.resolve(b.flush()).then(b=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=f;function m($){const b=Date.now()-new Date($).getTime();return isNaN(b)?!1:b<1e3*60*60*24}e.$iQ=(0,n.$Gi)("IExtHostTelemetry")}),define(ve[313],Se([1,0,6,4,39,130,22,5]),function(se,e,n,r,E,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.ActivationKind=e.$9G=e.$8G=e.$5G=e.ExtensionHostStartup=e.$4G=e.$3G=e.$2G=e.$1G=void 0,e.$6G=h,e.$7G=w,e.$0G=$,e.$$G=b,e.$1G=Object.freeze({identifier:new R.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2G="extensions.webWorker",e.$3G=(0,A.$Gi)("extensionService");class y{constructor(t){this.dependency=t}}e.$4G=y;var o;(function(p){p[p.EagerAutoStart=1]="EagerAutoStart",p[p.EagerManualStart=2]="EagerManualStart",p[p.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class D{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,l,i){this.c=t,this.d=l.slice(0),this.e=i.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:k.$MG.createActivationEventsMap(this.d)}}set(t,l,i){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],s=[],c=[],u=[],S=v(this.d),P=v(l),C=(Y,Q)=>Y.extensionLocation.toString()===Q.extensionLocation.toString()||Y.isBuiltin===Q.isBuiltin||Y.isUserBuiltin===Q.isUserBuiltin||Y.isUnderDevelopment===Q.isUnderDevelopment;for(const Y of this.d){const Q=P.get(Y.identifier);if(!Q){g.push(Y.identifier),S.delete(Y.identifier);continue}if(!C(Y,Q)){g.push(Y.identifier),S.delete(Y.identifier);continue}}for(const Y of l){const Q=S.get(Y.identifier);if(!Q){s.push(Y);continue}if(!C(Q,Y)){g.push(Q.identifier),S.delete(Q.identifier);continue}}const L=new R.$sn(this.e),T=new R.$sn(i);for(const Y of this.e)T.has(Y)||c.push(Y);for(const Y of i)L.has(Y)||u.push(Y);const I=k.$MG.createActivationEventsMap(s),q={versionId:t,toRemove:g,toAdd:s,addActivationEvents:I,myToRemove:c,myToAdd:u};return this.delta(q),q}delta(t){if(this.c>=t.versionId)return null;const{toRemove:l,toAdd:i,myToRemove:g,myToAdd:s}=t,c=new R.$sn(l),u=new R.$sn(g);for(let S=0;S<this.d.length;S++)c.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)u.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of i)this.d.push(S);for(const S of s)this.e.push(S);return this.f=null,t}containsExtension(t){for(const l of this.e)if(R.$rn.equals(l,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const l of this.d){if(!this.containsExtension(l.identifier))continue;const i=k.$MG.readActivationEvents(l);for(const g of i)t.add(g)}return t}}e.$5G=D;function v(p){const t=new R.$tn;for(const l of p)t.set(l.identifier,l);return t}function h(p,t){return p.enabledApiProposals?p.enabledApiProposals.includes(t):!1}function w(p,t){if(!h(p,t))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}class a{constructor(t,l,i,g){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=i,this.activationReason=g}}e.$8G=a;class f{constructor(t,l){this.description=t,this.value=l}}e.$9G=f;var m;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(p){return{type:p.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,E.$Pp)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation,targetPlatform:p.targetPlatform,validations:[],isValid:!0}}function b(p,t){const l=(0,E.$Np)(p.manifest.publisher,p.manifest.name);return{id:l,identifier:new R.$rn(l),isBuiltin:p.type===R.ExtensionType.System,isUserBuiltin:p.type===R.ExtensionType.User&&p.isBuiltin,isUnderDevelopment:!!t,extensionLocation:p.location,uuid:p.identifier.uuid,targetPlatform:p.targetPlatform,publisherDisplayName:p.publisherDisplayName,...p.manifest}}class d{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,l){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_G=d});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[314],Se([1,0,238,10,58,30,127,38,22,29,130,119]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,n=qe(n),E=mt(E);const h=A.$ro.as(R.$so.JSONContribution);class w{constructor(t,l,i){this.a=t,this.b=l,this.c=i}d(t,l){this.a({type:t,message:l,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(E.default.Error,t)}warn(t){this.d(E.default.Warning,t)}info(t){this.d(E.default.Info,t)}}e.$UG=w;class a{static a(t){const l=new y.$sn;for(let i=0,g=t.length;i<g;i++)l.add(t[i].description.identifier);return l}static compute(t,l){if(!t||!t.length)return new a(l,[]);if(!l||!l.length)return new a([],t);const i=this.a(t),g=this.a(l),s=l.filter(u=>!i.has(u.description.identifier)),c=t.filter(u=>!g.has(u.description.identifier));return new a(s,c)}constructor(t,l){this.added=t,this.removed=l}}e.$VG=a;class f{constructor(t,l){this.name=t,this.defaultExtensionKind=l,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=a.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,r.$3)(t)}}}e.$WG=f;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},$="vscode://schemas/vscode-extensions";e.$XG={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$qn},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals).map(p=>p),markdownEnumDescriptions:Object.values(v.allApiProposals).map(p=>p.proposal)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:n.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:n.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:n.localize(44,null)},{label:"*",description:n.localize(45,null),body:"*"}]}},badges:{type:"array",description:n.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(47,null)},href:{type:"string",description:n.localize(48,null)},description:{type:"string",description:n.localize(49,null)}}}},markdown:{type:"string",description:n.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$9o}},extensionPack:{description:n.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$9o}},extensionKind:{description:n.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(55,null)},{body:["workspace"],description:n.localize(56,null)},{body:["ui","workspace"],description:n.localize(57,null)},{body:["workspace","ui"],description:n.localize(58,null)},{body:[],description:n.localize(59,null)}]},capabilities:{description:n.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)]},description:{type:"string",markdownDescription:n.localize(66,null)}}},untrustedWorkspaces:{description:n.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(69,null),n.localize(70,null),n.localize(71,null)]},restrictedConfigurations:{description:n.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(73,null)}}}}},sponsor:{description:n.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(76,null),type:"string"},"vscode:uninstall":{description:n.localize(77,null),type:"string"}}},icon:{type:"string",description:n.localize(78,null)},l10n:{type:"string",description:n.localize(79,null)},pricing:{type:"string",markdownDescription:n.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class b{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const l=new f(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,l),t.activationEventsGenerator&&D.$MG.register(t.extensionPoint,t.activationEventsGenerator),e.$XG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,h.registerSchema($,e.$XG),l}getExtensionPoints(){return Array.from(this.a.values())}}e.$YG=b;const d={ExtensionsRegistry:"ExtensionsRegistry"};A.$ro.add(d.ExtensionsRegistry,new b),e.$ZG=A.$ro.as(d.ExtensionsRegistry),h.registerSchema($,e.$XG),h.registerSchema(o.$uk,{properties:{extensionEnabledApiProposals:{description:n.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals).map(p=>p.proposal)}}]}}}})}),define(ve[315],Se([1,0,6,40,2,17,235,22,5,12,313,314]),function(se,e,n,r,E,k,R,A,y,o,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.ChatMessageRole=void 0;var h;(function(f){f[f.System=0]="System",f[f.User=1]="User",f[f.Assistant=2]="Assistant"})(h||(e.ChatMessageRole=h={})),e.$aH=(0,y.$Gi)("ILanguageModelsService");const w={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.$bH=v.$ZG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[w,{type:"array",items:w}]},activationEventsGenerator:(f,m)=>{for(const $ of f)m.push(`onLanguageModelChat:${$.vendor}`)}});let a=class{constructor(m,$){this.e=m,this.f=$,this.a=new E.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new n.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$bH.setHandler(b=>{this.c.clear();for(const p of b){if(!(0,D.$6G)(p.description,"chatProvider")){p.collector.error((0,R.localize)(2,null));continue}for(const t of r.Iterable.wrap(p.value)){if(this.c.has(t.vendor)){p.collector.error((0,R.localize)(3,null,t.vendor));continue}if((0,k.$ef)(t.vendor)){p.collector.error((0,R.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){p.collector.error((0,R.localize)(5,null));continue}this.c.add(t.vendor)}}const d=[];for(const[p,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(p),d.push(p));d.length>0&&this.d.fire({removed:d})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const b=Array.from(this.c).map(d=>this.e.activateByEvent(`onLanguageModelChat:${d}`));await Promise.all(b)}const $=[];for(const[b,d]of this.b)(m.vendor===void 0||d.metadata.vendor===m.vendor)&&(m.family===void 0||d.metadata.family===m.family)&&(m.version===void 0||d.metadata.version===m.version)&&(m.identifier===void 0||d.metadata.id===m.identifier)&&(!d.metadata.targetExtensions||d.metadata.targetExtensions.some(p=>A.$rn.equals(p,m.extension)))&&$.push(b);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,E.$Vc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,b,d,p){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(b,$,d,p)}computeTokenLength(m,$,b){const d=this.b.get(m);if(!d)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return d.provideTokenCount($,b)}};e.$cH=a,e.$cH=a=Be([je(0,D.$3G),je(1,o.$ak)],a)}),define(ve[316],Se([1,0,22,239,63]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=k,E=qe(E);function k(R,A,y,o,D){const v=new n.$tn;return R.forEach(h=>{const w=v.get(h.identifier);w&&D.warn((0,r.localize)(0,null,w.extensionLocation.fsPath,h.extensionLocation.fsPath)),v.set(h.identifier,h)}),A.forEach(h=>{const w=v.get(h.identifier);if(w)if(w.isBuiltin){if(E.gte(w.version,h.version)){D.warn(`Skipping extension ${h.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}h.isBuiltin=!0}else D.warn((0,r.localize)(1,null,w.extensionLocation.fsPath,h.extensionLocation.fsPath));else if(h.isBuiltin){D.warn(`Skipping obsolete builtin extension ${h.extensionLocation.path}`);return}v.set(h.identifier,h)}),y.forEach(h=>{const w=v.get(h.identifier);w&&D.warn((0,r.localize)(2,null,w.extensionLocation.fsPath,h.extensionLocation.fsPath)),v.set(h.identifier,h)}),o.forEach(h=>{D.info((0,r.localize)(3,null,h.extensionLocation.fsPath));const w=v.get(h.identifier);w&&w.isBuiltin&&(h.isBuiltin=!0),v.set(h.identifier,h)}),Array.from(v.values())}}),define(ve[317],Se([1,0,9,3,33,4,44,59,42,64,22,316,13]),function(se,e,n,r,E,k,R,A,y,o,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=void 0,r=qe(r),R=qe(R);class w{constructor(m,$,b,d,p,t,l){this.c=m,this.d=b,this.f=d,this.g=p,this.h=t,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const i=$.args["install-builtin-extension"];if(i){p.trace("Installing builtin extensions passed via args...");const s={isMachineScoped:!!$.args["do-not-sync"],installPreReleaseVersion:!!$.args["pre-release"]};R.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(i),s,!!$.args.force).then(()=>{R.mark("code/server/didInstallBuiltinExtensions"),p.trace("Finished installing builtin extensions")},c=>{p.error(c)})}const g=$.args["install-extension"];g&&(p.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(g),[],{isMachineScoped:!!$.args["do-not-sync"],installPreReleaseVersion:!!$.args["pre-release"],isApplicationScoped:!0},!!$.args.force)).then(()=>{p.trace("Finished installing extensions")},s=>{p.error(s)}))}j(m){return m.map($=>/\.vsix$/i.test($)?k.URI.file((0,n.$lc)($)?$:(0,n.$mc)((0,E.cwd)(),$)):$)}whenExtensionsReady(){return this.b}async scanExtensions(m,$,b,d,p){R.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const t=d?d.filter(i=>i.scheme===h.Schemas.file).map(i=>i.fsPath):void 0;$=$??this.d.defaultProfile.extensionsResource;const l=await this.k($,m??r.$w,b,t,p);return this.g.trace("Scanned Extensions",l),this.r(l),R.mark("code/server/didScanExtensions"),l}async k(m,$,b,d,p){await this.q($,p);const[t,l,i,g]=await Promise.all([this.n($),this.o(m,$),this.m($,b),this.l($,d)]);return(0,v.$pR)(t,l,i,g,this.g)}async l(m,$){return $?(await Promise.all($.map(b=>this.f.scanOneOrMultipleExtensions(k.URI.file((0,n.$nc)(b)),D.ExtensionType.User,{language:m})))).flat().map(b=>(0,o.$Oq)(b,!0)):[]}async m(m,$){const b=[];if($?.length){const d=await Promise.all($.map(p=>this.f.scanExistingExtension(p,D.ExtensionType.User,{language:m})));for(const p of d)p&&b.push((0,o.$Oq)(p,!1))}return b}async n(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(b=>(0,o.$Oq)(b,!1))}async o(m,$){return(await this.f.scanUserExtensions({profileLocation:m,language:$,useCache:!0})).map(d=>(0,o.$Oq)(d,!1))}async q(m,$){if(!(m===r.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(b){this.g.error(b)}if(!$){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${$} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([$],[],{isMachineScoped:!0},!0)}catch(b){this.g.error(b)}}}r(m){const $=(i,g)=>i.replace(/file/g,"vscode-remote"),b=i=>{let g="";return g+=i.global?"g":"",g+=i.ignoreCase?"i":"",g+=i.multiline?"m":"",new RegExp($(i.source,!0),g)},d=new class{mapDefined(i){return y.$Jj.create(i)}mapNot(i){return y.$Oj.create(i)}mapEquals(i,g){return i==="resourceScheme"&&typeof g=="string"?y.$Kj.create(i,$(g,!1)):y.$Kj.create(i,g)}mapNotEquals(i,g){return i==="resourceScheme"&&typeof g=="string"?y.$Nj.create(i,$(g,!1)):y.$Nj.create(i,g)}mapGreater(i,g){return y.$Pj.create(i,g)}mapGreaterEquals(i,g){return y.$Qj.create(i,g)}mapSmaller(i,g){return y.$Rj.create(i,g)}mapSmallerEquals(i,g){return y.$Sj.create(i,g)}mapRegex(i,g){return i==="resourceScheme"&&g?y.$Tj.create(i,b(g)):y.$Tj.create(i,g)}mapIn(i,g){return y.$Lj.create(i,g)}mapNotIn(i,g){return y.$Mj.create(i,g)}},p=i=>{if(!i||!i.when||!/resourceScheme/.test(i.when))return;const g=y.$Ej.deserialize(i.when);if(!g)return;const s=g.map(d);i.when=s.serialize()},t=i=>{if(Array.isArray(i))for(const g of i)p(g);else p(i)},l=i=>{for(const g in i)t(i[g])};m.forEach(i=>{i.contributes&&(i.contributes.menus&&l(i.contributes.menus),i.contributes.keybindings&&t(i.contributes.keybindings),i.contributes.views&&l(i.contributes.views))})}}e.$sR=w;class a{constructor(m,$){this.a=m,this.b=$}listen(m,$){throw new Error("Invalid listen")}async call(m,$,b){const d=this.b(m);switch($){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const p=b[0],t=b[1]?k.URI.revive(d.transformIncoming(b[1])):void 0,l=Array.isArray(b[2])?b[2].map(c=>k.URI.revive(d.transformIncoming(c))):void 0,i=Array.isArray(b[3])?b[3].map(c=>k.URI.revive(d.transformIncoming(c))):void 0,g=b[4];return(await this.a.scanExtensions(p,t,l,i,g)).map(c=>(0,A.$On)(c,d))}}throw new Error("Invalid call")}}e.$tR=a}),define(ve[151],Se([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=E,e.$Tw=k;class n{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}e.$Rw=n;const r=[];function E(A){const y=new n(A);return r[y.nid]=y,y}function k(A){return r[A].sid}class R{constructor(y){this.value=y}}e.$Uw=R}),define(ve[318],Se([1,0,151]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var E;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput",f[f.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(E||(e.TabInputKind=E={}));var k;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var o;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var D;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output",f[f.Hybrid=3]="Hybrid"})(D||(e.CandidatePortSource=D={}));class v{static{this.a=0}static mixin(m){return m._id=v.a++,m}}e.$tN=v;var h;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var w;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var a;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$uN={MainThreadAuthentication:(0,n.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,n.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,n.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,n.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,n.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,n.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,n.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,n.$Sw)("MainThreadCommands"),MainThreadComments:(0,n.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,n.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,n.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,n.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,n.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,n.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,n.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,n.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,n.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,n.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,n.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,n.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,n.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,n.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,n.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,n.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,n.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,n.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,n.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,n.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,n.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,n.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,n.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,n.$Sw)("MainThreadSCM"),MainThreadSearch:(0,n.$Sw)("MainThreadSearch"),MainThreadShare:(0,n.$Sw)("MainThreadShare"),MainThreadTask:(0,n.$Sw)("MainThreadTask"),MainThreadWindow:(0,n.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,n.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,n.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,n.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,n.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,n.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,n.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,n.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,n.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,n.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,n.$Sw)("MainThreadAiEmbeddingVector")},e.$vN={ExtHostCommands:(0,n.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,n.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,n.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,n.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,n.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,n.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,n.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,n.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,n.$Sw)("ExtHostSCM"),ExtHostSearch:(0,n.$Sw)("ExtHostSearch"),ExtHostTask:(0,n.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,n.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,n.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,n.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,n.$Sw)("ExtHostProgress"),ExtHostComments:(0,n.$Sw)("ExtHostComments"),ExtHostSecretState:(0,n.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,n.$Sw)("ExtHostStorage"),ExtHostUrls:(0,n.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,n.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,n.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,n.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,n.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,n.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,n.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,n.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,n.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,n.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,n.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,n.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,n.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,n.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,n.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,n.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,n.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,n.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,n.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,n.$Sw)("ExtHostLocalization")}}),define(ve[319],Se([1,0,15,26,13,120,5]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$eL=void 0,e.$fL=D,e.$gL=v,e.$eL=(0,R.$Gi)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],y=new RegExp(`^[${A.join("")}]+`),o=7;function D(w){if(w.scheme!==E.Schemas.vscodeNotebookCell)return;const a=w.fragment.indexOf("s");if(a<0)return;const f=parseInt(w.fragment.substring(0,a).replace(y,""),o),m=(0,n.$9e)(w.fragment.substring(a+1)).toString();if(!isNaN(f))return{handle:f,notebook:w.with({scheme:m,fragment:null})}}function v(w,a){const f=a.toString(o),$=`${f.length<A.length?A[f.length-1]:"z"}${f}s${(0,n.$0e)(n.$Pe.fromString(w.scheme),!0,!0)}`;return w.with({scheme:E.Schemas.vscodeNotebookCell,fragment:$})}class h{constructor(){this.a=new r.$Dc}getNotebook(a){if(a.scheme===E.Schemas.vscodeNotebookCell){const f=D(a);if(f){const m=this.a.get(f.notebook);if(m)return m}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$hL=h,(0,k.$Ps)(e.$eL,h,k.InstantiationType.Delayed)}),define(ve[152],Se([1,0,15,86,40,68,13,9,3,42,319]),function(se,e,n,r,E,k,R,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$yL=e.CellStatusbarAlignment=e.$xL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$uL=e.$tL=e.$rL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qL=e.$pL=e.$oL=e.$nL=e.CellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$sL=i,e.$vL=c,e.$wL=u,e.$zL=C,e.$AL=T,r=qe(r),e.$iL="workbench.editor.notebook",e.$jL="workbench.editor.notebookTextDiffEditor",e.$kL="workbench.editor.interactive",e.$lL="workbench.editor.repl",e.$mL="replNotebook.input.execute";var v;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(v||(e.CellKind=v={})),e.$nL=["application/json","application/javascript","text/html","image/svg+xml",k.$9s.latex,k.$9s.markdown,"image/png","image/jpeg",k.$9s.text],e.$oL=[k.$9s.latex,k.$9s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.$9s.text],e.$pL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qL="_notAvailable";var h;(function(J){J[J.Running=1]="Running",J[J.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var w;(function(J){J[J.Unconfirmed=1]="Unconfirmed",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var a;(function(J){J[J.Unconfirmed=1]="Unconfirmed",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var f;(function(J){J[J.WithHardKernelDependency=0]="WithHardKernelDependency",J[J.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",J[J.Pure=2]="Pure",J[J.Never=3]="Never"})(f||(e.NotebookRendererMatch=f={}));var m;(function(J){J.Always="always",J.Never="never",J.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(J){J[J.ModelChange=1]="ModelChange",J[J.Move=2]="Move",J[J.ChangeCellLanguage=5]="ChangeCellLanguage",J[J.Initialize=6]="Initialize",J[J.ChangeCellMetadata=7]="ChangeCellMetadata",J[J.Output=8]="Output",J[J.OutputItem=9]="OutputItem",J[J.ChangeCellContent=10]="ChangeCellContent",J[J.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",J[J.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",J[J.ChangeCellMime=13]="ChangeCellMime",J[J.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var b;(function(J){J[J.Handle=0]="Handle",J[J.Index=1]="Index"})(b||(e.SelectionStateType=b={}));var d;(function(J){J[J.Replace=1]="Replace",J[J.Output=2]="Output",J[J.Metadata=3]="Metadata",J[J.CellLanguage=4]="CellLanguage",J[J.DocumentMetadata=5]="DocumentMetadata",J[J.Move=6]="Move",J[J.OutputItems=7]="OutputItems",J[J.PartialMetadata=8]="PartialMetadata",J[J.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var p;(function(J){J.scheme=R.Schemas.vscodeNotebookCell;function ae(H,ce){return(0,D.$gL)(H,ce)}J.generate=ae;function z(H){return(0,D.$fL)(H)}J.parse=z;function B(H,ce){return H.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${H.scheme!==R.Schemas.file?H.scheme:""}`})}J.generateCellOutputUri=B;function ie(H){if(H.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!ce)return;const x=ce[1]&&ce[1]!==""?ce[1]:void 0,U=ce[2];return{outputId:x,notebook:H.with({scheme:U||R.Schemas.file,fragment:null})}}J.parseCellOutputUri=ie;function le(H,ce,x){return J.generate(H,ce).with({scheme:x})}J.generateCellPropertyUri=le;function pe(H,ce){if(H.scheme===ce)return J.parse(H.with({scheme:J.scheme}))}J.parseCellPropertyUri=pe})(p||(e.CellUri=p={}));const t=J=>y.$i?J.replace(/\//g,"\\"):J;class l{constructor(ae=[],z=e.$nL){this.e=z,this.d=[...new Set(ae)].map(B=>({pattern:B,matches:r.$Ak(t(B))}))}sort(ae){const z=new Map(E.Iterable.map(ae,ie=>[ie,t(ie)]));let B=[];for(const{matches:ie}of this.d)for(const[le,pe]of z)if(ie(pe)){B.push(le),z.delete(le);break}return z.size&&(B=B.concat([...z.keys()].sort((ie,le)=>this.e.indexOf(ie)-this.e.indexOf(le)))),B}prioritize(ae,z){const B=this.f(ae);if(B===-1){this.d.unshift({pattern:ae,matches:r.$Ak(t(ae))});return}const ie=new Set(z.map(pe=>this.f(pe,B)));ie.delete(-1);const le=Array.from(ie).sort();this.d.splice(B+1,0,...le.map(pe=>this.d[pe]));for(let pe=le.length-1;pe>=0;pe--)this.d.splice(le[pe],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,z=this.d.length){const B=t(ae);for(let ie=0;ie<z;ie++)if(this.d[ie].matches(B))return ie;return-1}}e.$rL=l;function i(J,ae,z,B=(ie,le)=>ie===le){const ie=[];function le(ce,x,U){if(x===0&&U.length===0)return;const O=ie[ie.length-1];O&&O.start+O.deleteCount===ce?(O.deleteCount+=x,O.toInsert.push(...U)):ie.push({start:ce,deleteCount:x,toInsert:U})}let pe=0,H=0;for(;;){if(pe===J.length){le(pe,0,ae.slice(H));break}if(H===ae.length){le(pe,J.length-pe,[]);break}const ce=J[pe],x=ae[H];if(B(ce,x)){pe+=1,H+=1;continue}z(x)?(le(pe,1,[]),pe+=1):(le(pe,0,[x]),H+=1)}return ie}e.$tL=new o.$Xj("notebookEditorCursorAtBoundary","none"),e.$uL=new o.$Xj("notebookEditorCursorAtLineBoundary","none");var g;(function(J){J.default="default",J.option="option"})(g||(e.NotebookEditorPriority=g={}));var s;(function(J){J.Cells="cells",J.Text="text",J.None="none"})(s||(e.NotebookFindScopeType=s={}));function c(J){const ae=J;return!!((typeof ae.include=="string"||r.$Bk(ae.include))&&(typeof ae.exclude=="string"||r.$Bk(ae.exclude)))}function u(J,ae,z){if(Array.isArray(J.viewType)&&J.viewType.indexOf(ae)>=0||J.viewType===ae)return!0;if(J.filenamePattern){const B=c(J.filenamePattern)?J.filenamePattern.include:J.filenamePattern,ie=c(J.filenamePattern)?J.filenamePattern.exclude:void 0;if(r.$zk(B,(0,A.$qc)(z.fsPath).toLowerCase()))return!(ie&&r.$zk(ie,(0,A.$qc)(z.fsPath).toLowerCase()))}return!1}e.$xL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class P{static{this.d="notebook/"}static create(ae){return`${P.d}${ae}`}static parse(ae){if(ae.startsWith(P.d))return ae.substring(P.d.length)}}e.$yL=P;function C(J){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(J)}const L=new TextDecoder;function T(J){const ae=[];let z=!1;for(const pe of J)(ae.length===0||z)&&(ae.push(pe),z=!0);let B=Y(ae);const ie=n.$Pe.concat(ae.map(pe=>n.$Pe.wrap(pe))),le=de(ie);return B=B||le.byteLength!==ie.byteLength,{data:le,didCompression:B}}e.$BL="\x1B[A";const I=e.$BL.split("").map(J=>J.charCodeAt(0)),q=10;function Y(J){let ae=!1;return J.forEach((z,B)=>{if(B===0||z.length<e.$BL.length)return;const ie=J[B-1],le=z.subarray(0,e.$BL.length);if(le[0]===I[0]&&le[1]===I[1]&&le[2]===I[2]){const pe=ie.lastIndexOf(q);if(pe===-1)return;ae=!0,J[B-1]=ie.subarray(0,pe),J[B]=z.subarray(e.$BL.length)}}),ae}function Q(J){let ae=J;do J=ae,ae=J.replace(/[^\n]\x08/gm,"");while(ae.length<J.length);return J}function re(J){for(J=J.replace(/\r+\n/gm,`
`);J.search(/\r[^$]/g)>-1;){const ae=J.match(/^(.*)\r+/m)[1];let z=J.match(/\r+(.*)$/m)[1];z=z+ae.slice(z.length,ae.length),J=J.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return J}const te=8,_=13;function de(J){return!J.buffer.includes(te)&&!J.buffer.includes(_)?J:n.$Pe.fromString(re(Q(L.decode(J.buffer))))}}),define(ve[153],Se([1,0,18,10,111,26,68,17,11,4,23,22,16,90,152]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a){"use strict";var f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fP=e.$eP=e.$dP=e.$cP=e.$aP=e.$_O=e.$$O=e.$0O=e.TestRunProfileKind=e.TestResultState=e.$9O=e.$8O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7O=e.NotebookVariablesRequestKind=e.$6O=e.$5O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.ColorThemeKind=e.$XO=e.$WO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VO=e.$UO=e.DebugConsoleMode=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OO=e.$NO=e.FileChangeType=e.$MO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LO=e.$KO=e.$JO=e.$IO=e.InlineCompletionTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.ConfigurationTarget=e.$uO=e.$tO=e.$sO=e.$rO=e.DocumentPasteTriggerKind=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kO=e.ViewBadge=e.ProgressLocation=e.$jO=e.$iO=e.TaskScope=e.ShellQuoting=e.$hO=e.$gO=e.$fO=e.TaskPanelKind=e.TaskRevealKind=e.$eO=e.TerminalLocation=e.$dO=e.$cO=e.$bO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aO=e.$_N=e.$$N=e.$0N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8N=e.$7N=e.$6N=e.$5N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4N=e.$3N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.LanguageStatusSeverity=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CodeActionTriggerKind=e.$QN=e.$PN=e.SymbolTag=e.SymbolKind=e.$ON=e.$NN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.DiagnosticSeverity=e.DiagnosticTag=e.$HN=e.$GN=e.FileEditType=e.$FN=e.$EN=e.$DN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=Xe,e.$wO=Sn,e.$bP=hi;function T(j){return Object.assign(j,{apply:function(...ue){if(ue.length===0)return Reflect.construct(j,[]);{const Ie=ue.length===1?[]:ue[1];return Reflect.construct(j,Ie,ue[0].constructor)}},call:function(...ue){if(ue.length===0)return Reflect.construct(j,[]);{const[Ie,...Ve]=ue;return Reflect.construct(j,Ve,Ie.constructor)}}})}var I;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var q;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(q||(e.TerminalQuickFixType=q={}));let Y=f=class{static from(...N){let ue=N;return new f(function(){if(ue){for(const Ie of ue)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();ue=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wN=Y,e.$wN=Y=f=Be([T],Y);let Q=m=class{static Min(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isBefore(ue)&&(ue=Ve)}return ue}static Max(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isAfter(ue)&&(ue=Ve)}return ue}static isPosition(N){if(!N)return!1;if(N instanceof m)return!0;const{line:ue,character:Ie}=N;return typeof ue=="number"&&typeof Ie=="number"}static of(N){if(N instanceof m)return N;if(this.isPosition(N))return new m(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ue){if(N<0)throw(0,r.$0)("line must be non-negative");if(ue<0)throw(0,r.$0)("character must be non-negative");this.c=N,this.e=ue}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ue=0){if(N===null||ue===null)throw(0,r.$0)();let Ie;return typeof N>"u"?Ie=0:typeof N=="number"?Ie=N:(Ie=typeof N.lineDelta=="number"?N.lineDelta:0,ue=typeof N.characterDelta=="number"?N.characterDelta:0),Ie===0&&ue===0?this:new m(this.line+Ie,this.character+ue)}with(N,ue=this.character){if(N===null||ue===null)throw(0,r.$0)();let Ie;return typeof N>"u"?Ie=this.line:typeof N=="number"?Ie=N:(Ie=typeof N.line=="number"?N.line:this.line,ue=typeof N.character=="number"?N.character:this.character),Ie===this.line&&ue===this.character?this:new m(Ie,ue)}toJSON(){return{line:this.line,character:this.character}}};e.$xN=Q,e.$xN=Q=m=Be([T],Q);let re=$=class{static isRange(N){return N instanceof $?!0:N?Q.isPosition(N.start)&&Q.isPosition(N.end):!1}static of(N){if(N instanceof $)return N;if(this.isRange(N))return new $(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ue,Ie,Ve){let Ye,at;if(typeof N=="number"&&typeof ue=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(Ye=new Q(N,ue),at=new Q(Ie,Ve)):Q.isPosition(N)&&Q.isPosition(ue)&&(Ye=Q.of(N),at=Q.of(ue)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(N){return $.isRange(N)?this.contains(N.start)&&this.contains(N.end):Q.isPosition(N)?!(Q.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ue=Q.Max(N.start,this.c),Ie=Q.Min(N.end,this.e);if(!ue.isAfter(Ie))return new $(ue,Ie)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ue=Q.Min(N.start,this.c),Ie=Q.Max(N.end,this.end);return new $(ue,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ue=this.end){if(N===null||ue===null)throw(0,r.$0)();let Ie;return N?Q.isPosition(N)?Ie=N:(Ie=N.start||this.start,ue=N.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&ue.isEqual(this.end)?this:new $(Ie,ue)}toJSON(){return[this.start,this.end]}};e.$yN=re,e.$yN=re=$=Be([T],re);let te=b=class extends re{static isSelection(N){return N instanceof b?!0:N?re.isRange(N)&&Q.isPosition(N.anchor)&&Q.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ue,Ie,Ve){let Ye,at;if(typeof N=="number"&&typeof ue=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(Ye=new Q(N,ue),at=new Q(Ie,Ve)):Q.isPosition(N)&&Q.isPosition(ue)&&(Ye=Q.of(N),at=Q.of(ue)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zN=te,e.$zN=te=b=Be([T],te);const _=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,r.$0)("connectionToken")};class de{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue,Ie){if(typeof N!="string"||N.length===0)throw(0,r.$0)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,r.$0)("port");typeof Ie<"u"&&_(Ie),this.host=N,this.port=Math.round(ue),this.connectionToken=Ie}}e.$AN=de;class J{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue){this.makeConnection=N,this.connectionToken=ue,typeof ue<"u"&&_(ue)}}e.$BN=J;class ae extends Error{static NotAvailable(N,ue){return new ae(N,w.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(N){return new ae(N,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ue=w.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(N),this._message=N,this._code=ue,this._detail=Ie,Object.setPrototypeOf(this,ae.prototype)}}e.$CN=ae;var z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(z||(e.EndOfLine=z={}));var B;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(B||(e.EnvironmentVariableMutatorType=B={}));let ie=d=class{static isTextEdit(N){return N instanceof d?!0:N?re.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ue){return new d(N,ue)}static insert(N,ue){return d.replace(new re(N,N),ue)}static delete(N){return d.replace(N,"")}static setEndOfLine(N){const ue=new d(new re(new Q(0,0),new Q(0,0)),"");return ue.newEol=N,ue}get range(){return this.c}set range(N){if(N&&!re.isRange(N))throw(0,r.$0)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,r.$0)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,r.$0)("newEol");this.f=N}constructor(N,ue){this.c=N,this.e=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DN=ie,e.$DN=ie=d=Be([T],ie);let le=p=class{static isNotebookCellEdit(N){return N instanceof p?!0:N?hn.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ue){return new p(N,ue)}static insertCells(N,ue){return new p(new hn(N,N),ue)}static deleteCells(N){return new p(N,[])}static updateCellMetadata(N,ue){const Ie=new p(new hn(N,N),[]);return Ie.newCellMetadata=ue,Ie}static updateNotebookMetadata(N){const ue=new p(new hn(0,0),[]);return ue.newNotebookMetadata=N,ue}constructor(N,ue){this.range=N,this.newCells=ue}};e.$EN=le,e.$EN=le=p=Be([T],le);class pe{static isSnippetTextEdit(N){return N instanceof pe?!0:N?re.isRange(N.range)&&x.isSnippetString(N.snippet):!1}static replace(N,ue){return new pe(N,ue)}static insert(N,ue){return pe.replace(new re(N,N),ue)}constructor(N,ue){this.range=N,this.snippet=ue}}e.$FN=pe;var H;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(H||(e.FileEditType=H={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ue,Ie,Ve){this.c.push({_type:H.File,from:N,to:ue,options:Ie,metadata:Ve})}createFile(N,ue,Ie){this.c.push({_type:H.File,from:void 0,to:N,options:ue,metadata:Ie})}deleteFile(N,ue,Ie){this.c.push({_type:H.File,from:N,to:void 0,options:ue,metadata:Ie})}e(N,ue,Ie){this.c.push({_type:H.Cell,metadata:Ie,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:ue},notebookMetadata:ue})}f(N,ue,Ie,Ve){const Ye=ue.start,at=ue.end;(Ye!==at||Ie.length>0)&&this.c.push({_type:H.CellReplace,uri:N,index:Ye,count:at-Ye,cells:Ie,metadata:Ve})}g(N,ue,Ie,Ve){this.c.push({_type:H.Cell,metadata:Ve,uri:N,edit:{editType:a.CellEditType.Metadata,index:ue,metadata:Ie}})}replace(N,ue,Ie,Ve){this.c.push({_type:H.Text,uri:N,edit:new ie(ue,Ie),metadata:Ve})}insert(N,ue,Ie,Ve){this.replace(N,new re(ue,ue),Ie,Ve)}delete(N,ue,Ie){this.replace(N,ue,"",Ie)}has(N){return this.c.some(ue=>ue._type===H.Text&&ue.uri.toString()===N.toString())}set(N,ue){if(ue)for(const Ie of ue){if(!Ie)continue;let Ve,Ye;Array.isArray(Ie)?(Ve=Ie[0],Ye=Ie[1]):Ve=Ie,le.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.g(N,Ve.range.start,Ve.newCellMetadata,Ye):Ve.newNotebookMetadata?this.e(N,Ve.newNotebookMetadata,Ye):this.f(N,Ve.range,Ve.newCells,Ye):pe.isSnippetTextEdit(Ve)?this.c.push({_type:H.Snippet,uri:N,range:Ve.range,edit:Ve.snippet,metadata:Ye}):this.c.push({_type:H.Text,uri:N,edit:Ve,metadata:Ye})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Ve=this.c[Ie];switch(Ve._type){case H.Text:case H.Snippet:case H.Cell:case H.CellReplace:Ve.uri.toString()===N.toString()&&(this.c[Ie]=void 0);break}}(0,n.$Lb)(this.c)}}get(N){const ue=[];for(const Ie of this.c)Ie._type===H.Text&&Ie.uri.toString()===N.toString()&&ue.push(Ie.edit);return ue}entries(){const N=new k.$Dc;for(const ue of this.c)if(ue._type===H.Text){let Ie=N.get(ue.uri);Ie||(Ie=[ue.uri,[]],N.set(ue.uri,Ie)),Ie[1].push(ue.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GN=ce,e.$GN=ce=Be([T],ce);let x=t=class{static isSnippetString(N){return N instanceof t?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=t.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ue=this.e++){if(typeof N=="function"){const Ie=new t;Ie.e=this.e,N(Ie),this.e=Ie.e,N=Ie.value}else N=t.c(N);return this.value+="${",this.value+=ue,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ue=this.e++){const Ie=N.map(Ve=>Ve.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(N,ue){if(typeof ue=="function"){const Ie=new t;Ie.e=this.e,ue(Ie),this.e=Ie.e,ue=Ie.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};e.$HN=x,e.$HN=x=t=Be([T],x);var U;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var O;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(O||(e.DiagnosticSeverity=O={}));let Z=l=class{static isLocation(N){return N instanceof l?!0:N?re.isRange(N.range)&&o.URI.isUri(N.uri):!1}constructor(N,ue){if(this.uri=N,ue)if(re.isRange(ue))this.range=re.of(ue);else if(Q.isPosition(ue))this.range=new re(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IN=Z,e.$IN=Z=l=Be([T],Z);let V=class{static is(N){return N?typeof N.message=="string"&&N.location&&re.isRange(N.location.range)&&o.URI.isUri(N.location.uri):!1}constructor(N,ue){this.location=N,this.message=ue}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.location.range.isEqual(ue.location.range)&&N.location.uri.toString()===ue.location.uri.toString()}};e.$JN=V,e.$JN=V=Be([T],V);let M=class{constructor(N,ue,Ie=O.Error){if(!re.isRange(N))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=N,this.message=ue,this.severity=Ie}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.severity===ue.severity&&N.code===ue.code&&N.severity===ue.severity&&N.source===ue.source&&N.range.isEqual(ue.range)&&(0,n.$xb)(N.tags,ue.tags)&&(0,n.$xb)(N.relatedInformation,ue.relatedInformation,V.isEqual)}};e.$KN=M,e.$KN=M=Be([T],M);let G=class{constructor(N,ue){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ue}};e.$LN=G,e.$LN=G=Be([T],G);let X=class extends G{constructor(N,ue,Ie,Ve){super(N,ue),this.canIncreaseHover=Ie,this.canDecreaseHover=Ve}};e.$MN=X,e.$MN=X=Be([T],X);var F;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(F||(e.HoverVerbosityAction=F={}));var W;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(W||(e.DocumentHighlightKind=W={}));let oe=class{constructor(N,ue=W.Text){this.range=N,this.kind=ue}toJSON(){return{range:this.range,kind:W[this.kind]}}};e.$NN=oe,e.$NN=oe=Be([T],oe);let he=class{constructor(N,ue){this.uri=N,this.highlights=ue}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$ON=he,e.$ON=he=Be([T],he);var ke;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Ne;(function(j){j[j.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let me=i=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ue,Ie,Ve,Ye){this.name=N,this.kind=ue,this.containerName=Ye,typeof Ie=="string"&&(this.containerName=Ie),Ve instanceof Z?this.location=Ve:Ie instanceof re&&(this.location=new Z(Ve,Ie)),i.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$PN=me,e.$PN=me=i=Be([T],me);let $e=g=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(g.validate)}constructor(N,ue,Ie,Ve,Ye){this.name=N,this.detail=ue,this.kind=Ie,this.range=Ve,this.selectionRange=Ye,this.children=[],g.validate(this)}};e.$QN=$e,e.$QN=$e=g=Be([T],$e);var Pe;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Oe=class{constructor(N,ue){this.title=N,this.kind=ue}};e.$RN=Oe,e.$RN=Oe=Be([T],Oe);let fe=class{static{s=this}static{this.c="."}constructor(N){this.value=N}append(N){return new s(this.value?this.value+s.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+s.c)}};e.$SN=fe,e.$SN=fe=s=Be([T],fe),fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorMove=fe.Refactor.append("move"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll"),fe.Notebook=fe.Empty.append("notebook");let De=class{constructor(N,ue){if(this.range=N,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TN=De,e.$TN=De=Be([T],De);class Re{constructor(N,ue,Ie,Ve,Ye,at){this.kind=N,this.name=ue,this.detail=Ie,this.uri=Ve,this.range=Ye,this.selectionRange=at}}e.$UN=Re;class ze{constructor(N,ue){this.fromRanges=ue,this.from=N}}e.$VN=ze;class We{constructor(N,ue){this.fromRanges=ue,this.to=N}}e.$WN=We;var Qe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let Ke=class{constructor(N,ue){this.range=N,this.command=ue}get isResolved(){return!!this.command}};e.$XN=Ke,e.$XN=Ke=Be([T],Ke);let Ge=c=class{#e;static isMarkdownString(N){return N instanceof c?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ue=!1){this.#e=new E.$4k(N,{supportThemeIcons:ue})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ue){return this.#e.appendCodeblock(ue??"",N),this}};e.$YN=Ge,e.$YN=Ge=c=Be([T],Ge);let xe=class{constructor(N,ue){this.label=N,this.documentation=ue}};e.$ZN=xe,e.$ZN=xe=Be([T],xe);let st=class{constructor(N,ue){this.label=N,this.documentation=ue,this.parameters=[]}};e.$1N=st,e.$1N=st=Be([T],st);let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2N=lt,e.$2N=lt=Be([T],lt);var rt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var nt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let tt=class{constructor(N){this.value=N}};e.$3N=tt,e.$3N=tt=Be([T],tt);let et=class{constructor(N,ue,Ie){this.position=N,this.label=ue,this.kind=Ie}};e.$4N=et,e.$4N=et=Be([T],et);var Ze;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var be;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(be||(e.CompletionItemKind=be={}));var Le;(function(j){j[j.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Fe=class{constructor(N,ue){this.label=N,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5N=Fe,e.$5N=Fe=Be([T],Fe);let ye=class{constructor(N=[],ue=!1){this.items=N,this.isIncomplete=ue}};e.$6N=ye,e.$6N=ye=Be([T],ye);let Ce=class{constructor(N,ue,Ie){this.insertText=N,this.range=ue,this.command=Ie}};e.$7N=Ce,e.$7N=Ce=Be([T],Ce);let ne=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$8N=ne,e.$8N=ne=Be([T],ne);var ee;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(ee||(e.PartialAcceptTriggerKind=ee={}));var we;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(we||(e.ViewColumn=we={}));var He;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(He||(e.StatusBarAlignment=He={}));function Xe(j,N){return`${v.$rn.toKey(j)}.${N}`}var _e;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(_e||(e.TextEditorLineNumbersStyle=_e={}));var it;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(it||(e.TextDocumentSaveReason=it={}));var ut;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ut||(e.TextEditorRevealType=ut={}));var gt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(gt||(e.TextEditorSelectionChangeKind=gt={}));var bt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(bt||(e.TextDocumentChangeReason=bt={}));var Mt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Mt||(e.DecorationRangeBehavior=Mt={})),function(j){function N(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=N}(gt||(e.TextEditorSelectionChangeKind=gt={}));var At;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(At||(e.SyntaxTokenType=At={})),function(j){function N(ue){switch(ue){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=N}(At||(e.SyntaxTokenType=At={}));let ft=class{constructor(N,ue){if(ue&&!o.URI.isUri(ue))throw(0,r.$0)("target");if(!re.isRange(N)||N.isEmpty)throw(0,r.$0)("range");this.range=N,this.target=ue}};e.$0N=ft,e.$0N=ft=Be([T],ft);let wt=class{constructor(N,ue,Ie,Ve){this.red=N,this.green=ue,this.blue=Ie,this.alpha=Ve}};e.$$N=wt,e.$$N=wt=Be([T],wt);let Et=class{constructor(N,ue){if(ue&&!(ue instanceof wt))throw(0,r.$0)("color");if(!re.isRange(N)||N.isEmpty)throw(0,r.$0)("range");this.range=N,this.color=ue}};e.$_N=Et,e.$_N=Et=Be([T],Et);let kt=class{constructor(N){if(!N||typeof N!="string")throw(0,r.$0)("label");this.label=N}};e.$aO=kt,e.$aO=kt=Be([T],kt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Ot;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ot||(e.SourceControlInputBoxValidationType=Ot={}));var ht;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));var pt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(pt||(e.TerminalShellExecutionCommandLineConfidence=pt={}));class vt{constructor(N,ue,Ie){if(this.startIndex=N,this.length=ue,this.tooltip=Ie,typeof N!="number"||N<0)throw(0,r.$0)("startIndex");if(typeof ue!="number"||ue<1)throw(0,r.$0)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,r.$0)("tooltip")}}e.$bO=vt;class It{constructor(N){this.uri=N}}e.$cO=It;class zt{constructor(N){this.terminalCommand=N}}e.$dO=zt;var Ct;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ct||(e.TerminalLocation=Ct={}));class _t{constructor(N){if(this.options=N,typeof N!="object")throw(0,r.$0)("options")}}e.$eO=_t;var Pt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Lt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Bt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(N){switch(N){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(N,ue){if(this.label=ue,typeof N!="string"||typeof ue!="string")throw(0,r.$0)("name");this.c=N}get id(){return this.c}};e.$fO=Bt,e.$fO=Bt=u=Be([T],Bt);function Nt(j){let N="";for(let ue=0;ue<j.length;ue++)N+=j[ue].replace(/,/g,",,")+",";return N}let Tt=class{constructor(N,ue,Ie){if(typeof N!="string")throw(0,r.$0)("process");this.e=[],this.c=N,ue!==void 0&&(Array.isArray(ue)?(this.e=ue,this.f=Ie):this.f=ue)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,r.$0)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ue of this.e)N.push(ue);return Nt(N)}};e.$gO=Tt,e.$gO=Tt=Be([T],Tt);let St=class{constructor(N,ue,Ie){if(this.f=[],Array.isArray(ue)){if(!N)throw(0,r.$0)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$0)("command");this.e=N,this.f=ue,this.g=Ie}else{if(typeof N!="string")throw(0,r.$0)("commandLine");this.c=N,this.g=ue}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,r.$0)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$0)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ue of this.f)N.push(typeof ue=="string"?ue:ue.value);return Nt(N)}};e.$hO=St,e.$hO=St=Be([T],St);var Ut;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class Ht{constructor(N){this.c=N}computeId(){return"customExecution"+(0,D.$3g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$iO=Ht;let Wt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ue,Ie,Ve,Ye,at){this.k=!1,this.l=this.definition=N;let ct;typeof ue=="string"?(this.o=this.name=ue,this.w=this.source=Ie,this.execution=Ve,ct=Ye,this.k=!0):ue===qt.Global||ue===qt.Workspace?(this.target=ue,this.o=this.name=Ie,this.w=this.source=Ve,this.execution=Ye,ct=at):(this.target=ue,this.o=this.name=Ie,this.w=this.source=Ve,this.execution=Ye,ct=at),typeof ct=="string"?(this.r=[ct],this.t=!0):Array.isArray(ct)?(this.r=ct,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Tt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof St?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,D.$3g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,r.$0)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,r.$0)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ue=this.l.type;(S.g===ue||S.e===ue||S.f===ue||S.c===ue)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,r.$0)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$jO=Wt,e.$jO=Wt=S=Be([T],Wt);var Qt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var en;(function(j){function N(ue){const Ie=ue;return(0,y.$kg)(Ie.value)?Ie.tooltip&&!(0,y.$gg)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}j.isViewBadge=N})(en||(e.ViewBadge=en={}));let Vt=P=class{static isTreeItem(N,ue){const Ie=N;if(Ie.checkboxState!==void 0){const Ve=(0,y.$kg)(Ie.checkboxState)?Ie.checkboxState:(0,y.$ig)(Ie.checkboxState)&&(0,y.$kg)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,Ye=!(0,y.$kg)(Ie.checkboxState)&&(0,y.$ig)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==Ft.Checked&&Ve!==Ft.Unchecked||Ye!==void 0&&!(0,y.$gg)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(N instanceof P)return!0;if(Ie.label!==void 0&&!(0,y.$gg)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,y.$gg)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,y.$gg)(Ie.iconPath)&&!o.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,y.$gg)(Ie.iconPath.id))){const Ve=Ie.iconPath;if(!Ve||!(0,y.$gg)(Ve.light)&&!o.URI.isUri(Ve.light)&&!(0,y.$gg)(Ve.dark)&&!o.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,y.$gg)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!o.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,y.$gg)(Ie.tooltip)&&!(Ie.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<Dt.None&&Ie.collapsibleState>Dt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,y.$gg)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(N,ue=Dt.None){this.collapsibleState=ue,o.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$kO=Vt,e.$kO=Vt=P=Be([T],Vt);var Dt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Dt||(e.TreeItemCollapsibleState=Dt={}));var Ft;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let $t=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$lO=$t,e.$lO=$t=Be([T],$t);class Yt extends $t{}e.$mO=Yt;class Zt extends Yt{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$nO=Zt;class an{constructor(N,ue,Ie,Ve){this.name=N,this.uri=ue,this._itemId=Ie,this.c=Ve}data(){return this.c()}}e.$oO=an;let ln=class{#e=new Map;constructor(N){for(const[ue,Ie]of N??[]){const Ve=this.#e.get(this.#t(ue));Ve?Ve.push(Ie):this.#e.set(this.#t(ue),[Ie])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ue){this.#e.set(this.#t(N),[ue])}forEach(N,ue){for(const[Ie,Ve]of this.#e)for(const Ye of Ve)N.call(ue,Ye,Ie,this)}*[Symbol.iterator](){for(const[N,ue]of this.#e)for(const Ie of ue)yield[N,Ie]}#t(N){return N.toLowerCase()}};e.$pO=ln,e.$pO=ln=Be([T],ln);let un=class{constructor(N,ue,Ie){this.insertText=N,this.title=ue,this.kind=Ie}};e.$qO=un,e.$qO=un=Be([T],un);var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(bn||(e.DocumentPasteTriggerKind=bn={}));class nn{static{this.c="."}constructor(N){this.value=N}append(...N){return new nn((this.value?[this.value,...N]:N).join(nn.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+nn.c)}}e.$rO=nn,nn.Empty=new nn("");class wn{constructor(N,ue,Ie){this.title=ue,this.insertText=N,this.kind=Ie}}e.$sO=wn;let Gt=class{constructor(N,ue){this.id=N,this.color=ue}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$tO=Gt,e.$tO=Gt=Be([T],Gt),Gt.File=new Gt("file"),Gt.Folder=new Gt("folder");let dn=class{constructor(N){this.id=N}};e.$uO=dn,e.$uO=dn=Be([T],dn);var mn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(mn||(e.ConfigurationTarget=mn={}));let gn=class{get base(){return this.c}set base(N){this.c=N,this.e=o.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ue){if(typeof N!="string"&&(!N||!o.URI.isUri(N)&&!o.URI.isUri(N.uri)))throw(0,r.$0)("base");if(typeof ue!="string")throw(0,r.$0)("pattern");typeof N=="string"?this.baseUri=o.URI.file(N):o.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vO=gn,e.$vO=gn=Be([T],gn);const vn=new WeakMap;function Sn(j,N){vn.set(j,N)}let rn=class{constructor(N,ue,Ie,Ve,Ye){this.enabled=typeof N=="boolean"?N:!0,typeof ue=="string"&&(this.condition=ue),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ve=="string"&&(this.logMessage=Ve),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=vn.get(this)??(0,D.$3g)()),this.c}};e.$xO=rn,e.$xO=rn=Be([T],rn);let $n=class extends rn{constructor(N,ue,Ie,Ve,Ye,at){if(super(ue,Ie,Ve,Ye,at),N===null)throw(0,r.$0)("location");this.location=N}};e.$yO=$n,e.$yO=$n=Be([T],$n);let pn=class extends rn{constructor(N,ue,Ie,Ve,Ye,at){super(ue,Ie,Ve,Ye,at),this.functionName=N}};e.$zO=pn,e.$zO=pn=Be([T],pn);let Ee=class extends rn{constructor(N,ue,Ie,Ve,Ye,at,ct,Rt){if(super(Ve,Ye,at,ct,Rt),!ue)throw(0,r.$0)("dataId");this.label=N,this.dataId=ue,this.canPersist=Ie}};e.$AO=Ee,e.$AO=Ee=Be([T],Ee);let Te=class{constructor(N,ue,Ie){this.command=N,this.args=ue||[],this.options=Ie}};e.$BO=Te,e.$BO=Te=Be([T],Te);let ge=class{constructor(N,ue){this.port=N,this.host=ue}};e.$CO=ge,e.$CO=ge=Be([T],ge);let K=class{constructor(N){this.path=N}};e.$DO=K,e.$DO=K=Be([T],K);let Ae=class{constructor(N){this.implementation=N}};e.$EO=Ae,e.$EO=Ae=Be([T],Ae);class Me{constructor(N,ue,Ie){this.session=N,this.threadId=ue,this.frameId=Ie}}e.$FO=Me;class Je{constructor(N,ue){this.session=N,this.threadId=ue}}e.$GO=Je;let Ue=class{constructor(N,ue){this.range=N,this.expression=ue}};e.$HO=Ue,e.$HO=Ue=Be([T],Ue);var ot;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ot||(e.InlineCompletionTriggerKind=ot={}));let dt=class{constructor(N,ue){this.range=N,this.text=ue}};e.$IO=dt,e.$IO=dt=Be([T],dt);let jt=class{constructor(N,ue,Ie=!0){this.range=N,this.variableName=ue,this.caseSensitiveLookup=Ie}};e.$JO=jt,e.$JO=jt=Be([T],jt);let Kt=class{constructor(N,ue){this.range=N,this.expression=ue}};e.$KO=Kt,e.$KO=Kt=Be([T],Kt);let yt=class{constructor(N,ue){this.frameId=N,this.stoppedLocation=ue}};e.$LO=yt,e.$LO=yt=Be([T],yt);var Xt;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Xt||(e.NewSymbolNameTag=Xt={}));var Un;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Un||(e.NewSymbolNameTriggerKind=Un={}));class Ai{constructor(N,ue){this.newSymbolName=N,this.tags=ue}}e.$MO=Ai;var qn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(qn||(e.FileChangeType=qn={}));let An=C=class extends Error{static FileExists(N){return new C(N,h.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(N){return new C(N,h.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(N){return new C(N,h.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(N){return new C(N,h.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(N){return new C(N,h.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(N){return new C(N,h.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(N,ue=h.FileSystemProviderErrorCode.Unknown,Ie){super(o.URI.isUri(N)?N.toString(!0):N),this.code=Ie?.name??"Unknown",(0,h.$pl)(this,ue),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$NO=An,e.$NO=An=C=Be([T],An);let Cn=class{constructor(N,ue,Ie){this.start=N,this.end=ue,this.kind=Ie}};e.$OO=Cn,e.$OO=Cn=Be([T],Cn);var Hn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hn||(e.FoldingRangeKind=Hn={}));var Wn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Wn||(e.CommentThreadCollapsibleState=Wn={}));var Vn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Vn||(e.CommentMode=Vn={}));var Gn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Gn||(e.CommentState=Gn={}));var Kn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Kn||(e.CommentThreadState=Kn={}));var Xn;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Xn||(e.CommentThreadApplicability=Xn={}));class Ci{constructor(N,ue=[]){this.tokenTypes=N,this.tokenModifiers=ue}}e.$PO=Ci;function Ti(j){return typeof j>"u"||(0,y.$hg)(j)}class Tn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ue=0,Ie=N.tokenTypes.length;ue<Ie;ue++)this.k.set(N.tokenTypes[ue],ue);for(let ue=0,Ie=N.tokenModifiers.length;ue<Ie;ue++)this.l.set(N.tokenModifiers[ue],ue)}}push(N,ue,Ie,Ve,Ye){if(typeof N=="number"&&typeof ue=="number"&&typeof Ie=="number"&&typeof Ve=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(N,ue,Ie,Ve,Ye);if(re.isRange(N)&&typeof ue=="string"&&Ti(Ie))return this.o(N,ue,Ie);throw(0,r.$0)()}o(N,ue,Ie){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ue))throw new Error("`tokenType` is not in the provided legend");const Ve=N.start.line,Ye=N.start.character,at=N.end.character-N.start.character,ct=this.k.get(ue);let Rt=0;if(Ie)for(const xt of Ie){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const tn=this.l.get(xt);Rt|=1<<tn>>>0}this.q(Ve,Ye,at,ct,Rt)}q(N,ue,Ie,Ve,Ye){if(this.f&&(N<this.c||N===this.c&&ue<this.e)){this.f=!1;const Rt=this.g.length/5|0;let xt=0,tn=0;for(let on=0;on<Rt;on++){let cn=this.g[5*on],yn=this.g[5*on+1];cn===0?(cn=xt,yn+=tn):cn+=xt,this.g[5*on]=cn,this.g[5*on+1]=yn,xt=cn,tn=yn}}let at=N,ct=ue;this.f&&this.j>0&&(at-=this.c,at===0&&(ct-=this.e)),this.g[this.j++]=at,this.g[this.j++]=ct,this.g[this.j++]=Ie,this.g[this.j++]=Ve,this.g[this.j++]=Ye,this.c=N,this.e=ue}static r(N){const ue=[],Ie=N.length/5|0;for(let ct=0;ct<Ie;ct++)ue[ct]=ct;ue.sort((ct,Rt)=>{const xt=N[5*ct],tn=N[5*Rt];if(xt===tn){const on=N[5*ct+1],cn=N[5*Rt+1];return on-cn}return xt-tn});const Ve=new Uint32Array(N.length);let Ye=0,at=0;for(let ct=0;ct<Ie;ct++){const Rt=5*ue[ct],xt=N[Rt+0],tn=N[Rt+1],on=N[Rt+2],cn=N[Rt+3],yn=N[Rt+4],Ii=xt-Ye,kr=Ii===0?tn-at:tn,En=5*ct;Ve[En+0]=Ii,Ve[En+1]=kr,Ve[En+2]=on,Ve[En+3]=cn,Ve[En+4]=yn,Ye=xt,at=tn}return Ve}build(N){return this.f?new On(new Uint32Array(this.g),N):new On(Tn.r(this.g),N)}}e.$QO=Tn;class On{constructor(N,ue){this.resultId=ue,this.data=N}}e.$RO=On;class Oi{constructor(N,ue,Ie){this.start=N,this.deleteCount=ue,this.data=Ie}}e.$SO=Oi;class Li{constructor(N,ue){this.resultId=ue,this.edits=N}}e.$TO=Li;var Jn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Jn||(e.DebugConsoleMode=Jn={}));class Ni{constructor(N){this.name=N}}e.$UO=Ni;let Ln=class{static{this.Back={iconPath:new Gt("arrow-left")}}constructor(){}};e.$VO=Ln,e.$VO=Ln=Be([T],Ln);var Qn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qn||(e.QuickPickItemKind=Qn={}));var Yn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Yn||(e.InputBoxValidationSeverity=Yn={}));var Zn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Zn||(e.ExtensionKind=Zn={}));class Fi{static validate(N){if(typeof N.badge=="string"){let ue=(0,A.$Rf)(N.badge,0);if(ue<N.badge.length&&(ue+=(0,A.$Rf)(N.badge,ue)),N.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Gt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ue,Ie){this.badge=N,this.tooltip=ue,this.color=Ie}}e.$WO=Fi;let Nn=class{constructor(N){this.kind=N}};e.$XO=Nn,e.$XO=Nn=Be([T],Nn);var xn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(xn||(e.ColorThemeKind=xn={}));class hn{static isNotebookRange(N){return N instanceof hn?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ue){if(N<0)throw(0,r.$0)("start must be positive");if(ue<0)throw(0,r.$0)("end must be positive");N<=ue?(this.c=N,this.e=ue):(this.c=ue,this.e=N)}with(N){let ue=this.c,Ie=this.e;return N.start!==void 0&&(ue=N.start),N.end!==void 0&&(Ie=N.end),ue===this.c&&Ie===this.e?this:new hn(ue,Ie)}}e.$YO=hn;class Dn{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ue=>Dn.isNotebookCellData(ue))}static isNotebookCellData(N){return!0}constructor(N,ue,Ie,Ve,Ye,at,ct){this.kind=N,this.value=ue,this.languageId=Ie,this.mime=Ve,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ct,Dn.validate(this)}}e.$ZO=Dn;class ji{constructor(N){this.cells=N}}e.$1O=ji;class sn{static isNotebookCellOutputItem(N){return N instanceof sn?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ue={name:N.name,message:N.message,stack:N.stack};return sn.json(ue,"application/vnd.code.notebook.error")}static stdout(N){return sn.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return sn.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ue="application/octet-stream"){return new sn(N,ue)}static#e=new TextEncoder;static text(N,ue=R.$9s.text){const Ie=sn.#e.encode(String(N));return new sn(Ie,ue)}static json(N,ue="text/x-json"){const Ie=JSON.stringify(N,void 0,"	");return sn.text(Ie,ue)}constructor(N,ue){this.data=N,this.mime=ue;const Ie=(0,R.$at)(ue,!0);if(!Ie)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$2O=sn;class kn{static isNotebookCellOutput(N){return N instanceof kn?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ue=!1){const Ie=new Set,Ve=new Set;for(let Ye=0;Ye<N.length;Ye++){const at=N[Ye],ct=(0,R.$at)(at.mime);if(!Ie.has(ct)||(0,a.$zL)(ct)){Ie.add(ct);continue}Ve.add(Ye),ue&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?N:N.filter((Ye,at)=>!Ve.has(at))}constructor(N,ue,Ie){this.items=kn.ensureUniqueMimeTypes(N,!0),typeof ue=="string"?(this.id=ue,this.metadata=Ie):(this.id=(0,D.$3g)(),this.metadata=ue??Ie)}}e.$3O=kn;var _n;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(_n||(e.NotebookCellKind=_n={}));var ei;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ei||(e.NotebookCellExecutionState=ei={}));var ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var ni;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ni||(e.NotebookEditorRevealType=ni={}));class Mi{constructor(N,ue){this.text=N,this.alignment=ue}}e.$4O=Mi;var ii;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ii||(e.NotebookControllerAffinity=ii={}));var ri;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(ri||(e.NotebookControllerAffinity2=ri={}));class zi{constructor(N,ue=[]){this.uri=N,this.provides=(0,n.$5b)(ue)}}e.$5O=zi;class Bi{constructor(N){this.label=N}}e.$6O=Bi;var si;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(si||(e.NotebookVariablesRequestKind=si={}));let Fn=class{constructor(N,ue){this.label=N,this.timestamp=ue}};e.$7O=Fn,e.$7O=Fn=Be([T],Fn);var oi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(oi||(e.ExtensionMode=oi={}));var ai;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ai||(e.ExtensionRuntime=ai={}));var li;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class Ui{constructor(N,ue){this.ranges=N,this.wordPattern=ue}}e.$8O=Ui;class qi{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$9O=qi;var ci;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ci||(e.TestResultState=ci={}));var ui;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ui||(e.TestRunProfileKind=ui={}));let jn=class{constructor(N=void 0,ue=void 0,Ie=void 0,Ve=!1,Ye=!0){this.include=N,this.exclude=ue,this.profile=Ie,this.continuous=Ve,this.preserveFocus=Ye}};e.$0O=jn,e.$0O=jn=Be([T],jn);let Mn=L=class{static diff(N,ue,Ie){const Ve=new L(N);return Ve.expectedOutput=ue,Ve.actualOutput=Ie,Ve}constructor(N){this.message=N}};e.$$O=Mn,e.$$O=Mn=L=Be([T],Mn);let zn=class{constructor(N){this.id=N}};e.$_O=zn,e.$_O=zn=Be([T],zn);class In{constructor(N,ue){this.covered=N,this.total=ue,hi(this)}}e.$aP=In;function hi(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Bn{static fromDetails(N,ue){const Ie=new In(0,0),Ve=new In(0,0),Ye=new In(0,0);for(const ct of ue)if("branches"in ct){Ie.total+=1,Ie.covered+=ct.executed?1:0;for(const Rt of ct.branches)Ve.total+=1,Ve.covered+=Rt.executed?1:0}else Ye.total+=1,Ye.covered+=ct.executed?1:0;const at=new Bn(N,Ie,Ve.total>0?Ve:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ue,at}constructor(N,ue,Ie,Ve,Ye=[]){this.uri=N,this.statementCoverage=ue,this.branchCoverage=Ie,this.declarationCoverage=Ve,this.fromTests=Ye}}e.$cP=Bn;class Hi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Ie=[]){this.executed=N,this.location=ue,this.branches=Ie}}e.$dP=Hi;class Wi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Ie){this.executed=N,this.location=ue,this.label=Ie}}e.$eP=Wi;class Vi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Ie){this.name=N,this.executed=ue,this.location=Ie}}e.$fP=Vi;var fi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(fi||(e.ExternalUriOpenerPriority=fi={}));var di;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(di||(e.WorkspaceTrustState=di={}));var mi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi||(e.PortAutoForwardAction=mi={}));class Gi{constructor(N,ue,Ie,Ve,Ye,at){this.kind=N,this.name=ue,this.detail=Ie,this.uri=Ve,this.range=Ye,this.selectionRange=at}}e.$gP=Gi;class Ki{constructor(N){this.uri=N}}e.$hP=Ki;class Xi{constructor(N,ue){this.original=N,this.modified=ue}}e.$iP=Xi;class Ji{constructor(N,ue,Ie,Ve){this.base=N,this.input1=ue,this.input2=Ie,this.result=Ve}}e.$jP=Ji;class Qi{constructor(N,ue){this.uri=N,this.viewType=ue}}e.$kP=Qi;class Yi{constructor(N){this.viewType=N}}e.$lP=Yi;class Zi{constructor(N,ue){this.uri=N,this.notebookType=ue}}e.$mP=Zi;class xi{constructor(N,ue,Ie){this.original=N,this.modified=ue,this.notebookType=Ie}}e.$nP=xi;class _i{constructor(){}}e.$oP=_i;class er{constructor(N,ue){this.uri=N,this.inputBoxUri=ue}}e.$pP=er;class tr{constructor(){}}e.$qP=tr;class nr{constructor(N){this.textDiffs=N}}e.$rP=nr;var gi;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(gi||(e.InteractiveSessionVoteDirection=gi={}));var $i;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})($i||(e.ChatCopyKind=$i={}));var pi;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(pi||(e.ChatVariableLevel=pi={}));class ir{constructor(N,ue,Ie){this.id=N,this.label=ue,this.values=Ie}}e.$sP=ir;var bi;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(bi||(e.InteractiveEditorResponseFeedbackKind=bi={}));var wi;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(wi||(e.ChatResultFeedbackKind=wi={}));class rr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N}}e.$tP=rr;class sr{constructor(N,ue){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N,this.vulnerabilities=ue}}e.$uP=sr;class or{constructor(N,ue){this.participant=N,this.command=ue}}e.$vP=or;class ar{constructor(N,ue,Ie){this.title=N,this.message=ue,this.data=Ie}}e.$wP=ar;class lr{constructor(N,ue){this.value=N,this.baseUri=ue}}e.$xP=lr;class cr{constructor(N,ue){this.value=N,this.title=ue}}e.$yP=cr;class ur{constructor(N){this.value=N}}e.$zP=ur;class hr{constructor(N,ue){this.value=N,this.task=ue}}e.$AP=hr;class fr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N}}e.$BP=fr;class dr{constructor(N){this.value=N}}e.$CP=dr;class mr{constructor(N,ue){this.value=N,this.iconPath=ue}}e.$DP=mr;class gr{constructor(N,ue){this.uri=N,this.edits=Array.isArray(ue)?ue:[ue]}}e.$EP=gr;class $r{constructor(N,ue,Ie,Ve){this.prompt=N,this.command=ue,this.references=Ie,this.participant=Ve}}e.$FP=$r;class pr{constructor(N,ue,Ie,Ve){this.response=N,this.result=ue,this.participant=Ie,this.command=Ve}}e.$GP=pr;var vi;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(vi||(e.ChatLocation=vi={}));var Pn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(Pn||(e.LanguageModelChatMessageRole=Pn={}));class br{constructor(N,ue,Ie){this.name=N,this.content=ue,this.isError=Ie??!1}}e.$HP=br;class Rn{static User(N,ue){const Ie=new Rn(Pn.User,typeof N=="string"?N:"",ue);return Ie.content2=N,Ie}static Assistant(N,ue){return new Rn(Pn.Assistant,N,ue)}constructor(N,ue,Ie){this.role=N,this.content=ue,this.content2=ue,this.name=Ie}}e.$IP=Rn;class wr{constructor(N,ue){this.name=N,this.parameters=ue}}e.$JP=wr;class vr{constructor(N){this.value=N}}e.$KP=vr;class yr{constructor(N){this.content=N}}e.$LP=yr;class Er{constructor(N,ue){this.content=N,this.name=ue}}e.$MP=Er;class Sr{constructor(N,ue){this.content=N,this.name=ue}}e.$NP=Sr;class fn extends Error{static NotFound(N){return new fn(N,fn.NotFound.name)}static NoPermissions(N){return new fn(N,fn.NoPermissions.name)}static Blocked(N){return new fn(N,fn.Blocked.name)}constructor(N,ue,Ie){super(N,{cause:Ie}),this.name="LanguageModelError",this.code=ue??""}}e.$OP=fn;var yi;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(yi||(e.RelatedInformationType=yi={}));var Ei;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Ei||(e.SpeechToTextStatus=Ei={}));var Si;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Si||(e.TextToSpeechStatus=Si={}));var Di;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Di||(e.KeywordRecognitionStatus=Di={}));class Dr{constructor(N,ue){this.text=N,this.range=ue}}e.$PP=Dr;var ki;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ki||(e.InlineEditTriggerKind=ki={}))}),define(ve[154],Se([1,0,18,15,175,79,111,26,161,50,68,21,167,20,82,11,4,249,49,110,201,182,261,262,148,102,302,315,303,152,76,103,150,153]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=le,e.$YP=H,e.$ZP=ce,R=qe(R),b=qe(b),d=qe(d),p=qe(p),u=qe(u),P=qe(P),I=qe(I);var q;(function(Ee){function Te(K){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:Ue}=K,ot=new I.$xN(Ae-1,Me-1),dt=new I.$xN(Je-1,Ue-1);return new I.$zN(ot,dt)}Ee.to=Te;function ge(K){const{anchor:Ae,active:Me}=K;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}Ee.from=ge})(q||(e.Selection=q={}));var Y;(function(Ee){function Te(K){if(!K)return;const{start:Ae,end:Me}=K;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}Ee.from=Te;function ge(K){if(!K)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:Je,endColumn:Ue}=K;return new I.$yN(Ae-1,Me-1,Je-1,Ue-1)}Ee.to=ge})(Y||(e.Range=Y={}));var Q;(function(Ee){function Te(K){return{uri:K.uri,range:Y.from(K.range)}}Ee.from=Te;function ge(K){return new I.$IN(m.URI.revive(K.uri),Y.to(K.range))}Ee.to=ge})(Q||(e.Location=Q={}));var re;(function(Ee){function Te(ge){switch(ge){case d.StandardTokenType.Comment:return I.StandardTokenType.Comment;case d.StandardTokenType.Other:return I.StandardTokenType.Other;case d.StandardTokenType.RegEx:return I.StandardTokenType.RegEx;case d.StandardTokenType.String:return I.StandardTokenType.String}}Ee.to=Te})(re||(e.TokenType=re={}));var te;(function(Ee){function Te(K){return new I.$xN(K.lineNumber-1,K.column-1)}Ee.to=Te;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}Ee.from=ge})(te||(e.Position=te={}));var _;(function(Ee){function Te(Ae,Me,Je){return(0,n.$Kb)((0,n.$5b)(Ae).map(Ue=>ge(Ue,Me,Je)))}Ee.from=Te;function ge(Ae,Me,Je){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:Je?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:K(Ae.scheme,Me),pattern:Xe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:Je?.isBuiltin}}function K(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(_||(e.DocumentSelector=_={}));var de;(function(Ee){function Te(K){switch(K){case I.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case I.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}Ee.from=Te;function ge(K){switch(K){case l.MarkerTag.Unnecessary:return I.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return I.DiagnosticTag.Deprecated;default:return}}Ee.to=ge})(de||(e.DiagnosticTag=de={}));var J;(function(Ee){function Te(K){let Ae;return K.code&&((0,f.$gg)(K.code)||(0,f.$kg)(K.code)?Ae=String(K.code):Ae={value:String(K.code.value),target:K.code.target}),{...Y.from(K.range),message:K.message,source:K.source,code:Ae,severity:z.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ae.from),tags:Array.isArray(K.tags)?(0,n.$Kb)(K.tags.map(de.from)):void 0}}Ee.from=Te;function ge(K){const Ae=new I.$KN(Y.to(K),K.message,z.to(K.severity));return Ae.source=K.source,Ae.code=(0,f.$gg)(K.code)?K.code:K.code?.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ae.to),Ae.tags=K.tags&&(0,n.$Kb)(K.tags.map(de.to)),Ae}Ee.to=ge})(J||(e.Diagnostic=J={}));var ae;(function(Ee){function Te(K){return{...Y.from(K.location.range),message:K.message,resource:K.location.uri}}Ee.from=Te;function ge(K){return new I.$JN(new I.$IN(K.resource,Y.to(K)),K.message)}Ee.to=ge})(ae||(e.DiagnosticRelatedInformation=ae={}));var z;(function(Ee){function Te(K){switch(K){case I.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case I.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case I.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case I.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=Te;function ge(K){switch(K){case l.MarkerSeverity.Info:return I.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return I.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return I.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return I.DiagnosticSeverity.Hint;default:return I.DiagnosticSeverity.Error}}Ee.to=ge})(z||(e.DiagnosticSeverity=z={}));var B;(function(Ee){function Te(K){return typeof K=="number"&&K>=I.ViewColumn.One?K-1:K===I.ViewColumn.Beside?T.$pE:T.$oE}Ee.from=Te;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ge})(B||(e.ViewColumn=B={}));function ie(Ee){return typeof Ee.range<"u"}function le(Ee){return Ee.length===0?!0:!!ie(Ee[0])}var pe;(function(Ee){function Te(Ue){return Ue.map(Ee.from)}Ee.fromMany=Te;function ge(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function K(Ue){let ot;if(ge(Ue)){const{language:yt,value:Xt}=Ue;ot={value:"```"+yt+`
`+Xt+"\n```\n"}}else I.$YN.isMarkdownString(Ue)?ot={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?ot={value:Ue}:ot={value:""};const dt=Object.create(null);ot.uris=dt;const jt=yt=>{try{let Xt=m.URI.parse(yt,!0);Xt=Xt.with({query:Ae(Xt.query,dt)}),dt[yt]=Xt}catch{}return""},Kt=new y.marked.Renderer;return Kt.link=jt,Kt.image=yt=>typeof yt=="string"?jt(R.$_k(yt).href):"",(0,y.marked)(ot.value,{renderer:Kt}),ot}Ee.from=K;function Ae(Ue,ot){if(!Ue)return Ue;let dt;try{dt=(0,o.$ci)(Ue)}catch{}if(!dt)return Ue;let jt=!1;return dt=(0,v.$go)(dt,Kt=>{if(m.URI.isUri(Kt)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[yt]=Kt,jt=!0,yt}else return}),jt?JSON.stringify(dt):Ue}function Me(Ue){const ot=new I.$YN(Ue.value,Ue.supportThemeIcons);return ot.isTrusted=Ue.isTrusted,ot.supportHtml=Ue.supportHtml,ot.baseUri=Ue.baseUri?m.URI.from(Ue.baseUri):void 0,ot}Ee.to=Me;function Je(Ue){if(Ue)return typeof Ue=="string"?Ue:Ee.from(Ue)}Ee.fromStrict=Je})(pe||(e.MarkdownString=pe={}));function H(Ee){return le(Ee)?Ee.map(Te=>({range:Y.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?pe.fromMany(Te.hoverMessage):Te.hoverMessage?pe.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Ee.map(Te=>({range:Y.from(Te)}))}function ce(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?m.URI.file(Ee):Ee}var x;(function(Ee){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?ce(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ee.from=Te})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var U;(function(Ee){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ce(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?x.from(ge.before):void 0,after:ge.after?x.from(ge.after):void 0}}Ee.from=Te})(U||(e.ThemableDecorationRenderOptions=U={}));var O;(function(Ee){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case I.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case I.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case I.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case I.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Te})(O||(e.DecorationRangeBehavior=O={}));var Z;(function(Ee){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?O.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?U.from(ge.light):void 0,dark:ge.dark?U.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ce(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?x.from(ge.before):void 0,after:ge.after?x.from(ge.after):void 0}}Ee.from=Te})(Z||(e.DecorationRenderOptions=Z={}));var V;(function(Ee){function Te(K){return{text:K.newText,eol:K.newEol&&Ce.from(K.newEol),range:Y.from(K.range)}}Ee.from=Te;function ge(K){const Ae=new I.$DN(Y.to(K.range),K.text);return Ae.newEol=typeof K.eol>"u"?void 0:Ce.to(K.eol),Ae}Ee.to=ge})(V||(e.TextEdit=V={}));var M;(function(Ee){function Te(K,Ae){const Me={edits:[]};if(K instanceof I.$GN){const Je=new A.$Ec;for(const Ue of K._allEntries())Ue._type===I.FileEditType.File&&m.URI.isUri(Ue.to)&&Ue.from===void 0&&Je.add(Ue.to);for(const Ue of K._allEntries())if(Ue._type===I.FileEditType.File){let ot;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?ot={type:"base64",value:(0,r.$0e)(r.$Pe.wrap(Ue.options.contents))}:ot={type:"dataTransferItem",id:Ue.options.contents._itemId}),Me.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:ot},metadata:Ue.metadata})}else Ue._type===I.FileEditType.Text?Me.edits.push({resource:Ue.uri,textEdit:V.from(Ue.edit),versionId:Je.has(Ue.uri)?void 0:Ae?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===I.FileEditType.Snippet?Me.edits.push({resource:Ue.uri,textEdit:{range:Y.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Je.has(Ue.uri)?void 0:Ae?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===I.FileEditType.Cell?Me.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===I.FileEditType.CellReplace&&Me.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:P.CellEditType.Replace,index:Ue.index,count:Ue.count,cells:Ue.cells.map(ft.from)}})}return Me}Ee.from=Te;function ge(K){const Ae=new I.$GN,Me=new A.$Dc;for(const Je of K.edits)if(Je.textEdit){const Ue=Je,ot=m.URI.revive(Ue.resource),dt=Y.to(Ue.textEdit.range),jt=Ue.textEdit.text,Kt=Ue.textEdit.insertAsSnippet;let yt;Kt?yt=I.$FN.replace(dt,new I.$HN(jt)):yt=I.$DN.replace(dt,jt);const Xt=Me.get(ot);Xt?Xt.push(yt):Me.set(ot,[yt])}else Ae.renameFile(m.URI.revive(Je.oldResource),m.URI.revive(Je.newResource),Je.options);for(const[Je,Ue]of Me)Ae.set(Je,Ue);return Ae}Ee.to=ge})(M||(e.WorkspaceEdit=M={}));var G;(function(Ee){const Te=Object.create(null);Te[I.SymbolKind.File]=p.SymbolKind.File,Te[I.SymbolKind.Module]=p.SymbolKind.Module,Te[I.SymbolKind.Namespace]=p.SymbolKind.Namespace,Te[I.SymbolKind.Package]=p.SymbolKind.Package,Te[I.SymbolKind.Class]=p.SymbolKind.Class,Te[I.SymbolKind.Method]=p.SymbolKind.Method,Te[I.SymbolKind.Property]=p.SymbolKind.Property,Te[I.SymbolKind.Field]=p.SymbolKind.Field,Te[I.SymbolKind.Constructor]=p.SymbolKind.Constructor,Te[I.SymbolKind.Enum]=p.SymbolKind.Enum,Te[I.SymbolKind.Interface]=p.SymbolKind.Interface,Te[I.SymbolKind.Function]=p.SymbolKind.Function,Te[I.SymbolKind.Variable]=p.SymbolKind.Variable,Te[I.SymbolKind.Constant]=p.SymbolKind.Constant,Te[I.SymbolKind.String]=p.SymbolKind.String,Te[I.SymbolKind.Number]=p.SymbolKind.Number,Te[I.SymbolKind.Boolean]=p.SymbolKind.Boolean,Te[I.SymbolKind.Array]=p.SymbolKind.Array,Te[I.SymbolKind.Object]=p.SymbolKind.Object,Te[I.SymbolKind.Key]=p.SymbolKind.Key,Te[I.SymbolKind.Null]=p.SymbolKind.Null,Te[I.SymbolKind.EnumMember]=p.SymbolKind.EnumMember,Te[I.SymbolKind.Struct]=p.SymbolKind.Struct,Te[I.SymbolKind.Event]=p.SymbolKind.Event,Te[I.SymbolKind.Operator]=p.SymbolKind.Operator,Te[I.SymbolKind.TypeParameter]=p.SymbolKind.TypeParameter;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:p.SymbolKind.Property}Ee.from=ge;function K(Ae){for(const Me in Te)if(Te[Me]===Ae)return Number(Me);return I.SymbolKind.Property}Ee.to=K})(G||(e.SymbolKind=G={}));var X;(function(Ee){function Te(K){switch(K){case I.SymbolTag.Deprecated:return p.SymbolTag.Deprecated}}Ee.from=Te;function ge(K){switch(K){case p.SymbolTag.Deprecated:return I.SymbolTag.Deprecated}}Ee.to=ge})(X||(e.SymbolTag=X={}));var F;(function(Ee){function Te(K){return{name:K.name,kind:G.from(K.kind),tags:K.tags&&K.tags.map(X.from),containerName:K.containerName,location:Ne.from(K.location)}}Ee.from=Te;function ge(K){const Ae=new I.$PN(K.name,G.to(K.kind),K.containerName,Ne.to(K.location));return Ae.tags=K.tags&&K.tags.map(X.to),Ae}Ee.to=ge})(F||(e.WorkspaceSymbol=F={}));var W;(function(Ee){function Te(K){const Ae={name:K.name||"!!MISSING: name!!",detail:K.detail,range:Y.from(K.range),selectionRange:Y.from(K.selectionRange),kind:G.from(K.kind),tags:K.tags?.map(X.from)??[]};return K.children&&(Ae.children=K.children.map(Te)),Ae}Ee.from=Te;function ge(K){const Ae=new I.$QN(K.name,K.detail,G.to(K.kind),Y.to(K.range),Y.to(K.selectionRange));return(0,n.$Ob)(K.tags)&&(Ae.tags=K.tags.map(X.to)),K.children&&(Ae.children=K.children.map(ge)),Ae}Ee.to=ge})(W||(e.DocumentSymbol=W={}));var oe;(function(Ee){function Te(K){const Ae=new I.$UN(G.to(K.kind),K.name,K.detail||"",m.URI.revive(K.uri),Y.to(K.range),Y.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}Ee.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:K.name,detail:K.detail,kind:G.from(K.kind),uri:K.uri,range:Y.from(K.range),selectionRange:Y.from(K.selectionRange),tags:K.tags?.map(X.from)}}Ee.from=ge})(oe||(e.CallHierarchyItem=oe={}));var he;(function(Ee){function Te(ge){return new I.$VN(oe.to(ge.from),ge.fromRanges.map(K=>Y.to(K)))}Ee.to=Te})(he||(e.CallHierarchyIncomingCall=he={}));var ke;(function(Ee){function Te(ge){return new I.$WN(oe.to(ge.to),ge.fromRanges.map(K=>Y.to(K)))}Ee.to=Te})(ke||(e.CallHierarchyOutgoingCall=ke={}));var Ne;(function(Ee){function Te(K){return{range:K.range&&Y.from(K.range),uri:K.uri}}Ee.from=Te;function ge(K){return new I.$IN(m.URI.revive(K.uri),Y.to(K.range))}Ee.to=ge})(Ne||(e.location=Ne={}));var me;(function(Ee){function Te(K){const Ae=K,Me=K;return{originSelectionRange:Ae.originSelectionRange?Y.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:Y.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?Y.from(Ae.targetSelectionRange):void 0}}Ee.from=Te;function ge(K){return{targetUri:m.URI.revive(K.uri),targetRange:Y.to(K.range),targetSelectionRange:K.targetSelectionRange?Y.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?Y.to(K.originSelectionRange):void 0}}Ee.to=ge})(me||(e.DefinitionLink=me={}));var $e;(function(Ee){function Te(K){return{range:Y.from(K.range),contents:pe.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}Ee.from=Te;function ge(K){const Ae=K.contents.map(pe.to),Me=Y.to(K.range),Je=K.canIncreaseVerbosity,Ue=K.canDecreaseVerbosity;return new I.$MN(Ae,Me,Je,Ue)}Ee.to=ge})($e||(e.Hover=$e={}));var Pe;(function(Ee){function Te(K){return{range:Y.from(K.range),expression:K.expression}}Ee.from=Te;function ge(K){return new I.$HO(Y.to(K.range),K.expression)}Ee.to=ge})(Pe||(e.EvaluatableExpression=Pe={}));var Oe;(function(Ee){function Te(K){if(K instanceof I.$IO)return{type:"text",range:Y.from(K.range),text:K.text};if(K instanceof I.$JO)return{type:"variable",range:Y.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof I.$KO)return{type:"expression",range:Y.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Te;function ge(K){switch(K.type){case"text":return{range:Y.to(K.range),text:K.text};case"variable":return{range:Y.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:Y.to(K.range),expression:K.expression}}}Ee.to=ge})(Oe||(e.InlineValue=Oe={}));var fe;(function(Ee){function Te(K){return{frameId:K.frameId,stoppedLocation:Y.from(K.stoppedLocation)}}Ee.from=Te;function ge(K){return new I.$LO(K.frameId,Y.to(K.stoppedLocation))}Ee.to=ge})(fe||(e.InlineValueContext=fe={}));var De;(function(Ee){function Te(K){return{range:Y.from(K.range),kind:K.kind}}Ee.from=Te;function ge(K){return new I.$NN(Y.to(K.range),K.kind)}Ee.to=ge})(De||(e.DocumentHighlight=De={}));var Re;(function(Ee){function Te(K){return{uri:K.uri,highlights:K.highlights.map(De.from)}}Ee.from=Te;function ge(K){return new I.$ON(m.URI.revive(K.uri),K.highlights.map(De.to))}Ee.to=ge})(Re||(e.MultiDocumentHighlight=Re={}));var ze;(function(Ee){function Te(ge){switch(ge){case p.CompletionTriggerKind.TriggerCharacter:return I.CompletionTriggerKind.TriggerCharacter;case p.CompletionTriggerKind.TriggerForIncompleteCompletions:return I.CompletionTriggerKind.TriggerForIncompleteCompletions;case p.CompletionTriggerKind.Invoke:default:return I.CompletionTriggerKind.Invoke}}Ee.to=Te})(ze||(e.CompletionTriggerKind=ze={}));var We;(function(Ee){function Te(ge){return{triggerKind:ze.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ee.to=Te})(We||(e.CompletionContext=We={}));var Qe;(function(Ee){function Te(K){switch(K){case I.CompletionItemTag.Deprecated:return p.CompletionItemTag.Deprecated}}Ee.from=Te;function ge(K){switch(K){case p.CompletionItemTag.Deprecated:return I.CompletionItemTag.Deprecated}}Ee.to=ge})(Qe||(e.CompletionItemTag=Qe={}));var Ke;(function(Ee){const Te=new Map([[I.CompletionItemKind.Method,p.CompletionItemKind.Method],[I.CompletionItemKind.Function,p.CompletionItemKind.Function],[I.CompletionItemKind.Constructor,p.CompletionItemKind.Constructor],[I.CompletionItemKind.Field,p.CompletionItemKind.Field],[I.CompletionItemKind.Variable,p.CompletionItemKind.Variable],[I.CompletionItemKind.Class,p.CompletionItemKind.Class],[I.CompletionItemKind.Interface,p.CompletionItemKind.Interface],[I.CompletionItemKind.Struct,p.CompletionItemKind.Struct],[I.CompletionItemKind.Module,p.CompletionItemKind.Module],[I.CompletionItemKind.Property,p.CompletionItemKind.Property],[I.CompletionItemKind.Unit,p.CompletionItemKind.Unit],[I.CompletionItemKind.Value,p.CompletionItemKind.Value],[I.CompletionItemKind.Constant,p.CompletionItemKind.Constant],[I.CompletionItemKind.Enum,p.CompletionItemKind.Enum],[I.CompletionItemKind.EnumMember,p.CompletionItemKind.EnumMember],[I.CompletionItemKind.Keyword,p.CompletionItemKind.Keyword],[I.CompletionItemKind.Snippet,p.CompletionItemKind.Snippet],[I.CompletionItemKind.Text,p.CompletionItemKind.Text],[I.CompletionItemKind.Color,p.CompletionItemKind.Color],[I.CompletionItemKind.File,p.CompletionItemKind.File],[I.CompletionItemKind.Reference,p.CompletionItemKind.Reference],[I.CompletionItemKind.Folder,p.CompletionItemKind.Folder],[I.CompletionItemKind.Event,p.CompletionItemKind.Event],[I.CompletionItemKind.Operator,p.CompletionItemKind.Operator],[I.CompletionItemKind.TypeParameter,p.CompletionItemKind.TypeParameter],[I.CompletionItemKind.Issue,p.CompletionItemKind.Issue],[I.CompletionItemKind.User,p.CompletionItemKind.User]]);function ge(Me){return Te.get(Me)??p.CompletionItemKind.Property}Ee.from=ge;const K=new Map([[p.CompletionItemKind.Method,I.CompletionItemKind.Method],[p.CompletionItemKind.Function,I.CompletionItemKind.Function],[p.CompletionItemKind.Constructor,I.CompletionItemKind.Constructor],[p.CompletionItemKind.Field,I.CompletionItemKind.Field],[p.CompletionItemKind.Variable,I.CompletionItemKind.Variable],[p.CompletionItemKind.Class,I.CompletionItemKind.Class],[p.CompletionItemKind.Interface,I.CompletionItemKind.Interface],[p.CompletionItemKind.Struct,I.CompletionItemKind.Struct],[p.CompletionItemKind.Module,I.CompletionItemKind.Module],[p.CompletionItemKind.Property,I.CompletionItemKind.Property],[p.CompletionItemKind.Unit,I.CompletionItemKind.Unit],[p.CompletionItemKind.Value,I.CompletionItemKind.Value],[p.CompletionItemKind.Constant,I.CompletionItemKind.Constant],[p.CompletionItemKind.Enum,I.CompletionItemKind.Enum],[p.CompletionItemKind.EnumMember,I.CompletionItemKind.EnumMember],[p.CompletionItemKind.Keyword,I.CompletionItemKind.Keyword],[p.CompletionItemKind.Snippet,I.CompletionItemKind.Snippet],[p.CompletionItemKind.Text,I.CompletionItemKind.Text],[p.CompletionItemKind.Color,I.CompletionItemKind.Color],[p.CompletionItemKind.File,I.CompletionItemKind.File],[p.CompletionItemKind.Reference,I.CompletionItemKind.Reference],[p.CompletionItemKind.Folder,I.CompletionItemKind.Folder],[p.CompletionItemKind.Event,I.CompletionItemKind.Event],[p.CompletionItemKind.Operator,I.CompletionItemKind.Operator],[p.CompletionItemKind.TypeParameter,I.CompletionItemKind.TypeParameter],[p.CompletionItemKind.User,I.CompletionItemKind.User],[p.CompletionItemKind.Issue,I.CompletionItemKind.Issue]]);function Ae(Me){return K.get(Me)??I.CompletionItemKind.Property}Ee.to=Ae})(Ke||(e.CompletionItemKind=Ke={}));var Ge;(function(Ee){function Te(ge,K){const Ae=new I.$5N(ge.label);return Ae.insertText=ge.insertText,Ae.kind=Ke.to(ge.kind),Ae.tags=ge.tags?.map(Qe.to),Ae.detail=ge.detail,Ae.documentation=R.$6k(ge.documentation)?pe.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,b.$Mt.isIRange(ge.range)?Ae.range=Y.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:Y.to(ge.range.insert),replacing:Y.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&p.CompletionItemInsertTextRule.KeepWhitespace),typeof ge.insertTextRules<"u"&&ge.insertTextRules&p.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new I.$HN(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof I.$yN?new I.$DN(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>V.to(Me))),Ae.command=K&&ge.command?K.fromInternal(ge.command):void 0,Ae}Ee.to=Te})(Ge||(e.CompletionItem=Ge={}));var xe;(function(Ee){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:pe.fromStrict(K.documentation)}}Ee.from=Te;function ge(K){return{label:K.label,documentation:R.$6k(K.documentation)?pe.to(K.documentation):K.documentation}}Ee.to=ge})(xe||(e.ParameterInformation=xe={}));var st;(function(Ee){function Te(K){return{label:K.label,documentation:pe.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(xe.from):[],activeParameter:K.activeParameter}}Ee.from=Te;function ge(K){return{label:K.label,documentation:R.$6k(K.documentation)?pe.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(xe.to):[],activeParameter:K.activeParameter}}Ee.to=ge})(st||(e.SignatureInformation=st={}));var lt;(function(Ee){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(st.from):[]}}Ee.from=Te;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(st.to):[]}}Ee.to=ge})(lt||(e.SignatureHelp=lt={}));var rt;(function(Ee){function Te(ge,K){const Ae=new I.$4N(te.to(K.position),typeof K.label=="string"?K.label:K.label.map(nt.to.bind(void 0,ge)),K.kind&&tt.to(K.kind));return Ae.textEdits=K.textEdits&&K.textEdits.map(V.to),Ae.tooltip=R.$6k(K.tooltip)?pe.to(K.tooltip):K.tooltip,Ae.paddingLeft=K.paddingLeft,Ae.paddingRight=K.paddingRight,Ae}Ee.to=Te})(rt||(e.InlayHint=rt={}));var nt;(function(Ee){function Te(ge,K){const Ae=new I.$3N(K.label);return Ae.tooltip=R.$6k(K.tooltip)?pe.to(K.tooltip):K.tooltip,p.Command.is(K.command)&&(Ae.command=ge.fromInternal(K.command)),K.location&&(Ae.location=Ne.to(K.location)),Ae}Ee.to=Te})(nt||(e.InlayHintLabelPart=nt={}));var tt;(function(Ee){function Te(K){return K}Ee.from=Te;function ge(K){return K}Ee.to=ge})(tt||(e.InlayHintKind=tt={}));var et;(function(Ee){function Te(K){return{range:Y.from(K.range),url:K.target,tooltip:K.tooltip}}Ee.from=Te;function ge(K){let Ae;if(K.url)try{Ae=typeof K.url=="string"?m.URI.parse(K.url,!0):m.URI.revive(K.url)}catch{}const Me=new I.$0N(Y.to(K.range),Ae);return Me.tooltip=K.tooltip,Me}Ee.to=ge})(et||(e.DocumentLink=et={}));var Ze;(function(Ee){function Te(K){const Ae=new I.$aO(K.label);return K.textEdit&&(Ae.textEdit=V.to(K.textEdit)),K.additionalTextEdits&&(Ae.additionalTextEdits=K.additionalTextEdits.map(Me=>V.to(Me))),Ae}Ee.to=Te;function ge(K){return{label:K.label,textEdit:K.textEdit?V.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ae=>V.from(Ae)):void 0}}Ee.from=ge})(Ze||(e.ColorPresentation=Ze={}));var be;(function(Ee){function Te(K){return new I.$$N(K[0],K[1],K[2],K[3])}Ee.to=Te;function ge(K){return[K.red,K.green,K.blue,K.alpha]}Ee.from=ge})(be||(e.Color=be={}));var Le;(function(Ee){function Te(K){return{range:Y.from(K.range)}}Ee.from=Te;function ge(K){return new I.$TN(Y.to(K.range))}Ee.to=ge})(Le||(e.SelectionRange=Le={}));var Fe;(function(Ee){function Te(ge){switch(ge){case s.SaveReason.AUTO:return I.TextDocumentSaveReason.AfterDelay;case s.SaveReason.EXPLICIT:return I.TextDocumentSaveReason.Manual;case s.SaveReason.FOCUS_CHANGE:case s.SaveReason.WINDOW_CHANGE:return I.TextDocumentSaveReason.FocusOut}}Ee.to=Te})(Fe||(e.TextDocumentSaveReason=Fe={}));var ye;(function(Ee){function Te(K){switch(K){case I.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case I.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case I.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case I.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}Ee.from=Te;function ge(K){switch(K){case $.RenderLineNumbersType.Off:return I.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return I.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return I.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return I.TextEditorLineNumbersStyle.On}}Ee.to=ge})(ye||(e.TextEditorLineNumbersStyle=ye={}));var Ce;(function(Ee){function Te(K){if(K===I.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===I.EndOfLine.LF)return t.EndOfLineSequence.LF}Ee.from=Te;function ge(K){if(K===t.EndOfLineSequence.CRLF)return I.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return I.EndOfLine.LF}Ee.to=ge})(Ce||(e.EndOfLine=Ce={}));var ne;(function(Ee){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case I.ProgressLocation.SourceControl:return i.ProgressLocation.Scm;case I.ProgressLocation.Window:return i.ProgressLocation.Window;case I.ProgressLocation.Notification:return i.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Te})(ne||(e.ProgressLocation=ne={}));var ee;(function(Ee){function Te(K){const Ae={start:K.start+1,end:K.end+1};return K.kind&&(Ae.kind=we.from(K.kind)),Ae}Ee.from=Te;function ge(K){const Ae={start:K.start-1,end:K.end-1};return K.kind&&(Ae.kind=we.to(K.kind)),Ae}Ee.to=ge})(ee||(e.FoldingRange=ee={}));var we;(function(Ee){function Te(K){if(K)switch(K){case I.FoldingRangeKind.Comment:return p.$Mu.Comment;case I.FoldingRangeKind.Imports:return p.$Mu.Imports;case I.FoldingRangeKind.Region:return p.$Mu.Region}}Ee.from=Te;function ge(K){if(K)switch(K.value){case p.$Mu.Comment.value:return I.FoldingRangeKind.Comment;case p.$Mu.Imports.value:return I.FoldingRangeKind.Imports;case p.$Mu.Region.value:return I.FoldingRangeKind.Region}}Ee.to=ge})(we||(e.FoldingRangeKind=we={}));var He;(function(Ee){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?Y.from(ge.selection):void 0,override:typeof ge.override=="boolean"?s.$SF.id:void 0}}Ee.from=Te})(He||(e.TextEditorOpenOptions=He={}));var Xe;(function(Ee){function Te(Me){return Me instanceof I.$vO?Me.toJSON():typeof Me=="string"?Me:ge(Me)||K(Me)?new I.$vO(Me.baseUri??Me.base,Me.pattern).toJSON():Me}Ee.from=Te;function ge(Me){const Je=Me;return Je?m.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function K(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new I.$vO(m.URI.revive(Me.baseUri),Me.pattern)}Ee.to=Ae})(Xe||(e.GlobPattern=Xe={}));var _e;(function(Ee){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:Xe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ee.from=Te})(_e||(e.LanguageSelector=_e={}));var it;(function(Ee){function Te(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Me=>Me&&typeof Me=="object"&&"uri"in Me&&m.URI.isUri(Me.uri)&&"version"in Me&&typeof Me.version=="number"&&"ranges"in Me&&Array.isArray(Me.ranges)&&Me.ranges.every(Je=>Je instanceof I.$yN)))}Ee.is=Te;function ge(K){return{documents:K.documents.map(Ae=>Ae.map(Me=>({uri:m.URI.from(Me.uri),version:Me.version,ranges:Me.ranges.map(Je=>Y.from(Je))})))}}Ee.from=ge})(it||(e.MappedEditsContext=it={}));var ut;(function(Ee){function Te(K){return{start:K.start,end:K.end}}Ee.from=Te;function ge(K){return new I.$YO(K.start,K.end)}Ee.to=ge})(ut||(e.NotebookRange=ut={}));var gt;(function(Ee){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ee.to=Te;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ee.from=ge})(gt||(e.NotebookCellExecutionSummary=gt={}));var bt;(function(Ee){function Te(ge){if(ge===P.NotebookCellExecutionState.Unconfirmed)return I.NotebookCellExecutionState.Pending;if(ge===P.NotebookCellExecutionState.Pending)return;if(ge===P.NotebookCellExecutionState.Executing)return I.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ee.to=Te})(bt||(e.NotebookCellExecutionState=bt={}));var Mt;(function(Ee){function Te(K){switch(K){case I.NotebookCellKind.Markup:return P.CellKind.Markup;case I.NotebookCellKind.Code:default:return P.CellKind.Code}}Ee.from=Te;function ge(K){switch(K){case P.CellKind.Markup:return I.NotebookCellKind.Markup;case P.CellKind.Code:default:return I.NotebookCellKind.Code}}Ee.to=ge})(Mt||(e.NotebookCellKind=Mt={}));var At;(function(Ee){function Te(K){const Ae={metadata:K.metadata??Object.create(null),cells:[]};for(const Me of K.cells)I.$ZO.validate(Me),Ae.cells.push(ft.from(Me));return Ae}Ee.from=Te;function ge(K){const Ae=new I.$1O(K.cells.map(ft.to));return(0,f.$tg)(K.metadata)||(Ae.metadata=K.metadata),Ae}Ee.to=ge})(At||(e.NotebookData=At={}));var ft;(function(Ee){function Te(K){return{cellKind:Mt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:gt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Et.from):[]}}Ee.from=Te;function ge(K){return new I.$ZO(Mt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Et.to):void 0,K.metadata,K.internalMetadata?gt.to(K.internalMetadata):void 0)}Ee.to=ge})(ft||(e.NotebookCellData=ft={}));var wt;(function(Ee){function Te(K){return{mime:K.mime,valueBytes:r.$Pe.wrap(K.data)}}Ee.from=Te;function ge(K){return new I.$2O(K.valueBytes.buffer,K.mime)}Ee.to=ge})(wt||(e.NotebookCellOutputItem=wt={}));var Et;(function(Ee){function Te(K){return{outputId:K.id,items:K.items.map(wt.from),metadata:K.metadata}}Ee.from=Te;function ge(K){const Ae=K.items.map(wt.to);return new I.$3O(Ae,K.outputId,K.metadata)}Ee.to=ge})(Et||(e.NotebookCellOutput=Et={}));var kt;(function(Ee){function Te(Ae){return K(Ae)?{include:Xe.from(Ae.include)??void 0,exclude:Xe.from(Ae.exclude)??void 0}:Xe.from(Ae)??void 0}Ee.from=Te;function ge(Ae){return K(Ae)?{include:Xe.to(Ae.include),exclude:Xe.to(Ae.exclude)}:Xe.to(Ae)}Ee.to=ge;function K(Ae){const Me=Ae;return Me?!(0,f.$pg)(Me.include)&&!(0,f.$pg)(Me.exclude):!1}})(kt||(e.NotebookExclusiveDocumentPattern=kt={}));var Jt;(function(Ee){function Te(ge,K,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===I.NotebookCellStatusBarAlignment.Left?P.CellStatusbarAlignment.Left:P.CellStatusbarAlignment.Right,command:K.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ee.from=Te})(Jt||(e.NotebookStatusBarItem=Jt={}));var Ot;(function(Ee){function Te(ge,K,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:K.toInternal(Me,Ae),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ee.from=Te})(Ot||(e.NotebookKernelSourceAction=Ot={}));var ht;(function(Ee){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ee.from=Te})(ht||(e.NotebookDocumentContentOptions=ht={}));var pt;(function(Ee){function Te(K){return{uri:K.uri,provides:K.provides}}Ee.from=Te;function ge(K){return new I.$5O(m.URI.revive(K.uri),K.provides)}Ee.to=ge})(pt||(e.NotebookRendererScript=pt={}));var vt;(function(Ee){function Te(K){return{message:pe.fromStrict(K.message)||"",type:L.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:Y.from(K.location.range),uri:K.location.uri}}}Ee.from=Te;function ge(K){const Ae=new I.$$O(typeof K.message=="string"?K.message:pe.to(K.message));return Ae.actualOutput=K.actual,Ae.expectedOutput=K.expected,Ae.contextValue=K.contextValue,Ae.location=K.location?Ne.to(K.location):void 0,Ae}Ee.to=ge})(vt||(e.TestMessage=vt={}));var It;(function(Ee){Ee.namespace=L.$YI,Ee.denamespace=L.$ZI})(It||(e.TestTag=It={}));var zt;(function(Ee){function Te(K){const Ae=(0,g.$WP)(K).controllerId;return{extId:C.$TI.fromExtHostTestItem(K,Ae).toString(),label:K.label,uri:m.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Me=>It.namespace(Ae,Me.id)),range:b.$Mt.lift(Y.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&pe.fromStrict(K.error)||null}}Ee.from=Te;function ge(K){return{parent:void 0,error:void 0,id:C.$TI.fromString(K.extId).localId,label:K.label,uri:m.URI.revive(K.uri),tags:(K.tags||[]).map(Ae=>{const{tagId:Me}=It.denamespace(Ae);return new I.$_O(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:Y.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ee.toPlain=ge})(zt||(e.TestItem=zt={})),function(Ee){function Te(K){return{id:K.id}}Ee.from=Te;function ge(K){return new I.$_O(K.id)}Ee.to=ge}(It||(e.TestTag=It={}));var Ct;(function(Ee){const Te=(K,Ae)=>{const Me=K.value;if(!Me)return;const Je={...zt.toPlain(Me.item),parent:Ae,taskStates:Me.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(ot=>ot.type===L.TestMessageType.Error).map(vt.to)})),children:[]};if(K.children)for(const Ue of K.children.values()){const ot=Te(Ue,Je);ot&&Je.children.push(ot)}return Je};function ge(K){const Ae=new h.$SI;for(const Ue of K.items)Ae.insert(C.$TI.fromString(Ue.item.extId).path,Ue);const Me=[Ae.nodes],Je=[];for(;Me.length;)for(const Ue of Me.pop())Ue.value?Je.push(Ue):Ue.children&&Me.push(Ue.children.values());return{completedAt:K.completedAt,results:Je.map(Ue=>Te(Ue)).filter(f.$og)}}Ee.to=ge})(Ct||(e.TestResults=Ct={}));var _t;(function(Ee){function Te(Me){return{covered:Me.covered,total:Me.total}}function ge(Me){return"line"in Me?te.from(Me):Y.from(Me)}function K(Me){if(typeof Me.executed=="number"&&Me.executed<0)throw new Error(`Invalid coverage count ${Me.executed}`);return"branches"in Me?{count:Me.executed,location:ge(Me.location),type:L.DetailType.Statement,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executed,location:Je.location&&ge(Je.location),label:Je.label})):void 0}:{type:L.DetailType.Declaration,name:Me.name,count:Me.executed,location:ge(Me.location)}}Ee.fromDetails=K;function Ae(Me,Je,Ue){return I.$bP(Ue.statementCoverage),I.$bP(Ue.branchCoverage),I.$bP(Ue.declarationCoverage),{id:Je,uri:Ue.uri,statement:Te(Ue.statementCoverage),branch:Ue.branchCoverage&&Te(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Te(Ue.declarationCoverage),testIds:Ue instanceof I.$cP&&Ue.fromTests.length?Ue.fromTests.map(ot=>C.$TI.fromExtHostTestItem(ot,Me).toString()):void 0}}Ee.fromFile=Ae})(_t||(e.TestCoverage=_t={}));var Pt;(function(Ee){function Te(ge){switch(ge){case p.CodeActionTriggerType.Invoke:return I.CodeActionTriggerKind.Invoke;case p.CodeActionTriggerType.Auto:return I.CodeActionTriggerKind.Automatic}}Ee.to=Te})(Pt||(e.CodeActionTriggerKind=Pt={}));var Lt;(function(Ee){function Te(K){const Ae=new I.$gP(G.to(K.kind),K.name,K.detail||"",m.URI.revive(K.uri),Y.to(K.range),Y.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}Ee.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:G.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:Y.from(K.range),selectionRange:Y.from(K.selectionRange),tags:K.tags?.map(X.from)}}Ee.from=ge})(Lt||(e.TypeHierarchyItem=Lt={}));var Bt;(function(Ee){function Te(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ee.from=Te})(Bt||(e.ViewBadge=Bt={}));var Nt;(function(Ee){function Te(Me,Je,Ue){const ot=Je.fileData;return ot?new I.$nO(new I.$oO(ot.name,m.URI.revive(ot.uri),ot.id,(0,k.$gb)(()=>Ue(ot.id)))):Me===D.$9s.uriList&&Je.uriListData?new I.$mO(Ae(Je.uriListData)):new I.$mO(Je.asString)}Ee.to=Te;async function ge(Me,Je){const Ue=await Je.asString();if(Me===D.$9s.uriList)return{asString:Ue,fileData:void 0,uriListData:K(Ue)};const ot=Je.asFile();return{asString:Ue,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Ee.from=ge;function K(Me){return E.$qu.split(Me).map(Je=>{if(Je.startsWith("#"))return Je;try{return m.URI.parse(Je)}catch{}return Je})}function Ae(Me){return E.$qu.create(Me.map(Je=>typeof Je=="string"?Je:m.URI.revive(Je)))}})(Nt||(e.DataTransferItem=Nt={}));var Tt;(function(Ee){function Te(K,Ae){const Me=K.items.map(([Je,Ue])=>[Je,Nt.to(Je,Ue,Ae)]);return new I.$pO(Me)}Ee.toDataTransfer=Te;async function ge(K){const Ae={items:[]},Me=[];for(const[Je,Ue]of K)Me.push((async()=>{Ae.items.push([Je,await Nt.from(Je,Ue)])})());return await Promise.all(Me),Ae}Ee.from=ge})(Tt||(e.DataTransfer=Tt={}));var St;(function(Ee){function Te(K,Ae){return{kind:"reply",agentId:K.participant??Ae?.agentId??"",subCommand:K.command??Ae?.command,message:K.prompt,title:K.label}}Ee.from=Te;function ge(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}Ee.to=ge})(St||(e.ChatFollowup=St={}));var Ut;(function(Ee){function Te(K){switch(K){case u.ChatMessageRole.System:return I.LanguageModelChatMessageRole.System;case u.ChatMessageRole.User:return I.LanguageModelChatMessageRole.User;case u.ChatMessageRole.Assistant:return I.LanguageModelChatMessageRole.Assistant}}Ee.to=Te;function ge(K){switch(K){case I.LanguageModelChatMessageRole.System:return u.ChatMessageRole.System;case I.LanguageModelChatMessageRole.User:return u.ChatMessageRole.User;case I.LanguageModelChatMessageRole.Assistant:return u.ChatMessageRole.Assistant}return u.ChatMessageRole.User}Ee.from=ge})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var qt;(function(Ee){function Te(K){let Ae="",Me;K.content.type==="text"?Ae=K.content.value:Me=new I.$HP(K.content.name,K.content.value,K.content.isError);const Je=Ut.to(K.role),Ue=new I.$IP(Je,Ae,K.name);return Me!==void 0&&(Ue.content2=Me),Ue}Ee.to=Te;function ge(K){const Ae=Ut.from(K.role),Me=K.name;let Je;return K.content2 instanceof I.$HP?Je={type:"function_result",name:K.content2.name,value:K.content2.content,isError:K.content2.isError}:Je={type:"text",value:K.content},{role:Ae,name:Me,content:Je}}Ee.from=ge})(qt||(e.LanguageModelChatMessage=qt={}));var Ht;(function(Ee){function Te(K){return{kind:"markdownContent",content:pe.from(K.value)}}Ee.from=Te;function ge(K){return new I.$tP(pe.to(K.content))}Ee.to=ge})(Ht||(e.ChatResponseMarkdownPart=Ht={}));var Wt;(function(Ee){function Te(K){return{kind:"markdownVuln",content:pe.from(K.value),vulnerabilities:K.vulnerabilities}}Ee.from=Te;function ge(K){return new I.$uP(pe.to(K.content),K.vulnerabilities)}Ee.to=ge})(Wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Wt={}));var Qt;(function(Ee){function Te(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}Ee.from=Te;function ge(K){return new I.$vP(K.agentId,K.command)}Ee.to=ge})(Qt||(e.ChatResponseDetectedParticipantPart=Qt={}));var en;(function(Ee){function Te(ge){return{kind:"confirmation",title:ge.title,message:ge.message,data:ge.data}}Ee.from=Te})(en||(e.ChatResponseConfirmationPart=en={}));var Vt;(function(Ee){function Te(K){const{value:Ae,baseUri:Me}=K;function Je(Ue,ot){return Ue.map(dt=>{const jt=m.URI.joinPath(ot,dt.name);return{label:dt.name,uri:jt,children:dt.children&&Je(dt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,w.$eh)(Me),uri:Me,children:Je(Ae,Me)}}}Ee.from=Te;function ge(K){const Ae=(0,o.$di)(K.treeData);function Me(ot){return ot.map(dt=>({name:dt.label,children:dt.children&&Me(dt.children)}))}const Je=Ae.uri,Ue=Ae.children?Me(Ae.children):[];return new I.$xP(Ue,Je)}Ee.to=ge})(Vt||(e.ChatResponseFilesPart=Vt={}));var Dt;(function(Ee){function Te(K){const Ae=Me=>m.URI.isUri(Me);return{kind:"inlineReference",name:K.title,inlineReference:Ae(K.value)?K.value:Q.from(K.value)}}Ee.from=Te;function ge(K){const Ae=(0,o.$di)(K);return new I.$yP(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:Q.to(Ae.inlineReference),K.name)}Ee.to=ge})(Dt||(e.ChatResponseAnchorPart=Dt={}));var Ft;(function(Ee){function Te(K){return{kind:"progressMessage",content:pe.from(K.value)}}Ee.from=Te;function ge(K){return new I.$zP(K.content.value)}Ee.to=ge})(Ft||(e.ChatResponseProgressPart=Ft={}));var $t;(function(Ee){function Te(K){return{kind:"warning",content:pe.from(K.value)}}Ee.from=Te;function ge(K){return new I.$BP(K.content.value)}Ee.to=ge})($t||(e.ChatResponseWarningPart=$t={}));var Yt;(function(Ee){function Te(ge){return{kind:"progressTask",content:pe.from(ge.value)}}Ee.from=Te})(Yt||(e.ChatTask=Yt={}));var Zt;(function(Ee){function Te(ge){return{kind:"progressTaskResult",content:typeof ge=="string"?pe.from(ge):void 0}}Ee.from=Te})(Zt||(e.ChatTaskResult=Zt={}));var an;(function(Ee){function Te(K,Ae,Me){return{kind:"command",command:Ae.toInternal(K.value,Me)??{command:K.value.command,title:K.value.title}}}Ee.from=Te;function ge(K,Ae){return new I.$CP(Ae.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}Ee.to=ge})(an||(e.ChatResponseCommandButtonPart=an={}));var ln;(function(Ee){function Te(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(Ae=>V.from(Ae))}}Ee.from=Te;function ge(K){return new I.$EP(m.URI.revive(K.uri),K.edits.map(Ae=>V.to(Ae)))}Ee.to=ge})(ln||(e.ChatResponseTextEditPart=ln={}));var un;(function(Ee){function Te(K){const Ae=a.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:m.URI.isUri(K.iconPath)?{light:m.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&m.URI.isUri(K.iconPath.light)&&m.URI.isUri(K.iconPath.dark)?{light:m.URI.revive(K.iconPath.light),dark:m.URI.revive(K.iconPath.dark)}:void 0;return"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:m.URI.isUri(K.value.value)||!K.value.value?K.value.value:Q.from(K.value.value)},iconPath:Ae}:{kind:"reference",reference:m.URI.isUri(K.value)?K.value:Q.from(K.value),iconPath:Ae}}Ee.from=Te;function ge(K){const Ae=(0,o.$di)(K),Me=Je=>m.URI.isUri(Je)?Je:Q.to(Je);return new I.$DP("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Me(Ae.reference.value)}:Me(Ae.reference))}Ee.to=ge})(un||(e.ChatResponseReferencePart=un={}));var bn;(function(Ee){function Te(Ae,Me,Je){return Ae instanceof I.$tP?Ht.from(Ae):Ae instanceof I.$yP?Dt.from(Ae):Ae instanceof I.$DP?un.from(Ae):Ae instanceof I.$zP?Ft.from(Ae):Ae instanceof I.$xP?Vt.from(Ae):Ae instanceof I.$CP?an.from(Ae,Me,Je):Ae instanceof I.$EP?ln.from(Ae):Ae instanceof I.$uP?Wt.from(Ae):Ae instanceof I.$vP?Qt.from(Ae):Ae instanceof I.$BP?$t.from(Ae):{kind:"markdownContent",content:pe.from("")}}Ee.from=Te;function ge(Ae,Me){switch(Ae.kind){case"reference":return un.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(Ae,Me)}}Ee.to=ge;function K(Ae,Me){switch(Ae.kind){case"markdownContent":return Ht.to(Ae);case"inlineReference":return Dt.to(Ae);case"progressMessage":return;case"treeData":return Vt.to(Ae);case"command":return an.to(Ae,Me)}}Ee.toContent=K})(bn||(e.ChatResponsePart=bn={}));var nn;(function(Ee){function Te(ge){return{prompt:ge.message,command:ge.command,attempt:ge.attempt??0,enableCommandDetection:ge.enableCommandDetection??!0,references:ge.variables.variables.map(Gt.to),location:wn.to(ge.location),acceptedConfirmationData:ge.acceptedConfirmationData,rejectedConfirmationData:ge.rejectedConfirmationData}}Ee.to=Te})(nn||(e.ChatAgentRequest=nn={}));var wn;(function(Ee){function Te(K){switch(K){case c.ChatAgentLocation.Notebook:return I.ChatLocation.Notebook;case c.ChatAgentLocation.Terminal:return I.ChatLocation.Terminal;case c.ChatAgentLocation.Panel:return I.ChatLocation.Panel;case c.ChatAgentLocation.Editor:return I.ChatLocation.Editor}}Ee.to=Te;function ge(K){switch(K){case I.ChatLocation.Notebook:return c.ChatAgentLocation.Notebook;case I.ChatLocation.Terminal:return c.ChatAgentLocation.Terminal;case I.ChatLocation.Panel:return c.ChatAgentLocation.Panel;case I.ChatLocation.Editor:return c.ChatAgentLocation.Editor}}Ee.from=ge})(wn||(e.ChatLocation=wn={}));var Gt;(function(Ee){function Te(ge){const K=ge.value;if(!K)throw new Error("Invalid value reference");return{id:ge.id,name:ge.name,range:ge.range&&[ge.range.start,ge.range.endExclusive],value:(0,m.$yc)(K)?m.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,m.$yc)(K.uri)?Q.to((0,o.$di)(K)):K,modelDescription:ge.modelDescription}}Ee.to=Te})(Gt||(e.ChatAgentValueReference=Gt={}));var dn;(function(Ee){function Te(ge,K,Ae){return{id:ge.id,label:ge.label,fullName:ge.fullName,icon:ge.icon?.id,value:ge.values[0].value,insertText:ge.insertText,detail:ge.detail,documentation:ge.documentation,command:K.toInternal(ge.command,Ae)}}Ee.from=Te})(dn||(e.ChatAgentCompletionItem=dn={}));var mn;(function(Ee){function Te(ge){return{errorDetails:ge.errorDetails,metadata:ge.metadata}}Ee.to=Te})(mn||(e.ChatAgentResult=mn={}));var gn;(function(Ee){function Te(ge,K,Ae){if(K.action.kind==="vote")return;const Me=mn.to(ge);if(K.action.kind==="command"){const Je=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(Je)??{command:Je.id,title:Je.title}}},result:Me}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:St.to(K.action.followup)},result:Me}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:Me}:{action:K.action,result:Me}}Ee.to=Te})(gn||(e.ChatAgentUserActionEvent=gn={}));var vn;(function(Ee){function Te(ge,K,Ae){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand,shouldExecute:ge.shouldExecute}:"uri"in ge?{uri:ge.uri}:K.toInternal(ge,Ae)}Ee.from=Te})(vn||(e.TerminalQuickFix=vn={}));var Sn;(function(Ee){function Te(ge){return{kind:rn.to(ge.kind)}}Ee.to=Te})(Sn||(e.PartialAcceptInfo=Sn={}));var rn;(function(Ee){function Te(ge){switch(ge){case p.PartialAcceptTriggerKind.Word:return I.PartialAcceptTriggerKind.Word;case p.PartialAcceptTriggerKind.Line:return I.PartialAcceptTriggerKind.Line;case p.PartialAcceptTriggerKind.Suggest:return I.PartialAcceptTriggerKind.Suggest;default:return I.PartialAcceptTriggerKind.Unknown}}Ee.to=Te})(rn||(e.PartialAcceptTriggerKind=rn={}));var $n;(function(Ee){function Te(ge,K){return{id:K,label:ge.label,description:ge.description,canEdit:ge.canEdit,collapsibleState:ge.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ge.contextValue}}Ee.from=Te})($n||(e.DebugTreeItem=$n={}));var pn;(function(Ee){function Te(ge){return{name:ge.name,description:ge.description,parametersSchema:ge.parametersSchema}}Ee.to=Te})(pn||(e.LanguageModelToolDescription=pn={}))}),define(ve[320],Se([1,0,49,148,76,147,103,154,4]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,n=qe(n),A=qe(A);const o=(d,p,t,l)=>{let i=p;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!t(i,g)){const s=i;i=g,d.listener?.(l(g,s))}}}},D=(d,p)=>d===p,v={range:(d,p)=>d===p?!0:!d||!p?!1:d.isEqual(p),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(d,p)=>!(d.length!==p.length||d.some(t=>!p.find(l=>t.id===l.id)))},h=d=>p=>({op:k.TestItemEventOp.SetProp,update:d(p)}),w=(d,p)=>({range:(()=>{let t;const l=h(i=>({range:n.$Mt.lift(A.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return t},set(i){d.listener?.({op:k.TestItemEventOp.DocumentSynced}),v.range(t,i)||(t=i,d.listener?.(l(i)))}}})(),label:o(d,p,v.label,h(t=>({label:t}))),description:o(d,void 0,v.description,h(t=>({description:t}))),sortText:o(d,void 0,v.sortText,h(t=>({sortText:t}))),canResolveChildren:o(d,!1,v.canResolveChildren,t=>({op:k.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(d,!1,v.busy,h(t=>({busy:t}))),error:o(d,void 0,v.error,h(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:o(d,[],v.tags,(t,l)=>({op:k.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:l.map(A.TestTag.from)}))}),a=d=>{const p=E.$TI.fromString(d.extId),t=new m(p.controllerId,p.localId,d.label,y.URI.revive(d.uri)||void 0);return t.range=A.Range.to(d.range||void 0),t.description=d.description||void 0,t.sortText=d.sortText||void 0,t.tags=d.tags.map(l=>A.TestTag.to({id:(0,R.$ZI)(l).tagId})),t},f=d=>{let p;for(const t of d.tests){const l=a(t.item);(0,r.$WP)(l).parent=p,p=l}return p};e.$aQ=f;class m{constructor(p,t,l,i){if(t.includes(E.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,r.$VP)(this,p);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof $?void 0:g.parent}},children:{value:(0,k.$UP)(g,r.$WP,m),enumerable:!0,writable:!1},...w(g,l)})}}e.$bQ=m;class $ extends m{constructor(p,t){super(p,p,t,void 0),this._isRoot=!0}}e.$cQ=$;class b extends k.$QP{constructor(p,t,l){super({controllerId:p,getDocumentVersion:i=>i&&l.getDocument(i)?.version,getApiFor:r.$WP,getChildren:i=>i.children,root:new $(p,t),toITestItem:A.TestItem.from})}}e.$dQ=b}),define(ve[321],Se([1,0,11,153,154,21,318,18,12,50,49,85,4,2,5,298,320,15,151,45,48,41,312,23]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,r=qe(r),E=qe(E);let g=class{#e;#t;#n;constructor(C,L,T){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$uN.MainThreadCommands),this.d=L,this.#n=T,this.#t=C.getProxy(R.$uN.MainThreadTelemetry),this.converter=new s(this,I=>{const q=this.c.get(I);return q?.result===u.Void?q:void 0},L),this.f=[{processArgument(I){return(0,o.$di)(I)}},{processArgument(I){return(0,k.$go)(I,function(q){if(D.$Mt.isIRange(q))return E.Range.to(q);if(v.$Lt.isIPosition(q))return E.Position.to(q);if(D.$Mt.isIRange(q.range)&&h.URI.isUri(q.uri))return E.location.to(q);if(q instanceof $.$Pe)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const L=this.registerCommand(!1,C.id,async(...T)=>{const I=C.args.map((Y,Q)=>{if(!Y.validate(T[Q]))throw new Error(`Invalid argument '${Y.name}' when running '${C.id}', received: ${typeof T[Q]=="object"?JSON.stringify(T[Q],null,"	"):T[Q]} `);return Y.convert(T[Q])}),q=await this.executeCommand(C.internalId,...I);return C.result.convert(q,T,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new r.$wN(()=>{L.dispose(),this.c.delete(C.id)})}registerCommand(C,L,T,I,q,Y){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:T,thisArg:I,metadata:q,extension:Y}),C&&this.#e.$registerCommand(L),new r.$wN(()=>{this.b.delete(L)&&C&&this.#e.$unregisterCommand(L)})}executeCommand(C,...L){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,L,!0)}async g(C,L,T){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,L,!1);{let I=!1;const q=(0,k.$go)(L,function(Y){if(Y instanceof r.$xN)return E.Position.from(Y);if(Y instanceof r.$yN)return E.Range.from(Y);if(Y instanceof r.$IN)return E.location.from(Y);if(r.$YO.isNotebookRange(Y))return E.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return I=!0,$.$Pe.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return I=!0,$.$Pe.wrap(Y);if(Y instanceof $.$Pe)return I=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await this.#e.$executeCommand(C,I?new b.$Uw(q):q,T);return(0,o.$di)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this.g(C,L,!1);throw Y}}}async h(C,L,T){const I=this.b.get(C);if(!I)throw new Error("Unknown command");const{callback:q,thisArg:Y,metadata:Q}=I;if(Q?.args)for(let te=0;te<Q.args.length;te++)try{(0,n.$xg)(L[te],Q.args[te].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${Q.args[te].name}' - ${Q.args[te].description}`)}const re=p.$he.create();try{return await q.apply(Y,L)}catch(te){if(C===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...L);_&&(C=_.command)}if(this.d.error(te,C,I.extension?.identifier),!T)throw te;if(I.extension?.identifier){const _=this.#n.onExtensionError(I.extension.identifier,te);this.d.trace("forwarded error to extension?",_,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$rj)(te)),this.id=C,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,C,re.elapsed())}}j(C,L,T){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$vp(L),duration:T})}$executeContributedCommand(C,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const T=this.b.get(C);return T?(L=L.map(I=>this.f.reduce((q,Y)=>Y.processArgument(q,T.extension?.identifier),I)),this.h(C,L,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(L=>(C&&(L=L.filter(T=>T[0]!=="_")),L))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[L,T]of this.b){const{metadata:I}=T;I&&(C[L]=I)}return Promise.resolve(C)}};e.$jQ=g,e.$jQ=g=Be([je(0,f.$1P),je(1,y.$ak),je(2,l.$iQ)],g),e.$kQ=(0,a.$Gi)("IExtHostCommands");class s{constructor(C,L,T){this.d=C,this.f=L,this.g=T,this.delegatingCommandId=`__vsc${(0,i.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,L){if(!C)return;const T={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return T;const I=this.f(C.command);if(I)T.id=I.internalId,T.arguments=I.args.map((q,Y)=>q.convert(C.arguments&&C.arguments[Y]));else if((0,A.$Ob)(C.arguments)){const q=`${C.command} /${++this.c}`;this.b.set(q,C),L.add((0,w.$Vc)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),T.$ident=q,T.id=this.delegatingCommandId,T.arguments=[q],this.g.trace("CommandsConverter#CREATE",C.command,q)}return T}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const L=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$lQ=s;class c{static{this.Uri=new c("uri","Uri of a text document",C=>h.URI.isUri(C),C=>C)}static{this.Position=new c("position","A position in a text document",C=>r.$xN.isPosition(C),E.Position.from)}static{this.Range=new c("range","A range in a text document",C=>r.$yN.isRange(C),E.Range.from)}static{this.Selection=new c("selection","A selection in a text document",C=>r.$zN.isSelection(C),E.Selection.from)}static{this.Number=new c("number","",C=>typeof C=="number",C=>C)}static{this.String=new c("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=c.Arr(c.String)}static Arr(C){return new c(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,L=>Array.isArray(L)&&L.every(T=>C.validate(T)),L=>L.map(T=>C.convert(T)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",C=>C instanceof r.$UN,E.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",C=>C instanceof r.$gP,E.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",C=>C instanceof m.$bQ,E.TestItem.from)}constructor(C,L,T,I){this.name=C,this.description=L,this.validate=T,this.convert=I}optional(){return new c(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,L){return new c(C??this.name,L??this.description,this.validate,this.convert)}}e.$mQ=c;class u{static{this.Void=new u("no result",C=>C)}constructor(C,L){this.description=C,this.convert=L}}e.$nQ=u;class S{constructor(C,L,T,I,q){this.id=C,this.internalId=L,this.description=T,this.args=I,this.result=q}}e.$oQ=S}),define(ve[322],Se([1,0,10,2,13,3,251]),function(se,e,n,r,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.$$Q=void 0,e.$$Q="remoteFilesystem";class A extends R.$0Q{static register(o,D,v){const h=o.getConnection();if(!h)return r.$Xc.None;const w=new r.$Wc,a=(async()=>{try{const f=await o.getRawEnvironment();f?D.registerProvider(E.Schemas.vscodeRemote,w.add(new A(f,h))):v.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){v.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,n.$ab)(f))}})();return w.add(D.onWillActivateFileSystemProvider(f=>{f.scheme===E.Schemas.vscodeRemote&&f.join(a)})),w}constructor(o,D){super(D.getChannel(e.$$Q),{pathCaseSensitive:o.os===k.OperatingSystem.Linux})}}e.$_Q=A}),define(ve[77],Se([1,0,96,84,32,323,15,10,6,2,9,3,23,51,61]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=s,e.$zi=c,e.$Bi=P,e.$Ci=C;const f=3e4;class m{traceSocketEvent(T,I){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,T,I)}constructor(T,I=""){this.f=!0,this.debugLabel=I,this.socket=T,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=Y=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:Y?.code,message:Y?.message}),Y){if(Y.code==="EPIPE")return;(0,A.$3)(Y)}},this.socket.on("error",this.a);let q;this.b=Y=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:Y}),this.f=!1,q&&clearTimeout(q)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,q=setTimeout(()=>T.destroy(),f)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(T){const I=q=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,q),T(R.$Pe.wrap(q))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(T){const I=q=>{T({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:q,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(T){const I=()=>{T()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(T){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,T),this.socket.write(T.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,A.$3)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,A.$3)(I)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((T,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),T();return}const q=()=>{this.socket.off("close",q),this.socket.off("end",q),this.socket.off("error",q),this.socket.off("timeout",q),this.socket.off("drain",q),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),T()};this.socket.on("close",q),this.socket.on("end",q),this.socket.on("error",q),this.socket.on("timeout",q),this.socket.on("drain",q)})}}e.$vi=m;var $;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var b;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(b||(b={}));class d extends o.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(T,I){this.socket.traceSocketEvent(T,I)}constructor(T,I,q,Y){super(),this.f=this.B(new y.$ne),this.g=this.B(new y.$ne),this.h=!1,this.j={state:b.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=T,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:q?.byteLength||0,recordInflateBytes:Y}),this.a=this.B(new p(this,I,q,Y,this.f,(Q,re)=>this.m(Q,re))),this.B(this.a.onError(Q=>{console.error(Q),(0,A.$3)(Q),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:Q})})),this.b=new a.$qi,this.B(this.socket.onData(Q=>this.n(Q))),this.B(this.socket.onClose(async Q=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(T){return this.f.event(T)}onClose(T){return this.g.event(T)}onEnd(T){return this.socket.onEnd(T)}write(T){let I=0;for(;I<T.byteLength;)this.a.writeMessage(T.slice(I,Math.min(I+$.MaxWebSocketMessageLength,T.byteLength)),{compressed:!0,opcode:2}),I+=$.MaxWebSocketMessageLength}m(T,{compressed:I,opcode:q}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,T);let Y=$.MinHeaderByteSize;T.byteLength<126?Y+=0:T.byteLength<2**16?Y+=2:Y+=8;const Q=R.$Pe.alloc(Y),re=I?64:0,te=q&15;if(Q.writeUInt8(128|re|te,0),T.byteLength<126)Q.writeUInt8(T.byteLength,1);else if(T.byteLength<2**16){Q.writeUInt8(126,1);let _=1;Q.writeUInt8(T.byteLength>>>8&255,++_),Q.writeUInt8(T.byteLength>>>0&255,++_)}else{Q.writeUInt8(127,1);let _=1;Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(T.byteLength>>>24&255,++_),Q.writeUInt8(T.byteLength>>>16&255,++_),Q.writeUInt8(T.byteLength>>>8&255,++_),Q.writeUInt8(T.byteLength>>>0&255,++_)}this.socket.write(R.$Pe.concat([Q,T]))}end(){this.h=!0,this.socket.end()}n(T){if(T.byteLength!==0){for(this.b.acceptChunk(T);this.b.byteLength>=this.j.readLen;)if(this.j.state===b.PeekHeader){const I=this.b.peek(this.j.readLen),q=I.readUInt8(0),Y=(q&128)>>>7,Q=(q&64)>>>6,re=q&15,te=I.readUInt8(1),_=(te&128)>>>7,de=te&127;this.j.state=b.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(_?4:0)+(de===126?2:0)+(de===127?8:0),this.j.fin=Y,this.j.firstFrameOfMessage&&(this.j.compressed=!!Q),this.j.firstFrameOfMessage=!!Y,this.j.mask=0,this.j.opcode=re,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===b.ReadHeader){const I=this.b.read(this.j.readLen),q=I.readUInt8(1),Y=(q&128)>>>7;let Q=q&127,re=1;Q===126?Q=I.readUInt8(++re)*2**8+I.readUInt8(++re):Q===127&&(Q=I.readUInt8(++re)*0+I.readUInt8(++re)*0+I.readUInt8(++re)*0+I.readUInt8(++re)*0+I.readUInt8(++re)*2**24+I.readUInt8(++re)*2**16+I.readUInt8(++re)*2**8+I.readUInt8(++re));let te=0;Y&&(te=I.readUInt8(++re)*2**24+I.readUInt8(++re)*2**16+I.readUInt8(++re)*2**8+I.readUInt8(++re)),this.j.state=b.ReadBody,this.j.readLen=Q,this.j.mask=te,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===b.ReadBody){const I=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,I),i(I,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,I),this.j.state=b.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=d;class p extends o.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Pe.alloc(0)}constructor(T,I,q,Y,Q,re){super(),this.n=T,this.r=Q,this.s=re,this.a=this.B(new y.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new t(this.n,Y,q,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(te=>this.a.fire(te))),this.B(this.f.onError(te=>this.a.fire(te)))):(this.b=null,this.f=null)}writeMessage(T,I){this.g.push({data:T,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:T,options:I}=this.g.shift();if(this.f&&I.compressed){const q=await this.w(this.f,T);this.s(q,I)}else this.s(T,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(T,I){return new Promise((q,Y)=>{T.write(I),T.flush(Q=>q(Q))})}acceptFrame(T,I,q){this.h.push({data:T,isCompressed:I,isLastFrameOfMessage:q}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const T=this.h.shift();if(this.b&&T.isCompressed){const I=await this.C(this.b,T.data,T.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(T.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(T,I,q){return new Promise((Y,Q)=>{T.write(I),q&&T.write(R.$Pe.fromByteArray([0,0,255,255])),T.flush(re=>Y(re))})}}class t extends o.$Xc{get recordedInflateBytes(){return this.j?R.$Pe.concat(this.f):R.$Pe.alloc(0)}constructor(T,I,q,Y){super(),this.h=T,this.j=I,this.a=this.B(new y.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(Y),this.b.on("error",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:Q?.message,code:Q?.code}),this.a.fire(Q)}),this.b.on("data",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,Q),this.g.push(R.$Pe.wrap(Q))}),q&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,q.buffer),this.b.write(q.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(T){this.j&&this.f.push(T.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,T),this.b.write(T.buffer)}flush(T){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const I=R.$Pe.concat(this.g);this.g.length=0,T(I)})}}class l extends o.$Xc{constructor(T,I){super(),this.g=T,this.a=this.B(new y.$ne),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,q),this.f.push(R.$Pe.wrap(q))})}write(T){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,T.buffer),this.b.write(T.buffer)}flush(T){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let I=R.$Pe.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),T(I)})}}function i(L,T){if(T===0)return;const I=L.byteLength>>>2;for(let _=0;_<I;_++){const de=L.readUInt32BE(_*4);L.writeUInt32BE(de^T,_*4)}const q=I*4,Y=L.byteLength-q,Q=T>>>24&255,re=T>>>16&255,te=T>>>8&255;Y>=1&&L.writeUInt8(L.readUInt8(q)^Q,q),Y>=2&&L.writeUInt8(L.readUInt8(q+1)^re,q+1),Y>=3&&L.writeUInt8(L.readUInt8(q+2)^te,q+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const g={[v.Platform.Linux]:107,[v.Platform.Mac]:103};function s(){const L=(0,h.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const T=process.platform!=="darwin"&&e.$xi?e.$xi:(0,E.tmpdir)(),I=(0,D.$mc)(T,`vscode-ipc-${L}.sock`);return u(I),I}function c(L,T,I){const Y=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Y}-${I}-${T}-sock`;const Q=I.substr(0,4),re=T.substr(0,6);let te;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?te=(0,D.$mc)(e.$xi,`vscode-${Y}-${Q}-${re}.sock`):te=(0,D.$mc)(L,`${Q}-${re}.sock`),u(te),te}function u(L){const T=g[v.$u];typeof T=="number"&&L.length>=T&&console.warn(`WARNING: IPC handle "${L}" is longer than ${T} chars, try a shorter --user-data-dir`)}class S extends w.$ki{static b(T){const I=y.Event.fromNodeEventEmitter(T,"connection");return y.Event.map(I,q=>({protocol:new a.$ri(new m(q,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(q,"close"))}))}constructor(T){super(S.b(T)),this.d=T}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=S;function P(L){return new Promise((T,I)=>{const q=(0,r.createServer)();q.on("error",I),q.listen(L,()=>{q.removeListener("error",I),T(new S(q))})})}function C(L,T){return new Promise((I,q)=>{const Y=(0,r.createConnection)(L,()=>{Y.removeListener("error",q),I(a.$si.fromSocket(new m(Y,`ipc-client${T}`),T))});Y.once("error",q)})}}),define(ve[155],Se([1,0,93,14,15,10,11,27,28,94,12,47,270,323]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$es=m;let a=class extends v.$7p{constructor(b,d,p,t){super(t),this.m=b,this.n=d,this.r=p,this.s(),this.B(b.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const b=this.m.getValue("http");this.f=b?.proxy,this.g=!!b?.proxyStrictSSL,this.h=b?.proxyAuthorization}async request(b,d){const{f:p,g:t}=this;let l;try{l=await(0,o.$Rm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$ab)(s)))}const i={...process.env,...l},g=b.agent?b.agent:await(0,h.$cs)(b.url||"",i,{proxyUrl:p,strictSSL:t});return b.agent=g,b.strictSSL=t,this.h&&(b.headers={...b.headers||{},"Proxy-Authorization":this.h}),this.c(b.isChromiumNetwork?"electron":"node",b,()=>m(b,d))}async resolveProxy(b){}async loadCertificates(){return(await new Promise((d,p)=>{se(["@vscode/proxy-agent"],d,p)}).then(qe)).loadSystemCertificates({log:this.r})}};e.$ds=a,e.$ds=a=Be([je(0,A.$aj),je(1,y.$Oi),je(2,D.$ak),je(3,D.$bk)],a);async function f($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((p,t)=>{se(["https"],p,t)}).then(qe):await new Promise((p,t)=>{se(["http"],p,t)}).then(qe)).request}async function m($,b){return r.Promises.withAsyncBody(async(d,p)=>{const t=(0,n.parse)($.url),l=$.getRawRequest?$.getRawRequest($):await f($),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,R.$mg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(i.auth=$.user+":"+$.password);const g=l(i,s=>{const c=(0,R.$kg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&c>0&&s.headers.location)m({...$,url:s.headers.location,followRedirects:c-1},b).then(d,p);else{let u=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(u=s.pipe((0,w.createGunzip)())),d({res:s,stream:(0,E.$5e)(u)})}});g.on("error",p),$.timeout&&g.setTimeout($.timeout),$.isChromiumNetwork&&g.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&g.write($.data),g.end(),b.onCancellationRequested(()=>{g.abort(),p(new k.$8)})})}}),define(ve[156],Se([1,0,60,84,15,6,2,13,9,3,69,77,27,12,94,143,144,55,310]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Dn=d,n=qe(n),r=qe(r);async function d(s={},c,u,S,P,C){const L=await(0,m.$1m)(u,S.userDataPath);let T={};if(c)try{T=await(0,a.$Rm)(C,P,S.args,process.env)}catch(te){P.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",te)}const q={...process.env,...T,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(L,void 0,0),...s},Y=S.isBuilt?(0,y.$mc)(S.appRoot,"bin"):(0,y.$mc)(S.appRoot,"resources","server","bin-dev"),Q=(0,y.$mc)(Y,"remote-cli");let re=l(q,"PATH");return re?re=Q+y.$wc+re:re=Q,i(q,"PATH",re),S.args["without-browser-env-var"]||(q.BROWSER=(0,y.$mc)(Y,"helpers",o.$i?"browser.cmd":"browser.sh")),g(q),q}class p{constructor(c,u){this.socket=c,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let c,u,S;return this.socket instanceof v.$vi?(c=!0,u=!1,S=E.$Pe.alloc(0)):(c=!1,u=this.socket.permessageDeflate,S=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:c,permessageDeflate:u,inflateBytes:S.buffer.toString("base64")}}}let t=class extends R.$Xc{constructor(c,u,S,P,C,L,T,I){super(),this.m=c,this.n=C,this.r=L,this.s=T,this.t=I,this.b=new k.$ne,this.onClose=this.b.event,this.c=!o.$i||!this.n.args["socket-path"],this.f=!1,this.g=u,this.h=null,this.j=new p(S,P),this.w("New connection established.")}dispose(){this.D(),super.dispose()}get u(){return`[${this.g}][${this.m.substr(0,8)}][ExtensionHostConnection] `}w(c){this.r.info(`${this.u}${c}`)}y(c){this.r.error(`${this.u}${c}`)}async z(c,u){const S=new R.$Wc;S.add(u.socket),S.add((0,R.$Vc)(()=>{c.destroy()}));const P=()=>{S.dispose()};S.add(u.socket.onEnd(P)),S.add(u.socket.onClose(P)),S.add(k.Event.fromNodeEventEmitter(c,"end")(P)),S.add(k.Event.fromNodeEventEmitter(c,"close")(P)),S.add(k.Event.fromNodeEventEmitter(c,"error")(P)),S.add(u.socket.onData(C=>c.write(C.buffer))),S.add(k.Event.fromNodeEventEmitter(c,"data")(C=>{u.socket.write(E.$Pe.wrap(C))})),u.initialDataChunk.byteLength>0&&c.write(u.initialDataChunk.buffer)}async C(c,u){await u.socketDrain();const S=u.toIExtHostSocketMessage();let P;u.socket instanceof v.$vi?P=u.socket.socket:P=u.socket.socket.socket,c.send(S,P)}shortenReconnectionGraceTimeIfNecessary(){if(!this.h)return;const c={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.h.send(c)}acceptReconnection(c,u,S){this.g=c,this.w("The client has reconnected.");const P=new p(u,S);if(!this.h){this.j=P;return}this.C(this.h,P)}D(){this.f||(this.f=!0,this.j&&(this.j.socket.end(),this.j=null),this.h&&(this.h.kill(),this.h=null),this.b.fire(void 0))}async start(c){try{let u=process.execArgv?process.execArgv.filter(Q=>!/^--inspect(-brk)?=/.test(Q)):[];c.port&&!process.pkg&&(u=[`--inspect${c.break?"-brk":""}=${c.port}`]);const S=await d(c.env,!0,c.language,this.n,this.r,this.t);(0,D.$mm)(S);let P;if(this.c)(0,b.$fn)(new b.$dn,S),P=null;else{const{namedPipeServer:Q,pipeName:re}=await this.F();(0,b.$fn)(new b.$cn(re),S),P=Q}const C={env:S,execArgv:u,silent:!0};C.execArgv.unshift("--dns-result-order=ipv4first");const L=["--type=extensionHost","--transformURIs"],T=this.n.args["use-host-proxy"];L.push(`--useHostProxy=${T?"true":"false"}`),this.h=n.fork(A.$1g.asFileUri("bootstrap-fork").fsPath,L,C);const I=this.h.pid;this.w(`<${I}> Launched Extension Host Process.`),this.h.stdout.setEncoding("utf8"),this.h.stderr.setEncoding("utf8");const q=k.Event.fromNodeEventEmitter(this.h.stdout,"data"),Y=k.Event.fromNodeEventEmitter(this.h.stderr,"data");if(this.B(q(Q=>this.w(`<${I}> ${Q}`))),this.B(Y(Q=>this.w(`<${I}><stderr> ${Q}`))),this.h.on("error",Q=>{this.y(`<${I}> Extension Host Process had an error`),this.r.error(Q),this.D()}),this.h.on("exit",(Q,re)=>{this.s.setExitInfo(this.m,{code:Q,signal:re}),this.w(`<${I}> Extension Host Process exited with code: ${Q}, signal: ${re}.`),this.D()}),P)P.on("connection",Q=>{P.close(),this.z(Q,this.j)});else{const Q=re=>{re.type==="VSCODE_EXTHOST_IPC_READY"&&(this.h.removeListener("message",Q),this.C(this.h,this.j),this.j=null)};this.h.on("message",Q)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}F(){return new Promise((c,u)=>{const S=(0,v.$yi)(),P=r.createServer();P.on("error",u),P.listen(S,()=>{P?.removeListener("error",u),c({pipeName:S,namedPipeServer:P})})})}};e.$En=t,e.$En=t=Be([je(4,$.$an),je(5,w.$ak),je(6,f.$Ym),je(7,h.$aj)],t);function l(s,c){const u=Object.keys(s).filter(P=>P.toLowerCase()===c.toLowerCase()),S=u.length>0?u[0]:c;return s[S]}function i(s,c,u){const S=Object.keys(s).filter(C=>C.toLowerCase()===c.toLowerCase()),P=S.length>0?S[0]:c;s[P]=u}function g(s){for(const c of Object.keys(s))s[c]===null&&delete s[c]}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[324],Se([1,0,89,12,71,129,27,47,155,41,24,30,141,139,95,122,62,2,123,72,13,16,29,55,132,92,133,10,4,9,33,268,88,36,137,70,3,64,145,34,54,73,142,140,125,126,229,325]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T,I,q,Y,Q,re,te,_,de,J,ae,z,B,ie,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=x,m=mt(m);class H extends $.$Xc{constructor(O,Z){super(),this.a=O,this.b=Z,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const O=await this.f();await O.invokeFunction(async Z=>{const V=Z.get(R.$aj),M=Z.get(r.$ak);Q.$i&&(V.getValue("security.restrictUNCAccess")===!1?(0,pe.disableUNCAccessRestrictions)():(0,pe.addUNCHostToAllowlist)(V.getValue("security.allowedUNCHosts")));try{await this.g(O.createInstance(g.$uq,new r.$ik(M.getLevel(),!1)))}catch(G){throw M.error(G),console.error((0,u.$ab)(G)),G}})}async f(){const O=new n.$Ei,Z={_serviceBrand:void 0,...m.default};O.set(l.$tk,Z);const V=new i.$bn(this.a,Z);O.set(i.$an,V);const M=new ie.$eR((0,r.$ok)(V),V.logsHome);O.set(r.$bk,M);const G=new B.$oR(this.B(M.createLogger("remoteCLI",{name:(0,le.localize)(0,null)})));O.set(r.$ak,G),G.trace(`Remote configuration data at ${this.b}`),G.trace("process arguments:",this.a);const X=this.B(new b.$1q(G));O.set(t.$al,X),X.registerProvider(p.Schemas.file,this.B(new d.$rr(G)));const F=new q.$Ss(X);O.set(I.$Kl,F);const W=this.B(new ae.$mR(F,V,X,G));O.set(_.$Ml,W);const oe=this.B(new k.$Vo(W.defaultProfile.settingsResource,X,new J.$vo,G));return O.set(R.$aj,oe),await Promise.all([oe.initialize(),W.init()]),O.set(A.$6p,new E.$Di(y.$ds)),O.set(T.$Zo,new E.$Di(L.$DR)),O.set(D.$_l,o.$xp),O.set(v.$jp,new E.$Di(h.$qq)),O.set(de.$Hq,new E.$Di(z.$nR)),O.set(re.$Lq,new E.$Di(te.$aR)),O.set(a.$rq,new E.$Di(a.$tq)),O.set(w.$Wq,new E.$Di(w.$Xq)),O.set(s.$0r,new E.$Di(c.$_r)),new f.$ur(O)}async g(O){if(this.a["list-extensions"])return O.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const Z={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return O.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),Z,!!this.a.force)}else{if(this.a["uninstall-extension"])return O.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return O.updateExtensions();if(this.a["locate-extension"])return O.locateExtension(this.a["locate-extension"])}}h(O){return O.map(Z=>/\.vsix$/i.test(Z)?S.URI.file((0,P.$lc)(Z)?Z:(0,P.$mc)((0,C.cwd)(),Z)):Z)}}function ce(U){setTimeout(()=>process.exit(U),0)}async function x(U,O,Z){if(U.help){const M=m.default.serverApplicationName+(Q.$i?".cmd":"");console.log((0,Y.$Fm)(m.default.nameLong,M,m.default.version,Z,{noInputFiles:!0,noPipe:!0}));return}if(U.version){console.log((0,Y.$Gm)(m.default.version,m.default.commit));return}const V=new H(U,O);try{await V.run(),ce(0)}catch{ce(1)}finally{V.dispose()}}}),define(ve[326],Se([1,0,77,337,31,321,4,12,98]),function(se,e,n,r,E,k,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0,r=qe(r),E=qe(E);class o{constructor(h,w,a){this.b=h,this.c=w,this.f=a,this.a=r.createServer((f,m)=>this.h(f,m)),this.g().catch(f=>(w.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",h=>this.c.error(h))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(h,w){const a=(m,$)=>{w.writeHead(m,{"content-type":"application/json"}),w.end(JSON.stringify($||null),b=>b&&this.c.error(b))},f=[];h.setEncoding("utf8"),h.on("data",m=>f.push(m)),h.on("end",async()=>{try{const m=JSON.parse(f.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;default:a(404,`Unknown message type: ${m.type}`);break}a(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);a(500,$),this.c.error("Error while processing pipe request",m)}})}async i(h){const{fileURIs:w,folderURIs:a,forceNewWindow:f,diffMode:m,mergeMode:$,addMode:b,forceReuseWindow:d,gotoLineMode:p,waitMarkerFilePath:t,remoteAuthority:l}=h,i=[];if(Array.isArray(a))for(const u of a)try{i.push({folderUri:R.URI.parse(u)})}catch{}if(Array.isArray(w))for(const u of w)try{(0,y.$_i)(u)?i.push({workspaceUri:R.URI.parse(u)}):i.push({fileUri:R.URI.parse(u)})}catch{}const g=t?R.URI.file(t):void 0,c={forceNewWindow:f,diffMode:m,mergeMode:$,addMode:b,gotoLineMode:p,forceReuseWindow:d,preferNewWindow:!d&&!g&&!b,waitMarkerFileURI:g,remoteAuthority:l};this.b.executeCommand("_remoteCLI.windowOpen",i,c)}async j(h){for(const w of h.uris){const a=R.URI.parse(w),f=a.scheme==="file"?a:w;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(h){const w=f=>f?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),a={list:h.list,install:w(h.install),uninstall:w(h.uninstall),force:h.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l(h){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&E.existsSync(this.f)&&E.unlinkSync(this.f)}}e.$pQ=o;let D=class extends o{constructor(h,w){super(h,w,(0,n.$yi)())}};e.$qQ=D,e.$qQ=D=Be([je(0,k.$kQ),je(1,A.$ak)],D)}),define(ve[327],Se([1,0,32,6,21,2,9,3,4,77,75,326,135,97,146,305,307,156,14,136]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=void 0,n=qe(n),R=qe(R),A=qe(A),f=qe(f);class p extends m.$5Q{constructor(i,g,s,c,u){super({getFolderUri:S=>{const P=g.filter(C=>C.name===S);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(S,P)=>c[`config:${P}`],getExecPath:()=>i.VSCODE_EXEC_PATH,getAppRoot:()=>i.VSCODE_CWD,getFilePath:()=>{if(s)return R.$kc(s.fsPath)},getSelectedText:()=>c.selectedText,getLineNumber:()=>c.lineNumber,getExtension:async S=>{const C=(await u.getInstalled()).find(L=>L.identifier.id===S);return C&&{extensionLocation:C.location}}},void 0,Promise.resolve(n.homedir()),Promise.resolve(i))}}class t extends k.$Xc{constructor(i,g,s,c,u,S){super(),this.g=i,this.h=g,this.j=s,this.m=c,this.n=u,this.r=S,this.a=0,this.b=new Map,this.c=this.B(new r.$ne),this.onExecuteCommand=this.c.event}async call(i,g,s){switch(g){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,s);case a.RemoteTerminalChannelRequest.CreateProcess:{const c=(0,D.$Ts)(i.remoteAuthority);return this.s(c,s)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,s);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,s);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,s);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,s);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,s);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,s);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,s);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,s);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(s[0],s[1],s[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,s);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,s);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,s);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(s[0],s[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,s);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,s);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,s);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,s);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,s);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,s);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,s);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(s[0],s[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(s[0],s[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,s)}throw new Error(`IPC Command ${g} not found`)}listen(i,g,s){switch(g){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${g} not found`)}async s(i,g){const s={name:g.shellLaunchConfig.name,executable:g.shellLaunchConfig.executable,args:g.shellLaunchConfig.args,cwd:typeof g.shellLaunchConfig.cwd=="string"||typeof g.shellLaunchConfig.cwd>"u"?g.shellLaunchConfig.cwd:y.URI.revive(i.transformIncoming(g.shellLaunchConfig.cwd)),env:g.shellLaunchConfig.env,useShellEnvironment:g.shellLaunchConfig.useShellEnvironment,reconnectionProperties:g.shellLaunchConfig.reconnectionProperties,type:g.shellLaunchConfig.type,isFeatureTerminal:g.shellLaunchConfig.isFeatureTerminal},c=await(0,$.$Dn)(g.resolverEnv,!!g.shellLaunchConfig.useShellEnvironment,A.$w,this.g,this.h,this.r);this.h.trace("baseEnv",c);const u=J=>({uri:y.URI.revive(i.transformIncoming(J.uri)),name:J.name,index:J.index,toResource:()=>{throw new Error("Not implemented")}}),S=g.workspaceFolders.map(u),P=g.activeWorkspaceFolder?u(g.activeWorkspaceFolder):void 0,C=g.activeFileResource?y.URI.revive(i.transformIncoming(g.activeFileResource)):void 0,L=new p(c,S,C,g.resolvedVariables,this.n),T=f.$1Q(P,process.env,L),I=await f.$ZQ(s,n.homedir(),T,P?.uri,g.configuration["terminal.integrated.cwd"],this.h);s.cwd=I;const q=A.$i?"terminal.integrated.env.windows":A.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Y=g.configuration[q],Q=await f.$2Q(s,Y,T,this.m.version,g.configuration["terminal.integrated.detectLocale"],c);if((0,d.$TQ)(s)){const J=[];for(const[ie,le,pe]of g.envVariableCollections)J.push([ie,{map:(0,w.$Fs)(le),descriptionMap:(0,w.$Gs)(pe)}]);const ae=new Map(J),z=new h.$Js(ae),B=P?P??void 0:void 0;await z.applyToProcessEnvironment(Q,{workspaceFolder:B},T)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:I,cols:g.cols,rows:g.rows,env:Q});const re=(0,o.$yi)();Q.VSCODE_IPC_HOOK_CLI=re;const te=await this.j.createProcess(s,I,g.cols,g.rows,g.unicodeVersion,Q,c,g.options,g.shouldPersistTerminal,g.workspaceId,g.workspaceName),_={executeCommand:(J,...ae)=>this.t(te,J,ae,i)},de=new v.$pQ(_,this.h,re);return this.j.onProcessExit(J=>J.id===te&&de.dispose()),{persistentTerminalId:te,resolvedShellLaunchConfig:s}}t(i,g,s,c){const{resolve:u,reject:S,promise:P}=(0,b.$zh)(),C=++this.a;this.b.set(C,{resolve:u,reject:S,uriTransformer:c});const L=(0,E.$go)(s,T=>{if(T&&T.$mid===1)return c.transformOutgoing(T);if(T&&T instanceof y.URI)return c.transformOutgoingURI(T)});return this.c.fire({reqId:C,persistentProcessId:i,commandId:g,commandArgs:L}),P}u(i,g,s){const c=this.b.get(i);if(!c)return;this.b.delete(i);const u=(0,E.$go)(s,S=>{if(S&&S.$mid===1)return c.uriTransformer.transformIncoming(S)});g?c.reject(u):c.resolve(u)}w(i){return this.j.getDefaultSystemShell(i)}async y(i,g,s,c){return this.j.getProfiles(i,g,s,c)||[]}z(){return{...process.env}}C(i,g){return this.j.getWslPath(i,g)}D(){return this.j.reduceConnectionGraceTime()}}e.$6Q=t});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[328],Se([1,0,32,6,2,13,9,112,25,51,61,27,129,241,88,242,28,141,30,95,132,266,139,16,123,72,71,122,89,92,133,12,62,29,47,269,155,131,24,41,281,53,288,36,137,299,300,275,279,327,75,55,309,322,143,64,145,54,34,73,280,126,142,140,125,124,231,317,265,293,285]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T,I,q,Y,Q,re,te,_,de,J,ae,z,B,ie,le,pe,H,ce,x,U,O,Z,V,M,G,X,F,W,oe,he,ke,Ne,me,$e,Pe,Oe,fe,De,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0,e.$xR=We,R=qe(R),T=mt(T),de=mt(de);const ze="monacoworkbench";async function We(nt,tt,et,Ze){const be=new S.$Ei,Le=new Ge,Fe={_serviceBrand:void 0,...T.default};be.set(I.$tk,Fe);const ye=new U.$bn(tt,Fe);be.set(m.$Ni,ye),be.set(m.$Oi,ye);const Ce=new he.$eR((0,L.$ok)(ye),ye.logsHome);be.set(L.$bk,Ce),Le.registerChannel("logger",new $e.$ss(Ce,ht=>Ke(ht.remoteAuthority)));const ne=Ce.createLogger("remoteagent",{name:(0,Pe.localize)(0,null)}),ee=new me.$oR(ne,[new xe((0,L.$ok)(ye))]);be.set(L.$ak,ee),setTimeout(()=>rt(ye.logsHome.with({scheme:k.Schemas.file}).fsPath).then(null,ht=>ee.error(ht)),1e4),ee.onDidChangeLogLevel(ht=>(0,L.log)(ee,ht,`Log level changed to ${(0,L.$pk)(ee.getLevel())}`)),ee.trace(`Remote configuration data at ${et}`),ee.trace("process arguments:",ye.args),Array.isArray(Fe.serverGreeting)&&ee.info(`

${Fe.serverGreeting.join(`
`)}

`),Le.registerChannel(w.$Xo.ChannelName,new w.$Xo);const we=new o.$oi(ht=>ht.clientId==="renderer"),He=Ze.add(new g.$1q(ee));be.set(i.$al,He),He.registerProvider(k.Schemas.file,Ze.add(new s.$rr(ee)));const Xe=new B.$Ss(He);be.set(z.$Kl,Xe);const _e=new h.$Vo(ye.machineSettingsResource,He,new W.$vo,ee);be.set(v.$aj,_e);const it=new ke.$mR(Xe,ye,He,ee);be.set(F.$Ml,it),Le.registerChannel("userDataProfiles",new De.$uR(it,ht=>Ke(ht.remoteAuthority)));const[,,ut,gt,bt]=await Promise.all([_e.initialize(),it.init(),(0,A.$Tn)(ee.error.bind(ee)),(0,A.$Un)(ee.error.bind(ee)),(0,A.$Vn)(ee.error.bind(ee))]),Mt=new V.$Zm;be.set(V.$Ym,Mt);const At=new Q.$ds(_e,ye,ee,Ce);be.set(q.$6p,At);let ft=_.$Bp;const wt=(0,_.$Hp)(Fe,_e);if((0,_.$Cp)(Fe,ye)){!(0,_.$Dp)(Fe,ye)&&Fe.aiConfig?.ariaKey&&(ft=new oe.$cR(At,wt,ze,null,Fe.aiConfig.ariaKey),Ze.add((0,E.$Vc)(()=>ft?.flush())));const ht={appenders:[ft],commonProperties:(0,re.$tp)((0,n.release)(),(0,n.hostname)(),process.arch,Fe.commit,Fe.version+"-remote",ut,gt,bt,wt,"remoteAgent"),piiPaths:(0,_.$Ip)(ye)},pt=ye.args["telemetry-level"];let vt=te.TelemetryLevel.USAGE;pt==="all"?vt=te.TelemetryLevel.USAGE:pt==="error"?vt=te.TelemetryLevel.ERROR:pt==="crash"?vt=te.TelemetryLevel.CRASH:pt!==void 0&&(vt=te.TelemetryLevel.NONE),be.set(H.$7s,new c.$Di(H.$5s,[ht,vt]))}else be.set(H.$7s,H.$6s);be.set(b.$jp,new c.$Di($.$qq));const Et=Le.getChannel("download",we);be.set(a.$Zo,new f.$2o(Et,()=>Ke("renderer"))),be.set(X.$Hq,new c.$Di(Ne.$nR)),be.set(M.$Lq,new c.$Di(G.$aR)),be.set(d.$rq,new c.$Di(d.$tq)),be.set(l.$Wq,new c.$Di(l.$Xq));const kt=new u.$ur(be);be.set(P.$0r,kt.createInstance(C.$_r));const Jt=kt.createInstance(Re.$wR,{graceTime:D.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:D.ProtocolConstants.ReconnectionShortGraceTime,scrollback:_e.getValue(J.TerminalSettingId.PersistentSessionScrollback)??100}),Ot=kt.createInstance(ae.$Os,Jt);return be.set(J.$ns,Ot),kt.invokeFunction(ht=>{const pt=ht.get(l.$Wq),vt=ht.get(M.$Lq),It=ht.get(b.$jp),zt=ht.get(P.$0r),Ct=new ie.$1s(nt,ye,it,Mt);Le.registerChannel("remoteextensionsenvironment",Ct);const _t=new pe.$8s(ht.get(H.$7s),ft);Le.registerChannel("telemetry",_t),Le.registerChannel(O.$7Q,new ce.$6Q(ye,ee,Ot,Fe,pt,_e));const Pt=new Oe.$sR(kt.createInstance(p.$uq,ee),ye,it,vt,ee,It,zt);Le.registerChannel(fe.$rR,new Oe.$tR(Pt,Nt=>Ke(Nt.remoteAuthority)));const Lt=Ze.add(new le.$4s(ee,ye));Le.registerChannel(Z.$$Q,Lt),Le.registerChannel("request",new Y.$as(ht.get(q.$6p)));const Bt=new t.$vq(pt,Nt=>Ke(Nt.remoteAuthority));return Le.registerChannel("extensions",Bt),Pt.whenExtensionsReady().then(()=>pt.cleanUp()),Ze.add(new de.default(ht.get(te.$_l))),{telemetryService:ht.get(te.$_l)}}),{socketServer:Le,instantiationService:kt}}const Qe=Object.create(null);function Ke(nt){return Qe[nt]||(Qe[nt]=(0,x.$Ts)(nt)),Qe[nt]}class Ge extends o.$ki{constructor(){const tt=new r.$ne;super(tt.event),this.b=tt}acceptConnection(tt,et){this.b.fire({protocol:tt,onDidClientDisconnect:et})}}e.$yR=Ge;class xe extends L.$fk{constructor(tt=L.$dk){super(),this.setLevel(tt),this.g=!!process.stdout.isTTY}trace(tt,...et){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}debug(tt,...et){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}info(tt,...et){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}warn(tt,...et){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${st()}]\x1B[0m`,tt,...et):console.warn(`[${st()}]`,tt,...et))}error(tt,...et){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${st()}]\x1B[0m`,tt,...et):console.error(`[${st()}]`,tt,...et))}flush(){}}function st(){const nt=new Date;return`${lt(nt.getHours())}:${lt(nt.getMinutes())}:${lt(nt.getSeconds())}`}function lt(nt){return nt<10?`0${nt}`:String(nt)}async function rt(nt){const tt=R.$qc(nt),et=R.$pc(nt),Le=(await y.Promises.readdir(et)).filter(ye=>/^\d{8}T\d{6}$/.test(ye)).sort().filter(ye=>ye!==tt),Fe=Le.slice(0,Math.max(0,Le.length-9));await Promise.all(Fe.map(ye=>y.Promises.rm(R.$mc(et,ye))))}}),define(ve[329],Se([1,0,96,31,84,330,93,104,15,35,10,37,2,13,9,44,3,17,4,23,195,178,325,61,77,27,5,12,29,264,24,156,294,101,55,328,296]),function(se,e,n,r,E,k,R,A,y,o,D,v,h,w,a,f,m,$,b,d,p,t,l,i,g,s,c,u,S,P,C,L,T,I,q,Y,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=_,n=qe(n),r=qe(r),E=qe(E),R=qe(R),f=qe(f),m=qe(m);const re=5*60*1e3;let te=class extends h.$Xc{constructor(ae,z,B,ie,le,pe,H,ce,x){super(),this.n=ae,this.r=z,this.s=B,this.t=pe,this.u=H,this.w=ce,this.y=x,this.h=de.create(this.u),this.j=(0,w.$Ug)(H,le),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ie?this.y.createInstance(Q.$BR,this.r,le??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(ae,z){if(ae.method!=="GET")return(0,Q.$zR)(ae,z,405,`Unsupported method ${ae.method}`);if(!ae.url)return(0,Q.$zR)(ae,z,400,"Bad request.");const B=R.parse(ae.url,!0);let ie=B.pathname;if(!ie)return(0,Q.$zR)(ae,z,400,"Bad request.");if(ie.startsWith(this.j)&&ie.charCodeAt(this.j.length)===o.CharCode.Slash&&(ie=ie.substring(this.j.length)),ie==="/version")return z.writeHead(200,{"Content-Type":"text/plain"}),void z.end(this.u.commit||"");if(ie==="/delay-shutdown")return this.N(),z.writeHead(200),void z.end("OK");if(!(0,I.$Ln)(this.r,ae,B))return(0,Q.$zR)(ae,z,403,"Forbidden.");if(ie==="/vscode-remote-resource"){const le=B.query.path;if(typeof le!="string")return(0,Q.$zR)(ae,z,400,"Bad request.");let pe;try{pe=b.URI.from({scheme:w.Schemas.file,path:le}).fsPath}catch{return(0,Q.$zR)(ae,z,400,"Bad request.")}const H=Object.create(null);this.t.isBuilt&&((0,v.$Fg)(pe,this.t.builtinExtensionsPath,!m.$k)||(0,v.$Fg)(pe,this.t.extensionsPath,!m.$k))&&(H["Cache-Control"]="public, max-age=31536000"),H.Vary="Origin";const ce=ae.headers.origin;return ce&&this.h.matches(ce)&&(H["Access-Control-Allow-Origin"]=ce),(0,Q.$AR)(pe,Q.CacheControl.ETAG,this.w,ae,z,H)}if(this.g){this.g.handle(ae,z,B);return}return z.writeHead(404,{"Content-Type":"text/plain"}),void z.end("Not found")}handleUpgrade(ae,z){let B=(0,d.$3g)(),ie=!1,le=!1;if(ae.url){const O=R.parse(ae.url,!0).query;typeof O.reconnectionToken=="string"&&(B=O.reconnectionToken),O.reconnection==="true"&&(ie=!0),O.skipWebSocketFrames==="true"&&(le=!0)}if(ae.headers.upgrade===void 0||ae.headers.upgrade.toLowerCase()!=="websocket"){z.end("HTTP/1.1 400 Bad Request");return}const pe=ae.headers["sec-websocket-key"],H=n.createHash("sha1");H.update(pe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const x=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${H.digest("base64")}`];let U=!1;if(!le&&!this.t.args["disable-websocket-compression"]&&ae.headers["sec-websocket-extensions"]){const O=Array.isArray(ae.headers["sec-websocket-extensions"])?ae.headers["sec-websocket-extensions"]:[ae.headers["sec-websocket-extensions"]];for(const Z of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Z)){if(/\b(permessage-deflate)\b/.test(Z)){U=!0,x.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Z)){U=!0,x.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}z.write(x.join(`\r
`)+`\r
\r
`),z.setTimeout(0),z.setNoDelay(!0),le?this.D(new g.$vi(z,`server-connection-${B}`),ie,B):this.D(new g.$wi(new g.$vi(z,`server-connection-${B}`),U,null,!0),ie,B)}handleServerError(ae){this.w.error("Error occurred in server"),this.w.error(ae)}z(ae){let z;return ae instanceof g.$vi?z=ae.socket:z=ae.socket.socket,z.remoteAddress||"<unknown>"}async C(ae,z,B){const ie=z.getSocket();this.w.error(`${ae} ${B}.`);const le={type:"error",reason:B};z.sendControl(y.$Pe.fromString(JSON.stringify(le))),z.dispose(),await ie.drain(),ie.dispose()}D(ae,z,B){const ie=this.z(ae),le=`[${ie}][${B.substr(0,8)}]`,pe=new i.$ui({socket:ae}),H=this.s?new this.s.validator:null,ce=this.s?new this.s.signer:null;let x;(function(V){V[V.WaitingForAuth=0]="WaitingForAuth",V[V.WaitingForConnectionType=1]="WaitingForConnectionType",V[V.Done=2]="Done",V[V.Error=3]="Error"})(x||(x={}));let U=x.WaitingForAuth;const O=V=>{U=x.Error,Z.dispose(),this.C(le,pe,V)},Z=pe.onControlMessage(V=>{if(U===x.WaitingForAuth){let M;try{M=JSON.parse(V.toString())}catch{return O("Malformed first message")}if(M.type!=="auth")return O("Invalid first message");if(this.r.type===I.ServerConnectionTokenType.Mandatory&&!this.r.validate(M.auth))return O("Unauthorized client refused: auth mismatch");let G=(0,d.$3g)();if(ce)try{G=ce.sign(M.data)}catch{}let X=(0,d.$3g)();if(H)try{X=H.createNewMessage(X)}catch{}const F={type:"sign",data:X,signedData:G};pe.sendControl(y.$Pe.fromString(JSON.stringify(F))),U=x.WaitingForConnectionType}else if(U===x.WaitingForConnectionType){let M;try{M=JSON.parse(V.toString())}catch{return O("Malformed second message")}if(M.type!=="connectionType")return O("Invalid second message");if(typeof M.signedData!="string")return O("Invalid second message field type");const G=M.commit,X=this.u.commit;if(G&&X&&G!==X)return O("Client refused: version mismatch");let F=!1;if(!H)F=!0;else if(this.r.validate(M.signedData))F=!0;else try{F=H.validate(M.signedData)==="ok"}catch{}if(!F){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${le} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const W in this.b)this.b[W].shortenReconnectionGraceTimeIfNecessary();for(const W in this.a)this.a[W].shortenReconnectionGraceTimeIfNecessary();U=x.Done,Z.dispose(),this.F(ie,le,pe,ae,z,B,M)}})}async F(ae,z,B,ie,le,pe,H){const ce=H.desiredConnectionType===P.ConnectionType.Management?`${z}[ManagementConnection]`:H.desiredConnectionType===P.ConnectionType.ExtensionHost?`${z}[ExtensionHostConnection]`:z;if(H.desiredConnectionType===P.ConnectionType.Management)if(le){if(!this.b[pe])return this.f.has(pe)?this.C(ce,B,"Unknown reconnection token (seen before)"):this.C(ce,B,"Unknown reconnection token (never seen)");B.sendControl(y.$Pe.fromString(JSON.stringify({type:"ok"})));const x=B.readEntireBuffer();B.dispose(),this.b[pe].acceptReconnection(ae,ie,x)}else{if(this.b[pe])return this.C(ce,B,"Duplicate reconnection token");B.sendControl(y.$Pe.fromString(JSON.stringify({type:"ok"})));const x=new T.$Fn(this.w,pe,ae,B);this.n.acceptConnection(x.protocol,x.onClose),this.b[pe]=x,this.f.add(pe),x.onClose(()=>{delete this.b[pe]})}else if(H.desiredConnectionType===P.ConnectionType.ExtensionHost){const x=H.args||{language:"en"},U=await this.I(x);if(U.port&&this.w.trace(`${ce} - startParams debug port ${U.port}`),this.w.trace(`${ce} - startParams language: ${U.language}`),this.w.trace(`${ce} - startParams env: ${JSON.stringify(U.env)}`),le){if(!this.a[pe])return this.f.has(pe)?this.C(ce,B,"Unknown reconnection token (seen before)"):this.C(ce,B,"Unknown reconnection token (never seen)");B.sendPause(),B.sendControl(y.$Pe.fromString(JSON.stringify(U.port?{debugPort:U.port}:{})));const O=B.readEntireBuffer();B.dispose(),this.a[pe].acceptReconnection(ae,ie,O)}else{if(this.a[pe])return this.C(ce,B,"Duplicate reconnection token");B.sendPause(),B.sendControl(y.$Pe.fromString(JSON.stringify(U.port?{debugPort:U.port}:{})));const O=B.readEntireBuffer();B.dispose();const Z=this.y.createInstance(L.$En,pe,ae,ie,O);this.a[pe]=Z,this.f.add(pe),Z.onClose(()=>{Z.dispose(),delete this.a[pe],this.J()}),Z.start(U)}}else if(H.desiredConnectionType===P.ConnectionType.Tunnel){const x=H.args;this.G(B,x)}else return this.C(ce,B,"Unknown initial data received")}async G(ae,z){const B=ae.getSocket().socket,ie=ae.readEntireBuffer();ae.dispose(),B.pause();const le=await this.H(z.host,z.port);ie.byteLength>0&&le.write(ie.buffer),le.on("end",()=>B.end()),le.on("close",()=>B.end()),le.on("error",()=>B.destroy()),B.on("end",()=>le.end()),B.on("close",()=>le.end()),B.on("error",()=>le.destroy()),le.pipe(B),B.pipe(le)}H(ae,z){return new Promise((B,ie)=>{const le=E.createConnection({host:ae,port:z,autoSelectFamily:!0},()=>{le.removeListener("error",ie),le.pause(),B(le)});le.once("error",ie)})}I(ae){return typeof ae.port=="number"?(0,t.$5g)(ae.port,10,5e3).then(z=>(ae.port=z,ae)):(ae.debugId=void 0,ae.port=void 0,ae.break=void 0,Promise.resolve(ae))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(ae=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!ae?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},re))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};te=Be([je(5,q.$an),je(6,S.$tk),je(7,u.$ak),je(8,c.$Fi)],te);async function _(J,ae,z){const B=await(0,I.$Kn)(ae);B instanceof I.$In&&(console.warn(B.message),process.exit(1));function ie(W){(0,D.setUnexpectedErrorHandler)(oe=>{(0,D.$2)(oe)&&oe.stack&&/unexpectedErrorHandler/.test(oe.stack)||W(oe)})}const le=[];ie(W=>{le.push(W),console.error(W)});let pe=!1;process.on("SIGPIPE",()=>{pe||(pe=!0,(0,D.$3)(new Error("Unexpected SIGPIPE")))});const H=new h.$Wc,{socketServer:ce,instantiationService:x}=await(0,Y.$xR)(B,ae,z,H);x.invokeFunction(W=>{const oe=W.get(u.$ak);le.forEach(he=>oe.error(he)),le.length=0,ie(he=>oe.error(he))}),x.invokeFunction(W=>{const oe=W.get(s.$aj);m.$i&&(oe.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(oe.getValue("security.allowedUNCHosts")))}),x.invokeFunction(W=>{const oe=W.get(u.$ak);if(m.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const he=(0,a.$mc)(process.env.HOMEDRIVE,"node_modules"),ke=(0,a.$pc)((0,a.$mc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ne=(0,a.$mc)(ke,"node_modules");if(r.existsSync(he)||r.existsSync(Ne)){const me=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${he}
* ${Ne}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;oe.warn(me),console.warn(me),process.exit(0)}}});const U=x.invokeFunction(W=>{const oe=W.get(u.$ak);if(r.existsSync((0,a.$mc)(w.$1g.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ke){oe.error(ke)}return null});let O=ae["server-base-path"];O&&!O.startsWith("/")&&(O=`/${O}`);const Z=r.existsSync(w.$1g.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(Z&&J&&typeof J!="string"){const W=B.type!==I.ServerConnectionTokenType.None?`?${w.$Sg}=${B.value}`:"";console.log(`Web UI available at http://localhost${J.port===80?"":`:${J.port}`}${O??""}${W}`)}const V=x.createInstance(te,ce,B,U,Z,O);f.mark("code/server/ready");const M=k.performance.now(),G=global.vscodeServerStartTime,X=global.vscodeServerListenTime,F=global.vscodeServerCodeLoadedTime;if(x.invokeFunction(async W=>{const oe=W.get(C.$_l);if(oe.publicLog2("serverStart",{startTime:G,startedTime:X,codeLoadedTime:F,readyTime:M}),m.$k){const he=W.get(u.$ak),ke=await(0,p.$4g)(he.error.bind(he));ke&&oe.publicLog2("serverPlatformInfo",{platformId:ke.id,platformVersionId:ke.version_id,platformIdLike:ke.id_like})}}),ae["print-startup-performance"]){const W=A.$W.get();let oe="";oe+=`

### Load AMD-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],W.amdLoad),oe+=`

### Load commonjs-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],W.nodeRequire),oe+=`

### Invoke AMD-module factory
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],W.amdInvoke),oe+=`

### Invoke commonjs-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],W.nodeEval),oe+=`Start-up time: ${X-G}
`,oe+=`Code loading time: ${F-G}
`,oe+=`Initialized time: ${M-G}
`,oe+=`
`,console.log(oe)}return V}class de{static create(ae){const z=ae.webEndpointUrlTemplate,B=ae.commit,ie=ae.quality;if(!z||!B||!ie)return new de(null);const le=(0,d.$3g)(),H=new URL(z.replace("{{uuid}}",le).replace("{{commit}}",B).replace("{{quality}}",ie)).origin,ce=(0,$.$jf)(H).replace(le,"[a-zA-Z0-9\\-]+");try{const x=(0,$.$sf)(`^${ce}$`,!0,{matchCase:!1});return new de(x)}catch{return new de(null)}}constructor(ae){this.a=ae}matches(ae){return this.a?this.a.test(ae):!1}}});var mt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ve[338],Se([1,0,32,31,13,324,329,70,9,330,55,62,44]),function(se,e,n,r,E,k,R,A,y,o,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=i,e.createServer=g,n=qe(n),r=qe(r),v=mt(v),h=qe(h),h.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=o.performance.now();const w={onMultipleValues:(s,c)=>{console.error(`Option '${s}' can only be defined once. Using value ${c}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,c)=>{console.warn(`Option '${s}' is deprecated: ${c}`)}},a=(0,A.$Dm)(process.argv.slice(2),D.$_m,w),f=a["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.$mc)(n.homedir(),v.default.serverDataFolderName||".vscode-remote"),m=(0,y.$mc)(f,"data"),$=(0,y.$mc)(m,"User"),b=(0,y.$mc)($,"globalStorage"),d=(0,y.$mc)($,"History"),p=(0,y.$mc)(m,"Machine");a["user-data-dir"]=m;const t=(0,y.$pc)(E.$1g.asFileUri("").fsPath),l=(0,y.$mc)(t,"extensions");a["builtin-extensions-dir"]=l,a["extensions-dir"]=a["extensions-dir"]||(0,y.$mc)(f,"extensions"),[f,a["extensions-dir"],m,$,p,b,d].forEach(s=>{try{r.existsSync(s)||r.mkdirSync(s,{mode:448})}catch(c){console.error(c)}});function i(){(0,k.run)(a,f,D.$_m)}function g(s){return(0,R.$CR)(s,a,f)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1962f48b7f71772dc2c060dbaa5a6b4c0792a549/core/vs/server/node/server.main.js.map
